/* DUPLICATOR MYSQL SCRIPT CREATED ON : April 22, 2014, 1:14 pm */

SET FOREIGN_KEY_CHECKS = 0;

CREATE TABLE `wp_commentmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) DEFAULT NULL,
  `meta_value` longtext,
  PRIMARY KEY (`meta_id`),
  KEY `comment_id` (`comment_id`),
  KEY `meta_key` (`meta_key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `wp_comments` (
  `comment_ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_post_ID` bigint(20) unsigned NOT NULL DEFAULT '0',
  `comment_author` tinytext NOT NULL,
  `comment_author_email` varchar(100) NOT NULL DEFAULT '',
  `comment_author_url` varchar(200) NOT NULL DEFAULT '',
  `comment_author_IP` varchar(100) NOT NULL DEFAULT '',
  `comment_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_content` text NOT NULL,
  `comment_karma` int(11) NOT NULL DEFAULT '0',
  `comment_approved` varchar(20) NOT NULL DEFAULT '1',
  `comment_agent` varchar(255) NOT NULL DEFAULT '',
  `comment_type` varchar(20) NOT NULL DEFAULT '',
  `comment_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`comment_ID`),
  KEY `comment_post_ID` (`comment_post_ID`),
  KEY `comment_approved_date_gmt` (`comment_approved`,`comment_date_gmt`),
  KEY `comment_date_gmt` (`comment_date_gmt`),
  KEY `comment_parent` (`comment_parent`)
) ENGINE=InnoDB AUTO_INCREMENT=248 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_duplicator_packages` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(250) COLLATE utf8_unicode_ci NOT NULL,
  `hash` varchar(50) COLLATE utf8_unicode_ci NOT NULL,
  `status` int(11) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `owner` varchar(60) COLLATE utf8_unicode_ci NOT NULL,
  `package` mediumblob NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `wp_links` (
  `link_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `link_url` varchar(255) NOT NULL DEFAULT '',
  `link_name` varchar(255) NOT NULL DEFAULT '',
  `link_image` varchar(255) NOT NULL DEFAULT '',
  `link_target` varchar(25) NOT NULL DEFAULT '',
  `link_description` varchar(255) NOT NULL DEFAULT '',
  `link_visible` varchar(20) NOT NULL DEFAULT 'Y',
  `link_owner` bigint(20) unsigned NOT NULL DEFAULT '1',
  `link_rating` int(11) NOT NULL DEFAULT '0',
  `link_updated` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `link_rel` varchar(255) NOT NULL DEFAULT '',
  `link_notes` mediumtext NOT NULL,
  `link_rss` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`link_id`),
  KEY `link_visible` (`link_visible`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `wp_options` (
  `option_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `option_name` varchar(64) NOT NULL DEFAULT '',
  `option_value` longtext NOT NULL,
  `autoload` varchar(20) NOT NULL DEFAULT 'yes',
  PRIMARY KEY (`option_id`),
  UNIQUE KEY `option_name` (`option_name`)
) ENGINE=InnoDB AUTO_INCREMENT=348 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_postmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) DEFAULT NULL,
  `meta_value` longtext,
  PRIMARY KEY (`meta_id`),
  KEY `post_id` (`post_id`),
  KEY `meta_key` (`meta_key`)
) ENGINE=InnoDB AUTO_INCREMENT=1651 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_posts` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_author` bigint(20) unsigned NOT NULL DEFAULT '0',
  `post_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content` longtext NOT NULL,
  `post_title` text NOT NULL,
  `post_excerpt` text NOT NULL,
  `post_status` varchar(20) NOT NULL DEFAULT 'publish',
  `comment_status` varchar(20) NOT NULL DEFAULT 'open',
  `ping_status` varchar(20) NOT NULL DEFAULT 'open',
  `post_password` varchar(20) NOT NULL DEFAULT '',
  `post_name` varchar(200) NOT NULL DEFAULT '',
  `to_ping` text NOT NULL,
  `pinged` text NOT NULL,
  `post_modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_modified_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content_filtered` longtext NOT NULL,
  `post_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `guid` varchar(255) NOT NULL DEFAULT '',
  `menu_order` int(11) NOT NULL DEFAULT '0',
  `post_type` varchar(20) NOT NULL DEFAULT 'post',
  `post_mime_type` varchar(100) NOT NULL DEFAULT '',
  `comment_count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`),
  KEY `post_name` (`post_name`),
  KEY `type_status_date` (`post_type`,`post_status`,`post_date`,`ID`),
  KEY `post_parent` (`post_parent`),
  KEY `post_author` (`post_author`)
) ENGINE=InnoDB AUTO_INCREMENT=225 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_term_relationships` (
  `object_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_taxonomy_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_order` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`object_id`,`term_taxonomy_id`),
  KEY `term_taxonomy_id` (`term_taxonomy_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `wp_term_taxonomy` (
  `term_taxonomy_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `term_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `taxonomy` varchar(32) NOT NULL DEFAULT '',
  `description` longtext NOT NULL,
  `parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_taxonomy_id`),
  UNIQUE KEY `term_id_taxonomy` (`term_id`,`taxonomy`),
  KEY `taxonomy` (`taxonomy`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_terms` (
  `term_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(200) NOT NULL DEFAULT '',
  `slug` varchar(200) NOT NULL DEFAULT '',
  `term_group` bigint(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_id`),
  UNIQUE KEY `slug` (`slug`),
  KEY `name` (`name`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_usermeta` (
  `umeta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) DEFAULT NULL,
  `meta_value` longtext,
  PRIMARY KEY (`umeta_id`),
  KEY `user_id` (`user_id`),
  KEY `meta_key` (`meta_key`)
) ENGINE=InnoDB AUTO_INCREMENT=17 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_users` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_login` varchar(60) NOT NULL DEFAULT '',
  `user_pass` varchar(64) NOT NULL DEFAULT '',
  `user_nicename` varchar(50) NOT NULL DEFAULT '',
  `user_email` varchar(100) NOT NULL DEFAULT '',
  `user_url` varchar(100) NOT NULL DEFAULT '',
  `user_registered` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `user_activation_key` varchar(60) NOT NULL DEFAULT '',
  `user_status` int(11) NOT NULL DEFAULT '0',
  `display_name` varchar(250) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`),
  KEY `user_login_key` (`user_login`),
  KEY `user_nicename` (`user_nicename`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;


/* INSERT TABLE DATA: wp_comments */
INSERT INTO `wp_comments` VALUES("1", "1", "Mr WordPress", "", "http://wordpress.org/", "", "2014-04-19 13:44:02", "2014-04-19 13:44:02", "Hi, this is a comment.\nTo delete a comment, just log in and view the post&#039;s comments. There you will have the option to edit or delete them.", "0", "post-trashed", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("2", "6", "RugerRedhawk", "noreply926@yourdomain.com", "", "", "2014-04-21 06:15:35", "2014-04-21 06:15:35", "<strong>You can\'t break these</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("3", "6", "DustyBeard", "noreply6420@yourdomain.com", "", "", "2014-04-21 06:29:44", "2014-04-21 06:29:44", "<strong>Great deal on the standard garden hand tools</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("4", "6", "Mark \"Mark\"", "noreply1384@yourdomain.com", "", "", "2014-04-21 06:58:08", "2014-04-21 06:58:08", "<strong>Fiskars Rule</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("5", "8", "\"wbjy\"", "noreply3731@yourdomain.com", "", "", "2014-04-21 06:26:44", "2014-04-21 06:26:44", "<strong>An Edge for the Older Gardener</strong> My wife has a green fist!  Yes, I know the cliche is:  \"my wife has a green thumb.\"  Every living plant, vine, bush or tree she touches in her garden or around the house grows, thrives, and reproduces. Indeed, even slips from someone else\'s garden bursts into life when she transplants it.Our little garden out back is a riot of color and variety and only a year ago it was a dry plot of deep, impenatrable lifeless clay. Today people suck in their breath when they walk out the patio door into her \"Eden\" (my name for the space).But my wife is about to turn 70.  She is plagued with migraine headaches, vertigos and is having a long convelescence from a fall that broke many things.  She is slower, more deliberate in pace. Stooping is a hazard and so is running back and forth for tooks.But out she goes each day to trim, water, admire and talk to her growing things.  She needs an assistant or attendent who makes her chores less painful.  The bucket caddy and a little army...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("6", "8", "Douglas E. Wong", "noreply161@yourdomain.com", "", "", "2014-04-21 06:53:05", "2014-04-21 06:53:05", "<strong>Very Very Handy.</strong> Pros:This is a terrific product.  I use it mainly for weeding and pruning; keeping my cellphone, a bottle of water, my weeder and pruner in the caddy while throwing the weeds into the center of the bucket for later disposal.  I don\'t do a lot of gardening, all my plants are planted and set and I spend maybe a couple hours a week doing general maintenance.  This is perfect for that.  For heavy tools, you\'ll want to get a caddy designed for that purpose, such as the Bucket Boss.  This Garden Caddy is very very clever and handy, and designed specifically for gardening purposes.  I love it.Some minor, minor concerns:1. The strap is velcro.  The product description mentions a \"lock-and-loop fastener\" but perhaps that was an earlier version?  Unless \"lock-and-loop\" is code for velcro.  This is a concern for me because velcro doesn\'t work too well when muddy, or old, and if I have heavy items I\'m worried it might not hold.  However, I\'ve given the caddy a few good...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("7", "10", "rberger", "noreply7604@yourdomain.com", "", "", "2014-04-21 06:25:29", "2014-04-21 06:25:29", "<strong>gardener</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("8", "10", "TONY", "noreply3145@yourdomain.com", "", "", "2014-04-21 06:34:22", "2014-04-21 06:34:22", "<strong>Quality?? Not.</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("9", "12", "Jay Ciucci", "noreply9875@yourdomain.com", "", "", "2014-04-21 06:24:55", "2014-04-21 06:24:55", "<strong>Average shears</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("10", "12", "Al the Pal \"Al the Pal\"", "noreply3907@yourdomain.com", "", "", "2014-04-21 06:33:58", "2014-04-21 06:33:58", "<strong>Good for Light Duty Cutting</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("11", "12", "Ms. Opinionated \"polarity100\"", "noreply3725@yourdomain.com", "", "", "2014-04-21 06:48:28", "2014-04-21 06:48:28", "<strong>Not The FISKARS You Expect</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("12", "14", "", "noreply4508@yourdomain.com", "", "", "2014-04-21 06:33:46", "2014-04-21 06:33:46", "<strong></strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("13", "14", "", "noreply7854@yourdomain.com", "", "", "2014-04-21 07:02:47", "2014-04-21 07:02:47", "<strong></strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("14", "16", "T. Hampton", "noreply8442@yourdomain.com", "", "", "2014-04-21 06:34:33", "2014-04-21 06:34:33", "<strong>Very Satisfied</strong> I was hesitant to purchase this indoor garden tool set because it didn\'t have any reviews and I had read reviews for other similar products complaining the tools were too small or nondurable, but I took the risk and was pleasantly surprised.The shovel, trowel, and rake are reasonably sized for working with small potted plants. The orange wooden handles are about 4 inches long and fit nicely in my hand, while the stainless steel trowel and shovel are around 3 and 3.25 inches long (the rake\'s three teeth are around 2.5 inches long, bent at the 1.5 inch mark so you have at least 1 inch of steel to dig with). The snips and pruners have similar measurements with plastic-covered metal handles that are about 4.5 inches long and the actual metal cutters being around 1.25 and 1.5 inches long. The spray bottle is the size of a small soap dispenser, and its container is glass but the sprayer itself is plastic. The sprayer had a small leak but this was fixed with a little glue.  The...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("15", "16", "BARBARA W. VANAUSDALL", "noreply4298@yourdomain.com", "", "", "2014-04-21 06:43:12", "2014-04-21 06:43:12", "<strong>Practical and decorative tool set!</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("16", "16", "Veronica", "noreply1080@yourdomain.com", "", "", "2014-04-21 07:13:40", "2014-04-21 07:13:40", "<strong>Really nice</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("17", "18", "J. Muller", "noreply6981@yourdomain.com", "", "", "2014-04-21 06:30:45", "2014-04-21 06:30:45", "<strong>My mom loved it!</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("18", "18", "Mio \"Ing\"", "noreply2639@yourdomain.com", "", "", "2014-04-21 06:37:42", "2014-04-21 06:37:42", "<strong>All in one</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("19", "20", "jessica", "noreply3812@yourdomain.com", "", "", "2014-04-21 06:19:02", "2014-04-21 06:19:02", "<strong>thoughtless packaging**** updated 3/13</strong> These gloves are comfortable for me and I have huge hands and long fingers, I like the little nubbies of rubber, they seem to make it more comfortable to grip the hand trowel I use.  Here\'s the DOWNSIDE  each pair of gloves come STAPLED together.  Yep that\'s right, little metal staples just like the teacher used in school.  One pair was stapled together x3.  Putting to one side the aggravation of attempting to remove the stupid things, they make BIG HOLES in the ribbed cotten at the wrist. If u look at the picture u will see a plastic hook and I can indeed confirm that the plastic bit is present.  I therefore do not understand why the manufacturer does not use this bit to secure the gloves together.  Why damage their own product?  The gloves won\'t last long given they begin service with holes in.  I won\'t buy these again*******UPDATE****** review is changed to 5 stars because I was looking at these again and I saw in one of the pics that the gloves were packaged...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("20", "20", "Dr. Dave \"bike to work\"", "noreply5952@yourdomain.com", "", "", "2014-04-21 06:27:22", "2014-04-21 06:27:22", "<strong>great gardening glove</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("21", "22", "pilot\'s_wife", "noreply1196@yourdomain.com", "", "", "2014-04-21 06:07:45", "2014-04-21 06:07:45", "<strong>High quality tools!</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("22", "22", "Movesalotfamily", "noreply5935@yourdomain.com", "", "", "2014-04-21 06:25:35", "2014-04-21 06:25:35", "<strong>Great set for even a very young child</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("23", "24", "Nancy Manning", "noreply9812@yourdomain.com", "", "", "2014-04-21 06:09:49", "2014-04-21 06:09:49", "<strong>Carpal Tunnel Heaven</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("24", "24", "Linda \"stlmonoco\"", "noreply9350@yourdomain.com", "", "", "2014-04-21 06:36:56", "2014-04-21 06:36:56", "<strong>MOM PLEASE</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("25", "26", "Jennifer M. Macleod \"yiddishe supermama\"", "noreply4952@yourdomain.com", "", "", "2014-04-21 06:29:24", "2014-04-21 06:29:24", "<strong>A great... plastic... trowel</strong> This was my first trowel as a novice gardener 3 years ago.  I loved it.  I love that it\'s easy to spot in the garden, can be left out, and I don\'t care if the kids \"borrow\" it because it\'s dirt cheap.  I have the hand rake to match, both in a not-too-glaring terra cotta colour.For a while, this was my only garden tool, and it held up respectably creating beds, stirring in amendments and transplanting annuals and perennials of all sizes.I\'d have to go slowly when doing serious digging in rocky areas or digging up long-buried bricks - we have a million of these under our garden!  But it did the trick, including digging post holes for my new Square Foot Garden this season.However... this season brought the arrival of serious competition:  the Rittenhouse Trake (also available at Amazon!).  The trake\'s sturdy cast aluminum construction has, I\'m afraid, blown this baby out of the water.However much you want to call this trowel\'s material...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("26", "26", "A. Howard", "noreply8347@yourdomain.com", "", "", "2014-04-21 06:36:08", "2014-04-21 06:36:08", "<strong>I don\'t like to garden...but I do love to fertilize.</strong> I must preface this review by explaining that I\'ve never used this item for its \"intended\" purpose.  I don\'t garden and have only recently acquired the skill to keep anything more biologically advanced than a cactus alive.  If you like gardening and want to garden in style, you could almost definitely find something fancier and more ergonomically...impressive than the Fiskars (much like the dozen or so fine, Japanese & Swedish-made trowels of various sizes and shapes that are currently \"supplementing\" the iron content of my mother\'s lawn and garden.)  I actually bought this shovel for camping and backpacking when my Coleman mini entrenching tool shovel that I\'d had since boy scouts bent while trying to dig a privy hole in the roots of a long-dead, but still-stronger-than-me oak.  My bad that.  (Man Vs. Nature?...Bet on Nature.)  Still, the mistake DID lead me (indirectly) to this little gem.  Wanting a smaller and lighter trowel this time to fill the void (pardon my pun) left by...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("27", "30", "mrscoffeecrisp", "noreply853@yourdomain.com", "", "", "2014-04-21 06:06:46", "2014-04-21 06:06:46", "<strong>Love it!!</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("28", "30", "Ellen", "noreply650@yourdomain.com", "", "", "2014-04-21 06:27:14", "2014-04-21 06:27:14", "<strong>Happy in Pink</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("29", "34", "Gerald J. Handschuh", "noreply2486@yourdomain.com", "", "", "2014-04-21 06:19:15", "2014-04-21 06:19:15", "<strong>My Yard Butler</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("30", "34", "C. Rothwell", "noreply859@yourdomain.com", "", "", "2014-04-21 06:33:49", "2014-04-21 06:33:49", "<strong>Not Just for Gardening</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("31", "34", "Lisa M.", "noreply3043@yourdomain.com", "", "", "2014-04-21 07:01:53", "2014-04-21 07:01:53", "<strong>Save Your Knees</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("32", "36", "Divaliscious Baker", "noreply1184@yourdomain.com", "", "", "2014-04-21 06:04:32", "2014-04-21 06:04:32", "<strong>Fantastic Weeder Makes Gardening A Joy!</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("33", "36", "Winget84", "noreply1926@yourdomain.com", "", "", "2014-04-21 06:13:16", "2014-04-21 06:13:16", "<strong>Best Weed Puller</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("34", "38", "myway", "noreply1287@yourdomain.com", "", "", "2014-04-21 06:31:37", "2014-04-21 06:31:37", "<strong>Really is 6 pairs!</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("35", "38", "Chris Gilbreath \"chris\"", "noreply6781@yourdomain.com", "", "", "2014-04-21 06:35:49", "2014-04-21 06:35:49", "<strong>awesome gloves</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("36", "38", "NIGHTMAN", "noreply1628@yourdomain.com", "", "", "2014-04-21 06:43:47", "2014-04-21 06:43:47", "<strong>THE GLOVES TO BUY</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("37", "40", "Cheeky Monkey Mama", "noreply1462@yourdomain.com", "", "", "2014-04-21 06:13:38", "2014-04-21 06:13:38", "<strong>Great Garden Tool Set for Kids</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("38", "40", "Trish Van Baast", "noreply587@yourdomain.com", "", "", "2014-04-21 06:32:51", "2014-04-21 06:32:51", "<strong>The perfect present</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("39", "42", "austin_Larry", "noreply9756@yourdomain.com", "", "", "2014-04-21 06:19:28", "2014-04-21 06:19:28", "<strong>Great performance and control, perfect for a lefty</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("40", "42", "D. Blankenship", "noreply8043@yourdomain.com", "", "", "2014-04-21 06:40:55", "2014-04-21 06:40:55", "<strong>DIFFICULT TO BEAT THE QUALITY AT THIS PRICE - THIS IS AN EXCELLENT PRUNING SHEARS</strong> I have a large number of pruning shears of my own that I have collected throughout the years and am fortunate to have access to many more - different brands and different models.  I get to \"test\" a lot of these things.  I also do a lot of pruning as we have an orchard, heavily planted and landscaped yard which includes thick woodland.  I don\'t particularly like doing all this cutting, sawing and chopping but hey, it has to be done...or so my wife feels.Anyway...For the money these Fiskars 9124 Professional Bypass Pruning Shears are some of the best I own and in my case are quite handy.  First is the fact that they are built so that they can be used by both the left and the right hand.  Unfortunately I am old.  Unfortunately there are some drawbacks to becoming ancient.  One of those is that many people develop arthritis of the hands.  I am one of those people.  This is a real bummer to be quite frank.  It is not a major problem yet, but it can be quite painful...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("41", "44", "Everett A. Warren", "noreply6484@yourdomain.com", "", "", "2014-04-21 06:34:19", "2014-04-21 06:34:19", "<strong>Well Balanced Tools</strong> When I first came across these, I thought they looked neat, and maybe they might not function so bad. The look had additional marketing appeal for my landscaping company, something to set us aside from others.However, I wasn\'t really sure they\'d suit a functional purpose, so I tentatively ordered the shovel to give it a trial run and to see if I could live with it.I\'ve since gone out and stocked up on all the NRG-PRO tools, their hand tools, and I\'m looking forward to at least some of the NRG-STX series tools as well.All of the tools have a great balance. They are easier to control and carry materials across distances ~ a simple open hand across the circular handle keeps them from spinning and dropping whatever they\'re carrying. I\'ve also found the handle design helps keep them from rolling or causing too much trouble when toting them around across the arms of a wheelbarrow.The nice green does seem to get dulled quickly from the mud and,...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("42", "44", "P. Gatcomb", "noreply1592@yourdomain.com", "", "", "2014-04-21 06:44:05", "2014-04-21 06:44:05", "<strong>Bendable tines and poor customer service</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("43", "44", "J. Benway", "noreply7716@yourdomain.com", "", "", "2014-04-21 07:09:55", "2014-04-21 07:09:55", "<strong>Broken spading fork</strong> Had this item about 4 months tilling the ground removing weeds and hit part of a tree root. I believe this is about the third time I have used it. the end of the fork broke off where the fork and handle meet. I also paid almost double the current price for it. It does not have a solid handle. I would not recommend this item for anything other than the lightest duty, like scratching sand. Another fine product from China.Ok, follow up on this product, the company(radius)after some prodding did make good on replacing the fork that has a LIFETIME warranty. I too went through them (Radius) wanting me to pay for the shipping, as did another in the reviews, but ultimately after my argument that I had already payed the shipping the first time I got the bad fork they relented and sent me a new one at there cost. Before they did though I had to go through the process of trying to get Amazon to replace it which they (Amazon) refused to do saying they don\'t honor manufactures...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("44", "46", "ryan hennessy", "noreply362@yourdomain.com", "", "", "2014-04-21 06:19:41", "2014-04-21 06:19:41", "<strong>Could be great</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("45", "46", "Justin Van Winkle \"ltbarcly\"", "noreply2879@yourdomain.com", "", "", "2014-04-21 06:35:23", "2014-04-21 06:35:23", "<strong>Great shovel</strong> I got this shovel at Lowes because it was the best spade they had in stock.  I\'ve been using it for almost a year, and it is nearly indestructible.  The last week or so I\'ve been double digging new garden beds in my sand-clay backyard (as hard as concrete after a week of no rain), and it has been a comparative breeze.  I\'ve resharpened the shovel once to get through the large pine roots and stumps, and the plastic handle needs re-tightening about every 3 hours of digging (it is held on by a single screw, I\'ll probably give it a drop of super glue to lock the threads as it is wiggling loose).  I am able to push this shovel all the way into the ground, and then jump up and down on the handle with all of my weight without it showing any signs of stress whatsoever (the handle of the fork I was using snapped in 2 with much much less force).I highly recommend this for gardening.  My  only reservation is that for another $20-$30 you could move up to something made of stainless...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("46", "46", "trey769", "noreply1371@yourdomain.com", "", "", "2014-04-21 07:01:36", "2014-04-21 07:01:36", "<strong>Get the job done</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("47", "48", "Alex", "noreply2585@yourdomain.com", "", "", "2014-04-21 06:26:37", "2014-04-21 06:26:37", "<strong>Good value</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("48", "48", "Saffron Bright-Rawlings", "noreply3585@yourdomain.com", "", "", "2014-04-21 06:35:23", "2014-04-21 06:35:23", "<strong>What\'s not to love?</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("49", "48", "A. Murray \"shoppingpro\"", "noreply9036@yourdomain.com", "", "", "2014-04-21 06:48:46", "2014-04-21 06:48:46", "<strong>Top Quality</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("50", "50", "Zoinger", "noreply7184@yourdomain.com", "", "", "2014-04-21 06:18:55", "2014-04-21 06:18:55", "<strong>Precision Shovel</strong> What a shovel!So far I\'ve used it to transplant two pittosporums (each about 4\' tall). It\'s like a surgeon\'s instrument. It has an extra-wide foot-stomping plate on the top of the blade that makes it easy to get lots of weight in just the right place. The sturdy plastic handle is comfortable in the hand and solidly attached to rest of the steel shovel.I also used it to lever the pittosporums out of their hole. This worked great with very little flex in the shovel. The pittosporum with soil weighted about 60 pounds I\'m guessing.The blade is sharp enough to cut through small 1/4\"-to-1/2\" or so roots if you are determined. For big roots, a root-pruning saw is easier.Full disclosure: The soil I was digging in was moist from a recent rain, and I didn\'t hit any large roots or other obstacles of note... pretty much perfect transplanting conditions.Update - 2009-12:This shovel is still digging strong, and I use it a lot...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("51", "50", "JC", "noreply1514@yourdomain.com", "", "", "2014-04-21 06:41:07", "2014-04-21 06:41:07", "<strong>Fiskars 9654 Transplanting Spade</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("52", "50", "spooky", "noreply6441@yourdomain.com", "", "", "2014-04-21 07:07:21", "2014-04-21 07:07:21", "<strong>Fiskars Transplanting Spade #9654</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("53", "52", "K. Borchers \"opinionated in the extreme\"", "noreply179@yourdomain.com", "", "", "2014-04-21 06:27:04", "2014-04-21 06:27:04", "<strong>Yep...it\'s a shovel</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("54", "52", "Brian Cottrell", "noreply6821@yourdomain.com", "", "", "2014-04-21 06:51:19", "2014-04-21 06:51:19", "<strong>this is a shovel.</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("55", "52", "luckyduck", "noreply9668@yourdomain.com", "", "", "2014-04-21 07:17:49", "2014-04-21 07:17:49", "<strong>bargain shovel</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("56", "54", "Dennis B.", "noreply3215@yourdomain.com", "", "", "2014-04-21 06:30:33", "2014-04-21 06:30:33", "<strong>Great Shovel, An All Purpose Spade</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("57", "54", "Matthew P. Schwob", "noreply7103@yourdomain.com", "", "", "2014-04-21 06:53:00", "2014-04-21 06:53:00", "<strong>Good Piece of Gear!</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("58", "56", "Mark Williams", "noreply7561@yourdomain.com", "", "", "2014-04-21 06:08:24", "2014-04-21 06:08:24", "<strong>Quality issue</strong> I bought this product, but it came delivered with the D handle about 30 degrees off axis. The joint between the wooden shaft and the Polymer handle was also visibly chipped/splintered. I returned it for a replacement. I haven\'t received the new one yet. Though the product supposedly carries a 10 year warranty, I have had no luck contacting this company. Googling \'Truper tools\' for a customer service number came up empty. The product is delivered with no documentation. The product is made in Mexico, so I am not sure what the customer support is here in the USA. I feel more comfortable doing business with companies with good product documentation - even if it is just a card attached with website and contact numbers - than another foreign company slidng by with no customer/warranty support.EDIT: I received my new fork without the previous quality issues. Amazon still has no idea how to contact this company. Amazon Customer Service doesn\'t understand how they carry a product...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("59", "56", "M. Griggs", "noreply7003@yourdomain.com", "", "", "2014-04-21 06:25:45", "2014-04-21 06:25:45", "<strong>excellent hoe - good for snow or whatever</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("60", "58", "Flower", "noreply8870@yourdomain.com", "", "", "2014-04-21 06:20:19", "2014-04-21 06:20:19", "<strong>great tool</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("61", "58", "Cindy L Morin", "noreply1206@yourdomain.com", "", "", "2014-04-21 06:32:16", "2014-04-21 06:32:16", "<strong>Thanks!</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("62", "58", "", "noreply5395@yourdomain.com", "", "", "2014-04-21 06:34:26", "2014-04-21 06:34:26", "<strong></strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("63", "60", "spinal", "noreply9316@yourdomain.com", "", "", "2014-04-21 06:29:12", "2014-04-21 06:29:12", "<strong>Solid.</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("64", "62", "Danielle E. Aubert", "noreply5707@yourdomain.com", "", "", "2014-04-21 06:11:06", "2014-04-21 06:11:06", "<strong>Broke easily</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("65", "62", "F. Stephen Masri", "noreply9262@yourdomain.com", "", "", "2014-04-21 06:37:09", "2014-04-21 06:37:09", "<strong>Not a British Garden Tool</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("66", "62", "chic oldie", "noreply9465@yourdomain.com", "", "", "2014-04-21 06:54:51", "2014-04-21 06:54:51", "<strong>Shame on you, Amazon.</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("67", "64", "RubyZ", "noreply7877@yourdomain.com", "", "", "2014-04-21 06:23:20", "2014-04-21 06:23:20", "<strong>Great tiller</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("68", "64", "Their Nana \"Kat\"", "noreply9673@yourdomain.com", "", "", "2014-04-21 06:42:08", "2014-04-21 06:42:08", "<strong>Twist and Tiller</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("69", "64", "Anonymous", "noreply628@yourdomain.com", "", "", "2014-04-21 06:46:48", "2014-04-21 06:46:48", "<strong>Nice garden tool</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("70", "66", "Omar Siddique", "noreply4367@yourdomain.com", "", "", "2014-04-21 06:10:17", "2014-04-21 06:10:17", "<strong>good reach, mediocre leverage</strong> The telescoping works, but the design requires extra brute-strength to use at the extended length.I got these shears to reach the tops of bushes that I can\'t get with my old short-handled shears, but that don\'t warrant investing in specialized power tools.My reach was indeed extended, but I found the shearing slow going. It turns out that the 9\" blades (vs the 10\" more common for this sort of tool) provide less leverage.  And if I\'m reaching out, my arms will naturally be closer together, making it harder to use the full cutting motion.The end result is I get greater reach than with my old shears, but must use notably more effort to actually cut anything.  For me, this limits the tool to selective pruning rather than shaping or hedge-trimming.The extending part of the handles is plastic, but the on the whole appears well constructed.The unique product design moves this up from 3 to 4 stars, but if you\'re doing a lot of...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("71", "66", "Coffee Drinker", "noreply1819@yourdomain.com", "", "", "2014-04-21 06:24:35", "2014-04-21 06:24:35", "<strong>Great for Light Jobs</strong> I could immediately tell by looking at these hedge shears that they are for light duty.  To me, they seem better designed for garden use.  I noticed the other two posters commented on the drawbacks of pruning shrubbery. I haven\'t tried using them on shrubs yet, but I would probably agree with that.  You can tell by the size of the blades that they would not hold up well to pruning.  I think they\'re best for trimming the greenery or very small woody branches, but not to tackle anything like privet or forsythia.  However, my purpose for buying these shears  was not to use on shrubs.  I needed a telescoping lightweight trimmer to cut the plants in my pond and they work great for that.  Being female with a smaller frame, I needed something that was lightweight and wouldn\'t tire my arms.  You\'d think this would be easy to find, but not so much.  So be forewarned all you maniacal hedge-aholics out there, you should choose another brand with larger blades if your primary purpose is to prune...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("72", "66", "Amazon Customer", "noreply8924@yourdomain.com", "", "", "2014-04-21 06:47:02", "2014-04-21 06:47:02", "<strong>Like the extender locks</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("73", "68", "Randall Moran", "noreply1686@yourdomain.com", "", "", "2014-04-21 06:25:03", "2014-04-21 06:25:03", "<strong>Professional Garden Shears</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("74", "68", "D. Thorpe", "noreply3565@yourdomain.com", "", "", "2014-04-21 06:33:24", "2014-04-21 06:33:24", "<strong>Decent hand pruners</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("75", "68", "Desert Wolverine \"Desert Wolverine\"", "noreply3097@yourdomain.com", "", "", "2014-04-21 06:35:16", "2014-04-21 06:35:16", "<strong>Disappointing</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("76", "70", "Ms. Opinionated \"polarity100\"", "noreply7956@yourdomain.com", "", "", "2014-04-21 06:17:53", "2014-04-21 06:17:53", "<strong>scissors that won\'t let you down.</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("77", "70", "A. Murray", "noreply8586@yourdomain.com", "", "", "2014-04-21 06:42:14", "2014-04-21 06:42:14", "<strong>Excellent All-Purpose Shears</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("78", "72", "Mimi", "noreply5356@yourdomain.com", "", "", "2014-04-21 06:38:24", "2014-04-21 06:38:24", "<strong>Light, Comfortable, Affordable</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("79", "72", "B. Hoff-Buck \"Garden Nut\"", "noreply8297@yourdomain.com", "", "", "2014-04-21 07:04:29", "2014-04-21 07:04:29", "<strong>Durable yet light</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("80", "74", "Victor H. Agresti \"remodeling-guy\"", "noreply4341@yourdomain.com", "", "", "2014-04-21 06:33:00", "2014-04-21 06:33:00", "<strong>Excellent pruners at a bargain price</strong> Fiskars Consumer #91105935 Traditional Anvil PrunerOf the half dozen models or so hand-pruners we own, these are the best.  They are so good, I just ordered two more so everyone in the family can help me prune!Cons:- It\'s not too difficult to sharpen the blade if it\'s only a little dull.  However, if it has nicks, that\'s a different story.  This is because the entire sharpened blade must touch the brass anvil at the same time, to cut effectively.  If you take off too much steel from one spot or the blade is seriously nicked, you may as well buy another pair.  This is true of any anvil pruner.Pros:- Cuts any branch up to 5/8\" in diameter, or if the wood is really soft, 3/4\".- The \"power-lever\" feature is really a type of compound action, with the added benefit that the jaws open wide from the back.  That allows larger branches to fit close to the pivot point, increasing cutting leverage.  The result of these design...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("81", "74", "G. Anton \"Greekster\"", "noreply3066@yourdomain.com", "", "", "2014-04-21 06:38:41", "2014-04-21 06:38:41", "<strong>Fiskars needs improvement.</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("82", "76", "Amazon Customer", "noreply1402@yourdomain.com", "", "", "2014-04-21 06:21:36", "2014-04-21 06:21:36", "<strong>Nice shears, and happy, even though they broke</strong> I bought these shears at Lowe\'s for about 40 bucks.  They were on the higher end of the offerings at the store, but you should never skimp on real tools.  The tool has a great look, and the blades were rippin\' sharp.The tool is a joy to use, very satisfying, and it simply annihilates whatever you throw at it.  In fact, I turn to these rather than my electric Black and Decker long handled hedge trimmer (which I love), because they\'re easy, and tearing up the vegetation manually is pretty badassoldskool.One day, though, I was cutting some very minor shoots around the base of a tree, and I gave a nice chop to a branch, probably not more than a 1/2 inch thick, and the handle simply snapped, ironically right next to the \"Forged for Strength\" sticker.  So it sat on my shed workbench all winter (I\'m lazy), until I was finally motivated to look up the Corona website and complain.  I\'d had the tool for maybe a year and half, no receipt, registration, nada.I...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("83", "76", "Comdet", "noreply4988@yourdomain.com", "", "", "2014-04-21 06:28:36", "2014-04-21 06:28:36", "<strong>Great quality!</strong> I was really surprised at the quality of these clippers. Given the price, I was expecting a somewhat low-end product, but Corona really did a great job with this.The handles are steel and can be extended with a simple twist. They lock in at any spot with a positive click - very secure. The grip is very comfortable to hold using gloves or bare hands.The best part are the blades. They are forged rather than stamped, and come with a very sharp edge. After a fair amount of use the blades were still razor sharp. It also has a notch at the base of the blade for cutting larger stalks - handy for when you don\'t have hand pruners handy.The blade is straight and non-serrated, so it will be easy to re-sharpen when needed (I highly recommend the Istor sharpener). Has bumpers to minimize the jolt to your arms and shoulders when using it for long periods.I normally use a powered trimmer for my shrubs, but wanted a hand one for small jobs. This is so...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("84", "76", "L. Edwards", "noreply2941@yourdomain.com", "", "", "2014-04-21 06:31:22", "2014-04-21 06:31:22", "<strong>A good pair of shears</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("85", "78", "Dottie M. Jahoda", "noreply5352@yourdomain.com", "", "", "2014-04-21 06:20:33", "2014-04-21 06:20:33", "<strong>The best loppers I\'ve ever owned!</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("86", "78", "James C Smith", "noreply1730@yourdomain.com", "", "", "2014-04-21 06:28:02", "2014-04-21 06:28:02", "<strong>Fiskar\'s PowerGear Loppers</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("87", "80", "Susanne Koenig \"mynewwritinglife.blogspot.com\"", "noreply1072@yourdomain.com", "", "", "2014-04-21 06:26:20", "2014-04-21 06:26:20", "<strong>Mel and his squares work!</strong> By a happy accident, I stumbled upon the 1982 copy of Square Foot Gardening.  I was very pleased with his concept.  However, having a full acre but not a tiller, I was even more pleased when I came across his All New Square Foot Gardening.  \"What an ingenious method!\" thought I.  No $50 fee for a tiller and borrowing a truck and all that mess!  That\'s until I tried to actually put it into practice.  Don\'t get me wrong, this is a fantastic concept, and it works very well and you should get this book if you want to garden smarter not harder, but there are a few hiccups I wanted other readers to know about before they got started.For those of you who have not perused the book or are familiar with the new method, I\'ll sum it up for you:  you build these four by four boxes--no tilling required--cover the bottom with weed blocker material, and then fill it with a particular mix that Mel says works like a dream. The boxes are easy, the method is brilliant, but the mix was a...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("88", "80", "Windmere", "noreply4327@yourdomain.com", "", "", "2014-04-21 06:50:30", "2014-04-21 06:50:30", "<strong>Proven method of successful organic gardening - My experience with what\'s involved and cost</strong> I INTEND TO UPDATE THIS REVIEW FOR A PERIOD OF AT LEAST A YEAR... THIS WILL HOPEFULLY GIVE YOU A GOOD SNAPSHOT OF THIS ENTIRE ENDEAVOR.  I\'D LIKE TO WARN YOU THAT THIS REVIEW IS EXTREMELY LONG - There are a couple photos of the beginnings of my boxes posted above.My family and I have been wanting to plant an organic garden for years.  However, we live in an area where the soil is red clay.  The thought of tilling our soil was too daunting, so we put the gardening project on hold for several years.This year we decided to \"go for it\" and the idea of using raised garden beds made sense (due to our horrible local soil).  My wife did some research and found that Mel Bartholomew\'s method is consistently shown to be one of the best methods around.  She bought me this book to get our project off the ground.My wife had some reservations about this project.  The reason being that initial set up (when done correctly) can be a bit costly.One of the...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("89", "80", "J. Welch", "noreply8584@yourdomain.com", "", "", "2014-04-21 07:07:44", "2014-04-21 07:07:44", "<strong>Great book, but a few drawbacks...</strong> I\'ve square-foot gardened for a number of years (mostly following the statutes of Mel\'s original book), and last season, upon moving to a new house, I made raised beds based on Mel\'s all-new method in this book. My thoughts almost exactly match those of reviewer S. L. Hutchison in his May 19, 2006 Amazon user review of this book entitled \"Great concept but keep in mind...\"  It\'s a review worth reading.The two things I would add to Hitchison\'s review are:1. In many ways this \"All New\" book lacks a lot of the scope and detail of the original book. The old book seemed a bit more balanced and complete in the range of specific plants discussed, for instance. While I now follow the \"rules\" of this new book, I occasionally refer back to the old book for specific plant info, etc., not included in the new book. If you can buy a cheap used copy of the original book along with this new one, I don\'t think you\'ll regret it.2. The editing on this new book was...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("90", "82", "Crazy Daisy", "noreply4137@yourdomain.com", "", "", "2014-04-21 06:27:34", "2014-04-21 06:27:34", "<strong>If you could only have one, this would be it!</strong> UPDATE:  I just had to come back a year later to reaffirm just how much I depend on this book.  Seriously, it\'s all that and then some! My poor paperback is so beat up on the outside.  But the inside is holding up very well, so is the actual binding.  I\'ve tried so many times to put it away, but it ends up coming right back out shortly after.  Anytime I get to thinking about growing something or if I want to improve things in the garden, check the PH, nutrients, etc. back to the book I go.  I really do highly recommend it to anyone who isn\'t yet a \"master\" gardener.  Who knows, they might even learn something from it!  I think the reason it is so popular, other than the data being dependable, is the layout is so common sense.  The whole back of the book has pages dedicated to each vegetable and you just go in alphabetical order to access that page.  So my point is, if you are floundering around Amazon trying to pinpoint which gardening book to start with, this is it...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("91", "82", "HuskerFan", "noreply1191@yourdomain.com", "", "", "2014-04-21 06:29:23", "2014-04-21 06:29:23", "<strong>One of the better all-around vegetable gardening books</strong> I own a number of books on vegetable gardening, as I have been gardening [and collecting topical books] for over 35 years in 7 different sites. I\'ve observed that in many garden how-to books, the authors get very carried away with themselves, touting \"my way\" as the only way. To me, that\'s kind of off-putting, due to each garden is so different from all others, even in a neighboring yard.I don\'t get a lot of the \"my way\" attitude from this book. It\'s chock full of useful information, but the author is careful to say there is more than one way to do many of the chores and tasks related to the vegetable garden, as well as options for varieties of plants and seeds. One thing you won\'t find is a bunch of recipes or cooking ideas, which is fine with me. I don\'t cook in the garden, and I have plenty of recipes in my RECIPE books - don\'t need them in the gardening books.The text is in an easy conversational style, which I appreciated. The book offers sections on...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("92", "84", "Impska", "noreply9256@yourdomain.com", "", "", "2014-04-21 06:18:05", "2014-04-21 06:18:05", "<strong>Could be helpful, could be disastrous.</strong> I liked this book, I really did. I read through it and thought it sounded like a neat idea and that its checklists would help me keep on top of my garden chores week by week. So I happily filled in my frost date and dates thereafter on the weekly schedules in the book, then flipped to the page for the current date to check on my garden progress. That\'s when I realized that the dates had no bearing on reality at all.My average frost date is April 15. This book lists \"Early fall\" as 12-14 weeks after the average date of frost. That\'s in July. One of the hottest parts of my season. Huh? Fall doesn\'t even start until September. And this is where the book could be dangerous for beginners. It makes fertilizer recommendations based on dates that may be completely inappropriate for your area. If I had followed the instructions here, based on the weekly dates, I would have completely eradicated my harvest.Clearly it needed to switch from \"after frost\" to \"before frost\"...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("93", "84", "JOAN M DAVIS", "noreply7355@yourdomain.com", "", "", "2014-04-21 06:35:36", "2014-04-21 06:35:36", "<strong>Informative....</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("94", "86", "Carole A Gittleman", "noreply639@yourdomain.com", "", "", "2014-04-21 06:24:29", "2014-04-21 06:24:29", "<strong>Really disappointing</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("95", "86", "andy", "noreply3017@yourdomain.com", "", "", "2014-04-21 06:53:05", "2014-04-21 06:53:05", "<strong>Happy I updated from the eighth edition</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("96", "86", "Gen of North Coast Gardening", "noreply2911@yourdomain.com", "", "", "2014-04-21 07:17:58", "2014-04-21 07:17:58", "<strong>This new edition is SO worth it - beautiful photos, sustainable angles, and an emphasis on regional and contemporary design</strong> If you\'re a gardener on the West Coast, you already know this book is a must-have. The only real question is, will you upgrade to the new edition? You may be wondering how different it could be from the old version. Well, for one, it has photos in the encyclopedia. Yep, the charming but often-frustrating illustrations have been replaced with vivid, beautiful photographs. And thank god, they put back the plant index, which was missing in the last edition.The Plant Finder lists in the front have been revamped, with the old sections on broad categories of plants such as \"annuals, \"vines\" and \"ferns\" replaced with more useful sections on \"ornamental edibles\", \"plants that attract beneficial insects\", \"sculptural plants\", \"plants for moon gardens\" and more. Altogether a solid improvement, given the Plant Finder lists are already broken down by type of plant. Having \"trees\" listed separately was kind of overkill given that you\'d be better served by going to the section that most...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("97", "88", "Dianne Foster \"Di\"", "noreply6540@yourdomain.com", "", "", "2014-04-21 06:32:23", "2014-04-21 06:32:23", "<strong>Companions for life.....</strong> I love CARROTS LOVE TOMATOES?an update and revision of the original companion planting book. I used many of these ideas the summer of 1975 when I had a half acre garden. My traditional farmer neighbor laughed when I told him what I was going to do, but later in the summer when the insects devastated his vegetable patch he threatened to come over and pull up all my borage and marigolds. He had to admit I was onto something. We had a few mishaps?white and yellow corn planted to close together = polka-dot corn, but we ran beans up the stalks as Riotte suggests and it worked well. The Mexican bean beatles came to visit and stayed for dinner, but we soon learned how to control them. Marigolds in the rows and our evening search to destroy the yellow egg clusters ensured a good crop. My kids learned a great deal about ?real? survival that summer and they didn?t find it on tv. We had squash, melons, tomatoes, and all sorts of other vegetables, herbs, and flowers, and mixed and matched them as...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("98", "88", "Artemis Gems \"ChainWeavers.com\"", "noreply8248@yourdomain.com", "", "", "2014-04-21 06:59:11", "2014-04-21 06:59:11", "<strong>Disappointing</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("99", "88", "", "noreply1091@yourdomain.com", "", "", "2014-04-21 07:05:02", "2014-04-21 07:05:02", "<strong>Easy to understand for beginner gardeners!</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("100", "90", "Amalfi Coast Girl", "noreply7539@yourdomain.com", "", "", "2014-04-21 06:26:04", "2014-04-21 06:26:04", "<strong>Excellent Gardening Resource, high recommend</strong> I love to cook, and I decided to try my hand at gardening to see if I could grow some of our food.  Needless to say, I had no idea what I was doing.  I found this book at Smith and Hawken and it and helped me to obtain reasonable results the first year.  My garden now grows a little more each year.  I turn to this book regularly, when I am planning on expanding my garden or troubleshooting.The book is subdivided as follows:1. The Flower Garden2. The Landscape Garden3. The Kitchen Garden4. The Potted Garden5. Garden KeepingThe Flower Garden deals with annuals, perennials, roses and bulbs.  Plants that bloom in the spring, summer, fall and then fade back in the winter.The Landscape Garden will answer questions about the bigger picture it covers:  ground cover, lawns, shrubs, trees and vines.  The chapter also covers path materials and garden design.The Kitchen Garden provides...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("101", "90", "Midwest Book Review", "noreply2510@yourdomain.com", "", "", "2014-04-21 06:50:32", "2014-04-21 06:50:32", "<strong>Everything You Wanted to Know About Garddening in the NE</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("102", "92", "Paula Fitzsimmons", "noreply3450@yourdomain.com", "", "", "2014-04-21 06:36:29", "2014-04-21 06:36:29", "<strong>Original and Thoughftul!</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("103", "92", "K. Fritz", "noreply6553@yourdomain.com", "", "", "2014-04-21 06:41:06", "2014-04-21 06:41:06", "<strong>You will come back time after time to this book!</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("104", "94", "Amazon Customer", "noreply7625@yourdomain.com", "", "", "2014-04-21 06:12:45", "2014-04-21 06:12:45", "<strong>LOVE IT! LOVE IT! LOVE IT!</strong> This book is absolutely amazing!! We used to have gardens when I was little but, typical child that I was, I hated it and did not pay any attention. Now I am slowing down and want to do more than plant flowers (although I am not giving them up either!!) and don\'t know a darn thing about what to plant where. That is where this book comes in!It has practical tips about what to plant together to balance the nutrients. What plants need the same amount of water and sun (so you don\'t plant a sun lover in the shade!). And it is so easy to find what you are looking for in a matter of minutes not hours (like some books I have looked at). Plus it doesn\'t assume you know all of the terminology of gardening (as if I know what air layering, complete flowers, dormant oil, soil sterilizing, and sweating plants are--just to name a few one book I picked up used).This book is a must read for the basic beginner gardener who just wants to know what plants repel what pests and what...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("105", "94", "ShopZilla", "noreply6261@yourdomain.com", "", "", "2014-04-21 06:42:08", "2014-04-21 06:42:08", "<strong>More information about gardening than I even knew existed!</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("106", "94", "Sam Tracy", "noreply4153@yourdomain.com", "", "", "2014-04-21 06:43:22", "2014-04-21 06:43:22", "<strong>Focused on flowers</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("107", "96", "C. Fowlkes \"Thangmy\"", "noreply8062@yourdomain.com", "", "", "2014-04-21 06:21:16", "2014-04-21 06:21:16", "<strong>Great ideas, Very doable, Very thorough</strong> Howdy, I garden..too much some say... close to 2 acres of intensive vegetable beds in Vietnam, so I\'m always growing 12 months a yearI own just about every gardening book amazon sells, Most books are good for a few Ideas and that\'s finebut this book goes into great detail on vertical gardening with some very thorough explanations for vegetables and flowers and many different ways to go about it.He also gives an honest interpretation of heirlooms and hybrids seeds, I love heirlooms but hybrids get an unnecessary bad rap these days from misinformation.the author clears that up nicely, he also mentions some varieties that have worked very well for him(Always appreciated)That along with a new Compost tea recipe that I\'ve never seen anywhere else and won\'t have you going nuts trying to find the ingredients as well as Some very Good and NEW info makes this an easy 5 stars, I\'ll be changing existing beds and putting up new vertical Beds from the info provided in this...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("108", "96", "J. L. Maurer", "noreply3453@yourdomain.com", "", "", "2014-04-21 06:39:50", "2014-04-21 06:39:50", "<strong>General advice but little specifics of vertical structures</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("109", "98", "Diane Hoffmaster \"Turning the Clock Back\"", "noreply3906@yourdomain.com", "", "", "2014-04-21 06:20:53", "2014-04-21 06:20:53", "<strong>The Organic Gardener\'s Handbook of Natural Pest and Disease Control</strong> I have been trying my hand at organic gardening for a couple of years now and I am learning, quite quickly, that it is NOT easy!  I am so glad that books like The Organic Gardener\'s Handbook of Natural Pest and Disease Control  are around to help poor souls like me who just don\'t have much of a green thumb!There are 4 parts to this book.  Part 1 deals with building a healthy garden so that you can grow healthy plants.  This section deals with composting, cover crops, and applying healthy supplements such as seaweed spray. (I have never heard of seaweed spray!  I am going to do some research on that!)  It also covers topics such as choosing resistant strains of plants and planting at the right time of year.  Even a week or two change in when you plant can help avoid certain pests. I do wish there was more information on heirloom plant varieties, it seems like the hybrid plants offer more resistance to disease and the fewer diseases, the fewer treatments necessary, however I...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("110", "98", "C. Johnson", "noreply8529@yourdomain.com", "", "", "2014-04-21 06:21:13", "2014-04-21 06:21:13", "<strong>good start</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("111", "98", "Jose German-Gomez", "noreply9692@yourdomain.com", "", "", "2014-04-21 06:33:31", "2014-04-21 06:33:31", "<strong>The organic garderner\'s handbook</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("112", "100", "Michael Sullivan", "noreply2690@yourdomain.com", "", "", "2014-04-21 06:31:32", "2014-04-21 06:31:32", "<strong>Not literature but nice and useful</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("113", "100", "Willow", "noreply8754@yourdomain.com", "", "", "2014-04-21 06:35:13", "2014-04-21 06:35:13", "<strong>A clever, entertaining practical gardening book.</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("114", "102", "Bethany Fowler \"Gypsy November\"", "noreply3549@yourdomain.com", "", "", "2014-04-21 06:35:27", "2014-04-21 06:35:27", "<strong>Decent Beginning Homesteader Book</strong> This book is one of many you can find about, well, homesteading in your backyard. It\'s always good when the title is appropriate to the words within. ;) I own a few of these books, and this one doesn\'t veer one inch from the beaten track. What I mean by this is not that there is anything wrong with the book, only that if you already own a couple \"self-sufficiency\" books, this one is not going to shock you with any new information.It does have quite a number of illustrations, which is great if you are a visual person. In fact, I really think that this is the best thing going for this book. Some of the other \"back-to-basics\" which I have read which have few pictures. Ordinarily, I am more than fine with this, since, if I have to choose, I\'d rather have competent words than a ton of photographs. However, this book is pretty good at having plenty of illustrations without sacrificing the word content, and I appreciate that.I will warn those of you who are a little...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("115", "102", "wogan", "noreply3842@yourdomain.com", "", "", "2014-04-21 06:41:05", "2014-04-21 06:41:05", "<strong>Feed yourself</strong> This book is a good guide to helping you be more self-sustaining; although I always cringe when I read the statement...self-sustaining which is almost impossible, especially within a backyard.There is a list of safeties and cautions, but not until you get to the introduction is there a mention that perhaps your community or county/city codes might not allow you to have chickens, much less goats. Some of the down and dirty is brought up, such as having to trim goat\'s hooves. The charts and plans are very thorough for the most part. The storage sheds have a cut away diagrams and a supplies list, but do not tell you how to build them.There are many pictures and good descriptions; the garden tools you need are all well depicted, even for novices. Several charts are included such as; how much you should plant and steps for drying vegetables. The specifics for the herbs and vegetables are very complete; telling the life cycle, size, soil needed and propagation, spacing,...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("116", "102", "Jamie Moore", "noreply7585@yourdomain.com", "", "", "2014-04-21 06:52:29", "2014-04-21 06:52:29", "<strong>The pictures!!!</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("117", "104", "Crazy Daisy", "noreply3341@yourdomain.com", "", "", "2014-04-21 06:28:50", "2014-04-21 06:28:50", "<strong>If you could only have one, this would be it!</strong> UPDATE:  I just had to come back a year later to reaffirm just how much I depend on this book.  Seriously, it\'s all that and then some! My poor paperback is so beat up on the outside.  But the inside is holding up very well, so is the actual binding.  I\'ve tried so many times to put it away, but it ends up coming right back out shortly after.  Anytime I get to thinking about growing something or if I want to improve things in the garden, check the PH, nutrients, etc. back to the book I go.  I really do highly recommend it to anyone who isn\'t yet a \"master\" gardener.  Who knows, they might even learn something from it!  I think the reason it is so popular, other than the data being dependable, is the layout is so common sense.  The whole back of the book has pages dedicated to each vegetable and you just go in alphabetical order to access that page.  So my point is, if you are floundering around Amazon trying to pinpoint which gardening book to start with, this is it...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("118", "104", "HuskerFan", "noreply4025@yourdomain.com", "", "", "2014-04-21 06:48:39", "2014-04-21 06:48:39", "<strong>One of the better all-around vegetable gardening books</strong> I own a number of books on vegetable gardening, as I have been gardening [and collecting topical books] for over 35 years in 7 different sites. I\'ve observed that in many garden how-to books, the authors get very carried away with themselves, touting \"my way\" as the only way. To me, that\'s kind of off-putting, due to each garden is so different from all others, even in a neighboring yard.I don\'t get a lot of the \"my way\" attitude from this book. It\'s chock full of useful information, but the author is careful to say there is more than one way to do many of the chores and tasks related to the vegetable garden, as well as options for varieties of plants and seeds. One thing you won\'t find is a bunch of recipes or cooking ideas, which is fine with me. I don\'t cook in the garden, and I have plenty of recipes in my RECIPE books - don\'t need them in the gardening books.The text is in an easy conversational style, which I appreciated. The book offers sections on...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("119", "106", "M. Lam", "noreply1821@yourdomain.com", "", "", "2014-04-21 06:12:53", "2014-04-21 06:12:53", "<strong>lots of ideas, not enough photographs</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("120", "106", "Jeri Nevermind \"loves to read\"", "noreply2108@yourdomain.com", "", "", "2014-04-21 06:43:08", "2014-04-21 06:43:08", "<strong>Good book on garden design, even for the beginner.</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("121", "108", "E. White", "noreply7220@yourdomain.com", "", "", "2014-04-21 06:21:56", "2014-04-21 06:21:56", "<strong>Oooh... Rodale has a new book out!</strong> I have treasured my 1971-copy of their first guide to organic gardening by Robert Rodale and have always considered them to be an authority on the subject. With this new book, you have an update to sage advice with pretty pictures (illustrations and photos) to look at! If you are new to the world of organic growing, there are a lot of great books out there from Eliot Coleman\'s Four Season Harvest to Ruth Stout\'s .Here - is a great, straightforward guide to planting and growing for beginners. There are tips for taking care of weeds, good bugs vs. bad bugs, and pretty much anything that a new (or new-ish) organic gardener would need to know. If you are looking to establish better eating habits, there is no better way than to grow your own food. Get excited about the 2014 season with this beautiful book! And a little tip... and I am in no way association with the publisher... but at...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("122", "110", "KristiK", "noreply3229@yourdomain.com", "", "", "2014-04-21 06:18:38", "2014-04-21 06:18:38", "<strong>Organic Food Gardening Beginner\'s Manual</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("123", "110", "MJM", "noreply5199@yourdomain.com", "", "", "2014-04-21 06:28:11", "2014-04-21 06:28:11", "<strong>Not quite what I expected</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("124", "110", "Syed S. Ahmed", "noreply3484@yourdomain.com", "", "", "2014-04-21 06:47:21", "2014-04-21 06:47:21", "<strong>Ultimate Guide for Creating and Managing an Organic Garden</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("125", "112", "B. Marold \"Bruce W. Marold\"", "noreply3449@yourdomain.com", "", "", "2014-04-21 06:15:04", "2014-04-21 06:15:04", "<strong>Excellent on techniques for Perennials. Buy It.</strong> I am exceptionally pleased that \'The Well-Tended Perennial Garden\' has gotten as many favorable reviews as it has, since I suspect it\'s charms and offerings are just a bit more subtle than your average glossy oversized gardening book. It is essential that you pay attention to the subtitle, as this is a book specializing in teaching us about setting up and planting perennials, and less about choosing or matching or even weeding perennials (the author does not like to weed!). If you flip through the book, you may be put off by the lack of illustrations accompanying the text. While I\'m not a big fan of pictures in cookbooks, unless it\'s discussing a specific technique, I sort of miss them in gardening books. This volume is economically done, with all the glossies in a central rotogravure section. This is ok, because the real meat is in the lessons on planting and pruning. The only place I really miss them is in the encyclopedia of perennials, which is less a true comprehensive...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("126", "112", "D. Foster \"gardendollee\"", "noreply6012@yourdomain.com", "", "", "2014-04-21 06:26:23", "2014-04-21 06:26:23", "<strong>The Gardening Book I Recomend to Everyone !!!!!!!!!</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("127", "114", "icebear", "noreply8434@yourdomain.com", "", "", "2014-04-21 06:28:48", "2014-04-21 06:28:48", "<strong>Great practical guide, basics and history</strong> This book can be very useful for the small space gardener as it discusses at length, basics of gardening. Anywhere the book describes use of horses, logic would indicate that a tiller of varying sizes could be substituted. Crop rotation is also discussed, and multiple acres are not needed for this.I enjoyed the instructions on constructing a manure-driven hotbed.  This was the way it was done before electric seedling heat mats were around. Also prepping sods for seed starting.  It reminded me of the way things were done years before pellet pots,  plastic seed flats and cell packs were common.The book is old enough to resurrect much of the forgotten techniques used by our grandparents and great-grandparents  -of the way things were, the way things could be again for those trying to garden more naturally and self-sufficiently... not buying everything from the garden store. It might also be helpful for the budding survivalist who no longer wants to rely on manufactured...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("128", "114", "MainelyClassics", "noreply4357@yourdomain.com", "", "", "2014-04-21 06:40:36", "2014-04-21 06:40:36", "<strong>Kindle Review: Historic Gardening Read With Issues</strong> This Kindle book, \"Home Vegetable Gardening -a Complete and Practical Guide to the Planting and Care of All Vegetables, Fruits and Berries Worth Growing for Home Use\" was published in 1911. It was the first work by F. P. Rockwell, a prolific and well-known horticultural author of his day.  He was founder of Home Garden Magazine. Among his many other accomplishments, he was the Sunday garden editor of the New York Times, and garden editor of  McCall\'s.\"Waste of Time\" or \"I loved it\" are not cutting it for me when making a decision of whether or not to add a particular publication to my e-collection, so here is my take on this book:There are at least six issues for readers: (1) The information is 100 years old and outdated (ie use of coal ashes; broccoli \"is a poorer cousin of the cauliflower...of little use where cauliflower can be grown...\"). (2) This publication was intended for a larger gardening operation where you own a tractor, disc, etc. (onions can be...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("129", "114", "Rick", "noreply7123@yourdomain.com", "", "", "2014-04-21 06:55:56", "2014-04-21 06:55:56", "<strong>Great guide, great tips and help!!!</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("130", "116", "\"gaucho-poa\"", "noreply1306@yourdomain.com", "", "", "2014-04-21 06:15:27", "2014-04-21 06:15:27", "<strong>Take this book</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("131", "116", "E. Chandler", "noreply8250@yourdomain.com", "", "", "2014-04-21 06:32:08", "2014-04-21 06:32:08", "<strong>Fantastic Flower Garden Book!</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("132", "116", "Mary E. Brown", "noreply39@yourdomain.com", "", "", "2014-04-21 06:54:58", "2014-04-21 06:54:58", "<strong>Flower gardening Book</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("133", "118", "malc@jetcity.com", "noreply9514@yourdomain.com", "", "", "2014-04-21 06:34:45", "2014-04-21 06:34:45", "<strong>Absolutely the single best book for most gardeners</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("134", "118", "Bob Feeser \"MillCrafters.com\"", "noreply5958@yourdomain.com", "", "", "2014-04-21 06:48:18", "2014-04-21 06:48:18", "<strong>This is it. It\'s a must have. Truly an Encyclopedia</strong> It\'s is worth the money. It is the single most comprehensive book on Gardening. I know it does not give super detailed descriptions of every plant out there. Their supplemental book can help you with that. Buy this one first. When I built a greenhouse, this book have several pages on construction, types of materials, venting, watering systems, cooling, hydrating, you name it, it was covered. When my neighbors pine tree was getting a white pithy coating on the lower leaves, this book described the problem to a T, and had several methods of curing it. No matter where I go, in irrigation, propogation, seed starting, grading, setting up a bed, identifying which plants work, where, when, and in what kind of soil, climate, etc., this book is there. They must of had a zillion contributing editors-authors create this work, because nobody knows everything this book has to offer. It is big, it is well illustrated, and a definite must have for any gardener. It is even a great read during the...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("135", "120", "MYOB", "noreply355@yourdomain.com", "", "", "2014-04-21 06:19:28", "2014-04-21 06:19:28", "<strong>One of the best on gardening, mini-farming, food self-sufficiency</strong> I just read this book and I am very impressed. It compares favorably both to classics of intensive gardening and to classics on self sufficiency. Less complicated than , less expensive and resource-hogging (in terms of peat moss, vermiculite, and grids) than  (which is still well worth buying for the beginning gardener; the charts on planting for a continuous three-season harvest alone are probably worth the price of the book). More focused and with more current (though perhaps still debatable) numbers than , and written...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("136", "120", "John McNamara", "noreply2956@yourdomain.com", "", "", "2014-04-21 06:37:56", "2014-04-21 06:37:56", "<strong>Mini Farming: Self-Sufficiency on 1/4 Acre</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("137", "122", "GENE GERUE \"Author, Find Your Ideal Country Home\"", "noreply4723@yourdomain.com", "", "", "2014-04-21 06:28:24", "2014-04-21 06:28:24", "<strong>I like the way this man handles his rake</strong> Some books are like gold-bearing ore--you have to sift tons of words to find a few nuggets. This book has nuggets on nearly every page. And unlike some authors, Raymond is open-minded to the various gardening methods and  has tried them. Even better, he has worked in different soils in different  parts of the country. And he is innovative.I am not a fan of tillers and  I am biased against chemicals, so Raymond had to overcome my initial  skepticism. He did. While he extols the use of his tiller [he has a long  relationship with Troy-Bilt, owned by Garden Way, publishers of this book],  he also shows how to garden without one. And in most cases he offers  organic alternatives to chemical fertilizers and pesticides. Furthermore,  he started out on a farm, paid for his first home with a garden and  roadside stand, has appeared in food production documentaries and has given  gardening classes throughout the country, face-to-face and on radio and  television.I do not agree with...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("138", "122", "Jennifer \"Jennifer\"", "noreply3157@yourdomain.com", "", "", "2014-04-21 06:40:02", "2014-04-21 06:40:02", "<strong>My Gardening Bible</strong> I never gardened until I moved to Vermont a few years back.  As a city slicker I was amazed a little seed in some dirt could amount to anything.  I got a few gardening books to help me, but this one handed to me by my mother-in-law was the very best (I found the others, especially \"Gardening for Dummies\" a waste of money).  Dick\'s book is filled with photos of just about any run-of-the-mill vegetable (such as the tomato) as well as the more exotic (like my favorite, the brussels sprout).  With clear and easy to follow directions and photos, Dick guides you through the process of growing any vegetable successfully.  My second season of gardening I had an incredible bounty of tomatoes as my fellow gardeners\' tomatoes were hit by blight - I just followed Dick\'s suggestions for planting and mulching.  With the help of this book, I became a somewhat comfortable organic vegetable gardener.  I just bought it for a friend on the West Coast as a housewarming gift - he plans to plant...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("139", "124", "S. Mason", "noreply8760@yourdomain.com", "", "", "2014-04-21 06:13:59", "2014-04-21 06:13:59", "<strong>Great for the beginning gardener</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("140", "124", "Sharon Brown", "noreply8102@yourdomain.com", "", "", "2014-04-21 06:29:24", "2014-04-21 06:29:24", "<strong>Perfect gift for new gardeners</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("141", "124", "R. Perry", "noreply6102@yourdomain.com", "", "", "2014-04-21 06:48:43", "2014-04-21 06:48:43", "<strong>Great book to start with for beginners</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("142", "126", "J. McCoy", "noreply1545@yourdomain.com", "", "", "2014-04-21 06:33:24", "2014-04-21 06:33:24", "<strong>A standard for every organic gardener</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("143", "126", "Leigh", "noreply1545@yourdomain.com", "", "", "2014-04-21 06:34:23", "2014-04-21 06:34:23", "<strong>Doesn\'t compare with the original</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("144", "126", "Jackie \"Jackie\"", "noreply7240@yourdomain.com", "", "", "2014-04-21 06:45:34", "2014-04-21 06:45:34", "<strong>Not encyclopedic, in my opinion</strong> I\'ve enjoyed most of the other books in this series, so perhaps my expectations were high.  This book is really just not that helpful.  Partly the problem is the \"encyclopedic\" organization.  The book is (obviously) arranged alphabetically.  Fine - but then the index and TOC are useless additions of wasted paper that serve no real function, because hey - everything is alphabetical!  The index is worthless for cross-referencing.  Oddly, some things are alphabetical by scientific name, others by general name, etc. Another reviewer mentioned it was good for general reading.  I didn\'t feel it was readable this way at all, but I wasn\'t expecting to.  It really is organized as an \"encyclopedia\" and more conducive to looking up specific items. But when you look something up, the information itself is just not that useful. As a beginner to intermediate gardener, I was underwhelmed with the depth of the info - and at 700+ pages, you\'d think there would be a lot of information!  There are also...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("145", "128", "kcm", "noreply4778@yourdomain.com", "", "", "2014-04-21 06:41:26", "2014-04-21 06:41:26", "<strong>Beautiful pictures and helpful text</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("146", "128", "Margaret B. Huntley", "noreply5928@yourdomain.com", "", "", "2014-04-21 06:41:51", "2014-04-21 06:41:51", "<strong>Container Gardening</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("147", "128", "B. Cauchy", "noreply1056@yourdomain.com", "", "", "2014-04-21 06:44:08", "2014-04-21 06:44:08", "<strong>Great Containers</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("148", "130", "Theresa Christie \"Angeleyes\"", "noreply5222@yourdomain.com", "", "", "2014-04-21 06:33:47", "2014-04-21 06:33:47", "<strong>Beautiful Journal, just wish it was a bit bigger....</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("149", "130", "J. E. Pearce", "noreply2391@yourdomain.com", "", "", "2014-04-21 06:52:16", "2014-04-21 06:52:16", "<strong>Beautiful garden journal - can\'t wait to use</strong> I have never had a proper gardening journal before, and I can see why these moleskin ones are the kings of notebooks, as they really are a work of art, and so therefore have that special factor, as if I am going to write something really important.In the past I have used notebooks or art books which are a lot larger than this, and I have to say when I got the moleskin one, I thought it was a little too beautiful for my dirty gardening and I\'m not entirely sure where to begin, however, as we are not quite in spring here in the southern hemisphere, I still have plenty of time (although I must mark down the date I moved the compost heap and planted the garlic!)  The fact is though, that I\'m a bit fearful of ruining the beauty of the notebook with my scruffy garden writing, and I don\'t want to be so precious about it, particularly as I usually write in my scrappy old garden notebooks of the past when I\'ve just come in from the garden, usually before I\'ve washed up, so...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("150", "130", "bunnypenny", "noreply2515@yourdomain.com", "", "", "2014-04-21 06:53:54", "2014-04-21 06:53:54", "<strong>Just Beautiful!</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("151", "132", "Leslie Readit", "noreply8958@yourdomain.com", "", "", "2014-04-21 06:27:32", "2014-04-21 06:27:32", "<strong>Exquisite book about Potter\'s Gardens!</strong> A Review of \"Beatrix Potter\'s Gardening Life\"The plants and places that inspired the classic children\'s talesBy Marta McDowellOnly rarely in a reader\'s life will a book come along a book that is so perfectly suited for the reader\'s character that it brings out the schoolgirl in her and perhaps a squeal of delight and a series of silly, wistful sighs.  Reader, that is what Marta McDowell\'s latest book has done for me.  I admit I didn\'t exactly love her book on Emily\'s Dickinson\'s garden but perhaps it was just my lack of enthusiasm for Dickinson herself that underwhelmed me.  What a contrast is this treasure before me now.  Shall I tell you all the things I love about it?  The cover is what delights the eyes at once.  Part of the wonder of Beatrix Potter was that she was an amazingly accomplished artist, even from a young age.  The cover is beautiful and includes a watercolor of a sweet garden gate, another of a handful of adorable little guinea pigs...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("152", "132", "Lois-ellin Datta", "noreply8769@yourdomain.com", "", "", "2014-04-21 06:46:35", "2014-04-21 06:46:35", "<strong>The Tale of Mrs. Heelis----A Splendid Story of Beatrix Potter  and Her Many Gardens</strong> Marta McDowell\'s \"Beatrix Potter\'s Gardening Life\" is almost sure to delight all who lovingly remember the stories of Peter Rabbit, Squirrel Nutkin, and Jemima Puddle-Duck which readied us for meeting Mole, Water Rat, Toad, and Badger.  Even better, if these admirers of Beatrix Potter are slightly mad about gardens and wander in their dreams among the dreaming spires of English foxgloves & delphiniums.  (In this review, as in McDowell\'s book, Beatrix Potter is sometimes referred to as Beatrix, sometimes as Beatrix Potter, and after her marriage, sometimes as Mrs. Heelis. Hopefully, this won\'t be confusing.)This richly created book offers on almost every page superbly reproduced water colors of landscapes, plants, and the small creatures of hedgerow and streams, or photographs of the more than 10 homes in which Beatrix lived and gardened.  No one, not even Durer, has drawn bunnies like Beatrix Potter, bunnies with the softest fur, and on p. 106, the roundest tummies, as six...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("153", "134", "Charlie Nardozzi \"Charlie\"", "noreply7900@yourdomain.com", "", "", "2014-04-21 06:14:59", "2014-04-21 06:14:59", "<strong>Gardening Basics for Dummies</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("154", "134", "hajeh", "noreply8981@yourdomain.com", "", "", "2014-04-21 06:22:27", "2014-04-21 06:22:27", "<strong>so far so good</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("155", "136", "E. Tracy", "noreply2792@yourdomain.com", "", "", "2014-04-21 06:36:16", "2014-04-21 06:36:16", "<strong>the book on container gardens that I was waiting for!</strong> I have been gardening seriously for the past couple of years and really got interested in containers last year. I have been asking myself a lot of questions about container gardening, mainly about the nature of the soil to use for pots and I have always wondered if I could reuse potting soil. I have made my share of mistakes (buying lousy pptting soil, for one, or not fertilizing enough) but I have really been craving a seasoned gardener\'s advice. I already owned the  from the same author and . Both were great but the former was really focused on raised beds (which is fine) and the latter lacked pictures and specific guidance. I appreciated that the authors of the Bountiful...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("156", "136", "Comfort Creature", "noreply9197@yourdomain.com", "", "", "2014-04-21 06:38:30", "2014-04-21 06:38:30", "<strong>Rewrite of Incredible Vegetables from Self-Watering Containers</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("157", "136", "Patricia Hampton", "noreply7147@yourdomain.com", "", "", "2014-04-21 06:48:47", "2014-04-21 06:48:47", "<strong>I love this book!</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("158", "138", "Debbie Brown", "noreply5383@yourdomain.com", "", "", "2014-04-21 06:23:57", "2014-04-21 06:23:57", "<strong>Very helpful</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("159", "138", "", "noreply697@yourdomain.com", "", "", "2014-04-21 06:32:52", "2014-04-21 06:32:52", "<strong></strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("160", "140", "A. Ryan \"Merribelle\"", "noreply5956@yourdomain.com", "", "", "2014-04-21 06:17:33", "2014-04-21 06:17:33", "<strong>Fabulous technique for productive, organic gardens</strong> I believe that when it comes to books presenting new ways of doing anything, the only testimony that counts is that which comes from firsthand experience.  Well folks, I\'m here to tell you after a year of gardening the lasagna way that my firsthand experience shows this book is one of the wisest investments any gardener can make.  Let me tell you about my 2003 garden.First, a short outline of lasagna gardening technique:  soak b&w newspapers in water, then overlap sections in a single layer directly on top of premarked sod area.  This smothers the weeds/grass underneath.  Then put a 4 inch layer of moistened peat moss over that, followed by a moist layer of organic shredded green material, followed by another layer of peat moss, followed by a layer of moist compost or yard waste, repeat the peat moss/organic matter pattern until your bed is built up to at least 18 inches high.  Finish with compost on top, then either let it break down for a few months for certain crops or...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("161", "140", "Jade", "noreply9065@yourdomain.com", "", "", "2014-04-21 06:20:57", "2014-04-21 06:20:57", "<strong>Interesting idea, but not for everyone</strong> I really like the concept of this book. The author has taken practices of no-dig gardening, mulching and sheet composting and combined them to come up with an innovative method for quickly creating a productive garden without the back-breaking work traditionally involved.The first chapter of the book explains the lasagna gardening method -- which involves covering up the ground where you intend to plant with a layer of cardboard or wet newspaper to keep down weeds, then topping this with 1 1/2 to 2 feet of layered organic materials such as chopped leaves, compost, straw, grass clippings, etc. You can plant into this straight away, or cover the beds and wait for the materials to decompose. The lasagna gardening method is simple and really only takes 1 chapter to describe. The rest of the book offers good advice on growing vegetables, herbs, flowers, dealing with pests, and special tips and techniques for making your garden unique. This information is comprehensive and beginners...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("162", "142", "Shannon", "noreply1714@yourdomain.com", "", "", "2014-04-21 06:25:58", "2014-04-21 06:25:58", "<strong>Beautiful and useful</strong> This is an excellent veggie gardening book. It is big, 8.5 x 10.5 and almost 300 pages. The organization is clear and uncomplicated. She starts out with general gardening tips, marches through sections on herbs, greens, legumes, squash, cabbages, roots/tubers/bulbs, warm season veggies, and ends with fruit. The format is the same throughout: a short intro to the section and then each produce item. Each item has an intro, a thorough but concise tips on planting, growing, harvesting, storing, cooking, varieties, and a short overview of edible parts and potential problems, followed by a recipe.The format is conducive to learning and very enjoyable to read. I received the book this afternoon and have spent several hours reading it. The photos are excellent and really make the book because they are not only beautiful but helpful. There is enough space on each page to add your own notes. While we may disagree about the best lettuce, baby \"Merveille De Quatre Saisons\" from...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("163", "142", "Katy Gilmore", "noreply4574@yourdomain.com", "", "", "2014-04-21 06:38:06", "2014-04-21 06:38:06", "<strong>Beautiful and Practical!</strong> \"Grow, Cook, Eat\" is a gorgeous, practical guide - enhanced by Jim Henkens\'s photographs of enticing vegetables and the author at work in her garden. The book describes the pleasures and satisfactions of eating what you grow - and tells you how. Many people know Willi Galloway from KUOW\'s popular Seattle radio show \"Greendays,\" her website (digginfood.com), and her many guest appearances at gardening events. In the book\'s introduction she says: \"So think of the guides and advice in these pages as a recipe you can make your own - add a cup more here, a pinch less there - and have as much fun as possible.\"The first chapter of the book is a perfect guide for new gardeners, and chock-full of hints for more experienced ones. In a solid, readable way, she covers the gardening fundamentals from planning and planting to dealing with weeds. Then the book divides into sections on herbs, greens, legumes, squash, cabbage, roots, tubers, and bulbs, warm-season vegetables, and...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("164", "142", "Rebecca Lynn", "noreply9737@yourdomain.com", "", "", "2014-04-21 06:41:11", "2014-04-21 06:41:11", "<strong>Timeless Organic Gardening Reference</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("165", "144", "Marian the Librarian", "noreply1163@yourdomain.com", "", "", "2014-04-21 06:14:51", "2014-04-21 06:14:51", "<strong>For Experienced Gardeners</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("166", "144", "YodaWay \"Make me believe\"", "noreply5298@yourdomain.com", "", "", "2014-04-21 06:20:41", "2014-04-21 06:20:41", "<strong>Small is Beautiful</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("167", "146", "Joanna Daneman", "noreply2078@yourdomain.com", "", "", "2014-04-21 06:29:02", "2014-04-21 06:29:02", "<strong>If you love to garden but hate to dig, this is for you</strong> I have to admit it, digging the rocky soil of New England never appealed to me. So when I started a garden in our New Hampshire backyard, even though I had a half acre to work with, I used this book and the square foot principles.There is no reason to create a monster patch of garden if you are only going to have to give away those hundreds of zucchini (people in our town make sure to close their car windows in August, lest passersby fill their auto with their surplus squashes.)  The square-foot garden method uses square plots, starting with a 4-foot square, that\'s all.  This book gives you the right number of plants per square to put in each for a typical family. We love lettuce, so devoted more squares to lettuce; and you\'d be surprised how few tomato plants you actually need. A married couple with no kids can actually garden in a 4 foot square, which is also helpful for those living in condos or doing terrace or balcony gardening. This method is somewhat related to French...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("168", "146", "M. D. Cummings \"Marv\"", "noreply4043@yourdomain.com", "", "", "2014-04-21 06:43:35", "2014-04-21 06:43:35", "<strong>A great book for a suburban gardener.</strong> This is one of the 2 books that actually got me into gardening (the other being Christopher O. Bird\'s _Modern Vegetable Gardening_).  Like most suburban dwellers, I have a back yard that does not lend itself to traditional gardening.  With Mr. Bartholomew\'s method, I grew green and wax beans, peppers, tomatoes, zuccinni, watermelon, canteloupe, cucumbers, sunflowers, corn, pumpkins, lettuce, swiss chard, carrots and radishes all in a garden consisting of 2 4\'x8\', 1 4\'x4\' and 1 1\'x8\' plots.It is an excellent book for beginners, providing basic information on where to place a garden, when in the year to start it, amending your soil (or even making soil, if necessary), etc.  There is also a guide for every popular vegetable, showing how and when to plant it, how often to water, how often to fertilize, how to harvest, common problems, and other such things. In conclusion, if you are typical suburban dweller who is interested in starting a garden, this book is a...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("169", "146", "", "noreply8799@yourdomain.com", "", "", "2014-04-21 06:50:03", "2014-04-21 06:50:03", "<strong>A Handful of Seeds</strong> Are you like I was. . .grab a handful of seeds and sow them like grass then worry about thinning later? Of course, thinning was an arduous chore and never really got done; which meant, I\'d usually end up with a lot of small useless vegetables.\"Square Foot Gardening\" has done  away with the old traditional method of raising vegetables, especially, the  plant thick, thin later approach.  The first year I used the square foot  gardening method I couldn\'t believe how many carrots I grew, and each  carrot was picture perfect. What a difference square foot gardening made  for our family garden. No longer is it like fifteen little carrots then one  big one. The same is true for all the other produce. My radishes were the  biggest I\'d ever grown and not a hollow one in the bunch.Each plant  gets undivided attention in an easy almost carefree enviornment. Also, in  arid areas such as Utah--where I live. I use only a fraction of the water  with the square foot method. It\'s...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("170", "148", "BeachBrights \"beachbrights blogspot\"", "noreply2508@yourdomain.com", "", "", "2014-04-21 06:14:37", "2014-04-21 06:14:37", "<strong>Video Review</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("171", "148", "nsewus \"nsewus\"", "noreply8298@yourdomain.com", "", "", "2014-04-21 06:17:20", "2014-04-21 06:17:20", "<strong>Perfectly simple</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("172", "150", "Fantasy Lover \"Dragon Lover\"", "noreply9807@yourdomain.com", "", "", "2014-04-21 06:12:23", "2014-04-21 06:12:23", "<strong>Great Book!</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("173", "150", "Carolynn", "noreply9478@yourdomain.com", "", "", "2014-04-21 06:29:53", "2014-04-21 06:29:53", "<strong>MiracleGro Guide</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("174", "152", "lizardbreath@webtv.net", "noreply6913@yourdomain.com", "", "", "2014-04-21 06:28:16", "2014-04-21 06:28:16", "<strong>The best garden common sense book I\'ve read!</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("175", "152", "L. J. Frederick", "noreply1669@yourdomain.com", "", "", "2014-04-21 06:56:27", "2014-04-21 06:56:27", "<strong>Another wonderful Rodale book</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("176", "154", "Beverly Lower", "noreply4720@yourdomain.com", "", "", "2014-04-21 06:23:14", "2014-04-21 06:23:14", "<strong>great book</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("177", "154", "Angela Lee", "noreply2012@yourdomain.com", "", "", "2014-04-21 06:43:13", "2014-04-21 06:43:13", "<strong>Good Information</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("178", "156", "Ronda Thomson \"Jordy\'s gramma\"", "noreply5278@yourdomain.com", "", "", "2014-04-21 06:29:29", "2014-04-21 06:29:29", "<strong>Fantastic book</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("179", "156", "Chuck Martin \"Chuck\"", "noreply428@yourdomain.com", "", "", "2014-04-21 06:47:13", "2014-04-21 06:47:13", "<strong>Excellent!</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("180", "158", "Larry L. Kistler \"llkistler\"", "noreply182@yourdomain.com", "", "", "2014-04-21 06:17:15", "2014-04-21 06:17:15", "<strong>Results Beyond My Highest Expectations!</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("181", "158", "Michael C. Podlesny", "noreply2067@yourdomain.com", "", "", "2014-04-21 06:44:04", "2014-04-21 06:44:04", "<strong>Learned quite a bit</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("182", "160", "cucadare", "noreply7646@yourdomain.com", "", "", "2014-04-21 06:26:20", "2014-04-21 06:26:20", "<strong>Doing well</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("183", "160", "Kim Johnson", "noreply9321@yourdomain.com", "", "", "2014-04-21 06:52:43", "2014-04-21 06:52:43", "<strong>Disappointed</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("184", "162", "Michelle Young", "noreply9723@yourdomain.com", "", "", "2014-04-21 06:29:34", "2014-04-21 06:29:34", "<strong>Not what it claims to be!</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("185", "162", "Kara", "noreply3078@yourdomain.com", "", "", "2014-04-21 06:53:27", "2014-04-21 06:53:27", "<strong>Ripoff!</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("186", "164", "Emily Veinglory \"Book Reviewer\"", "noreply397@yourdomain.com", "", "", "2014-04-21 06:15:39", "2014-04-21 06:15:39", "<strong>Modified image</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("187", "164", "RobinJean", "noreply8118@yourdomain.com", "", "", "2014-04-21 06:17:07", "2014-04-21 06:17:07", "<strong>no such thing</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("188", "164", "Mafia medic \"Fivo\"", "noreply6053@yourdomain.com", "", "", "2014-04-21 06:41:47", "2014-04-21 06:41:47", "<strong>Dont Waist Your Money</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("189", "166", "Juan J. Peña \"Apollux\"", "noreply3033@yourdomain.com", "", "", "2014-04-21 06:33:57", "2014-04-21 06:33:57", "<strong>High germination rate</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("190", "166", "A. Dewitt \"wishful thinker\"", "noreply5924@yourdomain.com", "", "", "2014-04-21 06:50:49", "2014-04-21 06:50:49", "<strong>Still waiting</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("191", "166", "J. Johnson \"Collector of things\"", "noreply704@yourdomain.com", "", "", "2014-04-21 06:51:59", "2014-04-21 06:51:59", "<strong>Slow growing</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("192", "168", "Daniel S.", "noreply3292@yourdomain.com", "", "", "2014-04-21 06:28:59", "2014-04-21 06:28:59", "<strong>good looking seeds</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("193", "170", "Dicky T", "noreply993@yourdomain.com", "", "", "2014-04-21 06:29:35", "2014-04-21 06:29:35", "<strong>Outstanding Service</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("194", "170", "Kathy J Spears", "noreply7677@yourdomain.com", "", "", "2014-04-21 06:38:47", "2014-04-21 06:38:47", "<strong>Do not trust</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("195", "170", "Christine Moe", "noreply5928@yourdomain.com", "", "", "2014-04-21 07:06:34", "2014-04-21 07:06:34", "<strong>Ordered not received!</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("196", "174", "Chel Micheline \"Chel Micheline\"", "noreply7582@yourdomain.com", "", "", "2014-04-21 06:33:57", "2014-04-21 06:33:57", "<strong>grew beautifully, but no variety</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("197", "174", "Me", "noreply8978@yourdomain.com", "", "", "2014-04-21 06:55:13", "2014-04-21 06:55:13", "<strong>This is Not a Rainbow Mixture!</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("198", "174", "tk \"tk\"", "noreply3452@yourdomain.com", "", "", "2014-04-21 07:10:54", "2014-04-21 07:10:54", "<strong>Grew like crazy!</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("199", "176", "D. Heaton", "noreply2503@yourdomain.com", "", "", "2014-04-21 06:26:18", "2014-04-21 06:26:18", "<strong>Happy~</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("200", "176", "Jake", "noreply5410@yourdomain.com", "", "", "2014-04-21 06:50:27", "2014-04-21 06:50:27", "<strong>Good Product</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("201", "176", "Amarithe", "noreply4371@yourdomain.com", "", "", "2014-04-21 07:21:22", "2014-04-21 07:21:22", "<strong>Good Service</strong> Seeds arrived a day before they were expected, the package (and the seeds, which totaled 6) were in good shape. I look forward to watching them grow and I appreciate the chance to grow such a lovely plant for such an agreeable price.I put one in a bag with a moist paper towel yesterday and am awaiting the results. I have heard of several different methods of germinating the seeds, ranging from the paper towel method, to planting just beneath the soil surface, to soaking, as well as nicking before soaking. However, they are hardy plants, and I figured the paper towel method would suffice for a first try.I noticed that several individuals gave this store a lower rating due to not fully understanding or researching what they were buying first. So, some notes:*The wisteria may not bloom for 10 years. If you would like one to bloom sooner, you should try growing a cutting from a mature plant.*It is a vine plant, but can be trained into a...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("202", "178", "JK", "noreply5327@yourdomain.com", "", "", "2014-04-21 06:36:18", "2014-04-21 06:36:18", "<strong>Easy to grow, good price</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("203", "178", "Bryan Alexander", "noreply1443@yourdomain.com", "", "", "2014-04-21 06:48:56", "2014-04-21 06:48:56", "<strong>Great for juicing</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("204", "178", "Jen Estes \"Author of Big Leagues (A Cat McDan...", "noreply8262@yourdomain.com", "", "", "2014-04-21 06:53:19", "2014-04-21 06:53:19", "<strong>Keeps my cat healthy!</strong> Since adopting my Wrigley, a portly adult tabby, he has had a problem with chronic anal gland ruptures.  (This is much to the dismay of my vet, who rarely sees these on cats - however, internet research states they are common on cats, especially inactive, overweight ones.  Although he weighs 14 pounds, he does not over-eat and we try to get him to play/exercise.)  Still, he was getting AG ruptures, especially in the winter.  I\'ve often grown wheatgrass for him and he loves it, but I get busy and forget to plant it.Wrigley last had an AG rupture in November and it occurred to me that he\'d had a good stretch without one.  I remembered that during this stretch I had been very diligent about keeping grass growing for him.  After he was done with his treatment (a week of antibiotics), I decided I would keep a rotating supply for him and see what happens.  Well, I\'m happy to report that it\'s now been seven months since his last rupture.  Not only has he not been sick, he has...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("205", "182", "Louis J. Barbier \"The Cocoli Kid\"", "noreply5241@yourdomain.com", "", "", "2014-04-21 06:16:45", "2014-04-21 06:16:45", "<strong>Pyrethrum Daisy Seeds Review</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("206", "182", "Nurrah", "noreply3208@yourdomain.com", "", "", "2014-04-21 06:20:26", "2014-04-21 06:20:26", "<strong>You can\'t have too many flowers that repel mosquitos!</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("207", "184", "TFSeeds", "noreply2797@yourdomain.com", "", "", "2014-04-21 06:44:50", "2014-04-21 06:44:50", "<strong>Amazing Germination Rates!!</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("208", "184", "conforton", "noreply6951@yourdomain.com", "", "", "2014-04-21 06:59:37", "2014-04-21 06:59:37", "<strong>good deal</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("209", "186", "Brett A. Fishwild \"cz75auto\"", "noreply5059@yourdomain.com", "", "", "2014-04-21 06:29:16", "2014-04-21 06:29:16", "<strong>A review from someone who actually planted the seeds</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("210", "186", "Stuck in Michigan \"/T\"", "noreply5330@yourdomain.com", "", "", "2014-04-21 06:47:40", "2014-04-21 06:47:40", "<strong>100% sprouting so far</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("211", "188", "Amazon Customer", "noreply6342@yourdomain.com", "", "", "2014-04-21 06:26:45", "2014-04-21 06:26:45", "<strong>so far so good</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("212", "188", "Jane", "noreply8242@yourdomain.com", "", "", "2014-04-21 06:50:15", "2014-04-21 06:50:15", "<strong>Super Quality and Awesome Customer Service for these Heritage Seeds Pack</strong> I Really Like This Heritage Seeds PackI\'ve had my heritage seeds pack for almost a month and I really am impressed at the speed with which these seeds sprout and the healthy looking plants that are beginning to grow. At first, I almost bought another, more expensive product, because it was advertised as coming with a \"seed vault.\"  It looked great but I think it\'s just a tin can.After reading up on the best type of container for heritage seeds, I found that a metal can isn\'t a good way to store your survival seeds and that a glass container makes a much better vault for short term or long term storage. Wow, am I glad I didn\'t pay the extra money and was able to get a lot more seeds.This package came very quickly and I was impressed that it had a suggestion for using one of your old pickle or spaghetti jars for a container.  The lids on these jars are designed to re-seal so they are just as good as any jar you could use for storage and they don\'t...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("213", "188", "Michael L.", "noreply5935@yourdomain.com", "", "", "2014-04-21 06:50:57", "2014-04-21 06:50:57", "<strong>Great Seeds!</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("214", "190", "MEE2", "noreply7714@yourdomain.com", "", "", "2014-04-21 06:18:15", "2014-04-21 06:18:15", "<strong>Great Germination!</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("215", "192", "Amazon Customer \"Computer Tutor\"", "noreply2941@yourdomain.com", "", "", "2014-04-21 06:32:23", "2014-04-21 06:32:23", "<strong>great teaching surprise</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("216", "192", "Wolfee1", "noreply7061@yourdomain.com", "", "", "2014-04-21 06:34:04", "2014-04-21 06:34:04", "<strong>~ THEY LOOK BEAUTIFUL ~</strong> I never seen Purple Carrots so I ordered them for my Sister who likes to plant and grow all kinds of Fruits and Vegetables. The Seeds arrived very fast all 350 of them in a Tiny Little Plastic Bag. The Seeds were planted about two weeks before the last Frost where She lives, in deep well worked stone free soil, thin 2-3 inches apart, should not be planted in heavy Frost and from Spring to midsummer. Do not transplant as crooked roots may result. Cultivate periodically or mulch to control weeds, keep soil evenly moist, Seeds may be covered with Hessian or similar until Germination. Expect Harvests to start to occur in late Spring, This Plant likes Good Soil, Sun and Water, it takes about 75 days to grow to MaturityPurple Dragon is an Annual Plant which means it typically only grows best for a single growing Season. My Sister\'s Purple Dragon Carrots grew 6 to 8 Inches in Length and out of the 350 Seeds 80% Germinated, dozens of Beautiful thick Purple Dragon Carrots with a...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("217", "194", "Julie", "noreply9499@yourdomain.com", "", "", "2014-04-21 06:20:06", "2014-04-21 06:20:06", "<strong>Lousy germination</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("218", "194", "widowTink \"*tink*\"", "noreply4562@yourdomain.com", "", "", "2014-04-21 06:43:39", "2014-04-21 06:43:39", "<strong>no plants :-(</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("219", "196", "Wolfee1", "noreply6912@yourdomain.com", "", "", "2014-04-21 06:46:16", "2014-04-21 06:46:16", "<strong>~ SWEET WATERMELONS ~</strong> I\'ve got 100 Sugar Baby Watermelon Seeds for my Sister who has a Farm and She is always Planting and Growing all kinds of Fruits and Vegetables. The Seeds were Planted indoors in a Planting tray with good quality Soil. you should water the Seeds well and place the tray in a warm area 80 degrees during the day, a Greenhouse is Ideal but a sunny countertop will work as well. Covering your seeding trays with plastic wrap will create a Greenhouse like environment for your Seeds.The Seeds Germinated Beautifully, and they should be transplanted outdoors in an area that has been aerated with a rake and doesn\'t have any stones and is free of debris. The Seedlings are ready to be transplanted outdoors in your Garden when they have reached a height of 4 to 6 inches and have several leaves on them and after the last frost in your AreaAdding equal parts of Loam and sand to the Soil is beneficial since watermelons enjoy rich Loamy Soil. Space the Seedlings 2 to 3 feet apart...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("220", "196", "Eddie", "noreply6756@yourdomain.com", "", "", "2014-04-21 07:14:16", "2014-04-21 07:14:16", "<strong>will definitely order some more!! :-)</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("221", "198", "Annie", "noreply4557@yourdomain.com", "", "", "2014-04-21 06:16:49", "2014-04-21 06:16:49", "<strong>brussel sprouts yum!</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("222", "198", "pizzaman", "noreply1440@yourdomain.com", "", "", "2014-04-21 06:26:19", "2014-04-21 06:26:19", "<strong>brussel sprouts</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("223", "200", "BEARDOOG", "noreply2514@yourdomain.com", "", "", "2014-04-21 06:33:06", "2014-04-21 06:33:06", "<strong>really hong knog....sold from seedfans</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("224", "200", "Allen Schrock", "noreply8109@yourdomain.com", "", "", "2014-04-21 06:47:35", "2014-04-21 06:47:35", "<strong>No Production</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("225", "202", "VIVI", "noreply475@yourdomain.com", "", "", "2014-04-21 06:23:43", "2014-04-21 06:23:43", "<strong>Seeds</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("226", "202", "R. Woodward", "noreply563@yourdomain.com", "", "", "2014-04-21 06:52:59", "2014-04-21 06:52:59", "<strong>Wide Assortment</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("227", "204", "L. Deasy \"Literacy Teacher\"", "noreply480@yourdomain.com", "", "", "2014-04-21 06:27:13", "2014-04-21 06:27:13", "<strong>Nothing yet</strong> I received my seeds in a clear plastic baggie with a sticker stating what was in the package. I planted them a week ago and nothing has sprouted yet. Tomatoes, and two types of flowers are up. I\'ll give it another week to see if something sprouts, if so I\'ll change my stars.  As stated previously by another reviewer, this is a big disappointment. I have prime but i wanted these seeds and they weren\'t prime eligible, so I paid for shipping as well. Waste of money.Update 6/1/13 so I gave up on the peppers, stopped watering them for a day, left them coverered and walked away. Two days later nearly all the peppers sprouted!! Because there were no instructions I didn\'t know the germination time, apparently fourteen days is about right. I upped my stars to four. The only thing I dislike is the labeling on the package. Nothing in the description of the product that I received states it\'s actually organic. With all the GMO (genetically modified organisms) I want good wholesome...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("228", "204", "N. P.", "noreply5635@yourdomain.com", "", "", "2014-04-21 06:51:22", "2014-04-21 06:51:22", "<strong>None sprouted</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("229", "204", "Livnletliv", "noreply6477@yourdomain.com", "", "", "2014-04-21 07:19:32", "2014-04-21 07:19:32", "<strong>Biggest disappointment of the year</strong> These were extremely slow to germinate, I was about to give up and toss the peat pots that the seeds were in in the trash and just write it off when the first pepper seedling finally made an appearance. They took nearly a month to start sprouting, and only 17 germinated. Two seedlings died within days of sprouting, two more died after transplanting. The 13 surviving plants were very slow to set fruit, 8 have yet to produce a single pepper. Also, after transplanting, some started to try to grow sideways, all have weak stems and have had to be staked so the won\'t fall over.Additionally, it would have been very, very helpful if the seeds had been separated rather than all mixed together. Considering that most peppers are actually picked while green (not ripe) and all of them start out green, it\'s going to be difficult to determine when to pick these or what colors actually managed to make it to the garden and not die. Biggest disappointment of the season, totally not worth...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("230", "206", "RV Vagabonds", "noreply7695@yourdomain.com", "", "", "2014-04-21 06:44:03", "2014-04-21 06:44:03", "<strong>Great producer</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("231", "206", "Tori247", "noreply8452@yourdomain.com", "", "", "2014-04-21 07:05:37", "2014-04-21 07:05:37", "<strong>Thanks again</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("232", "208", "JJC", "noreply6940@yourdomain.com", "", "", "2014-04-21 06:38:28", "2014-04-21 06:38:28", "<strong>These Grew!</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("233", "208", "M. Ridgway", "noreply6643@yourdomain.com", "", "", "2014-04-21 07:02:07", "2014-04-21 07:02:07", "<strong>good for large containers</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("234", "210", "C. Fleming \"Book Damsel\"", "noreply5835@yourdomain.com", "", "", "2014-04-21 06:25:13", "2014-04-21 06:25:13", "<strong>Good germination</strong> I purchased the Hinterland Italian Tomato Tree seeds on 2/13/14, and received them on 2/18/14.  They were shipped in a small padded envelope and the seeds are in a mini-plastic envelope. The contents were un-damaged and in good condition.I began to germinate my seeds on 2/22/14.  My setup includes a planters heat mat that I place on my kitchen window sill, as seen here:http://www.amazon.com/gp/product/B00CRJ0XZO/ref=as_li_ss_tl?ie=UTF8&camp=1789&creative=390957&creativeASIN=B00CRJ0XZO&linkCode=as2&tag=thetecgir-20I plant my seeds in small plastic Dixie cups with Miracle Grow potters mix.  The Dixie cups have slits on the bottom for drainage, and all cups sit in a plastic container with water kept about 1/4 inch full on the bottom.Of the first 6 I planted, 5 germinated.  So I think that\'s a pretty good ratio.  I have since re-planted 2 more seeds that have not yet germinated.  So in total I have planted 8 seeds, and 5 have germinated.  I...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("235", "210", "Pen Name", "noreply7591@yourdomain.com", "", "", "2014-04-21 06:50:54", "2014-04-21 06:50:54", "<strong>Amazing</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("236", "212", "Jared", "noreply2933@yourdomain.com", "", "", "2014-04-21 06:31:45", "2014-04-21 06:31:45", "<strong>good product and instructions have not planted yet</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("237", "214", "kj", "noreply2252@yourdomain.com", "", "", "2014-04-21 06:18:59", "2014-04-21 06:18:59", "<strong>bok choy for bees</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("238", "214", "Barefoot in KY", "noreply2637@yourdomain.com", "", "", "2014-04-21 06:34:13", "2014-04-21 06:34:13", "<strong>Eager to Grow Seeds</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("239", "216", "REC", "noreply8574@yourdomain.com", "", "", "2014-04-21 06:34:38", "2014-04-21 06:34:38", "<strong>Beautiful Container Pepper</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("240", "216", "S. J. Cold \"coldje\"", "noreply6305@yourdomain.com", "", "", "2014-04-21 06:35:02", "2014-04-21 06:35:02", "<strong>Disappointing</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("241", "216", "Dee \"M.N.\"", "noreply3297@yourdomain.com", "", "", "2014-04-21 06:53:17", "2014-04-21 06:53:17", "<strong>great germination rate</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("242", "218", "Fred Johnson", "noreply559@yourdomain.com", "", "", "2014-04-21 06:28:36", "2014-04-21 06:28:36", "<strong>Highly recommend this seed bank!</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("243", "218", "I am 4 YHWH r u", "noreply450@yourdomain.com", "", "", "2014-04-21 06:49:57", "2014-04-21 06:49:57", "<strong>Lots of seeds</strong> 2/24/14 UPDATEfirst of all, I tried to navigate the website to figure out the best time of year to plant which plants and when, after hours I finally just made piles of seeds I would start this month and another batch to start in a month or two, (zone 8).  After that, since I have no experience I decided to sprout 3 plants of each that I had chosen and put 1-2 seeds in each pod.  Well, these seeds are unbelievable how fast they sprout!  Within days they had sprouted and they were so stocky and strong that many were pushing the top off the seed tray.With no experience I figured I would pull those out and move them to there own pot until I could plant them outside.  Over the next couple of days they got so long and reached so hard for the window that they were falling over so when we hit 75 degrees I moved them outside.  When I went to get them at the end of the day nearly all of them had fatally suffered.  Lesson learned...don\'t shock them with Texas sunlight...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("244", "218", "Janel", "noreply1261@yourdomain.com", "", "", "2014-04-21 07:06:26", "2014-04-21 07:06:26", "<strong>No instructions</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("245", "220", "Bread Woman \"Dottie\"", "noreply3207@yourdomain.com", "", "", "2014-04-21 06:47:24", "2014-04-21 06:47:24", "<strong>Garden seeds</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("246", "222", "Best To You", "noreply4645@yourdomain.com", "", "", "2014-04-21 06:34:32", "2014-04-21 06:34:32", "<strong>Low germination</strong> 0", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("247", "222", "RitaK.", "noreply7168@yourdomain.com", "", "", "2014-04-21 06:40:05", "2014-04-21 06:40:05", "<strong>Planted in tabletop greenhouse.  They are coming along just fine, looking good.</strong> 0", "0", "1", "", "", "0", "0");

/* INSERT TABLE DATA: wp_duplicator_packages */
INSERT INTO `wp_duplicator_packages` VALUES("1", "20140422_gardening", "53566b2f8d2299727140422131423", "20", "2014-04-22 13:14:23", "admin", "O:11:\"DUP_Package\":15:{s:2:\"ID\";i:1;s:4:\"Name\";s:18:\"20140422_gardening\";s:4:\"Hash\";s:29:\"53566b2f8d2299727140422131423\";s:8:\"NameHash\";s:48:\"20140422_gardening_53566b2f8d2299727140422131423\";s:7:\"Version\";s:5:\"0.5.2\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:68:\"/home1/anton241/public_html/blogsforsales.com/green/wp-snapshots/tmp\";s:8:\"StoreURL\";s:44:\"http://blogsforsales.com/green/wp-snapshots/\";s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:7:\"Archive\";O:11:\"DUP_Archive\":15:{s:10:\"FilterDirs\";s:0:\"\";s:10:\"FilterExts\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"File\";s:60:\"20140422_gardening_53566b2f8d2299727140422131423_archive.zip\";s:6:\"Format\";s:3:\"ZIP\";s:7:\"PackDir\";s:51:\"/home1/anton241/public_html/blogsforsales.com/green\";s:8:\"DirCount\";i:0;s:9:\"FileCount\";i:0;s:9:\"LinkCount\";i:0;s:4:\"Size\";i:0;s:11:\"BigFileList\";a:0:{}s:15:\"InvalidFileList\";a:0:{}s:10:\"\0*\0Package\";r:1;s:28:\"\0DUP_Archive\0filterDirsArray\";a:0:{}s:28:\"\0DUP_Archive\0filterExtsArray\";a:0:{}}s:9:\"Installer\";O:13:\"DUP_Installer\":11:{s:4:\"File\";s:62:\"20140422_gardening_53566b2f8d2299727140422131423_installer.php\";s:4:\"Size\";i:0;s:10:\"OptsDBHost\";s:0:\"\";s:10:\"OptsDBName\";s:0:\"\";s:10:\"OptsDBUser\";s:0:\"\";s:12:\"OptsSSLAdmin\";i:0;s:12:\"OptsSSLLogin\";i:0;s:11:\"OptsCacheWP\";i:0;s:13:\"OptsCachePath\";i:0;s:10:\"OptsURLNew\";s:0:\"\";s:10:\"\0*\0Package\";r:1;}s:8:\"Database\";O:12:\"DUP_Database\":9:{s:4:\"Type\";s:5:\"MySQL\";s:4:\"Size\";N;s:4:\"File\";s:61:\"20140422_gardening_53566b2f8d2299727140422131423_database.sql\";s:4:\"Path\";N;s:12:\"FilterTables\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"Name\";N;s:10:\"\0*\0Package\";r:1;s:25:\"\0DUP_Database\0dbStorePath\";N;}}");

/* INSERT TABLE DATA: wp_options */
INSERT INTO `wp_options` VALUES("1", "siteurl", "http://blogsforsales.com/green", "yes");
INSERT INTO `wp_options` VALUES("2", "blogname", "Gardening", "yes");
INSERT INTO `wp_options` VALUES("3", "blogdescription", "Gardening Supplies", "yes");
INSERT INTO `wp_options` VALUES("4", "users_can_register", "0", "yes");
INSERT INTO `wp_options` VALUES("5", "admin_email", "mail@email.com", "yes");
INSERT INTO `wp_options` VALUES("6", "start_of_week", "1", "yes");
INSERT INTO `wp_options` VALUES("7", "use_balanceTags", "0", "yes");
INSERT INTO `wp_options` VALUES("8", "use_smilies", "1", "yes");
INSERT INTO `wp_options` VALUES("9", "require_name_email", "", "yes");
INSERT INTO `wp_options` VALUES("10", "comments_notify", "", "yes");
INSERT INTO `wp_options` VALUES("11", "posts_per_rss", "10", "yes");
INSERT INTO `wp_options` VALUES("12", "rss_use_excerpt", "0", "yes");
INSERT INTO `wp_options` VALUES("13", "mailserver_url", "mail.example.com", "yes");
INSERT INTO `wp_options` VALUES("14", "mailserver_login", "login@example.com", "yes");
INSERT INTO `wp_options` VALUES("15", "mailserver_pass", "password", "yes");
INSERT INTO `wp_options` VALUES("16", "mailserver_port", "110", "yes");
INSERT INTO `wp_options` VALUES("17", "default_category", "1", "yes");
INSERT INTO `wp_options` VALUES("18", "default_comment_status", "closed", "yes");
INSERT INTO `wp_options` VALUES("19", "default_ping_status", "open", "yes");
INSERT INTO `wp_options` VALUES("20", "default_pingback_flag", "1", "yes");
INSERT INTO `wp_options` VALUES("21", "posts_per_page", "9", "yes");
INSERT INTO `wp_options` VALUES("22", "date_format", "F j, Y", "yes");
INSERT INTO `wp_options` VALUES("23", "time_format", "g:i a", "yes");
INSERT INTO `wp_options` VALUES("24", "links_updated_date_format", "F j, Y g:i a", "yes");
INSERT INTO `wp_options` VALUES("28", "comment_moderation", "", "yes");
INSERT INTO `wp_options` VALUES("29", "moderation_notify", "1", "yes");
INSERT INTO `wp_options` VALUES("30", "permalink_structure", "/%postname%/", "yes");
INSERT INTO `wp_options` VALUES("31", "gzipcompression", "0", "yes");
INSERT INTO `wp_options` VALUES("32", "hack_file", "0", "yes");
INSERT INTO `wp_options` VALUES("33", "blog_charset", "UTF-8", "yes");
INSERT INTO `wp_options` VALUES("34", "moderation_keys", "", "no");
INSERT INTO `wp_options` VALUES("35", "active_plugins", "a:4:{i:0;s:25:\"duplicator/duplicator.php\";i:1;s:19:\"jetpack/jetpack.php\";i:2;s:31:\"seo-wordpress/seo-wordpress.php\";i:3;s:27:\"wp-super-cache/wp-cache.php\";}", "yes");
INSERT INTO `wp_options` VALUES("36", "home", "http://blogsforsales.com/green", "yes");
INSERT INTO `wp_options` VALUES("37", "category_base", "", "yes");
INSERT INTO `wp_options` VALUES("38", "ping_sites", "http://rpc.pingomatic.com/", "yes");
INSERT INTO `wp_options` VALUES("39", "advanced_edit", "0", "yes");
INSERT INTO `wp_options` VALUES("40", "comment_max_links", "2", "yes");
INSERT INTO `wp_options` VALUES("41", "gmt_offset", "0", "yes");
INSERT INTO `wp_options` VALUES("42", "default_email_category", "1", "yes");
INSERT INTO `wp_options` VALUES("43", "recently_edited", "a:2:{i:0;s:98:\"/home1/anton241/public_html/blogsforsales.com/green/wp-content/themes/covertstorebuilder/style.css\";i:1;s:0:\"\";}", "no");
INSERT INTO `wp_options` VALUES("44", "template", "covertstorebuilder", "yes");
INSERT INTO `wp_options` VALUES("45", "stylesheet", "covertstorebuilder", "yes");
INSERT INTO `wp_options` VALUES("46", "comment_whitelist", "1", "yes");
INSERT INTO `wp_options` VALUES("47", "blacklist_keys", "", "no");
INSERT INTO `wp_options` VALUES("48", "comment_registration", "1", "yes");
INSERT INTO `wp_options` VALUES("49", "html_type", "text/html", "yes");
INSERT INTO `wp_options` VALUES("50", "use_trackback", "0", "yes");
INSERT INTO `wp_options` VALUES("51", "default_role", "subscriber", "yes");
INSERT INTO `wp_options` VALUES("52", "db_version", "27916", "yes");
INSERT INTO `wp_options` VALUES("53", "uploads_use_yearmonth_folders", "1", "yes");
INSERT INTO `wp_options` VALUES("54", "upload_path", "", "yes");
INSERT INTO `wp_options` VALUES("55", "blog_public", "1", "yes");
INSERT INTO `wp_options` VALUES("56", "default_link_category", "2", "yes");
INSERT INTO `wp_options` VALUES("57", "show_on_front", "posts", "yes");
INSERT INTO `wp_options` VALUES("58", "tag_base", "", "yes");
INSERT INTO `wp_options` VALUES("59", "show_avatars", "1", "yes");
INSERT INTO `wp_options` VALUES("60", "avatar_rating", "G", "yes");
INSERT INTO `wp_options` VALUES("61", "upload_url_path", "", "yes");
INSERT INTO `wp_options` VALUES("62", "thumbnail_size_w", "150", "yes");
INSERT INTO `wp_options` VALUES("63", "thumbnail_size_h", "150", "yes");
INSERT INTO `wp_options` VALUES("64", "thumbnail_crop", "1", "yes");
INSERT INTO `wp_options` VALUES("65", "medium_size_w", "300", "yes");
INSERT INTO `wp_options` VALUES("66", "medium_size_h", "300", "yes");
INSERT INTO `wp_options` VALUES("67", "avatar_default", "mystery", "yes");
INSERT INTO `wp_options` VALUES("68", "large_size_w", "1024", "yes");
INSERT INTO `wp_options` VALUES("69", "large_size_h", "1024", "yes");
INSERT INTO `wp_options` VALUES("70", "image_default_link_type", "file", "yes");
INSERT INTO `wp_options` VALUES("71", "image_default_size", "", "yes");
INSERT INTO `wp_options` VALUES("72", "image_default_align", "", "yes");
INSERT INTO `wp_options` VALUES("73", "close_comments_for_old_posts", "", "yes");
INSERT INTO `wp_options` VALUES("74", "close_comments_days_old", "14", "yes");
INSERT INTO `wp_options` VALUES("75", "thread_comments", "1", "yes");
INSERT INTO `wp_options` VALUES("76", "thread_comments_depth", "5", "yes");
INSERT INTO `wp_options` VALUES("77", "page_comments", "", "yes");
INSERT INTO `wp_options` VALUES("78", "comments_per_page", "50", "yes");
INSERT INTO `wp_options` VALUES("79", "default_comments_page", "newest", "yes");
INSERT INTO `wp_options` VALUES("80", "comment_order", "asc", "yes");
INSERT INTO `wp_options` VALUES("81", "sticky_posts", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("82", "widget_categories", "a:2:{i:2;a:4:{s:5:\"title\";s:0:\"\";s:5:\"count\";i:0;s:12:\"hierarchical\";i:0;s:8:\"dropdown\";i:0;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("83", "widget_text", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("84", "widget_rss", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("85", "uninstall_plugins", "a:1:{s:27:\"wp-super-cache/wp-cache.php\";s:23:\"wpsupercache_deactivate\";}", "no");
INSERT INTO `wp_options` VALUES("86", "timezone_string", "", "yes");
INSERT INTO `wp_options` VALUES("87", "page_for_posts", "0", "yes");
INSERT INTO `wp_options` VALUES("88", "page_on_front", "0", "yes");
INSERT INTO `wp_options` VALUES("89", "default_post_format", "0", "yes");
INSERT INTO `wp_options` VALUES("90", "link_manager_enabled", "0", "yes");
INSERT INTO `wp_options` VALUES("91", "initial_db_version", "26691", "yes");
INSERT INTO `wp_options` VALUES("92", "wp_user_roles", "a:5:{s:13:\"administrator\";a:2:{s:4:\"name\";s:13:\"Administrator\";s:12:\"capabilities\";a:62:{s:13:\"switch_themes\";b:1;s:11:\"edit_themes\";b:1;s:16:\"activate_plugins\";b:1;s:12:\"edit_plugins\";b:1;s:10:\"edit_users\";b:1;s:10:\"edit_files\";b:1;s:14:\"manage_options\";b:1;s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:6:\"import\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:8:\"level_10\";b:1;s:7:\"level_9\";b:1;s:7:\"level_8\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:12:\"delete_users\";b:1;s:12:\"create_users\";b:1;s:17:\"unfiltered_upload\";b:1;s:14:\"edit_dashboard\";b:1;s:14:\"update_plugins\";b:1;s:14:\"delete_plugins\";b:1;s:15:\"install_plugins\";b:1;s:13:\"update_themes\";b:1;s:14:\"install_themes\";b:1;s:11:\"update_core\";b:1;s:10:\"list_users\";b:1;s:12:\"remove_users\";b:1;s:9:\"add_users\";b:1;s:13:\"promote_users\";b:1;s:18:\"edit_theme_options\";b:1;s:13:\"delete_themes\";b:1;s:6:\"export\";b:1;}}s:6:\"editor\";a:2:{s:4:\"name\";s:6:\"Editor\";s:12:\"capabilities\";a:34:{s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;}}s:6:\"author\";a:2:{s:4:\"name\";s:6:\"Author\";s:12:\"capabilities\";a:10:{s:12:\"upload_files\";b:1;s:10:\"edit_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;s:22:\"delete_published_posts\";b:1;}}s:11:\"contributor\";a:2:{s:4:\"name\";s:11:\"Contributor\";s:12:\"capabilities\";a:5:{s:10:\"edit_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;}}s:10:\"subscriber\";a:2:{s:4:\"name\";s:10:\"Subscriber\";s:12:\"capabilities\";a:2:{s:4:\"read\";b:1;s:7:\"level_0\";b:1;}}}", "yes");
INSERT INTO `wp_options` VALUES("93", "widget_search", "a:2:{i:2;a:1:{s:5:\"title\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("94", "widget_recent-posts", "a:2:{i:2;a:2:{s:5:\"title\";s:0:\"\";s:6:\"number\";i:5;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("95", "widget_recent-comments", "a:2:{i:2;a:2:{s:5:\"title\";s:0:\"\";s:6:\"number\";i:5;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("96", "widget_archives", "a:2:{i:2;a:3:{s:5:\"title\";s:0:\"\";s:5:\"count\";i:0;s:8:\"dropdown\";i:0;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("97", "widget_meta", "a:2:{i:2;a:1:{s:5:\"title\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("98", "sidebars_widgets", "a:13:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:9:\"sidebar-2\";a:0:{}s:9:\"sidebar-3\";a:0:{}s:13:\"array_version\";i:3;s:23:\"sidebar-featured-widget\";a:0:{}s:19:\"sidebar-post-widget\";a:0:{}s:19:\"sidebar-page-widget\";a:0:{}s:22:\"sidebar-catpage-widget\";a:0:{}s:23:\"sidebar-wishlist-widget\";a:0:{}s:16:\"sidebar-footer-1\";a:0:{}s:16:\"sidebar-footer-2\";a:0:{}s:16:\"sidebar-footer-3\";a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("99", "cron", "a:8:{i:1398173007;a:1:{s:11:\"wp_cache_gc\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:0:{}}}}i:1398174129;a:1:{s:20:\"jetpack_clean_nonces\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"hourly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:3600;}}}i:1398174775;a:1:{s:31:\"imwb_zonpress_amazon_cron_event\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:11:\"every4hours\";s:4:\"args\";a:0:{}s:8:\"interval\";i:14400;}}}i:1398174882;a:1:{s:19:\"wp_cache_gc_watcher\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"hourly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:3600;}}}i:1398193380;a:1:{s:20:\"wp_maybe_auto_update\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1398199301;a:3:{s:16:\"wp_version_check\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:17:\"wp_update_plugins\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:16:\"wp_update_themes\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1398199311;a:1:{s:19:\"wp_scheduled_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}s:7:\"version\";i:2;}", "yes");
INSERT INTO `wp_options` VALUES("124", "recently_activated", "a:1:{s:54:\"mojo-marketplace-wp-plugin-master/mojo-marketplace.php\";i:1397585028;}", "yes");
INSERT INTO `wp_options` VALUES("127", "jetpack_activated", "1", "yes");
INSERT INTO `wp_options` VALUES("128", "jetpack_options", "a:2:{s:7:\"version\";s:14:\"2.9:1394138529\";s:11:\"old_version\";s:14:\"2.9:1394138529\";}", "yes");
INSERT INTO `wp_options` VALUES("137", "mm_master_aff", "hostgator", "yes");
INSERT INTO `wp_options` VALUES("138", "mm_install_date", "Mar 06, 2014", "yes");
INSERT INTO `wp_options` VALUES("139", "ossdl_off_cdn_url", "http://blogsforsales.com/green", "yes");
INSERT INTO `wp_options` VALUES("140", "ossdl_off_include_dirs", "wp-content,wp-includes", "yes");
INSERT INTO `wp_options` VALUES("141", "ossdl_off_exclude", ".php", "yes");
INSERT INTO `wp_options` VALUES("142", "ossdl_cname", "", "yes");
INSERT INTO `wp_options` VALUES("144", "wpsupercache_start", "1394138557", "yes");
INSERT INTO `wp_options` VALUES("145", "wpsupercache_count", "0", "yes");
INSERT INTO `wp_options` VALUES("146", "_transient_random_seed", "73c3552bb7cde5e2a5a2cc81d09dfec9", "yes");
INSERT INTO `wp_options` VALUES("160", "_site_transient_timeout_browser_913d5be043e54ae9a96874873accd677", "1398189803", "yes");
INSERT INTO `wp_options` VALUES("161", "_site_transient_browser_913d5be043e54ae9a96874873accd677", "a:9:{s:8:\"platform\";s:5:\"Linux\";s:4:\"name\";s:6:\"Chrome\";s:7:\"version\";s:12:\"21.0.1180.81\";s:10:\"update_url\";s:28:\"http://www.google.com/chrome\";s:7:\"img_src\";s:49:\"http://s.wordpress.org/images/browsers/chrome.png\";s:11:\"img_src_ssl\";s:48:\"https://wordpress.org/images/browsers/chrome.png\";s:15:\"current_version\";s:2:\"18\";s:7:\"upgrade\";b:0;s:8:\"insecure\";b:0;}", "yes");
INSERT INTO `wp_options` VALUES("180", "db_upgraded", "", "yes");
INSERT INTO `wp_options` VALUES("208", "_site_transient_update_core", "O:8:\"stdClass\":4:{s:7:\"updates\";a:1:{i:0;O:8:\"stdClass\":10:{s:8:\"response\";s:6:\"latest\";s:8:\"download\";s:57:\"https://downloads.wordpress.org/release/wordpress-3.9.zip\";s:6:\"locale\";s:5:\"en_US\";s:8:\"packages\";O:8:\"stdClass\":5:{s:4:\"full\";s:57:\"https://downloads.wordpress.org/release/wordpress-3.9.zip\";s:10:\"no_content\";b:0;s:11:\"new_bundled\";b:0;s:7:\"partial\";b:0;s:8:\"rollback\";b:0;}s:7:\"current\";s:3:\"3.9\";s:7:\"version\";s:3:\"3.9\";s:11:\"php_version\";s:5:\"5.2.4\";s:13:\"mysql_version\";s:3:\"5.0\";s:11:\"new_bundled\";s:3:\"3.8\";s:15:\"partial_version\";s:0:\"\";}}s:12:\"last_checked\";i:1398171825;s:15:\"version_checked\";s:3:\"3.9\";s:12:\"translations\";a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("209", "can_compress_scripts", "1", "yes");
INSERT INTO `wp_options` VALUES("215", "wpsupercache_gc_time", "1398172407", "yes");
INSERT INTO `wp_options` VALUES("217", "_site_transient_timeout_browser_a9c2a4a09c221fe1242bcc57ffac16b0", "1398664207", "yes");
INSERT INTO `wp_options` VALUES("218", "_site_transient_browser_a9c2a4a09c221fe1242bcc57ffac16b0", "a:9:{s:8:\"platform\";s:7:\"Windows\";s:4:\"name\";s:6:\"Chrome\";s:7:\"version\";s:13:\"34.0.1847.116\";s:10:\"update_url\";s:28:\"http://www.google.com/chrome\";s:7:\"img_src\";s:49:\"http://s.wordpress.org/images/browsers/chrome.png\";s:11:\"img_src_ssl\";s:48:\"https://wordpress.org/images/browsers/chrome.png\";s:15:\"current_version\";s:2:\"18\";s:7:\"upgrade\";b:0;s:8:\"insecure\";b:0;}", "yes");
INSERT INTO `wp_options` VALUES("236", "_transient_twentyfourteen_category_count", "1", "yes");
INSERT INTO `wp_options` VALUES("237", "_site_transient_timeout_wporg_theme_feature_list", "1398070240", "yes");
INSERT INTO `wp_options` VALUES("238", "_site_transient_wporg_theme_feature_list", "a:4:{s:6:\"Colors\";a:15:{i:0;s:5:\"black\";i:1;s:4:\"blue\";i:2;s:5:\"brown\";i:3;s:4:\"gray\";i:4;s:5:\"green\";i:5;s:6:\"orange\";i:6;s:4:\"pink\";i:7;s:6:\"purple\";i:8;s:3:\"red\";i:9;s:6:\"silver\";i:10;s:3:\"tan\";i:11;s:5:\"white\";i:12;s:6:\"yellow\";i:13;s:4:\"dark\";i:14;s:5:\"light\";}s:6:\"Layout\";a:9:{i:0;s:12:\"fixed-layout\";i:1;s:12:\"fluid-layout\";i:2;s:17:\"responsive-layout\";i:3;s:10:\"one-column\";i:4;s:11:\"two-columns\";i:5;s:13:\"three-columns\";i:6;s:12:\"four-columns\";i:7;s:12:\"left-sidebar\";i:8;s:13:\"right-sidebar\";}s:8:\"Features\";a:20:{i:0;s:19:\"accessibility-ready\";i:1;s:8:\"blavatar\";i:2;s:10:\"buddypress\";i:3;s:17:\"custom-background\";i:4;s:13:\"custom-colors\";i:5;s:13:\"custom-header\";i:6;s:11:\"custom-menu\";i:7;s:12:\"editor-style\";i:8;s:21:\"featured-image-header\";i:9;s:15:\"featured-images\";i:10;s:15:\"flexible-header\";i:11;s:20:\"front-page-post-form\";i:12;s:19:\"full-width-template\";i:13;s:12:\"microformats\";i:14;s:12:\"post-formats\";i:15;s:20:\"rtl-language-support\";i:16;s:11:\"sticky-post\";i:17;s:13:\"theme-options\";i:18;s:17:\"threaded-comments\";i:19;s:17:\"translation-ready\";}s:7:\"Subject\";a:3:{i:0;s:7:\"holiday\";i:1;s:13:\"photoblogging\";i:2;s:8:\"seasonal\";}}", "yes");
INSERT INTO `wp_options` VALUES("239", "_site_transient_update_themes", "O:8:\"stdClass\":4:{s:12:\"last_checked\";i:1398171863;s:7:\"checked\";a:4:{s:18:\"covertstorebuilder\";s:3:\"1.7\";s:14:\"twentyfourteen\";s:3:\"1.0\";s:14:\"twentythirteen\";s:3:\"1.1\";s:12:\"twentytwelve\";s:3:\"1.3\";}s:8:\"response\";a:0:{}s:12:\"translations\";a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("240", "theme_mods_twentyfourteen", "a:1:{s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1398059574;s:4:\"data\";a:4:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:9:\"sidebar-2\";a:0:{}s:9:\"sidebar-3\";a:0:{}}}}", "yes");
INSERT INTO `wp_options` VALUES("241", "current_theme", "Covert Store Builder Theme", "yes");
INSERT INTO `wp_options` VALUES("242", "theme_mods_covertstorebuilder", "a:10:{i:0;b:0;s:16:\"background_color\";s:6:\"8bbf8b\";s:16:\"header_textcolor\";s:6:\"eded00\";s:16:\"background_image\";s:0:\"\";s:17:\"background_repeat\";s:6:\"repeat\";s:21:\"background_position_x\";s:4:\"left\";s:21:\"background_attachment\";s:5:\"fixed\";s:12:\"header_image\";s:73:\"http://blogsforsales.com/green/wp-content/uploads/2014/04/cropped-007.jpg\";s:17:\"header_image_data\";O:8:\"stdClass\":5:{s:13:\"attachment_id\";i:224;s:3:\"url\";s:73:\"http://blogsforsales.com/green/wp-content/uploads/2014/04/cropped-007.jpg\";s:13:\"thumbnail_url\";s:73:\"http://blogsforsales.com/green/wp-content/uploads/2014/04/cropped-007.jpg\";s:6:\"height\";i:130;s:5:\"width\";i:970;}s:20:\"zp_header_text_align\";s:6:\"center\";}", "yes");
INSERT INTO `wp_options` VALUES("243", "theme_switched", "", "yes");
INSERT INTO `wp_options` VALUES("246", "csblic_key", "AP-09L192439X323780D", "yes");
INSERT INTO `wp_options` VALUES("247", "csblic_status", "COMPLETED", "yes");
INSERT INTO `wp_options` VALUES("248", "_transient_timeout_csblic_lastcheck", "1398102827", "no");
INSERT INTO `wp_options` VALUES("249", "_transient_csblic_lastcheck", "AP-09L192439X323780D", "no");
INSERT INTO `wp_options` VALUES("250", "imwb_zonpress_theme_options", "a:124:{s:10:\"faviconurl\";s:0:\"\";s:9:\"defOGPImg\";s:0:\"\";s:11:\"headerbgcol\";s:7:\"#a3bbc2\";s:14:\"sitemenutxtcol\";s:7:\"#e8f3f8\";s:13:\"headerscripts\";s:0:\"\";s:8:\"hidemenu\";s:1:\"N\";s:9:\"menubgcol\";s:7:\"#7c9f3e\";s:10:\"menutxtcol\";s:7:\"#e8f3f8\";s:13:\"menuseltxtcol\";s:7:\"#ffffff\";s:12:\"homepagemenu\";s:1:\"N\";s:7:\"mrsmenu\";s:1:\"Y\";s:10:\"mrsmenutxt\";s:11:\"What\\\'s New\";s:12:\"mrsmenutitle\";s:15:\"See What\\\'s New\";s:11:\"includecats\";s:5:\"1,2,3\";s:12:\"othercatmenu\";s:1:\"Y\";s:15:\"othercatmenutxt\";s:4:\"More\";s:11:\"excludecats\";s:0:\"\";s:12:\"posthidemenu\";s:1:\"N\";s:13:\"postmenubgcol\";s:7:\"#7fa7b8\";s:14:\"postmenutxtcol\";s:7:\"#432f04\";s:17:\"postmenuseltxtcol\";s:7:\"#ffffff\";s:11:\"postmrsmenu\";s:1:\"N\";s:14:\"postmrsmenutxt\";s:6:\"Newest\";s:11:\"posttrsmenu\";s:1:\"N\";s:14:\"posttrsmenutxt\";s:7:\"Popular\";s:11:\"posthpsmenu\";s:1:\"N\";s:14:\"posthpsmenutxt\";s:13:\"Highest Price\";s:11:\"postlpsmenu\";s:1:\"N\";s:14:\"postlpsmenutxt\";s:12:\"Lowest Price\";s:10:\"hidesearch\";s:1:\"N\";s:10:\"searchtext\";s:13:\"Find Stuff...\";s:10:\"hidefooter\";s:1:\"N\";s:14:\"hidesocialbtns\";s:1:\"N\";s:11:\"twitteruser\";s:0:\"\";s:12:\"facebookuser\";s:0:\"\";s:10:\"googleuser\";s:0:\"\";s:13:\"pinterestuser\";s:0:\"\";s:10:\"reddituser\";s:0:\"\";s:10:\"rssfeedurl\";s:36:\"http://blogsforsales.com/green/feed/\";s:11:\"hiderotator\";s:1:\"N\";s:11:\"fplistorder\";s:1:\"0\";s:15:\"postsperrotator\";s:2:\"10\";s:12:\"delayrotator\";s:1:\"5\";s:13:\"fpexcludecats\";s:0:\"\";s:7:\"fpbgcol\";s:7:\"#ffffff\";s:8:\"fpbdrcol\";s:7:\"#ffffff\";s:10:\"fptitlecol\";s:7:\"#20627e\";s:13:\"fptitlehvrcol\";s:7:\"#a03a18\";s:10:\"fppricecol\";s:7:\"#20627e\";s:9:\"fpdesccol\";s:7:\"#7fa7b8\";s:11:\"fphideprice\";s:1:\"N\";s:9:\"listorder\";s:1:\"0\";s:13:\"hpexcludecats\";s:0:\"\";s:10:\"linknewwin\";s:1:\"0\";s:11:\"usenofollow\";s:1:\"1\";s:12:\"sidebarbgcol\";s:7:\"#ffffff\";s:16:\"widgettitlebgcol\";s:7:\"#f7f7f7\";s:17:\"widgettitletxtcol\";s:7:\"#20627e\";s:9:\"showtitle\";s:1:\"1\";s:11:\"postcontent\";s:1:\"E\";s:9:\"postchars\";s:3:\"100\";s:12:\"postmoretext\";s:6:\"[More]\";s:12:\"shareoptions\";s:5:\"F,T,P\";s:9:\"postbgcol\";s:7:\"#f7f7f7\";s:12:\"posttitlecol\";s:7:\"#20627e\";s:15:\"posttitlehvrcol\";s:7:\"#1778a1\";s:11:\"postdesccol\";s:7:\"#a6a6a6\";s:13:\"postprdbtntxt\";s:13:\"Check It Out!\";s:16:\"postprdbtntxtcol\";s:7:\"#FFFFFF\";s:15:\"postprdbtnbgcol\";s:7:\"#628523\";s:18:\"postprdbtnbghvrcol\";s:7:\"#496812\";s:12:\"hideptthumbs\";s:1:\"N\";s:13:\"ptthumbsshown\";s:1:\"6\";s:11:\"ptprdbtntxt\";s:8:\"Buy Now!\";s:11:\"hidepttitle\";s:1:\"N\";s:11:\"hideptprice\";s:1:\"N\";s:13:\"hideptdetails\";s:1:\"N\";s:11:\"commenttype\";s:1:\"0\";s:7:\"fbappid\";s:0:\"\";s:15:\"hideptlikestats\";s:1:\"N\";s:17:\"hideptcommenttime\";s:1:\"N\";s:11:\"pagesidebar\";s:1:\"0\";s:11:\"postsidebar\";s:1:\"2\";s:10:\"catsidebar\";s:1:\"2\";s:12:\"hidecatprice\";s:1:\"N\";s:11:\"hidecatdesc\";s:1:\"N\";s:11:\"postspercat\";s:2:\"15\";s:11:\"hidepgtitle\";s:1:\"N\";s:14:\"hidepgcomments\";s:1:\"N\";s:11:\"footerbgcol\";s:7:\"#a3bbc2\";s:12:\"footertxtcol\";s:7:\"#f5f4bc\";s:16:\"footertxtlinkcol\";s:7:\"#DDDDDD\";s:19:\"footertxtlinkhvrcol\";s:7:\"#DDDDDD\";s:15:\"addwishlisttext\";s:18:\"+ Add To Wish List\";s:14:\"onwishlisttext\";s:17:\"On Your Wish List\";s:15:\"delwishlisttext\";s:21:\"Remove From Wish List\";s:12:\"wishlisttext\";s:9:\"Wish List\";s:15:\"wishlistsidebar\";s:1:\"0\";s:14:\"wlshareoptions\";s:5:\"F,T,P\";s:11:\"wlsharetext\";s:22:\"Check out my Wish List\";s:18:\"newmemberadminmail\";s:1:\"1\";s:13:\"newmembermail\";s:1:\"1\";s:17:\"newmembermailsubj\";s:40:\"[{SITE_NAME}] Your username and password\";s:17:\"newmembermailbody\";s:99:\"Thank you for registering with: {SITE_NAME}\r\nUsername: {USERNAME}\r\nPassword: {PASSWORD}\r\n{SITE_URL}\";s:14:\"custdefaultimg\";s:0:\"\";s:10:\"titlelinks\";s:1:\"1\";s:10:\"imagelinks\";s:1:\"1\";s:11:\"buttonlinks\";s:1:\"1\";s:17:\"newmemberaroption\";s:1:\"N\";s:16:\"aweber_auth_code\";s:0:\"\";s:19:\"aweber_consumer_key\";s:0:\"\";s:22:\"aweber_consumer_secret\";s:0:\"\";s:17:\"aweber_access_key\";s:0:\"\";s:20:\"aweber_access_secret\";s:0:\"\";s:11:\"aweber_list\";s:0:\"\";s:19:\"getresponse_api_key\";s:0:\"\";s:20:\"getresponse_campaign\";s:0:\"\";s:10:\"ar_formurl\";s:0:\"\";s:7:\"ar_form\";s:0:\"\";s:15:\"ar_formfldemail\";s:0:\"\";s:14:\"ar_formfldname\";s:0:\"\";s:16:\"newmembercaptcha\";s:1:\"1\";s:15:\"homepagescripts\";s:0:\"\";s:11:\"licensecode\";s:20:\"AP-09L192439X323780D\";}", "yes");
INSERT INTO `wp_options` VALUES("254", "category_children", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("255", "imwb_zonpress_theme_products", "a:18:{s:10:\"createtags\";s:1:\"N\";s:7:\"badtags\";s:86:\"all,and,here,this,that,then,make,what,which,where,when,does,with,while,your,other,will\";s:11:\"addcomments\";s:1:\"Y\";s:12:\"randcomments\";s:1:\"Y\";s:8:\"amzaffid\";s:10:\"freetos-20\";s:9:\"amzpubkey\";s:20:\"AKIAJULJCU4YH7LDDYQA\";s:9:\"amzprikey\";s:40:\"IM/JT0I1yHRJSeB0BJE4hsz25snswQXaD6bLByZZ\";s:9:\"amzregion\";s:3:\"com\";s:14:\"amzincfeatures\";s:1:\"Y\";s:13:\"amzpricetoson\";s:1:\"Y\";s:14:\"amzpriceupdate\";s:1:\"Y\";s:8:\"cjdevkey\";s:0:\"\";s:8:\"cjwebpid\";s:0:\"\";s:15:\"cjadvertiserids\";s:1:\"J\";s:6:\"cjcids\";s:0:\"\";s:6:\"ebayid\";s:0:\"\";s:9:\"ebayappid\";s:0:\"\";s:10:\"ebaysiteid\";s:1:\"0\";}", "yes");
INSERT INTO `wp_options` VALUES("267", "widget_popularproducts", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("268", "widget_newestproducts", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("269", "widget_pages", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("270", "widget_calendar", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("271", "widget_tag_cloud", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("272", "widget_nav_menu", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("278", "theme-update-covertstorebuilder", "O:8:\"stdClass\":3:{s:9:\"lastCheck\";i:1398171862;s:14:\"checkedVersion\";s:3:\"1.7\";s:6:\"update\";N;}", "yes");
INSERT INTO `wp_options` VALUES("280", "zeo_common_home_title", "Gardening | Gardening Supplies", "yes");
INSERT INTO `wp_options` VALUES("281", "zeo_common_frontpage_title", "| Gardening", "yes");
INSERT INTO `wp_options` VALUES("282", "zeo_common_page_title", "| Gardening", "yes");
INSERT INTO `wp_options` VALUES("283", "zeo_common_post_title", "| Gardening", "yes");
INSERT INTO `wp_options` VALUES("284", "zeo_common_category_title", "| Gardening", "yes");
INSERT INTO `wp_options` VALUES("285", "zeo_common_archive_title", "| Gardening", "yes");
INSERT INTO `wp_options` VALUES("286", "zeo_common_tag_title", "| Gardening", "yes");
INSERT INTO `wp_options` VALUES("287", "zeo_common_search_title", "| Gardening", "yes");
INSERT INTO `wp_options` VALUES("288", "zeo_common_error_title", "| Gardening", "yes");
INSERT INTO `wp_options` VALUES("289", "zeo_analytics_id", "", "yes");
INSERT INTO `wp_options` VALUES("290", "zeo_home_description", "", "yes");
INSERT INTO `wp_options` VALUES("291", "zeo_home_keywords", "", "yes");
INSERT INTO `wp_options` VALUES("292", "zeo_blog_description", "", "yes");
INSERT INTO `wp_options` VALUES("293", "zeo_blog_keywords", "", "yes");
INSERT INTO `wp_options` VALUES("294", "zeo_canonical_url", "yes", "yes");
INSERT INTO `wp_options` VALUES("295", "zeo_nofollow", "no", "yes");
INSERT INTO `wp_options` VALUES("296", "zeo_activate_title", "yes", "yes");
INSERT INTO `wp_options` VALUES("297", "zeo_category_nofollow", "no", "yes");
INSERT INTO `wp_options` VALUES("298", "zeo_tag_nofollow", "no", "yes");
INSERT INTO `wp_options` VALUES("299", "zeo_date_nofollow", "no", "yes");
INSERT INTO `wp_options` VALUES("300", "zeo_post_types", "", "yes");
INSERT INTO `wp_options` VALUES("301", "rewrite_rules", "a:67:{s:47:\"category/(.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:42:\"category/(.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:35:\"category/(.+?)/page/?([0-9]{1,})/?$\";s:53:\"index.php?category_name=$matches[1]&paged=$matches[2]\";s:17:\"category/(.+?)/?$\";s:35:\"index.php?category_name=$matches[1]\";s:44:\"tag/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:39:\"tag/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:32:\"tag/([^/]+)/page/?([0-9]{1,})/?$\";s:43:\"index.php?tag=$matches[1]&paged=$matches[2]\";s:14:\"tag/([^/]+)/?$\";s:25:\"index.php?tag=$matches[1]\";s:45:\"type/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:40:\"type/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:33:\"type/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?post_format=$matches[1]&paged=$matches[2]\";s:15:\"type/([^/]+)/?$\";s:33:\"index.php?post_format=$matches[1]\";s:48:\".*wp-(atom|rdf|rss|rss2|feed|commentsrss2)\\.php$\";s:18:\"index.php?feed=old\";s:20:\".*wp-app\\.php(/.*)?$\";s:19:\"index.php?error=403\";s:18:\".*wp-register.php$\";s:23:\"index.php?register=true\";s:32:\"feed/(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:27:\"(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:20:\"page/?([0-9]{1,})/?$\";s:28:\"index.php?&paged=$matches[1]\";s:41:\"comments/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:36:\"comments/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:44:\"search/(.+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:39:\"search/(.+)/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:32:\"search/(.+)/page/?([0-9]{1,})/?$\";s:41:\"index.php?s=$matches[1]&paged=$matches[2]\";s:14:\"search/(.+)/?$\";s:23:\"index.php?s=$matches[1]\";s:47:\"author/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:42:\"author/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:35:\"author/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?author_name=$matches[1]&paged=$matches[2]\";s:17:\"author/([^/]+)/?$\";s:33:\"index.php?author_name=$matches[1]\";s:69:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:64:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:57:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:81:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&paged=$matches[4]\";s:39:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/?$\";s:63:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]\";s:56:\"([0-9]{4})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:51:\"([0-9]{4})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:44:\"([0-9]{4})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:65:\"index.php?year=$matches[1]&monthnum=$matches[2]&paged=$matches[3]\";s:26:\"([0-9]{4})/([0-9]{1,2})/?$\";s:47:\"index.php?year=$matches[1]&monthnum=$matches[2]\";s:43:\"([0-9]{4})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:38:\"([0-9]{4})/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:31:\"([0-9]{4})/page/?([0-9]{1,})/?$\";s:44:\"index.php?year=$matches[1]&paged=$matches[2]\";s:13:\"([0-9]{4})/?$\";s:26:\"index.php?year=$matches[1]\";s:27:\".?.+?/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:37:\".?.+?/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:57:\".?.+?/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:20:\"(.?.+?)/trackback/?$\";s:35:\"index.php?pagename=$matches[1]&tb=1\";s:40:\"(.?.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:35:\"(.?.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:28:\"(.?.+?)/page/?([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&paged=$matches[2]\";s:35:\"(.?.+?)/comment-page-([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&cpage=$matches[2]\";s:20:\"(.?.+?)(/[0-9]+)?/?$\";s:47:\"index.php?pagename=$matches[1]&page=$matches[2]\";s:27:\"[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:37:\"[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:57:\"[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\"[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\"[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:20:\"([^/]+)/trackback/?$\";s:31:\"index.php?name=$matches[1]&tb=1\";s:40:\"([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?name=$matches[1]&feed=$matches[2]\";s:35:\"([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?name=$matches[1]&feed=$matches[2]\";s:28:\"([^/]+)/page/?([0-9]{1,})/?$\";s:44:\"index.php?name=$matches[1]&paged=$matches[2]\";s:35:\"([^/]+)/comment-page-([0-9]{1,})/?$\";s:44:\"index.php?name=$matches[1]&cpage=$matches[2]\";s:20:\"([^/]+)(/[0-9]+)?/?$\";s:43:\"index.php?name=$matches[1]&page=$matches[2]\";s:16:\"[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:26:\"[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:46:\"[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:41:\"[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:41:\"[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";}", "yes");
INSERT INTO `wp_options` VALUES("312", "_site_transient_timeout_browser_6d44eab61dcf5b1f0e6fa8f6595ee1bc", "1398671690", "yes");
INSERT INTO `wp_options` VALUES("313", "_site_transient_browser_6d44eab61dcf5b1f0e6fa8f6595ee1bc", "a:9:{s:8:\"platform\";s:7:\"Windows\";s:4:\"name\";N;s:7:\"version\";N;s:10:\"update_url\";s:0:\"\";s:7:\"img_src\";s:0:\"\";s:11:\"img_src_ssl\";s:0:\"\";s:15:\"current_version\";s:0:\"\";s:7:\"upgrade\";b:0;s:8:\"insecure\";b:0;}", "yes");
INSERT INTO `wp_options` VALUES("322", "_site_transient_timeout_theme_roots", "1398173624", "yes");
INSERT INTO `wp_options` VALUES("323", "_site_transient_theme_roots", "a:4:{s:18:\"covertstorebuilder\";s:7:\"/themes\";s:14:\"twentyfourteen\";s:7:\"/themes\";s:14:\"twentythirteen\";s:7:\"/themes\";s:12:\"twentytwelve\";s:7:\"/themes\";}", "yes");
INSERT INTO `wp_options` VALUES("324", "_transient_timeout_feed_ac0b00fe65abe10e0c5b588f3ed8c7ca", "1398215038", "no");
INSERT INTO `wp_options` VALUES("325", "_transient_feed_ac0b00fe65abe10e0c5b588f3ed8c7ca", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:51:\"\n	\n	\n	\n	\n	\n	\n		\n		\n	\n	\n		\n		\n		\n		\n		\n		\n		\n		\n		\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"WordPress News\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"http://wordpress.org/news\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"WordPress News\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:13:\"lastBuildDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 17 Apr 2014 01:07:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/?v=4.0-alpha\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:10:{i:0;a:6:{s:4:\"data\";s:42:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"WordPress 3.9 “Smith”\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"http://wordpress.org/news/2014/04/smith/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"http://wordpress.org/news/2014/04/smith/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 16 Apr 2014 18:33:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3154\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:411:\"Version 3.9 of WordPress, named &#8220;Smith&#8221; in honor of jazz organist Jimmy Smith, is available for download or update in your WordPress dashboard. This release features a number of refinements that we hope you&#8217;ll love. A smoother media editing experience Improved visual editing The updated visual editor has improved speed, accessibility, and mobile support. You can paste into the [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:23279:\"<p>Version 3.9 of WordPress, named &#8220;Smith&#8221; in honor of jazz organist <a href=\"http://en.wikipedia.org/wiki/Jimmy_Smith_(musician)\">Jimmy Smith</a>, is available <a href=\"http://wordpress.org/download/\">for download</a> or update in your WordPress dashboard. This release features a number of refinements that we hope you&#8217;ll love.</p>\n<embed src=\"//v0.wordpress.com/player.swf?v=1.03\" type=\"application/x-shockwave-flash\" width=\"640\" height=\"360\" wmode=\"direct\" seamlesstabbing=\"true\" allowfullscreen=\"true\" allowscriptaccess=\"always\" overstretch=\"true\" flashvars=\"guid=sAiXhCfV&amp;isDynamicSeeking=true\" title=\"\"></embed>\n<h2 class=\"about-headline-callout\" style=\"text-align: center\">A smoother media editing experience</h2>\n<div>\n<p><img class=\"alignright wp-image-3168\" src=\"//wordpress.org/news/files/2014/04/editor1-300x233.jpg\" alt=\"editor\" width=\"228\" height=\"177\" /></p>\n<h3>Improved visual editing</h3>\n<p>The updated visual editor has improved speed, accessibility, and mobile support. You can paste into the visual editor from your word processor without wasting time to clean up messy styling. (Yeah, we’re talking about you, Microsoft Word.)</p>\n</div>\n<div style=\"clear: both\"></div>\n<div>\n<p><img class=\"alignright wp-image-3170\" src=\"//wordpress.org/news/files/2014/04/image1-300x233.jpg\" alt=\"image\" width=\"228\" height=\"178\" /></p>\n<h3>Edit images easily</h3>\n<p>With quicker access to crop and rotation tools, it’s now much easier to edit your images while editing posts. You can also scale images directly in the editor to find just the right fit.</p>\n</div>\n<div style=\"clear: both\"></div>\n<div>\n<p><img class=\"alignright wp-image-3187\" src=\"//wordpress.org/news/files/2014/04/dragdrop1-300x233.jpg\" alt=\"dragdrop\" width=\"228\" height=\"178\" /></p>\n<h3>Drag and drop your images</h3>\n<p>Uploading your images is easier than ever. Just grab them from your desktop and drop them in the editor.</p>\n</div>\n<div style=\"clear: both\"></div>\n<hr />\n<h2 style=\"text-align: center\">Gallery previews</h2>\n<p><img class=\"aligncenter size-full wp-image-3169\" src=\"//wordpress.org/news/files/2014/04/gallery1.jpg\" alt=\"gallery\" width=\"980\" height=\"550\" /></p>\n<p>Galleries display a beautiful grid of images right in the editor, just like they do in your published post.</p>\n<hr />\n<h2 style=\"text-align: center\">Do more with audio and video</h2>\n\n<a href=\'http://wordpress.org/news/files/2014/04/AintMisbehavin.mp3\'>Ain\'t Misbehavin\'</a>\n<a href=\'http://wordpress.org/news/files/2014/04/DavenportBlues.mp3\'>Davenport Blues</a>\n<a href=\'http://wordpress.org/news/files/2014/04/JellyRollMorton-BuddyBoldensBlues.mp3\'>Buddy Bolden\'s Blues</a>\n<a href=\'http://wordpress.org/news/files/2014/04/Johnny_Hodges_Orchestra-Squaty_Roo-1941.mp3\'>Squaty Roo</a>\n<a href=\'http://wordpress.org/news/files/2014/04/Louisiana_Five-Dixie_Blues-1919.mp3\'>Dixie Blues</a>\n<a href=\'http://wordpress.org/news/files/2014/04/WolverineBlues.mp3\'>Wolverine Blues</a>\n\n<p>Images have galleries; now we’ve added simple audio and video playlists, so you can showcase your music and clips.</p>\n<hr />\n<h2 style=\"text-align: center\">Live widget and header previews</h2>\n<div style=\"width: 692px; max-width: 100%;\" class=\"wp-video\"><!--[if lt IE 9]><script>document.createElement(\'video\');</script><![endif]-->\n<video class=\"wp-video-shortcode\" id=\"video-3154-1\" width=\"692\" height=\"448\" preload=\"metadata\" controls=\"controls\"><source type=\"video/mp4\" src=\"//wordpress.org/news/files/2014/04/widgets.mp4?_=1\" /><a href=\"//wordpress.org/news/files/2014/04/widgets.mp4\">//wordpress.org/news/files/2014/04/widgets.mp4</a></video></div>\n<p>Add, edit, and rearrange your site’s widgets right in the theme customizer. No “save and surprise” — preview your changes live and only save them when you’re ready.</p>\n<p>The improved header image tool also lets you upload, crop, and manage headers while customizing your theme.</p>\n<hr />\n<h2 style=\"text-align: center\">Stunning new theme browser</h2>\n<p><img class=\"aligncenter size-full wp-image-3172\" src=\"//wordpress.org/news/files/2014/04/theme1.jpg\" alt=\"theme\" width=\"1003\" height=\"558\" /><br />\nLooking for a new theme should be easy and fun. Lose yourself in the boundless supply of free WordPress.org themes with the beautiful new theme browser.</p>\n<hr />\n<h2 style=\"text-align: center\">The Crew</h2>\n<p>This release was led by <a href=\"http://nacin.com/\">Andrew Nacin</a> and <a href=\"http://www.getsource.net/\">Mike Schroder</a>, with the help of these fine individuals. There are 267 contributors with props in this release, a new high:</p>\n<p><a href=\"http://profiles.wordpress.org/aaroncampbell\">Aaron D. Campbell</a>, <a href=\"http://profiles.wordpress.org/jorbin\">Aaron Jorbin</a>, <a href=\"http://profiles.wordpress.org/kawauso\">Adam Harley</a>, <a href=\"http://profiles.wordpress.org/adamsilverstein\">Adam Silverstein</a>, <a href=\"http://profiles.wordpress.org/adelval\">adelval</a>, <a href=\"http://profiles.wordpress.org/ajay\">Ajay</a>, <a href=\"http://profiles.wordpress.org/akeda\">Akeda Bagus</a>, <a href=\"http://profiles.wordpress.org/xknown\">Alex Concha</a>, <a href=\"http://profiles.wordpress.org/aliso\">Alison Barrett</a>, <a href=\"http://profiles.wordpress.org/collinsinternet\">Allan Collins</a>, <a href=\"http://profiles.wordpress.org/sabreuse\">Amy Hendrix (sabreuse)</a>, <a href=\"http://profiles.wordpress.org/afercia\">Andrea Fercia</a>, <a href=\"http://profiles.wordpress.org/nacin\">Andrew Nacin</a>, <a href=\"http://profiles.wordpress.org/norcross\">Andrew Norcross</a>, <a href=\"http://profiles.wordpress.org/azaozz\">Andrew Ozz</a>, <a href=\"http://profiles.wordpress.org/rarst\">Andrey \"Rarst\" Savchenko</a>, <a href=\"http://profiles.wordpress.org/andykeith\">Andy Keith</a>, <a href=\"http://profiles.wordpress.org/andy\">Andy Skelton</a>, <a href=\"http://profiles.wordpress.org/atimmer\">Anton Timmermans</a>, <a href=\"http://profiles.wordpress.org/aubreypwd\">Aubrey Portwood</a>, <a href=\"http://profiles.wordpress.org/barry\">Barry</a>, <a href=\"http://profiles.wordpress.org/toszcze\">Bartosz Romanowski</a>, <a href=\"http://profiles.wordpress.org/bassgang\">bassgang</a>, <a href=\"http://profiles.wordpress.org/bcworkz\">bcworkz</a>, <a href=\"http://profiles.wordpress.org/empireoflight\">Ben Dunkle</a>, <a href=\"http://profiles.wordpress.org/neoxx\">Bernhard Riedl</a>, <a href=\"http://profiles.wordpress.org/bigdawggi\">bigdawggi</a>, <a href=\"http://profiles.wordpress.org/bobbravo2\">Bob Gregor</a>, <a href=\"http://profiles.wordpress.org/bobbingwide\">bobbingwide</a>, <a href=\"http://profiles.wordpress.org/bradt\">Brad Touesnard</a>, <a href=\"http://profiles.wordpress.org/bradparbs\">bradparbs</a>, <a href=\"http://profiles.wordpress.org/bramd\">bramd</a>, <a href=\"http://profiles.wordpress.org/kraftbj\">Brandon Kraft</a>, <a href=\"http://profiles.wordpress.org/brasofilo\">brasofilo</a>, <a href=\"http://profiles.wordpress.org/bravokeyl\">bravokeyl</a>, <a href=\"http://profiles.wordpress.org/bpetty\">Bryan Petty</a>, <a href=\"http://profiles.wordpress.org/cgaffga\">cgaffga</a>, <a href=\"http://profiles.wordpress.org/chiragswadia\">Chirag Swadia</a>, <a href=\"http://profiles.wordpress.org/chouby\">Chouby</a>, <a href=\"http://profiles.wordpress.org/ehg\">Chris Blower</a>, <a href=\"http://profiles.wordpress.org/cmmarslender\">Chris Marslender</a>, <a href=\"http://profiles.wordpress.org/c3mdigital\">Chris Olbekson</a>, <a href=\"http://profiles.wordpress.org/chrisscott\">Chris Scott</a>, <a href=\"http://profiles.wordpress.org/chriseverson\">chriseverson</a>, <a href=\"http://profiles.wordpress.org/chrisguitarguy\">chrisguitarguy</a>, <a href=\"http://profiles.wordpress.org/cfinke\">Christopher Finke</a>, <a href=\"http://profiles.wordpress.org/ciantic\">ciantic</a>, <a href=\"http://profiles.wordpress.org/antorome\">Comparativa de Bancos</a>, <a href=\"http://profiles.wordpress.org/cojennin\">Connor Jennings</a>, <a href=\"http://profiles.wordpress.org/corvannoorloos\">Cor van Noorloos</a>, <a href=\"http://profiles.wordpress.org/corphi\">Corphi</a>, <a href=\"http://profiles.wordpress.org/cramdesign\">cramdesign</a>, <a href=\"http://profiles.wordpress.org/danielbachhuber\">Daniel Bachhuber</a>, <a href=\"http://profiles.wordpress.org/redsweater\">Daniel Jalkut (Red Sweater)</a>, <a href=\"http://profiles.wordpress.org/dannydehaan\">Danny de Haan</a>, <a href=\"http://profiles.wordpress.org/koop\">Daryl Koopersmith</a>, <a href=\"http://profiles.wordpress.org/eightface\">Dave Kellam (eightface)</a>, <a href=\"http://profiles.wordpress.org/dpe415\">DaveE</a>, <a href=\"http://profiles.wordpress.org/davidakennedy\">David A. Kennedy</a>, <a href=\"http://profiles.wordpress.org/davidanderson\">David Anderson</a>, <a href=\"http://profiles.wordpress.org/davidmarichal\">David Marichal</a>, <a href=\"http://profiles.wordpress.org/denis-de-bernardy\">Denis de Bernardy</a>, <a href=\"http://profiles.wordpress.org/dd32\">Dion Hulse</a>, <a href=\"http://profiles.wordpress.org/ocean90\">Dominik Schilling</a>, <a href=\"http://profiles.wordpress.org/dougwollison\">Doug Wollison</a>, <a href=\"http://profiles.wordpress.org/drewapicture\">Drew Jaynes</a>, <a href=\"http://profiles.wordpress.org/drprotocols\">DrProtocols</a>, <a href=\"http://profiles.wordpress.org/dustyf\">Dustin Filippini</a>, <a href=\"http://profiles.wordpress.org/eatingrules\">eatingrules</a>, <a href=\"http://profiles.wordpress.org/plocha\">edik</a>, <a href=\"http://profiles.wordpress.org/eliorivero\">Elio Rivero</a>, <a href=\"http://profiles.wordpress.org/enej\">enej</a>, <a href=\"http://profiles.wordpress.org/ericlewis\">Eric Andrew Lewis</a>, <a href=\"http://profiles.wordpress.org/ericmann\">Eric Mann</a>, <a href=\"http://profiles.wordpress.org/evarlese\">Erica Varlese</a>, <a href=\"http://profiles.wordpress.org/ethitter\">Erick Hitter</a>, <a href=\"http://profiles.wordpress.org/ejdanderson\">Evan Anderson</a>, <a href=\"http://profiles.wordpress.org/fahmiadib\">Fahmi Adib</a>, <a href=\"http://profiles.wordpress.org/fboender\">fboender</a>, <a href=\"http://profiles.wordpress.org/frank-klein\">Frank Klein</a>, <a href=\"http://profiles.wordpress.org/garyc40\">Gary Cao</a>, <a href=\"http://profiles.wordpress.org/garyj\">Gary Jones</a>, <a href=\"http://profiles.wordpress.org/pento\">Gary Pendergast</a>, <a href=\"http://profiles.wordpress.org/genkisan\">genkisan</a>, <a href=\"http://profiles.wordpress.org/soulseekah\">Gennady Kovshenin</a>, <a href=\"http://profiles.wordpress.org/georgestephanis\">George Stephanis</a>, <a href=\"http://profiles.wordpress.org/grahamarmfield\">Graham Armfield</a>, <a href=\"http://profiles.wordpress.org/vancoder\">Grant Mangham</a>, <a href=\"http://profiles.wordpress.org/gcorne\">Gregory Cornelius</a>, <a href=\"http://profiles.wordpress.org/tivnet\">Gregory Karpinsky</a>, <a href=\"http://profiles.wordpress.org/hakre\">hakre</a>, <a href=\"http://profiles.wordpress.org/hanni\">hanni</a>, <a href=\"http://profiles.wordpress.org/helen\">Helen Hou-Sandí</a>, <a href=\"http://profiles.wordpress.org/ippetkov\">ippetkov</a>, <a href=\"http://profiles.wordpress.org/ipstenu\">Ipstenu (Mika Epstein)</a>, <a href=\"http://profiles.wordpress.org/jdgrimes\">J.D. Grimes</a>, <a href=\"http://profiles.wordpress.org/jackreichert\">Jack Reichert</a>, <a href=\"http://profiles.wordpress.org/_jameslee\">jameslee</a>, <a href=\"http://profiles.wordpress.org/avryl\">Janneke Van Dorpe</a>, <a href=\"http://profiles.wordpress.org/janrenn\">janrenn</a>, <a href=\"http://profiles.wordpress.org/jaycc\">JayCC</a>, <a href=\"http://profiles.wordpress.org/jeffsebring\">Jeff Sebring</a>, <a href=\"http://profiles.wordpress.org/jenmylo\">Jen Mylo</a>, <a href=\"http://profiles.wordpress.org/jeremyfelt\">Jeremy Felt</a>, <a href=\"http://profiles.wordpress.org/jesin\">Jesin A</a>, <a href=\"http://profiles.wordpress.org/jayjdk\">Jesper Johansen (jayjdk)</a>, <a href=\"http://profiles.wordpress.org/jnielsendotnet\">jnielsendotnet</a>, <a href=\"http://profiles.wordpress.org/jartes\">Joan Artes</a>, <a href=\"http://profiles.wordpress.org/joedolson\">Joe Dolson</a>, <a href=\"http://profiles.wordpress.org/joehoyle\">Joe Hoyle</a>, <a href=\"http://profiles.wordpress.org/johnbillion\">John Blackbourn</a>, <a href=\"http://profiles.wordpress.org/johnjamesjacoby\">John James Jacoby</a>, <a href=\"http://profiles.wordpress.org/johnpbloch\">John P. Bloch</a>, <a href=\"http://profiles.wordpress.org/johnregan3\">John Regan</a>, <a href=\"http://profiles.wordpress.org/duck_\">Jon Cave</a>, <a href=\"http://profiles.wordpress.org/jond3r\">Jonas Bolinder (jond3r)</a>, <a href=\"http://profiles.wordpress.org/joostdevalk\">Joost de Valk</a>, <a href=\"http://profiles.wordpress.org/shelob9\">Josh Pollock</a>, <a href=\"http://profiles.wordpress.org/joshuaabenazer\">Joshua Abenazer</a>, <a href=\"http://profiles.wordpress.org/jstraitiff\">jstraitiff</a>, <a href=\"http://profiles.wordpress.org/juliobox\">Julio Potier</a>, <a href=\"http://profiles.wordpress.org/kopepasah\">Justin Kopepasah</a>, <a href=\"http://profiles.wordpress.org/justinsainton\">Justin Sainton</a>, <a href=\"http://profiles.wordpress.org/kadamwhite\">K.Adam White</a>, <a href=\"http://profiles.wordpress.org/trepmal\">Kailey (trepmal)</a>, <a href=\"http://profiles.wordpress.org/kasparsd\">Kaspars</a>, <a href=\"http://profiles.wordpress.org/ryelle\">Kelly Dwan</a>, <a href=\"http://profiles.wordpress.org/kerikae\">kerikae</a>, <a href=\"http://profiles.wordpress.org/kworthington\">Kevin Worthington</a>, <a href=\"http://profiles.wordpress.org/kpdesign\">Kim Parsell</a>, <a href=\"http://profiles.wordpress.org/kwight\">Kirk Wight</a>, <a href=\"http://profiles.wordpress.org/kitchin\">kitchin</a>, <a href=\"http://profiles.wordpress.org/klihelp\">klihelp</a>, <a href=\"http://profiles.wordpress.org/knutsp\">Knut Sparhell</a>, <a href=\"http://profiles.wordpress.org/kovshenin\">Konstantin Kovshenin</a>, <a href=\"http://profiles.wordpress.org/obenland\">Konstantin Obenland</a>, <a href=\"http://profiles.wordpress.org/drozdz\">Krzysiek Drozdz</a>, <a href=\"http://profiles.wordpress.org/lancewillett\">Lance Willett</a>, <a href=\"http://profiles.wordpress.org/leewillis77\">Lee Willis</a>, <a href=\"http://profiles.wordpress.org/lkwdwrd\">lkwdwrd</a>, <a href=\"http://profiles.wordpress.org/lpointet\">lpointet</a>, <a href=\"http://profiles.wordpress.org/ldebrouwer\">Luc De Brouwer</a>, <a href=\"http://profiles.wordpress.org/spmlucas\">Lucas Karpiuk</a>, <a href=\"http://profiles.wordpress.org/mark8barnes\">Mark Barnes</a>, <a href=\"http://profiles.wordpress.org/markjaquith\">Mark Jaquith</a>, <a href=\"http://profiles.wordpress.org/markoheijnen\">Marko Heijnen</a>, <a href=\"http://profiles.wordpress.org/marventus\">Marventus</a>, <a href=\"http://profiles.wordpress.org/iammattthomas\">Matt (Thomas) Miklic</a>, <a href=\"http://profiles.wordpress.org/mjbanks\">Matt Banks</a>, <a href=\"http://profiles.wordpress.org/matt\">Matt Mullenweg</a>, <a href=\"http://profiles.wordpress.org/mboynes\">Matthew Boynes</a>, <a href=\"http://profiles.wordpress.org/mdbitz\">Matthew Denton</a>, <a href=\"http://profiles.wordpress.org/mattheu\">Matthew Haines-Young</a>, <a href=\"http://profiles.wordpress.org/mattonomics\">mattonomics</a>, <a href=\"http://profiles.wordpress.org/mattyrob\">mattyrob</a>, <a href=\"http://profiles.wordpress.org/matveb\">Matías Ventura</a>, <a href=\"http://profiles.wordpress.org/maxcutler\">Max Cutler</a>, <a href=\"http://profiles.wordpress.org/mcadwell\">mcadwell</a>, <a href=\"http://profiles.wordpress.org/melchoyce\">Mel Choyce</a>, <a href=\"http://profiles.wordpress.org/meloniq\">meloniq</a>, <a href=\"http://profiles.wordpress.org/michael-arestad\">Michael Arestad</a>, <a href=\"http://profiles.wordpress.org/michelwppi\">Michel - xiligroup dev</a>, <a href=\"http://profiles.wordpress.org/mcsf\">Miguel Fonseca</a>, <a href=\"http://profiles.wordpress.org/gradyetc\">Mike Burns</a>, <a href=\"http://profiles.wordpress.org/mikehansenme\">Mike Hansen</a>, <a href=\"http://profiles.wordpress.org/mikemanger\">Mike Manger</a>, <a href=\"http://profiles.wordpress.org/mikeschinkel\">Mike Schinkel</a>, <a href=\"http://profiles.wordpress.org/dh-shredder\">Mike Schroder</a>, <a href=\"http://profiles.wordpress.org/mikecorkum\">mikecorkum</a>, <a href=\"http://profiles.wordpress.org/mitchoyoshitaka\">mitcho (Michael Yoshitaka Erlewine)</a>, <a href=\"http://profiles.wordpress.org/batmoo\">Mohammad Jangda</a>, <a href=\"http://profiles.wordpress.org/morganestes\">Morgan Estes</a>, <a href=\"http://profiles.wordpress.org/mor10\">Morten Rand-Hendriksen</a>, <a href=\"http://profiles.wordpress.org/Nao\">Naoko Takano</a>, <a href=\"http://profiles.wordpress.org/alex-ye\">Nashwan Doaqan</a>, <a href=\"http://profiles.wordpress.org/nendeb55\">nendeb55</a>, <a href=\"http://profiles.wordpress.org/celloexpressions\">Nick Halsey</a>, <a href=\"http://profiles.wordpress.org/nicolealleyinteractivecom\">Nicole Arnold</a>, <a href=\"http://profiles.wordpress.org/nikv\">Nikhil Vimal (NikV)</a>, <a href=\"http://profiles.wordpress.org/nivijah\">nivijah</a>, <a href=\"http://profiles.wordpress.org/nofearinc\">nofearinc</a>, <a href=\"http://profiles.wordpress.org/nunomorgadinho\">Nuno Morgadinho</a>, <a href=\"http://profiles.wordpress.org/olivm\">olivM</a>, <a href=\"http://profiles.wordpress.org/jbkkd\">Omer Korner</a>, <a href=\"http://profiles.wordpress.org/originalexe\">OriginalEXE</a>, <a href=\"http://profiles.wordpress.org/oso96_2000\">oso96_2000</a>, <a href=\"http://profiles.wordpress.org/patricknami\">patricknami</a>, <a href=\"http://profiles.wordpress.org/pbearne\">Paul Bearne</a>, <a href=\"http://profiles.wordpress.org/djpaul\">Paul Gibbs</a>, <a href=\"http://profiles.wordpress.org/paulwilde\">Paul Wilde</a>, <a href=\"http://profiles.wordpress.org/pavelevap\">pavelevap</a>, <a href=\"http://profiles.wordpress.org/westi\">Peter Westwood</a>, <a href=\"http://profiles.wordpress.org/philiparthurmoore\">Philip Arthur Moore</a>, <a href=\"http://profiles.wordpress.org/mordauk\">Pippin Williamson</a>, <a href=\"http://profiles.wordpress.org/nprasath002\">Prasath Nadarajah</a>, <a href=\"http://profiles.wordpress.org/prettyboymp\">prettyboymp</a>, <a href=\"http://profiles.wordpress.org/raamdev\">Raam Dev</a>, <a href=\"http://profiles.wordpress.org/rachelbaker\">rachelbaker</a>, <a href=\"http://profiles.wordpress.org/mauryaratan\">Ram Ratan Maurya</a>, <a href=\"http://profiles.wordpress.org/ramonchiara\">ramonchiara</a>, <a href=\"http://profiles.wordpress.org/ounziw\">Rescuework Support</a>, <a href=\"http://profiles.wordpress.org/rhyswynne\">Rhys Wynne</a>, <a href=\"http://profiles.wordpress.org/ricardocorreia\">Ricardo Correia</a>, <a href=\"http://profiles.wordpress.org/theorboman\">Richard Sweeney</a>, <a href=\"http://profiles.wordpress.org/iamfriendly\">Richard Tape</a>, <a href=\"http://profiles.wordpress.org/richard2222\">richard2222</a>, <a href=\"http://profiles.wordpress.org/rickalee\">Ricky Lee Whittemore</a>, <a href=\"http://profiles.wordpress.org/miqrogroove\">Robert Chapin</a>, <a href=\"http://profiles.wordpress.org/robmiller\">robmiller</a>, <a href=\"http://profiles.wordpress.org/rodrigosprimo\">Rodrigo Primo</a>, <a href=\"http://profiles.wordpress.org/romaimperator\">romaimperator</a>, <a href=\"http://profiles.wordpress.org/roothorick\">roothorick</a>, <a href=\"http://profiles.wordpress.org/ruudjoyo\">ruud@joyo</a>, <a href=\"http://profiles.wordpress.org/ryan\">Ryan Boren</a>, <a href=\"http://profiles.wordpress.org/rmccue\">Ryan McCue</a>, <a href=\"http://profiles.wordpress.org/salcode\">Sal Ferrarello</a>, <a href=\"http://profiles.wordpress.org/otto42\">Samuel Wood (Otto)</a>, <a href=\"http://profiles.wordpress.org/sandyr\">Sandeep</a>, <a href=\"http://profiles.wordpress.org/scottlee\">Scott Lee</a>, <a href=\"http://profiles.wordpress.org/coffee2code\">Scott Reilly</a>, <a href=\"http://profiles.wordpress.org/wonderboymusic\">Scott Taylor</a>, <a href=\"http://profiles.wordpress.org/greglone\">ScreenfeedFr</a>, <a href=\"http://profiles.wordpress.org/scribu\">scribu</a>, <a href=\"http://profiles.wordpress.org/sdasse\">sdasse</a>, <a href=\"http://profiles.wordpress.org/bootsz\">Sean Butze</a>, <a href=\"http://profiles.wordpress.org/seanchayes\">Sean Hayes</a>, <a href=\"http://profiles.wordpress.org/nessworthy\">Sean Nessworthy</a>, <a href=\"http://profiles.wordpress.org/sergeybiryukov\">Sergey Biryukov</a>, <a href=\"http://profiles.wordpress.org/shahpranaf\">shahpranaf</a>, <a href=\"http://profiles.wordpress.org/shaunandrews\">Shaun Andrews</a>, <a href=\"http://profiles.wordpress.org/shinichin\">ShinichiN</a>, <a href=\"http://profiles.wordpress.org/pross\">Simon Prosser</a>, <a href=\"http://profiles.wordpress.org/simonwheatley\">Simon Wheatley</a>, <a href=\"http://profiles.wordpress.org/siobhan\">Siobhan</a>, <a href=\"http://profiles.wordpress.org/siobhyb\">Siobhan Bamber (siobhyb)</a>, <a href=\"http://profiles.wordpress.org/sirzooro\">sirzooro</a>, <a href=\"http://profiles.wordpress.org/solarissmoke\">solarissmoke</a>, <a href=\"http://profiles.wordpress.org/sonjanyc\">sonjanyc</a>, <a href=\"http://profiles.wordpress.org/spencerfinnell\">Spencer Finnell</a>, <a href=\"http://profiles.wordpress.org/piontkowski\">Spencer Piontkowski</a>, <a href=\"http://profiles.wordpress.org/stephcook22\">stephcook22</a>, <a href=\"http://profiles.wordpress.org/netweb\">Stephen Edgar</a>, <a href=\"http://profiles.wordpress.org/stephenharris\">Stephen Harris</a>, <a href=\"http://profiles.wordpress.org/sbruner\">Steve Bruner</a>, <a href=\"http://profiles.wordpress.org/stevenkword\">Steven Word</a>, <a href=\"http://profiles.wordpress.org/miyauchi\">Takayuki Miyauchi</a>, <a href=\"http://profiles.wordpress.org/tanner-m\">Tanner Moushey</a>, <a href=\"http://profiles.wordpress.org/tlovett1\">Taylor Lovett</a>, <a href=\"http://profiles.wordpress.org/tbrams\">tbrams</a>, <a href=\"http://profiles.wordpress.org/tellyworth\">tellyworth</a>, <a href=\"http://profiles.wordpress.org/tobiasbg\">TobiasBg</a>, <a href=\"http://profiles.wordpress.org/tomauger\">Tom Auger</a>, <a href=\"http://profiles.wordpress.org/willmot\">Tom Willmot</a>, <a href=\"http://profiles.wordpress.org/topher1kenobe\">Topher</a>, <a href=\"http://profiles.wordpress.org/topquarky\">topquarky</a>, <a href=\"http://profiles.wordpress.org/zodiac1978\">Torsten Landsiedel</a>, <a href=\"http://profiles.wordpress.org/toru\">Toru</a>, <a href=\"http://profiles.wordpress.org/wpsmith\">Travis Smith</a>, <a href=\"http://profiles.wordpress.org/umeshsingla\">Umesh Kumar</a>, <a href=\"http://profiles.wordpress.org/undergroundnetwork\">undergroundnetwork</a>, <a href=\"http://profiles.wordpress.org/varunagw\">VarunAgw</a>, <a href=\"http://profiles.wordpress.org/wawco\">wawco</a>, <a href=\"http://profiles.wordpress.org/westonruter\">Weston Ruter</a>, <a href=\"http://profiles.wordpress.org/wokamoto\">wokamoto</a>, <a href=\"http://profiles.wordpress.org/xsonic\">xsonic</a>, <a href=\"http://profiles.wordpress.org/yoavf\">Yoav Farhi</a>, <a href=\"http://profiles.wordpress.org/yurivictor\">Yuri Victor</a>, <a href=\"http://profiles.wordpress.org/zbtirrell\">Zach Tirrell</a>, and <a href=\"http://profiles.wordpress.org/vanillalounge\">Ze Fontainhas</a>. Also thanks to <a href=\"http://michaelpick.wordpress.com/\">Michael Pick</a> for producing the release video.</p>\n<p>If you want to follow along or help out, check out <a href=\"http://make.wordpress.org/\">Make WordPress</a> and our <a href=\"http://make.wordpress.org/core/\">core development blog</a>. Thanks for choosing WordPress. See you soon for version 4.0!</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"http://wordpress.org/news/2014/04/smith/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"WordPress 3.9 Release Candidate 2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"http://wordpress.org/news/2014/04/wordpress-3-9-release-candidate-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"http://wordpress.org/news/2014/04/wordpress-3-9-release-candidate-2/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 15 Apr 2014 09:47:36 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3151\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:356:\"The second release candidate for WordPress 3.9 is now available for testing. If you haven&#8217;t tested 3.9 yet, you&#8217;re running out of time! We made about five dozen changes since the first release candidate, and those changes are all helpfully summarized in our weekly post on the development blog. Probably the biggest fixes are to live [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2328:\"<p>The second release candidate for WordPress 3.9 is now available for testing.</p>\n<p>If you haven&#8217;t tested 3.9 yet, you&#8217;re running out of time! We made about five dozen changes since the <a title=\"WordPress 3.9 Release Candidate\" href=\"http://wordpress.org/news/2014/04/wordpress-3-9-release-candidate/\">first release candidate</a>, and those changes are all helpfully summarized <a href=\"http://make.wordpress.org/core/?p=10237\">in our weekly post</a> on the development blog. Probably the biggest fixes are to live widget previews and the new theme browser, along with some extra TinyMCE compatibility and some RTL fixes.</p>\n<p><strong>Plugin authors:</strong> Could you test your plugins against 3.9, and if they&#8217;re compatible, make sure they are marked as tested up to 3.9? It only takes a few minutes and this really helps make launch easier. Be sure to follow along the core development blog; we&#8217;ve been posting <a href=\"http://make.wordpress.org/core/tag/3-9-dev-notes/\">notes for developers for 3.9</a>. (For example: <a href=\"http://make.wordpress.org/core/2014/04/15/html5-galleries-captions-in-wordpress-3-9/\">HTML5</a>, <a href=\"http://make.wordpress.org/core/2014/04/14/symlinked-plugins-in-wordpress-3-9/\">symlinks</a>, <a href=\"http://make.wordpress.org/core/2014/04/07/mysql-in-wordpress-3-9/\">MySQL</a>, <a href=\"http://make.wordpress.org/core/2014/04/11/plupload-2-x-in-wordpress-3-9/\">Plupload</a>.)</p>\n<p>To test WordPress 3.9 RC2, try the <a href=\"http://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”). Or you can <a href=\"http://wordpress.org/wordpress-3.9-RC2.zip\">download the release candidate here</a> (zip). If you’d like to learn more about what’s new in WordPress 3.9, visit the nearly complete About screen in your dashboard (<strong><img src=\"http://i0.wp.com/core.svn.wordpress.org/branches/3.6/wp-content/themes/twentyten/images/wordpress.png?w=692\" alt=\"\" width=\"16\" height=\"16\" /> → About</strong> in the toolbar) and also check out <a title=\"WordPress 3.9 Beta 1\" href=\"http://wordpress.org/news/2014/03/wordpress-3-9-beta-1/\">the Beta 1 post</a>.</p>\n<p><em>This is for testing,</em><br />\n<em>so not recommended for<br />\nproduction sites—yet.</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"http://wordpress.org/news/2014/04/wordpress-3-9-release-candidate-2/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:42:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"WordPress 3.8.3 Maintenance Release\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wordpress.org/news/2014/04/wordpress-3-8-3/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/news/2014/04/wordpress-3-8-3/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 14 Apr 2014 19:29:13 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3145\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:338:\"WordPress 3.8.3 is now available to fix a small but unfortunate bug in the WordPress 3.8.2 security release. The &#8220;Quick Draft&#8221; tool on the dashboard screen was broken in the 3.8.2 update. If you tried to use it, your draft would disappear and it wouldn&#8217;t save. While we doubt anyone was writing a novella using [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2339:\"<p>WordPress 3.8.3 is now available to fix a small but unfortunate bug in the <a title=\"WordPress 3.8.2 Security Release\" href=\"http://wordpress.org/news/2014/04/wordpress-3-8-2/\">WordPress 3.8.2 security release</a>.</p>\n<p>The &#8220;Quick Draft&#8221; tool on the dashboard screen was broken in the 3.8.2 update. If you tried to use it, your draft would disappear and it wouldn&#8217;t save. While we doubt anyone was writing a novella using this tool, <em>any</em> loss of content is unacceptable to us.</p>\n<p>We recognize how much trust you place in us to safeguard your content, and we take this responsibility very seriously. We&#8217;re sorry we let you down.</p>\n<p>We&#8217;ve all lost words we&#8217;ve written before, like an email thanks to a cat on the keyboard or a term paper to a blue screen of death. Over the last few WordPress releases, we&#8217;ve made a number of improvements to features like autosaves and revisions. With revisions, an old edit can always be restored. We&#8217;re trying our hardest to save your content somewhere even if your power goes out or your browser crashes. We even monitor your internet connection and prevent you from hitting that &#8220;Publish&#8221; button at the exact moment the coffee shop Wi-Fi has a hiccup.</p>\n<p>It&#8217;s <em>possible</em> that the quick draft you lost last week is still in the database, and just hidden from view. As an added complication, these &#8220;discarded drafts&#8221; normally get deleted after seven days, and it&#8217;s already been six days since the release. If we were able to rescue your draft, you&#8217;ll see it on the &#8220;All Posts&#8221; screen after you update to 3.8.3. (We&#8217;ll also be pushing 3.8.3 out as a background update, so you may just see a draft appear.)</p>\n<p>So, if you tried to jot down a quick idea last week, I hope WordPress has recovered it for you. Maybe it&#8217;ll turn into that novella.</p>\n<p><a href=\"http://wordpress.org/download/\">Download WordPress 3.8.3</a> or click &#8220;Update Now&#8221; on Dashboard → Updates.</p>\n<p><em>This affected version 3.7.2 as well, so we&#8217;re pushing a 3.7.3 to these installs, but we&#8217;d encourage you to update to the latest and greatest.</em></p>\n<hr />\n<p><em>Now for some good news:<br />\nWordPress 3.9 is near.<br />\nExpect it this week</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2014/04/wordpress-3-8-3/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"WordPress 3.9 Release Candidate\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"http://wordpress.org/news/2014/04/wordpress-3-9-release-candidate/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:75:\"http://wordpress.org/news/2014/04/wordpress-3-9-release-candidate/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 08 Apr 2014 21:05:21 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3129\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:338:\"As teased earlier, the first release candidate for WordPress 3.9 is now available for testing! We hope to ship WordPress 3.9 next week, but we need your help to get there. If you haven’t tested 3.9 yet, there’s no time like the present. (Please, not on a production site, unless you’re adventurous.) To test WordPress 3.9 [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:3022:\"<p><a href=\"http://wordpress.org/news/2014/04/wordpress-3-8-2/\">As teased earlier</a>, the first release candidate for WordPress 3.9 is now available for testing!</p>\n<p>We hope to ship WordPress 3.9 <em>next week</em>, but we need your help to get there. If you haven’t tested 3.9 yet, there’s no time like the present. (Please, not on a production site, unless you’re adventurous.)</p>\n<p>To test WordPress 3.9 RC1, try the <a href=\"http://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”). Or you can <a href=\"http://wordpress.org/wordpress-3.9-RC1.zip\">download the release candidate here</a> (zip). If you’d like to learn more about what’s new in WordPress 3.9, visit the work-in-progress About screen in your dashboard (<strong><img src=\"http://i0.wp.com/core.svn.wordpress.org/branches/3.6/wp-content/themes/twentyten/images/wordpress.png?w=692\" alt=\"\" width=\"16\" height=\"16\" /> → About</strong> in the toolbar) and check out <a title=\"WordPress 3.9 Beta 1\" href=\"http://wordpress.org/news/2014/03/wordpress-3-9-beta-1/\">the Beta 1 post</a>.</p>\n<p><strong>Think you’ve found a bug? </strong>Please post to the <a href=\"http://wordpress.org/support/forum/alphabeta/\">Alpha/Beta area in the support forums</a>. If any known issues come up, you’ll be able to <a href=\"http://core.trac.wordpress.org/report/5\">find them here</a>.</p>\n<p><strong>If you&#8217;re a plugin author</strong>, there are two important changes in particular to be aware of:</p>\n<ul>\n<li>TinyMCE received a major update, to version 4.0. Any editor plugins written for TinyMCE 3.x might require some updates. (If things broke, we&#8217;d like to hear about them so we can make adjustments.) For more, see TinyMCE&#8217;s <a href=\"http://www.tinymce.com/wiki.php/Tutorial:Migration_guide_from_3.x\">migration guide</a> and <a href=\"http://www.tinymce.com/wiki.php/api4:index\">API documentation</a>, and the notes on the <a href=\"http://make.wordpress.org/core/2014/01/18/tinymce-4-0-is-in-core/\">core development blog</a>.</li>\n<li>WordPress 3.9 now uses the MySQLi Improved extension for sites running PHP 5.5. Any plugins that made direct calls to <code>mysql_*</code> functions will experience some problems on these sites. For more information, see the notes on the <a href=\"http://make.wordpress.org/core/2014/04/07/mysql-in-wordpress-3-9/\">core development blog</a>.</li>\n</ul>\n<p>Be sure to follow along the core development blog, where we will be continuing to post <a href=\"http://make.wordpress.org/core/tag/3-9-dev-notes/\">notes for developers for 3.9</a>. (For example, read <a href=\"http://make.wordpress.org/core/2014/03/27/masonry-in-wordpress-3-9/\">this</a> if you are using Masonry in your theme.) And please, please update your plugin&#8217;s <em>Tested up to</em> version in the readme to 3.9 before April 16.</p>\n<p><em>Release candidate<br />\nThis haiku&#8217;s the easy one<br />\n3.9 is near</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"http://wordpress.org/news/2014/04/wordpress-3-9-release-candidate/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"WordPress 3.8.2 Security Release\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wordpress.org/news/2014/04/wordpress-3-8-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/news/2014/04/wordpress-3-8-2/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 08 Apr 2014 19:04:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3124\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:355:\"WordPress 3.8.2 is now available. This is an important security release for all previous versions and we strongly encourage you to update your sites immediately. This releases fixes a weakness that could let an attacker force their way into your site by forging authentication cookies. This was discovered and fixed by Jon Cave of the WordPress [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2272:\"<p>WordPress 3.8.2 is now available. This is an important security release for all previous versions and we strongly encourage you to update your sites immediately.</p>\n<p>This releases fixes a weakness that could let an attacker force their way into your site by forging authentication cookies. This was discovered and fixed by <a href=\"http://joncave.co.uk/\">Jon Cave</a> of the WordPress security team.</p>\n<p>It also contains a fix to prevent a user with the Contributor role from improperly publishing posts. Reported by <a href=\"http://edik.ch/\">edik</a>.</p>\n<p>This release also fixes nine bugs and contains three other security hardening changes:</p>\n<ul>\n<li>Pass along additional information when processing pingbacks to help hosts identify potentially abusive requests.</li>\n<li>Fix a low-impact SQL injection by trusted users. Reported by <a href=\"http://www.dxw.com/\">Tom Adams</a> of dxw.</li>\n<li>Prevent possible cross-domain scripting through Plupload, the third-party library WordPress uses for uploading files. Reported by <a href=\"http://szgru.website.pl/\">Szymon Gruszecki</a>.</li>\n</ul>\n<p>We appreciated <a href=\"http://codex.wordpress.org/FAQ_Security\">responsible disclosure</a> of these security issues directly to our security team. For more information on all of the changes, see the <a href=\"http://codex.wordpress.org/Version_3.8.2\">release notes</a> or consult <a href=\"https://core.trac.wordpress.org/log/branches/3.8?rev=28057&amp;stop_rev=27024\">the list of changes</a>.</p>\n<p><a href=\"http://wordpress.org/download/\">Download WordPress 3.8.2</a> or venture over to <strong>Dashboard → Updates</strong> and simply click &#8220;Update Now.&#8221;</p>\n<p>Sites that support automatic background updates will be updated to WordPress 3.8.2 within 12 hours. If you are still on WordPress 3.7.1, you will be updated to 3.7.2, which contains the same security fixes as 3.8.2. We don&#8217;t support older versions, so please update to 3.8.2 for the latest and greatest.</p>\n<p>Already testing WordPress 3.9? The first release candidate is <a href=\"https://wordpress.org/wordpress-3.9-RC1.zip\">now available</a> (zip) and it contains these security fixes. Look for a full announcement later today; we expect to release 3.9 next week.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2014/04/wordpress-3-8-2/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 3.9 Beta 3\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2014/03/wordpress-3-9-beta-3/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"http://wordpress.org/news/2014/03/wordpress-3-9-beta-3/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 29 Mar 2014 13:15:10 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3106\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:373:\"The third (and maybe last) beta of WordPress 3.9 is now available for download. Beta 3 includes more than 200 changes, including: New features like live widget previews and the new theme installer are now more ready for prime time, so check &#8216;em out. UI refinements when editing images and when working with media in the editor. We&#8217;ve also brought [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2668:\"<p>The third (and maybe last) beta of WordPress 3.9 is now available for download.</p>\n<p>Beta 3 includes more than 200 <a href=\"https://core.trac.wordpress.org/log?rev=27850&amp;stop_rev=27639&amp;limit=300\">changes</a>, including:</p>\n<ul>\n<li>New features like live widget previews and the new theme installer are now more ready for prime time, so check &#8216;em out.</li>\n<li>UI refinements when editing images and when working with media in the editor. We&#8217;ve also brought back some of the advanced display settings for images.</li>\n<li>If you want to test out audio and video playlists, the links will appear in the media manager once you&#8217;ve uploaded an audio or video file.</li>\n<li>For theme developers, we&#8217;ve added HTML5 caption support (<a class=\"reopened ticket\" title=\"task (blessed): HTML5 captions (reopened)\" href=\"https://core.trac.wordpress.org/ticket/26642\">#26642</a>) to match the new gallery support (<a class=\"closed ticket\" title=\"enhancement: HTML5 Galleries (closed: fixed)\" href=\"https://core.trac.wordpress.org/ticket/26697\">#26697</a>).</li>\n<li>The formatting function that turns straight quotes into smart quotes (among other things) underwent some changes to drastically speed it up, so let us know if you see anything weird.</li>\n</ul>\n<p><strong>We need your help</strong>. We&#8217;re still aiming for an April release, which means the next week will be critical for identifying and squashing bugs. If you&#8217;re just joining us, please see <a href=\"https://wordpress.org/news/2014/03/wordpress-3-9-beta-1/\">the Beta 1 announcement post</a> for what to look out for.</p>\n<p><strong>If you think you’ve found a bug</strong>, you can post to the <a href=\"http://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a> in the support forums, where friendly moderators are standing by. <b>Plugin developers</b><strong>,</strong> if you haven&#8217;t tested WordPress 3.9 yet, now is the time — and be sure to update the &#8220;tested up to&#8221; version for your plugins so they&#8217;re listed as compatible with 3.9.</p>\n<p><strong>This software is still in development,</strong> so we don’t recommend you run it on a production site. Consider setting up a test site just to play with the new version. To test WordPress 3.9, try the <a href=\"http://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”). Or you can <a href=\"http://wordpress.org/wordpress-3.9-beta3.zip\">download the beta here</a> (zip).</p>\n<p><em>WordPress 3.9<br />\nLet&#8217;s make the date official<br />\nIt&#8217;s April 16</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"http://wordpress.org/news/2014/03/wordpress-3-9-beta-3/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 3.9 Beta 2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2014/03/wordpress-3-9-beta-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"http://wordpress.org/news/2014/03/wordpress-3-9-beta-2/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 20 Mar 2014 05:01:25 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3101\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:309:\"WordPress 3.9 Beta 2 is now available for testing! We&#8217;ve made more than a hundred changes since Beta 1, but we still need your help if we&#8217;re going to hit our goal of an April release. For what to look out for, please head on over to the Beta 1 announcement post. Some of the changes in [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:1901:\"<p>WordPress 3.9 Beta 2 is now available for testing!</p>\n<p>We&#8217;ve made more than a hundred <a href=\"https://core.trac.wordpress.org/log?rev=27639&amp;stop_rev=27500&amp;limit=200\">changes</a> since Beta 1, but we still need your help if we&#8217;re going to hit our goal of an April release. For what to look out for, please head on over to <a href=\"https://wordpress.org/news/2014/03/wordpress-3-9-beta-1/\">the Beta 1 announcement post</a>. Some of the changes in Beta 2 include:</p>\n<ul>\n<li>Rendering of embedded audio and video players directly in the visual editor.</li>\n<li>Visual and functional improvements to the editor, the media manager, and theme installer.</li>\n<li>Various bug fixes to TinyMCE, the software behind the visual editor.</li>\n<li>Lots of fixes to widget management in the theme customizer.</li>\n</ul>\n<p>As always,<strong> if you think you’ve found a bug</strong>, you can post to the <a href=\"http://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a> in the support forums. Or, if you’re comfortable writing a reproducible bug report, <a href=\"https://make.wordpress.org/core/reports/\">file one on the WordPress Trac</a>. There, you can also find <a href=\"http://core.trac.wordpress.org/tickets/major\">a list of known bugs</a> and <a href=\"http://core.trac.wordpress.org/query?status=closed&amp;group=component&amp;milestone=3.9\">everything we’ve fixed</a> so far.</p>\n<p><strong>This software is still in development,</strong> so we don’t recommend you run it on a production site. Consider setting up a test site just to play with the new version. To test WordPress 3.9, try the <a href=\"http://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”). Or you can <a href=\"http://wordpress.org/wordpress-3.9-beta2.zip\">download the beta here</a> (zip).</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"http://wordpress.org/news/2014/03/wordpress-3-9-beta-2/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 3.9 Beta 1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2014/03/wordpress-3-9-beta-1/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"http://wordpress.org/news/2014/03/wordpress-3-9-beta-1/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 11 Mar 2014 13:42:19 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3083\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:329:\"I&#8217;m excited to announce that the first beta of WordPress 3.9 is now available for testing. WordPress 3.9 is due out next month &#8212; but in order to hit that goal, we need your help testing all of the goodies we&#8217;ve added: We updated TinyMCE, the software powering the visual editor, to the latest version. [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:6065:\"<p>I&#8217;m excited to announce that the <strong>first beta of WordPress 3.9</strong> is now available for testing.</p>\n<p>WordPress 3.9 is due out next month &#8212; but in order to hit that goal, <strong>we need your help</strong> testing all of the goodies we&#8217;ve added:</p>\n<ul>\n<li>We updated TinyMCE, the software powering the visual editor, to the latest version. Be on the lookout for cleaner markup. Also try the new paste handling &#8212; if you paste in a block of text from Microsoft Word, for example, it will no longer come out terrible. (The &#8220;Paste from Word&#8221; button you probably never noticed has been removed.) It&#8217;s possible some plugins that added stuff to the visual editor (like a new toolbar button) no longer work, so we&#8217;d like to hear about them (<a href=\"https://core.trac.wordpress.org/ticket/24067\">#24067</a>). (And be sure to <a href=\"http://wordpress.org/support/\">open a support thread</a> for the plugin author.)</li>\n<li>We&#8217;ve added <strong>widget management to live previews</strong> (the customizer). Please test editing, adding, and rearranging widgets! (<a href=\"https://core.trac.wordpress.org/ticket/27112\">#27112</a>) We&#8217;ve also added the ability to upload, crop, and manage header images, without needing to leave the preview. (<a href=\"https://core.trac.wordpress.org/ticket/21785\">#21785</a>)</li>\n<li>We brought 3.8&#8242;s beautiful new theme browsing experience to the <strong>theme installer</strong>. Check it out! (<a title=\"View ticket\" href=\"https://core.trac.wordpress.org/ticket/27055\">#27055</a>)</li>\n<li><strong>Galleries</strong> now receive a live preview in the editor. Upload some photos and insert a gallery to see this in action. (<a href=\"https://core.trac.wordpress.org/ticket/26959\">#26959</a>)</li>\n<li>You can now <strong>drag-and-drop</strong> images directly onto the editor to upload them. It can be a bit finicky, so try it and help us work out the kinks. (<a href=\"https://core.trac.wordpress.org/ticket/19845\">#19845</a>)</li>\n<li>Some things got improved around <strong>editing images</strong>. It&#8217;s a lot easier to make changes to an image after you insert it into a post (<a class=\"closed\" title=\"View ticket\" href=\"https://core.trac.wordpress.org/ticket/24409\">#24409</a>) and you no longer get kicked to a new window when you need to crop or rotate an image (<a href=\"https://core.trac.wordpress.org/ticket/21811\">#21811</a>).</li>\n<li>New <strong>audio/video playlists</strong>. Upload a few audio or video files to test these. (<a href=\"https://core.trac.wordpress.org/ticket/26631\">#26631</a>)</li>\n</ul>\n<p><strong>If you think you’ve found a bug</strong>, you can post to the <a href=\"http://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a> in the support forums. We&#8217;d love to hear from you! If you’re comfortable writing a reproducible bug report, <a href=\"https://make.wordpress.org/core/reports/\">file one on the WordPress Trac</a>. There, you can also find <a href=\"http://core.trac.wordpress.org/tickets/major\">a list of known bugs</a> and <a href=\"http://core.trac.wordpress.org/query?status=closed&amp;group=component&amp;milestone=3.9\">everything we’ve fixed</a> so far.</p>\n<p><strong>This software is still in development,</strong> so we don’t recommend you run it on a production site. Consider setting up a test site just to play with the new version. To test WordPress 3.9, try the <a href=\"http://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”). Or you can <a href=\"http://wordpress.org/wordpress-3.9-beta1.zip\">download the beta here</a> (zip).</p>\n<hr />\n<p><strong>DEVELOPERS!</strong> Hello! There&#8217;s lots for you, too.</p>\n<p><strong>Please test your plugins and themes!</strong> There&#8217;s a lot of great stuff under the hood in 3.9 and we hope to blog a bit about them in the coming days. If you haven&#8217;t been reading the awesome <a href=\"http://make.wordpress.org/core/tag/week-in-core/\">weekly summaries</a> on the <a href=\"http://make.wordpress.org/core/\">main core development blog</a>, that&#8217;s a great place to start. (You should definitely follow that blog.) For now, here are some things to watch out for when testing:</p>\n<ul>\n<li>The <strong>load process in multisite</strong> got rewritten. If you notice any issues with your network, see <a href=\"https://core.trac.wordpress.org/ticket/27003\">#27003</a>.</li>\n<li>We now use the <strong>MySQL Improved (mysqli) database extension</strong> if you&#8217;re running a recent version of PHP (<a href=\"https://core.trac.wordpress.org/ticket/21663\">#21663</a>). Please test your plugins and see that everything works well, and please make sure you&#8217;re not calling <code>mysql_*</code> functions directly.</li>\n<li><strong>Autosave</strong> was refactored, so if you see any issues related to autosaving, heartbeat, etc., let us know (<a href=\"https://core.trac.wordpress.org/ticket/25272\">#25272</a>).</li>\n<li>Library updates, in particular Backbone 1.1 and Underscore 1.6 (<a href=\"https://core.trac.wordpress.org/ticket/26799\">#26799</a>). Also Masonry 3 (<a href=\"https://core.trac.wordpress.org/ticket/25351\">#25351</a>), PHPMailer (<a href=\"https://core.trac.wordpress.org/ticket/25560\">#25560</a>), Plupload (<a href=\"https://core.trac.wordpress.org/ticket/25663\">#25663</a>), and TinyMCE (<a href=\"https://core.trac.wordpress.org/ticket/24067\">#24067</a>).</li>\n<li>TinyMCE 4.0 is a <em>major</em> update. Please see TinyMCE&#8217;s <a href=\"http://www.tinymce.com/wiki.php/Tutorial:Migration_guide_from_3.x\">upgrade guide</a> and our <a href=\"https://core.trac.wordpress.org/ticket/24067\">implementation ticket</a> for more. If you have any questions or problems, please <a href=\"http://wordpress.org/support/forum/alphabeta\">open a thread in the support forums</a>.</li>\n</ul>\n<p>Happy testing!</p>\n<p><em><em>Lots of improvements<br />\nLittle things go a long way</em><br />\nPlease test beta one<br />\n</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"http://wordpress.org/news/2014/03/wordpress-3-9-beta-1/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:42:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"WordPress 3.8.1 Maintenance Release\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wordpress.org/news/2014/01/wordpress-3-8-1/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/news/2014/01/wordpress-3-8-1/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 23 Jan 2014 20:37:49 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3063\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:358:\"After six weeks and more than 9.3 million downloads of WordPress 3.8, we&#8217;re pleased to announce WordPress 3.8.1 is now available. Version 3.8.1 is a maintenance releases that addresses 31 bugs in 3.8, including various fixes and improvements for the new dashboard design and new themes admin screen. An issue with taxonomy queries in WP_Query [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:3809:\"<p>After six weeks and more than <a href=\"http://wordpress.org/download/counter/\">9.3 million downloads</a> of WordPress 3.8, we&#8217;re pleased to announce WordPress 3.8.1 is now available.</p>\n<p>Version 3.8.1 is a maintenance releases that addresses 31 bugs in 3.8, including various fixes and improvements for the new dashboard design and new themes admin screen. An issue with taxonomy queries in WP_Query was resolved. And if you&#8217;ve been frustrated by submit buttons that won&#8217;t do anything when you click on them (or thought you were going crazy, like some of us), we&#8217;ve found and fixed this &#8220;dead zone&#8221; on submit buttons.</p>\n<p>It also contains a fix for <strong>embedding tweets</strong> (by placing the URL to the tweet on its own line), which was broken due to a recent Twitter API change. (For more on Embeds, see <a href=\"http://codex.wordpress.org/Embeds\">the Codex</a>.)</p>\n<p>For a full list of changes, consult the <a href=\"http://core.trac.wordpress.org/query?milestone=3.8.1\">list of tickets</a> and <a href=\"https://core.trac.wordpress.org/log/branches/3.8?rev=27018&amp;stop_rev=26862\">the changelog</a>. There&#8217;s also a <a href=\"http://make.wordpress.org/core/2014/01/22/wordpress-3-8-1-release-candidate/\">detailed summary</a> for developers on the development blog.</p>\n<p>If you are one of the millions already running WordPress 3.8, we will start rolling out automatic background updates for WordPress 3.8.1 in the next few hours. For sites <a href=\"http://wordpress.org/plugins/background-update-tester/\">that support them</a>, of course.</p>\n<p><a href=\"http://wordpress.org/download/\">Download WordPress 3.8.1</a> or venture over to <strong>Dashboard → Updates</strong> and simply click &#8220;Update Now.&#8221;</p>\n<p>Thanks to all of these fine individuals for contributing to 3.8.1:</p>\n<p><a href=\"http://profiles.wordpress.org/jorbin\">Aaron Jorbin</a>, <a href=\"http://profiles.wordpress.org/collinsinternet\">Allan Collins</a>, <a href=\"http://profiles.wordpress.org/nacin\">Andrew Nacin</a>, <a href=\"http://profiles.wordpress.org/azaozz\">Andrew Ozz</a>, <a href=\"http://profiles.wordpress.org/aubreypwd\">Aubrey Portwood</a>, <a href=\"http://profiles.wordpress.org/empireoflight\">Ben Dunkle</a>, <a href=\"http://profiles.wordpress.org/cojennin\">Connor Jennings</a>, <a href=\"http://profiles.wordpress.org/dd32\">Dion Hulse</a>, <a href=\"http://profiles.wordpress.org/ocean90\">Dominik Schilling</a>, <a href=\"http://profiles.wordpress.org/fboender\">fboender</a>, <a href=\"http://profiles.wordpress.org/avryl\">Janneke Van Dorpe</a>, <a href=\"http://profiles.wordpress.org/janrenn\">janrenn</a>, <a href=\"http://profiles.wordpress.org/joedolson\">Joe Dolson</a>, <a href=\"http://profiles.wordpress.org/johnbillion\">John Blackbourn</a>, <a href=\"#\">José Pino</a>, <a href=\"http://profiles.wordpress.org/kovshenin\">Konstantin Kovshenin</a>, <a href=\"http://profiles.wordpress.org/matveb\">Matias Ventura</a>, <a href=\"http://profiles.wordpress.org/mattheu\">Matthew Haines-Young</a>, <a href=\"http://profiles.wordpress.org/iammattthomas\">Matt Thomas</a>, <a href=\"http://profiles.wordpress.org/melchoyce\">Mel Choyce</a>, <a href=\"http://profiles.wordpress.org/batmoo\">Mohammad Jangda</a>, <a href=\"http://profiles.wordpress.org/morganestes\">Morgan Estes</a>, <a href=\"http://profiles.wordpress.org/nivijah\">nivijah</a>, <a href=\"http://profiles.wordpress.org/wonderboymusic\">Scott Taylor</a>, <a href=\"http://profiles.wordpress.org/sergeybiryukov\">Sergey Biryukov</a>, <a href=\"http://profiles.wordpress.org/undergroundnetwork\">undergroundnetwork</a>, and <a href=\"http://profiles.wordpress.org/yurivictor\">Yuri Victor</a>.</p>\n<p><em>WordPress three eight one<br />\nWe heard you didn&#8217;t like bugs<br />\nSo we took them out</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2014/01/wordpress-3-8-1/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:42:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:26:\"WordPress 3.8 “Parker”\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:41:\"http://wordpress.org/news/2013/12/parker/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wordpress.org/news/2013/12/parker/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 12 Dec 2013 17:00:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2765\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:354:\"Version 3.8 of WordPress, named “Parker” in honor of Charlie Parker, bebop innovator, is available for download or update in your WordPress dashboard. We hope you&#8217;ll think this is the most beautiful update yet. Introducing a modern new design WordPress has gotten a facelift. 3.8 brings a fresh new look to the entire admin dashboard. [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:19114:\"<p>Version 3.8 of WordPress, named “Parker” in honor of <a href=\"http://en.wikipedia.org/wiki/Charlie_Parker\">Charlie Parker</a>, bebop innovator, is available <a href=\"http://wordpress.org/download/\">for download</a> or update in your WordPress dashboard. We hope you&#8217;ll think this is the most beautiful update yet.</p>\n<div id=\"v-6wORgoGb-1\" class=\"video-player\"><embed id=\"v-6wORgoGb-1-video\" src=\"http://s0.videopress.com/player.swf?v=1.03&amp;guid=6wORgoGb&amp;isDynamicSeeking=true\" type=\"application/x-shockwave-flash\" width=\"692\" height=\"388\" wmode=\"direct\" seamlesstabbing=\"true\" allowfullscreen=\"true\" allowscriptaccess=\"always\" overstretch=\"true\"></embed></div>\n<h2 class=\"aligncenter\">Introducing a modern new design</h2>\n<p><img class=\"wp-image-2951 aligncenter\" alt=\"overview\" src=\"http://i0.wp.com/wpdotorg.files.wordpress.com/2013/12/overview.jpg?resize=623%2C193\" data-recalc-dims=\"1\" /></p>\n<p>WordPress has gotten a facelift. 3.8 brings a fresh new look to the entire admin dashboard. Gone are overbearing gradients and dozens of shades of grey — bring on a bigger, bolder, more colorful design!</p>\n<p><img class=\"aligncenter  wp-image-2856\" style=\"margin-left: 0;margin-right: 0\" alt=\"about-modern-wordpress\" src=\"http://i2.wp.com/wpdotorg.files.wordpress.com/2013/12/design.png?resize=623%2C151\" data-recalc-dims=\"1\" /></p>\n<h3>Modern aesthetic</h3>\n<p>The new WordPress dashboard has a fresh, uncluttered design that embraces clarity and simplicity.</p>\n<h3>Clean typography</h3>\n<p>The Open Sans typeface provides simple, friendly text that is optimized for both desktop and mobile viewing. It’s even open source, just like WordPress.</p>\n<h3>Refined contrast</h3>\n<p>We think beautiful design should never sacrifice legibility. With superior contrast and large, comfortable type, the new design is easy to read and a pleasure to navigate.</p>\n<hr />\n<h2 class=\"aligncenter\">WordPress on every device</h2>\n<p><img class=\"alignright  wp-image-2984\" alt=\"responsive\" src=\"http://i2.wp.com/wpdotorg.files.wordpress.com/2013/12/responsive.jpg?resize=255%2C255\" data-recalc-dims=\"1\" />We all access the internet in different ways. Smartphone, tablet, notebook, desktop — no matter what you use, WordPress will adapt and you’ll feel right at home.</p>\n<h3>High definition at high speed</h3>\n<p>WordPress is sharper than ever with new vector-based icons that scale to your screen. By ditching pixels, pages load significantly faster, too.</p>\n<hr />\n<h2 class=\"aligncenter\">Admin color schemes to match your personality</h2>\n<p><img class=\"aligncenter  wp-image-2954\" alt=\"colors\" src=\"http://i0.wp.com/wpdotorg.files.wordpress.com/2013/12/colors.jpg?resize=623%2C339\" data-recalc-dims=\"1\" /></p>\n<p>WordPress just got a colorful new update. We’ve included eight new admin color schemes so you can pick the one that suits you best.</p>\n<p>Color schemes can be previewed and changed from your Profile page.</p>\n<hr />\n<h2 class=\"aligncenter\">Refined theme management</h2>\n<p><img class=\"alignright  wp-image-2967\" alt=\"themes\" src=\"http://i0.wp.com/wpdotorg.files.wordpress.com/2013/12/themes.jpg?resize=360%2C344\" data-recalc-dims=\"1\" />The new themes screen lets you survey your themes at a glance. Or want more information? Click to discover more. Then sit back and use your keyboard’s navigation arrows to flip through every theme you’ve got.</p>\n<h3>Smoother widget experience</h3>\n<p>Drag-drag-drag. Scroll-scroll-scroll. Widget management can be complicated. With the new design, we’ve worked to streamline the widgets screen.</p>\n<p>Have a large monitor? Multiple widget areas stack side-by-side to use the available space. Using a tablet? Just tap a widget to add it.</p>\n<hr />\n<h2 class=\"aligncenter\">Twenty Fourteen, a sleek new magazine theme</h2>\n<p><img class=\"aligncenter size-large wp-image-2789\" alt=\"The new Twenty Fourteen theme displayed on a laptop. tablet and phone\" src=\"http://i0.wp.com/wpdotorg.files.wordpress.com/2013/12/twentyfourteen.jpg?resize=692%2C275\" data-recalc-dims=\"1\" /></p>\n<h3>Turn your blog into a magazine</h3>\n<p>Create a beautiful magazine-style site with WordPress and Twenty Fourteen. Choose a grid or a slider to display featured content on your homepage. Customize your site with three widget areas or change your layout with two page templates.</p>\n<p>With a striking design that does not compromise our trademark simplicity, Twenty Fourteen is our most intrepid default theme yet.</p>\n<hr />\n<h2>Beginning of a new era</h2>\n<p>This release was led by Matt Mullenweg. This is our second release using the new plugin-first development process, with a much shorter timeframe than in the past. We think it’s been going great. You can check out the features currently in production on the <a title=\"Make WordPress Core\" href=\"http://make.wordpress.org/core/\" target=\"_blank\">make/core blog</a>.</p>\n<p>There are 188 contributors with props in this release:</p>\n<p><a href=\"http://profiles.wordpress.org/aaronholbrook\">Aaron Holbrook</a>, <a href=\"http://profiles.wordpress.org/jorbin\">Aaron Jorbin</a>, <a href=\"http://profiles.wordpress.org/adamsilverstein\">adamsilverstein</a>, <a href=\"http://profiles.wordpress.org/admiralthrawn\">admiralthrawn</a>, <a href=\"http://profiles.wordpress.org/ahoereth\">Alexander Hoereth</a>, <a href=\"http://profiles.wordpress.org/collinsinternet\">Allan Collins</a>, <a href=\"http://profiles.wordpress.org/sabreuse\">Amy Hendrix (sabreuse)</a>, <a href=\"http://profiles.wordpress.org/nacin\">Andrew Nacin</a>, <a href=\"http://profiles.wordpress.org/azaozz\">Andrew Ozz</a>, <a href=\"http://profiles.wordpress.org/aralbald\">Andrey Kabakchiev</a>, <a href=\"http://profiles.wordpress.org/andykeith\">Andy Keith</a>, <a href=\"http://profiles.wordpress.org/apeatling\">Andy Peatling</a>, <a href=\"http://profiles.wordpress.org/ankitgadertcampcom\">Ankit Gade</a>, <a href=\"http://profiles.wordpress.org/atimmer\">Anton Timmermans</a>, <a href=\"http://profiles.wordpress.org/fliespl\">Arkadiusz Rzadkowolski</a>, <a href=\"http://profiles.wordpress.org/aubreypwd\">Aubrey Portwood</a>, <a href=\"http://profiles.wordpress.org/bassgang\">bassgang</a>, <a href=\"http://profiles.wordpress.org/empireoflight\">Ben Dunkle</a>, <a href=\"http://profiles.wordpress.org/bananastalktome\">Billy Schneider</a>, <a href=\"http://profiles.wordpress.org/binarymoon\">binarymoon</a>, <a href=\"http://profiles.wordpress.org/bradyvercher\">Brady Vercher</a>, <a href=\"http://profiles.wordpress.org/bramd\">bramd</a>, <a href=\"http://profiles.wordpress.org/kraftbj\">Brandon Kraft</a>, <a href=\"http://profiles.wordpress.org/rzen\">Brian Richards</a>, <a href=\"http://profiles.wordpress.org/bpetty\">Bryan Petty</a>, <a href=\"http://profiles.wordpress.org/calin\">Calin Don</a>, <a href=\"http://profiles.wordpress.org/carldanley\">Carl Danley</a>, <a href=\"http://profiles.wordpress.org/sixhours\">Caroline Moore</a>, <a href=\"http://profiles.wordpress.org/caspie\">Caspie</a>, <a href=\"http://profiles.wordpress.org/chrisbliss18\">Chris Jean</a>, <a href=\"http://profiles.wordpress.org/iblamefish\">Clinton Montague</a>, <a href=\"http://profiles.wordpress.org/cojennin\">Connor Jennings</a>, <a href=\"http://profiles.wordpress.org/corphi\">Corphi</a>, <a href=\"http://profiles.wordpress.org/dbernar1\">Dan Bernardic</a>, <a href=\"http://profiles.wordpress.org/danieldudzic\">Daniel Dudzic</a>, <a href=\"http://profiles.wordpress.org/koop\">Daryl Koopersmith</a>, <a href=\"http://profiles.wordpress.org/datafeedrcom\">datafeedr</a>, <a href=\"http://profiles.wordpress.org/lessbloat\">Dave Martin</a>, <a href=\"http://profiles.wordpress.org/drw158\">Dave Whitley</a>, <a href=\"http://profiles.wordpress.org/dd32\">Dion Hulse</a>, <a href=\"http://profiles.wordpress.org/ocean90\">Dominik Schilling</a>, <a href=\"http://profiles.wordpress.org/dougwollison\">Doug Wollison</a>, <a href=\"http://profiles.wordpress.org/drewapicture\">Drew Jaynes</a>, <a href=\"http://profiles.wordpress.org/dziudek\">dziudek</a>, <a href=\"http://profiles.wordpress.org/plocha\">edik</a>, <a href=\"http://profiles.wordpress.org/ericlewis\">Eric Andrew Lewis</a>, <a href=\"http://profiles.wordpress.org/ericmann\">Eric Mann</a>, <a href=\"http://profiles.wordpress.org/ethitter\">Erick Hitter</a>, <a href=\"http://profiles.wordpress.org/evansolomon\">Evan Solomon</a>, <a href=\"http://profiles.wordpress.org/faison\">Faison</a>, <a href=\"http://profiles.wordpress.org/fboender\">fboender</a>, <a href=\"http://profiles.wordpress.org/frank-klein\">Frank Klein</a>, <a href=\"http://profiles.wordpress.org/garyj\">Gary Jones</a>, <a href=\"http://profiles.wordpress.org/pento\">Gary Pendergast</a>, <a href=\"http://profiles.wordpress.org/soulseekah\">Gennady Kovshenin</a>, <a href=\"http://profiles.wordpress.org/georgestephanis\">George Stephanis</a>, <a href=\"http://profiles.wordpress.org/gnarf37\">gnarf37</a>, <a href=\"http://profiles.wordpress.org/tivnet\">Gregory Karpinsky</a>, <a href=\"http://profiles.wordpress.org/hanni\">hanni</a>, <a href=\"http://profiles.wordpress.org/helen\">Helen Hou-Sandi</a>, <a href=\"http://profiles.wordpress.org/iandunn\">Ian Dunn</a>, <a href=\"http://profiles.wordpress.org/ipstenu\">Ipstenu (Mika Epstein)</a>, <a href=\"http://profiles.wordpress.org/isaackeyet\">Isaac Keyet</a>, <a href=\"http://profiles.wordpress.org/jdgrimes\">J.D. Grimes</a>, <a href=\"http://profiles.wordpress.org/jacklenox\">Jack Lenox</a>, <a href=\"http://profiles.wordpress.org/janhenckens\">janhenckens</a>, <a href=\"http://profiles.wordpress.org/avryl\">Janneke Van Dorpe</a>, <a href=\"http://profiles.wordpress.org/janrenn\">janrenn</a>, <a href=\"http://profiles.wordpress.org/jblz\">Jeff Bowen</a>, <a href=\"http://profiles.wordpress.org/jeffr0\">Jeff Chandler</a>, <a href=\"http://profiles.wordpress.org/jenmylo\">Jen Mylo</a>, <a href=\"http://profiles.wordpress.org/buffler\">Jeremy Buller</a>, <a href=\"http://profiles.wordpress.org/jeremyfelt\">Jeremy Felt</a>, <a href=\"http://profiles.wordpress.org/jeherve\">Jeremy Herve</a>, <a href=\"http://profiles.wordpress.org/jpry\">Jeremy Pry</a>, <a href=\"http://profiles.wordpress.org/jayjdk\">Jesper Johansen (jayjdk)</a>, <a href=\"http://profiles.wordpress.org/jhned\">jhned</a>, <a href=\"http://profiles.wordpress.org/jim912\">jim912</a>, <a href=\"http://profiles.wordpress.org/jartes\">Joan Artes</a>, <a href=\"http://profiles.wordpress.org/joedolson\">Joe Dolson</a>, <a href=\"http://profiles.wordpress.org/joen\">Joen Asmussen</a>, <a href=\"http://profiles.wordpress.org/johnbillion\">John Blackbourn</a>, <a href=\"http://profiles.wordpress.org/johnafish\">John Fish</a>, <a href=\"http://profiles.wordpress.org/johnjamesjacoby\">John James Jacoby</a>, <a href=\"http://profiles.wordpress.org/duck_\">Jon Cave</a>, <a href=\"http://profiles.wordpress.org/joostdevalk\">Joost de Valk</a>, <a href=\"http://profiles.wordpress.org/joshuaabenazer\">Joshua Abenazer</a>, <a href=\"http://profiles.wordpress.org/nukaga\">Junko Nukaga</a>, <a href=\"http://profiles.wordpress.org/devesine\">Justin de Vesine</a>, <a href=\"http://profiles.wordpress.org/justinsainton\">Justin Sainton</a>, <a href=\"http://profiles.wordpress.org/kadamwhite\">K. Adam White</a>, <a href=\"http://profiles.wordpress.org/trepmal\">Kailey (trepmal)</a>, <a href=\"http://profiles.wordpress.org/codebykat\">Kat Hagan</a>, <a href=\"http://profiles.wordpress.org/littlethingsstudio\">Kate Whitley</a>, <a href=\"http://profiles.wordpress.org/ryelle\">Kelly Dwan</a>, <a href=\"http://profiles.wordpress.org/kpdesign\">Kim Parsell</a>, <a href=\"http://profiles.wordpress.org/kwight\">Kirk Wight</a>, <a href=\"http://profiles.wordpress.org/koki4a\">Konstantin Dankov</a>, <a href=\"http://profiles.wordpress.org/kovshenin\">Konstantin Kovshenin</a>, <a href=\"http://profiles.wordpress.org/obenland\">Konstantin Obenland</a>, <a href=\"http://profiles.wordpress.org/drozdz\">Krzysiek Drozdz</a>, <a href=\"http://profiles.wordpress.org/lancewillett\">Lance Willett</a>, <a href=\"http://profiles.wordpress.org/leewillis77\">Lee Willis</a>, <a href=\"http://profiles.wordpress.org/lite3\">lite3</a>, <a href=\"http://profiles.wordpress.org/lucp\">Luc Princen</a>, <a href=\"http://profiles.wordpress.org/latz\">Lutz Schroer</a>, <a href=\"http://profiles.wordpress.org/mako09\">Mako</a>, <a href=\"http://profiles.wordpress.org/markjaquith\">Mark Jaquith</a>, <a href=\"http://profiles.wordpress.org/markmcwilliams\">Mark McWilliams</a>, <a href=\"http://profiles.wordpress.org/markoheijnen\">Marko Heijnen</a>, <a href=\"http://profiles.wordpress.org/matt\">Matt Mullenweg</a>, <a href=\"http://profiles.wordpress.org/iammattthomas\">Matt Thomas</a>, <a href=\"http://profiles.wordpress.org/mattwiebe\">Matt Wiebe</a>, <a href=\"http://profiles.wordpress.org/mdbitz\">Matthew Denton</a>, <a href=\"http://profiles.wordpress.org/mattheu\">Matthew Haines-Young</a>, <a href=\"http://profiles.wordpress.org/mattonomics\">mattonomics</a>, <a href=\"http://profiles.wordpress.org/matveb\">Matías Ventura</a>, <a href=\"http://profiles.wordpress.org/megane9988\">megane9988</a>, <a href=\"http://profiles.wordpress.org/melchoyce\">Mel Choyce</a>, <a href=\"http://profiles.wordpress.org/micahwave\">micahwave</a>, <a href=\"http://profiles.wordpress.org/cainm\">Michael Cain</a>, <a href=\"http://profiles.wordpress.org/mitchoyoshitaka\">Michael Erlewine</a>, <a href=\"http://profiles.wordpress.org/michelwppi\">Michel - xiligroup dev</a>, <a href=\"http://profiles.wordpress.org/chellycat\">Michelle Langston</a>, <a href=\"http://profiles.wordpress.org/gradyetc\">Mike Burns</a>, <a href=\"http://profiles.wordpress.org/mikehansenme\">Mike Hansen</a>, <a href=\"http://profiles.wordpress.org/mikelittle\">Mike Little</a>, <a href=\"http://profiles.wordpress.org/dh-shredder\">Mike Schroder</a>, <a href=\"http://profiles.wordpress.org/dimadin\">Milan Dinic</a>, <a href=\"http://profiles.wordpress.org/batmoo\">Mohammad Jangda</a>, <a href=\"http://profiles.wordpress.org/morganestes\">Morgan Estes</a>, <a href=\"http://profiles.wordpress.org/mt8biz\">moto hachi</a>, <a href=\"http://profiles.wordpress.org/Nao\">Naoko Takano</a>, <a href=\"http://profiles.wordpress.org/neil_pie\">Neil Pie</a>, <a href=\"http://profiles.wordpress.org/nickdaugherty\">Nick Daugherty</a>, <a href=\"http://profiles.wordpress.org/celloexpressions\">Nick Halsey</a>, <a href=\"http://profiles.wordpress.org/nbachiyski\">Nikolay Bachiyski</a>, <a href=\"http://profiles.wordpress.org/ninio\">ninio</a>, <a href=\"http://profiles.wordpress.org/ninnypants\">ninnypants</a>, <a href=\"http://profiles.wordpress.org/nivijah\">nivijah</a>, <a href=\"http://profiles.wordpress.org/nofearinc\">nofearinc</a>, <a href=\"http://profiles.wordpress.org/nvwd\">Nowell VanHoesen</a>, <a href=\"http://profiles.wordpress.org/odysseygate\">odyssey</a>, <a href=\"http://profiles.wordpress.org/originalexe\">OriginalEXE</a>, <a href=\"http://profiles.wordpress.org/swissspidy\">Pascal Birchler</a>, <a href=\"http://profiles.wordpress.org/pauldewouters\">Paul de Wouters</a>, <a href=\"http://profiles.wordpress.org/pavelevap\">pavelevap</a>, <a href=\"http://profiles.wordpress.org/westi\">Peter Westwood</a>, <a href=\"http://profiles.wordpress.org/senlin\">Piet</a>, <a href=\"http://profiles.wordpress.org/ptahdunbar\">Ptah Dunbar</a>, <a href=\"http://profiles.wordpress.org/raamdev\">Raam Dev</a>, <a href=\"http://profiles.wordpress.org/bamadesigner\">Rachel Carden</a>, <a href=\"http://profiles.wordpress.org/rachelbaker\">rachelbaker</a>, <a href=\"http://profiles.wordpress.org/radices\">Radices</a>, <a href=\"http://profiles.wordpress.org/mauryaratan\">Ram Ratan Maurya</a>, <a href=\"http://profiles.wordpress.org/defries\">Remkus de Vries</a>, <a href=\"http://profiles.wordpress.org/ounziw\">Rescuework Support</a>, <a href=\"http://profiles.wordpress.org/rickalee\">Ricky Lee Whittemore</a>, <a href=\"http://profiles.wordpress.org/rdall\">Robert Dall</a>, <a href=\"http://profiles.wordpress.org/wet\">Robert Wetzlmayr, PHP-Programmierer</a>, <a href=\"http://profiles.wordpress.org/rodrigosprimo\">Rodrigo Primo</a>, <a href=\"http://profiles.wordpress.org/ryan\">Ryan Boren</a>, <a href=\"http://profiles.wordpress.org/otto42\">Samuel Wood</a>, <a href=\"http://profiles.wordpress.org/sanchothefat\">sanchothefat</a>, <a href=\"http://profiles.wordpress.org/sboisvert\">sboisvert</a>, <a href=\"http://profiles.wordpress.org/scottbasgaard\">Scott Basgaard</a>, <a href=\"http://profiles.wordpress.org/coffee2code\">Scott Reilly</a>, <a href=\"http://profiles.wordpress.org/wonderboymusic\">Scott Taylor</a>, <a href=\"http://profiles.wordpress.org/scribu\">scribu</a>, <a href=\"http://profiles.wordpress.org/seanchayes\">Sean Hayes</a>, <a href=\"http://profiles.wordpress.org/sergeybiryukov\">Sergey Biryukov</a>, <a href=\"http://profiles.wordpress.org/shaunandrews\">Shaun Andrews</a>, <a href=\"http://profiles.wordpress.org/designsimply\">Sheri Bigelow (designsimply)</a>, <a href=\"http://profiles.wordpress.org/shinichin\">ShinichiN</a>, <a href=\"http://profiles.wordpress.org/simonwheatley\">Simon Wheatley</a>, <a href=\"http://profiles.wordpress.org/siobhan\">Siobhan</a>, <a href=\"http://profiles.wordpress.org/siobhyb\">Siobhan Bamber (siobhyb)</a>, <a href=\"http://profiles.wordpress.org/sirbrillig\">sirbrillig</a>, <a href=\"http://profiles.wordpress.org/solarissmoke\">solarissmoke</a>, <a href=\"http://profiles.wordpress.org/netweb\">Stephen Edgar</a>, <a href=\"http://profiles.wordpress.org/stephenharris\">Stephen Harris</a>, <a href=\"http://profiles.wordpress.org/stevenkword\">Steven Word</a>, <a href=\"http://profiles.wordpress.org/iamtakashi\">Takashi Irie</a>, <a href=\"http://profiles.wordpress.org/miyauchi\">Takayuki Miyauchi</a>, <a href=\"http://profiles.wordpress.org/tmtoy\">Takuma Morikawa</a>, <a href=\"http://profiles.wordpress.org/tellyworth\">tellyworth</a>, <a href=\"http://profiles.wordpress.org/thomasguillot\">Thomas Guillot</a>, <a href=\"http://profiles.wordpress.org/tierra\">tierra</a>, <a href=\"http://profiles.wordpress.org/tillkruess\">Till Krüss</a>, <a href=\"http://profiles.wordpress.org/tlamedia\">TLA Media</a>, <a href=\"http://profiles.wordpress.org/tobiasbg\">TobiasBg</a>, <a href=\"http://profiles.wordpress.org/tomdxw\">tomdxw</a>, <a href=\"http://profiles.wordpress.org/tommcfarlin\">tommcfarlin</a>, <a href=\"http://profiles.wordpress.org/zodiac1978\">Torsten Landsiedel</a>, <a href=\"http://profiles.wordpress.org/taupecat\">Tracy Rotton</a>, <a href=\"http://profiles.wordpress.org/trishasalas\">trishasalas</a>, <a href=\"http://profiles.wordpress.org/mbmufffin\">Tyler Smith</a>, <a href=\"http://profiles.wordpress.org/grapplerulrich\">Ulrich</a>, <a href=\"http://profiles.wordpress.org/undergroundnetwork\">undergroundnetwork</a>, <a href=\"http://profiles.wordpress.org/l10n\">Vladimir</a>, <a href=\"http://profiles.wordpress.org/westonruter\">Weston Ruter</a>, <a href=\"http://profiles.wordpress.org/yoavf\">Yoav Farhi</a>, <a href=\"http://profiles.wordpress.org/yonasy\">yonasy</a>, <a href=\"http://profiles.wordpress.org/yurivictor\">Yuri Victor</a>, and <a href=\"http://profiles.wordpress.org/tollmanz\">Zack Tollman</a>. Also thanks to <a href=\"http://benmorrison.org/\">Ben Morrison</a> and <a href=\"http://christineswebb.com/\">Christine Webb</a> for help with the video.</p>\n<p>Thanks for choosing WordPress. See you soon for version 3.9!</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:46:\"http://wordpress.org/news/2013/12/parker/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:31:\"http://wordpress.org/news/feed/\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:44:\"http://purl.org/rss/1.0/modules/syndication/\";a:2:{s:12:\"updatePeriod\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"hourly\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:15:\"updateFrequency\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:8:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Tue, 22 Apr 2014 13:03:57 GMT\";s:12:\"content-type\";s:23:\"text/xml; charset=UTF-8\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:10:\"x-pingback\";s:36:\"http://wordpress.org/news/xmlrpc.php\";s:13:\"last-modified\";s:29:\"Thu, 17 Apr 2014 01:07:32 GMT\";s:4:\"x-nc\";s:11:\"HIT lax 249\";}s:5:\"build\";s:14:\"20140417204711\";}", "no");
INSERT INTO `wp_options` VALUES("326", "_transient_timeout_feed_mod_ac0b00fe65abe10e0c5b588f3ed8c7ca", "1398215038", "no");
INSERT INTO `wp_options` VALUES("327", "_transient_feed_mod_ac0b00fe65abe10e0c5b588f3ed8c7ca", "1398171838", "no");
INSERT INTO `wp_options` VALUES("328", "_transient_timeout_feed_867bd5c64f85878d03a060509cd2f92c", "1398215038", "no");
INSERT INTO `wp_options` VALUES("329", "_transient_feed_867bd5c64f85878d03a060509cd2f92c", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:61:\"\n	\n	\n	\n	\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"WordPress Planet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://planet.wordpress.org/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:2:\"en\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"WordPress Planet - http://planet.wordpress.org/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:50:{i:0;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:90:\"WPTavern: How The Advanced Image Editing Properties Contributed To WordPress Theme Lock-in\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=21488\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:224:\"http://wptavern.com/how-the-advanced-image-editing-properties-contributed-to-wordpress-theme-lock-in?utm_source=rss&utm_medium=rss&utm_campaign=how-the-advanced-image-editing-properties-contributed-to-wordpress-theme-lock-in\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6232:\"<p>Although <a title=\"http://wptavern.com/wordpress-3-9-smith-released\" href=\"http://wptavern.com/wordpress-3-9-smith-released\">WordPress 3.9</a> has refined the media editing experience, it did so at the cost of removing a feature users appreciated. In WordPress 3.8, users could easily add a border, vertical, and horizontal padding to images. WordPress 3.9 removed this from the advanced image settings screen.</p>\n<p>It’s not just those who use the self-hosted version of WordPress <a title=\"http://wordpress.org/support/topic/major-problems-with-image-editing-in-wp-39?replies=12\" href=\"http://wordpress.org/support/topic/major-problems-with-image-editing-in-wp-39?replies=12\">that are upset with the change</a>. A WordPress.com <a title=\"http://en.forums.wordpress.com/topic/image-resize-1?replies=430\" href=\"http://en.forums.wordpress.com/topic/image-resize-1?replies=430\">support forum thread</a> with over 430 posts is filled with users asking why the feature was removed. In some cases, WordPress.com staff are explaining how to use HTML code to add or remove borders to images.</p>\n<p>Thankfully, there&#8217;s a new plugin available that not only restores the original advanced image settings but has expanded upon them. The plugin is called <a title=\"http://wordpress.org/plugins/advanced-image-styles/\" href=\"http://wordpress.org/plugins/advanced-image-styles/\">Advanced Image Styles</a> and is maintained by <a title=\"http://profiles.wordpress.org/gcorne/\" href=\"http://profiles.wordpress.org/gcorne/\">Gregory Cornelius</a>. As you can see, users can now apply padding in all four directions instead of two. You can also apply a border color instead of just the border width.</p>\n<div id=\"attachment_21489\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/04/AdvancedImageEditingOptions.png\" rel=\"prettyphoto[21488]\"><img class=\"size-full wp-image-21489\" src=\"http://wptavern.com/wp-content/uploads/2014/04/AdvancedImageEditingOptions.png\" alt=\"Advanced Image Editing Styles\" width=\"840\" height=\"401\" /></a><p class=\"wp-caption-text\">Advanced Image Styles</p></div>\n<p><a title=\"http://wordpress.org/support/view/plugin-reviews/advanced-image-styles\" href=\"http://wordpress.org/support/view/plugin-reviews/advanced-image-styles\">Early reviews</a> indicate users are happy to see these options return despite having to use a plugin. Unfortunately, those on WordPress.com are still out of luck. A member of the WordPress.com staff says <a title=\"http://en.forums.wordpress.com/topic/image-resize-1/page/15?replies=430#post-1754610\" href=\"http://en.forums.wordpress.com/topic/image-resize-1/page/15?replies=430#post-1754610\">it&#8217;s possible</a> the plugin will be merged into the WordPress.com codebase.</p>\n<blockquote><p>I have asked the developers if this will be merged. At the moment I have not heard back. I will let you know as soon as possible!</p></blockquote>\n<h3>These Options Are Causing Theme Lock-in</h3>\n<p>If themes are coded to properly handle image padding and borders, the options within WordPress are redundant and unnecessary. What&#8217;s troubling is users are utilizing these options to override the styling within the theme instead of changing its CSS stylesheet.</p>\n<p>In a test on my local server, I used the advanced image editing options to add a black, four pixel border to an image within the media library. Then I switched themes to see if the border was still there. I discovered that settings applied to images via the WordPress image editing options are displayed no matter which theme is used.</p>\n<div id=\"attachment_21520\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/04/OldTavernDesign.png\" rel=\"prettyphoto[21488]\"><img class=\"size-full wp-image-21520\" src=\"http://wptavern.com/wp-content/uploads/2014/04/OldTavernDesign.png\" alt=\"Old Tavern Design With The Black Image Border\" width=\"605\" height=\"339\" /></a><p class=\"wp-caption-text\">Old Tavern Design With The Black Image Border</p></div>\n<div id=\"attachment_21519\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/04/NewTavernDesign.png\" rel=\"prettyphoto[21488]\"><img class=\"size-full wp-image-21519\" src=\"http://wptavern.com/wp-content/uploads/2014/04/NewTavernDesign.png\" alt=\"New Tavern Design With The Black Image Border\" width=\"665\" height=\"387\" /></a><p class=\"wp-caption-text\">New Tavern Design With The Black Image Border</p></div>\n<p>If a user switches to a theme that uses a color scheme not compatible with the image border color, each image has to be edited individually within the media library. Each time an image is edited using the advanced settings provided by WordPress, you lose more theme compatibility and it further locks you in to a specific theme.</p>\n<h3>WordPress.com vs. Self-hosted WordPress</h3>\n<div id=\"attachment_21515\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/04/WPcomWporg.png\" rel=\"prettyphoto[21488]\"><img class=\"wp-image-21515 size-full\" src=\"http://wptavern.com/wp-content/uploads/2014/04/WPcomWporg.png\" alt=\"WPcomWporg\" width=\"738\" height=\"296\" /></a><p class=\"wp-caption-text\">WordPress.com and WordPress.org</p></div>\n<p>I understand why WordPress.com users would be so upset with the removal of these options. By default, they don&#8217;t have the ability to edit their theme&#8217;s CSS file. That is reserved as a paid upgrade. So these options give them a chance to override the styling within the theme without having the paid upgrade.</p>\n<p>For self-hosted WordPress users, there is no excuse. Image borders and padding should be controlled through the theme, not the advanced image editing options provided by WordPress. Despite the options making it easy to apply those changes to images, users are only hurting themselves by using them.</p>\n<p>I think the options for padding and image borders should stay removed from the self-hosted version of WordPress while restored on WordPress.com. In retrospect, these options should have never existed in the first place.</p>\n<p><strong>Do you think the image border width, color, and padding options should be restored to the self-hosted version of WordPress?</strong></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 22 Apr 2014 01:37:16 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"Mike Little: WordPress 10th Anniversary: a Reflection\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"http://journalized.zed1.com/?p=1929\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:171:\"http://journalized.zed1.com/archives/2013/05/27/wordpress-10th-anniversary-a-reflection/?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-10th-anniversary-a-reflection\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:468:\"<p>I posted about <a href=\"http://mikelittle.org/wordpress-10th-anniversary/\">WordPress&#8217; 10th Anniversary</a> celebration and reflected on the last 10 years over on my new blog</p>\n<p>The post <a rel=\"nofollow\" href=\"http://journalized.zed1.com/archives/2013/05/27/wordpress-10th-anniversary-a-reflection/\">WordPress 10th Anniversary: a Reflection</a> appeared first on <a rel=\"nofollow\" href=\"http://journalized.zed1.com\">Mike Little&#039;s Journalized</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 Apr 2014 23:00:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Mike Little\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"Mike Little: WordPress – A 10 year journey\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"http://journalized.zed1.com/?p=1867\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:147:\"http://journalized.zed1.com/archives/2013/01/25/wordpress-a-10-year-journey/?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-a-10-year-journey\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2530:\"<p><a href=\"http://journalized.zed1.com/wp-content/uploads/2013/01/wordpress-logo-notext-rgb.png\"><img class=\"size-thumbnail wp-image-1873 alignleft\" alt=\"WordPress logo\" src=\"http://journalized.zed1.com/wp-content/uploads/2013/01/wordpress-logo-notext-rgb-150x150.png\" width=\"150\" height=\"150\" /></a></p>\n<p>I find it hard to believe but it has now been <strong>ten years</strong> since my fateful <a href=\"http://ma.tt/2003/01/the-blogging-software-dilemma/#comment-445\">comment on Matt&#8217;s blog </a>that kicked off what became the <a href=\"http://wordpress.org/\">WordPress</a> project!<br />\nFrom those humble beginnings of a simple unmaintained blogging platform (b2/Cafelog) to a world-beating open source CMS. B2/Cafelog was used by perhaps 2,000 bloggers. Now WordPress runs more than <a href=\"http://en.wordpress.com/stats/\">60 million sites</a> around the world. That&#8217;s over <a href=\"http://w3techs.com/technologies/overview/content_management/all\">17.5% of the web</a>!</p>\n<h2>WordPress Industry</h2>\n<p>WordPress now supports a world-wide industry from individual <a href=\"http://mikelittle.org/\">WordPress specialists</a> like me (I&#8217;ve just completed my fourth year as my own company <a href=\"http://zed1.com/\">zed1.com</a>); small WordPress-based companies like <a href=\"http://codeforthepeople.com/\">Code for the People</a>; through to multi-million dollar companies like <a href=\"http://www.copyblogger.com/\">Copyblogger</a>, <a href=\"http://www.woothemes.com/\">WooThemes</a>, and of course <a href=\"http://automattic.com/\">Automattic</a>.</p>\n<p>Praise must go as usual to the <a href=\"http://make.wordpress.org/\">fantastic community</a> around WordPress, the singular vision of <a href=\"http://ma.tt/\">Matt Mullenweg</a>, and the awesome power of the <a title=\"GNU General Public License\" href=\"http://www.gnu.org/licenses/gpl.html\">GNU GPL</a> open source license.</p>\n<h2>Here&#8217;s to the next year</h2>\n<p>As WordPress enters it&#8217;s <strong>eleventh</strong> year, with version 3.5.1 recently released and <a href=\"http://make.wordpress.org/core/\">version 3.6 currently in the making</a>, I predict it will be another great year for <a title=\"Personal Publishing Platform\" href=\"http://wordpress.org\">WordPress</a>.</p>\n<p>The post <a rel=\"nofollow\" href=\"http://journalized.zed1.com/archives/2013/01/25/wordpress-a-10-year-journey/\">WordPress &#8211; A 10 year journey</a> appeared first on <a rel=\"nofollow\" href=\"http://journalized.zed1.com\">Mike Little&#039;s Journalized</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 Apr 2014 23:00:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Mike Little\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"Mike Little: WordCamp Edinburgh UK 2012\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"http://journalized.zed1.com/?p=1856\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:145:\"http://journalized.zed1.com/archives/2012/05/29/wordcamp-edinburgh-uk-2012/?utm_source=rss&utm_medium=rss&utm_campaign=wordcamp-edinburgh-uk-2012\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1650:\"<p><a href=\"http://journalized.zed1.com/wp-content/uploads/2012/05/wordcamp-edinburgh-header-1.png\"><img class=\"aligncenter size-full wp-image-1857\" title=\"wordcamp-edinburgh-header-1\" src=\"http://journalized.zed1.com/wp-content/uploads/2012/05/wordcamp-edinburgh-header-1.png\" alt=\"\" width=\"855\" height=\"330\" /></a></p>\n<p>Folks, if you are looking to attend WordCamp Edinburgh UK 2012, on the weekend of the 14th and 15th of July, you need to get your <a href=\"http://2012.edinburgh.wordcamp.org/tickets/\">tickets</a> pretty soon to qualify for the early bird price (£35).</p>\n<p>After midday this coming Friday (June 1st) the price will rise to £45. Mind you, that&#8217;s still a fantastic price for a <a href=\"http://2012.edinburgh.wordcamp.org/\"><strong>two-day weekend</strong> filled with WordPressy goodness</a> .</p>\n<p>I&#8217;ll be there of course, will you? It&#8217;s looking like a cracker with some <a href=\"http://wiki.wpuk.org/2012_content_ideas\">great ideas for sessions already put forward</a>. I&#8217;ll be running an extended session called <a href=\"http://2012.edinburgh.wordcamp.org/session/starting-out-with-wordpress/\">Starting Out with WordPress</a>. Once again, get your <a href=\"http://2012.edinburgh.wordcamp.org/tickets/\">tickets</a> soon.</p>\n<p>I look forward to seeing you there.</p>\n<p><a href=\"http://wpuk.org/\">WPUK</a> is organising this event.</p>\n<p>The post <a rel=\"nofollow\" href=\"http://journalized.zed1.com/archives/2012/05/29/wordcamp-edinburgh-uk-2012/\">WordCamp Edinburgh UK 2012</a> appeared first on <a rel=\"nofollow\" href=\"http://journalized.zed1.com\">Mike Little&#039;s Journalized</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 Apr 2014 23:00:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Mike Little\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"Mike Little: WordPress is Nine. Happy Birthday WordPress!\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"http://journalized.zed1.com/?p=1852\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:177:\"http://journalized.zed1.com/archives/2012/05/27/wordpress-is-nine-happy-birthday-wordpress/?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-is-nine-happy-birthday-wordpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1387:\"<p>Today is the ninth birthday of WordPress (the anniversary of the <a href=\"http://wordpress.org/news/2003/05/wordpress-now-available/\">first release</a>).</p>\n<p>WordPress still continues to astonish me in its phenomenal growth. Comparing to <a href=\"http://journalized.zed1.com/archives/2011/05/27/wordpress-eighth-birthday/\">this time last year</a>, WordPress now powers <a href=\"http://en.wordpress.com/stats/\">more than 74 million sites</a>, accounting for <a href=\"http://w3techs.com/technologies/overview/content_management/all\">more than 16% of the internet</a>.</p>\n<div>I&#8217;m looking forward to the next year in the world of WordPress. As usual there are lots of exciting things ahead. The first <a href=\"http://wpappstore.com/\">WordPress App Store</a> launched recently, and I&#8217;m sure there will be more (it looks like <a href=\"http://z1.tl/wpmudevdashboard\">WPMU Dev&#8217;s updater/dashboard</a> now lets you buy).</div>\n<div></div>\n<div>WordPress is really maturing and as a platform and as an industry. There is much more to come and I can&#8217;t wait.</div>\n<div></div>\n<p>The post <a rel=\"nofollow\" href=\"http://journalized.zed1.com/archives/2012/05/27/wordpress-is-nine-happy-birthday-wordpress/\">WordPress is Nine. Happy Birthday WordPress!</a> appeared first on <a rel=\"nofollow\" href=\"http://journalized.zed1.com\">Mike Little&#039;s Journalized</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 Apr 2014 23:00:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Mike Little\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:46:\"Mike Little: WordPress 3 for Business Bloggers\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"http://journalized.zed1.com/?p=1847\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:159:\"http://journalized.zed1.com/archives/2012/03/11/wordpress-3-for-business-bloggers/?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-3-for-business-bloggers\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1071:\"<p>I&#8217;m currently reading <a href=\"http://www.packtpub.com/wordpress-3-for-business-bloggers/book\">WordPress 3 for Business Bloggers</a><a href=\"http://www.packtpub.com/wordpress-3-for-business-bloggers/book\"><img class=\"alignright\" title=\"WordPress 3 for Business Bloggers\" src=\"https://www.packtpub.com/sites/default/files/imagecache/productview/1322OS_WordPress%203%20for%20Business%20Bloggers_Frontcover.jpg\" alt=\"\" width=\"124\" height=\"152\" /></a> by Paul Thewlis. I&#8217;m trying to squeeze it in between all the other stuff I seem to have on my plate. I read the first edition of the book a couple of years ago (though I can&#8217;t find my review to point to); so I&#8217;m looking forward to this one.</p>\n<p>I&#8217;ll post a proper review when I&#8217;ve finished it.</p>\n<p>&nbsp;</p>\n<p>The post <a rel=\"nofollow\" href=\"http://journalized.zed1.com/archives/2012/03/11/wordpress-3-for-business-bloggers/\">WordPress 3 for Business Bloggers</a> appeared first on <a rel=\"nofollow\" href=\"http://journalized.zed1.com\">Mike Little&#039;s Journalized</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 Apr 2014 23:00:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Mike Little\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"Mike Little: WordPress – 9 years since it’s conception\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"http://journalized.zed1.com/?p=1836\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:169:\"http://journalized.zed1.com/archives/2012/01/25/wordpress-9-years-since-its-conception/?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-9-years-since-its-conception\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2138:\"<p>Simon D <a title=\"Simon\'s tweet\" href=\"https://twitter.com/#!/simond/status/162125708506832896\">reminded me</a> that it is now nine years since my fateful <a href=\"http://ma.tt/2003/01/the-blogging-software-dilemma/#comment-445\">comment on Matt&#8217;s blog </a>that kicked off this whole WordPress thing!</p>\n<blockquote class=\"twitter-tweet\" width=\"550\"><p>Nine years ago today @<a href=\"https://twitter.com/mikelittlezed1\">mikelittlezed1</a> floated an idea which eventually became WordPress. <a href=\"https://twitter.com/search/%23thanksmike\">#thanksmike</a> <a href=\"http://t.co/teYbVHX8\" title=\"http://ma.tt/2003/01/the-blogging-software-dilemma/\">ma.tt/2003/01/the-bl…</a></p>\n<p>&mdash; Simon Dickson (@simond) <a href=\"https://twitter.com/simond/status/162125708506832896\">January 25, 2012</a></p></blockquote>\n<p></p>\n<p>WordPress is really shaping up, and is an evermore stable and functional CMS platform. The statistics continue to astonish me, with more than <a href=\"http://en.wordpress.com/stats/\">70 million sites</a> around the world. That&#8217;s nearly <a href=\"http://w3techs.com/technologies/overview/content_management/all\">16% of the web</a>!</p>\n<p>WordPress is supporting a whole industry of WordPress experts, including me: I&#8217;m just starting my fourth year as an <a href=\"http://zed1.com/\">independent WordPress specialist</a>.</p>\n<p>Praise must go as usual to the fantastic community around WordPress, the singular vision of <a href=\"http://ma.tt/\">Matt Mullenweg</a>, and the awesome power of the <a title=\"GNU General Public License\" href=\"http://www.gnu.org/licenses/gpl.html\">GNU GPL</a> open source license.</p>\n<p>With version 3.4 currently in the making, I predict it will be another great year for <a title=\"Personal Publishing Platform\" href=\"http://wordpress.org\">WordPress</a>.</p>\n<p>The post <a rel=\"nofollow\" href=\"http://journalized.zed1.com/archives/2012/01/25/wordpress-9-years-since-its-conception/\">WordPress &#8211; 9 years since it&#8217;s conception</a> appeared first on <a rel=\"nofollow\" href=\"http://journalized.zed1.com\">Mike Little&#039;s Journalized</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 Apr 2014 23:00:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Mike Little\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:41:\"Mike Little: WordPress’ Eighth Birthday\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"http://journalized.zed1.com/?p=1813\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:143:\"http://journalized.zed1.com/archives/2011/05/27/wordpress-eighth-birthday/?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-eighth-birthday\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1737:\"<p>Today is WordPress&#8217; official eighth birthday (the anniversary of the <a href=\"http://wordpress.org/news/2003/05/wordpress-now-available/\">first release</a>).</p>\n<p>I still marvel at the incredible distance it has come. I&#8217;m also still proud that I had a part in its birth. But even more, I marvel at the wonderful contribution of all the WordPress community make to this fantastic project.</p>\n<p>A client said to me this morning &#8220;This WordPress is brilliant isn&#8217;t it?&#8221; As I helped him set up his fourth WordPress site. You can&#8217;t get much clearer praise than that.</p>\n<p>So raise a virtual beer (or other non-alcoholic beverage if, like me, you are teetotal) to WordPress, the community, and to another year.</p>\n<p><strong>Update:</strong> I just spotted this tweet from <a href=\"http://twitter.com/#!/nacin\">Andrew Nacin</a>:</p>\n<blockquote class=\"twitter-tweet\" width=\"550\"><p>At more than 20 million WordPress.com blogs, that puts WordPress at north of 45 million sites. Wowza. Happy birthday indeed.</p>\n<p>&mdash; Andrew Nacin (@nacin) <a href=\"https://twitter.com/nacin/status/74139775761793024\">May 27, 2011</a></p></blockquote>\n<p></p>\n<p>Wow! 25 million <a href=\"http://wordpress.org/\">standalone WordPress</a> sites plus 20 million <a href=\"http://WordPress.com\">WordPress.com</a> sites! No wonder it <a href=\"http://w3techs.com/technologies/overview/content_management/all\">powers more than 14 percent of the web</a>.</p>\n<p>The post <a rel=\"nofollow\" href=\"http://journalized.zed1.com/archives/2011/05/27/wordpress-eighth-birthday/\">WordPress&#8217; Eighth Birthday</a> appeared first on <a rel=\"nofollow\" href=\"http://journalized.zed1.com\">Mike Little&#039;s Journalized</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 Apr 2014 23:00:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Mike Little\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"Mike Little: WordPress – 8 Years in the making\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"http://journalized.zed1.com/?p=1748\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:155:\"http://journalized.zed1.com/archives/2011/01/27/wordpress-8-years-in-the-making/?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-8-years-in-the-making\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2038:\"<p>Wow! Another year has passed and it is now eight years since my fateful <a href=\"http://ma.tt/2003/01/the-blogging-software-dilemma/#comment-445\">comment on Matt&#8217;s blog </a>that kicked off this whole WordPress thing!</p>\n<p>WordPress is now a mature CMS platform driving <a href=\"http://w3techs.com/technologies/overview/content_management/all\">13% of the web</a>! It is used for an <a href=\"http://wordpress.org/showcase/\">astonishing array</a> of very different web sites around the world, from the humblest one person blog to <a title=\"I\'m a Scientist, Get me out of here!\" href=\"http://imascientist.org.uk/\">award-winning education sites</a>, <a title=\"The New Adventures of Stephen Fry\" href=\"http://www.stephenfry.com/\">celebrity sites</a>, <a title=\"The New York Times blogs\" href=\"http://www.nytimes.com/interactive/blogs/directory.html\">newspapers</a>, and even <a title=\"The official site of the Prime Minister\'s Office\" href=\"http://www.number10.gov.uk\">world leaders</a>!</p>\n<p>WordPress is supporting a whole industry of <a title=\"WordPress consultants\" href=\"http://codepoet.com/\">WordPress experts</a>, including me: I&#8217;m now in my third year as an <a href=\"http://zed1.com/\">independent WordPress specialist</a>.</p>\n<p>I believe that WordPress has achieved this massive success in no small way because of the fantastic community around it, the keen-eyed vision of <a href=\"http://ma.tt/\">Matt Mullenweg</a>, and the awesome power of the <a title=\"GNU General Public License\" href=\"http://www.gnu.org/licenses/gpl.html\">GNU GPL</a> open source license.</p>\n<p>With version 3.1 just around the corner, I predict it will be another great year for <a title=\"Personal Publishing Platform\" href=\"http://wordpress.org\">WordPress</a>.</p>\n<p>The post <a rel=\"nofollow\" href=\"http://journalized.zed1.com/archives/2011/01/27/wordpress-8-years-in-the-making/\">WordPress &#8211; 8 Years in the making</a> appeared first on <a rel=\"nofollow\" href=\"http://journalized.zed1.com\">Mike Little&#039;s Journalized</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 Apr 2014 23:00:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Mike Little\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"Mike Little: WordCamp slides featured on Slideshare\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"http://journalized.zed1.com/?p=1523\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:169:\"http://journalized.zed1.com/archives/2010/07/21/wordcamp-slides-featured-on-slideshare/?utm_source=rss&utm_medium=rss&utm_campaign=wordcamp-slides-featured-on-slideshare\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1285:\"<p>The slides from <a href=\"http://www.slideshare.net/mikelittle/wordcamp-2010-im-a-scientist-get-me-out-of-here-mike-little\">my presentation at WordCamp UK</a> in Manchester over the weekend are now on SlideShare. I presented on the fantastic <a href=\"http://imascientist.org.uk/\">I&#8217;m a Scientist Get me Out of Here</a> project website I have built for <a href=\"http://www.gallomanor.com/\">Gallomanor</a> this year.</p>\n<p>It&#8217;s best to read the notes in the &#8220;Notes on slide x&#8221; tab so that everything makes sense! I also link to some of the plugins I used at the end.</p>\n<p>Amazingly, the presentation features on the <a href=\"http://www.slideshare.net/\">SlideShare home page</a> today along with a couple of other presentations from <a href=\"http://uk.wordcamp.org/\">WordCamp UK</a>! See the &#8220;featured&#8221; section in the right hand column. Woo Hoo!</p>\n<p>I have still to finish my write-up of the weekend, but will hopefully get that done &#8216;real soon&#8217;.</p>\n<p>The post <a rel=\"nofollow\" href=\"http://journalized.zed1.com/archives/2010/07/21/wordcamp-slides-featured-on-slideshare/\">WordCamp slides featured on Slideshare</a> appeared first on <a rel=\"nofollow\" href=\"http://journalized.zed1.com\">Mike Little&#039;s Journalized</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 Apr 2014 23:00:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Mike Little\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:42:\"Mike Little: WordCamp UK A Few Places Left\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"http://journalized.zed1.com/?p=1519\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:153:\"http://journalized.zed1.com/archives/2010/07/15/wordcamp-uk-a-few-tickets-left/?utm_source=rss&utm_medium=rss&utm_campaign=wordcamp-uk-a-few-tickets-left\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1313:\"<p>For those of you thinking you may have missed out on this coming weekend&#8217;s WordPress fun at <a href=\"http://uk.wordcamp.org/\">WordCamp UK</a> in Manchester, think again!</p>\n<p>As the tickets did not completely sell out, we are making the last few available on the door, as we did last year.</p>\n<p>You must email me (mike at my domain ) to reserve a ticket, and then turn up on Saturday morning with your £30 cash.</p>\n<p>To recap, WordCamp UK is this weekend, July 17th and 18th, at the <a href=\"http://www.business.mmu.ac.uk/\">Manchester Metropolitan University Business School</a> which is in Manchester city centre, a few minutes walk from the main Piccadilly train Station.</p>\n<p>There are <a href=\"http://wiki.wordcampuk.tonyscott.org.uk/2010_running_order\">four simultaneous tracks</a> : General &amp; user, Specialist &amp; developer, Miscellaneous &amp; spontaneous and a &#8216;Genius Bar&#8217; (a range of WordPress experts available to advice attendees on a one-to-one basis).</p>\n<p>I look forward to seeing you there.</p>\n<p>The post <a rel=\"nofollow\" href=\"http://journalized.zed1.com/archives/2010/07/15/wordcamp-uk-a-few-tickets-left/\">WordCamp UK A Few Places Left</a> appeared first on <a rel=\"nofollow\" href=\"http://journalized.zed1.com\">Mike Little&#039;s Journalized</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 Apr 2014 23:00:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Mike Little\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"WPTavern: WordPress Projects Announced for Google Summer of Code 2014\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=21492\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:182:\"http://wptavern.com/wordpress-projects-announced-for-google-summer-of-code-2014?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-projects-announced-for-google-summer-of-code-2014\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2573:\"<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/gsoc2014.png\" rel=\"prettyphoto[21492]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/gsoc2014.png\" alt=\"gsoc2014\" width=\"924\" height=\"156\" class=\"aligncenter size-full wp-image-21501\" /></a></p>\n<p>Earlier this year, WordPress was <a href=\"http://wptavern.com/wordpress-accepted-as-a-mentoring-organization-for-google-summer-of-code-2014\" target=\"_blank\">accepted</a> as one of 190 mentoring organizations for <a href=\"http://www.google-melange.com/gsoc/homepage/google/gsoc2014\" target=\"_blank\">Google Summer of Code 2014</a>. This year marks the 10th annual GSoC and WordPress&#8217; 7th year participating in the program. Five students have been <a href=\"http://make.wordpress.org/community/2014/04/21/gsoc-students-accepted/\" target=\"_blank\">accepted</a> and will soon begin work on some exciting projects:</p>\n<ul>\n<li><a href=\"http://profiles.wordpress.org/secretmapper\" target=\"_blank\">Arian Allenson M. Valdez</a> — Working on GlotPress UI and profiles with Yoav Farhi and Marko Heijnen as mentors</li>\n<li><a href=\"http://profiles.wordpress.org/gautamgupta\" target=\"_blank\">Gautam Gupta</a> — Working on bbPress improvements with John James Jacoby and Stephen Edgar as mentors</li>\n<li><a href=\"http://profiles.wordpress.org/avryl\" target=\"_blank\">Janneke Van Dorpe</a> — Working on front-end editing/content blocks with Gregory Cornelius and Aaron Jorbin as mentors</li>\n<li><a href=\"http://profiles.wordpress.org/celloexpressions\" target=\"_blank\">Nick Halsey</a> — Working on adding custom menus to the customizer with Erick Hitter and Konstantin Obenland as mentors</li>\n<li><a href=\"http://profiles.wordpress.org/VarunAgw\" target=\"_blank\">Varun Agrawal</a> — Working on SupportPress as a plugin with Ian Dunn, Aaron Campbell, and Alex Mills as mentors</li>\n</ul>\n<p>The students selected to participate are all very talented and enthusiastic. In fact, several of them are already active in contributing to WordPress core and have several plugins hosted in the directory.</p>\n<p>GSoC 2014 kicks off May 19th when the students will begin their summer coding adventures. In the meantime, they will be bonding with their mentoring teams and working to nail down the scope of their projects. Jen Mylo, who is coordinating WordPress&#8217; involvement in the GSoC, will be working with the teams to set up some livestreamed prototype demos at midterm. Students will also be posting on a weekly basis and we&#8217;ll be following the progress on their projects throughout the summer.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 Apr 2014 20:15:24 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"WPTavern: 13 Vagrant Resources for WordPress Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=21194\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:156:\"http://wptavern.com/13-vagrant-resources-for-wordpress-development?utm_source=rss&utm_medium=rss&utm_campaign=13-vagrant-resources-for-wordpress-development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:8671:\"<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/vagrant.png\" rel=\"prettyphoto[21194]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/vagrant.png\" alt=\"vagrant\" width=\"1400\" height=\"632\" class=\"aligncenter size-full wp-image-21435\" /></a></p>\n<p><a href=\"http://www.vagrantup.com/\" target=\"_blank\">Vagrant</a> is an open source tool that makes it easy to configure and distribute virtual development environments. The project was started in 2010 by Mitchell Hashimoto and John Bender who wanted to create a way to standardize development environments for teams. Vagrant was designed to put an end to the &#8220;works on my machine&#8221; frustration that often surfaces when teams develop on different environments.</p>\n<p>Because it&#8217;s so lightweight and portable, many WordPress developers have adopted Vagrant for development, which has resulted in different tools and configurations for various project needs. We&#8217;ve collected a few WordPress-related Vagrant resources here that will help you get started.</p>\n<h3>Varying Vagrant Vagrants</h3>\n<p><a href=\"https://github.com/Varying-Vagrant-Vagrants/VVV\" target=\"_blank\">Varying Vagrant Vagrants</a> is one of the most widely used and best-supported Vagrant configurations for WordPress development. Originally created by the folks at <a href=\"http://10up.com/\" target=\"_blank\">10up</a>, the open source VVV project <a href=\"http://10up.com/blog/varying-vagrant-vagrants-future/\" target=\"_blank\">became a community organization</a> earlier this year. The company still contributes to its development and maintenance, helping to make it one of the most stable options for setting up a Vagrant-based WordPress development environment. VVV provides a comprehensive configuration for developing themes and plugins as well as for contributing to WordPress core.</p>\n<h3>VVV Site Wizard</h3>\n<p>If you&#8217;re a VVV user who is often creating and removing sites, then the <a href=\"https://github.com/aliso/vvv-site-wizard\" target=\"_blank\">VVV Site Wizard</a> may be able to save you some time. It completely automates the creation of new sites as well as the teardown of old ones.</p>\n<h3>WordPress Theme Review VVV</h3>\n<p>If you&#8217;re a VVV user who spends quite a bit of time developing WordPress themes, this is a quick Vagrant setup that adds all the necessary tools for reviewing themes. <a href=\"https://github.com/aubreypwd/wordpress-themereview-vvv\" target=\"_blank\">WordPress Theme Review VVV</a> creates a fresh WordPress site, installs and activates the Developer and Theme-Check plugins, and imports the Theme Unit Test data. Check out our <a href=\"http://wptavern.com/wordpress-theme-review-vvv-a-quick-vagrant-setup-for-testing-and-reviewing-themes\" target=\"_blank\">tutorial</a> for a quick walkthrough on setting it set up.</p>\n<h3>Primary Vagrant</h3>\n<p><a href=\"https://github.com/ChrisWiegman/Primary-Vagrant\" target=\"_blank\">Primary Vagrant</a> is a configuration created by Chris Wiegman. It&#8217;s similar to VVV but with a few important differences: it uses Apache instead of NGINX and Puppet instead of Bash. Wiegman used VVV and Puppet as a base for a new Vagrant configuration for WordPress plugin or theme development. Primary Vagrant supports Apache and MySQL on Ubuntu and allows for use of different major PHP versions (currently 5.3 – 5.5), which can be easily changed with one line of code.</p>\n<h3>VagrantPress</h3>\n<p><a href=\"https://github.com/chad-thompson/vagrantpress\" target=\"_blank\">VagrantPress</a> is a simple configuration that sets up a WordPress development environment using Apache with Vagrant/Puppet. It&#8217;s geared toward developing themes and plugins. VagrantPress currently does not allow for multiple installations but Chat Thompson, the project&#8217;s creator, <a href=\"http://wptavern.com/vagrantpress-a-wordpress-development-environment-for-themes-and-plugins#comment-53714\" target=\"_blank\">plans to add more features</a> related to automating the provisioning and maintenance of multiple WordPress installations.</p>\n<h3>Chassis</h3>\n<p><a href=\"https://github.com/Chassis/Chassis\" target=\"_blank\">Chassis</a> uses Vagrant and Puppet to create a development environment running Ubuntu, Ngnix, PHP 5.4, Imagick, MySQL, Xdebug, WP-CLI, and WordPress, a setup which more closely matches many managed WP hosting environments. Chassis makes it easy to add additional testing domains via a YAML configuration file. It also has support for WordPress multisite, which can be enabled in config.local.yaml or the project configuration file.</p>\n<h3>WordPress and Vagrant Google Group</h3>\n<p><a href=\"https://groups.google.com/forum/#!forum/wordpress-and-vagrant\" target=\"_blank\">WordPress and Vagrant</a> is a public Google group that you can join to post basic or advanced questions about using Vagrant for development. This can be a helpful resource for troubleshooting some unique issues concerning Vagrant-based WordPress development environments. Most of the threads seem to be about working with VVV, but the group isn&#8217;t specifically limited.</p>\n<h3>WordPress Vagrant Boxes</h3>\n<p><a href=\"https://github.com/tierra/wp-vagrant\" target=\"_blank\">WordPress Vagrant Boxes</a> is a Vagrant configuration that uses Apache. Although the web server is preconfigured to look for WordPress in a specific location, WordPress Vagrant Boxes is unique in that it doesn&#8217;t checkout or install WordPress at all. It&#8217;s up to you to unpack and install a WordPress ZIP, checkout from SVN, or clone from git.</p>\n<h3>VCCW (vagrant-chef-centos-wordpress)</h3>\n<p><a href=\"https://github.com/miya0001/vagrant-chef-centos-wordpress\" target=\"_blank\">VCCW</a> (Vagrant + Chef + CentOS + WordPress) was configured for those developing WordPress plugins, themes or websites. It includes 17 customizable constants for setting the WordPress version (or beta release), language, hostname, subdirectory, admin credentials, default plugins, default theme, multisite, SSL and other options. These constants give you a lot of flexibility in tailoring your development environment to your specific needs.</p>\n<h3>Throwaway WordPress VMs with Vagrant and Ansible</h3>\n<p><a href=\"https://github.com/jalefkowit/vagrant-ansible-wordpress\" target=\"_blank\">Throwaway WordPress VMs</a> uses Vagrant and <a href=\"http://www.ansible.com/home\" target=\"_blank\">Ansible</a> to automate the process of creating and provisioning local virtual machines for WordPress development. The scripts were designed for use with Ubuntu, but you can select any version of Ubuntu you wish to use, or a base box from <a href=\"http://www.vagrantbox.es/\" target=\"_blank\">vagrantbox.es</a>.</p>\n<h3>WordPress Machine</h3>\n<p><a href=\"https://github.com/audionerd/wordpress-machine\" target=\"_blank\">WordPress Machine</a> sets up WordPress on a LAMP stack. It also includes Composer, <a href=\"http://wp-cli.org/\" target=\"_blank\">WP-CLI</a>, and <a href=\"http://forge.thethemefoundry.com/\" target=\"_blank\">Forge</a> for WordPress theme setup and asset compilation (SCSS, CoffeeScript). This configuration runs <a href=\"http://ajk.fi/2013/wordpress-as-a-submodule/\" target=\"_blank\">WordPress as a submodule</a> using <a href=\"https://github.com/Darep/wordpress-boilerplate\" target=\"_blank\">WordPress Boilerplate</a>, which means that themes, plugins and uploads are separated from the WordPress installation so that WP can be easily updated as a git submodule.</p>\n<h3>Monkey Rocket</h3>\n<p>The developer who created <a href=\"https://github.com/Cikica/monkeyrocket\" target=\"_blank\">Monkey Rocket</a> used much of the code from VVV, which he found installed more things than he needed for a simple development environment. This Vagrant configuration is basically a stripped down version of VVV that will set you up with the latest stable version of WordPress at local.wordpress.dev on your machine.</p>\n<h3>WordPress Kickstart</h3>\n<p><a href=\"https://github.com/jnettome/wordpress_kickstart\" target=\"_blank\">WordPress Kickstart</a> is a Vagrant development environment provisioned by Puppet. It was created for use with production stacks that are hosted on <a href=\"https://www.digitalocean.com/\" target=\"_blank\">DigitalOcean</a>. Once you enter your DigitalOcean API credentials into the vagrantfile, you&#8217;ll have a command available for working on production deployment and provisioning. This command allows you to create a new droplet, setup your SSH key for authentication, create a new user account, and run the provisioners configured. You can easily switch back and forth from production to development by removing .vagrant/ from your project&#8217;s root folder.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 Apr 2014 14:19:18 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"WPTavern: WPWeekly Episode 146 – WordPress 3.9 With Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"http://wptavern.com?p=21420&preview_id=21420\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:168:\"http://wptavern.com/wpweekly-episode-146-wordpress-3-9-with-andrew-nacin?utm_source=rss&utm_medium=rss&utm_campaign=wpweekly-episode-146-wordpress-3-9-with-andrew-nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2175:\"<p>In this weeks edition of WordPress Weekly, we discussed several topics with WordPress lead developer <a href=\"http://nacin.com/\" title=\"http://nacin.com/\">Andrew Nacin</a>. Ever since the release of WordPress 3.7, many have questioned why auto updates are turned on by default for minor and security updates. Nacin described the philosophy behind the auto update system and why the team will be sticking with its current implementation.</p>\n<p>We also learned the details behind the release of a major security update to Jetpack. Last but not least, Nacin describes what it was like to lead the release of 3.9 and what he&#8217;ll be focusing on now that he won&#8217;t be leading a release cycle.</p>\n<h2>Stories Discussed:</h2>\n<p><a href=\"http://wptavern.com/wordpress-3-9-smith-released\" title=\"http://wptavern.com/wordpress-3-9-smith-released\">WordPress 3.9 “Smith” Released</a><br />\n<a href=\"http://wptavern.com/wordpress-3-9-has-built-in-support-for-pasting-from-microsoft-word\" title=\"http://wptavern.com/wordpress-3-9-has-built-in-support-for-pasting-from-microsoft-word\">WordPress 3.9 Has Built-In Support for Pasting from Microsoft Word</a><br />\n<a href=\"http://wptavern.com/buddypress-2-0-released-big-performance-improvements-and-new-administration-tools\" title=\"http://wptavern.com/buddypress-2-0-released-big-performance-improvements-and-new-administration-tools\">BuddyPress 2.0 Released: Big Performance Improvements and New Administration Tools</a></p>\n<h2>WPWeekly Meta:</h2>\n<p><strong>Next Episode:</strong> Friday, April 25th 3 P.M. Eastern &#8211; Special Guest &#8211; Japh</p>\n<p><strong>Subscribe To WPWeekly Via Itunes: </strong><a href=\"https://itunes.apple.com/us/podcast/wordpress-weekly/id694849738\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via RSS: </strong><a href=\"http://www.wptavern.com/feed/podcast\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via Stitcher Radio: </strong><a href=\"http://www.stitcher.com/podcast/wordpress-weekly-podcast?refid=stpr\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Listen To Episode #146:</strong><br />\n</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 19 Apr 2014 14:29:46 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Andrew: Customizing TinyMCE 4.0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"http://azaozz.wordpress.com/?p=380\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"http://azaozz.wordpress.com/2014/04/19/customizing-tinymce-4-0/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2358:\"<p>Many of the TinyMCE settings have changed in version 4.0. There is a new default theme: Modern, and all the UI settings for the former Advanced theme (<code>theme_advanced...)</code> are deprecated.</p>\n<p>One often used setting was <code>theme_advanced_blockformats</code><strong><code>.</code></strong> It was renamed to <code>block_formats</code> and keeps the same formatting. To specify a different set of elements for the &#8216;blockformats&#8217; drop-down (second toolbar row in the WordPress Visual editor), you can set a string of name=value pairs separated by a semicolon in the initialization object:</p>\n<pre class=\"brush: jscript; title: ; notranslate\">block_formats: \"Paragraph=p;Heading 1=h1;Heading 2=h2;Heading 3=h3\"</pre>\n<p>Another handy setting: <code>theme_advanced_styles</code> doesn&#8217;t exist any more. However there is a more powerful version: <code>style_formats</code>. Now it can replace or add items to the new &#8220;Formats&#8221; menu.The value is an array of objects each containing a name that is displayed as sub-menu and several settings: a CSS class name or an inline style, and optionally the wrapper element where the class or inline style will be set:</p>\n<pre class=\"brush: jscript; title: ; notranslate\">\ntoolbar3: \'styleselect\',\nstyle_formats_merge: true,\nstyle_formats: { name: \'Custom styles\', [\n  {title: \'Red bold text\', inline: \'b\', styles: {color: \'#ff0000\'}},\n  {title: \'Red text\', inline: \'span\', styles: {color: \'#ff0000\'}},\n  {title: \'Red header\', block: \'h1\', styles: {color: \'#ff0000\'}},\n  {title: \'Example 1\', inline: \'span\', classes: \'example1\'},\n  {title: \'Example 2\', inline: \'span\', classes: \'example2\'}\n]}\n</pre>\n<p>The above code will add another sub-menu to &#8220;Formats&#8221; without replacing the default menu items. There is <a href=\"http://www.tinymce.com/wiki.php/Configuration:style_formats\">more information</a> and an <a href=\"http://www.tinymce.com/tryit/custom_formats.php\">example</a> on the TinyMCE website.</p><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/azaozz.wordpress.com/380/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/azaozz.wordpress.com/380/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=azaozz.wordpress.com&blog=3380945&post=380&subd=azaozz&ref=&feed=1\" width=\"1\" height=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 19 Apr 2014 07:04:36 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Andrew Ozz\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:15;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"WPTavern: Quotable: Highlight and Share WordPress Posts on Twitter\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=21400\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:174:\"http://wptavern.com/quotable-highlight-and-share-wordpress-posts-on-twitter?utm_source=rss&utm_medium=rss&utm_campaign=quotable-highlight-and-share-wordpress-posts-on-twitter\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3084:\"<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/quotable.png\" rel=\"prettyphoto[21400]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/quotable.png\" alt=\"quotable\" width=\"772\" height=\"250\" class=\"aligncenter size-full wp-image-21403\" /></a></p>\n<p>Readers may not always identify with the title that you&#8217;ve chosen for your posts but they may find a gem within your article that is more &#8220;quotable&#8221; and worth sharing. <a href=\"http://wordpress.org/plugins/quotable/\" target=\"_blank\">Quotable</a> is a new WordPress plugin that capitalizes on this, allowing readers to highlight any text within your content to quote the article on Twitter.</p>\n<p>The plugin, developed by <a href=\"http://josiahsprague.com/\" target=\"_blank\">Josiah Sprague</a>, was partially inspired by the toolbar on Medium.com that enables visitors to tweet or comment on the text they select. Sprague said that he created it out of his love for both WordPress and Twitter:</p>\n<blockquote><p> I love how both platforms make it easy for people to share ideas and communicate openly and freely. I love that both serve as a sort of “public square” of the web and support discourse, democracy and free society.</p></blockquote>\n<p>Quotable adds a tiny Twitter icon to the end of blockquotes for quick sharing.  It also works with text highlighting. Readers will often instinctively highlight text that they agree with or are wanting to share. When they do, they&#8217;ll naturally discover that it&#8217;s easy to share.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/quotable2.png\" rel=\"prettyphoto[21400]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/quotable2.png\" alt=\"quotable2\" width=\"916\" height=\"458\" class=\"aligncenter size-full wp-image-21405\" /></a></p>\n<p>When you click the Twitter bird, a tweet modal will automatically launch with the quoted text inserted. Quotable also integrates with Twitter accounts configured via Yoast&#8217;s WordPress SEO, which allows you to include Twitter mentions for post authors and suggest following the website&#8217;s Twitter account.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/quotable-1.png\" rel=\"prettyphoto[21400]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/quotable-1.png\" alt=\"quotable-1\" width=\"1400\" height=\"1360\" class=\"aligncenter size-full wp-image-21404\" /></a></p>\n<p>Let&#8217;s face it &#8211; the comments section of your post is not always the locus of the conversation sparked by your blog. Even if your post is the origin of a hotly debated topic, the conversation often moves to Twitter, and that&#8217;s OK. This plugin helps you to be ready to follow the conversation wherever it goes, especially if you configure it to automatically mention you, the post author, when a quote gets tweeted.</p>\n<p>I tested Quotable with WordPress 3.9 and found that it works as advertised and fits naturally into any theme without being obtrusive. <a href=\"http://wordpress.org/plugins/quotable/\" target=\"_blank\">Download</a> it for free from WordPress.org.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 18 Apr 2014 23:10:17 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:16;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"Akismet: New in 3.0: Activation with Jetpack\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://blog.akismet.com/?p=1308\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://blog.akismet.com/2014/04/18/activation-with-jetpack/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2091:\"<p>We launched <a href=\"http://blog.akismet.com/2014/04/15/akismet-3-0-0/\" title=\"Akismet 3.0.0 is Now Available\">Akismet 3.0</a> just a few days ago and hope that you&#8217;ve already upgraded to enjoy its many new features. One of the nifty items we added to the mix is a seamless activation process using the popular <a href=\"http://wordpress.org/plugins/jetpack/\" title=\"Jetpack by WordPress.com\">Jetpack</a> plugin.</p>\n<p>Let&#8217;s take a closer look.</p>\n<p>If you have Jetpack and Akismet installed and activated on your site &#8211; and the Jetpack plugin connected to a <a href=\"http://wordpress.com\" title=\"WordPress.com\">WordPress.com</a> account &#8211; you will find this new feature in your dashboard via <strong>Jetpack &#8594; Akismet</strong>.</p>\n<p>There, you will see which WordPress.com account is connected via Jetpack and an option to activate the Akismet plugin using that very same account.</p>\n<p><a href=\"http://akismet.files.wordpress.com/2014/04/akismet-activation-with-jetpack.png\"><img src=\"http://akismet.files.wordpress.com/2014/04/akismet-activation-with-jetpack.png?w=640&h=263\" alt=\"Akismet Activation with Jetpack\" class=\"alignnone size-large wp-image-1348\" /></a></p>\n<p>Click on <strong>Use this Akismet account</strong>, and you&#8217;re all set! Of course, you will have the option to disconnect the account at any time from the same page in your dashboard.</p>\n<p>And if you want to use a different account to activate Akismet, no worries at all. Simply select the option to register a different email address or manually enter an existing API key.</p>\n<p>Digging the new flow? Any problems with it? <a href=\"http://akismet.com/contact/\" title=\"Contact Akismet\">Drop us a line</a>.</p><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/akismet.wordpress.com/1308/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/akismet.wordpress.com/1308/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=blog.akismet.com&blog=116920&post=1308&subd=akismet&ref=&feed=1\" width=\"1\" height=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 18 Apr 2014 19:40:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Anthony Bubel\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:17;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:76:\"WPTavern: WordPress 3.9 Has Built-in Support for Pasting from Microsoft Word\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=21366\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:196:\"http://wptavern.com/wordpress-3-9-has-built-in-support-for-pasting-from-microsoft-word?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-3-9-has-built-in-support-for-pasting-from-microsoft-word\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2744:\"<div id=\"attachment_21384\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/04/paste.png\" rel=\"prettyphoto[21366]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/paste.png\" alt=\"photo credit: This Year\'s Love - cc\" width=\"900\" height=\"401\" class=\"size-full wp-image-21384\" /></a><p class=\"wp-caption-text\">photo credit: <a href=\"http://www.flickr.com/photos/hand-nor-glove/1481913840/\">This Year&#8217;s Love</a> &#8211; <a href=\"http://creativecommons.org/licenses/by-nc-nd/2.0/\">cc</a></p></div>\n<p>A common support question that&#8217;s been popping up on the web after WordPress users update to 3.9: <strong>What happened to the &#8220;Paste from Word&#8221; button in the visual editor?</strong> If you find that the button is missing, don&#8217;t worry &#8211; it&#8217;s not a bug.  Prior to this update, the button was located in the kitchen sink of the visual editor:</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/paste-from-word.png\" rel=\"prettyphoto[21366]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/paste-from-word.png\" alt=\"paste-from-word\" width=\"622\" height=\"233\" class=\"aligncenter size-full wp-image-21370\" /></a></p>\n<p>WordPress 3.9, however, <a href=\"https://core.trac.wordpress.org/changeset/28089\" target=\"_blank\">removes the &#8220;paste from word&#8221; button</a> entirely. It includes <a href=\"http://make.wordpress.org/core/2014/01/18/tinymce-4-0-is-in-core/\" target=\"_blank\">TinyMCE 4.0</a> and has better built-in support for pasting in blocks of text for Microsoft Word. The better your software gets, the more the magic happens behind the scenes. WordPress now detects if the pasted text is coming from MS Word and makes the appropriate changes.</p>\n<p>Until I saw the <a href=\"http://www.reddit.com/r/Wordpress/comments/23ah5d/copy_from_word_button_went_missing/\" target=\"_blank\">question</a> on Reddit, indicating that the button had gone missing, I had no idea that anyone still used this feature. The missing button is actually an enhancement, not a bug. Hopefully this information has reached you before you started deactivating all your plugins.</p>\n<p>Unless you had been closely following the posts at <a href=\"http://make.wordpress.org\" target=\"_blank\">make.wordpress.org</a>, this improvement might have been easy to miss. Check out our <a href=\"http://wptavern.com/wordpress-3-9-smith-released\" target=\"_blank\">summary of everything that&#8217;s new in WordPress 3.9</a>. If you&#8217;re having any problems with the update, you may want to review some of the <a href=\"http://wptavern.com/common-issues-and-troubleshooting-wordpress-3-9\" target=\"_blank\">known issues</a> with plugins before posting in the support forums.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 18 Apr 2014 17:53:15 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:18;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"WPTavern: How to Limit Activity Comment Depth in BuddyPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=21347\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:162:\"http://wptavern.com/how-to-limit-activity-comment-depth-in-buddypress?utm_source=rss&utm_medium=rss&utm_campaign=how-to-limit-activity-comment-depth-in-buddypress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2642:\"<p>BuddyPress 2.0 was <a href=\"http://wptavern.com/buddypress-2-0-released-big-performance-improvements-and-new-administration-tools\" target=\"_blank\">released</a> this week with many new administrative tools that make it easier to manage communities from the backend. One of the lesser known new features is the ability to limit comment depth in the activity stream.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/old-threaded-comments.png\" rel=\"prettyphoto[21347]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/old-threaded-comments-300x258.png\" alt=\"old-threaded-comments\" width=\"300\" height=\"258\" class=\"alignright size-medium wp-image-21351\" /></a>Activity threads can sometimes get out of control when it comes to replies, which results in the comments box getting progressively squished to an inconveniently small size.</p>\n<p>In the past, the only way to change the comment depth was to filter the output of the bp_activity_can_comment_reply() function, but this wasn&#8217;t very user-friendly for community managers.</p>\n<p>Since WordPress already has a built-in setting for comment depth, this was a natural fit for activity comments and did not require adding any new settings. BuddyPress 2.0 now <a href=\"https://buddypress.trac.wordpress.org/ticket/2768\" target=\"_blank\">respects WordPress&#8217; comment depth settings</a>. You can adjust them in the admin at <strong>Settings > Discussion > Other Comment Settings</strong>.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/threaded-comments.png\" rel=\"prettyphoto[21347]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/threaded-comments.png\" alt=\"threaded-comments\" width=\"1200\" height=\"397\" class=\"aligncenter size-full wp-image-21349\" /></a></p>\n<p>In the following example, threaded comments have been set to three. You&#8217;ll notice that the third comment has no reply link beneath it. Members can still comment on the activity item itself but will not be able to add more than three replies.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/activity-comments.png\" rel=\"prettyphoto[21347]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/activity-comments.png\" alt=\"activity-comments\" width=\"900\" height=\"680\" class=\"aligncenter size-full wp-image-21355\" /></a></p>\n<p>This update shouldn&#8217;t affect the structure of your previous activity comments/replies, but it will be in effect for threaded comments moving forward. If you&#8217;ve been itching to to limit activity comment depth on your BuddyPress site, this new setting makes it easy to set a limit, without having to touch any code.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 18 Apr 2014 06:42:38 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:19;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"WordPress.tv: Cédric Motte : Sans contenu, WordPress n’est rien\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=34325\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"http://wordpress.tv/2014/04/17/cedric-motte-sans-contenu-wordpress-nest-rien/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:673:\"<div id=\"v-4WgeuUC1-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/34325/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/34325/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=34325&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/04/17/cedric-motte-sans-contenu-wordpress-nest-rien/\"><img alt=\"13 &#8211; Cedric Motte-Conf-WCParis2014.mp4\" src=\"http://videos.videopress.com/4WgeuUC1/video-88337de484_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 17 Apr 2014 21:58:16 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:20;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:91:\"WPTavern: Automattic Publishes Transparency Report, Reaffirms Support for Freedom of Speech\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=21275\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:224:\"http://wptavern.com/automattic-publishes-transparency-report-reaffirms-support-for-freedom-of-speech?utm_source=rss&utm_medium=rss&utm_campaign=automattic-publishes-transparency-report-reaffirms-support-for-freedom-of-speech\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5451:\"<p>Automattic was created to bring WordPress&#8217; open source publishing software to people on a larger scale. The company shares <a href=\"http://codex.wordpress.org/WordPress_Policies\" target=\"_blank\">WordPress&#8217; mission</a> to democratize publishing. As part of that mission, Automattic published a transparency report, which outlines the number of information requests, takedown demands, and national security requests it has received.</p>\n<p>The <a href=\"http://transparency.automattic.com/\" target=\"_blank\">Transparency Report</a> is located on a new site which helps users to navigate what will likely become a large archive of information, as Automattic plans to publish a new report every six months. This report will keep users informed about which governments are making requests and policies for responding to them.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/transparency-report.jpg\" rel=\"prettyphoto[21275]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/transparency-report.jpg\" alt=\"transparency-report\" width=\"1280\" height=\"664\" class=\"aligncenter size-full wp-image-21310\" /></a></p>\n<p>Writing on behalf of Automattic, Jenny Zhu <a href=\"http://en.blog.wordpress.com/2014/04/17/transparency-report/\" target=\"_blank\">summarized</a> the company&#8217;s policy regarding information requests:</p>\n<blockquote><p>Our policy is to notify you of any information request we receive regarding your account, so that you may challenge the request. The only exception is if we are prohibited by law (not just asked nicely by the police) from making such a notification. </p></blockquote>\n<h3>Automattic is Committed to Actively Pushing Back Against Requests That Violate Freedom of Speech</h3>\n<p>Historically, Automattic has demonstrated its support for freedom of speech by <a href=\"http://en.blog.wordpress.com/2010/07/01/support-the-first-amendment-with-1-for-all/\" target=\"_blank\">raising awareness about the First Amendment</a>, even taking to the courts <a href=\"http://en.blog.wordpress.com/2013/11/21/striking-back-against-censorship/\" target=\"_blank\">to stand with users against DMCA abuse</a>. The company also recently joined forces with other organizations around the globe to <a href=\"http://wptavern.com/wordpress-com-joins-google-reddit-and-tumblr-in-protesting-nsa-surveillance\" target=\"_blank\">protest NSA surveillance</a>.</p>\n<p>Through its statement today, Automattic emphasized that it will push back against requests that constitute infringements on freedom of speech:</p>\n<blockquote><p>We also carefully review all legal requests we receive and actively push back on those that are procedurally deficient, overly-broad, or otherwise improper (i.e., those that target non-criminal free speech).</p></blockquote>\n<h3>The US Government Represents 60% of the Information Requests</h3>\n<p>Russia, not known for its support of free press, leads the way in <a href=\"http://transparency.automattic.com/takedown-demands/\" target=\"_blank\">takedown demands</a> with 88% of the total requests received by WordPress.com. The United States, however, far and away leads in the number of user <a href=\"http://transparency.automattic.com/information-requests/\" target=\"_blank\">information requests</a> from governments and law enforcement agencies from July 1 – December 31, 2013.</p>\n<p>While most of the countries listed have submitted a handful of requests, the US government sent 20 requests, specifying 29 different sites. In 60% of those requests, some or all information was produced. The requests shown here do not include those related to litigation and civil proceedings.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/information-requests.jpg\" rel=\"prettyphoto[21275]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/information-requests.jpg\" alt=\"information-requests\" width=\"753\" height=\"736\" class=\"aligncenter size-full wp-image-21315\" /></a></p>\n<p>Automattic specifies that the company will only turn over private user information upon receipt of valid US legal process. Requests that originate from outside the US are required to be served through a US court or enforcement agency.</p>\n<p>The company is not permitted to disclose very much regarding national security requests, despite wishing they could:</p>\n<blockquote><p>Finally, we’re reporting the maximum amount of information allowed by law about the number and type(s) of National Security Requests that we received. The disclosures we’re currently allowed to make are limited, and unfortunately, we’re not permitted to paint a more truthful picture.</p></blockquote>\n<p>The <a href=\"http://transparency.automattic.com/\" target=\"_blank\">Transparency Report</a> makes it clear that Automattic will not tolerate censorship of its users and is committed to disclosing as much information related to government requests as they are permitted. Many governments are <a href=\"http://www.bloomberg.com/news/2014-04-11/nsa-said-to-have-used-heartbleed-bug-exposing-consumers.html\" target=\"_blank\">ruthless about extracting information from citizens</a>, even when it comes at the expense of the people they serve. Given that the United States leads the pack in information requests, it&#8217;s reassuring to know that WordPress.com, one of the most highly trafficked sites in the US and around the globe, is committed to standing against any request that violates users&#8217; freedom of speech.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 17 Apr 2014 20:43:07 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:21;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"WPTavern: Common Issues and Troubleshooting WordPress 3.9\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=21274\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:158:\"http://wptavern.com/common-issues-and-troubleshooting-wordpress-3-9?utm_source=rss&utm_medium=rss&utm_campaign=common-issues-and-troubleshooting-wordpress-3-9\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:8165:\"<div id=\"attachment_21291\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/04/WP39Support.png\" rel=\"prettyphoto[21274]\"><img class=\"size-full wp-image-21291\" src=\"http://wptavern.com/wp-content/uploads/2014/04/WP39Support.png\" alt=\"WordPress 3.9 Featured Images\" width=\"639\" height=\"200\" /></a><p class=\"wp-caption-text\">photo credit: <a href=\"http://www.flickr.com/photos/ironrodart/4154904299/\">IronRodArt &#8211; Royce Bair (&#8220;Star Shooter&#8221;)</a> &#8211; <a href=\"http://creativecommons.org/licenses/by-nc-nd/2.0/\">cc</a></p></div>\n<p>After the release of WordPress 3.9, I decided to help out in the <a title=\"http://wordpress.org/support/\" href=\"http://wordpress.org/support/\">support forums</a> since they usually become busy soon after a release. Providing support in the WordPress.org forums gives you a clear indication on how well a release is being received and whether or not anything major broke. After spending five hours in the support forum, here are some common issues being reported by users.</p>\n<h3>Visual Editor Disappeared Or Is Broken</h3>\n<p>A lot of users are <a title=\"http://wordpress.org/tags/visual-editor\" href=\"http://wordpress.org/tags/visual-editor\">reporting that the visual editor</a> has either disappeared or is broken. Considering the <a title=\"http://make.wordpress.org/core/2014/01/18/tinymce-4-0-is-in-core/\" href=\"http://make.wordpress.org/core/2014/01/18/tinymce-4-0-is-in-core/\">number</a> of changes that took place with TinyMCE in 3.9, this is not surprising. In most cases, having users go through the following process solved the problem.</p>\n<ol>\n<li>Deactivate ALL plugins.</li>\n<li>Switch to default TwentyFourteen theme.</li>\n<li>Manually empty browser cache.</li>\n</ol>\n<p>If the visual editor doesn&#8217;t work after disabling all plugins and switching to the default theme, there could be a JavaScript issue. Follow <a title=\"http://codex.wordpress.org/Using_Your_Browser_to_Diagnose_JavaScript_Errors\" href=\"http://codex.wordpress.org/Using_Your_Browser_to_Diagnose_JavaScript_Errors\">these instructions</a> to diagnose JavaScript errors in your browser. Then, open up a new support forum thread and make sure to add the following information:</p>\n<ul>\n<li>the browsers that you are experiencing the problem in</li>\n<li>whether SCRIPT_DEBUG fixed the error or not</li>\n<li>the JavaScript error</li>\n<li>the location of the error &#8211; both the file name and the line number</li>\n<li>the context of the error &#8211; including the whole error stack will help developers</li>\n</ul>\n<p>This detailed information will help volunteer moderators determine the best way to solve your problem.</p>\n<h3>Master List Of Known Issues</h3>\n<p>Themes and plugins confirmed to be the cause of the problem are documented and added to the <a title=\"http://wordpress.org/support/topic/wordpress-39-master-list?replies=4\" href=\"http://wordpress.org/support/topic/wordpress-39-master-list?replies=4\">master list</a> of known issues with WordPress 3.9. So far, the list of plugins is up to eight with at least one in the process of being fixed.</p>\n<ul>\n<li><a href=\"http://wordpress.org/plugins/wysija-newsletters/\">MailPoet Newsletters</a> &#8211; Issue with <a href=\"https://wordpress.org/support/topic/39-update-tinymce-disappeared?replies=6#post-5465005\">outdated TinyMCE plugin in version 2.6.3</a>, disabling plugin fixed Visual Editor problem. MailPoet is already working on a fix for the TinyMCE issue in the next versions 2.6.4 (for post editor screen) and 2.6.5 (for newsletter editor).</li>\n<li><a href=\"https://wordpress.org/plugins/ziplist-recipe-plugin/\">ZipList Recipe Plugin</a> &#8211; Version 2.2 has a problem with the post editor in <a href=\"https://wordpress.org/support/topic/plugin-causes-posts-to-not-be-editable?replies=2\">both Visual and Text mode</a>.</li>\n<li><a href=\"http://wordpress.org/plugins/zedity/\">Zedity</a> &#8211; Version 3.1.0 causes the Visual Editor to break.</li>\n<li><a href=\"https://wordpress.org/plugins/enhanced-media-library/\">Enhanced Media Library</a> &#8211; Version 1.0.4 doesn&#8217;t show any media in the media library when the Add Media button is clicked</li>\n<li><a href=\"http://wordpress.org/plugins/soundcloud-is-gold/\">SoundCloud Is Gold</a> &#8211; Version 2.2.1 disables the Visual editor and prevents text from being entered</li>\n<li><a href=\"https://wordpress.org/plugins/nofollow/\">Ultimate NoFollow</a> &#8211; Version 1.4.1 doesn&#8217;t allow links to be inserted in the visual editor</li>\n<li><a href=\"https://wordpress.org/plugins/many-tips-together/\">Admin Tweaks</a> &#8211; version 2.3.8 causes the visual editor to white out.</li>\n<li><a href=\"http://wordpress.org/plugins/qtranslate/\">Qtranslate</a> &#8211; version 2.5.39 causes the media uploaded not to function</li>\n</ul>\n<p>The support team tries their best to help everyone with any WordPress problem even if it&#8217;s for a commercial theme or plugin. However, due to the great variety of existing themes and plugins it is nearly impossible to know everything. Your best option is to contact the developer for support. It’s always best to go to where the theme/plugin is officially supported when trying to get support.</p>\n<h3>How To Create An Audio Playlist</h3>\n<p>A few users have asked where the link is to create an audio playlist. In order to see the link to create an audio playlist, you either need existing audio files within the media library or you need to add them. It&#8217;s worth noting that if you host your media files on a content delivery network that&#8217;s not synchronized with the WordPress media library, you won&#8217;t be able to take advantage of the playlist feature.</p>\n<h3>Easy Way To Add Borders and Padding To Images Removed</h3>\n<p>Although WordPress 3.9 has refined the media editing experience, it did so at the cost of removing a feature users appreciated. In WordPress 3.8, users could easily add a border, vertical, and horizontal padding to images. WordPress 3.9 has removed this from the advanced image settings screen.</p>\n<div id=\"attachment_21279\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/04/WP38ImageProperties.png\" rel=\"prettyphoto[21274]\"><img class=\"size-full wp-image-21279\" src=\"http://wptavern.com/wp-content/uploads/2014/04/WP38ImageProperties.png\" alt=\"Image Properties In WordPress 3.8\" width=\"620\" height=\"476\" /></a><p class=\"wp-caption-text\">Image Properties In WordPress 3.8</p></div>\n<p>It&#8217;s not just those who use the self-hosted version of WordPress that are upset with the change. A WordPress.com <a title=\"http://en.forums.wordpress.com/topic/image-resize-1?replies=430\" href=\"http://en.forums.wordpress.com/topic/image-resize-1?replies=430\">support forum thread</a> with over 430 posts is filled with users asking why the feature was removed. In some cases, WordPress.com staff are explaining how to use HTML code to add or remove borders to images. It&#8217;s possible that a plugin will soon be released that will restore this feature.</p>\n<h3>Use Patience When Asking For Support</h3>\n<p>Since WordPress 3.9 is a major upgrade, please exercise patience when requesting support on the forum. This <a title=\"https://codex.wordpress.org/Using_the_Support_Forums#Getting_Your_Questions_Answered_on_the_Forum\" href=\"https://codex.wordpress.org/Using_the_Support_Forums#Getting_Your_Questions_Answered_on_the_Forum\">guide on the Codex</a> does a great job explaining how to get your question answered. Last but not least, if a volunteer helps solve your problem, say thank you. During my five-hour support stint, I realized first-hand that providing support is a thankless job. Reading thank you notes and seeing users express joy from having their problem solved gave me the energy to keep on going.</p>\n<p>I encourage you to take 15-20 minutes to browse the support forum and help out where you can. Not only will you get a better understanding of problems users are facing, but you&#8217;ll learn a lot in the process. To anyone who&#8217;s taken the time to answer a support question on the forum, <strong>thank you!</strong></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 17 Apr 2014 19:45:25 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:22;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"WordPress.tv: Introducing WordPress 3.9 “Smith”\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=34317\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"http://wordpress.tv/2014/04/16/introducing-wordpress-3-9-smith/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:635:\"<div id=\"v-sAiXhCfV-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/34317/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/34317/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=34317&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/04/16/introducing-wordpress-3-9-smith/\"><img alt=\"WordPress3-9-Smith\" src=\"http://videos.videopress.com/sAiXhCfV/wordpress3-9-smith_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 16 Apr 2014 21:10:08 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:23;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"WPTavern: How To Set Up 1 Or 2 Columns For WordPress Dashboard Widgets\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=21030\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:184:\"http://wptavern.com/how-to-set-up-1-or-2-columns-for-wordpress-dashboard-widgets?utm_source=rss&utm_medium=rss&utm_campaign=how-to-set-up-1-or-2-columns-for-wordpress-dashboard-widgets\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3932:\"<p>One of the improvements in <a title=\"http://wordpress.org/news/2013/12/parker/\" href=\"http://wordpress.org/news/2013/12/parker/\">WordPress 3.8</a> was the responsive dashboard. Thanks to this improvement, the option to select the number of columns to display dashboard widgets <a title=\"http://make.wordpress.org/ui/2013/10/11/dash-update-4/\" href=\"http://make.wordpress.org/ui/2013/10/11/dash-update-4/\">was removed</a>. The dashboard now shows the appropriate number of columns using the available screen real estate. Unfortunately, for those using wide-screen monitors, this usually means 4-5 skinny columns. In the screenshot below, you can see that even if a column doesn&#8217;t have a widget assigned to it, the column remains in place.</p>\n<div id=\"attachment_21233\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/04/DashboardWithFourColumns.png\" rel=\"prettyphoto[21030]\"><img class=\"size-full wp-image-21233\" src=\"http://wptavern.com/wp-content/uploads/2014/04/DashboardWithFourColumns.png\" alt=\"The Result Of A Responsive Dashboard\" width=\"1724\" height=\"417\" /></a><p class=\"wp-caption-text\">The Result Of A Responsive Dashboard</p></div>\n<p>The issue was <a title=\"http://imtheirwebguy.com/dont-hit-update-just-yet-wp-3-8-overhauls-ui-breaks-dashboard-widgets/\" href=\"http://imtheirwebguy.com/dont-hit-update-just-yet-wp-3-8-overhauls-ui-breaks-dashboard-widgets/\">brought up by Chris Jenkins</a> shortly after the release of WordPress 3.8. WordPress core developer Mark Jaquith agreed that &#8220;dashboard widgets should be able to specify a min-width, such that they span multiple columns if WordPress tries to make them smaller than that.&#8221; Jaquith <a title=\"https://core.trac.wordpress.org/ticket/26575\" href=\"https://core.trac.wordpress.org/ticket/26575\">created a ticket</a> suggesting a fix but so far, a patch has not been created.</p>\n<p>Since the ticket was created, Jenkins has developed and released a plugin called <a title=\"http://wordpress.org/plugins/two-column-admin/\" href=\"http://wordpress.org/plugins/two-column-admin/\">Two Column Admin</a>. When activated, the plugin restores the ability to select 1 or 2 columns to the screen options tab. The downside to using this plugin is that selecting two columns will disable the responsiveness of the dashboard widgets. Instead of merging into one column when the screen size gets smaller, the two columns will crash into each other.</p>\n<div id=\"attachment_21234\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/04/TwoColumnUnresponsiveWidgets.png\" rel=\"prettyphoto[21030]\"><img class=\"size-full wp-image-21234\" src=\"http://wptavern.com/wp-content/uploads/2014/04/TwoColumnUnresponsiveWidgets.png\" alt=\"Two Column Unresponsive Widgets\" width=\"500\" height=\"447\" /></a><p class=\"wp-caption-text\">Two Column Unresponsive Widgets</p></div>\n<p>Matt Beck <a title=\"https://core.trac.wordpress.org/ticket/26575#comment:1\" href=\"https://core.trac.wordpress.org/ticket/26575#comment:1\">responded to the ticket</a> with a good suggestion in lieu of the column option returning:</p>\n<blockquote><p>Best case scenario would be for the number/width of columns to adjust to the number of active dashboard widgets instead of displaying the empty drag/drop areas. In lieu of that, some mechanism to specify either column-count of a widget intended to be wide and/or better yet &#8211; maximum number of columns to display on the dashboard would be great.</p></blockquote>\n<p>After being stuck with four columns since the release of 3.8, I&#8217;ve forgotten how nice it is to have wide dashboard widgets. I&#8217;m hopeful that in the future, the ability to specify the number of columns in the dashboard returns as I prefer three, not four columns.</p>\n<p><strong>How many of you would like to be able to specify a specific amount of columns versus the current implementation?</strong></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 16 Apr 2014 19:30:38 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:24;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:76:\"WPTavern: BuddyPress Development Trunk to Adopt a Grunt-Powered Build System\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=21231\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:196:\"http://wptavern.com/buddypress-development-trunk-to-adopt-a-grunt-powered-build-system?utm_source=rss&utm_medium=rss&utm_campaign=buddypress-development-trunk-to-adopt-a-grunt-powered-build-system\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3238:\"<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/grunt.jpg\" rel=\"prettyphoto[21231]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/grunt.jpg\" alt=\"grunt\" width=\"916\" height=\"360\" class=\"aligncenter size-full wp-image-21245\" /></a></p>\n<p>Now that <a href=\"http://wptavern.com/buddypress-2-0-released-big-performance-improvements-and-new-administration-tools\" target=\"_blank\">BuddyPress 2.0</a> has been released, the core development team is refining its workflow to make use of <a href=\"http://gruntjs.com/\" target=\"_blank\">Grunt</a>, the Javascript task runner that the WordPress project <a href=\"http://make.wordpress.org/core/2013/08/06/a-new-frontier-for-core-development/\" target=\"_blank\">adopted</a> last year. The <a href=\"http://buddypress.svn.wordpress.org/trunk\" target=\"_blank\">BuddyPress development trunk</a> will be adopting a similar Grunt-powered build system that will automate many tedious tasks.</p>\n<p>The BuddyPress trunk will be reorganized to include a <strong>/src</strong> directory for BuddyPress, minus bbPress 1.1 and the BP-Default theme, which will be removed. The <strong>/tests</strong> directory will house the phpUnit tests. <a href=\"https://travis-ci.org/buddypress/BuddyPress\" target=\"_blank\">Travis-CI</a> and configuration files for tests will be moved to the root.</p>\n<h3>Who Is Affected?</h3>\n<p>The reorganization of the trunk will not affect production releases of BuddyPress, so for most ordinary users nothing will change. BuddyPress core contributor Paul Gibbs specified who will be affected by the changes in his <a href=\"http://bpdevel.wordpress.com/2014/04/16/grunt-coming-to-buddypress/\" target=\"_blank\">post</a> on the development blog. The changes concern you if:</p>\n<ul>\n<li>You develop plugins for BuddyPress</li>\n<li>You are a core contributor</li>\n<li>You run a checkout of trunk on a production site</li>\n</ul>\n<p>While this cross section of affected users represents just a handful of BuddyPress developers, the good news for everyone is that both core and extension development will become more efficient. That means that improvements and new plugins are likely to reach you faster than before.</p>\n<h3>How Will Grunt Make BuddyPress Development More Efficient?</h3>\n<p>Grunt will reduce the amount of manual labor that developers put into contributing to the BuddyPress core and creating plugins. The task runner will handle all of the following:</p>\n<ul>\n<li>Validate and lint CSS/JS</li>\n<li>Generate right-to-left CSS</li>\n<li>Compress images</li>\n<li>Run unit tests</li>\n<li>Generate the .pot file for internationalization</li>\n<li>Check for missing text domains</li>\n<li>Make it easier for developers to apply patches from BuddyPress Trac for testing</li>\n</ul>\n<p>The core team may add to this list in the future. If you want to get involved in the discussion or keep an eye on the &#8220;grunt-ification&#8221; of the BuddyPress trunk, there&#8217;s a <a href=\"https://buddypress.trac.wordpress.org/ticket/5160\" target=\"_blank\">trac ticket</a> open where updates will be posted. Core contributors and developers running a checkout of trunk on production/development sites will want to stay tuned for any changes that might affect your workflow.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 16 Apr 2014 19:16:36 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:25;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"WPTavern: WordPress 3.9 “Smith” Released\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=19881\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:120:\"http://wptavern.com/wordpress-3-9-smith-released?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-3-9-smith-released\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:13415:\"<div id=\"attachment_21131\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/04/WordPress39.png\" rel=\"prettyphoto[19881]\"><img class=\"size-full wp-image-21131\" src=\"http://wptavern.com/wp-content/uploads/2014/04/WordPress39.png\" alt=\"WordPress 3.9 Featured Image\" width=\"637\" height=\"227\" /></a><p class=\"wp-caption-text\">photo credit: <a href=\"http://www.flickr.com/photos/wbaiv/6252639219/\">wbaiv</a> &#8211; <a href=\"http://creativecommons.org/licenses/by-sa/2.0/\">cc</a></p></div>\n<p><a title=\"http://wordpress.org/news/2014/04/smith/\" href=\"http://wordpress.org/news/2014/04/smith/\">WordPress 3.9 &#8220;Smith&#8221;</a> is now available, just four months after the release of 3.8. This release continues the strategy of developing features as plugins first. <a title=\"http://wordpress.org/plugins/widget-customizer/\" href=\"http://wordpress.org/plugins/widget-customizer/\">Widgets Customizer</a> by <a title=\"http://profiles.wordpress.org/westonruter\" href=\"http://profiles.wordpress.org/westonruter\">Westonruter</a> is the only plugin that was developed and merged into WordPress this time around. Much of the work in <a title=\"http://codex.wordpress.org/Version_3.9\" href=\"http://codex.wordpress.org/Version_3.9\">WordPress 3.9</a> is an improvement of features added in earlier versions. Without further ado, let&#8217;s take a look at what this release has to offer.</p>\n<h3>New: Create Audio/Video Playlists</h3>\n<p>Building upon the addition of audio and video in WordPress 3.6, WordPress 3.9 offers a lot of enhancements. For starters, you can now create audio playlists. You can also add multiple sources to help with cross-browser compatibility. Managing multiple sources is easy thanks to an improved workflow. WordPress now has subtitle support for videos as long as you supply the appropriate files. <a title=\"http://html5doctor.com/video-subtitling-and-webvtt/\" href=\"http://html5doctor.com/video-subtitling-and-webvtt/\">This post by HTML5Doctor</a> explains how to create the proper files to add subtitles to videos.</p>\n<div id=\"attachment_21126\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/04/WP39AudioPlaylists.png\" rel=\"prettyphoto[19881]\"><img class=\"size-full wp-image-21126\" src=\"http://wptavern.com/wp-content/uploads/2014/04/WP39AudioPlaylists.png\" alt=\"Audio Playlist In The Visual Editor Of WordPress 3.9\" width=\"911\" height=\"464\" /></a><p class=\"wp-caption-text\">Audio Playlist In The Visual Editor Of WordPress 3.9</p></div>\n<h3>Searching For WordPress Themes Has Never Been Easier</h3>\n<p>The theme browsing experience in WordPress 3.8 has been significantly improved in 3.9. The new theme browser features large preview images, indicators on which themes you already have installed, and fast-loading previews. Browsing and installing new themes in WordPress has never been easier.</p>\n<div id=\"attachment_21121\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/04/WP39ThemeExperience.png\" rel=\"prettyphoto[19881]\"><img class=\"size-full wp-image-21121\" src=\"http://wptavern.com/wp-content/uploads/2014/04/WP39ThemeExperience.png\" alt=\"Theme Browser Experience Revamped In WordPress 3.9\" width=\"859\" height=\"503\" /></a><p class=\"wp-caption-text\">Theme Browser Experience Revamped In WordPress 3.9</p></div>\n<h3>Crop and Edit Images From Within The Visual Editor</h3>\n<p>Images are easier to edit and remove from posts. Simply click on the image within the visual editor and select the pencil icon. This will launch the image details screen. From here, you can quickly edit the details of the image and if you select the <strong>Edit Original button</strong>, you&#8217;ll be able to crop, flip, and change the image size. You can also drag and drop images right into the editor. Alternatively, you can crop and edit an image from within the visual editor.</p>\n<div id=\"attachment_21117\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/04/ImageEditingWP39.png\" rel=\"prettyphoto[19881]\"><img class=\"size-full wp-image-21117\" src=\"http://wptavern.com/wp-content/uploads/2014/04/ImageEditingWP39.png\" alt=\"Image Editing In WordPress 3.9\" width=\"818\" height=\"488\" /></a><p class=\"wp-caption-text\">Image Editing In WordPress 3.9</p></div>\n<p>Instead of seeing a placeholder, galleries can now be previewed as a grid within the visual editor. You cannot yet drag images around to change the display order, but this feature is expected to be added in a future update.</p>\n<div id=\"attachment_21116\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/04/LivePreviewGalleries.png\" rel=\"prettyphoto[19881]\"><img class=\"size-full wp-image-21116\" src=\"http://wptavern.com/wp-content/uploads/2014/04/LivePreviewGalleries.png\" alt=\"Preview Galleries Live Within The Visual Editor\" width=\"878\" height=\"625\" /></a><p class=\"wp-caption-text\">Preview Galleries Live Within The Visual Editor</p></div>\n<h3>Live Widget Previews</h3>\n<p>You can now preview changes to widgets in real-time thanks to the theme customizer. Gone are the days of having to refresh the page every time you want to preview a change to a widget.</p>\n<div id=\"attachment_21138\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/04/WP39LiveWidgetPreview.png\" rel=\"prettyphoto[19881]\"><img class=\"size-full wp-image-21138\" src=\"http://wptavern.com/wp-content/uploads/2014/04/WP39LiveWidgetPreview.png\" alt=\"WordPress 3.9 Live Widget Previews\" width=\"1150\" height=\"569\" /></a><p class=\"wp-caption-text\">WordPress 3.9 Live Widget Previews</p></div>\n<h3>A New Streamlined Post Editor</h3>\n<p>The post editor in WordPress 3.9 has been updated to use TinyMCE 4.0. The update provides the following enhancements:</p>\n<ul>\n<li>New UI and UI API.</li>\n<li>New theme.</li>\n<li>Revamped events system/API.</li>\n<li>Better code quality, readability and build process.</li>\n<li>Lots of (inline) documentation.</li>\n</ul>\n<p>The Paste from Word button has been removed. When text from Microsoft Word is pasted into WordPress, the editor will automatically strip out the special formatting. The distraction free writing mode button is now on the right side of the editor. Distraction free writing mode <a title=\"http://wptavern.com/distraction-free-writing-mode-will-be-responsive-in-wordpress-3-9\" href=\"http://wptavern.com/distraction-free-writing-mode-will-be-responsive-in-wordpress-3-9\">is also responsive</a>. The changes to the editor are a noticeable improvement when compared to WordPress 3.8.</p>\n<div id=\"attachment_21130\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/04/WP39TinyMCE40.png\" rel=\"prettyphoto[19881]\"><img class=\"size-full wp-image-21130\" src=\"http://wptavern.com/wp-content/uploads/2014/04/WP39TinyMCE40.png\" alt=\"TinyMCE 4.0 In WordPress 3.9\" width=\"683\" height=\"349\" /></a><p class=\"wp-caption-text\">TinyMCE 4.0 In WordPress 3.9</p></div>\n<h3>oEmbed Support Added For Meetup and Imgur</h3>\n<p>Publishing content from either Meetup.com or Imgur is now as simple as <a title=\"http://wptavern.com/wordpress-3-9-to-add-oembed-support-for-meetup-com-and-imgur\" href=\"http://wptavern.com/wordpress-3-9-to-add-oembed-support-for-meetup-com-and-imgur\">pasting the URL</a> into the editor. Meanwhile, oEmbed support for Qik has been removed.</p>\n<div id=\"attachment_20405\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/04/oembeddedurlformeetupevent2.png\" rel=\"prettyphoto[19881]\"><img class=\"size-full wp-image-20405\" src=\"http://wptavern.com/wp-content/uploads/2014/04/oembeddedurlformeetupevent2.png\" alt=\"Meetup Group Event Embedded Into A Post\" width=\"545\" height=\"255\" /></a><p class=\"wp-caption-text\">Meetup Group Event Embedded Into A Post</p></div>\n<h3>Take A Tour Of WordPress 3.9</h3>\n<p>Michael Pick does a great job showing and explaining the new features in WordPress 3.9.<br />\n</p>\n<h3>Important Information For WordPress Developers</h3>\n<p>There are a lot of under-the-hood improvements in WordPress 3.9. Over the past two-weeks, those responsible for adding specific features to WordPress have written detailed blog posts on the <a title=\"http://make.wordpress.org/core/\" href=\"http://make.wordpress.org/core/\">Make WordPress Core</a> development blog. Here is a list of noteworthy items you may have missed.</p>\n<p><a title=\"http://make.wordpress.org/core/2014/04/15/html5-galleries-captions-in-wordpress-3-9/\" href=\"http://make.wordpress.org/core/2014/04/15/html5-galleries-captions-in-wordpress-3-9/\">HTML5 Galleries and Captions in WordPress 3.9</a> &#8211; WordPress 3.6 introduced HTML5 versions of popular template tags, starting out with comments, the comment form, and the search form. With the 3.9 release the team added galleries and captions to that list. Now, when adding HTML5 support for those features, WordPress will use <code>&lt;figure&gt;</code> and <code>&lt;figcaption&gt;</code> elements, instead of the generic definition list markup.</p>\n<p><a title=\"http://make.wordpress.org/core/2014/04/14/symlinked-plugins-in-wordpress-3-9/\" href=\"http://make.wordpress.org/core/2014/04/14/symlinked-plugins-in-wordpress-3-9/\">Symlinked Plugins in WordPress 3.9</a> &#8211; One of the cool little features included with 3.9 is the ability to symlink plugin directories. While it has been possible to symlink plugins in the past, functions such as <code>plugins_url()</code> return the wrong URL, which causes breakage in most plugins. The team has corrected this with the help of a new function.</p>\n<p><a title=\"http://make.wordpress.org/core/2014/04/11/plupload-2-x-in-wordpress-3-9/\" href=\"http://make.wordpress.org/core/2014/04/11/plupload-2-x-in-wordpress-3-9/\">Plupload 2.x in WordPress 3.9</a> &#8211; Plupload is the library that powers most of the file upload interfaces in WordPress, and in 3.9 the team has updated the bundled library to version 2.1.1. This post lists some of the things that have changed, which may affect WordPress plugins and themes.</p>\n<p><a title=\"http://make.wordpress.org/core/2014/04/07/mysql-in-wordpress-3-9/\" href=\"http://make.wordpress.org/core/2014/04/07/mysql-in-wordpress-3-9/\">MySQL in WordPress 3.9</a> &#8211; In WordPress 3.9, we added an extra layer to WPDB, causing it to switch to using the mysqli PHP library, when using PHP 5.5 or higher. For plugin developers, this means that you absolutely shouldn’t be using PHP’s mysql_*() functions any more – you can use the equivalent WPDB functions instead.</p>\n<p><a title=\"http://make.wordpress.org/core/2014/03/27/masonry-in-wordpress-3-9/\" href=\"http://make.wordpress.org/core/2014/03/27/masonry-in-wordpress-3-9/\">Masonry in WordPress 3.9</a> &#8211; If you use Masonry in your themes or plugins, here’s what you should know about the 3.9 update.</p>\n<p><a title=\"http://make.wordpress.org/core/2014/03/27/tinymce-4-0-requires-textcss-for-editor-style-files/\" href=\"http://make.wordpress.org/core/2014/03/27/tinymce-4-0-requires-textcss-for-editor-style-files/\">TinyMCE 4.0 Requires text/css For Editor Style Files</a> &#8211; As of TinyMCE 4.0, the visual editor iframe now has an HTML5 document type (<code><!--<span class=\"hiddenSpellError\" pre=\"\"-->DOCTYPE html&gt;</code>). In this scenario, CSS files must be served with the <code>text/css</code> content type. A server will serve a <code>*.css</code> file with the proper content type, but if you’re using a PHP file for an editor style file, you need to be the one to do it.</p>\n<p><a title=\"http://make.wordpress.org/core/2014/04/16/multisite-changes-in-3-9/\" href=\"http://make.wordpress.org/core/2014/04/16/multisite-changes-in-3-9/\">Multisite Changes In 3.9</a> &#8211; Much of the bootstrap code for Multisite in ms-settings.php has been refactored in<a href=\"http://core.trac.wordpress.org/ticket/27003\"> #27003</a> with the intent to improve how we handle the detection of domains and paths for sites and networks in core. Several other smaller enhancements and bugs have been completed in this and in other tickets.</p>\n<p><a title=\"http://make.wordpress.org/core/2014/04/16/jquery-ui-and-wpdialogs-in-wordpress-3-9/\" href=\"http://make.wordpress.org/core/2014/04/16/jquery-ui-and-wpdialogs-in-wordpress-3-9/\">jQuery UI and wpdialogs in WordPress 3.9</a> &#8211; WordPress 3.9 does not use the “wpdialogs” TinyMCE plugin as part of the TinyMCE 4.0 update which comes with a new dialog manager.</p>\n<h3>Thanks To Everyone Who Contributed To 3.9</h3>\n<p>Although 3.9 doesn&#8217;t have a lot of <strong>new</strong> features, the refinements to existing functionality are just as satisfying. I&#8217;m happy to see a release where the focus was more on improving what WordPress already has versus adding new functionality. Even though the live previews of widgets is my favorite feature, several of the pesky bugs that were squashed are a close second.</p>\n<p>WordPress wouldn&#8217;t be what it is today without all of the awesome contributions from the community. Thanks to everyone who helped make 3.9 a reality! This release was led by <a href=\"http://nacin.com/\">Andrew Nacin</a> and <a href=\"http://www.getsource.net/\">Mike Schroder. </a>There are 267 contributors with props in this release, which is a new high for WordPress.</p>\n<p><strong>What is your favorite feature or enhancement in WordPress 3.9?</strong></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 16 Apr 2014 18:34:59 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:26;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"Dev Blog: WordPress 3.9 “Smith”\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3154\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"http://wordpress.org/news/2014/04/smith/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:22531:\"<p>Version 3.9 of WordPress, named &#8220;Smith&#8221; in honor of jazz organist <a href=\"http://en.wikipedia.org/wiki/Jimmy_Smith_(musician)\">Jimmy Smith</a>, is available <a href=\"http://wordpress.org/download/\">for download</a> or update in your WordPress dashboard. This release features a number of refinements that we hope you&#8217;ll love.</p>\n\n<h2 class=\"about-headline-callout\">A smoother media editing experience</h2>\n<div>\n<p><img class=\"alignright wp-image-3168\" src=\"http://wordpress.org/news/files/2014/04/editor1-300x233.jpg\" alt=\"editor\" width=\"228\" height=\"177\" /></p>\n<h3>Improved visual editing</h3>\n<p>The updated visual editor has improved speed, accessibility, and mobile support. You can paste into the visual editor from your word processor without wasting time to clean up messy styling. (Yeah, we’re talking about you, Microsoft Word.)</p>\n</div>\n<div></div>\n<div>\n<p><img class=\"alignright wp-image-3170\" src=\"http://wordpress.org/news/files/2014/04/image1-300x233.jpg\" alt=\"image\" width=\"228\" height=\"178\" /></p>\n<h3>Edit images easily</h3>\n<p>With quicker access to crop and rotation tools, it’s now much easier to edit your images while editing posts. You can also scale images directly in the editor to find just the right fit.</p>\n</div>\n<div></div>\n<div>\n<p><img class=\"alignright wp-image-3187\" src=\"http://wordpress.org/news/files/2014/04/dragdrop1-300x233.jpg\" alt=\"dragdrop\" width=\"228\" height=\"178\" /></p>\n<h3>Drag and drop your images</h3>\n<p>Uploading your images is easier than ever. Just grab them from your desktop and drop them in the editor.</p>\n</div>\n<div></div>\n<hr />\n<h2>Gallery previews</h2>\n<p><img class=\"aligncenter size-full wp-image-3169\" src=\"http://wordpress.org/news/files/2014/04/gallery1.jpg\" alt=\"gallery\" width=\"980\" height=\"550\" /></p>\n<p>Galleries display a beautiful grid of images right in the editor, just like they do in your published post.</p>\n<hr />\n<h2>Do more with audio and video</h2>\n\n<a href=\"http://wordpress.org/news/files/2014/04/AintMisbehavin.mp3\">Ain\'t Misbehavin\'</a>\n<a href=\"http://wordpress.org/news/files/2014/04/DavenportBlues.mp3\">Davenport Blues</a>\n<a href=\"http://wordpress.org/news/files/2014/04/JellyRollMorton-BuddyBoldensBlues.mp3\">Buddy Bolden\'s Blues</a>\n<a href=\"http://wordpress.org/news/files/2014/04/Johnny_Hodges_Orchestra-Squaty_Roo-1941.mp3\">Squaty Roo</a>\n<a href=\"http://wordpress.org/news/files/2014/04/Louisiana_Five-Dixie_Blues-1919.mp3\">Dixie Blues</a>\n<a href=\"http://wordpress.org/news/files/2014/04/WolverineBlues.mp3\">Wolverine Blues</a>\n\n<p>Images have galleries; now we’ve added simple audio and video playlists, so you can showcase your music and clips.</p>\n<hr />\n<h2>Live widget and header previews</h2>\n<div class=\"wp-video\"><!--[if lt IE 9]><script>document.createElement(\'video\');</script><![endif]-->\n<a href=\"http://wordpress.org/news/files/2014/04/widgets.mp4\">//wordpress.org/news/files/2014/04/widgets.mp4</a></div>\n<p>Add, edit, and rearrange your site’s widgets right in the theme customizer. No “save and surprise” — preview your changes live and only save them when you’re ready.</p>\n<p>The improved header image tool also lets you upload, crop, and manage headers while customizing your theme.</p>\n<hr />\n<h2>Stunning new theme browser</h2>\n<p><img class=\"aligncenter size-full wp-image-3172\" src=\"http://wordpress.org/news/files/2014/04/theme1.jpg\" alt=\"theme\" width=\"1003\" height=\"558\" /><br />\nLooking for a new theme should be easy and fun. Lose yourself in the boundless supply of free WordPress.org themes with the beautiful new theme browser.</p>\n<hr />\n<h2>The Crew</h2>\n<p>This release was led by <a href=\"http://nacin.com/\">Andrew Nacin</a> and <a href=\"http://www.getsource.net/\">Mike Schroder</a>, with the help of these fine individuals. There are 267 contributors with props in this release, a new high:</p>\n<p><a href=\"http://profiles.wordpress.org/aaroncampbell\">Aaron D. Campbell</a>, <a href=\"http://profiles.wordpress.org/jorbin\">Aaron Jorbin</a>, <a href=\"http://profiles.wordpress.org/kawauso\">Adam Harley</a>, <a href=\"http://profiles.wordpress.org/adamsilverstein\">Adam Silverstein</a>, <a href=\"http://profiles.wordpress.org/adelval\">adelval</a>, <a href=\"http://profiles.wordpress.org/ajay\">Ajay</a>, <a href=\"http://profiles.wordpress.org/akeda\">Akeda Bagus</a>, <a href=\"http://profiles.wordpress.org/xknown\">Alex Concha</a>, <a href=\"http://profiles.wordpress.org/aliso\">Alison Barrett</a>, <a href=\"http://profiles.wordpress.org/collinsinternet\">Allan Collins</a>, <a href=\"http://profiles.wordpress.org/sabreuse\">Amy Hendrix (sabreuse)</a>, <a href=\"http://profiles.wordpress.org/afercia\">Andrea Fercia</a>, <a href=\"http://profiles.wordpress.org/nacin\">Andrew Nacin</a>, <a href=\"http://profiles.wordpress.org/norcross\">Andrew Norcross</a>, <a href=\"http://profiles.wordpress.org/azaozz\">Andrew Ozz</a>, <a href=\"http://profiles.wordpress.org/rarst\">Andrey \"Rarst\" Savchenko</a>, <a href=\"http://profiles.wordpress.org/andykeith\">Andy Keith</a>, <a href=\"http://profiles.wordpress.org/andy\">Andy Skelton</a>, <a href=\"http://profiles.wordpress.org/atimmer\">Anton Timmermans</a>, <a href=\"http://profiles.wordpress.org/aubreypwd\">Aubrey Portwood</a>, <a href=\"http://profiles.wordpress.org/barry\">Barry</a>, <a href=\"http://profiles.wordpress.org/toszcze\">Bartosz Romanowski</a>, <a href=\"http://profiles.wordpress.org/bassgang\">bassgang</a>, <a href=\"http://profiles.wordpress.org/bcworkz\">bcworkz</a>, <a href=\"http://profiles.wordpress.org/empireoflight\">Ben Dunkle</a>, <a href=\"http://profiles.wordpress.org/neoxx\">Bernhard Riedl</a>, <a href=\"http://profiles.wordpress.org/bigdawggi\">bigdawggi</a>, <a href=\"http://profiles.wordpress.org/bobbravo2\">Bob Gregor</a>, <a href=\"http://profiles.wordpress.org/bobbingwide\">bobbingwide</a>, <a href=\"http://profiles.wordpress.org/bradt\">Brad Touesnard</a>, <a href=\"http://profiles.wordpress.org/bradparbs\">bradparbs</a>, <a href=\"http://profiles.wordpress.org/bramd\">bramd</a>, <a href=\"http://profiles.wordpress.org/kraftbj\">Brandon Kraft</a>, <a href=\"http://profiles.wordpress.org/brasofilo\">brasofilo</a>, <a href=\"http://profiles.wordpress.org/bravokeyl\">bravokeyl</a>, <a href=\"http://profiles.wordpress.org/bpetty\">Bryan Petty</a>, <a href=\"http://profiles.wordpress.org/cgaffga\">cgaffga</a>, <a href=\"http://profiles.wordpress.org/chiragswadia\">Chirag Swadia</a>, <a href=\"http://profiles.wordpress.org/chouby\">Chouby</a>, <a href=\"http://profiles.wordpress.org/ehg\">Chris Blower</a>, <a href=\"http://profiles.wordpress.org/c3mdigital\">Chris Olbekson</a>, <a href=\"http://profiles.wordpress.org/chrisscott\">Chris Scott</a>, <a href=\"http://profiles.wordpress.org/chriseverson\">chriseverson</a>, <a href=\"http://profiles.wordpress.org/chrisguitarguy\">chrisguitarguy</a>, <a href=\"http://profiles.wordpress.org/cfinke\">Christopher Finke</a>, <a href=\"http://profiles.wordpress.org/ciantic\">ciantic</a>, <a href=\"http://profiles.wordpress.org/cmmarslender\">cmmarslender</a>, <a href=\"http://profiles.wordpress.org/antorome\">Comparativa de Bancos</a>, <a href=\"http://profiles.wordpress.org/cojennin\">Connor Jennings</a>, <a href=\"http://profiles.wordpress.org/corvannoorloos\">Cor van Noorloos</a>, <a href=\"http://profiles.wordpress.org/corphi\">Corphi</a>, <a href=\"http://profiles.wordpress.org/cramdesign\">cramdesign</a>, <a href=\"http://profiles.wordpress.org/danielbachhuber\">Daniel Bachhuber</a>, <a href=\"http://profiles.wordpress.org/redsweater\">Daniel Jalkut (Red Sweater)</a>, <a href=\"http://profiles.wordpress.org/dannydehaan\">Danny de Haan</a>, <a href=\"http://profiles.wordpress.org/koop\">Daryl Koopersmith</a>, <a href=\"http://profiles.wordpress.org/eightface\">Dave Kellam (eightface)</a>, <a href=\"http://profiles.wordpress.org/dpe415\">DaveE</a>, <a href=\"http://profiles.wordpress.org/davidakennedy\">David A. Kennedy</a>, <a href=\"http://profiles.wordpress.org/davidanderson\">David Anderson</a>, <a href=\"http://profiles.wordpress.org/davidmarichal\">David Marichal</a>, <a href=\"http://profiles.wordpress.org/denis-de-bernardy\">Denis de Bernardy</a>, <a href=\"http://profiles.wordpress.org/dd32\">Dion Hulse</a>, <a href=\"http://profiles.wordpress.org/ocean90\">Dominik Schilling</a>, <a href=\"http://profiles.wordpress.org/dougwollison\">Doug Wollison</a>, <a href=\"http://profiles.wordpress.org/drewapicture\">Drew Jaynes</a>, <a href=\"http://profiles.wordpress.org/drprotocols\">DrProtocols</a>, <a href=\"http://profiles.wordpress.org/dustyf\">Dustin Filippini</a>, <a href=\"http://profiles.wordpress.org/eatingrules\">eatingrules</a>, <a href=\"http://profiles.wordpress.org/plocha\">edik</a>, <a href=\"http://profiles.wordpress.org/eliorivero\">Elio Rivero</a>, <a href=\"http://profiles.wordpress.org/enej\">enej</a>, <a href=\"http://profiles.wordpress.org/ericlewis\">Eric Andrew Lewis</a>, <a href=\"http://profiles.wordpress.org/ericmann\">Eric Mann</a>, <a href=\"http://profiles.wordpress.org/evarlese\">Erica Varlese</a>, <a href=\"http://profiles.wordpress.org/ethitter\">Erick Hitter</a>, <a href=\"http://profiles.wordpress.org/ejdanderson\">Evan Anderson</a>, <a href=\"http://profiles.wordpress.org/fahmiadib\">Fahmi</a>, <a href=\"http://profiles.wordpress.org/fboender\">fboender</a>, <a href=\"http://profiles.wordpress.org/frank-klein\">Frank Klein</a>, <a href=\"http://profiles.wordpress.org/garyc40\">Gary Cao</a>, <a href=\"http://profiles.wordpress.org/garyj\">Gary Jones</a>, <a href=\"http://profiles.wordpress.org/pento\">Gary Pendergast</a>, <a href=\"http://profiles.wordpress.org/genkisan\">genkisan</a>, <a href=\"http://profiles.wordpress.org/soulseekah\">Gennady Kovshenin</a>, <a href=\"http://profiles.wordpress.org/georgestephanis\">George Stephanis</a>, <a href=\"http://profiles.wordpress.org/grahamarmfield\">Graham Armfield</a>, <a href=\"http://profiles.wordpress.org/vancoder\">Grant Mangham</a>, <a href=\"http://profiles.wordpress.org/gcorne\">Gregory Cornelius</a>, <a href=\"http://profiles.wordpress.org/tivnet\">Gregory Karpinsky</a>, <a href=\"http://profiles.wordpress.org/hakre\">hakre</a>, <a href=\"http://profiles.wordpress.org/hanni\">hanni</a>, <a href=\"http://profiles.wordpress.org/helen\">Helen Hou-Sandí</a>, <a href=\"http://profiles.wordpress.org/ippetkov\">ippetkov</a>, <a href=\"http://profiles.wordpress.org/ipstenu\">Ipstenu (Mika Epstein)</a>, <a href=\"http://profiles.wordpress.org/jdgrimes\">J.D. Grimes</a>, <a href=\"http://profiles.wordpress.org/jackreichert\">Jack Reichert</a>, <a href=\"http://profiles.wordpress.org/_jameslee\">jameslee</a>, <a href=\"http://profiles.wordpress.org/avryl\">Janneke Van Dorpe</a>, <a href=\"http://profiles.wordpress.org/janrenn\">janrenn</a>, <a href=\"http://profiles.wordpress.org/jaycc\">JayCC</a>, <a href=\"http://profiles.wordpress.org/jeffsebring\">Jeff Sebring</a>, <a href=\"http://profiles.wordpress.org/jenmylo\">Jen Mylo</a>, <a href=\"http://profiles.wordpress.org/jeremyfelt\">Jeremy Felt</a>, <a href=\"http://profiles.wordpress.org/jesin\">Jesin A</a>, <a href=\"http://profiles.wordpress.org/jayjdk\">Jesper Johansen (jayjdk)</a>, <a href=\"http://profiles.wordpress.org/jnielsendotnet\">jnielsendotnet</a>, <a href=\"http://profiles.wordpress.org/jartes\">Joan Artes</a>, <a href=\"http://profiles.wordpress.org/joedolson\">Joe Dolson</a>, <a href=\"http://profiles.wordpress.org/joehoyle\">Joe Hoyle</a>, <a href=\"http://profiles.wordpress.org/johnbillion\">John Blackbourn</a>, <a href=\"http://profiles.wordpress.org/johnjamesjacoby\">John James Jacoby</a>, <a href=\"http://profiles.wordpress.org/johnpbloch\">John P. Bloch</a>, <a href=\"http://profiles.wordpress.org/johnregan3\">John Regan</a>, <a href=\"http://profiles.wordpress.org/duck_\">Jon Cave</a>, <a href=\"http://profiles.wordpress.org/jond3r\">Jonas Bolinder (jond3r)</a>, <a href=\"http://profiles.wordpress.org/joostdevalk\">Joost de Valk</a>, <a href=\"http://profiles.wordpress.org/shelob9\">Josh Pollock</a>, <a href=\"http://profiles.wordpress.org/joshuaabenazer\">Joshua Abenazer</a>, <a href=\"http://profiles.wordpress.org/jstraitiff\">jstraitiff</a>, <a href=\"http://profiles.wordpress.org/juliobox\">Julio Potier</a>, <a href=\"http://profiles.wordpress.org/kopepasah\">Justin Kopepasah</a>, <a href=\"http://profiles.wordpress.org/justinsainton\">Justin Sainton</a>, <a href=\"http://profiles.wordpress.org/kadamwhite\">K.Adam White</a>, <a href=\"http://profiles.wordpress.org/trepmal\">Kailey (trepmal)</a>, <a href=\"http://profiles.wordpress.org/kasparsd\">Kaspars</a>, <a href=\"http://profiles.wordpress.org/ryelle\">Kelly Dwan</a>, <a href=\"http://profiles.wordpress.org/kerikae\">kerikae</a>, <a href=\"http://profiles.wordpress.org/kworthington\">Kevin Worthington</a>, <a href=\"http://profiles.wordpress.org/kpdesign\">Kim Parsell</a>, <a href=\"http://profiles.wordpress.org/kwight\">Kirk Wight</a>, <a href=\"http://profiles.wordpress.org/kitchin\">kitchin</a>, <a href=\"http://profiles.wordpress.org/klihelp\">klihelp</a>, <a href=\"http://profiles.wordpress.org/knutsp\">Knut Sparhell</a>, <a href=\"http://profiles.wordpress.org/kovshenin\">Konstantin Kovshenin</a>, <a href=\"http://profiles.wordpress.org/obenland\">Konstantin Obenland</a>, <a href=\"http://profiles.wordpress.org/drozdz\">Krzysiek Drozdz</a>, <a href=\"http://profiles.wordpress.org/lancewillett\">Lance Willett</a>, <a href=\"http://profiles.wordpress.org/leewillis77\">Lee Willis</a>, <a href=\"http://profiles.wordpress.org/lkwdwrd\">lkwdwrd</a>, <a href=\"http://profiles.wordpress.org/lpointet\">lpointet</a>, <a href=\"http://profiles.wordpress.org/ldebrouwer\">Luc De Brouwer</a>, <a href=\"http://profiles.wordpress.org/spmlucas\">Lucas Karpiuk</a>, <a href=\"http://profiles.wordpress.org/mark8barnes\">Mark Barnes</a>, <a href=\"http://profiles.wordpress.org/markjaquith\">Mark Jaquith</a>, <a href=\"http://profiles.wordpress.org/markoheijnen\">Marko Heijnen</a>, <a href=\"http://profiles.wordpress.org/marventus\">Marventus</a>, <a href=\"http://profiles.wordpress.org/iammattthomas\">Matt (Thomas) Miklic</a>, <a href=\"http://profiles.wordpress.org/mjbanks\">Matt Banks</a>, <a href=\"http://profiles.wordpress.org/matt\">Matt Mullenweg</a>, <a href=\"http://profiles.wordpress.org/mboynes\">Matthew Boynes</a>, <a href=\"http://profiles.wordpress.org/mdbitz\">Matthew Denton</a>, <a href=\"http://profiles.wordpress.org/mattheu\">Matthew Haines-Young</a>, <a href=\"http://profiles.wordpress.org/mattonomics\">mattonomics</a>, <a href=\"http://profiles.wordpress.org/mattyrob\">mattyrob</a>, <a href=\"http://profiles.wordpress.org/matveb\">Matías Ventura</a>, <a href=\"http://profiles.wordpress.org/maxcutler\">Max Cutler</a>, <a href=\"http://profiles.wordpress.org/mcadwell\">mcadwell</a>, <a href=\"http://profiles.wordpress.org/melchoyce\">Mel Choyce</a>, <a href=\"http://profiles.wordpress.org/meloniq\">meloniq</a>, <a href=\"http://profiles.wordpress.org/michael-arestad\">Michael Arestad</a>, <a href=\"http://profiles.wordpress.org/michelwppi\">Michel - xiligroup dev</a>, <a href=\"http://profiles.wordpress.org/mcsf\">Miguel Fonseca</a>, <a href=\"http://profiles.wordpress.org/gradyetc\">Mike Burns</a>, <a href=\"http://profiles.wordpress.org/mikehansenme\">Mike Hansen</a>, <a href=\"http://profiles.wordpress.org/mikemanger\">Mike Manger</a>, <a href=\"http://profiles.wordpress.org/mikeschinkel\">Mike Schinkel</a>, <a href=\"http://profiles.wordpress.org/dh-shredder\">Mike Schroder</a>, <a href=\"http://profiles.wordpress.org/mikecorkum\">mikecorkum</a>, <a href=\"http://profiles.wordpress.org/mitchoyoshitaka\">mitcho (Michael Yoshitaka Erlewine)</a>, <a href=\"http://profiles.wordpress.org/batmoo\">Mohammad Jangda</a>, <a href=\"http://profiles.wordpress.org/morganestes\">Morgan Estes</a>, <a href=\"http://profiles.wordpress.org/mor10\">Morten Rand-Hendriksen</a>, <a href=\"http://profiles.wordpress.org/Nao\">Naoko Takano</a>, <a href=\"http://profiles.wordpress.org/alex-ye\">Nashwan Doaqan</a>, <a href=\"http://profiles.wordpress.org/nendeb55\">nendeb55</a>, <a href=\"http://profiles.wordpress.org/celloexpressions\">Nick Halsey</a>, <a href=\"http://profiles.wordpress.org/nicolealleyinteractivecom\">Nicole Arnold</a>, <a href=\"http://profiles.wordpress.org/nikv\">Nikhil Vimal (NikV)</a>, <a href=\"http://profiles.wordpress.org/nivijah\">nivijah</a>, <a href=\"http://profiles.wordpress.org/nofearinc\">nofearinc</a>, <a href=\"http://profiles.wordpress.org/nunomorgadinho\">Nuno Morgadinho</a>, <a href=\"http://profiles.wordpress.org/olivm\">olivM</a>, <a href=\"http://profiles.wordpress.org/jbkkd\">Omer Korner</a>, <a href=\"http://profiles.wordpress.org/originalexe\">OriginalEXE</a>, <a href=\"http://profiles.wordpress.org/oso96_2000\">oso96_2000</a>, <a href=\"http://profiles.wordpress.org/patricknami\">patricknami</a>, <a href=\"http://profiles.wordpress.org/djpaul\">Paul Gibbs</a>, <a href=\"http://profiles.wordpress.org/paulwilde\">Paul Wilde</a>, <a href=\"http://profiles.wordpress.org/pavelevap\">pavelevap</a>, <a href=\"http://profiles.wordpress.org/pbearne\">Pbearne</a>, <a href=\"http://profiles.wordpress.org/westi\">Peter Westwood</a>, <a href=\"http://profiles.wordpress.org/philiparthurmoore\">Philip Arthur Moore</a>, <a href=\"http://profiles.wordpress.org/mordauk\">Pippin Williamson</a>, <a href=\"http://profiles.wordpress.org/nprasath002\">Prasath Nadarajah</a>, <a href=\"http://profiles.wordpress.org/prettyboymp\">prettyboymp</a>, <a href=\"http://profiles.wordpress.org/raamdev\">Raam Dev</a>, <a href=\"http://profiles.wordpress.org/rachelbaker\">rachelbaker</a>, <a href=\"http://profiles.wordpress.org/mauryaratan\">Ram Ratan Maurya</a>, <a href=\"http://profiles.wordpress.org/ramonchiara\">ramonchiara</a>, <a href=\"http://profiles.wordpress.org/ounziw\">Rescuework Support</a>, <a href=\"http://profiles.wordpress.org/rhyswynne\">Rhys Wynne</a>, <a href=\"http://profiles.wordpress.org/ricardocorreia\">Ricardo Correia</a>, <a href=\"http://profiles.wordpress.org/theorboman\">Richard Sweeney</a>, <a href=\"http://profiles.wordpress.org/iamfriendly\">Richard Tape</a>, <a href=\"http://profiles.wordpress.org/richard2222\">richard2222</a>, <a href=\"http://profiles.wordpress.org/rickalee\">Ricky Lee Whittemore</a>, <a href=\"http://profiles.wordpress.org/miqrogroove\">Robert Chapin</a>, <a href=\"http://profiles.wordpress.org/robmiller\">robmiller</a>, <a href=\"http://profiles.wordpress.org/rodrigosprimo\">Rodrigo Primo</a>, <a href=\"http://profiles.wordpress.org/romaimperator\">romaimperator</a>, <a href=\"http://profiles.wordpress.org/roothorick\">roothorick</a>, <a href=\"http://profiles.wordpress.org/ruudjoyo\">ruud@joyo</a>, <a href=\"http://profiles.wordpress.org/ryan\">Ryan Boren</a>, <a href=\"http://profiles.wordpress.org/rmccue\">Ryan McCue</a>, <a href=\"http://profiles.wordpress.org/salcode\">salcode</a>, <a href=\"http://profiles.wordpress.org/otto42\">Samuel Wood (Otto)</a>, <a href=\"http://profiles.wordpress.org/sandyr\">Sandeep</a>, <a href=\"http://profiles.wordpress.org/scottlee\">Scott Lee</a>, <a href=\"http://profiles.wordpress.org/coffee2code\">Scott Reilly</a>, <a href=\"http://profiles.wordpress.org/wonderboymusic\">Scott Taylor</a>, <a href=\"http://profiles.wordpress.org/greglone\">ScreenfeedFr</a>, <a href=\"http://profiles.wordpress.org/scribu\">scribu</a>, <a href=\"http://profiles.wordpress.org/sdasse\">sdasse</a>, <a href=\"http://profiles.wordpress.org/bootsz\">Sean Butze</a>, <a href=\"http://profiles.wordpress.org/seanchayes\">Sean Hayes</a>, <a href=\"http://profiles.wordpress.org/nessworthy\">Sean Nessworthy</a>, <a href=\"http://profiles.wordpress.org/sergeybiryukov\">Sergey Biryukov</a>, <a href=\"http://profiles.wordpress.org/shahpranaf\">shahpranaf</a>, <a href=\"http://profiles.wordpress.org/shaunandrews\">Shaun Andrews</a>, <a href=\"http://profiles.wordpress.org/shinichin\">ShinichiN</a>, <a href=\"http://profiles.wordpress.org/pross\">Simon Prosser</a>, <a href=\"http://profiles.wordpress.org/simonwheatley\">Simon Wheatley</a>, <a href=\"http://profiles.wordpress.org/siobhan\">Siobhan</a>, <a href=\"http://profiles.wordpress.org/siobhyb\">Siobhan Bamber (siobhyb)</a>, <a href=\"http://profiles.wordpress.org/sirzooro\">sirzooro</a>, <a href=\"http://profiles.wordpress.org/solarissmoke\">solarissmoke</a>, <a href=\"http://profiles.wordpress.org/sonjanyc\">sonjanyc</a>, <a href=\"http://profiles.wordpress.org/spencerfinnell\">Spencer Finnell</a>, <a href=\"http://profiles.wordpress.org/piontkowski\">Spencer Piontkowski</a>, <a href=\"http://profiles.wordpress.org/stephcook22\">stephcook22</a>, <a href=\"http://profiles.wordpress.org/netweb\">Stephen Edgar</a>, <a href=\"http://profiles.wordpress.org/stephenharris\">Stephen Harris</a>, <a href=\"http://profiles.wordpress.org/sbruner\">Steve Bruner</a>, <a href=\"http://profiles.wordpress.org/stevenkword\">Steven Word</a>, <a href=\"http://profiles.wordpress.org/miyauchi\">Takayuki Miyauchi</a>, <a href=\"http://profiles.wordpress.org/tanner-m\">Tanner Moushey</a>, <a href=\"http://profiles.wordpress.org/tlovett1\">Taylor Lovett</a>, <a href=\"http://profiles.wordpress.org/tbrams\">tbrams</a>, <a href=\"http://profiles.wordpress.org/tellyworth\">tellyworth</a>, <a href=\"http://profiles.wordpress.org/tobiasbg\">TobiasBg</a>, <a href=\"http://profiles.wordpress.org/tomauger\">Tom Auger</a>, <a href=\"http://profiles.wordpress.org/willmot\">Tom Willmot</a>, <a href=\"http://profiles.wordpress.org/topher1kenobe\">Topher</a>, <a href=\"http://profiles.wordpress.org/topquarky\">topquarky</a>, <a href=\"http://profiles.wordpress.org/zodiac1978\">Torsten Landsiedel</a>, <a href=\"http://profiles.wordpress.org/toru\">Toru</a>, <a href=\"http://profiles.wordpress.org/wpsmith\">Travis Smith</a>, <a href=\"http://profiles.wordpress.org/umeshsingla\">Umesh Kumar</a>, <a href=\"http://profiles.wordpress.org/undergroundnetwork\">undergroundnetwork</a>, <a href=\"http://profiles.wordpress.org/varunagw\">VarunAgw</a>, <a href=\"http://profiles.wordpress.org/wawco\">wawco</a>, <a href=\"http://profiles.wordpress.org/westonruter\">Weston Ruter</a>, <a href=\"http://profiles.wordpress.org/wokamoto\">wokamoto</a>, <a href=\"http://profiles.wordpress.org/xsonic\">xsonic</a>, <a href=\"http://profiles.wordpress.org/yoavf\">Yoav Farhi</a>, <a href=\"http://profiles.wordpress.org/yurivictor\">Yuri Victor</a>, <a href=\"http://profiles.wordpress.org/zbtirrell\">Zach Tirrell</a>, and <a href=\"http://profiles.wordpress.org/vanillalounge\">Ze Fontainhas</a>. Also thanks to <a href=\"http://michaelpick.wordpress.com/\">Michael Pick</a> for producing the release video.</p>\n<p>If you want to follow along or help out, check out <a href=\"http://make.wordpress.org/\">Make WordPress</a> and our <a href=\"http://make.wordpress.org/core/\">core development blog</a>. Thanks for choosing WordPress. See you soon for version 4.0!</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 16 Apr 2014 18:33:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:27;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:92:\"WPTavern: BuddyPress 2.0 Released: Big Performance Improvements and New Administration Tools\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=21201\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:226:\"http://wptavern.com/buddypress-2-0-released-big-performance-improvements-and-new-administration-tools?utm_source=rss&utm_medium=rss&utm_campaign=buddypress-2-0-released-big-performance-improvements-and-new-administration-tools\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4710:\"<p>BuddyPress 2.0 &#8220;<a href=\"http://buddypress.org/2014/04/buddypress-2-0-juliana/\" target=\"_blank\">Juliana</a>&#8221; arrived on schedule today, less than a week after the plugin crossed <a href=\"http://wptavern.com/major-milestone-for-buddypress-2-million-downloads-and-counting\" target=\"_blank\">two million downloads</a>. This release focused heavily on improving BuddyPress performance, adding new administrative tools and enhancing the activity stream. It&#8217;s named for <a href=\"http://julianaspizza.com/\" target=\"_blank\">Juliana’s Pizza</a> in Brooklyn, NY, a pizza joint that is special to members of the core development team.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/buddypress20.png\" rel=\"prettyphoto[21201]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/buddypress20.png\" alt=\"buddypress20\" width=\"1555\" height=\"1305\" class=\"aligncenter size-full wp-image-21202\" /></a></p>\n<h3>Performance Improvements</h3>\n<p>One of the major highlights of this release is the <a href=\"http://wptavern.com/ http://wptavern.com/buddypress-2-0-ramps-up-performance-reduces-footprint-by-up-to-75\" target=\"_blank\">massive improvement in performance</a>, especially as it relates to Members and Activity directories. BuddyPress 2.0 improves MySQL efficiency, decreasing queries by up to 75% and reducing query time by up to 71%, depending on the your site&#8217;s hosting environment. If your site uses advanced caching systems, such as APC and Memcached, expect a performance increase here, as 2.0 completely overhauls how these are utilized.</p>\n<h3>New BuddyPress Administration Tools</h3>\n<p>BuddyPress 2.0 introduces a host of new administration tools that make it easier to manage communities. Administrators can now <a href=\"http://wptavern.com/buddypress-2-0-to-add-profile-editing-in-the-wordpress-admin\" target=\"_blank\">edit member profiles</a> in the WordPress admin. This release also ships with a new <a href=\"http://wptavern.com/buddypress-2-0-to-add-signups-administration-screen\" target=\"_blank\">signups administration screen</a> that allows administrators to track the status of pending accounts and facilitate the signup process.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/03/signups-featured.jpg\" rel=\"prettyphoto[21201]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/03/signups-featured.jpg\" alt=\"signups-featured\" width=\"800\" height=\"438\" class=\"aligncenter size-full wp-image-19429\" /></a></p>\n<p>Community managers will be pleased to know that version 2.0 provides <a href=\"http://wptavern.com/buddypress-2-0-to-add-better-spam-management-capabilities-for-administrators\" target=\"_blank\">better spam management capabilities</a> with the ability to mark users as ham/spam within the admin users panel, a feature that was previously only available on multisite installations.</p>\n<p>Version 2.0 includes a handy new &#8220;Repair Tools&#8221; menu at Dashboard > Tools > BuddyPress. This menu makes it easy to correct data that can sometimes get out of sync on BuddyPress sites.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/buddypress-tools.jpg\" rel=\"prettyphoto[21201]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/buddypress-tools.jpg\" alt=\"buddypress-tools\" width=\"750\" height=\"516\" class=\"aligncenter size-full wp-image-21219\" /></a></p>\n<h3>Improved Activity Stream</h3>\n<p>The activity stream has received a few enhancements in 2.0. It will now automatically let you know when new items are ready to be loaded. It&#8217;s also much better integrated with blog posts. Comments are synced across blog-related activity items and the actual post itself. This unifies conversations that take place in different areas on a BP site.</p>\n<p>The activity stream will also play better with translations. Given that roughly half of BuddyPress installs are in a language other than English, this is a nice update. Check out this demo video created by <a href=\"https://twitter.com/BoweFrankema/status/455055453706526721\" target=\"_blank\">Bowe Frankema</a> to see how that works.</p>\n<p></p>\n<p></p>\n<p>Improvements in BuddyPress 2.0 help the social features to really shine and make community management more efficient for administrators. The plugin has come a long way since <a href=\"http://buddypress.org/2009/04/buddypress-10-has-arrived/\" target=\"_blank\">version 1.0</a> was released almost five years ago. The BuddyPress community has grown and thanks to the work of 42 volunteer contributors, 2.0 is ready for download today. Check out the full <a href=\"http://codex.buddypress.org/developer/releases/version-2-0/\" target=\"_blank\">2.0 changelog</a> to see everything that&#8217;s new and improved.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 16 Apr 2014 15:53:29 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:28;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"BuddyPress: BuddyPress 2.0 “Juliana”\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://buddypress.org/?p=181333\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"http://buddypress.org/2014/04/buddypress-2-0-juliana/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:10225:\"<p>The BuddyPress team is thrilled to announce that BuddyPress 2.0 &#8220;Juliana&#8221; is now available!</p>\n<p>This release focuses on administrative tools, performance, and improvements to the activity stream. Let&#8217;s take a look at some of the highlights.</p>\n<div></div>\n<h4>New Administrative Tools</h4>\n<p>If you manage a BuddyPress-powered community, BuddyPress 2.0 is for you. We have built a number of new tools that simplify and centralize common administrative tasks:</p>\n<ul>\n<li><em>Profile editing</em> &#8211; Need to manage a user&#8217;s profile information? We&#8217;ve integrated a new &#8220;Extended Profile&#8221; tab into the Dashboard &gt; Users interface, where you can manage profile data, avatars, user status, and more.<br /><a href=\"http://buddypress.org/wp-content/uploads/1/2014/04/admin-xprofile.jpg\"><img src=\"http://buddypress.org/wp-content/uploads/1/2014/04/admin-xprofile-300x206.jpg\" alt=\"admin-xprofile\" width=\"300\" height=\"206\" class=\"alignleft size-medium wp-image-181344\" /></a>\n  </li>\n<li><em>Spam User Management</em> &#8211; WordPress Multisite has long had the ability to manage spam users from the Dashboard. We&#8217;ve brought the same capabilities to non-Multisite installations. <br />\n<a href=\"http://buddypress.org/wp-content/uploads/1/2014/04/user-mark-spam.jpg\"><img src=\"http://buddypress.org/wp-content/uploads/1/2014/04/user-mark-spam-300x206.jpg\" alt=\"user-mark-spam\" class=\"size-thumbnail wp-image-181342\" /></a>\n  </li>\n<div> </div>\n<li><em>Pending Users</em> &#8211; The Pending users tab in Dashboard &gt; Users lets you see a list of signups that have not yet been activated. You can also perform useful tasks like manual account activation and resending activation emails. <br /><a href=\"http://buddypress.org/wp-content/uploads/1/2014/04/users-pending.jpg\"><img src=\"http://buddypress.org/wp-content/uploads/1/2014/04/users-pending-300x206.jpg\" alt=\"users-pending\" class=\"size-thumbnail wp-image-181343\" /></a>\n  </li>\n<li><em>Repair Tools</em> &#8211; Occasionally, BP friend counts and other data can get out of sync. The new Tools screen lets admins manually reset these values. <br /><a href=\"http://buddypress.org/wp-content/uploads/1/2014/04/tools-buddypress.jpg\"><img src=\"http://buddypress.org/wp-content/uploads/1/2014/04/tools-buddypress-300x206.jpg\" alt=\"tools-buddypress\" class=\"size-thumbnail wp-image-181341\" /></a>\n  </li>\n</ul>\n<div></div>\n<h4>Performance Improvements</h4>\n<p>The most successful BuddyPress sites are highly dynamic, with a steady stream of new visitors and new content. This dynamic nature means that BuddyPress is a highly database-driven platform, and database performance is often a bottleneck when it comes to scaling BP sites. BuddyPress 2.0 tackles this problem head-on. We&#8217;ve streamlined some of the most common problematic queries &#8211; such as those in the Members and Activity directories &#8211; to shave up to 95% of the query time off of certain individual queries. The sheer number of queries has been dramatically reduced as well, so that single page views access the database up to 50% less than in BP 1.9. And we&#8217;ve totally overhauled the way that BuddyPress utilizes advanced caching systems like APC and Memcached, so that users of these systems will see up to 75% fewer cache misses on costly queries.</p>\n<p>If you&#8217;re a BuddyPress developer or site administrator, you can get more in-depth explanation of changes and an overview of selected benchmarks <a href=\"http://bpdevel.wordpress.com/2014/04/02/one-of-the-primary-focuses/\">in this post on bpdevel.wordpress.com</a>. If you are a BuddyPress user, you can just sit back and enjoy the speedier pageloads and reduced server overhead of your BuddyPress 2.0 site!</p>\n<div></div>\n<h4>Activity Stream Enhancements</h4>\n<p>Spend a lot of time viewing the activity stream? BuddyPress 2.0 automatically lets you know when new items are ready to be loaded.</p>\n<p><a href=\"http://buddypress.org/wp-content/uploads/1/2014/04/load-newest.jpg\"><img src=\"http://buddypress.org/wp-content/uploads/1/2014/04/load-newest.jpg\" alt=\"load-newest\" width=\"558\" height=\"302\" class=\"size-full wp-image-181356\" /></a></p>\n<p>The activity stream is better integrated with blog posts, too. Comment on a blog post, and an activity item is posted. Comment on a blog-related activity item, and a blog comment is posted. No more worrying about fractured conversations.</p>\n<p>We’ve also reworked the way that phrases like &#8220;Boone posted an update&#8221; are handled, so that they’re always up-to-date and always translatable.</p>\n<div></div>\n<h4>And much more</h4>\n<p>BuddyPress 2.0 introduces dozens more small features, and fixes scores of bugs. We&#8217;ve compiled <a href=\"http://codex.buddypress.org/developer/releases/version-2-0/\">a complete 2.0 changelog</a> on the BuddyPress Codex.</p>\n<div></div>\n<h4>Juliana is Number Two</h4>\n<p>BuddyPress 2.0 is named for <a href=\"http://julianaspizza.com/\">Juliana&#8217;s Pizza</a> in Brooklyn, NY. Juliana&#8217;s is the second pizza establishment opened in the same location by master pizzaiolo Patsy Grimaldi (it&#8217;s a long story), and was also the locale for a serious BuddyPress powwow and up-close dining experience by two members of the core team. For these reasons (not to mention the outstanding pizza) we think that BuddyPress 2.0 &#8220;Juliana&#8221; has a special ring to it.</p>\n<div></div>\n<h4>Thanks, thanks, and more thanks</h4>\n<p>BuddyPress is built, with love, by a worldwide network of volunteers. The following people contributed patches during the BuddyPress 2.0 development cycle:</p>\n<p><a href=\"https://profiles.wordpress.org/boonebgorges/\">boonebgorges</a>, <a href=\"https://profiles.wordpress.org/Bowromir/\">Bowromir</a>, <a href=\"https://profiles.wordpress.org/burakali/\">burakali</a>, <a href=\"https://profiles.wordpress.org/chouf1/\">chouf1</a>, <a href=\"https://profiles.wordpress.org/cmmarslender/\">cmmarslender</a>, <a href=\"https://profiles.wordpress.org/danbp/\">danbp</a>, <a href=\"https://profiles.wordpress.org/dcavins/\">dcavins</a>, <a href=\"https://profiles.wordpress.org/Denis-de-Bernardy/\">Denis-de-Bernardy</a>, <a href=\"https://profiles.wordpress.org/DJPaul/\">DJPaul</a>, <a href=\"https://profiles.wordpress.org/ericlewis/\">ericlewis</a>, <a href=\"https://profiles.wordpress.org/glyndavidson/\">glyndavidson</a>, <a href=\"https://profiles.wordpress.org/graham-washbrook/\">graham-washbrook</a>, <a href=\"https://profiles.wordpress.org/henrywright/\">henrywright</a>, <a href=\"https://profiles.wordpress.org/henry.wright/\">henry.wright</a>, <a href=\"https://profiles.wordpress.org/hnla/\">hnla</a>, <a href=\"https://profiles.wordpress.org/imath/\">imath</a>, <a href=\"https://profiles.wordpress.org/johnjamesjacoby/\">johnjamesjacoby</a>, <a href=\"https://profiles.wordpress.org/karmatosed/\">karmatosed</a>, <a href=\"https://profiles.wordpress.org/lenasterg/\">lenasterg</a>, <a href=\"https://profiles.wordpress.org/MacPresss/\">MacPresss</a>, <a href=\"https://profiles.wordpress.org/markoheijnen/\">markoheijnen</a>, <a href=\"https://profiles.wordpress.org/megainfo/\">megainfo</a>, <a href=\"https://profiles.wordpress.org/mercime\">mercime</a>, <a href=\"https://profiles.wordpress.org/modemlooper/\">modemlooper</a>, <a href=\"https://profiles.wordpress.org/mpa4hu/\">mpa4hu</a>, <a href=\"https://profiles.wordpress.org/needle/\">needle</a>, <a href=\"https://profiles.wordpress.org/netweb/\">netweb</a>, <a href=\"https://profiles.wordpress.org/ninnypants/\">ninnypants</a>, Pietro Oliva, <a href=\"https://profiles.wordpress.org/pross/\">pross</a>, <a href=\"https://profiles.wordpress.org/r-a-y/\">r-a-y</a>, <a href=\"https://profiles.wordpress.org/reactuate/\">reactuate</a>, <a href=\"https://profiles.wordpress.org/rodrigorznd/\">rodrigorznd</a>, <a href=\"https://profiles.wordpress.org/rogercoathup/\">rogercoathup</a>, <a href=\"https://profiles.wordpress.org/rzen/\">rzen</a>, <a href=\"https://profiles.wordpress.org/SergeyBiryukov/\">SergeyBiryukov</a>, <a href=\"https://profiles.wordpress.org/shanebp/\">shanebp</a>, <a href=\"https://profiles.wordpress.org/SlothLoveChunk/\">SlothLoveChunk</a>, <a href=\"https://profiles.wordpress.org/StijnDeWitt/\">StijnDeWitt</a>, <a href=\"https://profiles.wordpress.org/terraling/\">terraling</a>, <a href=\"https://profiles.wordpress.org/trishasalas/\">trishasalas</a>, <a href=\"https://profiles.wordpress.org/tw2113/\">tw2113</a>, <a href=\"https://profiles.wordpress.org/vanillalounge/\">vanillalounge</a>.</p>\n<p>Many thanks to these contributors, and to all who have pitched in the forums and elsewhere.</p>\n<p>One final point. Technically, BuddyPress &#8220;2.0&#8243; is just the version between 1.9 and 2.1. But still, there&#8217;s something special about crossing into the 2.x series, especially given the timing: we just crossed <a href=\"http://wptavern.com/major-milestone-for-buddypress-2-million-downloads-and-counting\">2 million downloads</a>, and it&#8217;s been almost exactly five years since <a href=\"http://buddypress.org/2009/04/buddypress-10-has-arrived/\">BuddyPress 1.0 was released</a>. On behalf of the core team and contributors, I&#8217;d like to extend a few special thanks: to founding developer <a href=\"http://apeatling.com/\">Andy Peatling</a> for getting the ball rolling; to <a href=\"http://ma.tt\">Matt Mullenweg</a> for providing support to the BuddyPress project; and especially to the many thousands of BuddyPress users who have followed and advocated for the project over the years. If BP has done great things for the thousands of communities that depend on it (and I think it has), it&#8217;s because of the incredible community around the software itself. <strike>A million</strike> Two million thanks to all of you.</p>\n<div></div>\n<h4>Upgrade Today</h4>\n<p>You can get BuddyPress 2.0 from the <a href=\"http://wordpress.org/plugins/buddypress/\">wordpress.org plugin repository</a>, or right from your WordPress Dashboard. </p>\n<p>As always, questions, comments, bug reports, feature requests, and general laudatory remarks can be directed toward our <a href=\"https://buddypress.org/support/\">support forums</a> or our <a href=\"https://buddypress.trac.wordpress.org\">development tracker</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 16 Apr 2014 14:48:04 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Boone Gorges\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:29;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"Akismet: Akismet 3.0.0 is now available\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://blog.akismet.com/?p=1294\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"http://blog.akismet.com/2014/04/15/akismet-3-0-0/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1738:\"<p>Version 3.0.0 of the <a href=\"http://wordpress.org/plugins/akismet/\">Akismet plugin for WordPress</a> is now available.</p>\n<p>This is a <strong>major rewrite</strong> of the plugin code. It includes many small improvements and some new features. In particular:</p>\n<ul>\n<li>An easier signup and activation process</li>\n<li>An even easier activation process for <a href=\"http://jetpack.me/\">Jetpack</a> users</li>\n<li>A redesigned configuration tab</li>\n<li>New stats charts (example shown below)</li>\n<li>A new discard feature for outright blocking of the worst spam</li>\n</ul>\n<p><a href=\"http://akismet.files.wordpress.com/2014/04/stats-at-a-glance2.png\"><img src=\"http://akismet.files.wordpress.com/2014/04/stats-at-a-glance2.png?w=640&h=295\" alt=\"stats-at-a-glance\" width=\"640\" height=\"295\" class=\"alignnone size-large wp-image-1304\" /></a></p>\n<p>To update to version 3.0.0, just use the plugin updater in your WordPress dashboard. If you&#8217;re running WordPress 3.9, there&#8217;s no need to update. If you haven&#8217;t installed Akismet on your WordPress blog yet, <a href=\"http://docs.akismet.com/getting-started/activate/\">follow these instructions</a> to get started.</p>\n<p>Thanks again to everyone who helped <a href=\"http://blog.akismet.com/2014/04/11/help-test-the-next-akismet-plugin/\">test the new plugin</a> and offered suggestions and bug reports.</p><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/akismet.wordpress.com/1294/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/akismet.wordpress.com/1294/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=blog.akismet.com&blog=116920&post=1294&subd=akismet&ref=&feed=1\" width=\"1\" height=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 15 Apr 2014 23:40:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Alex\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:30;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"Andrew Nacin: My Talk Proposals for Open Source Bridge\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:24:\"http://nacin.com/?p=4228\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"http://nacin.com/2014/04/15/my-talk-proposals-for-open-source-bridge/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2106:\"<p>I submitted two proposals to <a href=\"http://opensourcebridge.org/\">Open Source Bridge</a>, an annual conference in Portland, Oregon, for &#8220;open source citizens.&#8221; The call for papers is now closed, but they let anyone leave comments on proposals that are private to the conference organizers. If you have any feedback on these, or have seen me speak before, it would be awesome if you could leave a comment. Here they are:</p>\n<h2><a href=\"http://opensourcebridge.org/proposals/1413\">Extreme Software Portability as an Art Form</a></h2>\n<p>Writing portable software is hard. Throw in thousands of bad and worse shared hosting configurations, a decade of technical debt, the need to cater to a sprawling ecosystem, and PHP — and you have WordPress. We&#8217;ve found breaking changes harm our community and unfairly punish our users, so we don&#8217;t make them. But that doesn&#8217;t mean we don&#8217;t innovate or evolve — we&#8217;re just forced to get really clever. And it works, with adoption continuing to soar.</p>\n<h2><a href=\"http://opensourcebridge.org/proposals/1419\">Trust, Community, and Automatic Updates</a></h2>\n<p>WordPress shipped in October what is perhaps its most polarizing feature ever — automatic updates in the background of self-hosted web software, on by default and no easy way to turn it off. In most open source communities, this would be cause for open revolt. Learn how through trust, communication, and a steadfast commitment to its philosophies, the WordPress core team convinced a skeptical community to go along, even if it meant users giving up some control.</p>\n<p>WordPress contributors Mel Choyce and Aaron Jorbin also both submitted proposals: <a href=\"http://opensourcebridge.org/proposals/1315\">My Journey into Open Source Design</a> and <a href=\"http://opensourcebridge.org/proposals/1312\">Modernizing a Stagnant Toolbox</a>.</p>\n<p class=\"share-sfc-stc\"><a href=\"http://twitter.com/share?url=http%3A%2F%2Fwp.me%2FpQEdq-16c&count=horizontal&related=nacin&text=My Talk Proposals for Open Source Bridge\" class=\"twitter-share-button\"></a></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 15 Apr 2014 21:04:08 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:31;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"WPTavern: Ozh’ Tweet Archiver 2.0 Backs Up Your Tweets to WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=20985\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:176:\"http://wptavern.com/ozh-tweet-archiver-2-0-backs-up-your-tweets-to-wordpress?utm_source=rss&utm_medium=rss&utm_campaign=ozh-tweet-archiver-2-0-backs-up-your-tweets-to-wordpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3526:\"<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/tweet-archiver.png\" rel=\"prettyphoto[20985]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/tweet-archiver.png\" alt=\"tweet-archiver\" width=\"772\" height=\"250\" class=\"aligncenter size-full wp-image-21135\" /></a></p>\n<p>Social networks come and go but your blog lives forever. The advent of social media brought a revolution in how people communicate, but it has also chained us to data silos that house many of our important thoughts, writings and memories. That is, unless you have your own blog or website as your home for your content on the web.</p>\n<p>Instead of mindlessly pumping content into a social network that is owned by someone else, you might stop to consider archiving that data to a better place where you can keep it forever. In a time when digital transactions and communications are the lifeblood of our work, owning your own data has become more important than owning land.</p>\n<p><a href=\"http://wordpress.org/plugins/ozh-tweet-archiver/\" target=\"_blank\">Ozh Tweet Archiver</a> is one tool that makes owning your Twitter data a practical possibility. This free plugin automatically archives all of your tweets to your WordPress site. Browsing your tweet history is nearly impossible on Twitter, but with Ozh Tweet Archiver in place, you can easily search through your past tweets.</p>\n<p>Version 2.0 is compatible with Twitter&#8217;s OAuth API. The plugin should be installed on a fresh WordPress site or subdomain. Once in place, it offers the following benefits:</p>\n<ul>\n<li>Searching is easier in WordPress than on Twitter</li>\n<li>WordPress is not limited to the most recent 3200 tweets</li>\n<li>It will automatically expand all those ugly t.co links</li>\n<li>All your #hashtags can be converted to WordPress tags</li>\n</ul>\n<p>Check out a <a href=\"http://planetozh.com/tweets/\" target=\"_blank\">live demo</a> of <a href=\"http://twitter.com/ozh\" target=\"_blank\">@ozh Twitter account</a> archives.</p>\n<p>Once the plugin is set up, it will automatically perform checks for new tweets at your chosen interval, so you won&#8217;t need to do anything else.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/twitter-archive-settings.jpg\" rel=\"prettyphoto[20985]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/twitter-archive-settings.jpg\" alt=\"twitter-archive-settings\" width=\"585\" height=\"454\" class=\"aligncenter size-full wp-image-21161\" /></a></p>\n<p>Tweets are imported as regular posts with a few custom fields. The plugin includes an options panel for setting the post author, category for tweets, and the ability to turn on links for usernames. It also has an option to link hashtags to WordPress tags or Twitter hashtags. You can even turn on embedding for images that originate on pic.twitter.com.</p>\n<p>Someday Twitter may lose all of its charms and fall to the wayside like many other networks before it. When that day comes, you&#8217;ll be glad that you archived all of your tweets to WordPress. If Twitter is one of your primary communication channels, consider the value of backing up your content to your home on the web with <a href=\"http://wordpress.org/plugins/ozh-tweet-archiver/\" target=\"_blank\">Ozh Tweet Archiver</a>. For more information on getting your archive set up, please refer to the <a href=\"http://planetozh.com/blog/my-projects/ozh-tweet-archiver-backup-twitter-with-wordpress/\" target=\"_blank\">official plugin page</a>, which includes documentation and troubleshooting tips.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 15 Apr 2014 20:36:09 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:32;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:87:\"WordPress.tv: Noel Tock : Le design d’interface : la cas d’Happytables (en anglais)\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=34302\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:93:\"http://wordpress.tv/2014/04/15/noel-tock-le-design-dinterface-la-cas-dhappytables-en-anglais/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:686:\"<div id=\"v-Fd96ypE1-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/34302/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/34302/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=34302&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/04/15/noel-tock-le-design-dinterface-la-cas-dhappytables-en-anglais/\"><img alt=\"12 &#8211; Noel Tock-Conf-WCParis2014.mp4\" src=\"http://videos.videopress.com/Fd96ypE1/video-9cccde5b3b_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 15 Apr 2014 18:02:52 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:33;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:89:\"WordPress.tv: Jean-Baptiste Marchand-Arvier : Utiliser WordPress pour son site e-commerce\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=34299\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:105:\"http://wordpress.tv/2014/04/15/jean-baptiste-marchand-arvier-utiliser-wordpress-pour-son-site-e-commerce/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:712:\"<div id=\"v-LMP5sHnL-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/34299/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/34299/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=34299&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/04/15/jean-baptiste-marchand-arvier-utiliser-wordpress-pour-son-site-e-commerce/\"><img alt=\"11 &#8211; Jean-Baptiste Marchand-Arvier-Conf-WCParis2014.mp4\" src=\"http://videos.videopress.com/LMP5sHnL/video-7717d23a5e_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 15 Apr 2014 17:09:40 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:34;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:43:\"Dev Blog: WordPress 3.9 Release Candidate 2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3151\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"http://wordpress.org/news/2014/04/wordpress-3-9-release-candidate-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2327:\"<p>The second release candidate for WordPress 3.9 is now available for testing.</p>\n<p>If you haven&#8217;t tested 3.9 yet, you&#8217;re running out of time! We made about five dozen changes since the <a title=\"WordPress 3.9 Release Candidate\" href=\"http://wordpress.org/news/2014/04/wordpress-3-9-release-candidate/\">first release candidate</a>, and those changes are all helpfully summarized <a href=\"http://make.wordpress.org/core/?p=10237\">in our weekly post</a> on the development blog. Probably the biggest fixes are to live widget previews and the new theme browser, along with some extra TinyMCE compatibility and some RTL fixes.</p>\n<p><strong>Plugin authors:</strong> Could you test your plugins against 3.9, and if they&#8217;re compatible, make sure they are marked as tested up to 3.9? It only takes a few minutes and this really helps make launch easier. Be sure to follow along the core development blog; we&#8217;ve been posting <a href=\"http://make.wordpress.org/core/tag/3-9-dev-notes/\">notes for developers for 3.9</a>. (For example: <a href=\"http://make.wordpress.org/core/2014/04/15/html5-galleries-captions-in-wordpress-3-9/\">HTML5</a>, <a href=\"http://make.wordpress.org/core/2014/04/14/symlinked-plugins-in-wordpress-3-9/\">symlinks</a>, <a href=\"http://make.wordpress.org/core/2014/04/07/mysql-in-wordpress-3-9/\">MySQL</a>, <a href=\"http://make.wordpress.org/core/2014/04/11/plupload-2-x-in-wordpress-3-9/\">Plupload</a>.)</p>\n<p>To test WordPress 3.9 RC2, try the <a href=\"http://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”). Or you can <a href=\"http://wordpress.org/wordpress-3.9-RC2.zip\">download the release candidate here</a> (zip). If you’d like to learn more about what’s new in WordPress 3.9, visit the nearly complete About screen in your dashboard (<strong><img src=\"http://i0.wp.com/core.svn.wordpress.org/branches/3.6/wp-content/themes/twentyten/images/wordpress.png?w=692\" alt=\"\" width=\"16\" height=\"16\" /> → About</strong> in the toolbar) and also check out <a title=\"WordPress 3.9 Beta 1\" href=\"http://wordpress.org/news/2014/03/wordpress-3-9-beta-1/\">the Beta 1 post</a>.</p>\n<p><em>This is for testing,</em><br />\n<em>so not recommended for<br />\nproduction sites—yet.</em></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 15 Apr 2014 09:47:36 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:35;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"WPTavern: Cite: A WordPress Plugin to Help Readers Correctly Attribute Articles\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=21094\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:200:\"http://wptavern.com/cite-a-wordpress-plugin-to-help-readers-correctly-attribute-articles?utm_source=rss&utm_medium=rss&utm_campaign=cite-a-wordpress-plugin-to-help-readers-correctly-attribute-articles\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2214:\"<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/cite.jpg\" rel=\"prettyphoto[21094]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/cite.jpg\" alt=\"cite\" width=\"772\" height=\"250\" class=\"aligncenter size-full wp-image-21098\" /></a></p>\n<p>WordPress sites that publish academic or scholarly articles often need to provide information to help readers know how to cite articles correctly. <a href=\"http://wordpress.org/plugins/cite/\" target=\"_blank\">Cite</a> is a new plugin that tackles this requirement using dynamic tags to generate the date, site name, post title and permalink.</p>\n<p>Post authors can easily post citation instructions by using the <strong>[cite]</strong> shortcode. It will automatically generate the article attribution information at the bottom of the post.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/cite-example.png\" rel=\"prettyphoto[21094]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/cite-example.png\" alt=\"cite-example\" width=\"1661\" height=\"676\" class=\"aligncenter size-full wp-image-21101\" /></a></p>\n<p>The plugin includes a settings page where you can use any of the available template tags to create a citation template.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/cite-settings.jpg\" rel=\"prettyphoto[21094]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/cite-settings.jpg\" alt=\"cite-settings\" width=\"915\" height=\"446\" class=\"aligncenter size-full wp-image-21100\" /></a></p>\n<p>The <a href=\"http://demo.enigmaweb.com.au/cite/\" target=\"_blank\">live demo</a> on the plugin author&#8217;s website shows how the citation template appears out-of-the-box. Its appearance can be further customized via CSS. The plugin is internationalized and ready for translation for use on academic sites in other languages.</p>\n<p>Cite is a free plugin created by <a href=\"http://profiles.wordpress.org/enigmaweb/\" target=\"_blank\">Maeve Lander</a>. It will save you time on every post where you would otherwise manually enter information to help readers cite your article. <a href=\"http://wordpress.org/plugins/cite/\" target=\"_blank\">Download Cite</a> from WordPress.org or install it via your site&#8217;s admin panel.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 15 Apr 2014 06:18:10 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:36;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"WPTavern: WordPress 3.8.3 Released, Fixes Quick Draft Bug\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=21043\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:156:\"http://wptavern.com/wordpress-3-8-3-released-fixes-quick-draft-bug?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-3-8-3-released-fixes-quick-draft-bug\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4177:\"<p>WordPress 3.8.3 <a title=\"http://wordpress.org/news/\" href=\"http://wordpress.org/news/\">was released today</a> and fixes a pesky bug introduced in WordPress 3.8.2. As <a title=\"http://wptavern.com/wordpress-3-8-3-to-fix-quick-draft-dashboard-widget\" href=\"http://wptavern.com/wordpress-3-8-3-to-fix-quick-draft-dashboard-widget\">we reported a few days ago</a>, one of the security fixes in 3.8.2 caused the Quick Draft dashboard widget to break. Auto-drafts created through the widget were not being promoted to draft status. When a title and content were added to the widget, clicking the save draft button gave the appearance that it was discarded. A Quick Drafted post didn&#8217;t show up within the drafts list even though it existed within the database.</p>\n<div id=\"attachment_21086\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/04/QuickDraftFixedFeaturedImage.png\" rel=\"prettyphoto[21043]\"><img class=\"size-full wp-image-21086\" alt=\"WordPress 3.8.3 Fixed The Quick Draft Dashboard Widget\" src=\"http://wptavern.com/wp-content/uploads/2014/04/QuickDraftFixedFeaturedImage.png\" width=\"666\" height=\"248\" /></a><p class=\"wp-caption-text\">WordPress 3.8.3 Fixed The Quick Draft Dashboard Widget</p></div>\n<p>According to the announcement post on the official WordPress developments blog, not only does the update fix the bug but it also attempts to retrieve the last created auto-draft.</p>\n<blockquote><p>It’s <em>possible</em> that the quick draft you lost last week is still in the database, and just hidden from view. As an added complication, these “discarded drafts” normally get deleted after seven days, and it’s already been six days since the release. If we were able to rescue your draft, you’ll see it on the “All Posts” screen after you update to 3.8.3.</p></blockquote>\n<p>The team also pushed out 3.8.3 as a background update so there&#8217;s a chance you may see a draft appear. WordPress 3.7.2 was affected by the bug as well. You can upgrade to 3.7.3 to fix the issue but you&#8217;re encouraged to upgrade to the latest version which is 3.8.3.</p>\n<h3>The Significance of WordPress 3.8.3</h3>\n<p>This release is significant for a few reasons. The first is that a security and maintenance release (3.8.2) broke core functionality. When <a title=\"http://wptavern.com/wordpress-automatic-updates-no-options-for-you\" href=\"http://wptavern.com/wordpress-automatic-updates-no-options-for-you\">we wrote about automatic updates</a> in WordPress not having an options panel to configure their behavior, I pointed out minor and security updates rarely break anything dealing with the core of WordPress.</p>\n<p>We now have an example of where a security update broke core functionality. Unfortunately, those that argue minor upgrades can break their site now have fuel for their argument. These types of mistakes happen and the core team has apologized.</p>\n<blockquote><p>We recognize how much trust you place in us to safeguard your content, and we take this responsibility very seriously. We’re sorry we let you down.</p></blockquote>\n<p>Second, the <a title=\"http://wordpress.org/about/philosophy/\" href=\"http://wordpress.org/about/philosophy/\">WordPress philosophy</a> doesn&#8217;t mention anything about preventing content from being lost. While we have post revisions, auto-saves, and auto-drafts, they weren&#8217;t enough to prevent some content from being lost. Whether using the Quick Draft dashboard widget is an <a title=\"http://www.poststat.us/wordpress-3-8-3-fixes-a-bug-with-quick-draft/\" href=\"http://www.poststat.us/wordpress-3-8-3-fixes-a-bug-with-quick-draft/\">edge case or not</a>, it&#8217;s reassuring to see the core team consider <strong>any loss of content</strong>, unacceptable.</p>\n<h3>Minor and Security Releases Can Break Things</h3>\n<p>Although there was a problem with 3.8.2 and using the Quick Draft widget, the team put together a fix and released it within a few days. Minor and security updates <strong>can</strong> break things but it happens far less frequently than the successful ones.</p>\n<p>On a brighter note, WordPress 3.9 is expected to ship later this week.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 15 Apr 2014 03:48:58 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:37;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:78:\"WPTavern: Why WordPress Theme Developers Are Moving Functionality Into Plugins\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=20499\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:200:\"http://wptavern.com/why-wordpress-theme-developers-are-moving-functionality-into-plugins?utm_source=rss&utm_medium=rss&utm_campaign=why-wordpress-theme-developers-are-moving-functionality-into-plugins\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:11646:\"<p>Jonathan Atkinson has been selling WordPress themes on <a href=\"http://themeforest.net/user/jonathan01\" target=\"_blank\">Themeforest</a> for the past five years. Through hard work and customer support, he&#8217;s learned how to <a href=\"http://wptavern.com/wpweekly-episode-137-making-a-living-on-themeforest-with-jonathan-atkinson\" target=\"_blank\">make a living on Themeforest</a> without having to pack hundreds of options into his products.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/plugins.jpg\" rel=\"prettyphoto[20499]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/plugins-300x236.jpg\" alt=\"plugins\" width=\"300\" height=\"236\" class=\"alignright size-medium wp-image-21026\" /></a>Over the past year, Atkinson and his team at <a href=\"http://cr3ativ.com/\" target=\"_blank\">Cr3ativ.com</a> have made an effort to convert all of their theme functionality into free plugins, eschewing the theme bloat that prevails in this market. Cr3ativ now has a <a href=\"http://cr3ativ.com/portfolio-category/plugins\" target=\"_blank\">plugins page</a> where you can find functionality that enables carousels, careers, portfolios, shortcodes, and staff profiles. They plan to add events, discography and photostreams in the coming weeks.</p>\n<h3>The Benefits of Keeping Plugin and Theme Functionality Separate</h3>\n<p>Atkinson said they initially created the plugins to be used with their themes and to better serve their buyers. &#8220;I took the decision to make them as generic as possible to ensure they could be just as easily used within any theme &#8211; free or premium,&#8221; he said. &#8220;I also decided to offer them 100% free and full GPL 2.0 so people can hopefully use, learn and extend if they wish.&#8221;</p>\n<p>Keeping plugin functionality separate from themes is part of WordPress theme development best practices but Atkinson cites a few additional benefits:</p>\n<ul>\n<li>Speeds up development of new themes</li>\n<li>Enables them to extend capabilities of existing themes</li>\n<li>Theme independence allows them to extend plugins without creating a massive and painful update to an existing theme</li>\n<li>Gives them more &#8220;breathing room&#8221; to concentrate on other possible outlets for their products, including other marketplaces, their own independent store and other avenues.</li>\n</ul>\n<p>Atkinson and his team are building new themes that support the use of their plugins and are also retrofitting the old themes to make use of them. The process hasn&#8217;t been easy, but they found help along the way.</p>\n<p>&#8220;We have never created a single plugin before embarking on these and had to lean on Pippin from <a href=\"http://PippinsPlugins.com\" target=\"_blank\">PippinsPlugins.com</a> for advice as we moved forward,&#8221; Atkinson said. Branching out into plugins was completely new territory but Pippin Williamson helped to review and test their free plugins. &#8220;We had some things to change and at the end of development we&#8217;re happy we traveled this road.&#8221;</p>\n<h3>The Demand for Bloat Keeps Theme Developers From Following Best Practices</h3>\n<p>Overall, keeping plugins and themes separate has provided a better experience for Atkinson&#8217;s user base and gives his team more freedom in what they create. If this practice is so beneficial to theme authors, then why aren&#8217;t we seeing a mad rush of others moving to do the same?</p>\n<p>The root of the problem is that consumers actually want themes that are packed full of options and functionality. The vast majority of Themeforest customers buy WordPress themes based on the demo. As WordPress has grown to power more than <a href=\"http://w3techs.com/technologies/overview/content_management/all\" target=\"_blank\">21% of the web</a>, theme developers are catering to people who, through no fault of their own, buy themes based solely on visual queues, not the code.</p>\n<p>Atkinson explains how the theme market has changed over time:</p>\n<blockquote><p>At the very beginning when Themeforest started I think that the buyers were different. The majority of buyers were developers. They may not have been full-on developers but they certainly knew how to roll their sleeves up and do a little bit of CSS. But now we&#8217;ve switched over to where the majority of buyers are actually the website owners&#8230;They know how to upload a theme; they know how to install every plugin on earth and that&#8217;s about it.</p></blockquote>\n<p>Consumers want themes that don&#8217;t require installing a bunch of plugins. They want to be able to simply click to customize everything. As a result, bloated WordPress themes sell far better than those that follow best practices. Most of the <a href=\"http://themeforest.net/popular_item/by_category?category=wordpress\" target=\"_blank\">top-selling WordPress themes on Themeforest</a> are products that are packed full of multiple sliders, dozens of homepage options, shortcodes, unlimited layouts, page builders, etc.</p>\n<p>Smashing Magazine has recently been <a href=\"https://twitter.com/smashingmag/status/453171965671395330\" target=\"_blank\">promoting</a> a WordPress theme that claims to be &#8220;the last WordPress theme you&#8217;ll ever have to buy.&#8221; The <a href=\"http://themeforest.net/item/x-the-ultimate-wordpress-theme/5871901\" target=\"_blank\">X theme</a>, created based on advice from internet marketers and SEO experts, promises &#8220;truly unlimited styling.&#8221; It is one among many themes that have been built to be all things for all projects.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/x-theme.png\" rel=\"prettyphoto[20499]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/x-theme.png\" alt=\"x-theme\" width=\"590\" height=\"300\" class=\"aligncenter size-full wp-image-20875\" /></a></p>\n<p>The WordPress theme market is saturated with themes that promise to do it all and these products tend to sell very well among non-developers. Specificity of form and purpose has been replaced with generic skeletons boasting unlimited options.</p>\n<p><strong>Theme authors are then faced with a grave decision:</strong> Sell a couple hundred niche themes with clean code or build every possible option/functionality into your theme and sell 50,000 copies. For those who are trying to make a living, it&#8217;s difficult to compete. This is a complex problem that doesn&#8217;t have an easy solution.</p>\n<h3>Building Themes that Respect WordPress&#8217; Plugin System</h3>\n<p>Atkinson and his team at <a href=\"http://cr3ativ.com/\" target=\"_blank\">Cr3ativ.com</a> are among a handful of theme authors who are taking a principled stand against building plugin functionality into WordPress themes. Those who have chosen this path stand out as beacons in a vast sea of bloated products.</p>\n<p>Justin Tadlock has long been a vocal proponent of keeping plugin functionality out of themes, especially as it relates to data portability. <strong>&#8220;That&#8217;s just been the way WordPress has worked since the inception of the plugin and theme systems,&#8221;</strong> he said. &#8220;It hadn&#8217;t crossed my mind to add certain functionality into a theme because that&#8217;s not how WordPress was designed. For some reason, a trend started toward adding plugin functionality into themes, which is when I started looking into the issue.&#8221;</p>\n<p>Tadlock&#8217;s <a href=\"http://themehybrid.com/\" target=\"_blank\">Theme Hybrid</a> framework comes with a suite of free <a href=\"http://themehybrid.com/plugins\" target=\"_blank\">plugins</a> that offer additional functionality. On occasion, he has made wrong choices and had to retrace his steps:</p>\n<blockquote><p>There are things that I&#8217;ve put into themes and later realized that it was not the right choice. I just go about correcting those mistakes one at a time.  Sometimes, it takes a number of months and possibly years of making sure you&#8217;re not breaking things for users.</p></blockquote>\n<p>The trend of packing everything into themes was ignited by WordPress&#8217; increasing popularity and the fierce competition among marketplace theme developers to provide the the most value. Unfortunately, consumers don&#8217;t care about best practices and re-educating them is not an easy task. It falls to WordPress theme developers and marketplace regulators to make the tough choice to keep themes clean and preserve data portability.</p>\n<h3>First Steps Toward Removing Plugin Functionality From Themes</h3>\n<div id=\"attachment_21080\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/04/salt-pepper.jpg\" rel=\"prettyphoto[20499]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/salt-pepper.jpg\" alt=\"photo credit: Sheyla Ruiz - cc\" width=\"1022\" height=\"490\" class=\"size-full wp-image-21080\" /></a><p class=\"wp-caption-text\">photo credit: <a href=\"http://www.flickr.com/photos/sheylaruiz/6968369150/\">Sheyla Ruiz</a> &#8211; <a href=\"http://creativecommons.org/licenses/by-nd/2.0/\">cc</a></p></div>\n<p>If you&#8217;re a theme developer who is looking to remove functionality from your products and offer it in the form of accompanying plugins, you&#8217;ve got your work cut out for you. Tadlock&#8217;s advice: <strong>&#8220;Just do it. Make sure you offer your users a fairly easy transition, at least as easy as these types of transitions can be.&#8221;</strong></p>\n<p>Theme authors don&#8217;t necessarily need to suddenly add plugin development to their skills. Tadlock suggests that making use of existing plugins is a good option.</p>\n<blockquote><p>So many developers want to build everything in house when there&#8217;s a much better solution out there already.  I&#8217;m even guilty of this at times. Of course, the infrastructure is not there on WordPress.org to make it easy for developers to work together. That&#8217;s why so many of us have turned to GitHub.</p></blockquote>\n<p>Tadlock reports that he&#8217;s seen a considerable jump in other developers using his plugins in their projects after moving his code to Github. Making use of others&#8217; work and collaborating on improvements is less daunting than having to develop all the accompanying plugins yourself.</p>\n<h3>Tips for Consumers Buying WordPress Themes</h3>\n<p>Since consumers inspecting commercial themes do not have access to the code, it&#8217;s not easy to know if a product is built with best practices in mind. The demo and list of features are often the deciding factors, especially for those who have no technical knowledge of WordPress themes. If you don&#8217;t want to have your data locked into a theme, you need to be on guard to select products that utilize plugins that will preserve your data.</p>\n<p>When it comes to theme options, the cold, hard truth is that not everyone is a designer. There is no ultimate visual layout builder or unlimited color chooser that will magically make you into a designer. If this is something you can recognize about yourself, then you may want to steer away from themes that offer massive options panels with unlimited everything. Instead, opt for design-specific themes that follow best practices and offer a few options using WordPress&#8217; native customizer.</p>\n<p>Eventually, marketplaces may enforce more strict submission guidelines for their themes, based on community input. Theme developers who have sunk into a hole with their heavy, bloated products, will have to dig their way out or get pushed out. WordPress developers who want to be successful long-term will need to return to WordPress&#8217; original design and keep plugin functionality separate from themes.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 14 Apr 2014 21:58:40 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:38;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"Dev Blog: WordPress 3.8.3 Maintenance Release\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3145\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wordpress.org/news/2014/04/wordpress-3-8-3/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2338:\"<p>WordPress 3.8.3 is now available to fix a small but unfortunate bug in the <a title=\"WordPress 3.8.2 Security Release\" href=\"http://wordpress.org/news/2014/04/wordpress-3-8-2/\">WordPress 3.8.2 security release</a>.</p>\n<p>The &#8220;Quick Draft&#8221; tool on the dashboard screen was broken in the 3.8.2 update. If you tried to use it, your draft would disappear and it wouldn&#8217;t save. While we doubt anyone was writing a novella using this tool, <em>any</em> loss of content is unacceptable to us.</p>\n<p>We recognize how much trust you place in us to safeguard your content, and we take this responsibility very seriously. We&#8217;re sorry we let you down.</p>\n<p>We&#8217;ve all lost words we&#8217;ve written before, like an email thanks to a cat on the keyboard or a term paper to a blue screen of death. Over the last few WordPress releases, we&#8217;ve made a number of improvements to features like autosaves and revisions. With revisions, an old edit can always be restored. We&#8217;re trying our hardest to save your content somewhere even if your power goes out or your browser crashes. We even monitor your internet connection and prevent you from hitting that &#8220;Publish&#8221; button at the exact moment the coffee shop Wi-Fi has a hiccup.</p>\n<p>It&#8217;s <em>possible</em> that the quick draft you lost last week is still in the database, and just hidden from view. As an added complication, these &#8220;discarded drafts&#8221; normally get deleted after seven days, and it&#8217;s already been six days since the release. If we were able to rescue your draft, you&#8217;ll see it on the &#8220;All Posts&#8221; screen after you update to 3.8.3. (We&#8217;ll also be pushing 3.8.3 out as a background update, so you may just see a draft appear.)</p>\n<p>So, if you tried to jot down a quick idea last week, I hope WordPress has recovered it for you. Maybe it&#8217;ll turn into that novella.</p>\n<p><a href=\"http://wordpress.org/download/\">Download WordPress 3.8.3</a> or click &#8220;Update Now&#8221; on Dashboard → Updates.</p>\n<p><em>This affected version 3.7.2 as well, so we&#8217;re pushing a 3.7.3 to these installs, but we&#8217;d encourage you to update to the latest and greatest.</em></p>\n<hr />\n<p><em>Now for some good news:<br />\nWordPress 3.9 is near.<br />\nExpect it this week</em></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 14 Apr 2014 19:29:13 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:39;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:76:\"WPTavern: WordPress Social Avatar Plugin Provides an Alternative to Gravatar\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=20440\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:196:\"http://wptavern.com/wordpress-social-avatar-plugin-provides-an-alternative-to-gravatar?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-social-avatar-plugin-provides-an-alternative-to-gravatar\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2196:\"<p>Despite the fact that <a href=\"http://gravatar.com/\" target=\"_blank\">Gravatar</a> is the default avatar service built into WordPress, it&#8217;s not everyone&#8217;s cup of tea. There are times when you may want to use a different avatar on a specific site but don&#8217;t want to change your Gravatar image. In some instances WordPress site admins choose to disable the service for whatever reason, but there is a way to give users more avatar options without turning Gravatar off.</p>\n<p><a href=\"http://wordpress.org/plugins/wp-social-avatar/\" target=\"_blank\">WP Social Avatar</a> is a new plugin that makes it easy to use your Facebook or G+ picture as your WordPress avatar. Once activated, users can add their Facebook handles or G+ IDs to <strong>/wp-admin/profile.php</strong>.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/socialavatar.png\" rel=\"prettyphoto[20440]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/socialavatar.png\" alt=\"socialavatar\" width=\"1372\" height=\"792\" class=\"aligncenter size-full wp-image-20990\" /></a></p>\n<p>Your avatar will be instantly updated to the new selection throughout the site.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/wpsocialavatar.png\" rel=\"prettyphoto[20440]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/wpsocialavatar.png\" alt=\"wpsocialavatar\" width=\"1271\" height=\"493\" class=\"aligncenter size-full wp-image-20992\" /></a></p>\n<p>WP Social Avatar includes a settings panel under the Users menu that allows administrators to set the minimum role/capabilities required to use social avatars.</p>\n<p>The plugin does not require Facebook or G+ authentication in order to set your avatar, so it&#8217;s just as convenient to use as Gravatar. It also does not disable Gravatar for users who prefer it. <a href=\"http://wptavern.com/marutimohanty.wordpress.com\" target=\"_blank\">Maruti Mohanty</a>, the plugin&#8217;s developer, plans to add more social avatars in the future. If you want to add a few convenient avatar options to WordPress profiles on your site, download <a href=\"http://wordpress.org/plugins/wp-social-avatar/\" target=\"_blank\">WP Social Avatar</a> from WordPress.org.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 14 Apr 2014 05:32:29 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:40;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"BuddyPress: BuddyPress 2.0 Release Candidate\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://buddypress.org/?p=181203\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"http://buddypress.org/2014/04/buddypress-2-0-release-candidate/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1019:\"<p>The first release candidate (RC1) for BuddyPress 2.0 is now available (<a href=\"http://downloads.wordpress.org/plugin/buddypress.2.0-RC1.zip\">zip</a>). Since <a href=\"https://buddypress.org/2014/04/buddypress-2-0-beta2/\">the last beta</a>, we have made about 10 small changes; see <a href=\"https://buddypress.trac.wordpress.org/timeline?from=04%2F13%2F14&daysback=5&authors=&changeset=on&sfp_email=&sfph_mail=&update=Update\">the changelog</a> for details.</p>\n<p>At this time, BP 2.0 is in a string freeze &#8211; we won&#8217;t be changing any more text between now and the final release. If you are helping to maintain <a href=\"http://translate.wordpress.org/projects/buddypress\">a BuddyPress translation</a>, this is your chance to make final revisions before 2.0 comes out. (We&#8217;re still looking good for April 16.)</p>\n<p>Questions, comments, concerns, bugs, praise? Visit <a href=\"https://buddypress.org/support/\">the support forums</a> or <a href=\"https://buddypress.trac.wordpress.org/\">BP Trac</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 13 Apr 2014 20:15:12 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Boone Gorges\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:41;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"WordPress.tv: Sarah Wefald: Twitter Integration With WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=34148\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"http://wordpress.tv/2014/04/12/sarah-wefald-twitter-integration-with-wordpress/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:679:\"<div id=\"v-s22WSUNH-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/34148/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/34148/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=34148&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/04/12/sarah-wefald-twitter-integration-with-wordpress/\"><img alt=\"Sarah Wefald: Twitter Integration With WordPress\" src=\"http://videos.videopress.com/s22WSUNH/video-05a42d3046_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 12 Apr 2014 12:06:51 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:42;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"WPTavern: WPWeekly Episode 145 – An OMGBBQWTF Kind Of Week\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"http://wptavern.com?p=20940&preview_id=20940\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:156:\"http://wptavern.com/wpweekly-episode-145-an-omgbbqwtf-kind-of-week?utm_source=rss&utm_medium=rss&utm_campaign=wpweekly-episode-145-an-omgbbqwtf-kind-of-week\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4879:\"<p><a title=\"http://marcuscouch.com/\" href=\"http://marcuscouch.com/\">Marcus Couch</a> and I were joined by <a title=\"http://eamann.com/\" href=\"http://eamann.com/\">Eric Mann</a> to discuss the news of the week. After the news, we discussed in-depth a few of the core proposals Mann has published on his blog. We covered the following three WordPress core proposals:</p>\n<ul>\n<li><a title=\"http://eamann.com/tech/data-service/\" href=\"http://eamann.com/tech/data-service/\">Data Service</a></li>\n<li><a title=\"http://eamann.com/tech/wordpress-portability/\" href=\"http://eamann.com/tech/wordpress-portability/\">Portability</a></li>\n<li><a title=\"http://eamann.com/tech/offline-editor/\" href=\"http://eamann.com/tech/offline-editor/\">Offline Editor</a></li>\n</ul>\n<p>After speaking with Mann, it&#8217;s clear he puts a lot of thought into each proposal. I hope you enjoy the show and don&#8217;t forget to give us your feedback in the comments.</p>\n<h2>Stories Discussed:</h2>\n<p><a title=\"http://wptavern.com/breaking-jetpack-releases-critical-security-update-immediate-action-required\" href=\"http://wptavern.com/breaking-jetpack-releases-critical-security-update-immediate-action-required\">Breaking: Jetpack Releases Critical Security Update, Immediate Action Required</a><br />\n<a title=\"http://wptavern.com/wordpress-3-8-2-first-security-release-shipped-as-a-background-update\" href=\"http://wptavern.com/wordpress-3-8-2-first-security-release-shipped-as-a-background-update\">WordPress 3.8.2: First Security Release Shipped as a Background Update</a><br />\n<a title=\"http://wptavern.com/recent-update-to-wordfence-security-breaks-wordpress-mobile-apps\" href=\"http://wptavern.com/recent-update-to-wordfence-security-breaks-wordpress-mobile-apps\">Recent Update To Wordfence Security Breaks WordPress Mobile Apps</a><br />\n<a title=\"http://wptavern.com/devpress-sold-to-unknown-buyer-for-14k\" href=\"http://wptavern.com/devpress-sold-to-unknown-buyer-for-14k\">DevPress Sold To Unknown Buyer For $14k</a><br />\n<a title=\"http://www.poststat.us/devin-price-new-owner-devpress/\" href=\"http://www.poststat.us/devin-price-new-owner-devpress/\">Devin Price is the new owner of DevPress</a><br />\n<a title=\"http://wptavern.com/wordpress-org-profile-redesign-is-live\" href=\"http://wptavern.com/wordpress-org-profile-redesign-is-live\">WordPress.org Profile Redesign is Live</a></p>\n<h2>Plugins Picked By Marcus:</h2>\n<p><a title=\"http://wordpress.org/plugins/webkite/\" href=\"http://wordpress.org/plugins/webkite/\">Webkite for WordPress</a> &#8211; WebKite is a service for getting your data online quickly and easily. Backed by the WebKite API, the WebKite for WordPress plugin delivers the filtering and sorting capabilities of sites like Kayak, Amazon, and Yelp. Users can interact with your content to easily find items that are relevant to their needs, a great way to build rapport and trust with your user base.</p>\n<p><a title=\"http://wordpress.org/plugins/alti-watermark/\" href=\"http://wordpress.org/plugins/alti-watermark/\">Watermark</a> &#8211; This plugin allows you to add a watermark on images uploaded to the media library. It applies a watermark on new images as well as images already uploaded.</p>\n<p><a href=\"http://wordpress.org/plugins/forget-about-shortcode-buttons/\" title=\"http://wordpress.org/plugins/forget-about-shortcode-buttons/\">Forget About Shortcode Buttons</a> &#8211; Forget About Shortcode (FASC) Buttons are a visual way to add CSS buttons in the post editor screen and to your themes.</p>\n<p><a title=\"http://wordpress.org/plugins/twentytwenty/\" href=\"http://wordpress.org/plugins/twentytwenty/\">TwentyTwenty</a> &#8211; Show before and after pictures in your blog, with an interactive slider that allows users to compare them.</p>\n<p><a title=\"http://wordpress.org/plugins/bp-group-documents/\" href=\"http://wordpress.org/plugins/bp-group-documents/\">BP Group Documents</a> &#8211; BP Group Documents creates a page within each BuddyPress group to upload and any type of file or document. This allows members of BuddyPress groups to upload and store files and documents that are relevant to the group.</p>\n<h2>WPWeekly Meta:</h2>\n<p><strong>Next Episode:</strong> Friday, April 18th 3 P.M. Eastern &#8211; Special Guest: <a href=\"http://nacin.com/\" title=\"http://nacin.com/\">Andrew Nacin</a></p>\n<p><strong>Subscribe To WPWeekly Via Itunes: </strong><a href=\"https://itunes.apple.com/us/podcast/wordpress-weekly/id694849738\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via RSS: </strong><a href=\"http://www.wptavern.com/feed/podcast\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via Stitcher Radio: </strong><a href=\"http://www.stitcher.com/podcast/wordpress-weekly-podcast?refid=stpr\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Listen To Episode #145:</strong><br />\n</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 12 Apr 2014 04:22:01 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:43;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"WPTavern: WordPress Plugin CoSchedule Secures $500K In Funding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=20935\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:166:\"http://wptavern.com/wordpress-plugin-coschedule-secures-500k-in-funding?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-plugin-coschedule-secures-500k-in-funding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2278:\"<p><a title=\"http://wordpress.org/plugins/coschedule-by-todaymade/\" href=\"http://wordpress.org/plugins/coschedule-by-todaymade/\">CoSchedule</a>, the editorial workflow and activity scheduling plugin, has <a title=\"http://coschedule.com/blog/coschedule-series-a-funding/\" href=\"http://coschedule.com/blog/coschedule-series-a-funding/\">secured $500K</a> in a Series A round of funding. The angel investment was led by Sandin Holdings and Bullinger Enterprises of Fargo, North Dakota. Matching funds were provided by the North Dakota Development Fund. Joe Sandin of Sandin Holdings will join CoSchedule&#8217;s Board of Directors, providing strategic guidance and business advice.</p>\n<p>When I <a title=\"http://wptavern.com/coschedule-a-viable-alternative-to-the-edit-flow-wordpress-plugin\" href=\"http://wptavern.com/coschedule-a-viable-alternative-to-the-edit-flow-wordpress-plugin\">reviewed the plugin</a> last year, I considered it to be a viable alternative to <a title=\"http://wordpress.org/plugins/edit-flow/\" href=\"http://wordpress.org/plugins/edit-flow/\">Edit Flow</a>. CoSchedule will use the money to hire more employees, increase their marketing budget, and increase the speed of development so new features reach users faster.</p>\n<p><span class=\"embed-youtube\"></span></p>\n<p>Moon says the company has experienced rapid growth since launching in September of 2013. Since the launch, the plugin has over 6,000 downloads with users in more than 100 countries and paying customers in 35 countries. I asked Moon, what advice does he have for those looking to obtain a round of funding to take their business or service to the next level? He replied:</p>\n<blockquote><p>I think a lot of developers hesitate to look for funding for their work because the process is overwhelming and unfamiliar to them. I will definitely admit that it is a ton of work, but it can be hugely valuable. Not only can you get the financing you need to move to the next level, but it really forces you to look at your product in a new way and challenge every assumption that you&#8217;ve made. Investors ask hard questions, and that can be a really good thing.</p></blockquote>\n<p>Do you use CoSchedule? If so, what do you think of its editorial workflow and how it handles multiple authors?</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 11 Apr 2014 21:27:17 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:44;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:74:\"WPTavern: Major Milestone For BuddyPress: 2 Million Downloads and Counting\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=20944\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:190:\"http://wptavern.com/major-milestone-for-buddypress-2-million-downloads-and-counting?utm_source=rss&utm_medium=rss&utm_campaign=major-milestone-for-buddypress-2-million-downloads-and-counting\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1599:\"<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/balloons.jpg\" rel=\"prettyphoto[20944]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/balloons.jpg\" alt=\"balloons\" width=\"1016\" height=\"466\" class=\"aligncenter size-full wp-image-20946\" /></a></p>\n<p><a href=\"http://buddypress.org/\">BuddyPress</a> reached a major milestone today, crossing the two million download mark just a week ahead of the official 2.0 release. The plugin, known as &#8220;a social network in a box,&#8221; now has more than 500 related <a href=\"http://buddypress.org/extend/plugins/\" target=\"_blank\">community extensions</a>.</p>\n<p>Over the past 7 years, BuddyPress has developed a strong international community of users and contributors. Roughly <a href=\"http://wptavern.com/7-surprising-results-from-the-2013-buddypress-codex-survey\">50% of BuddyPress sites are in English</a>, with the other half comprised of social networks in Spanish, Italian, French, German, Dutch, Swedish, Portugese, Chinese, and many other languages.</p>\n<p>The upcoming version 2.0 of the plugin adds a host of new features that help administrators manage their communities more efficiently in the dashboard. It also introduces some remarkable performance improvements that <a href=\"http://wptavern.com/buddypress-2-0-ramps-up-performance-reduces-footprint-by-up-to-75\" target=\"_blank\">reduce the plugin&#8217;s footprint by up to 75%</a> in many places. Help celebrate BuddyPress crossing the two million download mark by testing <a href=\"http://buddypress.org/2014/04/buddypress-2-0-beta2/\" target=\"_blank\">2.0-beta2</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 11 Apr 2014 20:10:57 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:45;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"WPTavern: Next Version Of WordPress To Fix Quick Draft Dashboard Widget\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=20773\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:166:\"http://wptavern.com/wordpress-3-8-3-to-fix-quick-draft-dashboard-widget?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-3-8-3-to-fix-quick-draft-dashboard-widget\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2316:\"<p>If you&#8217;ve noticed after <a title=\"http://wptavern.com/wordpress-3-8-2-first-security-release-shipped-as-a-background-update\" href=\"http://wptavern.com/wordpress-3-8-2-first-security-release-shipped-as-a-background-update\">upgrading to WordPress 3.8.2</a> that the <a title=\"http://codex.wordpress.org/Dashboard_Screen#QuickDraft\" href=\"http://codex.wordpress.org/Dashboard_Screen#QuickDraft\">Quick Draft</a> dashboard widget no longer functions correctly, <a title=\"https://wordpress.org/support/topic/quick-draft-doesnt-save-the-posts-all-lost?replies=11\" href=\"https://wordpress.org/support/topic/quick-draft-doesnt-save-the-posts-all-lost?replies=11\">you&#8217;re not the only one</a>. Unfortunately, one of the security fixes in 3.8.2 caused the widget to break. Auto-drafts created through the widget are not being promoted to draft status. When a title and content is added to the widget, clicking the save draft button gives the appearance that its discarded. It doesn&#8217;t show up within the drafts list even though it exist within the database.</p>\n<p>The <a title=\"https://core.trac.wordpress.org/ticket/27734\" href=\"https://core.trac.wordpress.org/ticket/27734\">patch attempts</a> to do two things.</p>\n<ul>\n<li>Find all lost Quick Draft auto-drafts and promote them to proper drafts.</li>\n<li>Bring them back in place, with no date changes or other processing.</li>\n</ul>\n<p>Andrew Nacin, lead developer for WordPress, explains why every auto-draft created won&#8217;t be able to be retrieved.</p>\n<blockquote><p>Unfortunately, each save of Quick Draft by the same user would update the existing auto-draft they previously lost. If they used Quick Draft in succession, or tried again when they couldn&#8217;t find their post — both of which are not unlikely — we can only rescue their last edit.</p></blockquote>\n<p>Quick drafts only hold onto a single auto-draft post ID per user and will re-use it as long as it remains an auto-draft. This is due to performance reasons so new auto-drafts are not created each time the dashboard is visited. Once upgraded, you should see the latest draft created through Quick Draft with the date and time of creation kept in tact.</p>\n<p>If WordPress 3.8.3 is released, it may be available as soon as this weekend but nothing has been set in stone.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 11 Apr 2014 18:31:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:46;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"WPTavern: Help Test Akismet 3.0, Win Exclusive Akismet Swag\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=20888\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:160:\"http://wptavern.com/help-test-akismet-3-0-win-exclusive-akismet-swag?utm_source=rss&utm_medium=rss&utm_campaign=help-test-akismet-3-0-win-exclusive-akismet-swag\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2438:\"<p>Akismet 3.0 is currently in development and the official release will likely coincide with WordPress 3.9 on April 16th. The <a href=\"http://blog.akismet.com/2014/04/11/help-test-the-next-akismet-plugin/\" target=\"_blank\">upcoming 3.0 release</a> represents a major rewrite of the plugin and the Akismet team is inviting everyone to help test the release candidate. This version will introduce a few new features and will remove much of the legacy code that was included for backwards compatibility with older versions of WordPress.</p>\n<p>Akismet 3.0 has a more straightforward configuration page that funnels users to the correct action:</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/new-akismet.png\" rel=\"prettyphoto[20888]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/new-akismet.png\" alt=\"new-akismet\" width=\"1414\" height=\"1110\" class=\"aligncenter size-full wp-image-20912\" /></a></p>\n<p>One critical item that seems to be missing here is direction on where to find your API key if you already have one. Though it may be obvious to some that you need to log into Akismet, go to Account Overview, and click &#8220;reveal key,&#8221; this process is not as intuitive as it might seem. Hopefully something can be added to help make this clear. The team has confirmed that this is on their list.</p>\n<p>Akismet 3.0 inclues a new feature that allows you to define how strict it is in discarding spam. It also adds the ability to easily disconnect your account.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/aksismet-settings.png\" rel=\"prettyphoto[20888]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/aksismet-settings.png\" alt=\"aksismet-settings\" width=\"1394\" height=\"880\" class=\"aligncenter size-full wp-image-20918\" /></a></p>\n<p>The service has zapped more than 130 billion spam comments and track backs to date. Millions of WordPress users depend on Akismet every day to help keep their blogs clear of spam. If you can spare a few minutes to help test the 3.0 release candidate, the Akismet team promises some exclusive swag for those who submit the most helpful bug reports and feedback. Even better than that is the opportunity to help improve Akismet for WordPress users across the globe. Check out the <a href=\"http://blog.akismet.com/2014/04/11/help-test-the-next-akismet-plugin/\" target=\"_blank\">announcement post</a> for more details and the latest download link.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 11 Apr 2014 07:37:42 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:47;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"WPTavern: New Plugin Adds BuddyPress Activity as a Wire/Wall to User Profiles\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=20879\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:196:\"http://wptavern.com/new-plugin-adds-buddypress-activity-as-a-wirewall-to-user-profiles?utm_source=rss&utm_medium=rss&utm_campaign=new-plugin-adds-buddypress-activity-as-a-wirewall-to-user-profiles\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3121:\"<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/buddypress-wall.jpg\" rel=\"prettyphoto[20879]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/buddypress-wall.jpg\" alt=\"buddypress-wall\" width=\"1018\" height=\"458\" class=\"aligncenter size-full wp-image-20901\" /></a></p>\n<p>For the past four years, BuddyPress developer Brajesh Singh has maintained a <a href=\"http://buddydev.com/buddypress/using-activity-as-wire-in-buddypress-1-2-themes/\" target=\"_blank\">popular tutorial</a> for allowing BuddyPress activity as a wire. This was the default behavior for activity during the early 1.x era of BuddyPress, which allowed users to &#8220;write on each other&#8217;s walls&#8221; without having to use @mentions.</p>\n<p>Singh&#8217;s <a href=\"http://buddydev.com/buddypress/buddypress-activity-wire-updated-buddypress-1-8-buddypress-1-9/\" target=\"_blank\">updated tutorial</a> shows you how to set up wire/wall functionality without having to edit any theme code, as was required in previous tutorials. He&#8217;s packaged it up and put it into a convenient <a href=\"http://buddydev.com/plugins/bp-activity-as-wire/\" target=\"_blank\">plugin</a> that emulates a user wall/wire by performing the following:</p>\n<ul>\n<li>Shows the activity post form on other user’s profile</li>\n<li>Filters the text that says “What’s new {username}” to say “Write something to {displayed_user_name}”</li>\n<li>Removes the BuddyPress function that handles the post update action and hooks a custom function that allows saving the activity posted from user profiles as a mention.</li>\n</ul>\n<p>The result is very similar to the wall/wire feature originally included in BuddyPress:</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/buddypress-wire-wall.png\" rel=\"prettyphoto[20879]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/buddypress-wire-wall.png\" alt=\"buddypress-wire-wall\" width=\"1300\" height=\"627\" class=\"aligncenter size-full wp-image-20884\" /></a></p>\n<p>Posts on user wires/walls will show up in the activity stream as having originated on a user&#8217;s wall, differentiating it from regular activity @mentions.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/wallpost.png\" rel=\"prettyphoto[20879]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/wallpost.png\" alt=\"wallpost\" width=\"1168\" height=\"358\" class=\"aligncenter size-full wp-image-20894\" /></a></p>\n<p>Inevitably, BuddyPress developers will have clients asking them to make their social networks more like Facebook. Some users are more comfortable using the wire/wall style of interaction, as it is the default behavior on Facebook and mirrors the way activity worked in the early days of BuddyPress. This plugin will restore that feature to BuddyPress so that users don&#8217;t have to bother with @mentions.</p>\n<p>BuddyPress Activity as a Wire is compatible with BuddyPress 1.9.2+ but will require a minor update to take advantage of the activity performance improvements in 2.0. <a href=\"http://buddydev.com/plugins/bp-activity-as-wire/\" target=\"_blank\">Download it</a> for free from BuddyDEV.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 11 Apr 2014 06:40:12 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:48;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:42:\"Akismet: Help test the next Akismet plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://blog.akismet.com/?p=1288\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"http://blog.akismet.com/2014/04/11/help-test-the-next-akismet-plugin/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1964:\"<p>We&#8217;ve been hard at work on version 3.0 of the Akismet plugin for WordPress. It&#8217;s a major rewrite of the plugin code that includes a new configuration page, improved signup and activation, and some new features. We&#8217;ve shed most of the legacy code that was maintained for backwards compatibility with ancient versions of WordPress, and redesigned the code so we can bring you new features in coming months.</p>\n<p>Since it&#8217;s a major change from previous versions, we could use your help testing the new plugin before its final release. If you&#8217;re comfortable manually installing a plugin in WordPress, you can download <a href=\"http://downloads.wordpress.org/plugin/akismet.3.0.0-RC1.zip\">akismet.3.0.0-RC1.zip</a> or use the <a href=\"http://plugins.svn.wordpress.org/akismet/tags/3.0.0-RC1\">3.0.0-RC1 tag</a> in the Subversion repository.</p>\n<p>Try it out and tell us what you think &#8211; we have some <strong>exclusive Akismet swag</strong> for those who send bug reports and the most helpful feedback. Bug reports and detailed feedback is best sent via <a href=\"http://akismet.com/contact/\">our contact form</a>. You can leave general public feedback in comments below or <a href=\"https://twitter.com/akismet/\">on Twitter</a>.</p>\n<p>If you&#8217;re not sure how to install the plugin manually, or you&#8217;re not willing to run pre-release code on your site, we recommend waiting for the final release, which we expect to coincide with next week&#8217;s launch of <a href=\"http://wordpress.org/news/2014/04/wordpress-3-9-release-candidate/\">WordPress 3.9</a>.</p><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/akismet.wordpress.com/1288/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/akismet.wordpress.com/1288/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=blog.akismet.com&blog=116920&post=1288&subd=akismet&ref=&feed=1\" width=\"1\" height=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 11 Apr 2014 04:30:52 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Alex\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:49;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"WPTavern: Embed 2048 in WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=20706\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:114:\"http://wptavern.com/embed-2048-in-wordpress-2?utm_source=rss&utm_medium=rss&utm_campaign=embed-2048-in-wordpress-2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2010:\"<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/embed-2048.png\" rel=\"prettyphoto[20706]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/embed-2048-357x500.png\" alt=\"embed-2048\" width=\"357\" height=\"500\" class=\"alignright size-large wp-image-20859\" /></a>In the aftermath of the <a href=\"http://heartbleed.com/\" target=\"_blank\">Heartbleed</a> bug and a week filled with <a href=\"http://wptavern.com/breaking-jetpack-releases-critical-security-update-immediate-action-required\" target=\"_blank\">critical security updates</a>, it&#8217;s time for some good news. The wildly popular and hopelessly addictive 2048 game can now be embedded in WordPress.</p>\n<p>The <a href=\"http://wordpress.org/plugins/2048-number-game/\" target=\"_blank\">2048 WordPress plugin</a> is based on the open source game created by <a href=\"http://gabrielecirulli.github.io/2048/\" target=\"_blank\">Gabriele Cirulli</a>. The game has been cloned many times into mobile apps as well as <a href=\"http://allthe2048.com/\" target=\"_blank\">bewildering variations</a> that feature the likes of <a href=\"http://doge2048.com/\" target=\"_blank\">Doge</a> and <a href=\"http://hczhcz.github.io/Flappy-2048/\" target=\"_blank\">Flappy</a> <a href=\"http://chenglou.github.io/flappy-2048-side-by-side/\" target=\"_blank\">Bird</a>.</p>\n<p>Embedding 2048 in WordPress is as easy as adding the <strong>[2048]</strong> shortcode to any page or post. The objective of the game is to achieve the 2048 tile by using your arrow keys to merge tiles of the same number.</p>\n<p>If you want to help your website visitors waste hours of their lives, install the <a href=\"http://wordpress.org/plugins/2048-number-game/\" target=\"_blank\">2048 plugin</a> from the WordPress Plugin Directory and embed it on your site. By now many of your friends and colleagues have already beaten the game and will undoubtedly provide you with strategic tips. However, the desire to win is likely to consume your every waking moment. Don&#8217;t say I didn&#8217;t warn you.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 10 Apr 2014 22:34:43 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:9:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Tue, 22 Apr 2014 13:03:58 GMT\";s:12:\"content-type\";s:8:\"text/xml\";s:14:\"content-length\";s:6:\"233317\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:13:\"last-modified\";s:29:\"Tue, 22 Apr 2014 12:45:17 GMT\";s:4:\"x-nc\";s:11:\"HIT lax 249\";s:13:\"accept-ranges\";s:5:\"bytes\";}s:5:\"build\";s:14:\"20140417204711\";}", "no");
INSERT INTO `wp_options` VALUES("330", "_transient_timeout_feed_mod_867bd5c64f85878d03a060509cd2f92c", "1398215038", "no");
INSERT INTO `wp_options` VALUES("331", "_transient_feed_mod_867bd5c64f85878d03a060509cd2f92c", "1398171838", "no");
INSERT INTO `wp_options` VALUES("332", "_transient_timeout_feed_b9388c83948825c1edaef0d856b7b109", "1398215038", "no");
INSERT INTO `wp_options` VALUES("333", "_transient_feed_b9388c83948825c1edaef0d856b7b109", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n	\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:72:\"\n		\n		\n		\n		\n		\n		\n				\n\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"WordPress Plugins » View: Most Popular\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"http://wordpress.org/plugins/browse/popular/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"WordPress Plugins » View: Most Popular\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 22 Apr 2014 12:55:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"http://bbpress.org/?v=1.1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:15:{i:0;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"Akismet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"http://wordpress.org/plugins/akismet/#post-15\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 09 Mar 2007 22:11:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"15@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:98:\"Akismet checks your comments against the Akismet web service to see if they look like spam or not.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"Google XML Sitemaps\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"http://wordpress.org/plugins/google-sitemap-generator/#post-132\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 09 Mar 2007 22:31:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"132@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:105:\"This plugin will generate a special XML sitemap which will help search engines to better index your blog.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"Arnee\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Contact Form 7\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"http://wordpress.org/plugins/contact-form-7/#post-2141\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 02 Aug 2007 12:45:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"2141@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"Just another contact form plugin. Simple but flexible.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Takayuki Miyoshi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"WordPress SEO by Yoast\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"http://wordpress.org/plugins/wordpress-seo/#post-8321\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 01 Jan 2009 20:34:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"8321@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:131:\"Improve your WordPress SEO: Write better content and have a fully optimized WordPress site using the WordPress SEO plugin by Yoast.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Joost de Valk\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:24:\"Jetpack by WordPress.com\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"http://wordpress.org/plugins/jetpack/#post-23862\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 20 Jan 2011 02:21:38 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"23862@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:104:\"Supercharge your WordPress site with powerful features previously only available to WordPress.com users.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Tim Moore\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"All in One SEO Pack\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"http://wordpress.org/plugins/all-in-one-seo-pack/#post-753\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 30 Mar 2007 20:08:18 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"753@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:126:\"All in One SEO Pack is a WordPress SEO plugin to automatically optimize your WordPress blog for Search Engines such as Google.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"uberdose\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:46:\"iThemes Security (formerly Better WP Security)\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/plugins/better-wp-security/#post-21738\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 22 Oct 2010 22:06:05 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"21738@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"The easiest, most effective way to secure WordPress in seconds.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Chris Wiegman\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"MailPoet Newsletters\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/plugins/wysija-newsletters/#post-32629\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 02 Dec 2011 17:09:16 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"32629@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:94:\"Send newsletters, post notifications or autoresponders from WordPress easily, and beautifully.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"MailPoet Staff\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"WooCommerce - excelling eCommerce\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"http://wordpress.org/plugins/woocommerce/#post-29860\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 05 Sep 2011 08:13:36 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"29860@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:97:\"WooCommerce is a powerful, extendable eCommerce plugin that helps you sell anything. Beautifully.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"WooThemes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"Wordfence Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wordpress.org/plugins/wordfence/#post-29832\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 04 Sep 2011 03:13:51 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"29832@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:121:\"Wordfence Security is a free enterprise class security plugin that makes your site up to 50 times faster and more secure.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Wordfence\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"TinyMCE Advanced\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"http://wordpress.org/plugins/tinymce-advanced/#post-2082\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 27 Jun 2007 15:00:26 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"2082@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"Enables the advanced features of TinyMCE, the WordPress WYSIWYG editor.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Andrew Ozz\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"Advanced Custom Fields\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"http://wordpress.org/plugins/advanced-custom-fields/#post-25254\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 17 Mar 2011 04:07:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"25254@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:150:\"Fully customise WordPress edit screens with powerful fields. Boasting a professional interface and a powerful API, it’s a must have for any web deve\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"elliotcondon\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"WordPress Importer\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/plugins/wordpress-importer/#post-18101\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 20 May 2010 17:42:45 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"18101@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:101:\"Import posts, pages, comments, custom fields, categories, tags and more from a WordPress export file.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Brian Colinger\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"WPtouch Mobile Plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"http://wordpress.org/plugins/wptouch/#post-5468\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 01 May 2008 04:58:09 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"5468@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"Create a slick mobile WordPress website with just a few clicks.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"BraveNewCode Inc.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"NextGEN Gallery\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/plugins/nextgen-gallery/#post-1169\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 23 Apr 2007 20:08:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"1169@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:120:\"The most popular WordPress gallery plugin and one of the most popular plugins of all time with over 9 million downloads.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Alex Rabe\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:45:\"http://wordpress.org/plugins/rss/view/popular\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:7:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Tue, 22 Apr 2014 13:03:58 GMT\";s:12:\"content-type\";s:23:\"text/xml; charset=UTF-8\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:13:\"last-modified\";s:29:\"Fri, 09 Mar 2007 22:11:30 GMT\";s:4:\"x-nc\";s:11:\"HIT lax 249\";}s:5:\"build\";s:14:\"20140417204711\";}", "no");
INSERT INTO `wp_options` VALUES("334", "_transient_timeout_feed_mod_b9388c83948825c1edaef0d856b7b109", "1398215038", "no");
INSERT INTO `wp_options` VALUES("335", "_transient_feed_mod_b9388c83948825c1edaef0d856b7b109", "1398171838", "no");
INSERT INTO `wp_options` VALUES("336", "_transient_timeout_plugin_slugs", "1398258267", "no");
INSERT INTO `wp_options` VALUES("337", "_transient_plugin_slugs", "a:6:{i:0;s:19:\"akismet/akismet.php\";i:1;s:25:\"duplicator/duplicator.php\";i:2;s:9:\"hello.php\";i:3;s:19:\"jetpack/jetpack.php\";i:4;s:31:\"seo-wordpress/seo-wordpress.php\";i:5;s:27:\"wp-super-cache/wp-cache.php\";}", "no");
INSERT INTO `wp_options` VALUES("338", "_transient_timeout_dash_4077549d03da2e451c8b5f002294ff51", "1398215038", "no");
INSERT INTO `wp_options` VALUES("339", "_transient_dash_4077549d03da2e451c8b5f002294ff51", "<div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'http://wordpress.org/news/2014/04/smith/\'>WordPress 3.9 “Smith”</a> <span class=\"rss-date\">April 16, 2014</span><div class=\"rssSummary\">Version 3.9 of WordPress, named “Smith” in honor of jazz organist Jimmy Smith, is available for download or update in your WordPress dashboard. This release features a number of refinements that we hope you’ll love. A smoother media editing experience Improved visual editing The updated visual editor has improved speed, accessibility, and mobile support. You</div></li></ul></div><div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'http://wptavern.com/how-the-advanced-image-editing-properties-contributed-to-wordpress-theme-lock-in?utm_source=rss&#038;utm_medium=rss&#038;utm_campaign=how-the-advanced-image-editing-properties-contributed-to-wordpress-theme-lock-in\' title=\'Although WordPress 3.9 has refined the media editing experience, it did so at the cost of removing a feature users appreciated. In WordPress 3.8, users could easily add a border, vertical, and horizontal padding to images. WordPress 3.9 removed this from the advanced image settings screen. It’s not just those who use the self-hosted version of WordPress that\'>WPTavern: How The Advanced Image Editing Properties Contributed To WordPress Theme Lock-in</a></li><li><a class=\'rsswidget\' href=\'http://journalized.zed1.com/archives/2011/05/27/wordpress-eighth-birthday/?utm_source=rss&#038;utm_medium=rss&#038;utm_campaign=wordpress-eighth-birthday\' title=\'Today is WordPress’ official eighth birthday (the anniversary of the first release). I still marvel at the incredible distance it has come. I’m also still proud that I had a part in its birth. But even more, I marvel at the wonderful contribution of all the WordPress community make to this fantastic project. A client said to me this morning “This WordPress i\'>Mike Little: WordPress’ Eighth Birthday</a></li><li><a class=\'rsswidget\' href=\'http://journalized.zed1.com/archives/2013/05/27/wordpress-10th-anniversary-a-reflection/?utm_source=rss&#038;utm_medium=rss&#038;utm_campaign=wordpress-10th-anniversary-a-reflection\' title=\'I posted about WordPress’ 10th Anniversary celebration and reflected on the last 10 years over on my new blog The post WordPress 10th Anniversary: a Reflection appeared first on Mike Little&#039;s Journalized.\'>Mike Little: WordPress 10th Anniversary: a Reflection</a></li></ul></div><div class=\"rss-widget\"><ul><li class=\'dashboard-news-plugin\'><span>Popular Plugin:</span> <a href=\'http://wordpress.org/plugins/wysija-newsletters/\' class=\'dashboard-news-plugin-link\'>MailPoet Newsletters</a>&nbsp;<span>(<a href=\'plugin-install.php?tab=plugin-information&amp;plugin=wysija-newsletters&amp;_wpnonce=6ecadc8155&amp;TB_iframe=true&amp;width=600&amp;height=800\' class=\'thickbox\' title=\'MailPoet Newsletters\'>Install</a>)</span></li></ul></div>", "no");
INSERT INTO `wp_options` VALUES("340", "_site_transient_timeout_poptags_40cd750bba9870f18aada2478b24840a", "1398182644", "yes");
INSERT INTO `wp_options` VALUES("341", "_site_transient_poptags_40cd750bba9870f18aada2478b24840a", "a:40:{s:6:\"widget\";a:3:{s:4:\"name\";s:6:\"widget\";s:4:\"slug\";s:6:\"widget\";s:5:\"count\";s:4:\"3898\";}s:4:\"post\";a:3:{s:4:\"name\";s:4:\"Post\";s:4:\"slug\";s:4:\"post\";s:5:\"count\";s:4:\"2456\";}s:6:\"plugin\";a:3:{s:4:\"name\";s:6:\"plugin\";s:4:\"slug\";s:6:\"plugin\";s:5:\"count\";s:4:\"2344\";}s:5:\"admin\";a:3:{s:4:\"name\";s:5:\"admin\";s:4:\"slug\";s:5:\"admin\";s:5:\"count\";s:4:\"1930\";}s:5:\"posts\";a:3:{s:4:\"name\";s:5:\"posts\";s:4:\"slug\";s:5:\"posts\";s:5:\"count\";s:4:\"1856\";}s:7:\"sidebar\";a:3:{s:4:\"name\";s:7:\"sidebar\";s:4:\"slug\";s:7:\"sidebar\";s:5:\"count\";s:4:\"1583\";}s:7:\"twitter\";a:3:{s:4:\"name\";s:7:\"twitter\";s:4:\"slug\";s:7:\"twitter\";s:5:\"count\";s:4:\"1329\";}s:6:\"google\";a:3:{s:4:\"name\";s:6:\"google\";s:4:\"slug\";s:6:\"google\";s:5:\"count\";s:4:\"1325\";}s:8:\"comments\";a:3:{s:4:\"name\";s:8:\"comments\";s:4:\"slug\";s:8:\"comments\";s:5:\"count\";s:4:\"1310\";}s:6:\"images\";a:3:{s:4:\"name\";s:6:\"images\";s:4:\"slug\";s:6:\"images\";s:5:\"count\";s:4:\"1260\";}s:4:\"page\";a:3:{s:4:\"name\";s:4:\"page\";s:4:\"slug\";s:4:\"page\";s:5:\"count\";s:4:\"1225\";}s:5:\"image\";a:3:{s:4:\"name\";s:5:\"image\";s:4:\"slug\";s:5:\"image\";s:5:\"count\";s:4:\"1121\";}s:9:\"shortcode\";a:3:{s:4:\"name\";s:9:\"shortcode\";s:4:\"slug\";s:9:\"shortcode\";s:5:\"count\";s:4:\"1000\";}s:8:\"facebook\";a:3:{s:4:\"name\";s:8:\"Facebook\";s:4:\"slug\";s:8:\"facebook\";s:5:\"count\";s:3:\"982\";}s:5:\"links\";a:3:{s:4:\"name\";s:5:\"links\";s:4:\"slug\";s:5:\"links\";s:5:\"count\";s:3:\"974\";}s:3:\"seo\";a:3:{s:4:\"name\";s:3:\"seo\";s:4:\"slug\";s:3:\"seo\";s:5:\"count\";s:3:\"950\";}s:9:\"wordpress\";a:3:{s:4:\"name\";s:9:\"wordpress\";s:4:\"slug\";s:9:\"wordpress\";s:5:\"count\";s:3:\"844\";}s:7:\"gallery\";a:3:{s:4:\"name\";s:7:\"gallery\";s:4:\"slug\";s:7:\"gallery\";s:5:\"count\";s:3:\"821\";}s:6:\"social\";a:3:{s:4:\"name\";s:6:\"social\";s:4:\"slug\";s:6:\"social\";s:5:\"count\";s:3:\"780\";}s:3:\"rss\";a:3:{s:4:\"name\";s:3:\"rss\";s:4:\"slug\";s:3:\"rss\";s:5:\"count\";s:3:\"722\";}s:7:\"widgets\";a:3:{s:4:\"name\";s:7:\"widgets\";s:4:\"slug\";s:7:\"widgets\";s:5:\"count\";s:3:\"686\";}s:6:\"jquery\";a:3:{s:4:\"name\";s:6:\"jquery\";s:4:\"slug\";s:6:\"jquery\";s:5:\"count\";s:3:\"681\";}s:5:\"pages\";a:3:{s:4:\"name\";s:5:\"pages\";s:4:\"slug\";s:5:\"pages\";s:5:\"count\";s:3:\"678\";}s:5:\"email\";a:3:{s:4:\"name\";s:5:\"email\";s:4:\"slug\";s:5:\"email\";s:5:\"count\";s:3:\"623\";}s:4:\"ajax\";a:3:{s:4:\"name\";s:4:\"AJAX\";s:4:\"slug\";s:4:\"ajax\";s:5:\"count\";s:3:\"615\";}s:5:\"media\";a:3:{s:4:\"name\";s:5:\"media\";s:4:\"slug\";s:5:\"media\";s:5:\"count\";s:3:\"595\";}s:10:\"javascript\";a:3:{s:4:\"name\";s:10:\"javascript\";s:4:\"slug\";s:10:\"javascript\";s:5:\"count\";s:3:\"572\";}s:5:\"video\";a:3:{s:4:\"name\";s:5:\"video\";s:4:\"slug\";s:5:\"video\";s:5:\"count\";s:3:\"570\";}s:10:\"buddypress\";a:3:{s:4:\"name\";s:10:\"buddypress\";s:4:\"slug\";s:10:\"buddypress\";s:5:\"count\";s:3:\"541\";}s:4:\"feed\";a:3:{s:4:\"name\";s:4:\"feed\";s:4:\"slug\";s:4:\"feed\";s:5:\"count\";s:3:\"539\";}s:7:\"content\";a:3:{s:4:\"name\";s:7:\"content\";s:4:\"slug\";s:7:\"content\";s:5:\"count\";s:3:\"530\";}s:5:\"photo\";a:3:{s:4:\"name\";s:5:\"photo\";s:4:\"slug\";s:5:\"photo\";s:5:\"count\";s:3:\"522\";}s:4:\"link\";a:3:{s:4:\"name\";s:4:\"link\";s:4:\"slug\";s:4:\"link\";s:5:\"count\";s:3:\"506\";}s:6:\"photos\";a:3:{s:4:\"name\";s:6:\"photos\";s:4:\"slug\";s:6:\"photos\";s:5:\"count\";s:3:\"505\";}s:5:\"login\";a:3:{s:4:\"name\";s:5:\"login\";s:4:\"slug\";s:5:\"login\";s:5:\"count\";s:3:\"471\";}s:4:\"spam\";a:3:{s:4:\"name\";s:4:\"spam\";s:4:\"slug\";s:4:\"spam\";s:5:\"count\";s:3:\"458\";}s:5:\"stats\";a:3:{s:4:\"name\";s:5:\"stats\";s:4:\"slug\";s:5:\"stats\";s:5:\"count\";s:3:\"453\";}s:8:\"category\";a:3:{s:4:\"name\";s:8:\"category\";s:4:\"slug\";s:8:\"category\";s:5:\"count\";s:3:\"452\";}s:7:\"youtube\";a:3:{s:4:\"name\";s:7:\"youtube\";s:4:\"slug\";s:7:\"youtube\";s:5:\"count\";s:3:\"436\";}s:7:\"comment\";a:3:{s:4:\"name\";s:7:\"comment\";s:4:\"slug\";s:7:\"comment\";s:5:\"count\";s:3:\"432\";}}", "yes");
INSERT INTO `wp_options` VALUES("342", "_site_transient_update_plugins", "O:8:\"stdClass\":4:{s:12:\"last_checked\";i:1398171866;s:7:\"checked\";a:6:{s:19:\"akismet/akismet.php\";s:5:\"3.0.0\";s:25:\"duplicator/duplicator.php\";s:5:\"0.5.2\";s:9:\"hello.php\";s:3:\"1.6\";s:19:\"jetpack/jetpack.php\";s:5:\"2.9.3\";s:31:\"seo-wordpress/seo-wordpress.php\";s:5:\"3.0.2\";s:27:\"wp-super-cache/wp-cache.php\";s:3:\"1.4\";}s:8:\"response\";a:0:{}s:12:\"translations\";a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("343", "duplicator_settings", "a:8:{s:7:\"version\";s:5:\"0.5.2\";s:18:\"uninstall_settings\";b:1;s:15:\"uninstall_files\";b:1;s:16:\"uninstall_tables\";b:1;s:13:\"package_debug\";b:0;s:17:\"package_mysqldump\";b:0;s:22:\"package_mysqldump_path\";s:0:\"\";s:17:\"package_zip_flush\";b:0;}", "yes");
INSERT INTO `wp_options` VALUES("344", "duplicator_version_plugin", "0.5.2", "yes");
INSERT INTO `wp_options` VALUES("345", "duplicator_ui_view_state", "a:2:{s:14:\"dup-wpnotice01\";b:1;s:16:\"dup-notice01-chk\";s:1:\"1\";}", "yes");
INSERT INTO `wp_options` VALUES("346", "duplicator_package_active", "s:1324:\"O:11:\"DUP_Package\":15:{s:2:\"ID\";N;s:4:\"Name\";s:18:\"20140422_gardening\";s:4:\"Hash\";N;s:8:\"NameHash\";N;s:7:\"Version\";s:5:\"0.5.2\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:68:\"/home1/anton241/public_html/blogsforsales.com/green/wp-snapshots/tmp\";s:8:\"StoreURL\";s:44:\"http://blogsforsales.com/green/wp-snapshots/\";s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:7:\"Archive\";O:11:\"DUP_Archive\":15:{s:10:\"FilterDirs\";s:0:\"\";s:10:\"FilterExts\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"File\";N;s:6:\"Format\";s:3:\"ZIP\";s:7:\"PackDir\";s:51:\"/home1/anton241/public_html/blogsforsales.com/green\";s:8:\"DirCount\";i:0;s:9:\"FileCount\";i:0;s:9:\"LinkCount\";i:0;s:4:\"Size\";i:0;s:11:\"BigFileList\";a:0:{}s:15:\"InvalidFileList\";a:0:{}s:10:\"\0*\0Package\";r:1;s:28:\"\0DUP_Archive\0filterDirsArray\";a:0:{}s:28:\"\0DUP_Archive\0filterExtsArray\";a:0:{}}s:9:\"Installer\";O:13:\"DUP_Installer\":11:{s:4:\"File\";N;s:4:\"Size\";i:0;s:10:\"OptsDBHost\";s:0:\"\";s:10:\"OptsDBName\";s:0:\"\";s:10:\"OptsDBUser\";s:0:\"\";s:12:\"OptsSSLAdmin\";i:0;s:12:\"OptsSSLLogin\";i:0;s:11:\"OptsCacheWP\";i:0;s:13:\"OptsCachePath\";i:0;s:10:\"OptsURLNew\";s:0:\"\";s:10:\"\0*\0Package\";r:1;}s:8:\"Database\";O:12:\"DUP_Database\":9:{s:4:\"Type\";s:5:\"MySQL\";s:4:\"Size\";N;s:4:\"File\";N;s:4:\"Path\";N;s:12:\"FilterTables\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"Name\";N;s:10:\"\0*\0Package\";r:1;s:25:\"\0DUP_Database\0dbStorePath\";N;}}\";", "yes");

/* INSERT TABLE DATA: wp_postmeta */
INSERT INTO `wp_postmeta` VALUES("1", "2", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("2", "1", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("5", "1", "_edit_lock", "1394138845:1");
INSERT INTO `wp_postmeta` VALUES("10", "6", "imwb_cc_amazon_asin", "B000DZH3XO");
INSERT INTO `wp_postmeta` VALUES("11", "6", "_imwb_cc_amazon_asin_updated", "1398171798");
INSERT INTO `wp_postmeta` VALUES("12", "7", "_wp_attached_file", "2014/04/41I7m8qWmkL.jpg");
INSERT INTO `wp_postmeta` VALUES("13", "7", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:323;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/41I7m8qWmkL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41I7m8qWmkL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41I7m8qWmkL-193x300.jpg\";s:5:\"width\";i:193;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41I7m8qWmkL-161x250.jpg\";s:5:\"width\";i:161;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41I7m8qWmkL-161x250.jpg\";s:5:\"width\";i:161;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"41I7m8qWmkL-82x128.jpg\";s:5:\"width\";i:82;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"41I7m8qWmkL-90x140.jpg\";s:5:\"width\";i:90;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41I7m8qWmkL-32x50.jpg\";s:5:\"width\";i:32;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("14", "6", "_thumbnail_id", "7");
INSERT INTO `wp_postmeta` VALUES("15", "6", "imwb_zonpress_post_producturl", "http://www.amazon.com/Fiskars-Piece-Softouch-Garden-Tool/dp/B000DZH3XO%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB000DZH3XO");
INSERT INTO `wp_postmeta` VALUES("16", "6", "imwb_zonpress_post_price", "14.99");
INSERT INTO `wp_postmeta` VALUES("17", "6", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("18", "6", "_imwb_zonpress_post_imp", "27");
INSERT INTO `wp_postmeta` VALUES("19", "6", "_imwb_zonpress_post_clicks", "1");
INSERT INTO `wp_postmeta` VALUES("20", "6", "_imwb_zonpress_post_ctr", "3.7037037037");
INSERT INTO `wp_postmeta` VALUES("21", "6", "imwb_interest_post_link_url", "http://www.amazon.com/Fiskars-Piece-Softouch-Garden-Tool/dp/B000DZH3XO%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB000DZH3XO");
INSERT INTO `wp_postmeta` VALUES("22", "6", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("25", "8", "imwb_cc_amazon_asin", "B00005YX30");
INSERT INTO `wp_postmeta` VALUES("26", "8", "_imwb_cc_amazon_asin_updated", "1398171798");
INSERT INTO `wp_postmeta` VALUES("27", "9", "_wp_attached_file", "2014/04/41ESVX7QBEL.jpg");
INSERT INTO `wp_postmeta` VALUES("28", "9", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/41ESVX7QBEL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41ESVX7QBEL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41ESVX7QBEL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41ESVX7QBEL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41ESVX7QBEL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41ESVX7QBEL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41ESVX7QBEL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41ESVX7QBEL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("29", "8", "_thumbnail_id", "9");
INSERT INTO `wp_postmeta` VALUES("30", "8", "imwb_zonpress_post_producturl", "http://www.amazon.com/Fiskars-94246980J-Garden-Bucket-Caddy/dp/B00005YX30%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00005YX30");
INSERT INTO `wp_postmeta` VALUES("31", "8", "imwb_zonpress_post_price", "11.31");
INSERT INTO `wp_postmeta` VALUES("32", "8", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("33", "8", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("34", "8", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("35", "8", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("36", "8", "imwb_interest_post_link_url", "http://www.amazon.com/Fiskars-94246980J-Garden-Bucket-Caddy/dp/B00005YX30%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00005YX30");
INSERT INTO `wp_postmeta` VALUES("37", "8", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("40", "10", "imwb_cc_amazon_asin", "B0058STCFS");
INSERT INTO `wp_postmeta` VALUES("41", "10", "_imwb_cc_amazon_asin_updated", "1398171798");
INSERT INTO `wp_postmeta` VALUES("42", "11", "_wp_attached_file", "2014/04/41NCm8TUIdL.jpg");
INSERT INTO `wp_postmeta` VALUES("43", "11", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:459;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/41NCm8TUIdL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41NCm8TUIdL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41NCm8TUIdL-275x300.jpg\";s:5:\"width\";i:275;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41NCm8TUIdL-229x250.jpg\";s:5:\"width\";i:229;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41NCm8TUIdL-229x250.jpg\";s:5:\"width\";i:229;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41NCm8TUIdL-117x128.jpg\";s:5:\"width\";i:117;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41NCm8TUIdL-128x140.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41NCm8TUIdL-45x50.jpg\";s:5:\"width\";i:45;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("44", "10", "_thumbnail_id", "11");
INSERT INTO `wp_postmeta` VALUES("45", "10", "imwb_zonpress_post_producturl", "http://www.amazon.com/Master-Craft-Eight-Piece-Garden-Tool/dp/B0058STCFS%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0058STCFS");
INSERT INTO `wp_postmeta` VALUES("46", "10", "imwb_zonpress_post_price", "29.54");
INSERT INTO `wp_postmeta` VALUES("47", "10", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("48", "10", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("49", "10", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("50", "10", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("51", "10", "imwb_interest_post_link_url", "http://www.amazon.com/Master-Craft-Eight-Piece-Garden-Tool/dp/B0058STCFS%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0058STCFS");
INSERT INTO `wp_postmeta` VALUES("52", "10", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("55", "12", "imwb_cc_amazon_asin", "B00002N66H");
INSERT INTO `wp_postmeta` VALUES("56", "12", "_imwb_cc_amazon_asin_updated", "1398171799");
INSERT INTO `wp_postmeta` VALUES("57", "13", "_wp_attached_file", "2014/04/31fhfmQTxGL.jpg");
INSERT INTO `wp_postmeta` VALUES("58", "13", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:165;s:4:\"file\";s:23:\"2014/04/31fhfmQTxGL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"31fhfmQTxGL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:22:\"31fhfmQTxGL-300x99.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:99;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:22:\"31fhfmQTxGL-300x99.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:99;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:22:\"31fhfmQTxGL-300x99.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:99;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"31fhfmQTxGL-153x50.jpg\";s:5:\"width\";i:153;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"31fhfmQTxGL-170x56.jpg\";s:5:\"width\";i:170;s:6:\"height\";i:56;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"31fhfmQTxGL-50x16.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:16;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("59", "12", "_thumbnail_id", "13");
INSERT INTO `wp_postmeta` VALUES("60", "12", "imwb_zonpress_post_producturl", "http://www.amazon.com/Fiskars-Traditional-Bypass-Pruning-Shears/dp/B00002N66H%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00002N66H");
INSERT INTO `wp_postmeta` VALUES("61", "12", "imwb_zonpress_post_price", "6.5");
INSERT INTO `wp_postmeta` VALUES("62", "12", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("63", "12", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("64", "12", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("65", "12", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("66", "12", "imwb_interest_post_link_url", "http://www.amazon.com/Fiskars-Traditional-Bypass-Pruning-Shears/dp/B00002N66H%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00002N66H");
INSERT INTO `wp_postmeta` VALUES("67", "12", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("70", "14", "imwb_cc_amazon_asin", "B002LGMIWE");
INSERT INTO `wp_postmeta` VALUES("71", "14", "_imwb_cc_amazon_asin_updated", "1398171799");
INSERT INTO `wp_postmeta` VALUES("72", "15", "_wp_attached_file", "2014/04/51xdw0oXZwL.jpg");
INSERT INTO `wp_postmeta` VALUES("73", "15", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:362;s:4:\"file\";s:23:\"2014/04/51xdw0oXZwL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51xdw0oXZwL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51xdw0oXZwL-300x217.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:217;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51xdw0oXZwL-300x217.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:217;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51xdw0oXZwL-300x217.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:217;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51xdw0oXZwL-153x110.jpg\";s:5:\"width\";i:153;s:6:\"height\";i:110;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51xdw0oXZwL-170x123.jpg\";s:5:\"width\";i:170;s:6:\"height\";i:123;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51xdw0oXZwL-50x36.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:36;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("74", "14", "_thumbnail_id", "15");
INSERT INTO `wp_postmeta` VALUES("75", "14", "imwb_zonpress_post_producturl", "http://www.amazon.com/Black-Decker-Garden-Series-Culti-Hoe/dp/B002LGMIWE%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB002LGMIWE");
INSERT INTO `wp_postmeta` VALUES("76", "14", "imwb_zonpress_post_price", "15.99");
INSERT INTO `wp_postmeta` VALUES("77", "14", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("78", "14", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("79", "14", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("80", "14", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("81", "14", "imwb_interest_post_link_url", "http://www.amazon.com/Black-Decker-Garden-Series-Culti-Hoe/dp/B002LGMIWE%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB002LGMIWE");
INSERT INTO `wp_postmeta` VALUES("82", "14", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("85", "16", "imwb_cc_amazon_asin", "B00757F3DA");
INSERT INTO `wp_postmeta` VALUES("86", "16", "_imwb_cc_amazon_asin_updated", "1398171799");
INSERT INTO `wp_postmeta` VALUES("87", "17", "_wp_attached_file", "2014/04/51Bz8AL2scL.jpg");
INSERT INTO `wp_postmeta` VALUES("88", "17", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/51Bz8AL2scL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51Bz8AL2scL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51Bz8AL2scL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51Bz8AL2scL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51Bz8AL2scL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51Bz8AL2scL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51Bz8AL2scL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51Bz8AL2scL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("89", "16", "_thumbnail_id", "17");
INSERT INTO `wp_postmeta` VALUES("90", "16", "imwb_zonpress_post_producturl", "http://www.amazon.com/Wrapables-Indoor-Gardening-Tool-Set/dp/B00757F3DA%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00757F3DA");
INSERT INTO `wp_postmeta` VALUES("91", "16", "imwb_zonpress_post_price", "14.99");
INSERT INTO `wp_postmeta` VALUES("92", "16", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("93", "16", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("94", "16", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("95", "16", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("96", "16", "imwb_interest_post_link_url", "http://www.amazon.com/Wrapables-Indoor-Gardening-Tool-Set/dp/B00757F3DA%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00757F3DA");
INSERT INTO `wp_postmeta` VALUES("97", "16", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("100", "18", "imwb_cc_amazon_asin", "B000FTGIAM");
INSERT INTO `wp_postmeta` VALUES("101", "18", "_imwb_cc_amazon_asin_updated", "1398171799");
INSERT INTO `wp_postmeta` VALUES("102", "19", "_wp_attached_file", "2014/04/51t+A5FlOtL.jpg");
INSERT INTO `wp_postmeta` VALUES("103", "19", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/51t+A5FlOtL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51t+A5FlOtL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51t+A5FlOtL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51t+A5FlOtL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51t+A5FlOtL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51t+A5FlOtL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51t+A5FlOtL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51t+A5FlOtL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("104", "18", "_thumbnail_id", "19");
INSERT INTO `wp_postmeta` VALUES("105", "18", "imwb_zonpress_post_producturl", "http://www.amazon.com/Picnic-Time-5-Piece-Garden-Folding/dp/B000FTGIAM%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB000FTGIAM");
INSERT INTO `wp_postmeta` VALUES("106", "18", "imwb_zonpress_post_price", "59.95");
INSERT INTO `wp_postmeta` VALUES("107", "18", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("108", "18", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("109", "18", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("110", "18", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("111", "18", "imwb_interest_post_link_url", "http://www.amazon.com/Picnic-Time-5-Piece-Garden-Folding/dp/B000FTGIAM%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB000FTGIAM");
INSERT INTO `wp_postmeta` VALUES("112", "18", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("115", "20", "imwb_cc_amazon_asin", "B001IMOG18");
INSERT INTO `wp_postmeta` VALUES("116", "20", "_imwb_cc_amazon_asin_updated", "1398171799");
INSERT INTO `wp_postmeta` VALUES("117", "21", "_wp_attached_file", "2014/04/51rEXTU+nLL.jpg");
INSERT INTO `wp_postmeta` VALUES("118", "21", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:366;s:4:\"file\";s:23:\"2014/04/51rEXTU+nLL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51rEXTU+nLL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51rEXTU+nLL-300x219.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:219;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51rEXTU+nLL-300x219.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:219;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51rEXTU+nLL-300x219.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:219;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51rEXTU+nLL-153x111.jpg\";s:5:\"width\";i:153;s:6:\"height\";i:111;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51rEXTU+nLL-170x124.jpg\";s:5:\"width\";i:170;s:6:\"height\";i:124;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51rEXTU+nLL-50x36.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:36;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("119", "20", "_thumbnail_id", "21");
INSERT INTO `wp_postmeta` VALUES("120", "20", "imwb_zonpress_post_producturl", "http://www.amazon.com/1852-3-Jersey-Garden-Gloves-3-Pairs/dp/B001IMOG18%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB001IMOG18");
INSERT INTO `wp_postmeta` VALUES("121", "20", "imwb_zonpress_post_price", "7.79");
INSERT INTO `wp_postmeta` VALUES("122", "20", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("123", "20", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("124", "20", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("125", "20", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("126", "20", "imwb_interest_post_link_url", "http://www.amazon.com/1852-3-Jersey-Garden-Gloves-3-Pairs/dp/B001IMOG18%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB001IMOG18");
INSERT INTO `wp_postmeta` VALUES("127", "20", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("130", "22", "imwb_cc_amazon_asin", "B00005BW71");
INSERT INTO `wp_postmeta` VALUES("131", "22", "_imwb_cc_amazon_asin_updated", "1398171799");
INSERT INTO `wp_postmeta` VALUES("132", "23", "_wp_attached_file", "2014/04/51WCqH8uLCL.jpg");
INSERT INTO `wp_postmeta` VALUES("133", "23", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:438;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/51WCqH8uLCL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51WCqH8uLCL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51WCqH8uLCL-262x300.jpg\";s:5:\"width\";i:262;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51WCqH8uLCL-219x250.jpg\";s:5:\"width\";i:219;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51WCqH8uLCL-219x250.jpg\";s:5:\"width\";i:219;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51WCqH8uLCL-112x128.jpg\";s:5:\"width\";i:112;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51WCqH8uLCL-122x140.jpg\";s:5:\"width\";i:122;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51WCqH8uLCL-43x50.jpg\";s:5:\"width\";i:43;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("134", "22", "_thumbnail_id", "23");
INSERT INTO `wp_postmeta` VALUES("135", "22", "imwb_zonpress_post_producturl", "http://www.amazon.com/Toysmith-2296-Kids-3-Piece-Garden/dp/B00005BW71%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00005BW71");
INSERT INTO `wp_postmeta` VALUES("136", "22", "imwb_zonpress_post_price", "5.99");
INSERT INTO `wp_postmeta` VALUES("137", "22", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("138", "22", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("139", "22", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("140", "22", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("141", "22", "imwb_interest_post_link_url", "http://www.amazon.com/Toysmith-2296-Kids-3-Piece-Garden/dp/B00005BW71%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00005BW71");
INSERT INTO `wp_postmeta` VALUES("142", "22", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("145", "24", "imwb_cc_amazon_asin", "B000P78CQM");
INSERT INTO `wp_postmeta` VALUES("146", "24", "_imwb_cc_amazon_asin_updated", "1398171800");
INSERT INTO `wp_postmeta` VALUES("147", "25", "_wp_attached_file", "2014/04/41hf2WzmL8L.jpg");
INSERT INTO `wp_postmeta` VALUES("148", "25", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:393;s:4:\"file\";s:23:\"2014/04/41hf2WzmL8L.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41hf2WzmL8L-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41hf2WzmL8L-300x235.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:235;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41hf2WzmL8L-300x235.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:235;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41hf2WzmL8L-300x235.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:235;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41hf2WzmL8L-153x120.jpg\";s:5:\"width\";i:153;s:6:\"height\";i:120;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41hf2WzmL8L-170x133.jpg\";s:5:\"width\";i:170;s:6:\"height\";i:133;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41hf2WzmL8L-50x39.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:39;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("149", "24", "_thumbnail_id", "25");
INSERT INTO `wp_postmeta` VALUES("150", "24", "imwb_zonpress_post_producturl", "http://www.amazon.com/Radius-Garden-NRGSET-Transplanter-Cultivator/dp/B000P78CQM%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB000P78CQM");
INSERT INTO `wp_postmeta` VALUES("151", "24", "imwb_zonpress_post_price", "38.95");
INSERT INTO `wp_postmeta` VALUES("152", "24", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("153", "24", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("154", "24", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("155", "24", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("156", "24", "imwb_interest_post_link_url", "http://www.amazon.com/Radius-Garden-NRGSET-Transplanter-Cultivator/dp/B000P78CQM%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB000P78CQM");
INSERT INTO `wp_postmeta` VALUES("157", "24", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("160", "26", "imwb_cc_amazon_asin", "B0002YVDSW");
INSERT INTO `wp_postmeta` VALUES("161", "26", "_imwb_cc_amazon_asin_updated", "1398171800");
INSERT INTO `wp_postmeta` VALUES("162", "27", "_wp_attached_file", "2014/04/31fLwed8LJL.jpg");
INSERT INTO `wp_postmeta` VALUES("163", "27", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:257;s:4:\"file\";s:23:\"2014/04/31fLwed8LJL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"31fLwed8LJL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"31fLwed8LJL-300x154.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:154;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"31fLwed8LJL-300x154.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:154;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"31fLwed8LJL-300x154.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:154;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"31fLwed8LJL-153x78.jpg\";s:5:\"width\";i:153;s:6:\"height\";i:78;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"31fLwed8LJL-170x87.jpg\";s:5:\"width\";i:170;s:6:\"height\";i:87;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"31fLwed8LJL-50x25.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:25;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("164", "26", "_thumbnail_id", "27");
INSERT INTO `wp_postmeta` VALUES("165", "26", "imwb_zonpress_post_producturl", "http://www.amazon.com/Fiskars-7878-7978-Composite-Trowel/dp/B0002YVDSW%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0002YVDSW");
INSERT INTO `wp_postmeta` VALUES("166", "26", "imwb_zonpress_post_price", "2.39");
INSERT INTO `wp_postmeta` VALUES("167", "26", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("168", "26", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("169", "26", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("170", "26", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("171", "26", "imwb_interest_post_link_url", "http://www.amazon.com/Fiskars-7878-7978-Composite-Trowel/dp/B0002YVDSW%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0002YVDSW");
INSERT INTO `wp_postmeta` VALUES("172", "26", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("175", "28", "imwb_cc_amazon_asin", "B00JEJ7O5M");
INSERT INTO `wp_postmeta` VALUES("176", "28", "_imwb_cc_amazon_asin_updated", "1398171800");
INSERT INTO `wp_postmeta` VALUES("177", "29", "_wp_attached_file", "2014/04/41GWJOiP0gL.jpg");
INSERT INTO `wp_postmeta` VALUES("178", "29", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/41GWJOiP0gL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41GWJOiP0gL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41GWJOiP0gL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41GWJOiP0gL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41GWJOiP0gL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41GWJOiP0gL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41GWJOiP0gL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41GWJOiP0gL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("179", "28", "_thumbnail_id", "29");
INSERT INTO `wp_postmeta` VALUES("180", "28", "imwb_zonpress_post_producturl", "http://www.amazon.com/Homegrown-3-piece-Garden-Tool-Set/dp/B00JEJ7O5M%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00JEJ7O5M");
INSERT INTO `wp_postmeta` VALUES("181", "28", "imwb_zonpress_post_price", "17.99");
INSERT INTO `wp_postmeta` VALUES("182", "28", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("183", "28", "_imwb_zonpress_post_imp", "24");
INSERT INTO `wp_postmeta` VALUES("184", "28", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("185", "28", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("186", "28", "imwb_interest_post_link_url", "http://www.amazon.com/Homegrown-3-piece-Garden-Tool-Set/dp/B00JEJ7O5M%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00JEJ7O5M");
INSERT INTO `wp_postmeta` VALUES("187", "28", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("190", "30", "imwb_cc_amazon_asin", "B0050LK8S8");
INSERT INTO `wp_postmeta` VALUES("191", "30", "_imwb_cc_amazon_asin_updated", "1398171801");
INSERT INTO `wp_postmeta` VALUES("192", "31", "_wp_attached_file", "2014/04/41mlM28f9KL.jpg");
INSERT INTO `wp_postmeta` VALUES("193", "31", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:454;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/41mlM28f9KL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41mlM28f9KL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41mlM28f9KL-272x300.jpg\";s:5:\"width\";i:272;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41mlM28f9KL-227x250.jpg\";s:5:\"width\";i:227;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41mlM28f9KL-227x250.jpg\";s:5:\"width\";i:227;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41mlM28f9KL-116x128.jpg\";s:5:\"width\";i:116;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41mlM28f9KL-127x140.jpg\";s:5:\"width\";i:127;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41mlM28f9KL-45x50.jpg\";s:5:\"width\";i:45;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("194", "30", "_thumbnail_id", "31");
INSERT INTO `wp_postmeta` VALUES("195", "30", "imwb_zonpress_post_producturl", "http://www.amazon.com/Apollo-Precision-Tools-DT0825P-Organizer/dp/B0050LK8S8%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0050LK8S8");
INSERT INTO `wp_postmeta` VALUES("196", "30", "imwb_zonpress_post_price", "14.97");
INSERT INTO `wp_postmeta` VALUES("197", "30", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("198", "30", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("199", "30", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("200", "30", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("201", "30", "imwb_interest_post_link_url", "http://www.amazon.com/Apollo-Precision-Tools-DT0825P-Organizer/dp/B0050LK8S8%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0050LK8S8");
INSERT INTO `wp_postmeta` VALUES("202", "30", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("205", "32", "imwb_cc_amazon_asin", "B00IPKNYIW");
INSERT INTO `wp_postmeta` VALUES("206", "32", "_imwb_cc_amazon_asin_updated", "1398171801");
INSERT INTO `wp_postmeta` VALUES("207", "33", "_wp_attached_file", "2014/04/41sO2EmIhOL.jpg");
INSERT INTO `wp_postmeta` VALUES("208", "33", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/41sO2EmIhOL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41sO2EmIhOL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41sO2EmIhOL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41sO2EmIhOL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41sO2EmIhOL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41sO2EmIhOL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41sO2EmIhOL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41sO2EmIhOL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("209", "32", "_thumbnail_id", "33");
INSERT INTO `wp_postmeta` VALUES("210", "32", "imwb_zonpress_post_producturl", "http://www.amazon.com/Blooms-5-Piece-Gardening-Tool-Canvas/dp/B00IPKNYIW%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00IPKNYIW");
INSERT INTO `wp_postmeta` VALUES("211", "32", "imwb_zonpress_post_price", "22.5");
INSERT INTO `wp_postmeta` VALUES("212", "32", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("213", "32", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("214", "32", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("215", "32", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("216", "32", "imwb_interest_post_link_url", "http://www.amazon.com/Blooms-5-Piece-Gardening-Tool-Canvas/dp/B00IPKNYIW%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00IPKNYIW");
INSERT INTO `wp_postmeta` VALUES("217", "32", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("220", "34", "imwb_cc_amazon_asin", "B000RYPZQ8");
INSERT INTO `wp_postmeta` VALUES("221", "34", "_imwb_cc_amazon_asin_updated", "1398171801");
INSERT INTO `wp_postmeta` VALUES("222", "35", "_wp_attached_file", "2014/04/41OKK6YyYVL.jpg");
INSERT INTO `wp_postmeta` VALUES("223", "35", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/41OKK6YyYVL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41OKK6YyYVL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41OKK6YyYVL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41OKK6YyYVL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41OKK6YyYVL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41OKK6YyYVL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41OKK6YyYVL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41OKK6YyYVL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("224", "34", "_thumbnail_id", "35");
INSERT INTO `wp_postmeta` VALUES("225", "34", "imwb_zonpress_post_producturl", "http://www.amazon.com/Yard-Butler-GKS-2-Garden-Kneeler/dp/B000RYPZQ8%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB000RYPZQ8");
INSERT INTO `wp_postmeta` VALUES("226", "34", "imwb_zonpress_post_price", "28.88");
INSERT INTO `wp_postmeta` VALUES("227", "34", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("228", "34", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("229", "34", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("230", "34", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("231", "34", "imwb_interest_post_link_url", "http://www.amazon.com/Yard-Butler-GKS-2-Garden-Kneeler/dp/B000RYPZQ8%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB000RYPZQ8");
INSERT INTO `wp_postmeta` VALUES("232", "34", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("235", "36", "imwb_cc_amazon_asin", "B003TJ9G40");
INSERT INTO `wp_postmeta` VALUES("236", "36", "_imwb_cc_amazon_asin_updated", "1398171802");
INSERT INTO `wp_postmeta` VALUES("237", "37", "_wp_attached_file", "2014/04/21UDpnMYdaL.jpg");
INSERT INTO `wp_postmeta` VALUES("238", "37", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:121;s:4:\"file\";s:23:\"2014/04/21UDpnMYdaL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"21UDpnMYdaL-150x121.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:121;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:22:\"21UDpnMYdaL-300x72.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:72;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:22:\"21UDpnMYdaL-300x72.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:72;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:22:\"21UDpnMYdaL-300x72.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:72;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"21UDpnMYdaL-153x37.jpg\";s:5:\"width\";i:153;s:6:\"height\";i:37;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"21UDpnMYdaL-170x41.jpg\";s:5:\"width\";i:170;s:6:\"height\";i:41;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"21UDpnMYdaL-50x12.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:12;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("239", "36", "_thumbnail_id", "37");
INSERT INTO `wp_postmeta` VALUES("240", "36", "imwb_zonpress_post_producturl", "http://www.amazon.com/Fiskars-70606935J-Softouch-Weeder/dp/B003TJ9G40%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB003TJ9G40");
INSERT INTO `wp_postmeta` VALUES("241", "36", "imwb_zonpress_post_price", "5.97");
INSERT INTO `wp_postmeta` VALUES("242", "36", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("243", "36", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("244", "36", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("245", "36", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("246", "36", "imwb_interest_post_link_url", "http://www.amazon.com/Fiskars-70606935J-Softouch-Weeder/dp/B003TJ9G40%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB003TJ9G40");
INSERT INTO `wp_postmeta` VALUES("247", "36", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("250", "38", "imwb_cc_amazon_asin", "B004W8RKR2");
INSERT INTO `wp_postmeta` VALUES("251", "38", "_imwb_cc_amazon_asin_updated", "1398171802");
INSERT INTO `wp_postmeta` VALUES("252", "39", "_wp_attached_file", "2014/04/41C5FXaBZdL.jpg");
INSERT INTO `wp_postmeta` VALUES("253", "39", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:332;s:4:\"file\";s:23:\"2014/04/41C5FXaBZdL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41C5FXaBZdL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41C5FXaBZdL-300x199.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:199;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41C5FXaBZdL-300x199.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:199;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41C5FXaBZdL-300x199.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:199;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41C5FXaBZdL-153x101.jpg\";s:5:\"width\";i:153;s:6:\"height\";i:101;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41C5FXaBZdL-170x112.jpg\";s:5:\"width\";i:170;s:6:\"height\";i:112;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41C5FXaBZdL-50x33.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:33;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("254", "38", "_thumbnail_id", "39");
INSERT INTO `wp_postmeta` VALUES("255", "38", "imwb_zonpress_post_producturl", "http://www.amazon.com/Womens-Garden-Gloves-assorted-colors/dp/B004W8RKR2%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB004W8RKR2");
INSERT INTO `wp_postmeta` VALUES("256", "38", "imwb_zonpress_post_price", "8.99");
INSERT INTO `wp_postmeta` VALUES("257", "38", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("258", "38", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("259", "38", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("260", "38", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("261", "38", "imwb_interest_post_link_url", "http://www.amazon.com/Womens-Garden-Gloves-assorted-colors/dp/B004W8RKR2%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB004W8RKR2");
INSERT INTO `wp_postmeta` VALUES("262", "38", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("265", "40", "imwb_cc_amazon_asin", "B00D4JV9NQ");
INSERT INTO `wp_postmeta` VALUES("266", "40", "_imwb_cc_amazon_asin_updated", "1398171802");
INSERT INTO `wp_postmeta` VALUES("267", "41", "_wp_attached_file", "2014/04/51ZDAZTsQ2L.jpg");
INSERT INTO `wp_postmeta` VALUES("268", "41", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:438;s:4:\"file\";s:23:\"2014/04/51ZDAZTsQ2L.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51ZDAZTsQ2L-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51ZDAZTsQ2L-300x262.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:262;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51ZDAZTsQ2L-285x250.jpg\";s:5:\"width\";i:285;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51ZDAZTsQ2L-285x250.jpg\";s:5:\"width\";i:285;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51ZDAZTsQ2L-146x128.jpg\";s:5:\"width\";i:146;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51ZDAZTsQ2L-159x140.jpg\";s:5:\"width\";i:159;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51ZDAZTsQ2L-50x43.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:43;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("269", "40", "_thumbnail_id", "41");
INSERT INTO `wp_postmeta` VALUES("270", "40", "imwb_zonpress_post_producturl", "http://www.amazon.com/Kids-Garden-Tools-Tote-Bag/dp/B00D4JV9NQ%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00D4JV9NQ");
INSERT INTO `wp_postmeta` VALUES("271", "40", "imwb_zonpress_post_price", "18.5");
INSERT INTO `wp_postmeta` VALUES("272", "40", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("273", "40", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("274", "40", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("275", "40", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("276", "40", "imwb_interest_post_link_url", "http://www.amazon.com/Kids-Garden-Tools-Tote-Bag/dp/B00D4JV9NQ%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00D4JV9NQ");
INSERT INTO `wp_postmeta` VALUES("277", "40", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("280", "42", "imwb_cc_amazon_asin", "B000F97DWO");
INSERT INTO `wp_postmeta` VALUES("281", "42", "_imwb_cc_amazon_asin_updated", "1398171802");
INSERT INTO `wp_postmeta` VALUES("282", "43", "_wp_attached_file", "2014/04/31rLfcABdrL.jpg");
INSERT INTO `wp_postmeta` VALUES("283", "43", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:167;s:4:\"file\";s:23:\"2014/04/31rLfcABdrL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"31rLfcABdrL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"31rLfcABdrL-300x100.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:100;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"31rLfcABdrL-300x100.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:100;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"31rLfcABdrL-300x100.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:100;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"31rLfcABdrL-153x51.jpg\";s:5:\"width\";i:153;s:6:\"height\";i:51;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"31rLfcABdrL-170x56.jpg\";s:5:\"width\";i:170;s:6:\"height\";i:56;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"31rLfcABdrL-50x16.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:16;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("284", "42", "_thumbnail_id", "43");
INSERT INTO `wp_postmeta` VALUES("285", "42", "imwb_zonpress_post_producturl", "http://www.amazon.com/Fiskars-Professional-Bypass-Pruning-Shears/dp/B000F97DWO%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB000F97DWO");
INSERT INTO `wp_postmeta` VALUES("286", "42", "imwb_zonpress_post_price", "16.99");
INSERT INTO `wp_postmeta` VALUES("287", "42", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("288", "42", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("289", "42", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("290", "42", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("291", "42", "imwb_interest_post_link_url", "http://www.amazon.com/Fiskars-Professional-Bypass-Pruning-Shears/dp/B000F97DWO%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB000F97DWO");
INSERT INTO `wp_postmeta` VALUES("292", "42", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("295", "44", "imwb_cc_amazon_asin", "B000QUXOM0");
INSERT INTO `wp_postmeta` VALUES("296", "44", "_imwb_cc_amazon_asin_updated", "1398171803");
INSERT INTO `wp_postmeta` VALUES("297", "45", "_wp_attached_file", "2014/04/21yzuel9G3L.jpg");
INSERT INTO `wp_postmeta` VALUES("298", "45", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:106;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/21yzuel9G3L.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"21yzuel9G3L-106x150.jpg\";s:5:\"width\";i:106;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:22:\"21yzuel9G3L-63x300.jpg\";s:5:\"width\";i:63;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:22:\"21yzuel9G3L-53x250.jpg\";s:5:\"width\";i:53;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:22:\"21yzuel9G3L-53x250.jpg\";s:5:\"width\";i:53;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"21yzuel9G3L-27x128.jpg\";s:5:\"width\";i:27;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"21yzuel9G3L-29x140.jpg\";s:5:\"width\";i:29;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"21yzuel9G3L-10x50.jpg\";s:5:\"width\";i:10;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("299", "44", "_thumbnail_id", "45");
INSERT INTO `wp_postmeta` VALUES("300", "44", "imwb_zonpress_post_producturl", "http://www.amazon.com/Radius-Garden-203-Ergonomic-Stainless/dp/B000QUXOM0%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB000QUXOM0");
INSERT INTO `wp_postmeta` VALUES("301", "44", "imwb_zonpress_post_price", "37.14");
INSERT INTO `wp_postmeta` VALUES("302", "44", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("303", "44", "_imwb_zonpress_post_imp", "2");
INSERT INTO `wp_postmeta` VALUES("304", "44", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("305", "44", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("306", "44", "imwb_interest_post_link_url", "http://www.amazon.com/Radius-Garden-203-Ergonomic-Stainless/dp/B000QUXOM0%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB000QUXOM0");
INSERT INTO `wp_postmeta` VALUES("307", "44", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("310", "46", "imwb_cc_amazon_asin", "B000BX4SLS");
INSERT INTO `wp_postmeta` VALUES("311", "46", "_imwb_cc_amazon_asin_updated", "1398171803");
INSERT INTO `wp_postmeta` VALUES("312", "47", "_wp_attached_file", "2014/04/21kBBt9b7OL.jpg");
INSERT INTO `wp_postmeta` VALUES("313", "47", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:176;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/21kBBt9b7OL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"21kBBt9b7OL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"21kBBt9b7OL-105x300.jpg\";s:5:\"width\";i:105;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:22:\"21kBBt9b7OL-88x250.jpg\";s:5:\"width\";i:88;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:22:\"21kBBt9b7OL-88x250.jpg\";s:5:\"width\";i:88;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"21kBBt9b7OL-45x128.jpg\";s:5:\"width\";i:45;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"21kBBt9b7OL-49x140.jpg\";s:5:\"width\";i:49;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"21kBBt9b7OL-17x50.jpg\";s:5:\"width\";i:17;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("314", "46", "_thumbnail_id", "47");
INSERT INTO `wp_postmeta` VALUES("315", "46", "imwb_zonpress_post_producturl", "http://www.amazon.com/Fiskars-Steel-D-handle-Square-Garden/dp/B000BX4SLS%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB000BX4SLS");
INSERT INTO `wp_postmeta` VALUES("316", "46", "imwb_zonpress_post_price", "22.99");
INSERT INTO `wp_postmeta` VALUES("317", "46", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("318", "46", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("319", "46", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("320", "46", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("321", "46", "imwb_interest_post_link_url", "http://www.amazon.com/Fiskars-Steel-D-handle-Square-Garden/dp/B000BX4SLS%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB000BX4SLS");
INSERT INTO `wp_postmeta` VALUES("322", "46", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("325", "48", "imwb_cc_amazon_asin", "B0058I1H60");
INSERT INTO `wp_postmeta` VALUES("326", "48", "_imwb_cc_amazon_asin_updated", "1398171803");
INSERT INTO `wp_postmeta` VALUES("327", "49", "_wp_attached_file", "2014/04/21S208a1vfL.jpg");
INSERT INTO `wp_postmeta` VALUES("328", "49", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:85;s:6:\"height\";i:400;s:4:\"file\";s:23:\"2014/04/21S208a1vfL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:22:\"21S208a1vfL-85x150.jpg\";s:5:\"width\";i:85;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:22:\"21S208a1vfL-63x300.jpg\";s:5:\"width\";i:63;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:22:\"21S208a1vfL-53x250.jpg\";s:5:\"width\";i:53;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:22:\"21S208a1vfL-53x250.jpg\";s:5:\"width\";i:53;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"21S208a1vfL-27x128.jpg\";s:5:\"width\";i:27;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"21S208a1vfL-29x140.jpg\";s:5:\"width\";i:29;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"21S208a1vfL-10x50.jpg\";s:5:\"width\";i:10;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("329", "48", "_thumbnail_id", "49");
INSERT INTO `wp_postmeta` VALUES("330", "48", "imwb_zonpress_post_producturl", "http://www.amazon.com/True-Temper-1564600-American-Shaped/dp/B0058I1H60%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0058I1H60");
INSERT INTO `wp_postmeta` VALUES("331", "48", "imwb_zonpress_post_price", "13.04");
INSERT INTO `wp_postmeta` VALUES("332", "48", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("333", "48", "_imwb_zonpress_post_imp", "2");
INSERT INTO `wp_postmeta` VALUES("334", "48", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("335", "48", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("336", "48", "imwb_interest_post_link_url", "http://www.amazon.com/True-Temper-1564600-American-Shaped/dp/B0058I1H60%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0058I1H60");
INSERT INTO `wp_postmeta` VALUES("337", "48", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("340", "50", "imwb_cc_amazon_asin", "B000F95D0I");
INSERT INTO `wp_postmeta` VALUES("341", "50", "_imwb_cc_amazon_asin_updated", "1398171804");
INSERT INTO `wp_postmeta` VALUES("342", "51", "_wp_attached_file", "2014/04/210RX3KA7GL.jpg");
INSERT INTO `wp_postmeta` VALUES("343", "51", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:116;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/210RX3KA7GL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"210RX3KA7GL-116x150.jpg\";s:5:\"width\";i:116;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:22:\"210RX3KA7GL-69x300.jpg\";s:5:\"width\";i:69;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:22:\"210RX3KA7GL-58x250.jpg\";s:5:\"width\";i:58;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:22:\"210RX3KA7GL-58x250.jpg\";s:5:\"width\";i:58;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"210RX3KA7GL-29x128.jpg\";s:5:\"width\";i:29;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"210RX3KA7GL-32x140.jpg\";s:5:\"width\";i:32;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"210RX3KA7GL-11x50.jpg\";s:5:\"width\";i:11;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("344", "50", "_thumbnail_id", "51");
INSERT INTO `wp_postmeta` VALUES("345", "50", "imwb_zonpress_post_producturl", "http://www.amazon.com/Fiskars-Steel-D-handle-Transplanting-Spade/dp/B000F95D0I%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB000F95D0I");
INSERT INTO `wp_postmeta` VALUES("346", "50", "imwb_zonpress_post_price", "22.84");
INSERT INTO `wp_postmeta` VALUES("347", "50", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("348", "50", "_imwb_zonpress_post_imp", "25");
INSERT INTO `wp_postmeta` VALUES("349", "50", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("350", "50", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("351", "50", "imwb_interest_post_link_url", "http://www.amazon.com/Fiskars-Steel-D-handle-Transplanting-Spade/dp/B000F95D0I%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB000F95D0I");
INSERT INTO `wp_postmeta` VALUES("352", "50", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("355", "52", "imwb_cc_amazon_asin", "B000BX4SOK");
INSERT INTO `wp_postmeta` VALUES("356", "52", "_imwb_cc_amazon_asin_updated", "1398171804");
INSERT INTO `wp_postmeta` VALUES("357", "53", "_wp_attached_file", "2014/04/21K9N12z-IL.jpg");
INSERT INTO `wp_postmeta` VALUES("358", "53", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:81;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/21K9N12z-IL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:22:\"21K9N12z-IL-81x150.jpg\";s:5:\"width\";i:81;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:22:\"21K9N12z-IL-48x300.jpg\";s:5:\"width\";i:48;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:22:\"21K9N12z-IL-40x250.jpg\";s:5:\"width\";i:40;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:22:\"21K9N12z-IL-40x250.jpg\";s:5:\"width\";i:40;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"21K9N12z-IL-20x128.jpg\";s:5:\"width\";i:20;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"21K9N12z-IL-22x140.jpg\";s:5:\"width\";i:22;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:20:\"21K9N12z-IL-8x50.jpg\";s:5:\"width\";i:8;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("359", "52", "_thumbnail_id", "53");
INSERT INTO `wp_postmeta` VALUES("360", "52", "imwb_zonpress_post_producturl", "http://www.amazon.com/Eagle-1554300-Shovel-47-Inch-Handle/dp/B000BX4SOK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB000BX4SOK");
INSERT INTO `wp_postmeta` VALUES("361", "52", "imwb_zonpress_post_price", "5.98");
INSERT INTO `wp_postmeta` VALUES("362", "52", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("363", "52", "_imwb_zonpress_post_imp", "2");
INSERT INTO `wp_postmeta` VALUES("364", "52", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("365", "52", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("366", "52", "imwb_interest_post_link_url", "http://www.amazon.com/Eagle-1554300-Shovel-47-Inch-Handle/dp/B000BX4SOK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB000BX4SOK");
INSERT INTO `wp_postmeta` VALUES("367", "52", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("370", "54", "imwb_cc_amazon_asin", "B006W287Q4");
INSERT INTO `wp_postmeta` VALUES("371", "54", "_imwb_cc_amazon_asin_updated", "1398171804");
INSERT INTO `wp_postmeta` VALUES("372", "55", "_wp_attached_file", "2014/04/31N8A64jRLL.jpg");
INSERT INTO `wp_postmeta` VALUES("373", "55", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/31N8A64jRLL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"31N8A64jRLL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"31N8A64jRLL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"31N8A64jRLL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"31N8A64jRLL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"31N8A64jRLL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"31N8A64jRLL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"31N8A64jRLL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("374", "54", "_thumbnail_id", "55");
INSERT INTO `wp_postmeta` VALUES("375", "54", "imwb_zonpress_post_producturl", "http://www.amazon.com/Bully-Tools-92601-15-Inch-Garden/dp/B006W287Q4%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB006W287Q4");
INSERT INTO `wp_postmeta` VALUES("376", "54", "imwb_zonpress_post_price", "49.22");
INSERT INTO `wp_postmeta` VALUES("377", "54", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("378", "54", "_imwb_zonpress_post_imp", "3");
INSERT INTO `wp_postmeta` VALUES("379", "54", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("380", "54", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("381", "54", "imwb_interest_post_link_url", "http://www.amazon.com/Bully-Tools-92601-15-Inch-Garden/dp/B006W287Q4%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB006W287Q4");
INSERT INTO `wp_postmeta` VALUES("382", "54", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("385", "56", "imwb_cc_amazon_asin", "B004T34A9G");
INSERT INTO `wp_postmeta` VALUES("386", "56", "_imwb_cc_amazon_asin_updated", "1398171805");
INSERT INTO `wp_postmeta` VALUES("387", "57", "_wp_attached_file", "2014/04/31t2u3LuTLL.jpg");
INSERT INTO `wp_postmeta` VALUES("388", "57", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:334;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/31t2u3LuTLL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"31t2u3LuTLL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"31t2u3LuTLL-200x300.jpg\";s:5:\"width\";i:200;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"31t2u3LuTLL-167x250.jpg\";s:5:\"width\";i:167;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"31t2u3LuTLL-167x250.jpg\";s:5:\"width\";i:167;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"31t2u3LuTLL-85x128.jpg\";s:5:\"width\";i:85;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"31t2u3LuTLL-93x140.jpg\";s:5:\"width\";i:93;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"31t2u3LuTLL-33x50.jpg\";s:5:\"width\";i:33;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("389", "56", "_thumbnail_id", "57");
INSERT INTO `wp_postmeta` VALUES("390", "56", "imwb_zonpress_post_producturl", "http://www.amazon.com/Truper-30293-Spading-D-Handle-30-Inch/dp/B004T34A9G%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB004T34A9G");
INSERT INTO `wp_postmeta` VALUES("391", "56", "imwb_zonpress_post_price", "16.42");
INSERT INTO `wp_postmeta` VALUES("392", "56", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("393", "56", "_imwb_zonpress_post_imp", "2");
INSERT INTO `wp_postmeta` VALUES("394", "56", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("395", "56", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("396", "56", "imwb_interest_post_link_url", "http://www.amazon.com/Truper-30293-Spading-D-Handle-30-Inch/dp/B004T34A9G%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB004T34A9G");
INSERT INTO `wp_postmeta` VALUES("397", "56", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("400", "58", "imwb_cc_amazon_asin", "B001IL0TDS");
INSERT INTO `wp_postmeta` VALUES("401", "58", "_imwb_cc_amazon_asin_updated", "1398171805");
INSERT INTO `wp_postmeta` VALUES("402", "59", "_wp_attached_file", "2014/04/31NsZJtThbL.jpg");
INSERT INTO `wp_postmeta` VALUES("403", "59", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:229;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/31NsZJtThbL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"31NsZJtThbL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"31NsZJtThbL-137x300.jpg\";s:5:\"width\";i:137;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"31NsZJtThbL-114x250.jpg\";s:5:\"width\";i:114;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"31NsZJtThbL-114x250.jpg\";s:5:\"width\";i:114;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"31NsZJtThbL-58x128.jpg\";s:5:\"width\";i:58;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"31NsZJtThbL-64x140.jpg\";s:5:\"width\";i:64;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"31NsZJtThbL-22x50.jpg\";s:5:\"width\";i:22;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("404", "58", "_thumbnail_id", "59");
INSERT INTO `wp_postmeta` VALUES("405", "58", "imwb_zonpress_post_producturl", "http://www.amazon.com/Flexrake-CLA324-Classic-Hand-Fork/dp/B001IL0TDS%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB001IL0TDS");
INSERT INTO `wp_postmeta` VALUES("406", "58", "imwb_zonpress_post_price", "7.25");
INSERT INTO `wp_postmeta` VALUES("407", "58", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("408", "58", "_imwb_zonpress_post_imp", "2");
INSERT INTO `wp_postmeta` VALUES("409", "58", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("410", "58", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("411", "58", "imwb_interest_post_link_url", "http://www.amazon.com/Flexrake-CLA324-Classic-Hand-Fork/dp/B001IL0TDS%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB001IL0TDS");
INSERT INTO `wp_postmeta` VALUES("412", "58", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("415", "60", "imwb_cc_amazon_asin", "B00EQ053G6");
INSERT INTO `wp_postmeta` VALUES("416", "60", "_imwb_cc_amazon_asin_updated", "1398171805");
INSERT INTO `wp_postmeta` VALUES("417", "61", "_wp_attached_file", "2014/04/21Hos-OaWpL.jpg");
INSERT INTO `wp_postmeta` VALUES("418", "61", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:96;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/21Hos-OaWpL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:22:\"21Hos-OaWpL-96x150.jpg\";s:5:\"width\";i:96;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:22:\"21Hos-OaWpL-57x300.jpg\";s:5:\"width\";i:57;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:22:\"21Hos-OaWpL-48x250.jpg\";s:5:\"width\";i:48;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:22:\"21Hos-OaWpL-48x250.jpg\";s:5:\"width\";i:48;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"21Hos-OaWpL-24x128.jpg\";s:5:\"width\";i:24;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"21Hos-OaWpL-26x140.jpg\";s:5:\"width\";i:26;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:20:\"21Hos-OaWpL-9x50.jpg\";s:5:\"width\";i:9;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("419", "60", "_thumbnail_id", "61");
INSERT INTO `wp_postmeta` VALUES("420", "60", "imwb_zonpress_post_producturl", "http://www.amazon.com/Fiskars-Steel-D-Handle-Garden-333400-1001/dp/B00EQ053G6%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00EQ053G6");
INSERT INTO `wp_postmeta` VALUES("421", "60", "imwb_zonpress_post_price", "37.53");
INSERT INTO `wp_postmeta` VALUES("422", "60", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("423", "60", "_imwb_zonpress_post_imp", "3");
INSERT INTO `wp_postmeta` VALUES("424", "60", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("425", "60", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("426", "60", "imwb_interest_post_link_url", "http://www.amazon.com/Fiskars-Steel-D-Handle-Garden-333400-1001/dp/B00EQ053G6%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00EQ053G6");
INSERT INTO `wp_postmeta` VALUES("427", "60", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("430", "62", "imwb_cc_amazon_asin", "B001PTG8AG");
INSERT INTO `wp_postmeta` VALUES("431", "62", "_imwb_cc_amazon_asin_updated", "1398171806");
INSERT INTO `wp_postmeta` VALUES("432", "63", "_wp_attached_file", "2014/04/21tZwrW25jL.jpg");
INSERT INTO `wp_postmeta` VALUES("433", "63", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:160;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/21tZwrW25jL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"21tZwrW25jL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:22:\"21tZwrW25jL-96x300.jpg\";s:5:\"width\";i:96;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:22:\"21tZwrW25jL-80x250.jpg\";s:5:\"width\";i:80;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:22:\"21tZwrW25jL-80x250.jpg\";s:5:\"width\";i:80;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"21tZwrW25jL-40x128.jpg\";s:5:\"width\";i:40;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"21tZwrW25jL-44x140.jpg\";s:5:\"width\";i:44;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"21tZwrW25jL-16x50.jpg\";s:5:\"width\";i:16;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("434", "62", "_thumbnail_id", "63");
INSERT INTO `wp_postmeta` VALUES("435", "62", "imwb_zonpress_post_producturl", "http://www.amazon.com/Brook-Hunter-11020DY-Handcrafted-Stainless/dp/B001PTG8AG%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB001PTG8AG");
INSERT INTO `wp_postmeta` VALUES("436", "62", "imwb_zonpress_post_price", "48.39");
INSERT INTO `wp_postmeta` VALUES("437", "62", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("438", "62", "_imwb_zonpress_post_imp", "3");
INSERT INTO `wp_postmeta` VALUES("439", "62", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("440", "62", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("441", "62", "imwb_interest_post_link_url", "http://www.amazon.com/Brook-Hunter-11020DY-Handcrafted-Stainless/dp/B001PTG8AG%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB001PTG8AG");
INSERT INTO `wp_postmeta` VALUES("442", "62", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("445", "64", "imwb_cc_amazon_asin", "B000RYQ0CG");
INSERT INTO `wp_postmeta` VALUES("446", "64", "_imwb_cc_amazon_asin_updated", "1398171806");
INSERT INTO `wp_postmeta` VALUES("447", "65", "_wp_attached_file", "2014/04/31TqyQkGfjL.jpg");
INSERT INTO `wp_postmeta` VALUES("448", "65", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/31TqyQkGfjL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"31TqyQkGfjL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"31TqyQkGfjL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"31TqyQkGfjL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"31TqyQkGfjL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"31TqyQkGfjL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"31TqyQkGfjL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"31TqyQkGfjL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("449", "64", "_thumbnail_id", "65");
INSERT INTO `wp_postmeta` VALUES("450", "64", "imwb_zonpress_post_producturl", "http://www.amazon.com/Yard-Butler-TNT-4-Garden-Tiller/dp/B000RYQ0CG%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB000RYQ0CG");
INSERT INTO `wp_postmeta` VALUES("451", "64", "imwb_zonpress_post_price", "18.57");
INSERT INTO `wp_postmeta` VALUES("452", "64", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("453", "64", "_imwb_zonpress_post_imp", "2");
INSERT INTO `wp_postmeta` VALUES("454", "64", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("455", "64", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("456", "64", "imwb_interest_post_link_url", "http://www.amazon.com/Yard-Butler-TNT-4-Garden-Tiller/dp/B000RYQ0CG%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB000RYQ0CG");
INSERT INTO `wp_postmeta` VALUES("457", "64", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("460", "66", "imwb_cc_amazon_asin", "B001KVZTSG");
INSERT INTO `wp_postmeta` VALUES("461", "66", "_imwb_cc_amazon_asin_updated", "1398171806");
INSERT INTO `wp_postmeta` VALUES("462", "67", "_wp_attached_file", "2014/04/31nsJs-fLcL.jpg");
INSERT INTO `wp_postmeta` VALUES("463", "67", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:184;s:4:\"file\";s:23:\"2014/04/31nsJs-fLcL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"31nsJs-fLcL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"31nsJs-fLcL-300x110.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:110;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"31nsJs-fLcL-300x110.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:110;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"31nsJs-fLcL-300x110.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:110;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"31nsJs-fLcL-153x56.jpg\";s:5:\"width\";i:153;s:6:\"height\";i:56;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"31nsJs-fLcL-170x62.jpg\";s:5:\"width\";i:170;s:6:\"height\";i:62;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"31nsJs-fLcL-50x18.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:18;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("464", "66", "_thumbnail_id", "67");
INSERT INTO `wp_postmeta` VALUES("465", "66", "imwb_zonpress_post_producturl", "http://www.amazon.com/Fiskars-25-33-Power-Lever-Extendable-Hedge/dp/B001KVZTSG%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB001KVZTSG");
INSERT INTO `wp_postmeta` VALUES("466", "66", "imwb_zonpress_post_price", "20.4");
INSERT INTO `wp_postmeta` VALUES("467", "66", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("468", "66", "_imwb_zonpress_post_imp", "2");
INSERT INTO `wp_postmeta` VALUES("469", "66", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("470", "66", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("471", "66", "imwb_interest_post_link_url", "http://www.amazon.com/Fiskars-25-33-Power-Lever-Extendable-Hedge/dp/B001KVZTSG%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB001KVZTSG");
INSERT INTO `wp_postmeta` VALUES("472", "66", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("475", "68", "imwb_cc_amazon_asin", "B005DTCMOK");
INSERT INTO `wp_postmeta` VALUES("476", "68", "_imwb_cc_amazon_asin_updated", "1398171807");
INSERT INTO `wp_postmeta` VALUES("477", "69", "_wp_attached_file", "2014/04/318g6I6aA3L.jpg");
INSERT INTO `wp_postmeta` VALUES("478", "69", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:151;s:4:\"file\";s:23:\"2014/04/318g6I6aA3L.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"318g6I6aA3L-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:22:\"318g6I6aA3L-300x90.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:90;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:22:\"318g6I6aA3L-300x90.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:90;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:22:\"318g6I6aA3L-300x90.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:90;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"318g6I6aA3L-153x46.jpg\";s:5:\"width\";i:153;s:6:\"height\";i:46;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"318g6I6aA3L-170x51.jpg\";s:5:\"width\";i:170;s:6:\"height\";i:51;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"318g6I6aA3L-50x15.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:15;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("479", "68", "_thumbnail_id", "69");
INSERT INTO `wp_postmeta` VALUES("480", "68", "imwb_zonpress_post_producturl", "http://www.amazon.com/Professional-Lifetime-Warranty-Dirty-Gardener/dp/B005DTCMOK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB005DTCMOK");
INSERT INTO `wp_postmeta` VALUES("481", "68", "imwb_zonpress_post_price", "7.99");
INSERT INTO `wp_postmeta` VALUES("482", "68", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("483", "68", "_imwb_zonpress_post_imp", "3");
INSERT INTO `wp_postmeta` VALUES("484", "68", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("485", "68", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("486", "68", "imwb_interest_post_link_url", "http://www.amazon.com/Professional-Lifetime-Warranty-Dirty-Gardener/dp/B005DTCMOK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB005DTCMOK");
INSERT INTO `wp_postmeta` VALUES("487", "68", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("490", "70", "imwb_cc_amazon_asin", "B00004SD77");
INSERT INTO `wp_postmeta` VALUES("491", "70", "_imwb_cc_amazon_asin_updated", "1398171807");
INSERT INTO `wp_postmeta` VALUES("492", "71", "_wp_attached_file", "2014/04/31he0dfG1uL.jpg");
INSERT INTO `wp_postmeta` VALUES("493", "71", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:232;s:4:\"file\";s:23:\"2014/04/31he0dfG1uL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"31he0dfG1uL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"31he0dfG1uL-300x139.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:139;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"31he0dfG1uL-300x139.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:139;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"31he0dfG1uL-300x139.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:139;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"31he0dfG1uL-153x70.jpg\";s:5:\"width\";i:153;s:6:\"height\";i:70;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"31he0dfG1uL-170x78.jpg\";s:5:\"width\";i:170;s:6:\"height\";i:78;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"31he0dfG1uL-50x23.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:23;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("494", "70", "_thumbnail_id", "71");
INSERT INTO `wp_postmeta` VALUES("495", "70", "imwb_zonpress_post_producturl", "http://www.amazon.com/Fiskars-8-Inch-Garden-Shears/dp/B00004SD77%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00004SD77");
INSERT INTO `wp_postmeta` VALUES("496", "70", "imwb_zonpress_post_price", "8.1");
INSERT INTO `wp_postmeta` VALUES("497", "70", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("498", "70", "_imwb_zonpress_post_imp", "29");
INSERT INTO `wp_postmeta` VALUES("499", "70", "_imwb_zonpress_post_clicks", "1");
INSERT INTO `wp_postmeta` VALUES("500", "70", "_imwb_zonpress_post_ctr", "3.44827586207");
INSERT INTO `wp_postmeta` VALUES("501", "70", "imwb_interest_post_link_url", "http://www.amazon.com/Fiskars-8-Inch-Garden-Shears/dp/B00004SD77%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00004SD77");
INSERT INTO `wp_postmeta` VALUES("502", "70", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("505", "72", "imwb_cc_amazon_asin", "B00004SD76");
INSERT INTO `wp_postmeta` VALUES("506", "72", "_imwb_cc_amazon_asin_updated", "1398171807");
INSERT INTO `wp_postmeta` VALUES("507", "73", "_wp_attached_file", "2014/04/31+aYCThskL.jpg");
INSERT INTO `wp_postmeta` VALUES("508", "73", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:164;s:4:\"file\";s:23:\"2014/04/31+aYCThskL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"31+aYCThskL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:22:\"31+aYCThskL-300x98.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:98;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:22:\"31+aYCThskL-300x98.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:98;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:22:\"31+aYCThskL-300x98.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:98;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"31+aYCThskL-153x50.jpg\";s:5:\"width\";i:153;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"31+aYCThskL-170x55.jpg\";s:5:\"width\";i:170;s:6:\"height\";i:55;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"31+aYCThskL-50x16.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:16;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("509", "72", "_thumbnail_id", "73");
INSERT INTO `wp_postmeta` VALUES("510", "72", "imwb_zonpress_post_producturl", "http://www.amazon.com/Fiskars-9921-Softouch-Micro-Tip-Pruning/dp/B00004SD76%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00004SD76");
INSERT INTO `wp_postmeta` VALUES("511", "72", "imwb_zonpress_post_price", "4");
INSERT INTO `wp_postmeta` VALUES("512", "72", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("513", "72", "_imwb_zonpress_post_imp", "2");
INSERT INTO `wp_postmeta` VALUES("514", "72", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("515", "72", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("516", "72", "imwb_interest_post_link_url", "http://www.amazon.com/Fiskars-9921-Softouch-Micro-Tip-Pruning/dp/B00004SD76%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00004SD76");
INSERT INTO `wp_postmeta` VALUES("517", "72", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("520", "74", "imwb_cc_amazon_asin", "B000NU4YL8");
INSERT INTO `wp_postmeta` VALUES("521", "74", "_imwb_cc_amazon_asin_updated", "1398171807");
INSERT INTO `wp_postmeta` VALUES("522", "75", "_wp_attached_file", "2014/04/31NvTmqXL3L.jpg");
INSERT INTO `wp_postmeta` VALUES("523", "75", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:156;s:4:\"file\";s:23:\"2014/04/31NvTmqXL3L.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"31NvTmqXL3L-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:22:\"31NvTmqXL3L-300x93.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:93;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:22:\"31NvTmqXL3L-300x93.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:93;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:22:\"31NvTmqXL3L-300x93.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:93;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"31NvTmqXL3L-153x47.jpg\";s:5:\"width\";i:153;s:6:\"height\";i:47;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"31NvTmqXL3L-170x53.jpg\";s:5:\"width\";i:170;s:6:\"height\";i:53;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"31NvTmqXL3L-50x15.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:15;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("524", "74", "_thumbnail_id", "75");
INSERT INTO `wp_postmeta` VALUES("525", "74", "imwb_zonpress_post_producturl", "http://www.amazon.com/Fiskars-9110-Traditional-Power-Lever-Pruner/dp/B000NU4YL8%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB000NU4YL8");
INSERT INTO `wp_postmeta` VALUES("526", "74", "imwb_zonpress_post_price", "9.95");
INSERT INTO `wp_postmeta` VALUES("527", "74", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("528", "74", "_imwb_zonpress_post_imp", "2");
INSERT INTO `wp_postmeta` VALUES("529", "74", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("530", "74", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("531", "74", "imwb_interest_post_link_url", "http://www.amazon.com/Fiskars-9110-Traditional-Power-Lever-Pruner/dp/B000NU4YL8%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB000NU4YL8");
INSERT INTO `wp_postmeta` VALUES("532", "74", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("535", "76", "imwb_cc_amazon_asin", "B000GIO0NY");
INSERT INTO `wp_postmeta` VALUES("536", "76", "_imwb_cc_amazon_asin_updated", "1398171807");
INSERT INTO `wp_postmeta` VALUES("537", "77", "_wp_attached_file", "2014/04/31CWXX6jnLL.jpg");
INSERT INTO `wp_postmeta` VALUES("538", "77", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:155;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/31CWXX6jnLL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"31CWXX6jnLL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:22:\"31CWXX6jnLL-93x300.jpg\";s:5:\"width\";i:93;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:22:\"31CWXX6jnLL-77x250.jpg\";s:5:\"width\";i:77;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:22:\"31CWXX6jnLL-77x250.jpg\";s:5:\"width\";i:77;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"31CWXX6jnLL-39x128.jpg\";s:5:\"width\";i:39;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"31CWXX6jnLL-43x140.jpg\";s:5:\"width\";i:43;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"31CWXX6jnLL-15x50.jpg\";s:5:\"width\";i:15;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("539", "76", "_thumbnail_id", "77");
INSERT INTO `wp_postmeta` VALUES("540", "76", "imwb_zonpress_post_producturl", "http://www.amazon.com/Corona-HS-3950-Extendable-Handles/dp/B000GIO0NY%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB000GIO0NY");
INSERT INTO `wp_postmeta` VALUES("541", "76", "imwb_zonpress_post_price", "26.35");
INSERT INTO `wp_postmeta` VALUES("542", "76", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("543", "76", "_imwb_zonpress_post_imp", "2");
INSERT INTO `wp_postmeta` VALUES("544", "76", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("545", "76", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("546", "76", "imwb_interest_post_link_url", "http://www.amazon.com/Corona-HS-3950-Extendable-Handles/dp/B000GIO0NY%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB000GIO0NY");
INSERT INTO `wp_postmeta` VALUES("547", "76", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("550", "78", "imwb_cc_amazon_asin", "B00004SD74");
INSERT INTO `wp_postmeta` VALUES("551", "78", "_imwb_cc_amazon_asin_updated", "1398171808");
INSERT INTO `wp_postmeta` VALUES("552", "79", "_wp_attached_file", "2014/04/41GOoxRKlHL.jpg");
INSERT INTO `wp_postmeta` VALUES("553", "79", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:415;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/41GOoxRKlHL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41GOoxRKlHL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41GOoxRKlHL-249x300.jpg\";s:5:\"width\";i:249;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41GOoxRKlHL-207x250.jpg\";s:5:\"width\";i:207;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41GOoxRKlHL-207x250.jpg\";s:5:\"width\";i:207;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41GOoxRKlHL-106x128.jpg\";s:5:\"width\";i:106;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41GOoxRKlHL-116x140.jpg\";s:5:\"width\";i:116;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41GOoxRKlHL-41x50.jpg\";s:5:\"width\";i:41;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("554", "78", "_thumbnail_id", "79");
INSERT INTO `wp_postmeta` VALUES("555", "78", "imwb_zonpress_post_producturl", "http://www.amazon.com/Fiskars-Inch-PowerGear-Bypass-Lopper/dp/B00004SD74%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00004SD74");
INSERT INTO `wp_postmeta` VALUES("556", "78", "imwb_zonpress_post_price", "31.99");
INSERT INTO `wp_postmeta` VALUES("557", "78", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("558", "78", "_imwb_zonpress_post_imp", "2");
INSERT INTO `wp_postmeta` VALUES("559", "78", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("560", "78", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("561", "78", "imwb_interest_post_link_url", "http://www.amazon.com/Fiskars-Inch-PowerGear-Bypass-Lopper/dp/B00004SD74%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00004SD74");
INSERT INTO `wp_postmeta` VALUES("562", "78", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("565", "80", "imwb_cc_amazon_asin", "1591865484");
INSERT INTO `wp_postmeta` VALUES("566", "80", "_imwb_cc_amazon_asin_updated", "1398171808");
INSERT INTO `wp_postmeta` VALUES("567", "81", "_wp_attached_file", "2014/04/61yie+gt2ZL.jpg");
INSERT INTO `wp_postmeta` VALUES("568", "81", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:350;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/61yie+gt2ZL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"61yie+gt2ZL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"61yie+gt2ZL-210x300.jpg\";s:5:\"width\";i:210;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"61yie+gt2ZL-175x250.jpg\";s:5:\"width\";i:175;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"61yie+gt2ZL-175x250.jpg\";s:5:\"width\";i:175;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"61yie+gt2ZL-89x128.jpg\";s:5:\"width\";i:89;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"61yie+gt2ZL-98x140.jpg\";s:5:\"width\";i:98;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"61yie+gt2ZL-35x50.jpg\";s:5:\"width\";i:35;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("569", "80", "_thumbnail_id", "81");
INSERT INTO `wp_postmeta` VALUES("570", "80", "imwb_zonpress_post_producturl", "http://www.amazon.com/Square-Foot-Gardening-Second-Edition/dp/1591865484%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1591865484");
INSERT INTO `wp_postmeta` VALUES("571", "80", "imwb_zonpress_post_price", "10.04");
INSERT INTO `wp_postmeta` VALUES("572", "80", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("573", "80", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("574", "80", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("575", "80", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("576", "80", "imwb_interest_post_link_url", "http://www.amazon.com/Square-Foot-Gardening-Second-Edition/dp/1591865484%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1591865484");
INSERT INTO `wp_postmeta` VALUES("577", "80", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("580", "82", "imwb_cc_amazon_asin", "160342475X");
INSERT INTO `wp_postmeta` VALUES("581", "82", "_imwb_cc_amazon_asin_updated", "1398171808");
INSERT INTO `wp_postmeta` VALUES("582", "83", "_wp_attached_file", "2014/04/514EATQNkWL.jpg");
INSERT INTO `wp_postmeta` VALUES("583", "83", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:389;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/514EATQNkWL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"514EATQNkWL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"514EATQNkWL-233x300.jpg\";s:5:\"width\";i:233;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"514EATQNkWL-194x250.jpg\";s:5:\"width\";i:194;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"514EATQNkWL-194x250.jpg\";s:5:\"width\";i:194;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"514EATQNkWL-99x128.jpg\";s:5:\"width\";i:99;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"514EATQNkWL-108x140.jpg\";s:5:\"width\";i:108;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"514EATQNkWL-38x50.jpg\";s:5:\"width\";i:38;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("584", "82", "_thumbnail_id", "83");
INSERT INTO `wp_postmeta` VALUES("585", "82", "imwb_zonpress_post_producturl", "http://www.amazon.com/Vegetable-Gardeners-Bible-Edward-Smith/dp/160342475X%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D160342475X");
INSERT INTO `wp_postmeta` VALUES("586", "82", "imwb_zonpress_post_price", "10.34");
INSERT INTO `wp_postmeta` VALUES("587", "82", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("588", "82", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("589", "82", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("590", "82", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("591", "82", "imwb_interest_post_link_url", "http://www.amazon.com/Vegetable-Gardeners-Bible-Edward-Smith/dp/160342475X%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D160342475X");
INSERT INTO `wp_postmeta` VALUES("592", "82", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("595", "84", "imwb_cc_amazon_asin", "1603426949");
INSERT INTO `wp_postmeta` VALUES("596", "84", "_imwb_cc_amazon_asin_updated", "1398171809");
INSERT INTO `wp_postmeta` VALUES("597", "85", "_wp_attached_file", "2014/04/51FlD28bMzL.jpg");
INSERT INTO `wp_postmeta` VALUES("598", "85", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:419;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/51FlD28bMzL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51FlD28bMzL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51FlD28bMzL-251x300.jpg\";s:5:\"width\";i:251;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51FlD28bMzL-209x250.jpg\";s:5:\"width\";i:209;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51FlD28bMzL-209x250.jpg\";s:5:\"width\";i:209;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51FlD28bMzL-107x128.jpg\";s:5:\"width\";i:107;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51FlD28bMzL-117x140.jpg\";s:5:\"width\";i:117;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51FlD28bMzL-41x50.jpg\";s:5:\"width\";i:41;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("599", "84", "_thumbnail_id", "85");
INSERT INTO `wp_postmeta` VALUES("600", "84", "imwb_zonpress_post_producturl", "http://www.amazon.com/Week-Week-Vegetable-Gardeners-Handbook/dp/1603426949%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1603426949");
INSERT INTO `wp_postmeta` VALUES("601", "84", "imwb_zonpress_post_price", "8.67");
INSERT INTO `wp_postmeta` VALUES("602", "84", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("603", "84", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("604", "84", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("605", "84", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("606", "84", "imwb_interest_post_link_url", "http://www.amazon.com/Week-Week-Vegetable-Gardeners-Handbook/dp/1603426949%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1603426949");
INSERT INTO `wp_postmeta` VALUES("607", "84", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("610", "86", "imwb_cc_amazon_asin", "0376039205");
INSERT INTO `wp_postmeta` VALUES("611", "86", "_imwb_cc_amazon_asin_updated", "1398171809");
INSERT INTO `wp_postmeta` VALUES("612", "87", "_wp_attached_file", "2014/04/51W6QM0XUSL.jpg");
INSERT INTO `wp_postmeta` VALUES("613", "87", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:381;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/51W6QM0XUSL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51W6QM0XUSL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51W6QM0XUSL-228x300.jpg\";s:5:\"width\";i:228;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51W6QM0XUSL-190x250.jpg\";s:5:\"width\";i:190;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51W6QM0XUSL-190x250.jpg\";s:5:\"width\";i:190;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"51W6QM0XUSL-97x128.jpg\";s:5:\"width\";i:97;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51W6QM0XUSL-106x140.jpg\";s:5:\"width\";i:106;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51W6QM0XUSL-38x50.jpg\";s:5:\"width\";i:38;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("614", "86", "_thumbnail_id", "87");
INSERT INTO `wp_postmeta` VALUES("615", "86", "imwb_zonpress_post_producturl", "http://www.amazon.com/The-New-Western-Garden-Book/dp/0376039205%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D0376039205");
INSERT INTO `wp_postmeta` VALUES("616", "86", "imwb_zonpress_post_price", "18.06");
INSERT INTO `wp_postmeta` VALUES("617", "86", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("618", "86", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("619", "86", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("620", "86", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("621", "86", "imwb_interest_post_link_url", "http://www.amazon.com/The-New-Western-Garden-Book/dp/0376039205%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D0376039205");
INSERT INTO `wp_postmeta` VALUES("622", "86", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("625", "88", "imwb_cc_amazon_asin", "1580170277");
INSERT INTO `wp_postmeta` VALUES("626", "88", "_imwb_cc_amazon_asin_updated", "1398171809");
INSERT INTO `wp_postmeta` VALUES("627", "89", "_wp_attached_file", "2014/04/51Me-evQWIL.jpg");
INSERT INTO `wp_postmeta` VALUES("628", "89", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:318;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/51Me-evQWIL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51Me-evQWIL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51Me-evQWIL-190x300.jpg\";s:5:\"width\";i:190;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51Me-evQWIL-159x250.jpg\";s:5:\"width\";i:159;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51Me-evQWIL-159x250.jpg\";s:5:\"width\";i:159;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"51Me-evQWIL-81x128.jpg\";s:5:\"width\";i:81;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"51Me-evQWIL-89x140.jpg\";s:5:\"width\";i:89;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51Me-evQWIL-31x50.jpg\";s:5:\"width\";i:31;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("629", "88", "_thumbnail_id", "89");
INSERT INTO `wp_postmeta` VALUES("630", "88", "imwb_zonpress_post_producturl", "http://www.amazon.com/Carrots-Love-Tomatoes-Companion-Successful/dp/1580170277%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1580170277");
INSERT INTO `wp_postmeta` VALUES("631", "88", "imwb_zonpress_post_price", "8.25");
INSERT INTO `wp_postmeta` VALUES("632", "88", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("633", "88", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("634", "88", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("635", "88", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("636", "88", "imwb_interest_post_link_url", "http://www.amazon.com/Carrots-Love-Tomatoes-Companion-Successful/dp/1580170277%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1580170277");
INSERT INTO `wp_postmeta` VALUES("637", "88", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("640", "90", "imwb_cc_amazon_asin", "0761119973");
INSERT INTO `wp_postmeta` VALUES("641", "90", "_imwb_cc_amazon_asin_updated", "1398171810");
INSERT INTO `wp_postmeta` VALUES("642", "91", "_wp_attached_file", "2014/04/51aVvcdzfoL.jpg");
INSERT INTO `wp_postmeta` VALUES("643", "91", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:347;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/51aVvcdzfoL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51aVvcdzfoL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51aVvcdzfoL-208x300.jpg\";s:5:\"width\";i:208;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51aVvcdzfoL-173x250.jpg\";s:5:\"width\";i:173;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51aVvcdzfoL-173x250.jpg\";s:5:\"width\";i:173;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"51aVvcdzfoL-88x128.jpg\";s:5:\"width\";i:88;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"51aVvcdzfoL-97x140.jpg\";s:5:\"width\";i:97;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51aVvcdzfoL-34x50.jpg\";s:5:\"width\";i:34;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("644", "90", "_thumbnail_id", "91");
INSERT INTO `wp_postmeta` VALUES("645", "90", "imwb_zonpress_post_producturl", "http://www.amazon.com/York-Times-Gardening-Questions-Answers/dp/0761119973%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D0761119973");
INSERT INTO `wp_postmeta` VALUES("646", "90", "imwb_zonpress_post_price", "8.94");
INSERT INTO `wp_postmeta` VALUES("647", "90", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("648", "90", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("649", "90", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("650", "90", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("651", "90", "imwb_interest_post_link_url", "http://www.amazon.com/York-Times-Gardening-Questions-Answers/dp/0761119973%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D0761119973");
INSERT INTO `wp_postmeta` VALUES("652", "90", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("655", "92", "imwb_cc_amazon_asin", "0761126325");
INSERT INTO `wp_postmeta` VALUES("656", "92", "_imwb_cc_amazon_asin_updated", "1398171810");
INSERT INTO `wp_postmeta` VALUES("657", "93", "_wp_attached_file", "2014/04/51yzSyQav7L.jpg");
INSERT INTO `wp_postmeta` VALUES("658", "93", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:432;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/51yzSyQav7L.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51yzSyQav7L-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51yzSyQav7L-259x300.jpg\";s:5:\"width\";i:259;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51yzSyQav7L-216x250.jpg\";s:5:\"width\";i:216;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51yzSyQav7L-216x250.jpg\";s:5:\"width\";i:216;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51yzSyQav7L-110x128.jpg\";s:5:\"width\";i:110;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51yzSyQav7L-120x140.jpg\";s:5:\"width\";i:120;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51yzSyQav7L-43x50.jpg\";s:5:\"width\";i:43;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("659", "92", "_thumbnail_id", "93");
INSERT INTO `wp_postmeta` VALUES("660", "92", "imwb_zonpress_post_producturl", "http://www.amazon.com/Trowel-Error-Remedies-Shortcuts-Gardener/dp/0761126325%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D0761126325");
INSERT INTO `wp_postmeta` VALUES("661", "92", "imwb_zonpress_post_price", "5.98");
INSERT INTO `wp_postmeta` VALUES("662", "92", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("663", "92", "_imwb_zonpress_post_imp", "24");
INSERT INTO `wp_postmeta` VALUES("664", "92", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("665", "92", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("666", "92", "imwb_interest_post_link_url", "http://www.amazon.com/Trowel-Error-Remedies-Shortcuts-Gardener/dp/0761126325%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D0761126325");
INSERT INTO `wp_postmeta` VALUES("667", "92", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("670", "94", "imwb_cc_amazon_asin", "0764525557");
INSERT INTO `wp_postmeta` VALUES("671", "94", "_imwb_cc_amazon_asin_updated", "1398171810");
INSERT INTO `wp_postmeta` VALUES("672", "95", "_wp_attached_file", "2014/04/51rWwMCX8WL.jpg");
INSERT INTO `wp_postmeta` VALUES("673", "95", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:386;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/51rWwMCX8WL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51rWwMCX8WL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51rWwMCX8WL-231x300.jpg\";s:5:\"width\";i:231;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51rWwMCX8WL-193x250.jpg\";s:5:\"width\";i:193;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51rWwMCX8WL-193x250.jpg\";s:5:\"width\";i:193;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"51rWwMCX8WL-98x128.jpg\";s:5:\"width\";i:98;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51rWwMCX8WL-108x140.jpg\";s:5:\"width\";i:108;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51rWwMCX8WL-38x50.jpg\";s:5:\"width\";i:38;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("674", "94", "_thumbnail_id", "95");
INSERT INTO `wp_postmeta` VALUES("675", "94", "imwb_zonpress_post_producturl", "http://www.amazon.com/Gardening-All-One-For-Dummies/dp/0764525557%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D0764525557");
INSERT INTO `wp_postmeta` VALUES("676", "94", "imwb_zonpress_post_price", "16.11");
INSERT INTO `wp_postmeta` VALUES("677", "94", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("678", "94", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("679", "94", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("680", "94", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("681", "94", "imwb_interest_post_link_url", "http://www.amazon.com/Gardening-All-One-For-Dummies/dp/0764525557%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D0764525557");
INSERT INTO `wp_postmeta` VALUES("682", "94", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("685", "96", "imwb_cc_amazon_asin", "1605290831");
INSERT INTO `wp_postmeta` VALUES("686", "96", "_imwb_cc_amazon_asin_updated", "1398171810");
INSERT INTO `wp_postmeta` VALUES("687", "97", "_wp_attached_file", "2014/04/51cUoIxj9eL.jpg");
INSERT INTO `wp_postmeta` VALUES("688", "97", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:356;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/51cUoIxj9eL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51cUoIxj9eL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51cUoIxj9eL-213x300.jpg\";s:5:\"width\";i:213;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51cUoIxj9eL-178x250.jpg\";s:5:\"width\";i:178;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51cUoIxj9eL-178x250.jpg\";s:5:\"width\";i:178;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"51cUoIxj9eL-91x128.jpg\";s:5:\"width\";i:91;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"51cUoIxj9eL-99x140.jpg\";s:5:\"width\";i:99;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51cUoIxj9eL-35x50.jpg\";s:5:\"width\";i:35;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("689", "96", "_thumbnail_id", "97");
INSERT INTO `wp_postmeta` VALUES("690", "96", "imwb_zonpress_post_producturl", "http://www.amazon.com/Vertical-Gardening-Vegetables-Flowers-Space/dp/1605290831%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1605290831");
INSERT INTO `wp_postmeta` VALUES("691", "96", "imwb_zonpress_post_price", "10.93");
INSERT INTO `wp_postmeta` VALUES("692", "96", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("693", "96", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("694", "96", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("695", "96", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("696", "96", "imwb_interest_post_link_url", "http://www.amazon.com/Vertical-Gardening-Vegetables-Flowers-Space/dp/1605290831%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1605290831");
INSERT INTO `wp_postmeta` VALUES("697", "96", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("700", "98", "imwb_cc_amazon_asin", "1605296775");
INSERT INTO `wp_postmeta` VALUES("701", "98", "_imwb_cc_amazon_asin_updated", "1398171810");
INSERT INTO `wp_postmeta` VALUES("702", "99", "_wp_attached_file", "2014/04/51RvKHWxQJL.jpg");
INSERT INTO `wp_postmeta` VALUES("703", "99", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:411;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/51RvKHWxQJL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51RvKHWxQJL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51RvKHWxQJL-246x300.jpg\";s:5:\"width\";i:246;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51RvKHWxQJL-205x250.jpg\";s:5:\"width\";i:205;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51RvKHWxQJL-205x250.jpg\";s:5:\"width\";i:205;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51RvKHWxQJL-105x128.jpg\";s:5:\"width\";i:105;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51RvKHWxQJL-115x140.jpg\";s:5:\"width\";i:115;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51RvKHWxQJL-41x50.jpg\";s:5:\"width\";i:41;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("704", "98", "_thumbnail_id", "99");
INSERT INTO `wp_postmeta` VALUES("705", "98", "imwb_zonpress_post_producturl", "http://www.amazon.com/Organic-Gardeners-Handbook-Natural-Disease/dp/1605296775%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1605296775");
INSERT INTO `wp_postmeta` VALUES("706", "98", "imwb_zonpress_post_price", "9.99");
INSERT INTO `wp_postmeta` VALUES("707", "98", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("708", "98", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("709", "98", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("710", "98", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("711", "98", "imwb_interest_post_link_url", "http://www.amazon.com/Organic-Gardeners-Handbook-Natural-Disease/dp/1605296775%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1605296775");
INSERT INTO `wp_postmeta` VALUES("712", "98", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("715", "100", "imwb_cc_amazon_asin", "0981928463");
INSERT INTO `wp_postmeta` VALUES("716", "100", "_imwb_cc_amazon_asin_updated", "1398171810");
INSERT INTO `wp_postmeta` VALUES("717", "101", "_wp_attached_file", "2014/04/51lJlKjb-PL.jpg");
INSERT INTO `wp_postmeta` VALUES("718", "101", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:333;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/51lJlKjb-PL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51lJlKjb-PL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51lJlKjb-PL-199x300.jpg\";s:5:\"width\";i:199;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51lJlKjb-PL-166x250.jpg\";s:5:\"width\";i:166;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51lJlKjb-PL-166x250.jpg\";s:5:\"width\";i:166;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"51lJlKjb-PL-85x128.jpg\";s:5:\"width\";i:85;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"51lJlKjb-PL-93x140.jpg\";s:5:\"width\";i:93;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51lJlKjb-PL-33x50.jpg\";s:5:\"width\";i:33;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("719", "100", "_thumbnail_id", "101");
INSERT INTO `wp_postmeta` VALUES("720", "100", "imwb_zonpress_post_producturl", "http://www.amazon.com/Gardening-Without-Work-Aging-Indolent/dp/0981928463%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D0981928463");
INSERT INTO `wp_postmeta` VALUES("721", "100", "imwb_zonpress_post_price", "16.86");
INSERT INTO `wp_postmeta` VALUES("722", "100", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("723", "100", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("724", "100", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("725", "100", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("726", "100", "imwb_interest_post_link_url", "http://www.amazon.com/Gardening-Without-Work-Aging-Indolent/dp/0981928463%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D0981928463");
INSERT INTO `wp_postmeta` VALUES("727", "100", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("730", "102", "imwb_cc_amazon_asin", "1580115217");
INSERT INTO `wp_postmeta` VALUES("731", "102", "_imwb_cc_amazon_asin_updated", "1398171811");
INSERT INTO `wp_postmeta` VALUES("732", "103", "_wp_attached_file", "2014/04/51kbLdwRREL.jpg");
INSERT INTO `wp_postmeta` VALUES("733", "103", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:392;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/51kbLdwRREL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51kbLdwRREL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51kbLdwRREL-235x300.jpg\";s:5:\"width\";i:235;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51kbLdwRREL-196x250.jpg\";s:5:\"width\";i:196;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51kbLdwRREL-196x250.jpg\";s:5:\"width\";i:196;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51kbLdwRREL-100x128.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51kbLdwRREL-109x140.jpg\";s:5:\"width\";i:109;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51kbLdwRREL-39x50.jpg\";s:5:\"width\";i:39;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("734", "102", "_thumbnail_id", "103");
INSERT INTO `wp_postmeta` VALUES("735", "102", "imwb_zonpress_post_producturl", "http://www.amazon.com/Backyard-Homesteading-Back-Basics-Self-Sufficiency/dp/1580115217%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1580115217");
INSERT INTO `wp_postmeta` VALUES("736", "102", "imwb_zonpress_post_price", "7.8");
INSERT INTO `wp_postmeta` VALUES("737", "102", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("738", "102", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("739", "102", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("740", "102", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("741", "102", "imwb_interest_post_link_url", "http://www.amazon.com/Backyard-Homesteading-Back-Basics-Self-Sufficiency/dp/1580115217%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1580115217");
INSERT INTO `wp_postmeta` VALUES("742", "102", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("745", "104", "imwb_cc_amazon_asin", "1603424768");
INSERT INTO `wp_postmeta` VALUES("746", "104", "_imwb_cc_amazon_asin_updated", "1398171811");
INSERT INTO `wp_postmeta` VALUES("747", "105", "_wp_attached_file", "2014/04/61gwQWqVp-L.jpg");
INSERT INTO `wp_postmeta` VALUES("748", "105", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:391;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/61gwQWqVp-L.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"61gwQWqVp-L-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"61gwQWqVp-L-234x300.jpg\";s:5:\"width\";i:234;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"61gwQWqVp-L-195x250.jpg\";s:5:\"width\";i:195;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"61gwQWqVp-L-195x250.jpg\";s:5:\"width\";i:195;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"61gwQWqVp-L-100x128.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"61gwQWqVp-L-109x140.jpg\";s:5:\"width\";i:109;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"61gwQWqVp-L-39x50.jpg\";s:5:\"width\";i:39;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("749", "104", "_thumbnail_id", "105");
INSERT INTO `wp_postmeta` VALUES("750", "104", "imwb_zonpress_post_producturl", "http://www.amazon.com/The-Vegetable-Gardeners-Bible-2nd/dp/1603424768%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1603424768");
INSERT INTO `wp_postmeta` VALUES("751", "104", "imwb_zonpress_post_price", "22.95");
INSERT INTO `wp_postmeta` VALUES("752", "104", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("753", "104", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("754", "104", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("755", "104", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("756", "104", "imwb_interest_post_link_url", "http://www.amazon.com/The-Vegetable-Gardeners-Bible-2nd/dp/1603424768%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1603424768");
INSERT INTO `wp_postmeta` VALUES("757", "104", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("760", "106", "imwb_cc_amazon_asin", "0376031891");
INSERT INTO `wp_postmeta` VALUES("761", "106", "_imwb_cc_amazon_asin_updated", "1398171811");
INSERT INTO `wp_postmeta` VALUES("762", "107", "_wp_attached_file", "2014/04/61EpKlO0kNL.jpg");
INSERT INTO `wp_postmeta` VALUES("763", "107", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:478;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/61EpKlO0kNL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"61EpKlO0kNL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"61EpKlO0kNL-286x300.jpg\";s:5:\"width\";i:286;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"61EpKlO0kNL-239x250.jpg\";s:5:\"width\";i:239;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"61EpKlO0kNL-239x250.jpg\";s:5:\"width\";i:239;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"61EpKlO0kNL-122x128.jpg\";s:5:\"width\";i:122;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"61EpKlO0kNL-133x140.jpg\";s:5:\"width\";i:133;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"61EpKlO0kNL-47x50.jpg\";s:5:\"width\";i:47;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("764", "106", "_thumbnail_id", "107");
INSERT INTO `wp_postmeta` VALUES("765", "106", "imwb_zonpress_post_producturl", "http://www.amazon.com/Big-Book-Garden-Designs/dp/0376031891%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D0376031891");
INSERT INTO `wp_postmeta` VALUES("766", "106", "imwb_zonpress_post_price", "10.28");
INSERT INTO `wp_postmeta` VALUES("767", "106", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("768", "106", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("769", "106", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("770", "106", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("771", "106", "imwb_interest_post_link_url", "http://www.amazon.com/Big-Book-Garden-Designs/dp/0376031891%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D0376031891");
INSERT INTO `wp_postmeta` VALUES("772", "106", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("775", "108", "imwb_cc_amazon_asin", "1609619838");
INSERT INTO `wp_postmeta` VALUES("776", "108", "_imwb_cc_amazon_asin_updated", "1398171811");
INSERT INTO `wp_postmeta` VALUES("777", "109", "_wp_attached_file", "2014/04/51CeGZ8n7QL.jpg");
INSERT INTO `wp_postmeta` VALUES("778", "109", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:356;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/51CeGZ8n7QL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51CeGZ8n7QL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51CeGZ8n7QL-213x300.jpg\";s:5:\"width\";i:213;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51CeGZ8n7QL-178x250.jpg\";s:5:\"width\";i:178;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51CeGZ8n7QL-178x250.jpg\";s:5:\"width\";i:178;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"51CeGZ8n7QL-91x128.jpg\";s:5:\"width\";i:91;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"51CeGZ8n7QL-99x140.jpg\";s:5:\"width\";i:99;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51CeGZ8n7QL-35x50.jpg\";s:5:\"width\";i:35;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("779", "108", "_thumbnail_id", "109");
INSERT INTO `wp_postmeta` VALUES("780", "108", "imwb_zonpress_post_producturl", "http://www.amazon.com/Rodales-Basic-Organic-Gardening-Beginners/dp/1609619838%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1609619838");
INSERT INTO `wp_postmeta` VALUES("781", "108", "imwb_zonpress_post_price", "10.93");
INSERT INTO `wp_postmeta` VALUES("782", "108", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("783", "108", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("784", "108", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("785", "108", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("786", "108", "imwb_interest_post_link_url", "http://www.amazon.com/Rodales-Basic-Organic-Gardening-Beginners/dp/1609619838%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1609619838");
INSERT INTO `wp_postmeta` VALUES("787", "108", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("790", "110", "imwb_cc_amazon_asin", "1480292206");
INSERT INTO `wp_postmeta` VALUES("791", "110", "_imwb_cc_amazon_asin_updated", "1398171811");
INSERT INTO `wp_postmeta` VALUES("792", "111", "_wp_attached_file", "2014/04/51+NhwT3BpL.jpg");
INSERT INTO `wp_postmeta` VALUES("793", "111", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:333;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/51+NhwT3BpL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51+NhwT3BpL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51+NhwT3BpL-199x300.jpg\";s:5:\"width\";i:199;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51+NhwT3BpL-166x250.jpg\";s:5:\"width\";i:166;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51+NhwT3BpL-166x250.jpg\";s:5:\"width\";i:166;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"51+NhwT3BpL-85x128.jpg\";s:5:\"width\";i:85;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"51+NhwT3BpL-93x140.jpg\";s:5:\"width\";i:93;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51+NhwT3BpL-33x50.jpg\";s:5:\"width\";i:33;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("794", "110", "_thumbnail_id", "111");
INSERT INTO `wp_postmeta` VALUES("795", "110", "imwb_zonpress_post_producturl", "http://www.amazon.com/Organic-Gardening-Beginners-Manual-Take-You-By-The-Hand/dp/1480292206%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1480292206");
INSERT INTO `wp_postmeta` VALUES("796", "110", "imwb_zonpress_post_price", "11.8");
INSERT INTO `wp_postmeta` VALUES("797", "110", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("798", "110", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("799", "110", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("800", "110", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("801", "110", "imwb_interest_post_link_url", "http://www.amazon.com/Organic-Gardening-Beginners-Manual-Take-You-By-The-Hand/dp/1480292206%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1480292206");
INSERT INTO `wp_postmeta` VALUES("802", "110", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("805", "112", "imwb_cc_amazon_asin", "0881928038");
INSERT INTO `wp_postmeta` VALUES("806", "112", "_imwb_cc_amazon_asin_updated", "1398171812");
INSERT INTO `wp_postmeta` VALUES("807", "113", "_wp_attached_file", "2014/04/613qW7UIHpL.jpg");
INSERT INTO `wp_postmeta` VALUES("808", "113", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:358;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/613qW7UIHpL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"613qW7UIHpL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"613qW7UIHpL-214x300.jpg\";s:5:\"width\";i:214;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"613qW7UIHpL-179x250.jpg\";s:5:\"width\";i:179;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"613qW7UIHpL-179x250.jpg\";s:5:\"width\";i:179;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"613qW7UIHpL-91x128.jpg\";s:5:\"width\";i:91;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"613qW7UIHpL-100x140.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"613qW7UIHpL-35x50.jpg\";s:5:\"width\";i:35;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("809", "112", "_thumbnail_id", "113");
INSERT INTO `wp_postmeta` VALUES("810", "112", "imwb_zonpress_post_producturl", "http://www.amazon.com/The-Well-Tended-Perennial-Garden-Techniques/dp/0881928038%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D0881928038");
INSERT INTO `wp_postmeta` VALUES("811", "112", "imwb_zonpress_post_price", "13.29");
INSERT INTO `wp_postmeta` VALUES("812", "112", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("813", "112", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("814", "112", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("815", "112", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("816", "112", "imwb_interest_post_link_url", "http://www.amazon.com/The-Well-Tended-Perennial-Garden-Techniques/dp/0881928038%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D0881928038");
INSERT INTO `wp_postmeta` VALUES("817", "112", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("820", "114", "imwb_cc_amazon_asin", "1611043719");
INSERT INTO `wp_postmeta` VALUES("821", "114", "_imwb_cc_amazon_asin_updated", "1398171812");
INSERT INTO `wp_postmeta` VALUES("822", "115", "_wp_attached_file", "2014/04/51lpkmp+-5L.jpg");
INSERT INTO `wp_postmeta` VALUES("823", "115", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:333;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/51lpkmp+-5L.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51lpkmp+-5L-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51lpkmp+-5L-199x300.jpg\";s:5:\"width\";i:199;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51lpkmp+-5L-166x250.jpg\";s:5:\"width\";i:166;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51lpkmp+-5L-166x250.jpg\";s:5:\"width\";i:166;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"51lpkmp+-5L-85x128.jpg\";s:5:\"width\";i:85;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"51lpkmp+-5L-93x140.jpg\";s:5:\"width\";i:93;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51lpkmp+-5L-33x50.jpg\";s:5:\"width\";i:33;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("824", "114", "_thumbnail_id", "115");
INSERT INTO `wp_postmeta` VALUES("825", "114", "imwb_zonpress_post_producturl", "http://www.amazon.com/Home-Vegetable-Gardening-Vegetables-Illustrated/dp/1611043719%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1611043719");
INSERT INTO `wp_postmeta` VALUES("826", "114", "imwb_zonpress_post_price", "12.6");
INSERT INTO `wp_postmeta` VALUES("827", "114", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("828", "114", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("829", "114", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("830", "114", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("831", "114", "imwb_interest_post_link_url", "http://www.amazon.com/Home-Vegetable-Gardening-Vegetables-Illustrated/dp/1611043719%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1611043719");
INSERT INTO `wp_postmeta` VALUES("832", "114", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("835", "116", "imwb_cc_amazon_asin", "0783548435");
INSERT INTO `wp_postmeta` VALUES("836", "116", "_imwb_cc_amazon_asin_updated", "1398171812");
INSERT INTO `wp_postmeta` VALUES("837", "117", "_wp_attached_file", "2014/04/61T4TSC580L.jpg");
INSERT INTO `wp_postmeta` VALUES("838", "117", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:355;s:6:\"height\";i:475;s:4:\"file\";s:23:\"2014/04/61T4TSC580L.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"61T4TSC580L-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"61T4TSC580L-224x300.jpg\";s:5:\"width\";i:224;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"61T4TSC580L-186x250.jpg\";s:5:\"width\";i:186;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"61T4TSC580L-186x250.jpg\";s:5:\"width\";i:186;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"61T4TSC580L-95x128.jpg\";s:5:\"width\";i:95;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"61T4TSC580L-104x140.jpg\";s:5:\"width\";i:104;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"61T4TSC580L-37x50.jpg\";s:5:\"width\";i:37;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("839", "116", "_thumbnail_id", "117");
INSERT INTO `wp_postmeta` VALUES("840", "116", "imwb_zonpress_post_producturl", "http://www.amazon.com/The-Big-Book-Flower-Gardening/dp/0783548435%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D0783548435");
INSERT INTO `wp_postmeta` VALUES("841", "116", "imwb_zonpress_post_price", "35.13");
INSERT INTO `wp_postmeta` VALUES("842", "116", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("843", "116", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("844", "116", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("845", "116", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("846", "116", "imwb_interest_post_link_url", "http://www.amazon.com/The-Big-Book-Flower-Gardening/dp/0783548435%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D0783548435");
INSERT INTO `wp_postmeta` VALUES("847", "116", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("850", "118", "imwb_cc_amazon_asin", "1564582914");
INSERT INTO `wp_postmeta` VALUES("851", "118", "_imwb_cc_amazon_asin_updated", "1398171812");
INSERT INTO `wp_postmeta` VALUES("852", "119", "_wp_attached_file", "2014/04/71D0WXQV6WL.gif");
INSERT INTO `wp_postmeta` VALUES("853", "119", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:377;s:6:\"height\";i:475;s:4:\"file\";s:23:\"2014/04/71D0WXQV6WL.gif\";s:5:\"sizes\";a:0:{}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("854", "118", "_thumbnail_id", "119");
INSERT INTO `wp_postmeta` VALUES("855", "118", "imwb_zonpress_post_producturl", "http://www.amazon.com/American-Horticultural-Encyclopedia-Gardening-Practical/dp/1564582914%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1564582914");
INSERT INTO `wp_postmeta` VALUES("856", "118", "imwb_zonpress_post_price", "21.98");
INSERT INTO `wp_postmeta` VALUES("857", "118", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("858", "118", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("859", "118", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("860", "118", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("861", "118", "imwb_interest_post_link_url", "http://www.amazon.com/American-Horticultural-Encyclopedia-Gardening-Practical/dp/1564582914%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1564582914");
INSERT INTO `wp_postmeta` VALUES("862", "118", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("865", "120", "imwb_cc_amazon_asin", "1602399840");
INSERT INTO `wp_postmeta` VALUES("866", "120", "_imwb_cc_amazon_asin_updated", "1398171813");
INSERT INTO `wp_postmeta` VALUES("867", "121", "_wp_attached_file", "2014/04/51WEkfzzKFL.jpg");
INSERT INTO `wp_postmeta` VALUES("868", "121", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:384;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/51WEkfzzKFL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51WEkfzzKFL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51WEkfzzKFL-230x300.jpg\";s:5:\"width\";i:230;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51WEkfzzKFL-192x250.jpg\";s:5:\"width\";i:192;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51WEkfzzKFL-192x250.jpg\";s:5:\"width\";i:192;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"51WEkfzzKFL-98x128.jpg\";s:5:\"width\";i:98;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51WEkfzzKFL-107x140.jpg\";s:5:\"width\";i:107;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51WEkfzzKFL-38x50.jpg\";s:5:\"width\";i:38;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("869", "120", "_thumbnail_id", "121");
INSERT INTO `wp_postmeta` VALUES("870", "120", "imwb_zonpress_post_producturl", "http://www.amazon.com/Mini-Farming-Self-Sufficiency-Brett-Markham/dp/1602399840%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1602399840");
INSERT INTO `wp_postmeta` VALUES("871", "120", "imwb_zonpress_post_price", "10.7");
INSERT INTO `wp_postmeta` VALUES("872", "120", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("873", "120", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("874", "120", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("875", "120", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("876", "120", "imwb_interest_post_link_url", "http://www.amazon.com/Mini-Farming-Self-Sufficiency-Brett-Markham/dp/1602399840%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1602399840");
INSERT INTO `wp_postmeta` VALUES("877", "120", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("880", "122", "imwb_cc_amazon_asin", "0882663194");
INSERT INTO `wp_postmeta` VALUES("881", "122", "_imwb_cc_amazon_asin_updated", "1398171813");
INSERT INTO `wp_postmeta` VALUES("882", "123", "_wp_attached_file", "2014/04/51yBE78o0HL.jpg");
INSERT INTO `wp_postmeta` VALUES("883", "123", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:403;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/51yBE78o0HL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51yBE78o0HL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51yBE78o0HL-241x300.jpg\";s:5:\"width\";i:241;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51yBE78o0HL-201x250.jpg\";s:5:\"width\";i:201;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51yBE78o0HL-201x250.jpg\";s:5:\"width\";i:201;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51yBE78o0HL-103x128.jpg\";s:5:\"width\";i:103;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51yBE78o0HL-112x140.jpg\";s:5:\"width\";i:112;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51yBE78o0HL-40x50.jpg\";s:5:\"width\";i:40;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("884", "122", "_thumbnail_id", "123");
INSERT INTO `wp_postmeta` VALUES("885", "122", "imwb_zonpress_post_producturl", "http://www.amazon.com/Garden-Ways-Gardening-Dick-Raymond/dp/0882663194%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D0882663194");
INSERT INTO `wp_postmeta` VALUES("886", "122", "imwb_zonpress_post_price", "12.78");
INSERT INTO `wp_postmeta` VALUES("887", "122", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("888", "122", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("889", "122", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("890", "122", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("891", "122", "imwb_interest_post_link_url", "http://www.amazon.com/Garden-Ways-Gardening-Dick-Raymond/dp/0882663194%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D0882663194");
INSERT INTO `wp_postmeta` VALUES("892", "122", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("895", "124", "imwb_cc_amazon_asin", "0470498706");
INSERT INTO `wp_postmeta` VALUES("896", "124", "_imwb_cc_amazon_asin_updated", "1398171813");
INSERT INTO `wp_postmeta` VALUES("897", "125", "_wp_attached_file", "2014/04/51KIhPvfgrL.jpg");
INSERT INTO `wp_postmeta` VALUES("898", "125", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:394;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/51KIhPvfgrL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51KIhPvfgrL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51KIhPvfgrL-236x300.jpg\";s:5:\"width\";i:236;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51KIhPvfgrL-197x250.jpg\";s:5:\"width\";i:197;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51KIhPvfgrL-197x250.jpg\";s:5:\"width\";i:197;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51KIhPvfgrL-100x128.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51KIhPvfgrL-110x140.jpg\";s:5:\"width\";i:110;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51KIhPvfgrL-39x50.jpg\";s:5:\"width\";i:39;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("899", "124", "_thumbnail_id", "125");
INSERT INTO `wp_postmeta` VALUES("900", "124", "imwb_zonpress_post_producturl", "http://www.amazon.com/Vegetable-Gardening-Dummies-Charlie-Nardozzi/dp/0470498706%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D0470498706");
INSERT INTO `wp_postmeta` VALUES("901", "124", "imwb_zonpress_post_price", "10.75");
INSERT INTO `wp_postmeta` VALUES("902", "124", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("903", "124", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("904", "124", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("905", "124", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("906", "124", "imwb_interest_post_link_url", "http://www.amazon.com/Vegetable-Gardening-Dummies-Charlie-Nardozzi/dp/0470498706%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D0470498706");
INSERT INTO `wp_postmeta` VALUES("907", "124", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("910", "126", "imwb_cc_amazon_asin", "1594869170");
INSERT INTO `wp_postmeta` VALUES("911", "126", "_imwb_cc_amazon_asin_updated", "1398171813");
INSERT INTO `wp_postmeta` VALUES("912", "127", "_wp_attached_file", "2014/04/5140+Kp0JoL.jpg");
INSERT INTO `wp_postmeta` VALUES("913", "127", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:413;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/5140+Kp0JoL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"5140+Kp0JoL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"5140+Kp0JoL-247x300.jpg\";s:5:\"width\";i:247;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"5140+Kp0JoL-206x250.jpg\";s:5:\"width\";i:206;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"5140+Kp0JoL-206x250.jpg\";s:5:\"width\";i:206;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"5140+Kp0JoL-105x128.jpg\";s:5:\"width\";i:105;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"5140+Kp0JoL-115x140.jpg\";s:5:\"width\";i:115;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"5140+Kp0JoL-41x50.jpg\";s:5:\"width\";i:41;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("914", "126", "_thumbnail_id", "127");
INSERT INTO `wp_postmeta` VALUES("915", "126", "imwb_zonpress_post_producturl", "http://www.amazon.com/Rodales-Ultimate-Encyclopedia-Organic-Gardening/dp/1594869170%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1594869170");
INSERT INTO `wp_postmeta` VALUES("916", "126", "imwb_zonpress_post_price", "10.43");
INSERT INTO `wp_postmeta` VALUES("917", "126", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("918", "126", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("919", "126", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("920", "126", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("921", "126", "imwb_interest_post_link_url", "http://www.amazon.com/Rodales-Ultimate-Encyclopedia-Organic-Gardening/dp/1594869170%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1594869170");
INSERT INTO `wp_postmeta` VALUES("922", "126", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("925", "128", "imwb_cc_amazon_asin", "1600850804");
INSERT INTO `wp_postmeta` VALUES("926", "128", "_imwb_cc_amazon_asin_updated", "1398171814");
INSERT INTO `wp_postmeta` VALUES("927", "129", "_wp_attached_file", "2014/04/61w81TnivSL.jpg");
INSERT INTO `wp_postmeta` VALUES("928", "129", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:385;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/61w81TnivSL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"61w81TnivSL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"61w81TnivSL-231x300.jpg\";s:5:\"width\";i:231;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"61w81TnivSL-192x250.jpg\";s:5:\"width\";i:192;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"61w81TnivSL-192x250.jpg\";s:5:\"width\";i:192;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"61w81TnivSL-98x128.jpg\";s:5:\"width\";i:98;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"61w81TnivSL-107x140.jpg\";s:5:\"width\";i:107;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"61w81TnivSL-38x50.jpg\";s:5:\"width\";i:38;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("929", "128", "_thumbnail_id", "129");
INSERT INTO `wp_postmeta` VALUES("930", "128", "imwb_zonpress_post_producturl", "http://www.amazon.com/Container-Gardening-Step-Step-Techniques/dp/1600850804%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1600850804");
INSERT INTO `wp_postmeta` VALUES("931", "128", "imwb_zonpress_post_price", "8");
INSERT INTO `wp_postmeta` VALUES("932", "128", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("933", "128", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("934", "128", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("935", "128", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("936", "128", "imwb_interest_post_link_url", "http://www.amazon.com/Container-Gardening-Step-Step-Techniques/dp/1600850804%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1600850804");
INSERT INTO `wp_postmeta` VALUES("937", "128", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("940", "130", "imwb_cc_amazon_asin", "8862936230");
INSERT INTO `wp_postmeta` VALUES("941", "130", "_imwb_cc_amazon_asin_updated", "1398171814");
INSERT INTO `wp_postmeta` VALUES("942", "131", "_wp_attached_file", "2014/04/41fIJGX80VL.jpg");
INSERT INTO `wp_postmeta` VALUES("943", "131", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/41fIJGX80VL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41fIJGX80VL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41fIJGX80VL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41fIJGX80VL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41fIJGX80VL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41fIJGX80VL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41fIJGX80VL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41fIJGX80VL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("944", "130", "_thumbnail_id", "131");
INSERT INTO `wp_postmeta` VALUES("945", "130", "imwb_zonpress_post_producturl", "http://www.amazon.com/Moleskine-Passion-Journal-Gardening-Series/dp/8862936230%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D8862936230");
INSERT INTO `wp_postmeta` VALUES("946", "130", "imwb_zonpress_post_price", "12.24");
INSERT INTO `wp_postmeta` VALUES("947", "130", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("948", "130", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("949", "130", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("950", "130", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("951", "130", "imwb_interest_post_link_url", "http://www.amazon.com/Moleskine-Passion-Journal-Gardening-Series/dp/8862936230%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D8862936230");
INSERT INTO `wp_postmeta` VALUES("952", "130", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("955", "132", "imwb_cc_amazon_asin", "1604693630");
INSERT INTO `wp_postmeta` VALUES("956", "132", "_imwb_cc_amazon_asin_updated", "1398171814");
INSERT INTO `wp_postmeta` VALUES("957", "133", "_wp_attached_file", "2014/04/51Za1kD3wEL.jpg");
INSERT INTO `wp_postmeta` VALUES("958", "133", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:394;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/51Za1kD3wEL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51Za1kD3wEL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51Za1kD3wEL-236x300.jpg\";s:5:\"width\";i:236;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51Za1kD3wEL-197x250.jpg\";s:5:\"width\";i:197;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51Za1kD3wEL-197x250.jpg\";s:5:\"width\";i:197;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51Za1kD3wEL-100x128.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51Za1kD3wEL-110x140.jpg\";s:5:\"width\";i:110;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51Za1kD3wEL-39x50.jpg\";s:5:\"width\";i:39;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("959", "132", "_thumbnail_id", "133");
INSERT INTO `wp_postmeta` VALUES("960", "132", "imwb_zonpress_post_producturl", "http://www.amazon.com/Beatrix-Potters-Gardening-Life-Childrens/dp/1604693630%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1604693630");
INSERT INTO `wp_postmeta` VALUES("961", "132", "imwb_zonpress_post_price", "15.12");
INSERT INTO `wp_postmeta` VALUES("962", "132", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("963", "132", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("964", "132", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("965", "132", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("966", "132", "imwb_interest_post_link_url", "http://www.amazon.com/Beatrix-Potters-Gardening-Life-Childrens/dp/1604693630%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1604693630");
INSERT INTO `wp_postmeta` VALUES("967", "132", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("970", "134", "imwb_cc_amazon_asin", "0470037490");
INSERT INTO `wp_postmeta` VALUES("971", "134", "_imwb_cc_amazon_asin_updated", "1398171815");
INSERT INTO `wp_postmeta` VALUES("972", "135", "_wp_attached_file", "2014/04/51N3Yt7U98L.jpg");
INSERT INTO `wp_postmeta` VALUES("973", "135", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:399;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/51N3Yt7U98L.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51N3Yt7U98L-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51N3Yt7U98L-239x300.jpg\";s:5:\"width\";i:239;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51N3Yt7U98L-199x250.jpg\";s:5:\"width\";i:199;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51N3Yt7U98L-199x250.jpg\";s:5:\"width\";i:199;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51N3Yt7U98L-102x128.jpg\";s:5:\"width\";i:102;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51N3Yt7U98L-111x140.jpg\";s:5:\"width\";i:111;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51N3Yt7U98L-39x50.jpg\";s:5:\"width\";i:39;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("974", "134", "_thumbnail_id", "135");
INSERT INTO `wp_postmeta` VALUES("975", "134", "imwb_zonpress_post_producturl", "http://www.amazon.com/Gardening-Basics-Dummies-Steven-Frowine/dp/0470037490%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D0470037490");
INSERT INTO `wp_postmeta` VALUES("976", "134", "imwb_zonpress_post_price", "7.92");
INSERT INTO `wp_postmeta` VALUES("977", "134", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("978", "134", "_imwb_zonpress_post_imp", "26");
INSERT INTO `wp_postmeta` VALUES("979", "134", "_imwb_zonpress_post_clicks", "1");
INSERT INTO `wp_postmeta` VALUES("980", "134", "_imwb_zonpress_post_ctr", "3.84615384615");
INSERT INTO `wp_postmeta` VALUES("981", "134", "imwb_interest_post_link_url", "http://www.amazon.com/Gardening-Basics-Dummies-Steven-Frowine/dp/0470037490%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D0470037490");
INSERT INTO `wp_postmeta` VALUES("982", "134", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("985", "136", "imwb_cc_amazon_asin", "1603429751");
INSERT INTO `wp_postmeta` VALUES("986", "136", "_imwb_cc_amazon_asin_updated", "1398171815");
INSERT INTO `wp_postmeta` VALUES("987", "137", "_wp_attached_file", "2014/04/61i6h3SRMaL.jpg");
INSERT INTO `wp_postmeta` VALUES("988", "137", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:390;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/61i6h3SRMaL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"61i6h3SRMaL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"61i6h3SRMaL-234x300.jpg\";s:5:\"width\";i:234;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"61i6h3SRMaL-195x250.jpg\";s:5:\"width\";i:195;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"61i6h3SRMaL-195x250.jpg\";s:5:\"width\";i:195;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"61i6h3SRMaL-99x128.jpg\";s:5:\"width\";i:99;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"61i6h3SRMaL-109x140.jpg\";s:5:\"width\";i:109;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"61i6h3SRMaL-39x50.jpg\";s:5:\"width\";i:39;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("989", "136", "_thumbnail_id", "137");
INSERT INTO `wp_postmeta` VALUES("990", "136", "imwb_zonpress_post_producturl", "http://www.amazon.com/The-Vegetable-Gardeners-Container-Bible/dp/1603429751%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1603429751");
INSERT INTO `wp_postmeta` VALUES("991", "136", "imwb_zonpress_post_price", "8.99");
INSERT INTO `wp_postmeta` VALUES("992", "136", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("993", "136", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("994", "136", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("995", "136", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("996", "136", "imwb_interest_post_link_url", "http://www.amazon.com/The-Vegetable-Gardeners-Container-Bible/dp/1603429751%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1603429751");
INSERT INTO `wp_postmeta` VALUES("997", "136", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1000", "138", "imwb_cc_amazon_asin", "0470638540");
INSERT INTO `wp_postmeta` VALUES("1001", "138", "_imwb_cc_amazon_asin_updated", "1398171815");
INSERT INTO `wp_postmeta` VALUES("1002", "139", "_wp_attached_file", "2014/04/61ysZHt7FIL.jpg");
INSERT INTO `wp_postmeta` VALUES("1003", "139", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:467;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/61ysZHt7FIL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"61ysZHt7FIL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"61ysZHt7FIL-280x300.jpg\";s:5:\"width\";i:280;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"61ysZHt7FIL-233x250.jpg\";s:5:\"width\";i:233;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"61ysZHt7FIL-233x250.jpg\";s:5:\"width\";i:233;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"61ysZHt7FIL-119x128.jpg\";s:5:\"width\";i:119;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"61ysZHt7FIL-130x140.jpg\";s:5:\"width\";i:130;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"61ysZHt7FIL-46x50.jpg\";s:5:\"width\";i:46;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1004", "138", "_thumbnail_id", "139");
INSERT INTO `wp_postmeta` VALUES("1005", "138", "imwb_zonpress_post_producturl", "http://www.amazon.com/Better-Homes-Gardens-Gardening-Simple/dp/0470638540%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D0470638540");
INSERT INTO `wp_postmeta` VALUES("1006", "138", "imwb_zonpress_post_price", "6.03");
INSERT INTO `wp_postmeta` VALUES("1007", "138", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1008", "138", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("1009", "138", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1010", "138", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1011", "138", "imwb_interest_post_link_url", "http://www.amazon.com/Better-Homes-Gardens-Gardening-Simple/dp/0470638540%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D0470638540");
INSERT INTO `wp_postmeta` VALUES("1012", "138", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1015", "140", "imwb_cc_amazon_asin", "0875969623");
INSERT INTO `wp_postmeta` VALUES("1016", "140", "_imwb_cc_amazon_asin_updated", "1398171815");
INSERT INTO `wp_postmeta` VALUES("1017", "141", "_wp_attached_file", "2014/04/61mTJBTww-L.jpg");
INSERT INTO `wp_postmeta` VALUES("1018", "141", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:396;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/61mTJBTww-L.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"61mTJBTww-L-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"61mTJBTww-L-237x300.jpg\";s:5:\"width\";i:237;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"61mTJBTww-L-198x250.jpg\";s:5:\"width\";i:198;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"61mTJBTww-L-198x250.jpg\";s:5:\"width\";i:198;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"61mTJBTww-L-101x128.jpg\";s:5:\"width\";i:101;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"61mTJBTww-L-110x140.jpg\";s:5:\"width\";i:110;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"61mTJBTww-L-39x50.jpg\";s:5:\"width\";i:39;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1019", "140", "_thumbnail_id", "141");
INSERT INTO `wp_postmeta` VALUES("1020", "140", "imwb_zonpress_post_producturl", "http://www.amazon.com/Lasagna-Gardening-Layering-Bountiful-Gardens/dp/0875969623%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D0875969623");
INSERT INTO `wp_postmeta` VALUES("1021", "140", "imwb_zonpress_post_price", "7.99");
INSERT INTO `wp_postmeta` VALUES("1022", "140", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1023", "140", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("1024", "140", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1025", "140", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1026", "140", "imwb_interest_post_link_url", "http://www.amazon.com/Lasagna-Gardening-Layering-Bountiful-Gardens/dp/0875969623%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D0875969623");
INSERT INTO `wp_postmeta` VALUES("1027", "140", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1030", "142", "imwb_cc_amazon_asin", "1570617317");
INSERT INTO `wp_postmeta` VALUES("1031", "142", "_imwb_cc_amazon_asin_updated", "1398171815");
INSERT INTO `wp_postmeta` VALUES("1032", "143", "_wp_attached_file", "2014/04/51YcjpN6V4L.jpg");
INSERT INTO `wp_postmeta` VALUES("1033", "143", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:405;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/51YcjpN6V4L.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51YcjpN6V4L-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51YcjpN6V4L-243x300.jpg\";s:5:\"width\";i:243;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51YcjpN6V4L-202x250.jpg\";s:5:\"width\";i:202;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51YcjpN6V4L-202x250.jpg\";s:5:\"width\";i:202;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51YcjpN6V4L-103x128.jpg\";s:5:\"width\";i:103;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51YcjpN6V4L-113x140.jpg\";s:5:\"width\";i:113;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51YcjpN6V4L-40x50.jpg\";s:5:\"width\";i:40;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1034", "142", "_thumbnail_id", "143");
INSERT INTO `wp_postmeta` VALUES("1035", "142", "imwb_zonpress_post_producturl", "http://www.amazon.com/Grow-Cook-Eat-Vegetable-Harvesting/dp/1570617317%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1570617317");
INSERT INTO `wp_postmeta` VALUES("1036", "142", "imwb_zonpress_post_price", "16.18");
INSERT INTO `wp_postmeta` VALUES("1037", "142", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1038", "142", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("1039", "142", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1040", "142", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1041", "142", "imwb_interest_post_link_url", "http://www.amazon.com/Grow-Cook-Eat-Vegetable-Harvesting/dp/1570617317%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1570617317");
INSERT INTO `wp_postmeta` VALUES("1042", "142", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1045", "144", "imwb_cc_amazon_asin", "160469372X");
INSERT INTO `wp_postmeta` VALUES("1046", "144", "_imwb_cc_amazon_asin_updated", "1398171816");
INSERT INTO `wp_postmeta` VALUES("1047", "145", "_wp_attached_file", "2014/04/61n4rfMMbDL.jpg");
INSERT INTO `wp_postmeta` VALUES("1048", "145", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:464;s:4:\"file\";s:23:\"2014/04/61n4rfMMbDL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"61n4rfMMbDL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"61n4rfMMbDL-300x278.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:278;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"61n4rfMMbDL-269x250.jpg\";s:5:\"width\";i:269;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"61n4rfMMbDL-269x250.jpg\";s:5:\"width\";i:269;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"61n4rfMMbDL-137x128.jpg\";s:5:\"width\";i:137;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"61n4rfMMbDL-150x140.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"61n4rfMMbDL-50x46.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:46;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1049", "144", "_thumbnail_id", "145");
INSERT INTO `wp_postmeta` VALUES("1050", "144", "imwb_zonpress_post_producturl", "http://www.amazon.com/Gardening-Miniature-Create-Living-World/dp/160469372X%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D160469372X");
INSERT INTO `wp_postmeta` VALUES("1051", "144", "imwb_zonpress_post_price", "11.89");
INSERT INTO `wp_postmeta` VALUES("1052", "144", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1053", "144", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("1054", "144", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1055", "144", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1056", "144", "imwb_interest_post_link_url", "http://www.amazon.com/Gardening-Miniature-Create-Living-World/dp/160469372X%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D160469372X");
INSERT INTO `wp_postmeta` VALUES("1057", "144", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1060", "146", "imwb_cc_amazon_asin", "1579548563");
INSERT INTO `wp_postmeta` VALUES("1061", "146", "_imwb_cc_amazon_asin_updated", "1398171816");
INSERT INTO `wp_postmeta` VALUES("1062", "147", "_wp_attached_file", "2014/04/61sBu6bClnL.jpg");
INSERT INTO `wp_postmeta` VALUES("1063", "147", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:313;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/61sBu6bClnL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"61sBu6bClnL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"61sBu6bClnL-187x300.jpg\";s:5:\"width\";i:187;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"61sBu6bClnL-156x250.jpg\";s:5:\"width\";i:156;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"61sBu6bClnL-156x250.jpg\";s:5:\"width\";i:156;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"61sBu6bClnL-80x128.jpg\";s:5:\"width\";i:80;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"61sBu6bClnL-87x140.jpg\";s:5:\"width\";i:87;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"61sBu6bClnL-31x50.jpg\";s:5:\"width\";i:31;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1064", "146", "_thumbnail_id", "147");
INSERT INTO `wp_postmeta` VALUES("1065", "146", "imwb_zonpress_post_producturl", "http://www.amazon.com/Square-Foot-Gardening-Garden-Space/dp/1579548563%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1579548563");
INSERT INTO `wp_postmeta` VALUES("1066", "146", "imwb_zonpress_post_price", "5.95");
INSERT INTO `wp_postmeta` VALUES("1067", "146", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1068", "146", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("1069", "146", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1070", "146", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1071", "146", "imwb_interest_post_link_url", "http://www.amazon.com/Square-Foot-Gardening-Garden-Space/dp/1579548563%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1579548563");
INSERT INTO `wp_postmeta` VALUES("1072", "146", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1075", "148", "imwb_cc_amazon_asin", "1603425292");
INSERT INTO `wp_postmeta` VALUES("1076", "148", "_imwb_cc_amazon_asin_updated", "1398171816");
INSERT INTO `wp_postmeta` VALUES("1077", "149", "_wp_attached_file", "2014/04/617SBt2AJuL.jpg");
INSERT INTO `wp_postmeta` VALUES("1078", "149", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:389;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/617SBt2AJuL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"617SBt2AJuL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"617SBt2AJuL-233x300.jpg\";s:5:\"width\";i:233;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"617SBt2AJuL-194x250.jpg\";s:5:\"width\";i:194;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"617SBt2AJuL-194x250.jpg\";s:5:\"width\";i:194;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"617SBt2AJuL-99x128.jpg\";s:5:\"width\";i:99;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"617SBt2AJuL-108x140.jpg\";s:5:\"width\";i:108;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"617SBt2AJuL-38x50.jpg\";s:5:\"width\";i:38;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1079", "148", "_thumbnail_id", "149");
INSERT INTO `wp_postmeta` VALUES("1080", "148", "imwb_zonpress_post_producturl", "http://www.amazon.com/Starter-Vegetable-Gardens-No-Fail-Organic/dp/1603425292%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1603425292");
INSERT INTO `wp_postmeta` VALUES("1081", "148", "imwb_zonpress_post_price", "7.93");
INSERT INTO `wp_postmeta` VALUES("1082", "148", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1083", "148", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("1084", "148", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1085", "148", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1086", "148", "imwb_interest_post_link_url", "http://www.amazon.com/Starter-Vegetable-Gardens-No-Fail-Organic/dp/1603425292%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1603425292");
INSERT INTO `wp_postmeta` VALUES("1087", "148", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1090", "150", "imwb_cc_amazon_asin", "0696236362");
INSERT INTO `wp_postmeta` VALUES("1091", "150", "_imwb_cc_amazon_asin_updated", "1398171817");
INSERT INTO `wp_postmeta` VALUES("1092", "151", "_wp_attached_file", "2014/04/51V-Tybw8vL.jpg");
INSERT INTO `wp_postmeta` VALUES("1093", "151", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:373;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/51V-Tybw8vL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51V-Tybw8vL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51V-Tybw8vL-223x300.jpg\";s:5:\"width\";i:223;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51V-Tybw8vL-186x250.jpg\";s:5:\"width\";i:186;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51V-Tybw8vL-186x250.jpg\";s:5:\"width\";i:186;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"51V-Tybw8vL-95x128.jpg\";s:5:\"width\";i:95;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51V-Tybw8vL-104x140.jpg\";s:5:\"width\";i:104;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51V-Tybw8vL-37x50.jpg\";s:5:\"width\";i:37;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1094", "150", "_thumbnail_id", "151");
INSERT INTO `wp_postmeta` VALUES("1095", "150", "imwb_zonpress_post_producturl", "http://www.amazon.com/Complete-Guide-Vegetables-Fruits-Herbs/dp/0696236362%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D0696236362");
INSERT INTO `wp_postmeta` VALUES("1096", "150", "imwb_zonpress_post_price", "1.95");
INSERT INTO `wp_postmeta` VALUES("1097", "150", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1098", "150", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("1099", "150", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1100", "150", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1101", "150", "imwb_interest_post_link_url", "http://www.amazon.com/Complete-Guide-Vegetables-Fruits-Herbs/dp/0696236362%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D0696236362");
INSERT INTO `wp_postmeta` VALUES("1102", "150", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1105", "152", "imwb_cc_amazon_asin", "0875968090");
INSERT INTO `wp_postmeta` VALUES("1106", "152", "_imwb_cc_amazon_asin_updated", "1398171817");
INSERT INTO `wp_postmeta` VALUES("1107", "153", "_wp_attached_file", "2014/04/715X2ZFTJXL.gif");
INSERT INTO `wp_postmeta` VALUES("1108", "153", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:367;s:6:\"height\";i:475;s:4:\"file\";s:23:\"2014/04/715X2ZFTJXL.gif\";s:5:\"sizes\";a:0:{}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1109", "152", "_thumbnail_id", "153");
INSERT INTO `wp_postmeta` VALUES("1110", "152", "imwb_zonpress_post_producturl", "http://www.amazon.com/001-Ingenious-Gardening-Ideas-Fabulous/dp/0875968090%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D0875968090");
INSERT INTO `wp_postmeta` VALUES("1111", "152", "imwb_zonpress_post_price", "21.55");
INSERT INTO `wp_postmeta` VALUES("1112", "152", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1113", "152", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("1114", "152", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1115", "152", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1116", "152", "imwb_interest_post_link_url", "http://www.amazon.com/001-Ingenious-Gardening-Ideas-Fabulous/dp/0875968090%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D0875968090");
INSERT INTO `wp_postmeta` VALUES("1117", "152", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1120", "154", "imwb_cc_amazon_asin", "1462110940");
INSERT INTO `wp_postmeta` VALUES("1121", "154", "_imwb_cc_amazon_asin_updated", "1398171817");
INSERT INTO `wp_postmeta` VALUES("1122", "155", "_wp_attached_file", "2014/04/61nziIZVmAL.jpg");
INSERT INTO `wp_postmeta` VALUES("1123", "155", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:431;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/61nziIZVmAL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"61nziIZVmAL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"61nziIZVmAL-258x300.jpg\";s:5:\"width\";i:258;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"61nziIZVmAL-215x250.jpg\";s:5:\"width\";i:215;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"61nziIZVmAL-215x250.jpg\";s:5:\"width\";i:215;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"61nziIZVmAL-110x128.jpg\";s:5:\"width\";i:110;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"61nziIZVmAL-120x140.jpg\";s:5:\"width\";i:120;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"61nziIZVmAL-43x50.jpg\";s:5:\"width\";i:43;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1124", "154", "_thumbnail_id", "155");
INSERT INTO `wp_postmeta` VALUES("1125", "154", "imwb_zonpress_post_producturl", "http://www.amazon.com/Backyard-Winter-Gardening-Vegetables-Electricity/dp/1462110940%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1462110940");
INSERT INTO `wp_postmeta` VALUES("1126", "154", "imwb_zonpress_post_price", "11.69");
INSERT INTO `wp_postmeta` VALUES("1127", "154", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1128", "154", "_imwb_zonpress_post_imp", "2");
INSERT INTO `wp_postmeta` VALUES("1129", "154", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1130", "154", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1131", "154", "imwb_interest_post_link_url", "http://www.amazon.com/Backyard-Winter-Gardening-Vegetables-Electricity/dp/1462110940%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1462110940");
INSERT INTO `wp_postmeta` VALUES("1132", "154", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1135", "156", "imwb_cc_amazon_asin", "1580174620");
INSERT INTO `wp_postmeta` VALUES("1136", "156", "_imwb_cc_amazon_asin_updated", "1398171817");
INSERT INTO `wp_postmeta` VALUES("1137", "157", "_wp_attached_file", "2014/04/51yNKNaF-HL.jpg");
INSERT INTO `wp_postmeta` VALUES("1138", "157", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:390;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/51yNKNaF-HL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51yNKNaF-HL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51yNKNaF-HL-234x300.jpg\";s:5:\"width\";i:234;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51yNKNaF-HL-195x250.jpg\";s:5:\"width\";i:195;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51yNKNaF-HL-195x250.jpg\";s:5:\"width\";i:195;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"51yNKNaF-HL-99x128.jpg\";s:5:\"width\";i:99;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51yNKNaF-HL-109x140.jpg\";s:5:\"width\";i:109;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51yNKNaF-HL-39x50.jpg\";s:5:\"width\";i:39;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1139", "156", "_thumbnail_id", "157");
INSERT INTO `wp_postmeta` VALUES("1140", "156", "imwb_zonpress_post_producturl", "http://www.amazon.com/The-Flower-Gardeners-Bible-Anniversary/dp/1580174620%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1580174620");
INSERT INTO `wp_postmeta` VALUES("1141", "156", "imwb_zonpress_post_price", "5.94");
INSERT INTO `wp_postmeta` VALUES("1142", "156", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1143", "156", "_imwb_zonpress_post_imp", "25");
INSERT INTO `wp_postmeta` VALUES("1144", "156", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1145", "156", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1146", "156", "imwb_interest_post_link_url", "http://www.amazon.com/The-Flower-Gardeners-Bible-Anniversary/dp/1580174620%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1580174620");
INSERT INTO `wp_postmeta` VALUES("1147", "156", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1150", "158", "imwb_cc_amazon_asin", "1591865506");
INSERT INTO `wp_postmeta` VALUES("1151", "158", "_imwb_cc_amazon_asin_updated", "1398171817");
INSERT INTO `wp_postmeta` VALUES("1152", "159", "_wp_attached_file", "2014/04/61dDLfH4gML.jpg");
INSERT INTO `wp_postmeta` VALUES("1153", "159", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:385;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/61dDLfH4gML.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"61dDLfH4gML-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"61dDLfH4gML-231x300.jpg\";s:5:\"width\";i:231;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"61dDLfH4gML-192x250.jpg\";s:5:\"width\";i:192;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"61dDLfH4gML-192x250.jpg\";s:5:\"width\";i:192;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"61dDLfH4gML-98x128.jpg\";s:5:\"width\";i:98;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"61dDLfH4gML-107x140.jpg\";s:5:\"width\";i:107;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"61dDLfH4gML-38x50.jpg\";s:5:\"width\";i:38;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1154", "158", "_thumbnail_id", "159");
INSERT INTO `wp_postmeta` VALUES("1155", "158", "imwb_zonpress_post_producturl", "http://www.amazon.com/Straw-Bale-Gardens-Breakthrough-Vegetables/dp/1591865506%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1591865506");
INSERT INTO `wp_postmeta` VALUES("1156", "158", "imwb_zonpress_post_price", "10.14");
INSERT INTO `wp_postmeta` VALUES("1157", "158", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1158", "158", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("1159", "158", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1160", "158", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1161", "158", "imwb_interest_post_link_url", "http://www.amazon.com/Straw-Bale-Gardens-Breakthrough-Vegetables/dp/1591865506%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D1591865506");
INSERT INTO `wp_postmeta` VALUES("1162", "158", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1163", "1", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("1164", "1", "_wp_trash_meta_time", "1398060761");
INSERT INTO `wp_postmeta` VALUES("1165", "1", "_wp_trash_meta_comments_status", "a:1:{i:1;s:1:\"1\";}");
INSERT INTO `wp_postmeta` VALUES("1168", "160", "imwb_cc_amazon_asin", "B00FJO0IOA");
INSERT INTO `wp_postmeta` VALUES("1169", "160", "_imwb_cc_amazon_asin_updated", "1398171818");
INSERT INTO `wp_postmeta` VALUES("1170", "161", "_wp_attached_file", "2014/04/61toZ79+bHL.jpg");
INSERT INTO `wp_postmeta` VALUES("1171", "161", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:468;s:4:\"file\";s:23:\"2014/04/61toZ79+bHL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"61toZ79+bHL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"61toZ79+bHL-300x280.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:280;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"61toZ79+bHL-267x250.jpg\";s:5:\"width\";i:267;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"61toZ79+bHL-267x250.jpg\";s:5:\"width\";i:267;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"61toZ79+bHL-136x128.jpg\";s:5:\"width\";i:136;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"61toZ79+bHL-149x140.jpg\";s:5:\"width\";i:149;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"61toZ79+bHL-50x46.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:46;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1172", "160", "_thumbnail_id", "161");
INSERT INTO `wp_postmeta` VALUES("1173", "160", "imwb_zonpress_post_producturl", "http://www.amazon.com/Kalanchoe-Species-Mix-Inflorescence-Greenhouse/dp/B00FJO0IOA%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00FJO0IOA");
INSERT INTO `wp_postmeta` VALUES("1174", "160", "imwb_zonpress_post_price", "3");
INSERT INTO `wp_postmeta` VALUES("1175", "160", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1176", "160", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1177", "160", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1178", "160", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1179", "160", "imwb_interest_post_link_url", "http://www.amazon.com/Kalanchoe-Species-Mix-Inflorescence-Greenhouse/dp/B00FJO0IOA%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00FJO0IOA");
INSERT INTO `wp_postmeta` VALUES("1180", "160", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1183", "162", "imwb_cc_amazon_asin", "B00E950WQ4");
INSERT INTO `wp_postmeta` VALUES("1184", "162", "_imwb_cc_amazon_asin_updated", "1398171818");
INSERT INTO `wp_postmeta` VALUES("1185", "163", "_wp_attached_file", "2014/04/51el11zh0tL.jpg");
INSERT INTO `wp_postmeta` VALUES("1186", "163", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/51el11zh0tL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51el11zh0tL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51el11zh0tL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51el11zh0tL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51el11zh0tL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51el11zh0tL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51el11zh0tL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51el11zh0tL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1187", "162", "_thumbnail_id", "163");
INSERT INTO `wp_postmeta` VALUES("1188", "162", "imwb_zonpress_post_producturl", "http://www.amazon.com/Purple-Cherry-Organic-Heirloom-Vegetable/dp/B00E950WQ4%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00E950WQ4");
INSERT INTO `wp_postmeta` VALUES("1189", "162", "imwb_zonpress_post_price", "0.99");
INSERT INTO `wp_postmeta` VALUES("1190", "162", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1191", "162", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1192", "162", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1193", "162", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1194", "162", "imwb_interest_post_link_url", "http://www.amazon.com/Purple-Cherry-Organic-Heirloom-Vegetable/dp/B00E950WQ4%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00E950WQ4");
INSERT INTO `wp_postmeta` VALUES("1195", "162", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1198", "164", "imwb_cc_amazon_asin", "B00HH644JS");
INSERT INTO `wp_postmeta` VALUES("1199", "164", "_imwb_cc_amazon_asin_updated", "1398171818");
INSERT INTO `wp_postmeta` VALUES("1200", "165", "_wp_attached_file", "2014/04/61PKodcw+dL.jpg");
INSERT INTO `wp_postmeta` VALUES("1201", "165", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:433;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/61PKodcw+dL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"61PKodcw+dL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"61PKodcw+dL-259x300.jpg\";s:5:\"width\";i:259;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"61PKodcw+dL-216x250.jpg\";s:5:\"width\";i:216;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"61PKodcw+dL-216x250.jpg\";s:5:\"width\";i:216;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"61PKodcw+dL-110x128.jpg\";s:5:\"width\";i:110;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"61PKodcw+dL-121x140.jpg\";s:5:\"width\";i:121;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"61PKodcw+dL-43x50.jpg\";s:5:\"width\";i:43;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1202", "164", "_thumbnail_id", "165");
INSERT INTO `wp_postmeta` VALUES("1203", "164", "imwb_zonpress_post_producturl", "http://www.amazon.com/100-Strawberry-Seeds-Treasures-Copyright/dp/B00HH644JS%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00HH644JS");
INSERT INTO `wp_postmeta` VALUES("1204", "164", "imwb_zonpress_post_price", "8.29");
INSERT INTO `wp_postmeta` VALUES("1205", "164", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1206", "164", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1207", "164", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1208", "164", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1209", "164", "imwb_interest_post_link_url", "http://www.amazon.com/100-Strawberry-Seeds-Treasures-Copyright/dp/B00HH644JS%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00HH644JS");
INSERT INTO `wp_postmeta` VALUES("1210", "164", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1213", "166", "imwb_cc_amazon_asin", "B004ZGL3QA");
INSERT INTO `wp_postmeta` VALUES("1214", "166", "_imwb_cc_amazon_asin_updated", "1398171818");
INSERT INTO `wp_postmeta` VALUES("1215", "167", "_wp_attached_file", "2014/04/51AEurtYSuL.jpg");
INSERT INTO `wp_postmeta` VALUES("1216", "167", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:400;s:6:\"height\";i:377;s:4:\"file\";s:23:\"2014/04/51AEurtYSuL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51AEurtYSuL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51AEurtYSuL-300x282.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:282;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51AEurtYSuL-265x250.jpg\";s:5:\"width\";i:265;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51AEurtYSuL-265x250.jpg\";s:5:\"width\";i:265;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51AEurtYSuL-135x128.jpg\";s:5:\"width\";i:135;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51AEurtYSuL-148x140.jpg\";s:5:\"width\";i:148;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51AEurtYSuL-50x47.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:47;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1217", "166", "_thumbnail_id", "167");
INSERT INTO `wp_postmeta` VALUES("1218", "166", "imwb_zonpress_post_producturl", "http://www.amazon.com/ENGLISH-LAVENDER-Lavender-Augustifolia-Flower/dp/B004ZGL3QA%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB004ZGL3QA");
INSERT INTO `wp_postmeta` VALUES("1219", "166", "imwb_zonpress_post_price", "0.45");
INSERT INTO `wp_postmeta` VALUES("1220", "166", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1221", "166", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("1222", "166", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1223", "166", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1224", "166", "imwb_interest_post_link_url", "http://www.amazon.com/ENGLISH-LAVENDER-Lavender-Augustifolia-Flower/dp/B004ZGL3QA%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB004ZGL3QA");
INSERT INTO `wp_postmeta` VALUES("1225", "166", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1228", "168", "imwb_cc_amazon_asin", "B00AXYWEFW");
INSERT INTO `wp_postmeta` VALUES("1229", "168", "_imwb_cc_amazon_asin_updated", "1398171819");
INSERT INTO `wp_postmeta` VALUES("1230", "169", "_wp_attached_file", "2014/04/41ilcSRnClL.jpg");
INSERT INTO `wp_postmeta` VALUES("1231", "169", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:400;s:6:\"height\";i:345;s:4:\"file\";s:23:\"2014/04/41ilcSRnClL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41ilcSRnClL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41ilcSRnClL-300x258.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:258;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41ilcSRnClL-289x250.jpg\";s:5:\"width\";i:289;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41ilcSRnClL-289x250.jpg\";s:5:\"width\";i:289;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41ilcSRnClL-148x128.jpg\";s:5:\"width\";i:148;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41ilcSRnClL-162x140.jpg\";s:5:\"width\";i:162;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41ilcSRnClL-50x43.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:43;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1232", "168", "_thumbnail_id", "169");
INSERT INTO `wp_postmeta` VALUES("1233", "168", "imwb_zonpress_post_producturl", "http://www.amazon.com/Highbush-Blueberry-Fruit-Plant-Stratisfied/dp/B00AXYWEFW%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00AXYWEFW");
INSERT INTO `wp_postmeta` VALUES("1234", "168", "imwb_zonpress_post_price", "0.01");
INSERT INTO `wp_postmeta` VALUES("1235", "168", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1236", "168", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("1237", "168", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1238", "168", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1239", "168", "imwb_interest_post_link_url", "http://www.amazon.com/Highbush-Blueberry-Fruit-Plant-Stratisfied/dp/B00AXYWEFW%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00AXYWEFW");
INSERT INTO `wp_postmeta` VALUES("1240", "168", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1243", "170", "imwb_cc_amazon_asin", "B00C8ETNRM");
INSERT INTO `wp_postmeta` VALUES("1244", "170", "_imwb_cc_amazon_asin_updated", "1398171819");
INSERT INTO `wp_postmeta` VALUES("1245", "171", "_wp_attached_file", "2014/04/617jdPANQDL.jpg");
INSERT INTO `wp_postmeta` VALUES("1246", "171", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:460;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/617jdPANQDL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"617jdPANQDL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"617jdPANQDL-276x300.jpg\";s:5:\"width\";i:276;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"617jdPANQDL-230x250.jpg\";s:5:\"width\";i:230;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"617jdPANQDL-230x250.jpg\";s:5:\"width\";i:230;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"617jdPANQDL-117x128.jpg\";s:5:\"width\";i:117;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"617jdPANQDL-128x140.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"617jdPANQDL-46x50.jpg\";s:5:\"width\";i:46;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1247", "170", "_thumbnail_id", "171");
INSERT INTO `wp_postmeta` VALUES("1248", "170", "imwb_zonpress_post_producturl", "http://www.amazon.com/Aubrieta-Bright-Perennial-Flower-Ground/dp/B00C8ETNRM%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00C8ETNRM");
INSERT INTO `wp_postmeta` VALUES("1249", "170", "imwb_zonpress_post_price", "2.5");
INSERT INTO `wp_postmeta` VALUES("1250", "170", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1251", "170", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1252", "170", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1253", "170", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1254", "170", "imwb_interest_post_link_url", "http://www.amazon.com/Aubrieta-Bright-Perennial-Flower-Ground/dp/B00C8ETNRM%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00C8ETNRM");
INSERT INTO `wp_postmeta` VALUES("1255", "170", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1258", "172", "imwb_cc_amazon_asin", "B00HNZ027Q");
INSERT INTO `wp_postmeta` VALUES("1259", "172", "_imwb_cc_amazon_asin_updated", "1398171819");
INSERT INTO `wp_postmeta` VALUES("1260", "173", "_wp_attached_file", "2014/04/51VYhPU64lL.jpg");
INSERT INTO `wp_postmeta` VALUES("1261", "173", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:317;s:6:\"height\";i:343;s:4:\"file\";s:23:\"2014/04/51VYhPU64lL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51VYhPU64lL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51VYhPU64lL-277x300.jpg\";s:5:\"width\";i:277;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51VYhPU64lL-231x250.jpg\";s:5:\"width\";i:231;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51VYhPU64lL-231x250.jpg\";s:5:\"width\";i:231;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51VYhPU64lL-118x128.jpg\";s:5:\"width\";i:118;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51VYhPU64lL-129x140.jpg\";s:5:\"width\";i:129;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51VYhPU64lL-46x50.jpg\";s:5:\"width\";i:46;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1262", "172", "_thumbnail_id", "173");
INSERT INTO `wp_postmeta` VALUES("1263", "172", "imwb_zonpress_post_producturl", "http://www.amazon.com/Strawberry-Variety-Pack-Plant-Seeds/dp/B00HNZ027Q%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00HNZ027Q");
INSERT INTO `wp_postmeta` VALUES("1264", "172", "imwb_zonpress_post_price", "24.99");
INSERT INTO `wp_postmeta` VALUES("1265", "172", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1266", "172", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1267", "172", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1268", "172", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1269", "172", "imwb_interest_post_link_url", "http://www.amazon.com/Strawberry-Variety-Pack-Plant-Seeds/dp/B00HNZ027Q%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00HNZ027Q");
INSERT INTO `wp_postmeta` VALUES("1270", "172", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1273", "174", "imwb_cc_amazon_asin", "B002UOYL2C");
INSERT INTO `wp_postmeta` VALUES("1274", "174", "_imwb_cc_amazon_asin_updated", "1398171819");
INSERT INTO `wp_postmeta` VALUES("1275", "175", "_wp_attached_file", "2014/04/61ETnv1jifL.jpg");
INSERT INTO `wp_postmeta` VALUES("1276", "175", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/61ETnv1jifL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"61ETnv1jifL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"61ETnv1jifL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"61ETnv1jifL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"61ETnv1jifL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"61ETnv1jifL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"61ETnv1jifL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"61ETnv1jifL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1277", "174", "_thumbnail_id", "175");
INSERT INTO `wp_postmeta` VALUES("1278", "174", "imwb_zonpress_post_producturl", "http://www.amazon.com/Rainbow-Solenostemon-scutellarioides-Seed-Needs/dp/B002UOYL2C%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB002UOYL2C");
INSERT INTO `wp_postmeta` VALUES("1279", "174", "imwb_zonpress_post_price", "1.85");
INSERT INTO `wp_postmeta` VALUES("1280", "174", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1281", "174", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1282", "174", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1283", "174", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1284", "174", "imwb_interest_post_link_url", "http://www.amazon.com/Rainbow-Solenostemon-scutellarioides-Seed-Needs/dp/B002UOYL2C%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB002UOYL2C");
INSERT INTO `wp_postmeta` VALUES("1285", "174", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1288", "176", "imwb_cc_amazon_asin", "B00158UK4C");
INSERT INTO `wp_postmeta` VALUES("1289", "176", "_imwb_cc_amazon_asin_updated", "1398171819");
INSERT INTO `wp_postmeta` VALUES("1290", "177", "_wp_attached_file", "2014/04/61vJOVYNuKL.jpg");
INSERT INTO `wp_postmeta` VALUES("1291", "177", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:480;s:6:\"height\";i:457;s:4:\"file\";s:23:\"2014/04/61vJOVYNuKL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"61vJOVYNuKL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"61vJOVYNuKL-300x285.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:285;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"61vJOVYNuKL-262x250.jpg\";s:5:\"width\";i:262;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"61vJOVYNuKL-262x250.jpg\";s:5:\"width\";i:262;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"61vJOVYNuKL-134x128.jpg\";s:5:\"width\";i:134;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"61vJOVYNuKL-147x140.jpg\";s:5:\"width\";i:147;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"61vJOVYNuKL-50x47.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:47;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1292", "176", "_thumbnail_id", "177");
INSERT INTO `wp_postmeta` VALUES("1293", "176", "imwb_zonpress_post_producturl", "http://www.amazon.com/Blue-Japanese-Wisteria-Vine-Seeds/dp/B00158UK4C%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00158UK4C");
INSERT INTO `wp_postmeta` VALUES("1294", "176", "imwb_zonpress_post_price", "0.01");
INSERT INTO `wp_postmeta` VALUES("1295", "176", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1296", "176", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("1297", "176", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1298", "176", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1299", "176", "imwb_interest_post_link_url", "http://www.amazon.com/Blue-Japanese-Wisteria-Vine-Seeds/dp/B00158UK4C%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00158UK4C");
INSERT INTO `wp_postmeta` VALUES("1300", "176", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1303", "178", "imwb_cc_amazon_asin", "B0045122EM");
INSERT INTO `wp_postmeta` VALUES("1304", "178", "_imwb_cc_amazon_asin_updated", "1398171819");
INSERT INTO `wp_postmeta` VALUES("1305", "179", "_wp_attached_file", "2014/04/41K9J4qWPkL.jpg");
INSERT INTO `wp_postmeta` VALUES("1306", "179", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:272;s:6:\"height\";i:185;s:4:\"file\";s:23:\"2014/04/41K9J4qWPkL.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41K9J4qWPkL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41K9J4qWPkL-153x104.jpg\";s:5:\"width\";i:153;s:6:\"height\";i:104;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41K9J4qWPkL-170x115.jpg\";s:5:\"width\";i:170;s:6:\"height\";i:115;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41K9J4qWPkL-50x34.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:34;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1307", "178", "_thumbnail_id", "179");
INSERT INTO `wp_postmeta` VALUES("1308", "178", "imwb_zonpress_post_producturl", "http://www.amazon.com/Todds-Seeds-Organic-Wheatgrass-Pound/dp/B0045122EM%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0045122EM");
INSERT INTO `wp_postmeta` VALUES("1309", "178", "imwb_zonpress_post_price", "6.49");
INSERT INTO `wp_postmeta` VALUES("1310", "178", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1311", "178", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1312", "178", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1313", "178", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1314", "178", "imwb_interest_post_link_url", "http://www.amazon.com/Todds-Seeds-Organic-Wheatgrass-Pound/dp/B0045122EM%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0045122EM");
INSERT INTO `wp_postmeta` VALUES("1315", "178", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1318", "180", "imwb_cc_amazon_asin", "B00E24YZBU");
INSERT INTO `wp_postmeta` VALUES("1319", "180", "_imwb_cc_amazon_asin_updated", "1398171819");
INSERT INTO `wp_postmeta` VALUES("1320", "181", "_wp_attached_file", "2014/04/41jP38HzThL.jpg");
INSERT INTO `wp_postmeta` VALUES("1321", "181", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:285;s:6:\"height\";i:285;s:4:\"file\";s:23:\"2014/04/41jP38HzThL.jpg\";s:5:\"sizes\";a:6:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41jP38HzThL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41jP38HzThL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41jP38HzThL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41jP38HzThL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41jP38HzThL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41jP38HzThL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1322", "180", "_thumbnail_id", "181");
INSERT INTO `wp_postmeta` VALUES("1323", "180", "imwb_zonpress_post_producturl", "http://www.amazon.com/Black-Sweet-Cherry-Fruit-Delicious/dp/B00E24YZBU%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00E24YZBU");
INSERT INTO `wp_postmeta` VALUES("1324", "180", "imwb_zonpress_post_price", "5.29");
INSERT INTO `wp_postmeta` VALUES("1325", "180", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1326", "180", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1327", "180", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1328", "180", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1329", "180", "imwb_interest_post_link_url", "http://www.amazon.com/Black-Sweet-Cherry-Fruit-Delicious/dp/B00E24YZBU%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00E24YZBU");
INSERT INTO `wp_postmeta` VALUES("1330", "180", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1333", "182", "imwb_cc_amazon_asin", "B006HVUJTS");
INSERT INTO `wp_postmeta` VALUES("1334", "182", "_imwb_cc_amazon_asin_updated", "1398171820");
INSERT INTO `wp_postmeta` VALUES("1335", "183", "_wp_attached_file", "2014/04/51xz26Uj0DL.jpg");
INSERT INTO `wp_postmeta` VALUES("1336", "183", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:468;s:4:\"file\";s:23:\"2014/04/51xz26Uj0DL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51xz26Uj0DL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51xz26Uj0DL-300x280.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:280;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51xz26Uj0DL-267x250.jpg\";s:5:\"width\";i:267;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51xz26Uj0DL-267x250.jpg\";s:5:\"width\";i:267;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51xz26Uj0DL-136x128.jpg\";s:5:\"width\";i:136;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51xz26Uj0DL-149x140.jpg\";s:5:\"width\";i:149;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51xz26Uj0DL-50x46.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:46;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1337", "182", "_thumbnail_id", "183");
INSERT INTO `wp_postmeta` VALUES("1338", "182", "imwb_zonpress_post_producturl", "http://www.amazon.com/PYRETHRUM-INSECTS-NATURAL-MOSQUITO-REPELLENT/dp/B006HVUJTS%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB006HVUJTS");
INSERT INTO `wp_postmeta` VALUES("1339", "182", "imwb_zonpress_post_price", "0.9");
INSERT INTO `wp_postmeta` VALUES("1340", "182", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1341", "182", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1342", "182", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1343", "182", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1344", "182", "imwb_interest_post_link_url", "http://www.amazon.com/PYRETHRUM-INSECTS-NATURAL-MOSQUITO-REPELLENT/dp/B006HVUJTS%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB006HVUJTS");
INSERT INTO `wp_postmeta` VALUES("1345", "182", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1348", "184", "imwb_cc_amazon_asin", "B0071J94RS");
INSERT INTO `wp_postmeta` VALUES("1349", "184", "_imwb_cc_amazon_asin_updated", "1398171820");
INSERT INTO `wp_postmeta` VALUES("1350", "185", "_wp_attached_file", "2014/04/61WqxZXh5YL.jpg");
INSERT INTO `wp_postmeta` VALUES("1351", "185", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:471;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/61WqxZXh5YL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"61WqxZXh5YL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"61WqxZXh5YL-282x300.jpg\";s:5:\"width\";i:282;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"61WqxZXh5YL-235x250.jpg\";s:5:\"width\";i:235;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"61WqxZXh5YL-235x250.jpg\";s:5:\"width\";i:235;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"61WqxZXh5YL-120x128.jpg\";s:5:\"width\";i:120;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"61WqxZXh5YL-131x140.jpg\";s:5:\"width\";i:131;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"61WqxZXh5YL-47x50.jpg\";s:5:\"width\";i:47;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1352", "184", "_thumbnail_id", "185");
INSERT INTO `wp_postmeta` VALUES("1353", "184", "imwb_zonpress_post_producturl", "http://www.amazon.com/Ferry-Morse-Large-Vegetable-Garden/dp/B0071J94RS%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0071J94RS");
INSERT INTO `wp_postmeta` VALUES("1354", "184", "imwb_zonpress_post_price", "17.99");
INSERT INTO `wp_postmeta` VALUES("1355", "184", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1356", "184", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1357", "184", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1358", "184", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1359", "184", "imwb_interest_post_link_url", "http://www.amazon.com/Ferry-Morse-Large-Vegetable-Garden/dp/B0071J94RS%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0071J94RS");
INSERT INTO `wp_postmeta` VALUES("1360", "184", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1363", "186", "imwb_cc_amazon_asin", "B004QXUWAU");
INSERT INTO `wp_postmeta` VALUES("1364", "186", "_imwb_cc_amazon_asin_updated", "1398171820");
INSERT INTO `wp_postmeta` VALUES("1365", "187", "_wp_attached_file", "2014/04/61pWzxxsgdL.jpg");
INSERT INTO `wp_postmeta` VALUES("1366", "187", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:456;s:4:\"file\";s:23:\"2014/04/61pWzxxsgdL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"61pWzxxsgdL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"61pWzxxsgdL-300x273.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:273;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"61pWzxxsgdL-274x250.jpg\";s:5:\"width\";i:274;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"61pWzxxsgdL-274x250.jpg\";s:5:\"width\";i:274;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"61pWzxxsgdL-140x128.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"61pWzxxsgdL-153x140.jpg\";s:5:\"width\";i:153;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"61pWzxxsgdL-50x45.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:45;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1367", "186", "_thumbnail_id", "187");
INSERT INTO `wp_postmeta` VALUES("1368", "186", "imwb_zonpress_post_producturl", "http://www.amazon.com/12-Heirloom-Varieties-Vegetable-Seeds/dp/B004QXUWAU%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB004QXUWAU");
INSERT INTO `wp_postmeta` VALUES("1369", "186", "imwb_zonpress_post_price", "12.95");
INSERT INTO `wp_postmeta` VALUES("1370", "186", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1371", "186", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1372", "186", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1373", "186", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1374", "186", "imwb_interest_post_link_url", "http://www.amazon.com/12-Heirloom-Varieties-Vegetable-Seeds/dp/B004QXUWAU%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB004QXUWAU");
INSERT INTO `wp_postmeta` VALUES("1375", "186", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1378", "188", "imwb_cc_amazon_asin", "B00BZLP0NK");
INSERT INTO `wp_postmeta` VALUES("1379", "188", "_imwb_cc_amazon_asin_updated", "1398171820");
INSERT INTO `wp_postmeta` VALUES("1380", "189", "_wp_attached_file", "2014/04/51ux3HGLgZL.jpg");
INSERT INTO `wp_postmeta` VALUES("1381", "189", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/51ux3HGLgZL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51ux3HGLgZL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51ux3HGLgZL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51ux3HGLgZL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51ux3HGLgZL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51ux3HGLgZL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51ux3HGLgZL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51ux3HGLgZL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1382", "188", "_thumbnail_id", "189");
INSERT INTO `wp_postmeta` VALUES("1383", "188", "imwb_zonpress_post_producturl", "http://www.amazon.com/Garden-SATISFACTION-ALL-NATURAL-Germination-Enthusiasts/dp/B00BZLP0NK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00BZLP0NK");
INSERT INTO `wp_postmeta` VALUES("1384", "188", "imwb_zonpress_post_price", "37.95");
INSERT INTO `wp_postmeta` VALUES("1385", "188", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1386", "188", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("1387", "188", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1388", "188", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1389", "188", "imwb_interest_post_link_url", "http://www.amazon.com/Garden-SATISFACTION-ALL-NATURAL-Germination-Enthusiasts/dp/B00BZLP0NK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00BZLP0NK");
INSERT INTO `wp_postmeta` VALUES("1390", "188", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1393", "190", "imwb_cc_amazon_asin", "B00GFE9FIS");
INSERT INTO `wp_postmeta` VALUES("1394", "190", "_imwb_cc_amazon_asin_updated", "1398171820");
INSERT INTO `wp_postmeta` VALUES("1395", "191", "_wp_attached_file", "2014/04/61D4m8dpBBL.jpg");
INSERT INTO `wp_postmeta` VALUES("1396", "191", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/61D4m8dpBBL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"61D4m8dpBBL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"61D4m8dpBBL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"61D4m8dpBBL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"61D4m8dpBBL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"61D4m8dpBBL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"61D4m8dpBBL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"61D4m8dpBBL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1397", "190", "_thumbnail_id", "191");
INSERT INTO `wp_postmeta` VALUES("1398", "190", "imwb_zonpress_post_producturl", "http://www.amazon.com/Heirloom-Vegetable-Survival-Tomatoes-Cauliflower/dp/B00GFE9FIS%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00GFE9FIS");
INSERT INTO `wp_postmeta` VALUES("1399", "190", "imwb_zonpress_post_price", "22.98");
INSERT INTO `wp_postmeta` VALUES("1400", "190", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1401", "190", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1402", "190", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1403", "190", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1404", "190", "imwb_interest_post_link_url", "http://www.amazon.com/Heirloom-Vegetable-Survival-Tomatoes-Cauliflower/dp/B00GFE9FIS%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00GFE9FIS");
INSERT INTO `wp_postmeta` VALUES("1405", "190", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1408", "192", "imwb_cc_amazon_asin", "B000UW5QP2");
INSERT INTO `wp_postmeta` VALUES("1409", "192", "_imwb_cc_amazon_asin_updated", "1398171820");
INSERT INTO `wp_postmeta` VALUES("1410", "193", "_wp_attached_file", "2014/04/41FMVnkCHNL.jpg");
INSERT INTO `wp_postmeta` VALUES("1411", "193", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:248;s:6:\"height\";i:248;s:4:\"file\";s:23:\"2014/04/41FMVnkCHNL.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41FMVnkCHNL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41FMVnkCHNL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41FMVnkCHNL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41FMVnkCHNL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1412", "192", "_thumbnail_id", "193");
INSERT INTO `wp_postmeta` VALUES("1413", "192", "imwb_zonpress_post_producturl", "http://www.amazon.com/Purple-Dragon-Carrot-350-Seeds/dp/B000UW5QP2%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB000UW5QP2");
INSERT INTO `wp_postmeta` VALUES("1414", "192", "imwb_zonpress_post_price", "0.1");
INSERT INTO `wp_postmeta` VALUES("1415", "192", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1416", "192", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("1417", "192", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1418", "192", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1419", "192", "imwb_interest_post_link_url", "http://www.amazon.com/Purple-Dragon-Carrot-350-Seeds/dp/B000UW5QP2%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB000UW5QP2");
INSERT INTO `wp_postmeta` VALUES("1420", "192", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1423", "194", "imwb_cc_amazon_asin", "B000UW0ZT4");
INSERT INTO `wp_postmeta` VALUES("1424", "194", "_imwb_cc_amazon_asin_updated", "1398171820");
INSERT INTO `wp_postmeta` VALUES("1425", "195", "_wp_attached_file", "2014/04/51MF8nMzKNL.jpg");
INSERT INTO `wp_postmeta` VALUES("1426", "195", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:354;s:6:\"height\";i:350;s:4:\"file\";s:23:\"2014/04/51MF8nMzKNL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51MF8nMzKNL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51MF8nMzKNL-300x296.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:296;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51MF8nMzKNL-252x250.jpg\";s:5:\"width\";i:252;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51MF8nMzKNL-252x250.jpg\";s:5:\"width\";i:252;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51MF8nMzKNL-129x128.jpg\";s:5:\"width\";i:129;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51MF8nMzKNL-141x140.jpg\";s:5:\"width\";i:141;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51MF8nMzKNL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1427", "194", "_thumbnail_id", "195");
INSERT INTO `wp_postmeta` VALUES("1428", "194", "imwb_zonpress_post_producturl", "http://www.amazon.com/Purple-Cauliflower-Seeds-LOW-Veggie/dp/B000UW0ZT4%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB000UW0ZT4");
INSERT INTO `wp_postmeta` VALUES("1429", "194", "imwb_zonpress_post_price", "0.79");
INSERT INTO `wp_postmeta` VALUES("1430", "194", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1431", "194", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1432", "194", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1433", "194", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1434", "194", "imwb_interest_post_link_url", "http://www.amazon.com/Purple-Cauliflower-Seeds-LOW-Veggie/dp/B000UW0ZT4%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB000UW0ZT4");
INSERT INTO `wp_postmeta` VALUES("1435", "194", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1438", "196", "imwb_cc_amazon_asin", "B004ZR0NBU");
INSERT INTO `wp_postmeta` VALUES("1439", "196", "_imwb_cc_amazon_asin_updated", "1398171821");
INSERT INTO `wp_postmeta` VALUES("1440", "197", "_wp_attached_file", "2014/04/41eluleGgdL.jpg");
INSERT INTO `wp_postmeta` VALUES("1441", "197", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:230;s:6:\"height\";i:250;s:4:\"file\";s:23:\"2014/04/41eluleGgdL.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41eluleGgdL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41eluleGgdL-117x128.jpg\";s:5:\"width\";i:117;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41eluleGgdL-128x140.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41eluleGgdL-46x50.jpg\";s:5:\"width\";i:46;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1442", "196", "_thumbnail_id", "197");
INSERT INTO `wp_postmeta` VALUES("1443", "196", "imwb_zonpress_post_producturl", "http://www.amazon.com/SUGAR-WATERMELON-Citrullus-lanatus-Fruit/dp/B004ZR0NBU%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB004ZR0NBU");
INSERT INTO `wp_postmeta` VALUES("1444", "196", "imwb_zonpress_post_price", "0.3");
INSERT INTO `wp_postmeta` VALUES("1445", "196", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1446", "196", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("1447", "196", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1448", "196", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1449", "196", "imwb_interest_post_link_url", "http://www.amazon.com/SUGAR-WATERMELON-Citrullus-lanatus-Fruit/dp/B004ZR0NBU%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB004ZR0NBU");
INSERT INTO `wp_postmeta` VALUES("1450", "196", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1453", "198", "imwb_cc_amazon_asin", "B0051GRNSK");
INSERT INTO `wp_postmeta` VALUES("1454", "198", "_imwb_cc_amazon_asin_updated", "1398171821");
INSERT INTO `wp_postmeta` VALUES("1455", "199", "_wp_attached_file", "2014/04/41IHP324mAL.jpg");
INSERT INTO `wp_postmeta` VALUES("1456", "199", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:225;s:6:\"height\";i:225;s:4:\"file\";s:23:\"2014/04/41IHP324mAL.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41IHP324mAL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41IHP324mAL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41IHP324mAL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41IHP324mAL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1457", "198", "_thumbnail_id", "199");
INSERT INTO `wp_postmeta` VALUES("1458", "198", "imwb_zonpress_post_producturl", "http://www.amazon.com/Hinterland-Trading-HTVEG0048-Brussels-Sprouts/dp/B0051GRNSK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0051GRNSK");
INSERT INTO `wp_postmeta` VALUES("1459", "198", "imwb_zonpress_post_price", "0.75");
INSERT INTO `wp_postmeta` VALUES("1460", "198", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1461", "198", "_imwb_zonpress_post_imp", "24");
INSERT INTO `wp_postmeta` VALUES("1462", "198", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1463", "198", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1464", "198", "imwb_interest_post_link_url", "http://www.amazon.com/Hinterland-Trading-HTVEG0048-Brussels-Sprouts/dp/B0051GRNSK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0051GRNSK");
INSERT INTO `wp_postmeta` VALUES("1465", "198", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1468", "200", "imwb_cc_amazon_asin", "B006W1I7QK");
INSERT INTO `wp_postmeta` VALUES("1469", "200", "_imwb_cc_amazon_asin_updated", "1398171821");
INSERT INTO `wp_postmeta` VALUES("1470", "201", "_wp_attached_file", "2014/04/519cZIukQpL.jpg");
INSERT INTO `wp_postmeta` VALUES("1471", "201", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:300;s:6:\"height\";i:300;s:4:\"file\";s:23:\"2014/04/519cZIukQpL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"519cZIukQpL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"519cZIukQpL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"519cZIukQpL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"519cZIukQpL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"519cZIukQpL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"519cZIukQpL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"519cZIukQpL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1472", "200", "_thumbnail_id", "201");
INSERT INTO `wp_postmeta` VALUES("1473", "200", "imwb_zonpress_post_producturl", "http://www.amazon.com/Shipping-Cucumber-Spacemaster-Seeds-vegetable/dp/B006W1I7QK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB006W1I7QK");
INSERT INTO `wp_postmeta` VALUES("1474", "200", "imwb_zonpress_post_price", "4.79");
INSERT INTO `wp_postmeta` VALUES("1475", "200", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1476", "200", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("1477", "200", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1478", "200", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1479", "200", "imwb_interest_post_link_url", "http://www.amazon.com/Shipping-Cucumber-Spacemaster-Seeds-vegetable/dp/B006W1I7QK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB006W1I7QK");
INSERT INTO `wp_postmeta` VALUES("1480", "200", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1483", "202", "imwb_cc_amazon_asin", "B0071J95BI");
INSERT INTO `wp_postmeta` VALUES("1484", "202", "_imwb_cc_amazon_asin_updated", "1398171821");
INSERT INTO `wp_postmeta` VALUES("1485", "203", "_wp_attached_file", "2014/04/51IliuU9mHL.jpg");
INSERT INTO `wp_postmeta` VALUES("1486", "203", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:390;s:4:\"file\";s:23:\"2014/04/51IliuU9mHL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51IliuU9mHL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51IliuU9mHL-300x234.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:234;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51IliuU9mHL-300x234.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:234;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51IliuU9mHL-300x234.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:234;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51IliuU9mHL-153x119.jpg\";s:5:\"width\";i:153;s:6:\"height\";i:119;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51IliuU9mHL-170x132.jpg\";s:5:\"width\";i:170;s:6:\"height\";i:132;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51IliuU9mHL-50x39.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:39;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1487", "202", "_thumbnail_id", "203");
INSERT INTO `wp_postmeta` VALUES("1488", "202", "imwb_zonpress_post_producturl", "http://www.amazon.com/Ferry-Morse-Organic-Vegetable-Garden/dp/B0071J95BI%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0071J95BI");
INSERT INTO `wp_postmeta` VALUES("1489", "202", "imwb_zonpress_post_price", "18.99");
INSERT INTO `wp_postmeta` VALUES("1490", "202", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1491", "202", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("1492", "202", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1493", "202", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1494", "202", "imwb_interest_post_link_url", "http://www.amazon.com/Ferry-Morse-Organic-Vegetable-Garden/dp/B0071J95BI%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0071J95BI");
INSERT INTO `wp_postmeta` VALUES("1495", "202", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1498", "204", "imwb_cc_amazon_asin", "B001LR46SI");
INSERT INTO `wp_postmeta` VALUES("1499", "204", "_imwb_cc_amazon_asin_updated", "1398171822");
INSERT INTO `wp_postmeta` VALUES("1500", "205", "_wp_attached_file", "2014/04/410ipa9XiLL.jpg");
INSERT INTO `wp_postmeta` VALUES("1501", "205", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:250;s:6:\"height\";i:250;s:4:\"file\";s:23:\"2014/04/410ipa9XiLL.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"410ipa9XiLL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"410ipa9XiLL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"410ipa9XiLL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"410ipa9XiLL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1502", "204", "_thumbnail_id", "205");
INSERT INTO `wp_postmeta` VALUES("1503", "204", "imwb_zonpress_post_producturl", "http://www.amazon.com/Organic-Rainbow-Pepper-Seeds-240mg/dp/B001LR46SI%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB001LR46SI");
INSERT INTO `wp_postmeta` VALUES("1504", "204", "imwb_zonpress_post_price", "0.01");
INSERT INTO `wp_postmeta` VALUES("1505", "204", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1506", "204", "_imwb_zonpress_post_imp", "2");
INSERT INTO `wp_postmeta` VALUES("1507", "204", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1508", "204", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1509", "204", "imwb_interest_post_link_url", "http://www.amazon.com/Organic-Rainbow-Pepper-Seeds-240mg/dp/B001LR46SI%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB001LR46SI");
INSERT INTO `wp_postmeta` VALUES("1510", "204", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1513", "206", "imwb_cc_amazon_asin", "B00AWKZIXM");
INSERT INTO `wp_postmeta` VALUES("1514", "206", "_imwb_cc_amazon_asin_updated", "1398171822");
INSERT INTO `wp_postmeta` VALUES("1515", "207", "_wp_attached_file", "2014/04/51vNJCg4NOL.jpg");
INSERT INTO `wp_postmeta` VALUES("1516", "207", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:432;s:6:\"height\";i:334;s:4:\"file\";s:23:\"2014/04/51vNJCg4NOL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51vNJCg4NOL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51vNJCg4NOL-300x231.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:231;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51vNJCg4NOL-300x231.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:231;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51vNJCg4NOL-300x231.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:231;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51vNJCg4NOL-153x118.jpg\";s:5:\"width\";i:153;s:6:\"height\";i:118;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51vNJCg4NOL-170x131.jpg\";s:5:\"width\";i:170;s:6:\"height\";i:131;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51vNJCg4NOL-50x38.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:38;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1517", "206", "_thumbnail_id", "207");
INSERT INTO `wp_postmeta` VALUES("1518", "206", "imwb_zonpress_post_producturl", "http://www.amazon.com/Buttercrunch-Heirloom-Lettuce-Seeds-Seeds/dp/B00AWKZIXM%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00AWKZIXM");
INSERT INTO `wp_postmeta` VALUES("1519", "206", "imwb_zonpress_post_price", "0.16");
INSERT INTO `wp_postmeta` VALUES("1520", "206", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1521", "206", "_imwb_zonpress_post_imp", "4");
INSERT INTO `wp_postmeta` VALUES("1522", "206", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1523", "206", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1524", "206", "imwb_interest_post_link_url", "http://www.amazon.com/Buttercrunch-Heirloom-Lettuce-Seeds-Seeds/dp/B00AWKZIXM%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00AWKZIXM");
INSERT INTO `wp_postmeta` VALUES("1525", "206", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1528", "208", "imwb_cc_amazon_asin", "B002JOX6FG");
INSERT INTO `wp_postmeta` VALUES("1529", "208", "_imwb_cc_amazon_asin_updated", "1398171822");
INSERT INTO `wp_postmeta` VALUES("1530", "209", "_wp_attached_file", "2014/04/31woLvKajCL.jpg");
INSERT INTO `wp_postmeta` VALUES("1531", "209", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:150;s:6:\"height\";i:150;s:4:\"file\";s:23:\"2014/04/31woLvKajCL.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"31woLvKajCL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"31woLvKajCL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"31woLvKajCL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"31woLvKajCL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1532", "208", "_thumbnail_id", "209");
INSERT INTO `wp_postmeta` VALUES("1533", "208", "imwb_zonpress_post_producturl", "http://www.amazon.com/Cherry-Tomato-Sweetie-Certified-Organic/dp/B002JOX6FG%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB002JOX6FG");
INSERT INTO `wp_postmeta` VALUES("1534", "208", "imwb_zonpress_post_price", "0.5");
INSERT INTO `wp_postmeta` VALUES("1535", "208", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1536", "208", "_imwb_zonpress_post_imp", "4");
INSERT INTO `wp_postmeta` VALUES("1537", "208", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1538", "208", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1539", "208", "imwb_interest_post_link_url", "http://www.amazon.com/Cherry-Tomato-Sweetie-Certified-Organic/dp/B002JOX6FG%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB002JOX6FG");
INSERT INTO `wp_postmeta` VALUES("1540", "208", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1543", "210", "imwb_cc_amazon_asin", "B0055KK84S");
INSERT INTO `wp_postmeta` VALUES("1544", "210", "_imwb_cc_amazon_asin_updated", "1398171823");
INSERT INTO `wp_postmeta` VALUES("1545", "211", "_wp_attached_file", "2014/04/41b7dZegUIL.jpg");
INSERT INTO `wp_postmeta` VALUES("1546", "211", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:225;s:6:\"height\";i:225;s:4:\"file\";s:23:\"2014/04/41b7dZegUIL.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41b7dZegUIL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41b7dZegUIL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41b7dZegUIL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41b7dZegUIL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1547", "210", "_thumbnail_id", "211");
INSERT INTO `wp_postmeta` VALUES("1548", "210", "imwb_zonpress_post_producturl", "http://www.amazon.com/Hinterland-Trading-Italian-Tomato-Tree-/dp/B0055KK84S%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0055KK84S");
INSERT INTO `wp_postmeta` VALUES("1549", "210", "imwb_zonpress_post_price", "0.99");
INSERT INTO `wp_postmeta` VALUES("1550", "210", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1551", "210", "_imwb_zonpress_post_imp", "3");
INSERT INTO `wp_postmeta` VALUES("1552", "210", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1553", "210", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1554", "210", "imwb_interest_post_link_url", "http://www.amazon.com/Hinterland-Trading-Italian-Tomato-Tree-/dp/B0055KK84S%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0055KK84S");
INSERT INTO `wp_postmeta` VALUES("1555", "210", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1558", "212", "imwb_cc_amazon_asin", "B00B5BOB3A");
INSERT INTO `wp_postmeta` VALUES("1559", "212", "_imwb_cc_amazon_asin_updated", "1398171823");
INSERT INTO `wp_postmeta` VALUES("1560", "213", "_wp_attached_file", "2014/04/61-Iyu3dwgL.jpg");
INSERT INTO `wp_postmeta` VALUES("1561", "213", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:448;s:6:\"height\";i:453;s:4:\"file\";s:23:\"2014/04/61-Iyu3dwgL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"61-Iyu3dwgL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"61-Iyu3dwgL-296x300.jpg\";s:5:\"width\";i:296;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"61-Iyu3dwgL-247x250.jpg\";s:5:\"width\";i:247;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"61-Iyu3dwgL-247x250.jpg\";s:5:\"width\";i:247;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"61-Iyu3dwgL-126x128.jpg\";s:5:\"width\";i:126;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"61-Iyu3dwgL-138x140.jpg\";s:5:\"width\";i:138;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"61-Iyu3dwgL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1562", "212", "_thumbnail_id", "213");
INSERT INTO `wp_postmeta` VALUES("1563", "212", "imwb_zonpress_post_producturl", "http://www.amazon.com/Survival-Seed-Kit-Varieties-Emergency/dp/B00B5BOB3A%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00B5BOB3A");
INSERT INTO `wp_postmeta` VALUES("1564", "212", "imwb_zonpress_post_price", "15.99");
INSERT INTO `wp_postmeta` VALUES("1565", "212", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1566", "212", "_imwb_zonpress_post_imp", "3");
INSERT INTO `wp_postmeta` VALUES("1567", "212", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1568", "212", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1569", "212", "imwb_interest_post_link_url", "http://www.amazon.com/Survival-Seed-Kit-Varieties-Emergency/dp/B00B5BOB3A%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00B5BOB3A");
INSERT INTO `wp_postmeta` VALUES("1570", "212", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1573", "214", "imwb_cc_amazon_asin", "B004IAB232");
INSERT INTO `wp_postmeta` VALUES("1574", "214", "_imwb_cc_amazon_asin_updated", "1398171823");
INSERT INTO `wp_postmeta` VALUES("1575", "215", "_wp_attached_file", "2014/04/41f6HALpWzL.jpg");
INSERT INTO `wp_postmeta` VALUES("1576", "215", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:300;s:6:\"height\";i:300;s:4:\"file\";s:23:\"2014/04/41f6HALpWzL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41f6HALpWzL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41f6HALpWzL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41f6HALpWzL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41f6HALpWzL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41f6HALpWzL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41f6HALpWzL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41f6HALpWzL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1577", "214", "_thumbnail_id", "215");
INSERT INTO `wp_postmeta` VALUES("1578", "214", "imwb_zonpress_post_producturl", "http://www.amazon.com/Seeds-Things-Choy-Chinese-Cabbage/dp/B004IAB232%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB004IAB232");
INSERT INTO `wp_postmeta` VALUES("1579", "214", "imwb_zonpress_post_price", "3.99");
INSERT INTO `wp_postmeta` VALUES("1580", "214", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1581", "214", "_imwb_zonpress_post_imp", "3");
INSERT INTO `wp_postmeta` VALUES("1582", "214", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1583", "214", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1584", "214", "imwb_interest_post_link_url", "http://www.amazon.com/Seeds-Things-Choy-Chinese-Cabbage/dp/B004IAB232%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB004IAB232");
INSERT INTO `wp_postmeta` VALUES("1585", "214", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1588", "216", "imwb_cc_amazon_asin", "B003HTZ2M2");
INSERT INTO `wp_postmeta` VALUES("1589", "216", "_imwb_cc_amazon_asin_updated", "1398171823");
INSERT INTO `wp_postmeta` VALUES("1590", "217", "_wp_attached_file", "2014/04/61b31ulvrlL.jpg");
INSERT INTO `wp_postmeta` VALUES("1591", "217", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:497;s:4:\"file\";s:23:\"2014/04/61b31ulvrlL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"61b31ulvrlL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"61b31ulvrlL-300x298.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:298;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"61b31ulvrlL-251x250.jpg\";s:5:\"width\";i:251;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"61b31ulvrlL-251x250.jpg\";s:5:\"width\";i:251;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"61b31ulvrlL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"61b31ulvrlL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"61b31ulvrlL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1592", "216", "_thumbnail_id", "217");
INSERT INTO `wp_postmeta` VALUES("1593", "216", "imwb_zonpress_post_producturl", "http://www.amazon.com/Sweet-Pickle-Pepper-Seeds-Christmas/dp/B003HTZ2M2%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB003HTZ2M2");
INSERT INTO `wp_postmeta` VALUES("1594", "216", "imwb_zonpress_post_price", "0.09");
INSERT INTO `wp_postmeta` VALUES("1595", "216", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1596", "216", "_imwb_zonpress_post_imp", "4");
INSERT INTO `wp_postmeta` VALUES("1597", "216", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1598", "216", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1599", "216", "imwb_interest_post_link_url", "http://www.amazon.com/Sweet-Pickle-Pepper-Seeds-Christmas/dp/B003HTZ2M2%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB003HTZ2M2");
INSERT INTO `wp_postmeta` VALUES("1600", "216", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1603", "218", "imwb_cc_amazon_asin", "B00GT49WS2");
INSERT INTO `wp_postmeta` VALUES("1604", "218", "_imwb_cc_amazon_asin_updated", "1398171823");
INSERT INTO `wp_postmeta` VALUES("1605", "219", "_wp_attached_file", "2014/04/613Q8zsUTqL.jpg");
INSERT INTO `wp_postmeta` VALUES("1606", "219", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/613Q8zsUTqL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"613Q8zsUTqL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"613Q8zsUTqL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"613Q8zsUTqL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"613Q8zsUTqL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"613Q8zsUTqL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"613Q8zsUTqL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"613Q8zsUTqL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1607", "218", "_thumbnail_id", "219");
INSERT INTO `wp_postmeta` VALUES("1608", "218", "imwb_zonpress_post_producturl", "http://www.amazon.com/Variety-Organic-Heirloom-Survival-Seed/dp/B00GT49WS2%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00GT49WS2");
INSERT INTO `wp_postmeta` VALUES("1609", "218", "imwb_zonpress_post_price", "74.99");
INSERT INTO `wp_postmeta` VALUES("1610", "218", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1611", "218", "_imwb_zonpress_post_imp", "4");
INSERT INTO `wp_postmeta` VALUES("1612", "218", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1613", "218", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1614", "218", "imwb_interest_post_link_url", "http://www.amazon.com/Variety-Organic-Heirloom-Survival-Seed/dp/B00GT49WS2%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00GT49WS2");
INSERT INTO `wp_postmeta` VALUES("1615", "218", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1618", "220", "imwb_cc_amazon_asin", "B006OUILA6");
INSERT INTO `wp_postmeta` VALUES("1619", "220", "_imwb_cc_amazon_asin_updated", "1398171823");
INSERT INTO `wp_postmeta` VALUES("1620", "221", "_wp_attached_file", "2014/04/51nX5zKHRdL.jpg");
INSERT INTO `wp_postmeta` VALUES("1621", "221", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:427;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/51nX5zKHRdL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51nX5zKHRdL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51nX5zKHRdL-256x300.jpg\";s:5:\"width\";i:256;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51nX5zKHRdL-213x250.jpg\";s:5:\"width\";i:213;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51nX5zKHRdL-213x250.jpg\";s:5:\"width\";i:213;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51nX5zKHRdL-109x128.jpg\";s:5:\"width\";i:109;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51nX5zKHRdL-119x140.jpg\";s:5:\"width\";i:119;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51nX5zKHRdL-42x50.jpg\";s:5:\"width\";i:42;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1622", "220", "_thumbnail_id", "221");
INSERT INTO `wp_postmeta` VALUES("1623", "220", "imwb_zonpress_post_producturl", "http://www.amazon.com/Seeds-Change-06465-Certified-Organic/dp/B006OUILA6%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB006OUILA6");
INSERT INTO `wp_postmeta` VALUES("1624", "220", "imwb_zonpress_post_price", "2.72");
INSERT INTO `wp_postmeta` VALUES("1625", "220", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1626", "220", "_imwb_zonpress_post_imp", "26");
INSERT INTO `wp_postmeta` VALUES("1627", "220", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1628", "220", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1629", "220", "imwb_interest_post_link_url", "http://www.amazon.com/Seeds-Change-06465-Certified-Organic/dp/B006OUILA6%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB006OUILA6");
INSERT INTO `wp_postmeta` VALUES("1630", "220", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1633", "222", "imwb_cc_amazon_asin", "B0032GC6ME");
INSERT INTO `wp_postmeta` VALUES("1634", "222", "_imwb_cc_amazon_asin_updated", "1398171824");
INSERT INTO `wp_postmeta` VALUES("1635", "223", "_wp_attached_file", "2014/04/515Sex2ikJL.jpg");
INSERT INTO `wp_postmeta` VALUES("1636", "223", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:441;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/04/515Sex2ikJL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"515Sex2ikJL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"515Sex2ikJL-264x300.jpg\";s:5:\"width\";i:264;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"515Sex2ikJL-220x250.jpg\";s:5:\"width\";i:220;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"515Sex2ikJL-220x250.jpg\";s:5:\"width\";i:220;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"515Sex2ikJL-112x128.jpg\";s:5:\"width\";i:112;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"515Sex2ikJL-123x140.jpg\";s:5:\"width\";i:123;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"515Sex2ikJL-44x50.jpg\";s:5:\"width\";i:44;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1637", "222", "_thumbnail_id", "223");
INSERT INTO `wp_postmeta` VALUES("1638", "222", "imwb_zonpress_post_producturl", "http://www.amazon.com/Tokyo-White-Bunching-Onion-Seeds/dp/B0032GC6ME%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0032GC6ME");
INSERT INTO `wp_postmeta` VALUES("1639", "222", "imwb_zonpress_post_price", "0.99");
INSERT INTO `wp_postmeta` VALUES("1640", "222", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1641", "222", "_imwb_zonpress_post_imp", "3");
INSERT INTO `wp_postmeta` VALUES("1642", "222", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1643", "222", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1644", "222", "imwb_interest_post_link_url", "http://www.amazon.com/Tokyo-White-Bunching-Onion-Seeds/dp/B0032GC6ME%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0032GC6ME");
INSERT INTO `wp_postmeta` VALUES("1645", "222", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1646", "224", "_wp_attached_file", "2014/04/cropped-007.jpg");
INSERT INTO `wp_postmeta` VALUES("1647", "224", "_wp_attachment_context", "custom-header");
INSERT INTO `wp_postmeta` VALUES("1648", "224", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:970;s:6:\"height\";i:130;s:4:\"file\";s:23:\"2014/04/cropped-007.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"cropped-007-150x130.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:130;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:22:\"cropped-007-300x40.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:40;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:22:\"cropped-007-300x40.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:40;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:22:\"cropped-007-300x40.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:40;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"cropped-007-153x20.jpg\";s:5:\"width\";i:153;s:6:\"height\";i:20;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"cropped-007-170x22.jpg\";s:5:\"width\";i:170;s:6:\"height\";i:22;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:20:\"cropped-007-50x6.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:6;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";d:1;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:8:\"DYNAX 5D\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:1383124331;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:3:\"100\";s:13:\"shutter_speed\";s:5:\"0.025\";s:5:\"title\";s:29:\"KONICA MINOLTA DIGITAL CAMERA\";}}");
INSERT INTO `wp_postmeta` VALUES("1649", "224", "_wp_attachment_is_custom_header", "covertstorebuilder");
INSERT INTO `wp_postmeta` VALUES("1650", "224", "_wp_attachment_custom_header_last_used_covertstorebuilder", "1398061629");

/* INSERT TABLE DATA: wp_posts */
INSERT INTO `wp_posts` VALUES("1", "1", "2014-04-19 13:44:02", "2014-04-19 13:44:02", "Welcome to WordPress. This is your first post. Edit or delete it, then start blogging!", "Hello world!", "", "trash", "closed", "open", "", "hello-world", "", "", "2014-04-21 06:12:41", "2014-04-21 06:12:41", "", "0", "http://blogsforsales.com/green/?p=1", "0", "post", "", "1");
INSERT INTO `wp_posts` VALUES("2", "1", "2014-04-19 13:44:02", "2014-04-19 13:44:02", "This is an example page. It\'s different from a blog post because it will stay in one place and will show up in your site navigation (in most themes). Most people start with an About page that introduces them to potential site visitors. It might say something like this:\n\n<blockquote>Hi there! I\'m a bike messenger by day, aspiring actor by night, and this is my blog. I live in Los Angeles, have a great dog named Jack, and I like pi&#241;a coladas. (And gettin\' caught in the rain.)</blockquote>\n\n...or something like this:\n\n<blockquote>The XYZ Doohickey Company was founded in 1971, and has been providing quality doohickeys to the public ever since. Located in Gotham City, XYZ employs over 2,000 people and does all kinds of awesome things for the Gotham community.</blockquote>\n\nAs a new WordPress user, you should go to <a href=\"http://blogsforsales.com/green/wp-admin/\">your dashboard</a> to delete this page and create new pages for your content. Have fun!", "Sample Page", "", "publish", "open", "open", "", "sample-page", "", "", "2014-04-19 13:44:02", "2014-04-19 13:44:02", "", "0", "http://blogsforsales.com/green/?page_id=2", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("3", "1", "2014-04-19 13:44:02", "0000-00-00 00:00:00", "", "Auto Draft", "", "auto-draft", "open", "open", "", "", "", "", "2014-04-19 13:44:02", "0000-00-00 00:00:00", "", "0", "http://blogsforsales.com/green/?p=3", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("4", "1", "2014-04-19 13:44:02", "2014-04-19 13:44:02", "Welcome to WordPress. This is your first post. Edit or delete it, then start blogging!", "Hello world!", "", "inherit", "closed", "open", "", "1-revision-v1", "", "", "2014-04-19 13:44:02", "2014-04-19 13:44:02", "", "1", "http://blogsforsales.com/green/1-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("6", "1", "2014-04-21 06:03:41", "2014-04-21 06:03:41", "<p>3 Piece, Garden Hand Tool Set, Includes: Trowel, Transplanter & Weeder, Comfortable, Soft Touch Handle Reduces Hand Stress, Cast Aluminum Head Resists Corrosion, Hang Hole For Easy Storage,<br />\n<h4>Fiskars 7067 3-Piece Softouch Garden Tool Set</h4>\n</p>\n<p>    <img src=\"https://images-na.ssl-images-amazon.com/images/G/01/outdoor-living/detailpages/fiskars/7067pkg.jpg\" width=\"275\" height=\"209\" alt=\"Big Grip Tools\" />\n<p>Fiskars 7067 Softouch garden tool set comes with three tools. View larger.</p>\n<p class=\"imageCaption\">\n<p>The Fiskars Softouch tools provide excellent comfort and durability to make digging, cultivating and transplanting in the garden a breeze. Each soft, contoured handle fits your hand naturally and encourages a neutral wrist position to help reduce hand stress and fatigue. The flat end pad of each handle also offers a smart way to generate more leverage than other garden tools. The cast-aluminum heads resist rust and won\'t snap off while you\'re digging no matter how tough your soil is, and the handles include hang holes for convenient storage. Softouch garden tools include a lifetime warranty. </p>\n<p>  Trowel is ideal for digging when planting, taking up plants, turning up earth and more Cultivator loosens soil, removes weeds and aerates soil with ease The transplanter features gradation marks to make transplanting small plants and flowers a breeze Soft, contoured handles are ergonomically designed to reduce hand and wrist fatigue while digging in tough soil Handle end pads offer enhanced leverage Polished aluminum heads resist rust for lasting value and won’t snap off Handle hang holes provide easy storage      <img src=\"https://images-na.ssl-images-amazon.com/images/G/01/outdoor-living/detailpages/fiskars/7062_handlesized.jpg\" width=\"118\" height=\"295\" alt=\"Handle\" />\n<p>Soft contoured handle helps reduce hand fatigue during use. View larger.</p>\n<p>    <img src=\"https://images-na.ssl-images-amazon.com/images/G/01/outdoor-living/detailpages/fiskars/7062.jpg\" width=\"290\" height=\"290\" alt=\"Shovel\" /> Trowel is ideal for digging. View larger.   <img src=\"https://images-na.ssl-images-amazon.com/images/G/01/outdoor-living/detailpages/fiskars/7063.jpg\" width=\"290\" height=\"290\" alt=\"Shovel\" /> Softouch transplaner features gradation marks. View larger.    <img src=\"https://images-na.ssl-images-amazon.com/images/G/01/outdoor-living/detailpages/fiskars/7064.jpg\" width=\"290\" height=\"290\" alt=\"Scoop\" />\n<p>Cultivator loosens soil and removes weeds. View larger.</p>\n<h3>Product Features</h3>\n<ul>\n<li>Short-handled garden set includes a trowel, transplanter, and cultivator</li>\n<li>Single-piece, polished aluminum construction is durable, lightweight, rust resistant</li>\n<li>Comfortable, fatigue-reducing Softouch cushioned handles</li>\n<li>Hanging holes for easy storage</li>\n<li>Lifetime warranty</li>\n</ul>\n", "Fiskars 3 Piece Softouch Garden Tool Set (7067)", "", "publish", "closed", "open", "", "fiskars-3-piece-softouch-garden-tool-set-7067", "", "", "2014-04-21 06:03:41", "2014-04-21 06:03:41", "", "0", "http://blogsforsales.com/green/fiskars-3-piece-softouch-garden-tool-set-7067/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("7", "1", "2014-04-21 06:03:41", "2014-04-21 06:03:41", "", "41I7m8qWmkL", "", "inherit", "closed", "open", "", "41i7m8qwmkl", "", "", "2014-04-21 06:03:41", "2014-04-21 06:03:41", "", "6", "http://blogsforsales.com/green/wp-content/uploads/2014/04/41I7m8qWmkL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("8", "1", "2014-04-21 06:03:42", "2014-04-21 06:03:42", "<p>Our Garden Bucket Caddy makes it easy to carry all of your essentials when you’re out in the garden. It fits snugly on a five-gallon bucket, freeing up the internal space for dirt, yard waste or supplies. Deep, large pockets provide ample space for tools, gloves, beverages and even a cell phone. Sturdy canvas construction is light, durable and easy to clean.\n<p>Keep all your essential garden tools organized and on hand.</p>\n<p>The 9424 Garden Bucket Caddy by Fiskars makes it easy to carry all of your essentials when you’re out in the garden. It fits snugly on a five-gallon bucket, freeing up the internal space for dirt, yard waste or supplies. Deep, large pockets provide ample space for tools, gloves, beverages and even a cell phone. Sturdy canvas construction is light, durable and easy to clean. The Bucket Caddy has a Lifetime warranty. </p>\n<p>  Ideal for transporting a variety of small tools, beverages, your cell phone and more Frees up internal bucket space for yard waste or other items Includes nine deep pockets and two “pencil” pockets Durable, easy-to-clean canvas construction offers lasting value Fits five-gallon buckets (bucket and tools not included)    <img src=\"https://images-na.ssl-images-amazon.com/images/G/01/outdoor-living/detailpages/fiskars/9424_sized.jpg\" width=\"195\" height=\"250\" alt=\"9424 Bucket Caddy\" />\n<p>Ideal for transporting a variety of small tools. (bucket and tools not included)View larger.</p>\n<p>   <img src=\"https://images-na.ssl-images-amazon.com/images/G/01/outdoor-living/detailpages/fiskars/9424_O_flatsized.jpg\" width=\"250\" height=\"118\" alt=\"Bucket Caddy Flat\" />\n<p>Durable, easy-to-clean canvas construction offers lasting value.(tools not included) View larger.</p>\n<p>   <img src=\"https://images-na.ssl-images-amazon.com/images/G/01/outdoor-living/detailpages/fiskars/9424_O_flat_emptysized.jpg\" width=\"250\" height=\"117\" alt=\"Bucket Caddy empty\" />\n<p>Includes nine deep pockets and two “pencil” pockets. View larger.</p>\n<p>    <img src=\"https://images-na.ssl-images-amazon.com/images/G/01/outdoor-living/detailpages/fiskars/9424_O2sized.jpg\" width=\"250\" height=\"186\" alt=\"Velcro closure\" />\n<p>Secure velcro fastener. View larger.</p>\n<h3>Product Features</h3>\n<ul>\n<li>Garden bucket caddy featuring unique and clever design</li>\n<li>Fits snugly on 5-gallon bucket</li>\n<li>Sturdy canvas construction with deep pockets for various hand tools</li>\n<li>Includes cell phone, beverage, and seed packet holders</li>\n<li>8.9-by-10-by-13.4-inches at 2-pounds</li>\n</ul>\n", "Fiskars Garden Bucket Caddy (9424)", "", "publish", "closed", "open", "", "fiskars-garden-bucket-caddy-9424", "", "", "2014-04-21 06:03:42", "2014-04-21 06:03:42", "", "0", "http://blogsforsales.com/green/fiskars-garden-bucket-caddy-9424/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("9", "1", "2014-04-21 06:03:42", "2014-04-21 06:03:42", "", "41ESVX7QBEL", "", "inherit", "closed", "open", "", "41esvx7qbel", "", "", "2014-04-21 06:03:42", "2014-04-21 06:03:42", "", "8", "http://blogsforsales.com/green/wp-content/uploads/2014/04/41ESVX7QBEL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("10", "1", "2014-04-21 06:03:43", "2014-04-21 06:03:43", "<p>This master craft eight-piece garden tool and tote set includes everything you need for those gardening and landscaping projects. The garden tools fit conveniently in the attractive canvas tote so you can easily transport your tools as needed. The eight-piece set includes: 8-inch by-pass pruner with black finished blades and aluminum handle, 12-1/2-inch fixed blade grass shear with black finished blades, 4-piece chrome plated steel digging tools with lacquered hardwood handles: 10-1/2-inch trowel, 10-3/4-inch transplanter, 8-1/2-inch cultivator, 12-inch weeder, 20 meter green vinyl coated twist tie wire with reel and cutter. The canvas tote is constructed of heavy weight cotton with pockets and elastic straps to store and secure the tools. Item #ga2027t-ph<br />\n<h3>Product Features</h3>\n<ul>\n<li>Eight-piece garden tool set with attractive canvas tote</li>\n<li>Everything you need for your landscaping projects</li>\n<li>Easily transport tools from project to project</li>\n</ul>\n", "Master Craft Eight-Piece Garden Tool and Tote Set", "", "publish", "closed", "open", "", "master-craft-eight-piece-garden-tool-and-tote-set", "", "", "2014-04-21 06:03:43", "2014-04-21 06:03:43", "", "0", "http://blogsforsales.com/green/master-craft-eight-piece-garden-tool-and-tote-set/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("11", "1", "2014-04-21 06:03:44", "2014-04-21 06:03:44", "", "41NCm8TUIdL", "", "inherit", "closed", "open", "", "41ncm8tuidl", "", "", "2014-04-21 06:03:44", "2014-04-21 06:03:44", "", "10", "http://blogsforsales.com/green/wp-content/uploads/2014/04/41NCm8TUIdL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("12", "1", "2014-04-21 06:03:45", "2014-04-21 06:03:45", "<p>This reliable pruner from Fiskars is ideal for a variety of general pruning tasks. A fully hardened, precision-ground steel blade stays sharp longer, and a rust-resistant, low-friction coating makes cutting easier. A self-cleaning sap groove keeps the blades from sticking, and the handle includes non-slip grips. All-steel construction provides lasting durability, and an easy-open lock protects the blades when not in use. Includes a maximum cutting capacity of 5/8 and a lifetime warranty.<br />\n<h3>Product Features</h3>\n<ul>\n<li>Ideal for cutting stems and light branches up to 5/8 diameter</li>\n<li>Fully hardened, precision-ground steel bypass blade stays sharp, and a low- friction, rust-resistant coating makes cutting easier</li>\n<li>Self-cleaning sap groove keeps the blade from sticking for easy operation</li>\n<li>Durable all-steel design with non-slip grips and an easy-open lock</li>\n<li>Lifetime warranty</li>\n</ul>\n", "Fiskars Traditional Bypass Pruning Shears (9109)", "", "publish", "closed", "open", "", "fiskars-traditional-bypass-pruning-shears-9109", "", "", "2014-04-21 06:03:45", "2014-04-21 06:03:45", "", "0", "http://blogsforsales.com/green/fiskars-traditional-bypass-pruning-shears-9109/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("13", "1", "2014-04-21 06:03:45", "2014-04-21 06:03:45", "", "31fhfmQTxGL", "", "inherit", "closed", "open", "", "31fhfmqtxgl", "", "", "2014-04-21 06:03:45", "2014-04-21 06:03:45", "", "12", "http://blogsforsales.com/green/wp-content/uploads/2014/04/31fhfmQTxGL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("14", "1", "2014-04-21 06:03:46", "2014-04-21 06:03:46", "<p>Black and Decker Garden IQ Series Three piece garden tool set, (trowel, fan rake and culti-hoe). These tools are made of heat treated hardened steel construction, powder coat finished with ergonomic handles. All tools have a two year manufacturer warranty.<br />\n<h3>Product Features</h3>\n<ul>\n<li>Durable heat treated hardened steel construction</li>\n<li>Powder coat finish</li>\n<li>Molded soft grip ergonomic handles</li>\n<li>2 year manufacturer warranty</li>\n</ul>\n", "Black and Decker Garden IQ Series Trowel, Fan Rake and Culti-Hoe", "", "publish", "closed", "open", "", "black-and-decker-garden-iq-series-trowel-fan-rake-and-culti-hoe", "", "", "2014-04-21 06:03:46", "2014-04-21 06:03:46", "", "0", "http://blogsforsales.com/green/black-and-decker-garden-iq-series-trowel-fan-rake-and-culti-hoe/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("15", "1", "2014-04-21 06:03:46", "2014-04-21 06:03:46", "", "51xdw0oXZwL", "", "inherit", "closed", "open", "", "51xdw0oxzwl", "", "", "2014-04-21 06:03:46", "2014-04-21 06:03:46", "", "14", "http://blogsforsales.com/green/wp-content/uploads/2014/04/51xdw0oXZwL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("16", "1", "2014-04-21 06:03:47", "2014-04-21 06:03:47", "<p>Bring all your gardening necessities with you in our Garden Tote Tool Set. This small gardening dynamite includes a pruner, snips, rake, trowel, shovel and glass spray bottle. The canvas tote has a reinforced bottom and it has brass grommets, elastic tool bands and an eight-pocket capacity. Perfect for tending to small gardens and indoor plants.<br />\n<h3>Product Features</h3>\n<ul>\n<li>Perfect for tending to small gardens and indoor plants</li>\n<li>Includes a pruner, snips, rake, trowel, shovel and glass spray bottle</li>\n<li>Canvas tote has a reinforced bottom and it has brass grommets, elastic tool bands and an eight-pocket capacity</li>\n</ul>\n", "Wrapables Indoor Gardening Tool Set", "", "publish", "closed", "open", "", "wrapables-indoor-gardening-tool-set", "", "", "2014-04-21 06:03:47", "2014-04-21 06:03:47", "", "0", "http://blogsforsales.com/green/wrapables-indoor-gardening-tool-set/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("17", "1", "2014-04-21 06:03:48", "2014-04-21 06:03:48", "", "51Bz8AL2scL", "", "inherit", "closed", "open", "", "51bz8al2scl", "", "", "2014-04-21 06:03:48", "2014-04-21 06:03:48", "", "16", "http://blogsforsales.com/green/wp-content/uploads/2014/04/51Bz8AL2scL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("18", "1", "2014-04-21 06:03:51", "2014-04-21 06:03:51", "<p>Gardening just got easier with the Gardener by Picnic Time! The Gardener is a folding seat and detachable polyester storage tote all-in-one. The storage tote has two zippered openings, one on the backside and one on the top for easy access from any angle and it conveniently holds 5 metal garden tools on the exterior of the tote so they are readily accessible when you need them. All 5 tools have wooden handles and leatherette straps for hanging. Makes a perfect gift for those who love spending time in their garden.<br />\n<h3>Product Features</h3>\n<ul>\n<li>Lightweight and portable;</li>\n<li>Sturdy steel frame;</li>\n<li>Tool pockets on the exterior of the storage tote make them readily accessible when sitting in the seat;</li>\n<li>Storage tote fully detaches from the bag for versatility;</li>\n</ul>\n", "Picnic Time 5-Piece Garden Tool Set With Tote And Folding Seat", "", "publish", "closed", "open", "", "picnic-time-5-piece-garden-tool-set-with-tote-and-folding-seat", "", "", "2014-04-21 06:03:51", "2014-04-21 06:03:51", "", "0", "http://blogsforsales.com/green/picnic-time-5-piece-garden-tool-set-with-tote-and-folding-seat/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("19", "1", "2014-04-21 06:03:51", "2014-04-21 06:03:51", "", "51t+A5FlOtL", "", "inherit", "closed", "open", "", "51ta5flotl", "", "", "2014-04-21 06:03:51", "2014-04-21 06:03:51", "", "18", "http://blogsforsales.com/green/wp-content/uploads/2014/04/51t+A5FlOtL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("20", "1", "2014-04-21 06:03:53", "2014-04-21 06:03:53", "<h3>Product Features</h3>\n<ul>\n<li>Made of 100 percent cotton</li>\n<li>Assorted jersey gloves</li>\n<li>Flower print with knit wrist</li>\n<li>PVC dots on palms</li>\n<li>Sold by pack (3 pairs--green, red, and blue--each)</li>\n</ul>\n", "G & F 1852-3 Women Soft Jersey Garden Gloves, 3-Pairs Green/Pink/Blue per Pack", "", "publish", "closed", "open", "", "g-f-1852-3-women-soft-jersey-garden-gloves-3-pairs-greenpinkblue-per-pack", "", "", "2014-04-21 06:03:53", "2014-04-21 06:03:53", "", "0", "http://blogsforsales.com/green/g-f-1852-3-women-soft-jersey-garden-gloves-3-pairs-greenpinkblue-per-pack/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("21", "1", "2014-04-21 06:03:53", "2014-04-21 06:03:53", "", "51rEXTU+nLL", "", "inherit", "closed", "open", "", "51rextunll", "", "", "2014-04-21 06:03:53", "2014-04-21 06:03:53", "", "20", "http://blogsforsales.com/green/wp-content/uploads/2014/04/51rEXTU+nLL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("22", "1", "2014-04-21 06:03:54", "2014-04-21 06:03:54", "<p>Toysmith 2296 kid-feets hand tool set<br />\n<h3>Product Features</h3>\n<ul>\n<li>These sturdy hand tools in a gift box for easy display</li>\n<li>These tools measure up to 8-1/2-Inch long</li>\n<li>6 sets per display</li>\n</ul>\n", "Toysmith 2296 Kid\'s 3-Piece Garden Tool Set", "", "publish", "closed", "open", "", "toysmith-2296-kids-3-piece-garden-tool-set", "", "", "2014-04-21 06:03:54", "2014-04-21 06:03:54", "", "0", "http://blogsforsales.com/green/toysmith-2296-kids-3-piece-garden-tool-set/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("23", "1", "2014-04-21 06:03:54", "2014-04-21 06:03:54", "", "51WCqH8uLCL", "", "inherit", "closed", "open", "", "51wcqh8ulcl", "", "", "2014-04-21 06:03:54", "2014-04-21 06:03:54", "", "22", "http://blogsforsales.com/green/wp-content/uploads/2014/04/51WCqH8uLCL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("24", "1", "2014-04-21 06:03:55", "2014-04-21 06:03:55", "<p>The Radius Garden NRGSET is a 4-piece set of high quality garden hand tools including a Trowel, Transplanter, Weeder, and Cultivator, all 4 with original Radius green handles. Discover garden tools unlike any you\'ve ever held before. The Radius Garden Natural Radius Grip garden tools were designed using the most current research into human factors and tool usage. The patent-pending, Natural Radius Grip, maximizes your power and comfort while minimizing hand and wrist stress. Traditional garden tools force you to use your hands and wrists in a way that can cause injuries. The curve of the grip matches the curve of the palm of your hand. This allows you to hold the tools with your wrist in a safe, neutral position at all angles of attack. This maximizes power and comfort while minimizing wrist and hand stress. The large grips on Radius tools allow you to hold the tool securely without exerting pressure and wasting your energy. The blades of these tools are made of a special aluminum/magnesium alloy. It weighs less than conventional die cast aluminum, but has strength similar to steel. The tools are lighter weight yet have equal or greater strength than traditional garden tools. The advanced ergonomic design should make gardening easier and more enjoyable.<br />\n<h3>Product Features</h3>\n<ul>\n<li>Complete set of five Radius Ergonomic Hand Tools: includes a Trowel, Transplanter, Weeder, and Cultivator</li>\n<li>Ergonomic design features a patented, high performance, natural grip that minimizes hand & wrist stress while maximizing power & comfort to provides a secure grip - wet or dry</li>\n<li>The ultra-light polished aluminum/magnesium blades are surprisingly light and remarkably strong and have an exceptional strength to weight ratio</li>\n<li>Used for digging, planting, potting and weeding</li>\n<li>These amazing tools are so strong and durable they carry a Lifetime Guarantee, so if they ever were to break, Radius will replace them</li>\n</ul>\n", "Radius Garden NRGSET 4-Piece Gardening Hand Tool Set, includes Trowel, Transplanter, Weeder, and Cultivator", "", "publish", "closed", "open", "", "radius-garden-nrgset-4-piece-gardening-hand-tool-set-includes-trowel-transplanter-weeder-and-cultivator", "", "", "2014-04-21 06:03:55", "2014-04-21 06:03:55", "", "0", "http://blogsforsales.com/green/radius-garden-nrgset-4-piece-gardening-hand-tool-set-includes-trowel-transplanter-weeder-and-cultivator/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("25", "1", "2014-04-21 06:03:55", "2014-04-21 06:03:55", "", "41hf2WzmL8L", "", "inherit", "closed", "open", "", "41hf2wzml8l", "", "", "2014-04-21 06:03:55", "2014-04-21 06:03:55", "", "24", "http://blogsforsales.com/green/wp-content/uploads/2014/04/41hf2WzmL8L.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("26", "1", "2014-04-21 06:03:56", "2014-04-21 06:03:56", "<p>Strong, lightweight and affordable, this quality Garden Trowel features stronger-than-steel FiberComp construction for lasting value. One-piece design means the handle won\'t loosen and the trowel won\'t bend at the neck when digging into tough soil. What\'s more, this trowel won\'t rust. Includes a hang hole for easy storage. Lifetime warranty.<br />\n<h3>Product Features</h3>\n<ul>\n<li>Durable, lightweight trowel ideal for working soil in gardens, borders, and containers</li>\n<li>Single-piece Nyglass nylon/fiberglass composite construction for strength and light weight</li>\n<li>Rust-proof and easy to clean</li>\n<li>Hanging hole for convenient storage</li>\n<li>Lifetime warranty</li>\n<li>A field work basic</li>\n<li>Great way to teach plant life and observation skills</li>\n<li>Multiple award winner, including Dr. Toy and Oppenheim Gold</li>\n<li>Plastic construction</li>\n<li>Watch carrot, radish and onion seeds grow up as the roots grow down</li>\n</ul>\n", "Fiskars 7978 Composite Trowel", "", "publish", "closed", "open", "", "fiskars-7978-composite-trowel", "", "", "2014-04-21 06:03:56", "2014-04-21 06:03:56", "", "0", "http://blogsforsales.com/green/fiskars-7978-composite-trowel/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("27", "1", "2014-04-21 06:03:56", "2014-04-21 06:03:56", "", "31fLwed8LJL", "", "inherit", "closed", "open", "", "31flwed8ljl", "", "", "2014-04-21 06:03:56", "2014-04-21 06:03:56", "", "26", "http://blogsforsales.com/green/wp-content/uploads/2014/04/31fLwed8LJL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("28", "1", "2014-04-21 06:03:57", "2014-04-21 06:03:57", "<p>GET YOUR GARDEN GROWING GREEN</p>\n<p>The joys of a bountiful garden come with skill, hard work, and a little luck.  The skill and luck are up to you, but Homegrown Garden Tools make the hard work so much easier with these three essential tools that every gardener needs.</p>\n<p>TRANSPLANTER - Inch and centimeter marks insure that you\'ll always set your seeds and small plants to exactly the right depth.</p>\n<p>TROWEL - Dig, transplant or turn soil with this polished aluminum blade that won\'t bend, break or rust.</p>\n<p>CULTIVATOR - Loosen soil, uproot unwanted weeds and give your planting beds a neat, tidy, raked look.</p>\n<p>Homegrown Garden Tools are used in gardens large and small.  From backyard and patio gardens to raised beds and window box planters.</p>\n<p>Plus with our 100% Satisfaction Guarantee backed by a Lifetime Warranty, you know you\'re getting tough, top quality tools that will last year after year.</p>\n<p>Buy your HOMEGROWN 3-PIECE GARDEN TOOL SET today.  And soon you\'ll say... The Best is Always Homegrown!<br />\n<h3>Product Features</h3>\n<ul>\n<li>Transplanter, Trowel & Cultivator</li>\n<li>One-Piece Polished Aluminum Tools - Durable - Rust Resistant - Will Not Bend or Break</li>\n<li>Easy to Grip Handles Reduce Hand Fatigue</li>\n<li>Reinforced Handle Holes for Easy Storage</li>\n<li>100% Satisfaction Guarantee with Lifetime Warranty</li>\n</ul>\n", "Homegrown 3-piece Garden Tool Set - Top Quality Hand Gardening Tools - Easy Grip Handles - Built to Last - 100% Satisfaction Guarantee with Lifetime Warranty", "", "publish", "closed", "open", "", "homegrown-3-piece-garden-tool-set-top-quality-hand-gardening-tools-easy-grip-handles-built-to-last-100-satisfaction-guarantee-with-lifetime-warranty", "", "", "2014-04-21 06:03:57", "2014-04-21 06:03:57", "", "0", "http://blogsforsales.com/green/homegrown-3-piece-garden-tool-set-top-quality-hand-gardening-tools-easy-grip-handles-built-to-last-100-satisfaction-guarantee-with-lifetime-warranty/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("29", "1", "2014-04-21 06:03:57", "2014-04-21 06:03:57", "", "41GWJOiP0gL", "", "inherit", "closed", "open", "", "41gwjoip0gl", "", "", "2014-04-21 06:03:57", "2014-04-21 06:03:57", "", "28", "http://blogsforsales.com/green/wp-content/uploads/2014/04/41GWJOiP0gL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("30", "1", "2014-04-21 06:03:57", "2014-04-21 06:03:57", "<p>Get organized with the Apollo Tools Bucket Tool Organizer. This Bucket Tool Organizer is made of single layer 600D oxford cloth w/PVC inner layer and will convert your 5 gallon bucket into a tool organizer. It is perfect for keeping your tools organized, protected and easily accessible. With the hook and loop fastener strap it fits any 5 gallon bucket and makes carry tools a breeze. Utilizes 14 inside pockets and 34 triple row outside pockets to hold anything and everything from your garden tools, gloves, seeds, marking sticks, string, scissors, tape , water bottle, and/or cell phone. Made of an extremely durable cloth constructed of PVC coated polyester material that is extremely tear resistant. This material is typically found on products that require abrasion resistance and waterproof characteristics like backpacks, hunting equipment or luggage. Color is Black with green accent. Bucket not included.<br />\n<h3>Product Features</h3>\n<ul>\n<li>Dollar 0.25 from this purchase is being donated to The Breast Cancer Research Foundation</li>\n<li>14 inside pockets, 34 triple row outside pockets</li>\n<li>Fits any standard 5 gallon bucket (bucket not included)</li>\n<li>Adjustable hook & loop strap attaches quickly and easily</li>\n<li>Holds most hand and garden tools</li>\n</ul>\n", "Apollo Precision Tools DT0825P 5-Gallon Bucket Garden Tool Organizer, Black/Pink", "", "publish", "closed", "open", "", "apollo-precision-tools-dt0825p-5-gallon-bucket-garden-tool-organizer-blackpink", "", "", "2014-04-21 06:03:57", "2014-04-21 06:03:57", "", "0", "http://blogsforsales.com/green/apollo-precision-tools-dt0825p-5-gallon-bucket-garden-tool-organizer-blackpink/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("31", "1", "2014-04-21 06:03:58", "2014-04-21 06:03:58", "", "41mlM28f9KL", "", "inherit", "closed", "open", "", "41mlm28f9kl", "", "", "2014-04-21 06:03:58", "2014-04-21 06:03:58", "", "30", "http://blogsforsales.com/green/wp-content/uploads/2014/04/41mlM28f9KL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("32", "1", "2014-04-21 06:03:59", "2014-04-21 06:03:59", "<p>Give the gift of nature with the Blooms 5 Piece Garden Tool Gift Combo Set. Each set features a draw string canvas tote in either Teal with Brown Edging or Tan with Brown Edging, trowel, cultivator, scissors and pruner, the perfect tools to craft a gorgeous green space.<br />\n<h3>Product Features</h3>\n<ul>\n<li>5 Piece Gardening Tool Kit</li>\n<li>Kit Includes:Trowel, Cultivator, Scissors and Pruner</li>\n<li>Comes with Canvas Carrying Bag in Two Available Colors- Teal or Tan</li>\n<li>Tools have Comfort Grip Handles</li>\n<li>Perfect gift for someone looking to dip their toes in the world of gardening or horticulture</li>\n</ul>\n", "Blooms 5-Piece Gardening Tool Set (Teal Canvas Bag)", "", "publish", "closed", "open", "", "blooms-5-piece-gardening-tool-set-teal-canvas-bag", "", "", "2014-04-21 06:03:59", "2014-04-21 06:03:59", "", "0", "http://blogsforsales.com/green/blooms-5-piece-gardening-tool-set-teal-canvas-bag/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("33", "1", "2014-04-21 06:03:59", "2014-04-21 06:03:59", "", "41sO2EmIhOL", "", "inherit", "closed", "open", "", "41so2emihol", "", "", "2014-04-21 06:03:59", "2014-04-21 06:03:59", "", "32", "http://blogsforsales.com/green/wp-content/uploads/2014/04/41sO2EmIhOL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("34", "1", "2014-04-21 06:04:00", "2014-04-21 06:04:00", "<p>Enjoy gardening in comfort with the Garden Kneeler and Seat. The ergonomic design prevents sore knees caused by kneeling on the ground and back pain caused by stooping and bending. Kneel in cushioned comfort and protect your clothes from dirt and grass stains. Turn it over to sit at the proper height for gardening and other household chores. Legs lock securely for safety. Ideal for arthritis sufferers. Both sides of the platform have 3/4-inch thick foam for comfort. In the kneeler position, the extended arms make getting up and down easier. When you\'re through with your tasks the Garden Kneeler and Seat folds flat for easy storage. Folds flat to 11- by 24-1/2- by 5-inches. Don\'t suffer for one more minute from unnecessary knee and back pain. Yard Butler guarantees all Yard Butler tools for life against any defects in manufacturing or materials.<br />\n<h3>Product Features</h3>\n<ul>\n<li>Sturdy, lightweight and portable</li>\n<li>Reduces strain and injury to your lower back and knees</li>\n<li>Protects your clothes from dirt and grass stains</li>\n<li>Weighs only 8.5 pounds but easily holds 250 pounds</li>\n<li>Lifetime warranty</li>\n</ul>\n", "Yard Butler GKS-2 Garden Kneeler and Seat", "", "publish", "closed", "open", "", "yard-butler-gks-2-garden-kneeler-and-seat", "", "", "2014-04-21 06:04:00", "2014-04-21 06:04:00", "", "0", "http://blogsforsales.com/green/yard-butler-gks-2-garden-kneeler-and-seat/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("35", "1", "2014-04-21 06:04:00", "2014-04-21 06:04:00", "", "41OKK6YyYVL", "", "inherit", "closed", "open", "", "41okk6yyyvl", "", "", "2014-04-21 06:04:00", "2014-04-21 06:04:00", "", "34", "http://blogsforsales.com/green/wp-content/uploads/2014/04/41OKK6YyYVL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("36", "1", "2014-04-21 06:04:01", "2014-04-21 06:04:01", "<p>This easy-to-use tool provides chemical-free weed removal while reducing hand fatigue. A contoured, Softouch handle offers excellent comfort and control, the unique head shape provides increased leverage to penetrate soil, and the forked tips cut deep to remove the weed by the root. The rust-resistant, one-piece aluminum head will not bend or break. Lifetime warranty.<br />\n<h3>Product Features</h3>\n<ul>\n<li>One piece, high strength cast aluminum alloy</li>\n<li>Softouch cushioned grip</li>\n<li>Will not rust, bend or break</li>\n<li>Forked tip and design curvature allow exposure to weeds in deep soil</li>\n<li>Lifetime warranty</li>\n</ul>\n", "Fiskars Softouch Weeder (7060)", "", "publish", "closed", "open", "", "fiskars-softouch-weeder-7060", "", "", "2014-04-21 06:04:01", "2014-04-21 06:04:01", "", "0", "http://blogsforsales.com/green/fiskars-softouch-weeder-7060/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("37", "1", "2014-04-21 06:04:02", "2014-04-21 06:04:02", "", "21UDpnMYdaL", "", "inherit", "closed", "open", "", "21udpnmydal", "", "", "2014-04-21 06:04:02", "2014-04-21 06:04:02", "", "36", "http://blogsforsales.com/green/wp-content/uploads/2014/04/21UDpnMYdaL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("38", "1", "2014-04-21 06:04:02", "2014-04-21 06:04:02", "<p>Women\'s Garden Gloves - 6-Pair.<br />\n<h3>Product Features</h3>\n<ul>\n<li>One Size Fits Most</li>\n<li>Women\'s Garden Gloves, 6 Pair Pack, assorted colors. Women\'s Medium</li>\n<li>Fits like a second skin</li>\n<li>Includes: pink, purple and green</li>\n</ul>\n", "Women\'s Garden Gloves, 6 Pair Pack, assorted colors. Women\'s Medium", "", "publish", "closed", "open", "", "womens-garden-gloves-6-pair-pack-assorted-colors-womens-medium", "", "", "2014-04-21 06:04:02", "2014-04-21 06:04:02", "", "0", "http://blogsforsales.com/green/womens-garden-gloves-6-pair-pack-assorted-colors-womens-medium/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("39", "1", "2014-04-21 06:04:03", "2014-04-21 06:04:03", "", "41C5FXaBZdL", "", "inherit", "closed", "open", "", "41c5fxabzdl", "", "", "2014-04-21 06:04:03", "2014-04-21 06:04:03", "", "38", "http://blogsforsales.com/green/wp-content/uploads/2014/04/41C5FXaBZdL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("40", "1", "2014-04-21 06:04:04", "2014-04-21 06:04:04", "<p><P>The Little Green Fingers Gardening Set are childrens gardening tools - and makes a great gift idea for your budding little gardener.</P><P>These quality tools are the perfect size for little children\'s hands, and are very solid and durable.</P><P>The Little Green Fingers Gardening Set includes 3 tools; a shovel, trowel, and cultivator, plus a durable gardening bag.</P><P>The dimensions of the tool set are:<br>Shovel: 8\" x 2½\" (20cm x 6¼cm)<br>Trowel: 8½\" x 2½\" (21½cm x 6¼cm)<br>Cultivator: 6\" x 3\" (15½cm x 7½cm)<br>Gardening Bag: 9½\" x 7\" x 6\" (24cm x 18cm x 15cm)</P><P>The metal tool heads are made from A3 carbon steel, which is very wear and corrosion resistant - perfect for garden tools. Many of our Amazon competitors make their tools from low grade metal or plastic - which would never last the heavy rough and tumble treatment of your budding gardener.</P><P>To add durability, we powder coated them for a resilient and protective finish. Powder coating gives excellent chip, scratch, and mark resistance. The result is a durable, high-quality finish - and it\'s why they look so shiny. We considered spray painting them like our competitors, but powder coating is much more environmentally friendly compared to solvent based spray paints, and produces less hazardous by-products during production and through the whole lifecycle of the tools. Powder coated tools can also be easily recycled. Overall, powder coating is a more environmentally sustainable choice.</P><P>The tool handles are made from solid wood, with the tool heads firmly screwed into each handle - so they\'re not going to dislodge easily.</P><P>The gardening bag is made from heavy duty 600D polyester fabric canvas, and is resistant to UV light, stretching, shrinking, and mildew. The bag is machine washable, in either a cold or warm wash. And just hang it up to dry.</P><br />\n<h3>Product Features</h3>\n<ul>\n<li>These real quality gardening tools are the perfect size for little children\'s hands.</li>\n<li>Includes three tools; a shovel, a trowel, and a cultivator, plus a very durable gardening bag.</li>\n<li>Tool heads made from quality powder coated A3 carbon steel which is wear and corrosion resistant.</li>\n<li>The tool handles are made from solid wood, with the tool heads firmly screwed into each handle.</li>\n<li>The gardening tote bag is made from heavy duty 600D polyester fabric canvas.</li>\n</ul>\n", "Kids Garden Tools with Tote Bag - Get Kids Learning About Flowers, Vegetables, and Nature - The Home Garden Tool Tote Kit Includes a Kids Shovel, Kids Trowel, Kids Cultivator, and a Handy Kids Tool Bag - These Are Wonderful Toys for Boys and Toys for Girls, and Are Fantastic Kids Educational Toys and Kids Birthday Gifts - These Kids Toys Are Excellent for Kids Gardening, and Makes Terrific Eco Friendly Gifts for Children", "", "publish", "closed", "open", "", "kids-garden-tools-with-tote-bag-get-kids-learning-about-flowers-vegetables-and-nature-the-home-garden-tool-tote-kit-includes-a-kids-shovel-kids-trowel-kids-cultivator-and-a-handy-kids-tool-ba", "", "", "2014-04-21 06:04:04", "2014-04-21 06:04:04", "", "0", "http://blogsforsales.com/green/kids-garden-tools-with-tote-bag-get-kids-learning-about-flowers-vegetables-and-nature-the-home-garden-tool-tote-kit-includes-a-kids-shovel-kids-trowel-kids-cultivator-and-a-handy-kids-tool-ba/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("41", "1", "2014-04-21 06:04:04", "2014-04-21 06:04:04", "", "51ZDAZTsQ2L", "", "inherit", "closed", "open", "", "51zdaztsq2l", "", "", "2014-04-21 06:04:04", "2014-04-21 06:04:04", "", "40", "http://blogsforsales.com/green/wp-content/uploads/2014/04/51ZDAZTsQ2L.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("42", "1", "2014-04-21 06:04:05", "2014-04-21 06:04:05", "<p>Master gardeners, arborists and avid gardeners alike put pruners to the test and demand features that allow fine tuning after extended use. These cutters deliver, with a replaceable blade, tension control for precise cuts, a sap grove to prevent the blade from sticking, and an ergonomic handle design that\'s comfortable to use.The Fiskars professional bypass pruning shears are an ideal choice for all kinds of pruning tasks. The pruner features adjustable blade tension that gives the user increased control over desired cutting force and precision. The replaceable stainless steel blade can cut branches up to 1 inch in diameter and features an integrated sap groove to keep the cutting action smooth and stick-free all-season long. The bypass blade provides a cleaner cut for living, green growth, and the ambidextrous handle design allows for comfortable left or right-handed use, making it an ideal choice for personal or professional use.<br />\n<h3>Product Features</h3>\n<ul>\n<li>An ideal professional grade tool for all kinds of pruning tasks</li>\n<li>Adjustable blade tension</li>\n<li>Ambidextrous handle design allows for comfortable left or right-handed use</li>\n<li>Integrated sap groove keeps cutting action smooth and stick-free</li>\n<li>1-inch cutting capacity</li>\n</ul>\n", "Fiskars 9124 Professional Bypass Pruning Shears", "", "publish", "closed", "open", "", "fiskars-9124-professional-bypass-pruning-shears", "", "", "2014-04-21 06:04:05", "2014-04-21 06:04:05", "", "0", "http://blogsforsales.com/green/fiskars-9124-professional-bypass-pruning-shears/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("43", "1", "2014-04-21 06:04:05", "2014-04-21 06:04:05", "", "31rLfcABdrL", "", "inherit", "closed", "open", "", "31rlfcabdrl", "", "", "2014-04-21 06:04:05", "2014-04-21 06:04:05", "", "42", "http://blogsforsales.com/green/wp-content/uploads/2014/04/31rLfcABdrL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("44", "1", "2014-04-21 06:05:33", "2014-04-21 06:05:33", "<p>Discover garden tools unlike any you\'ve ever held before. The Radius Garden Natural Radius Grip PRO garden tools were designed using the most current research into human factors and tool usage. Traditional garden tools force you to use your hands and wrists in a way that can cause injuries. These tools maximize your power and comfort while minimizing wrist and hand stress. The large \"O-handle\" grips on Radius tools allow you to hold the tool securely without exerting extra pressure and wasting your energy. The PRO series tools feature four times the gripping surface of conventional tools, with room for both hands! The blades of these tools are made of stainless steel. The advanced ergonomic design makes gardening easier and more enjoyable. Built as professional quality tools, Radius Garden NRG PRO tools come with a lifetime guarantee. The PRO Digging Fork is an ideal tool featuring sturdy, square-shaped \"English-style\" tines that is ideal for turning and cultivating soil as well as for moving mulch, sod, and yard debris. Often used to thin or divide perennials and vegetables. Radius PRO Stainless tools feature a large \"O\" handle and extra-wide raised forward kick for reduced strain, better balance, and ease-of-use. These tools also include a resin-encased steel core shaft, making them virtually unbreakable.<br />\n<h3>Product Features</h3>\n<ul>\n<li>Ergonomic design features a patented, high performance, \"O-Handle\" grip that minimizes hand & wrist stress while maximizing power & comfort to provides a secure grip - wet or dry</li>\n<li>Professional, high quality resin-encased steel shaft with unique stainless steel blade design, offset from shaft for better leverage & comfort</li>\n<li>An ideal tool featuring sturdy, square-shaped \"English-style\" tines that is ideal for turning & cultivating soil, moving mulch, sod, and yard debris, & to thin or divide perennials & vegetables</li>\n<li>Large comfort \"O\'-shaped, non-slip grip handle allows 4 times the gripping surface compared to conventional tools and has plenty of room for both hands</li>\n<li>Less hand stress, fewer blisters, and no splinters</li>\n</ul>\n", "Radius Garden 203 PRO Ergonomic Stainless Steel Digging Fork", "", "publish", "closed", "open", "", "radius-garden-203-pro-ergonomic-stainless-steel-digging-fork", "", "", "2014-04-21 06:05:33", "2014-04-21 06:05:33", "", "0", "http://blogsforsales.com/green/radius-garden-203-pro-ergonomic-stainless-steel-digging-fork/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("45", "1", "2014-04-21 06:05:33", "2014-04-21 06:05:33", "", "21yzuel9G3L", "", "inherit", "closed", "open", "", "21yzuel9g3l", "", "", "2014-04-21 06:05:33", "2014-04-21 06:05:33", "", "44", "http://blogsforsales.com/green/wp-content/uploads/2014/04/21yzuel9G3L.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("46", "1", "2014-04-21 06:06:33", "2014-04-21 06:06:33", "<p>Impress the relatives by referring to it as your Ladies Spade. Ideal for digging over a vegetable border, creating a trench or slicing through turf. Not very lady like when it comes to prying out rocks and smashing large clods because it handles those chores with reckless abandon. The oversized D-Handle provides ample space for both hands and a variety of hand positions. Bigger step for more digging power and a teardrop shaped shaft for more hand comfort. Shovel blade is welded to the shaft for additional strength.  Powder-coated steel prevents rust and is easy to clean.  Lifetime warranty.<br />\n<h3>Product Features</h3>\n<ul>\n<li>All-steel construction for heavy-duty durability</li>\n<li>Oversized step provides a secure and comfortable platform for your foot, allowing you to use your stronger leg muscles</li>\n<li>Pre-sharpened blade cuts through the ground easier</li>\n<li>Teardrop-shaped handle is easier to grip and reduces hand fatigue</li>\n<li>Oversized D-shaped handle fits both hands for added comfort and control</li>\n</ul>\n", "Fiskars 46 Inch Steel D-handle Square Garden Spade (9667)", "", "publish", "closed", "open", "", "fiskars-46-inch-steel-d-handle-square-garden-spade-9667", "", "", "2014-04-21 06:06:33", "2014-04-21 06:06:33", "", "0", "http://blogsforsales.com/green/fiskars-46-inch-steel-d-handle-square-garden-spade-9667/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("47", "1", "2014-04-21 06:06:33", "2014-04-21 06:06:33", "", "21kBBt9b7OL", "", "inherit", "closed", "open", "", "21kbbt9b7ol", "", "", "2014-04-21 06:06:33", "2014-04-21 06:06:33", "", "46", "http://blogsforsales.com/green/wp-content/uploads/2014/04/21kBBt9b7OL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("48", "1", "2014-04-21 06:06:34", "2014-04-21 06:06:34", "<p>Ames 1564600 true american d shaped wood handle garden spade<br />\n<h3>Product Features</h3>\n<ul>\n<li>Garden spade</li>\n<li>D shaped</li>\n<li>Steel is 100-percent formed, shaped, and tempered in the USA</li>\n<li>Strong, durable northern ash wood handles are verified sustainable</li>\n<li>Red poly d grips</li>\n</ul>\n", "True Temper 1564600 True American D Shaped Wood Handle Garden Spade", "", "publish", "closed", "open", "", "true-temper-1564600-true-american-d-shaped-wood-handle-garden-spade", "", "", "2014-04-21 06:06:34", "2014-04-21 06:06:34", "", "0", "http://blogsforsales.com/green/true-temper-1564600-true-american-d-shaped-wood-handle-garden-spade/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("49", "1", "2014-04-21 06:06:34", "2014-04-21 06:06:34", "", "21S208a1vfL", "", "inherit", "closed", "open", "", "21s208a1vfl", "", "", "2014-04-21 06:06:34", "2014-04-21 06:06:34", "", "48", "http://blogsforsales.com/green/wp-content/uploads/2014/04/21S208a1vfL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("50", "1", "2014-04-21 06:06:35", "2014-04-21 06:06:35", "<p>It\'s all about precision and comfort. The tall, pre-sharpened, curved blade quickly produces small deep holes for setting out plants or digging up bulbs. It scoops dirt like a champ. The oversized D-Handle provides ample space for both hands and a variety of hand positions. Shovel blade is welded to the shaft for additional strength.  Powder coated steel prevents rust and is easy to clean. Teardrop shaped shaft for more hand comfort. Lifetime warranty.The Fiskars transplanting spade features all-steel construction for heavy-duty strength and durability. The blade features an oversized step for additional leverage and comfort, and is pre-sharpened to cut through the ground easier. The teardrop-shaped shaft and oversized D-handle provide ergonomic comfort and control during use. For added strength, the blade itself is directly welded onto the shaft, and the entire shovel is powder-coated to prevent rust and clean up easily. The low-profile spade head is perfect for digging planting holes or other precise tasks.<br />\n<h3>Product Features</h3>\n<ul>\n<li>All-steel construction for heavy-duty durability</li>\n<li>Oversized step provides a secure and comfortable platform for your foot, allowing you to use your stronger leg muscles</li>\n<li>Pre-sharpened blade cuts through the ground easier</li>\n<li>Teardrop-shaped handle is easier to grip and reduces hand fatigue</li>\n<li>Oversized D-shaped handle fits both hands for added comfort and control</li>\n</ul>\n", "Fiskars 46 Inch Steel D-handle Transplanting Spade (9654)", "", "publish", "closed", "open", "", "fiskars-46-inch-steel-d-handle-transplanting-spade-9654", "", "", "2014-04-21 06:06:35", "2014-04-21 06:06:35", "", "0", "http://blogsforsales.com/green/fiskars-46-inch-steel-d-handle-transplanting-spade-9654/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("51", "1", "2014-04-21 06:06:35", "2014-04-21 06:06:35", "", "210RX3KA7GL", "", "inherit", "closed", "open", "", "210rx3ka7gl", "", "", "2014-04-21 06:06:35", "2014-04-21 06:06:35", "", "50", "http://blogsforsales.com/green/wp-content/uploads/2014/04/210RX3KA7GL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("52", "1", "2014-04-21 06:06:36", "2014-04-21 06:06:36", "<p>027-1554300 Features: -Steel collar for added strength at the handle/socket connection.- wood handle. Blade No.: #2.-Blade Material: Steel.-Price is for 1 Each.<br />\n<h3>Product Features</h3>\n<ul>\n<li>47-Inch Wood Handle</li>\n<li>10 Year Warranty</li>\n</ul>\n", "Eagle 1554300  Round Point Shovel with 47-Inch Wood Handle", "", "publish", "closed", "open", "", "eagle-1554300-round-point-shovel-with-47-inch-wood-handle", "", "", "2014-04-21 06:06:36", "2014-04-21 06:06:36", "", "0", "http://blogsforsales.com/green/eagle-1554300-round-point-shovel-with-47-inch-wood-handle/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("53", "1", "2014-04-21 06:06:36", "2014-04-21 06:06:36", "", "21K9N12z-IL", "", "inherit", "closed", "open", "", "21k9n12z-il", "", "", "2014-04-21 06:06:36", "2014-04-21 06:06:36", "", "52", "http://blogsforsales.com/green/wp-content/uploads/2014/04/21K9N12z-IL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("54", "1", "2014-04-21 06:06:37", "2014-04-21 06:06:37", "<p>The All Steel Spade Beats all Competition. Bully Tools 92601 - 15-inch All Steel Spade - Pro Garden Spade, Steel D-Grip, 12-Gauge Steel with Closed Back Blade: 7-1/4 by 15-inch. Handle Length 27-inch and tool length 42-inch. This tool has a 7-year no break guarantee made from aircraft quality steel. Thick 12-gauge steel heads with all steel construction handles, grips and blades. 100-Percent American Made.<br />\n<h3>Product Features</h3>\n<ul>\n<li>Thick 12-gauge steel heads</li>\n<li>All steel construction handles, grips and blades</li>\n<li>7-year no break guarantee</li>\n<li>100-Percent American Made</li>\n</ul>\n", "Bully Tools 92601 15-Inch All Steel Spade Garden Spade, Steel D-Grip", "", "publish", "closed", "open", "", "bully-tools-92601-15-inch-all-steel-spade-garden-spade-steel-d-grip", "", "", "2014-04-21 06:06:37", "2014-04-21 06:06:37", "", "0", "http://blogsforsales.com/green/bully-tools-92601-15-inch-all-steel-spade-garden-spade-steel-d-grip/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("55", "1", "2014-04-21 06:06:37", "2014-04-21 06:06:37", "", "31N8A64jRLL", "", "inherit", "closed", "open", "", "31n8a64jrll", "", "", "2014-04-21 06:06:37", "2014-04-21 06:06:37", "", "54", "http://blogsforsales.com/green/wp-content/uploads/2014/04/31N8A64jRLL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("56", "1", "2014-04-21 06:07:31", "2014-04-21 06:07:31", "<p>Truper 30293, BJ-4E, Tru Tough Spading Fork, 4-Tine, D-Handle, 30-Inch. 30-inch North American Ash, lacquered handle with D-grip for balance and control. 4 tine d handle spading fork. Clear-coated gray-steel finished heads. Spray clean with garden hose, coat with silicone spray. Tru-Tough: Trupers Best Selling Signature Tool Line.. Truper has been in the hand tool manufacturing business for over 40-year and is by far the largest Mexican company in its field. Truper relies on the most advanced modern and efficient technology to guarantee the optimum quality and value of its products and demanding service needs of the company\'s global customers. Tru Tough provides everything a dedicated handyman expects from a serious, long-lasting tool at an unbeatable price. Tru-tough has long been Trupers best selling products. The visual appeal is highlighted by clear-coated gray-steel finished heads, steel collars, lacquered ash handles and heavy duty D-grips. A 10-year free-replacement warranty backs all Tru-tough tools.<br />\n<h3>Product Features</h3>\n<ul>\n<li>BJ-4E, 30-inch North American ash, lacquered handle with d-grip for balance and control</li>\n<li>4 Tined handle spading fork</li>\n<li>Clear-coated gray-steel finished heads</li>\n<li>Spray clean with garden hose, coat with silicone spray</li>\n<li>Truper 30293, tru-tough: trupers best selling signature tool line</li>\n</ul>\n", "Truper 30293 Tru Tough Spading Fork, 4-Tine, D-Handle, 30-Inch", "", "publish", "closed", "open", "", "truper-30293-tru-tough-spading-fork-4-tine-d-handle-30-inch", "", "", "2014-04-21 06:07:31", "2014-04-21 06:07:31", "", "0", "http://blogsforsales.com/green/truper-30293-tru-tough-spading-fork-4-tine-d-handle-30-inch/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("57", "1", "2014-04-21 06:07:31", "2014-04-21 06:07:31", "", "31t2u3LuTLL", "", "inherit", "closed", "open", "", "31t2u3lutll", "", "", "2014-04-21 06:07:31", "2014-04-21 06:07:31", "", "56", "http://blogsforsales.com/green/wp-content/uploads/2014/04/31t2u3LuTLL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("58", "1", "2014-04-21 06:07:32", "2014-04-21 06:07:32", "<p>Flex rake introduces Classic - a full line of essential tools reminiscent of gardening\'s glorious tradition. Modeled after hard-to-find antiques from a time when tools were painstakingly crafted by hand. Classic features quality craftsmanship and details like beautiful oak handles and durable carbon steel blades. Since the 1600\'s, the most essential of garden tools have remained basically the same, Classic has a complete offering of these traditional tools with handcrafted quality for years of gardening success. This Classic series tough grade hand fork is made with a durable carbon steel blade and a beautiful oak handle. Classic by Flex rake. Garden Tools rooted in tradition.<br />\n<h3>Product Features</h3>\n<ul>\n<li>Heavy grade steel</li>\n<li>Oak hand turned handles</li>\n<li>Nostalgic craftsmanship</li>\n<li>Leather hanger</li>\n<li>Will not bend</li>\n</ul>\n", "Flexrake CLA324 Classic Hand Fork", "", "publish", "closed", "open", "", "flexrake-cla324-classic-hand-fork", "", "", "2014-04-21 06:07:32", "2014-04-21 06:07:32", "", "0", "http://blogsforsales.com/green/flexrake-cla324-classic-hand-fork/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("59", "1", "2014-04-21 06:07:33", "2014-04-21 06:07:33", "", "31NsZJtThbL", "", "inherit", "closed", "open", "", "31nszjtthbl", "", "", "2014-04-21 06:07:33", "2014-04-21 06:07:33", "", "58", "http://blogsforsales.com/green/wp-content/uploads/2014/04/31NsZJtThbL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("60", "1", "2014-04-21 06:07:34", "2014-04-21 06:07:34", "<p>The Fiskars steel D-handle ergo garden fork offers an ergonomic design that makes mixing, turning, loosening and lifting loose materials like soil, compost or mulch easier than ever. The welded steel construction is far more durable than wood and won\'t flex like fiberglass. An angled D-handle keeps your wrist in a neutral position to reduce strain and sharpened tines make penetrating hardened soil easy. A mid grip and teardrop-shaped shaft profile provide exceptional comfort and control. Lifetime warranty.<br />\n<h3>Product Features</h3>\n<ul>\n<li>Ideal for scooping and carrying mulch, wood chips, fertilizer, compost, soil, gravel, decorative landscaping stones and anything spread in your garden</li>\n<li>Welded steel head and 17-gauge steel shaft provide durability that far outlasts wood-handled tools and won\'t flex like fiberglass</li>\n<li>Angled D-handle keeps your wrist in a neutral position to reduce strain and provides a secure grip</li>\n<li>Mid grip and teardrop-shaped shaft profile fit the natural shape and motion of your hand for exceptional comfort and control</li>\n<li>Lifetime warranty</li>\n</ul>\n", "Fiskars 47 Inch Steel D-Handle Ergo Garden Fork (333400-1001)", "", "publish", "closed", "open", "", "fiskars-47-inch-steel-d-handle-ergo-garden-fork-333400-1001", "", "", "2014-04-21 06:07:34", "2014-04-21 06:07:34", "", "0", "http://blogsforsales.com/green/fiskars-47-inch-steel-d-handle-ergo-garden-fork-333400-1001/", "0", "post", "", "1");
INSERT INTO `wp_posts` VALUES("61", "1", "2014-04-21 06:07:34", "2014-04-21 06:07:34", "", "21Hos-OaWpL", "", "inherit", "closed", "open", "", "21hos-oawpl", "", "", "2014-04-21 06:07:34", "2014-04-21 06:07:34", "", "60", "http://blogsforsales.com/green/wp-content/uploads/2014/04/21Hos-OaWpL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("62", "1", "2014-04-21 06:07:35", "2014-04-21 06:07:35", "<h3>Product Features</h3>\n<ul>\n<li>Digging fork</li>\n<li>Handcrafted red oak wooden handle</li>\n<li>Stainless steel alloy blade - highly polished</li>\n<li>Rugged design</li>\n<li>Lifetime warranty</li>\n</ul>\n", "Brook & Hunter 11020DY Premium Digging Fork with a Handcrafted Red Oak Handle and a Stainless Steel Alloy Polished Blade, 43-Inch long", "", "publish", "closed", "open", "", "brook-hunter-11020dy-premium-digging-fork-with-a-handcrafted-red-oak-handle-and-a-stainless-steel-alloy-polished-blade-43-inch-long", "", "", "2014-04-21 06:07:35", "2014-04-21 06:07:35", "", "0", "http://blogsforsales.com/green/brook-hunter-11020dy-premium-digging-fork-with-a-handcrafted-red-oak-handle-and-a-stainless-steel-alloy-polished-blade-43-inch-long/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("63", "1", "2014-04-21 06:07:35", "2014-04-21 06:07:35", "", "21tZwrW25jL", "", "inherit", "closed", "open", "", "21tzwrw25jl", "", "", "2014-04-21 06:07:35", "2014-04-21 06:07:35", "", "62", "http://blogsforsales.com/green/wp-content/uploads/2014/04/21tZwrW25jL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("64", "1", "2014-04-21 06:07:36", "2014-04-21 06:07:36", "<p>Our garden tiller is a twist tiller. Extra long handles reduce the effort of twisting. Does a better job with only a fraction of the effort of older designs. Garden tillers utilizing claws twisted into the ground are a great idea! The sharp, angled claws dig into the ground to break up the hard, packed soil. Like all Yard Butler tools the versatile Twist Tiller has solid steel construction. Yard Butler guarantees all Yard Butler tools for life against any defects in manufacturing or materials.<br />\n<h3>Product Features</h3>\n<ul>\n<li>Step on the plate and the force of your body weight starts the claws into the ground</li>\n<li>Extra long handles reduce the effort of twisting</li>\n<li>Does a better job with only a fraction of the effort of older designs</li>\n<li>Cultivate around shrubs, bushes and other hard to reach areas</li>\n<li>Lifetime warranty</li>\n</ul>\n", "Yard Butler TNT-4 Garden Twist and Tiller", "", "publish", "closed", "open", "", "yard-butler-tnt-4-garden-twist-and-tiller", "", "", "2014-04-21 06:07:36", "2014-04-21 06:07:36", "", "0", "http://blogsforsales.com/green/yard-butler-tnt-4-garden-twist-and-tiller/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("65", "1", "2014-04-21 06:07:36", "2014-04-21 06:07:36", "", "31TqyQkGfjL", "", "inherit", "closed", "open", "", "31tqyqkgfjl", "", "", "2014-04-21 06:07:36", "2014-04-21 06:07:36", "", "64", "http://blogsforsales.com/green/wp-content/uploads/2014/04/31TqyQkGfjL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("66", "1", "2014-04-21 06:08:18", "2014-04-21 06:08:18", "<p>Tight-Lock flips up to extend tool and flips down to securely lock handles at desired length. Power-Lever mechanism increases leverage to make cutting 2X easier than single-pivot shears. Gator-Blade serrated blades grip and hold branches for a clean cut. Fully hardened steel blades hold sharp edge longer. Cushioned grips and shock-absorbing bumper for comfort. Durable steel handles. Cutting length 8.5 inches.<br />\n<h3>Product Features</h3>\n<ul>\n<li>Power Lever technology increases your cutting power</li>\n<li>Telescoping handles extend from 24-3/8-Inch to 31-1/8-Inch</li>\n<li>Soft grips for comfort</li>\n<li>Patented serrated blade design self sharpens during use</li>\n<li>10-inch blade length</li>\n</ul>\n", "Fiskars 25-33 Inch Power-Lever Extendable Hedge Shear (9169)", "", "publish", "closed", "open", "", "fiskars-25-33-inch-power-lever-extendable-hedge-shear-9169", "", "", "2014-04-21 06:08:18", "2014-04-21 06:08:18", "", "0", "http://blogsforsales.com/green/fiskars-25-33-inch-power-lever-extendable-hedge-shear-9169/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("67", "1", "2014-04-21 06:08:18", "2014-04-21 06:08:18", "", "31nsJs-fLcL", "", "inherit", "closed", "open", "", "31nsjs-flcl", "", "", "2014-04-21 06:08:18", "2014-04-21 06:08:18", "", "66", "http://blogsforsales.com/green/wp-content/uploads/2014/04/31nsJs-fLcL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("68", "1", "2014-04-21 06:08:19", "2014-04-21 06:08:19", "<p>Green and Black cusioned rubber handle. The last pair of pruning shears you will need to buy. The Dirty Gardener staff was tired of buying weak, flimsy pruners only to dull too fast, break, loosen or rust. We created these simple, versatile pruning shears to manage multiple jobs for the rest of your life! Made from drop forged carbon stainless steel with rich colored coating. The handles are just right for both large and small hands with their sleek curved inset. Should you have any problems 5 years down the road please give us a call and we will send you a new one, no questions asked!<br />\n<h3>Product Features</h3>\n<ul>\n<li>Drop forge carbon Steel construction. High Quality.</li>\n<li>Lifetime warranty from the Dirty Gardener.</li>\n<li>1\"-1 1/4\" cut capacity. 8.5\" length.</li>\n<li>Spring loaded Stowage clip</li>\n<li>Solid weighted feel of Quality construction</li>\n</ul>\n", "Professional Garden Shear- 8.5\" Lifetime Warranty From the Dirty Gardener", "", "publish", "closed", "open", "", "professional-garden-shear-8-5-lifetime-warranty-from-the-dirty-gardener", "", "", "2014-04-21 06:08:19", "2014-04-21 06:08:19", "", "0", "http://blogsforsales.com/green/professional-garden-shear-8-5-lifetime-warranty-from-the-dirty-gardener/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("69", "1", "2014-04-21 06:08:19", "2014-04-21 06:08:19", "", "318g6I6aA3L", "", "inherit", "closed", "open", "", "318g6i6aa3l", "", "", "2014-04-21 06:08:19", "2014-04-21 06:08:19", "", "68", "http://blogsforsales.com/green/wp-content/uploads/2014/04/318g6I6aA3L.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("70", "1", "2014-04-21 06:08:20", "2014-04-21 06:08:20", "<p>Serrated edge grips and holds while cutting. Stainless-steel blades resist rust, and ergonomic handles offer comfortable use.The Fiskars garden shears feature tough and durable, precision-ground stainless-steel blades. The unit\'s patented curved blade design grips as it cuts, and the blade is also notched for cutting stems, narrow wire, and cords. Additionally, the shears come with Fiskars\'s patented ergo-dynamic handle design for added comfort, making the shears an ideal choice for all-day professional or personal use. This tool comes with a limited lifetime warranty.<br />\n<h3>Product Features</h3>\n<ul>\n<li>Ideal for garden and flower pruning</li>\n<li>Precision-ground, stainless-steel blades</li>\n<li>Patented curved blade design grips as it cuts</li>\n<li>Comfort molded handles</li>\n<li>Lifetime warranty</li>\n</ul>\n", "Fiskars 8 Inch Garden Shears (9637)", "", "publish", "closed", "open", "", "fiskars-8-inch-garden-shears-9637", "", "", "2014-04-21 06:08:20", "2014-04-21 06:08:20", "", "0", "http://blogsforsales.com/green/fiskars-8-inch-garden-shears-9637/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("71", "1", "2014-04-21 06:08:20", "2014-04-21 06:08:20", "", "31he0dfG1uL", "", "inherit", "closed", "open", "", "31he0dfg1ul", "", "", "2014-04-21 06:08:20", "2014-04-21 06:08:20", "", "70", "http://blogsforsales.com/green/wp-content/uploads/2014/04/31he0dfG1uL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("72", "1", "2014-04-21 06:08:21", "2014-04-21 06:08:21", "<p>Makes quick, precise cuts effortlessly</p>\n<p>   <img src=\"https://images-na.ssl-images-amazon.com/images/G/01/outdoor-living/detailpages/fiskars/9921_P2_HR_sized.jpg\" width=\"304\" height=\"219\" alt=\"Micro-Tip snip\" />\n<p>View larger.</p>\n<p>Fiskars\' Softouch micro-tip pruning snip makes deadheading, trimming and shaping plants easy — so easy, it\'s earned the Arthritis Foundation Ease-of-Use Commendation. An easy-action design opens the blades after each cut to reduce hand strain, and the high-grade, stainless-steel blades feature a precision-ground edge that stays sharp longer and cuts all the way to the tip for clean, healthy cuts on living plants. Fiskars\' Softouch micro-tip pruning snip also includes a contoured soft-grip handle for a more comfortable grip. This tool is covered by a lifetime warranty. </p>\n<p>  Ideal for deadheading, trimming, shaping and other quick snips on small plants Awarded the Arthritis Foundation Ease-of-Use Commendation for a design that is easy-to-use for people with arthritis or limited hand strength Easy-action spring-action design gently opens blades after each cut to reduce hand strain High-grade, precision-ground, stainless-steel blades offer a lasting sharp edge that cuts all the way to the tip Symmetrical soft-grip handle offers added comfort and accommodates right- and left-handed users    <img src=\"https://images-na.ssl-images-amazon.com/images/G/01/outdoor-living/detailpages/fiskars/9921_Spring_sized.jpg\" width=\"232\" height=\"187\" alt=\"spring\" />\n<p>Easy Action spring-action design gently opens blades after each cut to reduce hand strain.  View larger.</p>\n<p>    <img src=\"https://images-na.ssl-images-amazon.com/images/G/01/outdoor-living/detailpages/fiskars/9921_sized._V160793082_.jpg\" width=\"360\" height=\"125\" alt=\"Handle\" />   Symmetrical Softgrip handle offers added comfort and accommodates right- and left-handed users. View larger.     <img src=\"https://images-na.ssl-images-amazon.com/images/G/01/outdoor-living/detailpages/fiskars/9921_P2_BLADE_sized.jpg\" width=\"260\" height=\"193\" alt=\"blades\" />\n<p align=\"left\">High-grade, precision-ground, stainlesssteel blades View larger.</p>\n<h3>Product Features</h3>\n<ul>\n<li>Fiskars pruning snip is ideal for the precision trimming and shaping of flowers and small plants</li>\n<li>Pruning snip has a 1-1/2-inch rust-resistant stainless steel blade</li>\n<li>The 4-inch softouch ergonomic handle fits well in small to medium sized hands</li>\n<li>Use for flower and herb gardening, bonsai, houseplant maintenance, and floral arranging</li>\n<li>Lifetime warranty</li>\n</ul>\n", "Fiskars 9921 Softouch Micro-Tip Pruning Snip", "", "publish", "closed", "open", "", "fiskars-9921-softouch-micro-tip-pruning-snip", "", "", "2014-04-21 06:08:21", "2014-04-21 06:08:21", "", "0", "http://blogsforsales.com/green/fiskars-9921-softouch-micro-tip-pruning-snip/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("73", "1", "2014-04-21 06:08:21", "2014-04-21 06:08:21", "", "31+aYCThskL", "", "inherit", "closed", "open", "", "31aycthskl", "", "", "2014-04-21 06:08:21", "2014-04-21 06:08:21", "", "72", "http://blogsforsales.com/green/wp-content/uploads/2014/04/31+aYCThskL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("74", "1", "2014-04-21 06:08:22", "2014-04-21 06:08:22", "<p>Power-Lever mechanism increases leverage to make cutting 2X easier than single-pivot pruners. All-steel construction offers traditional style. Corrosion-resistant, non-stick blade coating reduces friction to make cutting easier. Non-slip grips offer comfort. For right- or left-handed use. 5/8\" cutting capacity.<br />\n<h3>Product Features</h3>\n<ul>\n<li>Rugged all-steel anvil pruner featuring Fiskars Power-Lever technology that makes cutting up 2X easier than single pivot pruners</li>\n<li>5/8-inch cutting capacity</li>\n<li>Ideal for cutting dry or dead growth, the fully hardened anvil blade holds its sharp edge longer</li>\n<li>Corrosion-resistant, non-stick blade coating reduces friction</li>\n<li>Fatigue-reducing comfort grips for no-slip, blister-free functionality</li>\n</ul>\n", "Fiskars 9110 Traditional Power-Lever Anvil Pruner", "", "publish", "closed", "open", "", "fiskars-9110-traditional-power-lever-anvil-pruner", "", "", "2014-04-21 06:08:22", "2014-04-21 06:08:22", "", "0", "http://blogsforsales.com/green/fiskars-9110-traditional-power-lever-anvil-pruner/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("75", "1", "2014-04-21 06:08:22", "2014-04-21 06:08:22", "", "31NvTmqXL3L", "", "inherit", "closed", "open", "", "31nvtmqxl3l", "", "", "2014-04-21 06:08:22", "2014-04-21 06:08:22", "", "74", "http://blogsforsales.com/green/wp-content/uploads/2014/04/31NvTmqXL3L.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("76", "1", "2014-04-21 06:08:23", "2014-04-21 06:08:23", "<p>\"CORONA\" HEDGE SHEAR</p>\n<p>10\" blade<br />\nLightweight steel handles with comfort grips<br />\nHigh carbon steel blades for durability and strength<br />\nShock stop bumper reduces arm and shoulder fatigue<br />\nPrecision made pivot bolt provides smooth cutting action<br />\nExtendable head shear design for long reach areas.<br />\n<h3>Product Features</h3>\n<ul>\n<li>Lightweight steel handles with comfort grips extend from 15-Inch to 26\"</li>\n<li>8.5\" forged high carbon steel blades for durability and strength</li>\n<li>ShockStop bumper reduces and arm and shoulder fatigue</li>\n<li>Precision made pivot bolt provides smooth cutting action</li>\n<li>Limited lifetime warranty</li>\n</ul>\n", "Corona HS 3950  Hedge Shear with Extendable Steel Handles, 10\" Blade", "", "publish", "closed", "open", "", "corona-hs-3950-hedge-shear-with-extendable-steel-handles-10-blade", "", "", "2014-04-21 06:08:23", "2014-04-21 06:08:23", "", "0", "http://blogsforsales.com/green/corona-hs-3950-hedge-shear-with-extendable-steel-handles-10-blade/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("77", "1", "2014-04-21 06:08:23", "2014-04-21 06:08:23", "", "31CWXX6jnLL", "", "inherit", "closed", "open", "", "31cwxx6jnll", "", "", "2014-04-21 06:08:23", "2014-04-21 06:08:23", "", "76", "http://blogsforsales.com/green/wp-content/uploads/2014/04/31CWXX6jnLL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("78", "1", "2014-04-21 06:08:24", "2014-04-21 06:08:24", "<p>32 inches of pure lopper goodness. This superior grade tool is lighter, stronger and more powerful than anything you\'ve ever used. A unique gearing mechanism multiples the cutting force by nearly three times over single pivot loppers and the smooth action eliminates the jarring conclusion at the end of cuts. Razor-sharp, precision ground blades. Bypass blade design for cutting living growth. 2 inch cutting capacity.\n<p>Fiskars PowerGear Bypass Lopper offers 32 inches of pure lopper goodness. This superior-grade tool is lighter, stronger, and more powerful than anything you\'ve ever used. A unique gearing mechanism multiplies the cutting force by nearly three times over single pivot loppers and the smooth action eliminates the jarring conclusion at the end of cuts. Includes razor-sharp, precision-ground blades. The bypass-blade design provides for cutting living growth and has a 2-inch cutting capacity.</p>\n<p>  <img src=\"http://g-ecx.images-amazon.com/images/G/01/outdoor-living/detailpages/Gears-sm.jpg\" width=\"165\" height=\"165\" alt=\"XT722FE folding\" /> PowerGear mechanism inceases <br> leverage (see larger image).   <img src=\"http://g-ecx.images-amazon.com/images/G/01/outdoor-living/detailpages/Lifestyle-sm.jpg\" width=\"165\" height=\"165\" alt=\"XT722FE folding\" /> Capable of cutting through 2-inch thick <br> branches (see larger image).<br />\n<h4>Cutting-Edge Design</h4>\n<p>When pruning, the weight of the tool and the position of the hand and fingers can cause tension and stress, resulting in muscle and joint strain. When ergonomics are given prime importance in design, the result is products that require less muscle power and reduce joint strain.</p>\n<p>The goal of the Fiskars\' design team was to increase power, reduce effort and minimize weight – in short, to make pruning easier. The solution was a totally new gear mechanism that provides maximum leverage near the middle of the cut, when resistance is the greatest. That means a more compact tool can cut with a fraction of the effort required by larger single-pivot tools. </p>\n<p>The use of reinforced fiberglass composite materials (FiberComp) allowed for lighter handles to further reduce strain and fatigue while maintaining strength and durability.</p>\n<h4>Key Features</h4>\n<p>  PowerGear mechanism increases leverage to make cutting easier than single pivot loppers Sharp, precision-ground blade edge Fully hardened blade holds sharp edge longer Corrosion-resistant, non-stick blade coating reduces friction to make cutting easier Durable and lightweight aluminum handles Ergonomic handles fit comfortably in your hands Bypass blade for clean cuts of green, living growth Cutting capacity - 2 inch Lifetime warranty<br />\n<h3>Product Features</h3>\n<ul>\n<li>The PowerGear 32-inch bypass lopper is an ideal tool for cutting large vines and branches</li>\n<li>The lopper\'s patented, dual-hinge gear system increases cutting power</li>\n<li>Precision-ground, easily replaceable blade</li>\n<li>Large, 2-inch cutting capacity</li>\n<li>Lifetime warranty</li>\n</ul>\n", "Fiskars 32 Inch PowerGear Bypass Lopper (9154)", "", "publish", "closed", "open", "", "fiskars-32-inch-powergear-bypass-lopper-9154", "", "", "2014-04-21 06:08:24", "2014-04-21 06:08:24", "", "0", "http://blogsforsales.com/green/fiskars-32-inch-powergear-bypass-lopper-9154/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("79", "1", "2014-04-21 06:08:24", "2014-04-21 06:08:24", "", "41GOoxRKlHL", "", "inherit", "closed", "open", "", "41gooxrklhl", "", "", "2014-04-21 06:08:24", "2014-04-21 06:08:24", "", "78", "http://blogsforsales.com/green/wp-content/uploads/2014/04/41GOoxRKlHL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("80", "1", "2014-04-21 06:09:21", "2014-04-21 06:09:21", "<p>Rapidly increasing in popularity, square foot gardening is the most practical, foolproof way to grow a home garden. That explains why author and gardening innovator Mel Bartholomew has sold more than two million books describing how to become a successful DIY square foot gardener. Now, with the publication of All New Square Foot Gardening, Second Edition, the essential guide to his unique step-by-step method has become even better. Mel developed his techniques back in the early 1980s and has been teaching them throughout the world ever since. In the process, he has made improvements and refinements and continually adapted his practices to keep pace with modern times. In this new volume, Bartholomew furthers his discussion on one of the most popular gardening trends today: vertical gardening. He also explains how you can make gardening fun for kids by teaching them the square foot method. Finally, an expanded section on pest control helps you protect your precious produce. Rich with new full-color images and updated tips for selecting materials, this beautiful new edition is perfect for brand-new gardeners as well as the millions of square foot gardeners who are already dedicated to Mel’s industry-changing insights.</p>\n<p> <img alt=\" \" src=\"http://ecx.images-amazon.com/images/I/318iuKB4gfL.jpg\"  >The key to success of the All New Square Foot Gardening method is to avoid the poor qualities of loc <img alt=\" \" src=\"http://ecx.images-amazon.com/images/I/31I-OlkgPkL.jpg\"  >Once you build the basic 4 x 4 SFG box with rotated corners, add six inches of Mel’s Mix, and add th All New Square Foot Gardening offers ten new major improvements to the original SFG method. Now, with these improvements, anyone can be a successful gardener.\n<p>TEN MAJOR IMPROVEMENTS TO THE ORIGINAL SQUARE FOOT GARDEN METHOD 1. Location—Close to the House 2. Direction—Up, Not Down 3. Soil—Mel’s Mix 4. Box Depth—Only 6 Inches Deep 5. No Fertilizer—You Don’t Need It 6. Easy Access—Above the Ground 7. The Aisles—Comfortable Width 8. The Grids—Prominent and Permanent 9. Novel Idea—Don’t Waste Seeds 10. Expanded Opportunities—Tabletop Gardens</p>\n<p>Yes, it’s true; this improved gardening method makes gardening even easier than before. You’re going to love every one of these improvements. You will now be able to reduce the size of your SFG so much that you can locate it close to your house for better care and more enjoyment. You’ll never have to dig up your existing soil anymore as you now build your new garden on top of it. No more hard work or heavy-duty tools needed. All you’ll need is 6 inches of a perfect soil mix from three common ingredients available everywhere.  This mix never needs changing and no fertilizer is ever needed using this natural, organic method. You’ll use bottomless boxes made from common lumber, have aisles that are wide enough to comfortably move about in, and each box will have a permanent grid for that unique SFG look and use. You’ll use a minimum of seeds, so you won’t have to buy new packets every year. Best of all, some of your boxes can have bottoms so you can move them or place them at tabletop or railing heights for easier care and unique locations.</p>\n<p>       <br>   </p>\n", "All New Square Foot Gardening, Second Edition: The Revolutionary Way to Grow More In Less Space", "", "publish", "closed", "open", "", "all-new-square-foot-gardening-second-edition-the-revolutionary-way-to-grow-more-in-less-space", "", "", "2014-04-21 06:09:21", "2014-04-21 06:09:21", "", "0", "http://blogsforsales.com/green/all-new-square-foot-gardening-second-edition-the-revolutionary-way-to-grow-more-in-less-space/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("81", "1", "2014-04-21 06:09:21", "2014-04-21 06:09:21", "", "61yie+gt2ZL", "", "inherit", "closed", "open", "", "61yiegt2zl", "", "", "2014-04-21 06:09:21", "2014-04-21 06:09:21", "", "80", "http://blogsforsales.com/green/wp-content/uploads/2014/04/61yie+gt2ZL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("82", "1", "2014-04-21 06:09:23", "2014-04-21 06:09:23", "<p>The invaluable resource for home food gardeners! Ed Smith\'s W-O-R-D system has helped countless gardeners grow an abundance of vegetables and herbs. And those tomatoes and zucchini and basil and cucumbers have nourished countless families, neighbors, and friends with delicious, fresh produce. The Vegetable Gardener\'s Bible is essential reading for locavores in every corner of North America!</p>\n<p>Everything you loved about the first edition of The Vegetable Gardener\'s Bible is still here: friendly, accessible language; full-color photography; comprehensive vegetable specific information in the A-to-Z section; ahead-of-its-time commitment to organic methods; and much more.</p>\n<p>Now, Ed Smith is back with a 10th Anniversary Edition for the next generation of vegetable gardeners. New to this edition is coverage of 15 additional vegetables, including an expanded section on salad greens and more European and Asian vegetables. Readers will also find growing information on more fruits and herbs, new cultivar photographs in many vegetable entries, and a much-requested section on extending the season into the winter months. No matter how cold the climate, growers can bring herbs indoors and keep hardy greens alive in cold frames or hoop houses.<br /> \n<p>The impulse to grow vegetables is even stronger in 2009 than it was in 2000, when Storey published The Vegetable Gardener’s Bible. The financial and environmental costs of fossil fuels raise urgent questions: How far should we be shipping food? What are the health costs of petroleum-based pesticides and herbicides? Do we have to rely on megafarms that use gasoline-powered machinery to grow and harvest crops? With every difficult question, more people think, \"Maybe I should grow a few vegetables of my own.\" This book will continue to answer all their vegetable gardening questions.</p>\n<p>Praise for the First Edition:<br />\"In every small town, there is a vegetable garden that people go out of the way to walk past. Smith is the guy who grew that garden.\" — Verlyn Klinkenborg, The New York Times Book Review</p>\n<p>\"An abundance of photographs . . . visually bolster the techniques described, while frequent subheads, sidebars, and information-packed photo captions make the layout user-friendly . . . [Smith\'s] book is thorough and infused with practical wisdom and a dry Vermont humor that should endear him to readers.\" — Publisher’s Weekly</p>\n<p>\"Smith . . . clearly explains everything novice and experienced gardeners need to know to grow vegetables and herbs. . . . \" — Library Journal</p>\n<p>\"this book will answer all your questions as well as put you on the path to an abundant harvest. As a bonus, anecdotes and stories make this informative book fun to read.\" - New York Newsday</p>\n<h3>Product Features</h3>\n<ul>\n<li>The Vegetable Gardener\'s Bible</li>\n</ul>\n", "The Vegetable Gardener\'s Bible", "", "publish", "closed", "open", "", "the-vegetable-gardeners-bible", "", "", "2014-04-21 06:09:23", "2014-04-21 06:09:23", "", "0", "http://blogsforsales.com/green/the-vegetable-gardeners-bible/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("83", "1", "2014-04-21 06:09:23", "2014-04-21 06:09:23", "", "514EATQNkWL", "", "inherit", "closed", "open", "", "514eatqnkwl", "", "", "2014-04-21 06:09:23", "2014-04-21 06:09:23", "", "82", "http://blogsforsales.com/green/wp-content/uploads/2014/04/514EATQNkWL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("84", "1", "2014-04-21 06:09:24", "2014-04-21 06:09:24", "<p>Knowing exactly when to start vegetable seeds indoors, transplant them into the ground, pinch off the blossoms, and pick for peak flavor is the secret to enjoying bountiful harvests all through the season. In Week-by-Week Vegetable Gardener’s Handbook, authors Ron and Jennifer Kujawski eliminate the guesswork with weekly to-do lists that break gardening down into easily manageable tasks. Suitable for all gardening zones, the book offers easy instructions for setting up a perfectly personalized schedule based on your last frost date. Whether you\'re wondering when to plant strawberries, check for tomato hornworm, or harvest carrots, you\'ll see at a glance exactly when and how to do it, for the biggest yields and the best vegetable-growing experiences ever. </p>\n", "The Week-by-Week Vegetable Gardener\'s Handbook: Make the Most of Your Growing Season", "", "publish", "closed", "open", "", "the-week-by-week-vegetable-gardeners-handbook-make-the-most-of-your-growing-season", "", "", "2014-04-21 06:09:24", "2014-04-21 06:09:24", "", "0", "http://blogsforsales.com/green/the-week-by-week-vegetable-gardeners-handbook-make-the-most-of-your-growing-season/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("85", "1", "2014-04-21 06:09:24", "2014-04-21 06:09:24", "", "51FlD28bMzL", "", "inherit", "closed", "open", "", "51fld28bmzl", "", "", "2014-04-21 06:09:24", "2014-04-21 06:09:24", "", "84", "http://blogsforsales.com/green/wp-content/uploads/2014/04/51FlD28bMzL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("86", "1", "2014-04-21 06:09:26", "2014-04-21 06:09:26", "<p>As surely as gardens change with the seasons, gardening is ever changing. New plants, techniques, materials, and lifestyles are constantly broadening the choices you have and reshaping the way you garden in the West. In response to this natural evolution, the editors of Sunset-the West\'s most trusted source of gardening information for more than 80 years-have completely redesigned and updated The Western Garden Book in this new 2012 Ninth Edition. Following the best-selling success of the previous editions of The Western Garden Book, this edition includes a fresh new look, thousands of color photographs, fresh illustrations, and an easy-to-follow format. Written by experts for gardeners in the West, this book is an indispensable reference for beginning and expert gardeners alike.</p>\n<p>The New Western Garden Book features include:<br />A photo gallery shows the West\'s most innovative gardens, from all-edibles front yards to stylish water-wise and fire-wise gardens to living walls and green roofs-all with ideas you can use.<br />Climate Zone Maps and growing-season graphs for all regions of the West including Alaska and Hawaii.<br />A new \"Plant Finder\" section helps you choose plants for their garden\'s problem areas or for special effects.<br />\"A to Z Plant Encyclopedia\" lists some 8,000 plants that thrive in the West, including more than 500 new ones. Gorgeous color photographs illustrate all plant entries-for the first time ever in The Western Garden Book.<br />\"Gardening From Start to Finish\" is a new visual guide that leads readers through all steps of making a garden, from soil prep through planting, growing and care, with special sections on natives, veggies, grasses and more.</p>\n", "The New Western Garden Book: The Ultimate Gardening Guide (Sunset Western Garden Book)", "", "publish", "closed", "open", "", "the-new-western-garden-book-the-ultimate-gardening-guide-sunset-western-garden-book", "", "", "2014-04-21 06:09:26", "2014-04-21 06:09:26", "", "0", "http://blogsforsales.com/green/the-new-western-garden-book-the-ultimate-gardening-guide-sunset-western-garden-book/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("87", "1", "2014-04-21 06:09:26", "2014-04-21 06:09:26", "", "51W6QM0XUSL", "", "inherit", "closed", "open", "", "51w6qm0xusl", "", "", "2014-04-21 06:09:26", "2014-04-21 06:09:26", "", "86", "http://blogsforsales.com/green/wp-content/uploads/2014/04/51W6QM0XUSL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("88", "1", "2014-04-21 06:09:27", "2014-04-21 06:09:27", "<p>This classic has now taught generations of gardeners how to use the natural benefits of plants to protect and support each other. Here is a reader\'s complete reference to which plants nourish the soil, which keep away bugs and pests, and which plants just don\'t get along. Here is a complete guide to using companion planting to grow a better garden. 555,000 copies in print.This gardening classic was first published in 1975, and now a second generation of gardeners who prefer pest-resistant planning to chemicals will find a place for it on the shelves. Not only does it tell what to plant with what, but also how to use herbal sprays to control insects, what wild plants to encourage in the garden, how to grow fruit and nut trees, how to start small plots or window-box gardens, and much more. It\'s one of the most practical books around for any gardener of edibles, no matter how serious or casual.<br />\n<h3>Product Features</h3>\n<ul>\n<li>Used Book in Good Condition</li>\n</ul>\n", "Carrots Love Tomatoes: Secrets of Companion Planting for Successful Gardening", "", "publish", "closed", "open", "", "carrots-love-tomatoes-secrets-of-companion-planting-for-successful-gardening", "", "", "2014-04-21 06:09:27", "2014-04-21 06:09:27", "", "0", "http://blogsforsales.com/green/carrots-love-tomatoes-secrets-of-companion-planting-for-successful-gardening/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("89", "1", "2014-04-21 06:09:27", "2014-04-21 06:09:27", "", "51Me-evQWIL", "", "inherit", "closed", "open", "", "51me-evqwil", "", "", "2014-04-21 06:09:27", "2014-04-21 06:09:27", "", "88", "http://blogsforsales.com/green/wp-content/uploads/2014/04/51Me-evQWIL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("90", "1", "2014-04-21 06:09:28", "2014-04-21 06:09:28", "<p>Authoritative, accessible, and engaging, here is a new reference from The New York Times, a comprehensive, nearly 700-page bible of all the garden news that\'s fit to print. Based on \"Gardeners Q&A.\" the enormously popular syndicated column, 1000 Gardening Questions and Answers is like a passionate conversation between gardeners and gardening experts. Every week readers from around the country send in their most vexing problems--how to divide perennials, prune raspberry canes, grow basil that really tastes like basil, get rid of earwigs, find long-lost varieties of flowers, keep honeysuckle under control--and every week, the authorities at the Times write a column full of answers.<br><br>Carefully selected, updated, and expanded by Leslie Land, one of the column\'s two authors, here are 1,000 Q&As that add up to an informal encyclopedia of gardening knowledge. The book covers flowers, trees, shrubs, the lawn, vegetables, herbs, fruit, indoor plants, soil, pests, and troublemakers. It addresses problems and provides answers to difficulties in every North American zone.  Hundreds of line drawings illustrate the book, providing botanical identification and demonstrating how-to gardening techniques. In addition, sidebars throughout supply supplemental information--\"Dos and Don\'ts of Deadheading,\" \"Annuals that Beat the Heat,\" \"To Prune or Not to Prune: The Clematis Question,\" \"Air Layering,\" \"Windowsill Bonsai\"--plus quirky facts, trivia, lore, and myth. It\'s big, it\'s got heft, it\'s filled to the brim with information. And it\'s so lively, it reads like a novel--and belongs on every gardener\'s potting bench and bedside table.</p>\n", "The New York Times 1000 Gardening Questions and Answers: Based on the New York Times Column \"Garden Q & A.\"", "", "publish", "closed", "open", "", "the-new-york-times-1000-gardening-questions-and-answers-based-on-the-new-york-times-column-garden-q-a", "", "", "2014-04-21 06:09:28", "2014-04-21 06:09:28", "", "0", "http://blogsforsales.com/green/the-new-york-times-1000-gardening-questions-and-answers-based-on-the-new-york-times-column-garden-q-a/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("91", "1", "2014-04-21 06:09:28", "2014-04-21 06:09:28", "", "51aVvcdzfoL", "", "inherit", "closed", "open", "", "51avvcdzfol", "", "", "2014-04-21 06:09:28", "2014-04-21 06:09:28", "", "90", "http://blogsforsales.com/green/wp-content/uploads/2014/04/51aVvcdzfoL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("92", "1", "2014-04-21 06:09:29", "2014-04-21 06:09:29", "<p>Ever since she was old enough to help her grandmother in the garden, Sharon Lovejoy has spent her life working with plants--and along the way, through \"trowel and error,\" she\'s accumulated hundreds and hundreds of remedies, tips, short-cuts, and cure-alls. Now Ms. Lovejoy--author of Roots, Shoots, Buckets & Boots and the award-winning Sunflower Houses--does for the garden what Heloise or the Queen of Clean does for the household. Trowel and Error collects all of her homespun garden advice into an inviting, environmentally friendly, whimsically illustrated yet dead-on helpful book that will benefit every gardener, beginner or experienced.<br><br>Cure plant viruses with spoiled milk. Steep a natural and effective insecticide out of fresh basil. Place flat stones under squash or melons to hasten ripening. Recycle an old apple corer as the perfect dibber for muscari and other small bulbs. Start rosemary cuttings in a green glass bottle. Sprinkle baby powder over seedlings to discourage rabbits. Crush a garlic clove and apply it to your skin as an insect repellent. From urging the reader to take an occasional shower with the houseplants to giving all-natural gardenside first aid, Trowel and Error  is a direct line to the kind of practical wisdom that comes only after a lifetime of experience. The book is indexed by problem, plant, pest, and solution, and includes a list of tools and common household items--borax, cornmeal, vinegar--that completes the gardener\'s arsenal.</p>\n", "Trowel and Error: Over 700 Tips, Remedies and Shortcuts for the Gardener", "", "publish", "closed", "open", "", "trowel-and-error-over-700-tips-remedies-and-shortcuts-for-the-gardener", "", "", "2014-04-21 06:09:29", "2014-04-21 06:09:29", "", "0", "http://blogsforsales.com/green/trowel-and-error-over-700-tips-remedies-and-shortcuts-for-the-gardener/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("93", "1", "2014-04-21 06:09:30", "2014-04-21 06:09:30", "", "51yzSyQav7L", "", "inherit", "closed", "open", "", "51yzsyqav7l", "", "", "2014-04-21 06:09:30", "2014-04-21 06:09:30", "", "92", "http://blogsforsales.com/green/wp-content/uploads/2014/04/51yzSyQav7L.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("94", "1", "2014-04-21 06:09:31", "2014-04-21 06:09:31", "<p>\"God almighty first planted a garden: and, indeed, it is the purest of human pleasures.\"<br /> --Sir Francis Bacon\n<p>National surveys show that gardening has become the most popular, least exclusive hobby nationwide. From the balconies of Manhattan to the patios of Malibu to the backyards of Chicago, anybody with a few square feet of earth is doing their best to make their little corner of the world more gracious and beautiful. And the best thing is, you really don\'t have to be born with a green thumb to give life to a glorious garden. Anybody can do it with a little coaching. Which is where Gardening All-in-One For Dummies comes in.</p>\n<p>Puzzled by pruning? Baffled by bulbs? Can\'t tell a hosta from a hyacinth? Don’t worry! This all-in-one reference delivers the know-how you need to transform your little patch of the outdoors into a blooming paradise. Drawing upon the expertise of the National Gardening Association, it gets you up to speed on:</p>\n<p>Basic gardening skills—from understanding your microclimate to using gardening tools to managing pests and common plant diseasesHow to design, plan and build a garden landscape that reflects your unique sense of styleSelecting, planting and maintaining stunning rosesBuilding a raised bed for your perennials and making them bloom in any climateChoose, grow and maintain annualsFrom amaryllis to spider dahlias to wood tulips—coaxing beauty from homely bulbsEnjoying nature’s bounty by growing you own vegetables and herbs\n<p>A veritable encyclopedia of gardening, this Gardening All-in-One For Dummies is an indispensable resource for novices and experienced gardeners alike. It brings together between the covers of a single volume seven great books covering:</p>\n<p>Gardening BasicsGarden DesignRosesPerennialsAnnualsBulbsVegetables and Herbs\n<p>Your one-step guide to a beautiful garden, Gardening All-in-One For Dummies shows you how to experience the “purest of human pleasures” in your own backyard.</p>\n", "Gardening All-in-One For Dummies", "", "publish", "closed", "open", "", "gardening-all-in-one-for-dummies", "", "", "2014-04-21 06:09:31", "2014-04-21 06:09:31", "", "0", "http://blogsforsales.com/green/gardening-all-in-one-for-dummies/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("95", "1", "2014-04-21 06:09:31", "2014-04-21 06:09:31", "", "51rWwMCX8WL", "", "inherit", "closed", "open", "", "51rwwmcx8wl", "", "", "2014-04-21 06:09:31", "2014-04-21 06:09:31", "", "94", "http://blogsforsales.com/green/wp-content/uploads/2014/04/51rWwMCX8WL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("96", "1", "2014-04-21 06:09:32", "2014-04-21 06:09:32", "<p>The biggest mistake gardeners make each season is starting out too big and then quickly realizing<BR>their large plot requires too much weeding, watering, and backbreaking labor. Vertical gardening guarantees a better outcome from the day the trowel hits the soil—by shrinking the amount of “floor” space needed and focusing on climbing plants that are less prone to insects, diseases, and animal pests.<BR> Notable author and gardener Derek Fell has tried and tested thousands of varieties of vegetables,<BR>flowers, and fruits and recommends the best plants for space-saving vertical gardening. His grow-up,<BR>grow-down system also shows which ground-level plants make good companions underneath and alongside climbing plants. Best of all, many of Fell’s greatest climbers and mutually beneficial plants are available in seed packets in every local garden center.<BR>With a mix of DIY and commercially available string supports, trellises, pergolas, raised beds, skyscraper gardens, and topsy-turvy planters, the vertical garden system reduces work, increases yields, makes harvesting easier, and can be practiced in spaces as small as a container or a one-by-four-foot strip. Vertical Gardening features 100 color photos of the author’s own vertical methods and showcases beautiful, troublefree perennials, shrubs, vegetables, annuals, and fruit perfect for this new, rewarding way to garden.</p>\n", "Vertical Gardening: Grow Up, Not Out, for More Vegetables and Flowers in Much Less Space", "", "publish", "closed", "open", "", "vertical-gardening-grow-up-not-out-for-more-vegetables-and-flowers-in-much-less-space", "", "", "2014-04-21 06:09:32", "2014-04-21 06:09:32", "", "0", "http://blogsforsales.com/green/vertical-gardening-grow-up-not-out-for-more-vegetables-and-flowers-in-much-less-space/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("97", "1", "2014-04-21 06:09:32", "2014-04-21 06:09:32", "", "51cUoIxj9eL", "", "inherit", "closed", "open", "", "51cuoixj9el", "", "", "2014-04-21 06:09:32", "2014-04-21 06:09:32", "", "96", "http://blogsforsales.com/green/wp-content/uploads/2014/04/51cUoIxj9eL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("98", "1", "2014-04-21 06:09:33", "2014-04-21 06:09:33", "<p><P>With growing consumer awareness about the dangers of garden chemicals, turn to The Organic Gardener’s Handbook of Natural Pest and Disease Control as the most reliable and comprehensive guide on the garden shelf. Rodale has been the category leader in organic methods for decades, and this thoroughly updated edition features the latest science-based recommendations for battling garden problems. With all-new photos of common and recently introduced pests and plant diseases, you can quickly identify whether you\'ve discovered garden friend or foe and what action, if any, you should take.</P><P>No other reference includes a wider range of methods for growing and maintaining an organic garden. The plant-by-plant guide features symptoms and solutions for 200 popular plants, including flowers, vegetables, trees, shrubs, and fruits. The insect-and-disease encyclopedia includes a photo identification guide and detailed descriptions of damage readers may see. The extensive coverage of the most up-to-date organic control techniques and products, presented in order of lowest impact to most intensive intervention, makes it easy to choose the best control.</P><P> </P></p>\n", "The Organic Gardener\'s Handbook of Natural Pest and Disease Control: A Complete Guide to Maintaining a Healthy Garden and Yard the Earth-Friendly Way (Rodale Organic Gardening Books)", "", "publish", "closed", "open", "", "the-organic-gardeners-handbook-of-natural-pest-and-disease-control-a-complete-guide-to-maintaining-a-healthy-garden-and-yard-the-earth-friendly-way-rodale-organic-gardening-books", "", "", "2014-04-21 06:09:33", "2014-04-21 06:09:33", "", "0", "http://blogsforsales.com/green/the-organic-gardeners-handbook-of-natural-pest-and-disease-control-a-complete-guide-to-maintaining-a-healthy-garden-and-yard-the-earth-friendly-way-rodale-organic-gardening-books/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("99", "1", "2014-04-21 06:09:33", "2014-04-21 06:09:33", "", "51RvKHWxQJL", "", "inherit", "closed", "open", "", "51rvkhwxqjl", "", "", "2014-04-21 06:09:33", "2014-04-21 06:09:33", "", "98", "http://blogsforsales.com/green/wp-content/uploads/2014/04/51RvKHWxQJL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("100", "1", "2014-04-21 06:09:34", "2014-04-21 06:09:34", "<p>Garden expert and lovable eccentric Ruth Stout once said: \"At the age of 87 I grow vegetables for two people the year-round, doing all  the work myself and freezing the surplus. I tend several flower beds, write a column every week, answer an awful lot of mail, do the housework and cooking-and never do any of these things after 11 o\'clock in the morning!\"\n<p>Her first book about her no-work gardening system, How to Have a Green Thumb Without an Aching Back, was the kind of book people can\'t bear to return. She reports, \"A dentist in Pennsylvania and a doctor in Oregon have both written me that they keep a copy of my garden book in their waiting rooms. Or try to; the dentist has had twenty-three copies stolen, the doctor, sixteen.\"\n<p>Gardening Without Work is her second gardening book and is even more entertaining and instructional than the first, so hide it from your friends!\n<p>How does it work? \"And now let\'s get down to business. The labor-saving part of my system is that I never plow, spade, sow a cover crop, harrow, hoe, cultivate, weed, water or irrigate, or spray. I use just one fertilizer (cottonseed or soybean meal), and I don\'t go through the tortuous business of building a compost pile. Just yesterday, under the \"Questions and Answers\" in a big reputable farm paper, someone asked how to make a compost pile and the editor explained the arduous performance. After I read this I lay there on the couch and suffered because the victim\'s address wasn\'t given; there was no way I could reach him.\n<p>\"My way is simply to keep a thick mulch of any vegetable matter that rots on both my vegetable and flower garden all year round. As it decays and enriches the soil, I add more.\"\n<p>Regardless of topic, Ruth Stout\'s writing is always about living a joyous and independent life, and Gardening Without Work is no exception! This book is a treasure for the gardener and a delight even to the non-gardener. First published in 1961, this Norton Creek Press version is an exact reproduction of the original edition.\n<p>Ruth Stout, who, in her teens helped temperance activist Carrie Nation smash saloon windows, could turn any aspect of life into an adventure. She may have been the only woman who both gardened in the nude and wrote a book on being a hostess (Company Coming: Six Decades of Hospitality). She died in 1980 at the age of 96.Gardening that requires only planting and picking seems almost  sacrilegious, but with Ruth Stout\'s garden methods, weeds and bugs are  no more than fading memories. In a neighborly, conversational tone that  makes this how-to book on gardening a lot of fun, Stout gives advice on  growing various vegetables and flowers, finding the best catalogues and  nurseries, avoiding chemicals on plants, and--best of all--year-round  mulching, which is Stout\'s pièce de résistance that keeps  the unwanted elements out of your greened acres. If you\'ve ever wanted  your own asparagus bed, but thought it was too exotic a plant to grow  on your own, Gardening Without Work is a great place to dig in.<br />\n<h3>Product Features</h3>\n<ul>\n<li>Used Book in Good Condition</li>\n</ul>\n", "Gardening Without Work: For the Aging, the Busy & the Indolent", "", "publish", "closed", "open", "", "gardening-without-work-for-the-aging-the-busy-the-indolent", "", "", "2014-04-21 06:09:34", "2014-04-21 06:09:34", "", "0", "http://blogsforsales.com/green/gardening-without-work-for-the-aging-the-busy-the-indolent/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("101", "1", "2014-04-21 06:09:34", "2014-04-21 06:09:34", "", "51lJlKjb-PL", "", "inherit", "closed", "open", "", "51ljlkjb-pl", "", "", "2014-04-21 06:09:34", "2014-04-21 06:09:34", "", "100", "http://blogsforsales.com/green/wp-content/uploads/2014/04/51lJlKjb-PL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("102", "1", "2014-04-21 06:09:35", "2014-04-21 06:09:35", "<p>Backyard Homesteading addresses the needs of many people who want to take control of the food they eat and the products they use--even if they live in a urban or suburban house on a typical-size lot. It shows homeowners how to turn their yard into a productive and wholesome \"homestead\" that allows them to grow their own fruits and vegetables, and raise farm animals, including chickens and goats. Backyard Homesteading covers the laws and regulations of raising livestock in populated areas and demonstrates to readers how to use and  preserve the bounty they produce.  </p>\n", "Backyard Homesteading: A Back-to-Basics Guide to Self-Sufficiency (Gardening)", "", "publish", "closed", "open", "", "backyard-homesteading-a-back-to-basics-guide-to-self-sufficiency-gardening", "", "", "2014-04-21 06:09:35", "2014-04-21 06:09:35", "", "0", "http://blogsforsales.com/green/backyard-homesteading-a-back-to-basics-guide-to-self-sufficiency-gardening/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("103", "1", "2014-04-21 06:09:36", "2014-04-21 06:09:36", "", "51kbLdwRREL", "", "inherit", "closed", "open", "", "51kbldwrrel", "", "", "2014-04-21 06:09:36", "2014-04-21 06:09:36", "", "102", "http://blogsforsales.com/green/wp-content/uploads/2014/04/51kbLdwRREL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("104", "1", "2014-04-21 06:09:37", "2014-04-21 06:09:37", "<p>The invaluable resource for home food gardeners!<br><br>Ed Smith\'s W-O-R-D system has helped countless gardeners grow an abundance of vegetables and herbs. And those tomatoes and zucchini and basil and cucumbers have nourished countless families, neighbors, and friends with delicious, fresh produce. The Vegetable Gardener\'s Bible is essential reading for locavores in every corner of North America!<br>\n</p>\n<p>EVERYTHING YOU LOVED about the first edition of The Vegetable Gardener’s Bible is still here: friendly, accessible language; full-color photography; comprehensive vegetable specific information in the A-to-Z section; ahead-of-its-time commitment to organic methods; and much more.<br><br>Now, Ed Smith is back with a 10th Anniversary Edition for the next generation of vegetable gardeners. New to this edition is coverage of 15 additional vegetables, including an expanded section on salad greens and more European and Asian vegetables. Readers will also find growing information on more fruits and herbs, new cultivar photographs in many vegetable entries, and a much-requested section on extending the season into the winter months. No matter how cold the climate, growers can bring herbs indoors and keep hardy greens alive in cold frames or hoop houses.<br><br>The impulse to grow vegetables is even stronger in 2009 than it was in 2000, when Storey published The Vegetable Gardener’s Bible. The financial and environmental costs of fossil fuels raise urgent questions: How far should we be shipping food? What are the health costs of petroleum-based pesticides and herbicides? Do we have to rely on megafarms that use gasoline-powered machinery to grow and harvest crops? With every difficult question, more people think, “Maybe I should grow a few vegetables of my own.” This book will continue to answer all their vegetable gardening questions.<br></p>\n<p><br>Praise for the First Edition:<br>\"In every small town, there is a vegetable garden that people go out of the way to walk past. Smith is the guy who grew that garden.\" — Verlyn Klinkenborg, The New York Times Book Review<br><br>\"An abundance of photographs . . . visually bolster the techniques described, while frequent subheads, sidebars, and information-packed photo captions make the layout user-friendly . . . [Smith’s] book is thorough and infused with practical wisdom and a dry Vermont humor that should endear him to readers.\" — Publisher\'s Weekly<br><br>\"Smith . . . clearly explains everything novice and experienced gardeners need to know to grow vegetables and herbs. . . . \" — Library Journal<br><br>\"this book will answer all your questions as well as put you on the path to an abundant harvest. As a bonus, anecdotes and stories make this informative book fun to read.\" - New York Newsday</p>\n<h3>Product Features</h3>\n<ul>\n<li>Used Book in Good Condition</li>\n</ul>\n", "The Vegetable Gardener\'s Bible, 2nd edition", "", "publish", "closed", "open", "", "the-vegetable-gardeners-bible-2nd-edition", "", "", "2014-04-21 06:09:37", "2014-04-21 06:09:37", "", "0", "http://blogsforsales.com/green/the-vegetable-gardeners-bible-2nd-edition/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("105", "1", "2014-04-21 06:09:38", "2014-04-21 06:09:38", "", "61gwQWqVp-L", "", "inherit", "closed", "open", "", "61gwqwqvp-l", "", "", "2014-04-21 06:09:38", "2014-04-21 06:09:38", "", "104", "http://blogsforsales.com/green/wp-content/uploads/2014/04/61gwQWqVp-L.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("106", "1", "2014-04-21 06:09:39", "2014-04-21 06:09:39", "<p>Whether you\'re starting from the ground up or rethinking your existing outdoor living areas, you\'ll find plenty of inspiration in Big Book of Garden Designs. With over 120 garden plans designed to fit every imaginable landscape situation, this new volume guides you through the issues that perplex anyone planning a garden. Such as, which plants are appropriate for your climate? What species will give you the look you want? How much maintenance is involved? Each plan includes a flexible planting list adaptable to your climate and personal style. For every space and every need, from entries to side yards to specialty color schemes, you\'ll find a multitude of options that will fulfill your gardening desires. Features: More than 120 garden plans, all with planting lists Ideas for specialty themes, including cottage gardens, color gardens, kitchen and herb gardens, and more Inspiring landscaping ideas for every outdoor area, from the tiniest entryway to an expansive backyard Case Studies throughout offer in-depth looks at specific plans Designer Notebooks feature design tips and advice from a professional garden designer</p>\n", "Big Book of Garden Designs (Big Book of)", "", "publish", "closed", "open", "", "big-book-of-garden-designs-big-book-of", "", "", "2014-04-21 06:09:39", "2014-04-21 06:09:39", "", "0", "http://blogsforsales.com/green/big-book-of-garden-designs-big-book-of/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("107", "1", "2014-04-21 06:09:40", "2014-04-21 06:09:40", "", "61EpKlO0kNL", "", "inherit", "closed", "open", "", "61epklo0knl", "", "", "2014-04-21 06:09:40", "2014-04-21 06:09:40", "", "106", "http://blogsforsales.com/green/wp-content/uploads/2014/04/61EpKlO0kNL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("108", "1", "2014-04-21 06:09:41", "2014-04-21 06:09:41", "<p>When the inspiration hits to start an organic garden, many novices could benefit from a guidebook that speaks directly to their enthusiasm, their goals, and, of course, their need for solid information that speaks a newbie’s language—from the most trusted source for organic gardening methods.</P></P>In Rodale’s Basic Organic Gardening, general garden-building skills (from \"Do I need to dig?\" to \"Where do I dig?\") and specific techniques (from \"How do I plant a seed?\" to \"How much should I water?\") are presented in growing-season order—from garden planning and planting to growing and harvesting. Many other need-to-know topics like soil, compost, seeds, pest control, and weeds are explained in simple language to ensure success, even on a small scale, on the first try. More than 100 common garden terms are defined, and Smart Starts sidebars offer doable projects to build confidence and enthusiasm for expanding a garden when a gardener is ready. A flower, vegetable, and herb finder highlights easycare plants with good track records. Plus, there are no-dig garden methods, simple garden layouts, and tips and hints inspired by the most popular page views on OrganicGardening.com.</P></P>With a \"no question is unwelcome\" approach, a troubleshooting section lessens frustrations and encourages experimentation. Rodale’s Basic Organic Gardening is everything a beginning gardener (or one who’s new to gardening organically) needs to get growing and keep a garden going strong all season.</p>\n", "Rodale\'s Basic Organic Gardening: A Beginner\'s Guide to Starting a Healthy Garden", "", "publish", "closed", "open", "", "rodales-basic-organic-gardening-a-beginners-guide-to-starting-a-healthy-garden", "", "", "2014-04-21 06:09:41", "2014-04-21 06:09:41", "", "0", "http://blogsforsales.com/green/rodales-basic-organic-gardening-a-beginners-guide-to-starting-a-healthy-garden/", "0", "post", "", "1");
INSERT INTO `wp_posts` VALUES("109", "1", "2014-04-21 06:09:42", "2014-04-21 06:09:42", "", "51CeGZ8n7QL", "", "inherit", "closed", "open", "", "51cegz8n7ql", "", "", "2014-04-21 06:09:42", "2014-04-21 06:09:42", "", "108", "http://blogsforsales.com/green/wp-content/uploads/2014/04/51CeGZ8n7QL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("110", "1", "2014-04-21 06:09:43", "2014-04-21 06:09:43", "<p>*** #1 Amazon BESTSELLER in Vegetable Gardening ***<br> <br> Here\'s the ultimate \"Take-You-By-The-Hand\" beginner\'s gardening manual for creating and managing your own organic garden. Even if you know nothing about organic gardening.... so you can get back your health and energy and save a stack of money.<br> <br> You\'re  going to learn that organic gardening can greatly improve your health  and energy levels while really lowering your weekly food bills, and it  only takes about half an hour per week.<br> <br> If you\'re like me you  probably hate the idea of eating foods (and providing them for your  family) that may have been grown with chemicals.<br> <br> I want to share with you not only the joy of producing fresh, delicious food for your family, but also the health advantages of spending time in the fresh air and sunshine, stress relief, and  chemical free, vitamin filled, fresh, natural foods - what our bodies  really crave for and need.<br> <br> Now you can access the information you want quickly and easily,  to make planning and growing your vegetable garden a breeze! Growing  our own food makes us less reliant on commercially grown foods. Who  knows how long produce might have been sitting around on a shelf, or in a  cooler room? <br> <br> Do you wonder just what chemicals have been  sprayed on that perfect-looking tomato, that really is quite tasteless?  Being able to walk out to your organic vegetable garden and pick your own food - now let\'s see... how many food miles is that? - Oh, it\'s none!<br> <br> You\'ll instantly discover...<br>    Your very best area to grow your vegetables   How to build up healthy, fertile soil without costing a fortune   How to feed your soil - the organic ways   How to create an easy, \'no-dig\' veggie plot   Massive savings by learning how to grow from seeds   9 Essential tips to successfully transplanting your seedlings   Tips for the most effective watering   Why mulching is a must in every organic garden   5 easy ways to keep your garden weed free   How to slash your food bill in half   The 7 crucial ingredients to making great compost   What never to put into your compost   How to make your own organic liquid fertilizers, saving $$\'s   Natural ways to protect your plants from pests and disease   Top 10 easiest veggies to grow   Secrets to growing lush, healthy herbs   Why to include perennial vegetables   What you must do to grow your food if space is limited   How much to plant for your family\'s needs  And that\'s just a small glimpse of what\'s included. This gardening guide was created to give you simple, concise steps to easily create the right organic food garden for your family. I\'ve  gathered this information from both my own experience and from many  different resources over the past 20 years.<br> <br> Happy Organic Gardening, Healthy Living....<br> <br> ~Julie</p>\n", "Organic Gardening Beginner\'s Manual: The ultimate \"Take-You-By-The-Hand\" beginner\'s gardening manual for creating and managing your own organic garden.", "", "publish", "closed", "open", "", "organic-gardening-beginners-manual-the-ultimate-take-you-by-the-hand-beginners-gardening-manual-for-creating-and-managing-your-own-organic-garden", "", "", "2014-04-21 06:09:43", "2014-04-21 06:09:43", "", "0", "http://blogsforsales.com/green/organic-gardening-beginners-manual-the-ultimate-take-you-by-the-hand-beginners-gardening-manual-for-creating-and-managing-your-own-organic-garden/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("111", "1", "2014-04-21 06:09:43", "2014-04-21 06:09:43", "", "51+NhwT3BpL", "", "inherit", "closed", "open", "", "51nhwt3bpl", "", "", "2014-04-21 06:09:43", "2014-04-21 06:09:43", "", "110", "http://blogsforsales.com/green/wp-content/uploads/2014/04/51+NhwT3BpL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("112", "1", "2014-04-21 06:09:44", "2014-04-21 06:09:44", "<p>With more than 180,000 copies sold since its original publication, The Well-Tended Perennial Garden has proven itself to be one of the most useful tools a gardener can have. Now, in this expanded edition, there\'s even more to learn from and enjoy. <br><br>This is the first, and still the most thorough, book to detail essential practices of perennial care such as deadheading, pinching, cutting back, thinning, disbudding, and deadleafing, all of which are thoroughly explained and illustrated. More than 200 new color photographs have been added to this revised edition, showing perennials in various border situations and providing images for each of the entries in the A-to-Z encyclopedia of important perennial species. In addition, there is a new 32-page journal section, in which you can enter details, notes, and observations about the requirements and performance of perennials in your own garden. <br><br>Thousands of readers have commented that The Well-Tended Perennial Garden is one of the most useful and frequently consulted books in their gardening libraries. This new, expanded edition promises to be an even more effective ally in your quest to create a beautiful, healthy, well-maintained perennial garden.<br><br />\n<h3>Product Features</h3>\n<ul>\n<li>Used Book in Good Condition</li>\n</ul>\n", "The Well-Tended Perennial Garden: Planting and Pruning Techniques", "", "publish", "closed", "open", "", "the-well-tended-perennial-garden-planting-and-pruning-techniques", "", "", "2014-04-21 06:09:44", "2014-04-21 06:09:44", "", "0", "http://blogsforsales.com/green/the-well-tended-perennial-garden-planting-and-pruning-techniques/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("113", "1", "2014-04-21 06:09:45", "2014-04-21 06:09:45", "", "613qW7UIHpL", "", "inherit", "closed", "open", "", "613qw7uihpl", "", "", "2014-04-21 06:09:45", "2014-04-21 06:09:45", "", "112", "http://blogsforsales.com/green/wp-content/uploads/2014/04/613qW7UIHpL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("114", "1", "2014-04-21 06:09:46", "2014-04-21 06:09:46", "<p>For those who understand the significance of home-grown foods to surviving and thriving in difficult times, F. F. Rockwell\'s no-nonsense Home Vegetable Gardening: A Complete And Practical Guide To The Planting And Care Of All Vegetables, Fruits And Berries Worth Growing For Home Use, may be the best single volume, practical manual of family-feeding, high-yield home gardening ever compiled. With some, the home vegetable garden is a hobby; with others, especially in these days of high prices, a great help. There are many in both classes whose experience in gardening has been restricted within very narrow bounds, and whose present spare time for gardening is limited. It is as \"first aid\" to such persons, who want to do practical, efficient gardening, and do it with the least possible fuss and loss of time, that this book is written. “Home Vegetable Gardening” can be very useful for the small space gardener as it discusses at length, basics of gardening. Anywhere the book describes use of horses, logic would indicate that a tiller of varying sizes could be substituted. Crop rotation is also discussed, and multiple acres are not needed for this. Instructions on constructing a manure-driven hotbed (the way things were  done before electric seedling heat mats were around) are also included. Another section of “Home Gardening” discusses prepping sods for seed starting, the way things were done years before pellet pots, plastic seed flats and cell packs were common. “Home Gardening” is old enough to resurrect much of the forgotten techniques used by our grandparents and great-grandparents, when they had to garden more naturally and self-sufficiently rather than buying everything from the garden store. It might also be helpful for the budding survivalist who no longer wants to rely on manufactured products. The list of seed varieties is fascinating. When it comes to gardening basics, the publishing date of this book matters very little: many things haven’t changed at all.  In fact, this book might be better for beginners since it is a book that encourages a do-it-yourself and a \'from the ground up\' tone. It is almost void of any pre-made devices and there are no gimmicky products being hocked. In “Home Gardening,” the old standby tools are recommended, time tested and readily available.</p>\n", "Home Vegetable Gardening: A Complete and Practical Guide to the Planting and Care of all Vegetables, Fruits and Berries Worth Growing for Home Use (Illustrated Edition)", "", "publish", "closed", "open", "", "home-vegetable-gardening-a-complete-and-practical-guide-to-the-planting-and-care-of-all-vegetables-fruits-and-berries-worth-growing-for-home-use-illustrated-edition", "", "", "2014-04-21 06:09:46", "2014-04-21 06:09:46", "", "0", "http://blogsforsales.com/green/home-vegetable-gardening-a-complete-and-practical-guide-to-the-planting-and-care-of-all-vegetables-fruits-and-berries-worth-growing-for-home-use-illustrated-edition/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("115", "1", "2014-04-21 06:09:46", "2014-04-21 06:09:46", "", "51lpkmp+-5L", "", "inherit", "closed", "open", "", "51lpkmp-5l", "", "", "2014-04-21 06:09:46", "2014-04-21 06:09:46", "", "114", "http://blogsforsales.com/green/wp-content/uploads/2014/04/51lpkmp+-5L.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("116", "1", "2014-04-21 06:09:47", "2014-04-21 06:09:47", "<p>Unmarked book with light wear US media shipping only, due to size.<br />\n<h3>Product Features</h3>\n<ul>\n<li>Flower Gardening</li>\n<li>Annuals</li>\n<li>Perennials</li>\n<li>Bulbs</li>\n<li>Roses</li>\n</ul>\n", "The Big Book of Flower Gardening: A Guide to Growing Beautiful Annuals, Perennials, Bulbs, and Roses", "", "publish", "closed", "open", "", "the-big-book-of-flower-gardening-a-guide-to-growing-beautiful-annuals-perennials-bulbs-and-roses", "", "", "2014-04-21 06:09:47", "2014-04-21 06:09:47", "", "0", "http://blogsforsales.com/green/the-big-book-of-flower-gardening-a-guide-to-growing-beautiful-annuals-perennials-bulbs-and-roses/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("117", "1", "2014-04-21 06:09:47", "2014-04-21 06:09:47", "", "61T4TSC580L", "", "inherit", "closed", "open", "", "61t4tsc580l", "", "", "2014-04-21 06:09:47", "2014-04-21 06:09:47", "", "116", "http://blogsforsales.com/green/wp-content/uploads/2014/04/61T4TSC580L.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("118", "1", "2014-04-21 06:09:48", "2014-04-21 06:09:48", "<p>The American Horticultural Society Encyclopedia of Gardening is the one and only practical guide to gardening you\'ll ever need. The comprehensive, authoritative, and up-to-date text -- supported by more than 3,000 specially commissioned color photographs -- guides you expertly through the entire range of gardening techniques. The first section of the book, Creating the Garden, opens with detailed information on garden planning and design. Other chapters focus on the major plant groups, including trees, shrubs, and perennials, as well as special areas such as the fruit garden and indoor garden. Each chapter presents detailed. Each chapter presents detailed, in-depth coverage of soil preparation, planting, routine care, pruning and propagation with step-by-step photographs and artwork. Important plant groups, such as hostas, daylillies, an peonies, are highlighted. The second section of the book, Maintaining the Garden, covers tools and materials as well as soil an climate in different regions of the United States. Construction projects, from putting up fencing to building a pergola, are covered with easy-to-follow photographic sequences. A gallery of pests and diseases aids in quick identification and control. There is also a gardener\'s calendar with seasonal reminders and an extensive glossary. Written by Experts: Endorsed by the American Horticultural Society, the Encyclopedia of Gardening has been expertly researched and written by a team of more than 50 distinguished international gardening specialists. Four years in the making, painstakingly photographed and carefully written, The American Horticultural Society Encyclopedia of Gardening is truly the ultimate gardening reference book.Many books claim to be a \"definitive guide\"; this is one title that happily lives up to those claims--and then some. Encyclopedia of Gardening will become your indispensable how-to manual for any plant-related topic. Indoors or out, you\'ll find information on choosing and maintaining healthy plants of all varieties, how to build structures from greenhouses to trellises, ways to identify pests and diseases, and methods of garden design that enable you to turn your lawn into a unique and personal work of art.\n<p> The text is straightforward and accompanied at all points by close-up photos of techniques, ideas, and specimens. The handy glossary is ready with definitions for everything from bulblet to vermiculite, and two pages of seasonal reminders are a great quick-reference cheat sheet. Thanks to clear category separations and the easy-to-read layout, the information is never overwhelming, just friendly and helpful--it\'s like having a master gardener living in your bookshelf!  For the beginning-but-committed gardener, this encyclopedia is the perfect starting point. With every question answered thoroughly and accurately, you may find it\'s the only book you need for years to come. The fruit and vegetable sections are terrific, as are the areas on propagation and water gardening.  For novice and expert alike, there\'s plenty to be learned from this information-packed volume. --Jill Lightner</p>\n", "American Horticultural Society Encyclopedia of Gardening (American Horticultural Society Practical Guides)", "", "publish", "closed", "open", "", "american-horticultural-society-encyclopedia-of-gardening-american-horticultural-society-practical-guides", "", "", "2014-04-21 06:09:48", "2014-04-21 06:09:48", "", "0", "http://blogsforsales.com/green/american-horticultural-society-encyclopedia-of-gardening-american-horticultural-society-practical-guides/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("119", "1", "2014-04-21 06:09:48", "2014-04-21 06:09:48", "", "71D0WXQV6WL", "", "inherit", "closed", "open", "", "71d0wxqv6wl", "", "", "2014-04-21 06:09:48", "2014-04-21 06:09:48", "", "118", "http://blogsforsales.com/green/wp-content/uploads/2014/04/71D0WXQV6WL.gif", "0", "attachment", "image/gif", "0");
INSERT INTO `wp_posts` VALUES("120", "1", "2014-04-21 06:10:50", "2014-04-21 06:10:50", "<p>Start a mini farm on a quarter acre or less, provide 85 percent of the food for a family of four and earn an income.</p>\n<p> Mini Farming describes a holistic approach to small-area farming that will show you how to produce 85 percent of an average family’s food on just a quarter acre—and earn $10,000 in cash annually while spending less than half the time that an ordinary job would require. Even if you have never been a farmer or a gardener, this book covers everything you need to know to get started: buying and saving seeds, starting seedlings, establishing raised beds, soil fertility practices, composting, dealing with pest and disease problems, crop rotation, farm planning, and much more. Because self-sufﬁciency is the objective, subjects such as raising backyard chickens and home canning are also covered along with numerous methods for keeping costs down and production high. Materials, tools, and techniques are detailed with photographs, tables, diagrams, and illustrations.</p>\n", "Mini Farming: Self-Sufficiency on 1/4 Acre", "", "publish", "closed", "open", "", "mini-farming-self-sufficiency-on-14-acre", "", "", "2014-04-21 06:10:50", "2014-04-21 06:10:50", "", "0", "http://blogsforsales.com/green/mini-farming-self-sufficiency-on-14-acre/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("121", "1", "2014-04-21 06:10:51", "2014-04-21 06:10:51", "", "51WEkfzzKFL", "", "inherit", "closed", "open", "", "51wekfzzkfl", "", "", "2014-04-21 06:10:51", "2014-04-21 06:10:51", "", "120", "http://blogsforsales.com/green/wp-content/uploads/2014/04/51WEkfzzKFL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("122", "1", "2014-04-21 06:10:52", "2014-04-21 06:10:52", "<p>The best of Dick Raymond\'s vegetable gardening wisdom--his proven methods for raised beds, wide rows, and other simple techniques that promise a bigger harvest with much less work--is here in one comprehensive guide. Raymond covers everything from preparing the soil to starting plants, stopping weeds, caring for your garden through the season, and even storing your bounty in a root cellar.</p>\n<h3>Product Features</h3>\n<ul>\n<li>Used Book in Good Condition</li>\n</ul>\n", "Garden Way\'s Joy of Gardening", "", "publish", "closed", "open", "", "garden-ways-joy-of-gardening", "", "", "2014-04-21 06:10:52", "2014-04-21 06:10:52", "", "0", "http://blogsforsales.com/green/garden-ways-joy-of-gardening/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("123", "1", "2014-04-21 06:10:52", "2014-04-21 06:10:52", "", "51yBE78o0HL", "", "inherit", "closed", "open", "", "51ybe78o0hl", "", "", "2014-04-21 06:10:52", "2014-04-21 06:10:52", "", "122", "http://blogsforsales.com/green/wp-content/uploads/2014/04/51yBE78o0HL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("124", "1", "2014-04-21 06:10:54", "2014-04-21 06:10:54", "<p>A hands-on guide to the ins and outs of raising and using vegetables</p>\n<p>Want to grow your own vegetables? You can do it the fun and easy way with this practical guide. From selecting the right spot to preparing the soil to harvesting, Vegetable Gardening For Dummies, 2nd Edition shows you how to successfully raise vegetables regardless of the size of your plot or your dietary needs.\n<p>You\'ll discover how to plot your garden and get the soil in tip-top shape; select the types of vegetables you want to grow; plant the seeds properly; and care for them as they grow. You\'ll also know the right time to pick your vegetables and the best ways to enjoy them. Plus, you\'ll get tips on preserving foods grown at home.Expert advice on planting, caring for, harvesting, and enjoying the fruits of your own vegetable gardenFeatures environmentally friendly ways to combat pests in your gardenCharlie Nardozzi is senior horticulturist and spokesperson for the National Gardening Association; he\'s also been the gardening expert on such programs as HGTV\'s Today at Home and Way to Grow and the Discovery Channel\'s Home Matters\n<p>Whether you have a green thumb or you\'ve never grown a plant before, Vegetable Gardening For Dummies, 2nd Edition has all the information you need to create a healthy garden.</p>\n", "Vegetable Gardening For Dummies", "", "publish", "closed", "open", "", "vegetable-gardening-for-dummies", "", "", "2014-04-21 06:10:54", "2014-04-21 06:10:54", "", "0", "http://blogsforsales.com/green/vegetable-gardening-for-dummies/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("125", "1", "2014-04-21 06:10:54", "2014-04-21 06:10:54", "", "51KIhPvfgrL", "", "inherit", "closed", "open", "", "51kihpvfgrl", "", "", "2014-04-21 06:10:54", "2014-04-21 06:10:54", "", "124", "http://blogsforsales.com/green/wp-content/uploads/2014/04/51KIhPvfgrL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("126", "1", "2014-04-21 06:10:56", "2014-04-21 06:10:56", "<p>Rodale\'s Ultimate Encyclopedia of Organic Gardening has been the go-to resource for gardeners for more than 50 years—and the best tool novices can buy to start applying organic methods to their fruit and vegetable crops, herbs, trees and shrubs, perennials, annuals, and lawns. This thoroughly revised and updated version highlights new organic pest controls, new fertilizer products, improved gardening techniques, the latest organic soil practices, and new trends in garden design. In this indispensable work readers will find: - comprehensive coverage for the entire garden and landscape along with related entries such as Community Gardening, Edible Landscaping, Horticultural Therapy, Stonescaping, and more - the most in-depth information from the trusted Rodale Organic Gardening brand - a completely new section on earth-friendly techniques for gardening in a changing climate, covering wise water management, creating backyard habitats, managing invasive plants and insects, reducing energy use and recycling, and understanding biotechnology - entries all written by American gardeners for American gardeners, with answers for all the challenges presented by various conditions, from the humid Deep South and the mild maritime coasts to the cold far North and the dry Southwest Rodale\'s Ultimate Encyclopedia of Organic Gardening has everything anyone needs to create gorgeous, non-toxic gardens in any part of the country.<br />\n<h3>Product Features</h3>\n<ul>\n<li>Used Book in Good Condition</li>\n</ul>\n", "Rodale\'s Ultimate Encyclopedia of Organic Gardening: The Indispensable Green Resource for Every Gardener", "", "publish", "closed", "open", "", "rodales-ultimate-encyclopedia-of-organic-gardening-the-indispensable-green-resource-for-every-gardener", "", "", "2014-04-21 06:10:56", "2014-04-21 06:10:56", "", "0", "http://blogsforsales.com/green/rodales-ultimate-encyclopedia-of-organic-gardening-the-indispensable-green-resource-for-every-gardener/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("127", "1", "2014-04-21 06:10:56", "2014-04-21 06:10:56", "", "5140+Kp0JoL", "", "inherit", "closed", "open", "", "5140kp0jol", "", "", "2014-04-21 06:10:56", "2014-04-21 06:10:56", "", "126", "http://blogsforsales.com/green/wp-content/uploads/2014/04/5140+Kp0JoL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("128", "1", "2014-04-21 06:10:58", "2014-04-21 06:10:58", "<p>For people who dont have space or time for traditional gardening and who need expert advice on choosing and using plants and containers to create their own container garden, large or small. At long last, a smart and sensible gardening guide from the most trusted name in gardening. Compiled from the pages of Fine Gardening magazine, Container Gardening will inspire readers with dramatic plant combinations as well as provide step-by-step techniques to plant and care for containers under all conditions, including regions with short growing periods. The experts at Fine Gardening will show even a beginning gardener how containers can create boundaries, direct traffic, break up wall space, and soften edges throughout the year.<br />\n<h3>Product Features</h3>\n<ul>\n<li>ISBN13: 9781600850806</li>\n<li>Condition: New</li>\n<li>Notes: BRAND NEW FROM PUBLISHER! 100% Satisfaction Guarantee. Tracking provided on most orders. Buy with Confidence! Millions of books sold!</li>\n</ul>\n", "Container Gardening: 250 Design Ideas & Step-by-Step Techniques", "", "publish", "closed", "open", "", "container-gardening-250-design-ideas-step-by-step-techniques", "", "", "2014-04-21 06:10:58", "2014-04-21 06:10:58", "", "0", "http://blogsforsales.com/green/container-gardening-250-design-ideas-step-by-step-techniques/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("129", "1", "2014-04-21 06:10:58", "2014-04-21 06:10:58", "", "61w81TnivSL", "", "inherit", "closed", "open", "", "61w81tnivsl", "", "", "2014-04-21 06:10:58", "2014-04-21 06:10:58", "", "128", "http://blogsforsales.com/green/wp-content/uploads/2014/04/61w81TnivSL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("130", "1", "2014-04-21 06:10:59", "2014-04-21 06:10:59", "<p>Collect and organize your passion for gardening: - 5 themed sections to fill in - 5 tabbed sections to personalize - plants and pots information, hardiness zones, garden log, design grids, plant care records and more - 202 adhesive labels for personalizing your journal</p>\n", "Moleskine Passion Journal - Gardening, Large, Hard Cover (5 x 8.25) (Passion Book Series)", "", "publish", "closed", "open", "", "moleskine-passion-journal-gardening-large-hard-cover-5-x-8-25-passion-book-series", "", "", "2014-04-21 06:10:59", "2014-04-21 06:10:59", "", "0", "http://blogsforsales.com/green/moleskine-passion-journal-gardening-large-hard-cover-5-x-8-25-passion-book-series/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("131", "1", "2014-04-21 06:10:59", "2014-04-21 06:10:59", "", "41fIJGX80VL", "", "inherit", "closed", "open", "", "41fijgx80vl", "", "", "2014-04-21 06:10:59", "2014-04-21 06:10:59", "", "130", "http://blogsforsales.com/green/wp-content/uploads/2014/04/41fIJGX80VL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("132", "1", "2014-04-21 06:11:00", "2014-04-21 06:11:00", "<p>There aren’t many books more beloved than The Tale of Peter Rabbit and even fewer authors as iconic as Beatrix Potter. More than 150 million copies of her books have sold worldwide and interest in her work and life remains high. And her characters—Peter Rabbit, Jemima Puddle Duck, and all the rest—exist in a charmed world filled with flowers and gardens. Beatrix Potter’s Gardening Life is the first book to explore the origins of Beatrix Potter’s love of gardening and plants and show how this passion came to be reflected in her work. The book begins with a gardener’s biography, highlighting the key moments and places throughout her life that helped define her, including her home Hill Top Farm in England\'s Lake District. Next, the reader follows Beatrix Potter through a year in her garden, with a season-by-season overview of what is blooming that truly brings her gardens alive. The book culminates in a traveler’s guide, with information on how and where to visit Potter’s gardens today. </p>\n<p>Richly illustrated and filled with quotations from her books, letters, and journals, it is essential reading for all who know and cherish Beatrix Potter’s classic tales.</p>\n", "Beatrix Potter\'s Gardening Life: The Plants and Places That Inspired the Classic Children\'s Tales", "", "publish", "closed", "open", "", "beatrix-potters-gardening-life-the-plants-and-places-that-inspired-the-classic-childrens-tales", "", "", "2014-04-21 06:11:00", "2014-04-21 06:11:00", "", "0", "http://blogsforsales.com/green/beatrix-potters-gardening-life-the-plants-and-places-that-inspired-the-classic-childrens-tales/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("133", "1", "2014-04-21 06:11:01", "2014-04-21 06:11:01", "", "51Za1kD3wEL", "", "inherit", "closed", "open", "", "51za1kd3wel", "", "", "2014-04-21 06:11:01", "2014-04-21 06:11:01", "", "132", "http://blogsforsales.com/green/wp-content/uploads/2014/04/51Za1kD3wEL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("134", "1", "2014-04-21 06:11:02", "2014-04-21 06:11:02", "<p>You’re now officially out of excuses for not planting the garden of your dreams. Even if you’ve never sowed a seed nor pulled a weed, Gardening Basics For Dummies contains everything you need to know about flowers, beds, borders, trees, shrubs, and lawns to create your own private paradise. This friendly and informative guide also covers all of the tools and additives available to make gardening easier. You’ll discover: Clear definitions and descriptions of the different types of plantsTips on choosing the type of garden you wantHow to create a garden planEasy-to-follow instructions for soil preparationAdvice on planting, growing and caring for annuals and perennialsStep-by-step plans for organic and edible gardensPlans for butterfly and children\'s gardens\n<p>Packed with helpful tips on controlling pests safely, managing weeds, and correcting common gardening problems, Gardening for Dummies turns your brown thumb green in a hurry.</p>\n", "Gardening Basics For Dummies", "", "publish", "closed", "open", "", "gardening-basics-for-dummies", "", "", "2014-04-21 06:11:02", "2014-04-21 06:11:02", "", "0", "http://blogsforsales.com/green/gardening-basics-for-dummies/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("135", "1", "2014-04-21 06:11:02", "2014-04-21 06:11:02", "", "51N3Yt7U98L", "", "inherit", "closed", "open", "", "51n3yt7u98l", "", "", "2014-04-21 06:11:02", "2014-04-21 06:11:02", "", "134", "http://blogsforsales.com/green/wp-content/uploads/2014/04/51N3Yt7U98L.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("136", "1", "2014-04-21 06:11:03", "2014-04-21 06:11:03", "<p>By growing vegetables in containers, even novice gardeners can reap a bounty of organic food in very small spaces. Anyone can harvest tomatoes on a patio, produce a pumpkin in a planter, or grow broccoli on a balcony — it’s easy! Ed Smith shows you how to choose the right plants, select containers and tools, care for plants throughout the growing season, control pests without chemicals, and much more. He even includes plans for small-space container gardens that are perfect for urban and suburban gardeners. </p>\n", "The Vegetable Gardener\'s Container Bible: How to Grow a Bounty of Food in Pots, Tubs, and Other Containers", "", "publish", "closed", "open", "", "the-vegetable-gardeners-container-bible-how-to-grow-a-bounty-of-food-in-pots-tubs-and-other-containers", "", "", "2014-04-21 06:11:03", "2014-04-21 06:11:03", "", "0", "http://blogsforsales.com/green/the-vegetable-gardeners-container-bible-how-to-grow-a-bounty-of-food-in-pots-tubs-and-other-containers/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("137", "1", "2014-04-21 06:11:03", "2014-04-21 06:11:03", "", "61i6h3SRMaL", "", "inherit", "closed", "open", "", "61i6h3srmal", "", "", "2014-04-21 06:11:03", "2014-04-21 06:11:03", "", "136", "http://blogsforsales.com/green/wp-content/uploads/2014/04/61i6h3SRMaL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("138", "1", "2014-04-21 06:11:05", "2014-04-21 06:11:05", "<p>The ideal guide to getting started for every beginning gardener\n<p>Gardening Made Simple is a comprehensive step-by-step guide to creating beautiful gardens, including all the basics of planting, growing, and caring for trees, shrubs, flowers, fruits, vegetables, lawns and other greenery. With plenty of clear and explanatory full-color photographs, it gives beginners the inspiration and simple guidance they need to achieve their green-thumb dreams.\n<p>A helpful introductory section covers basic tools and techniques and shows you how to choose the right garden plans and plants for your Zone, prepare your soil, manage pests, and prune, mulch, fertilize, and water with ease.     Includes more than 65 step-by-step gardening projects  Features 145 easy-to-grow plants, including sections on container gardening, growing your own vegetables, fruits, and herbs, flower gardening, landscaping with trees, shrubs, vines, and groundcovers, and foolproof houseplants  Features more than 1,200 color photographs throughout, including step-by-step photos and shots of finished projects, as well as colorful illustrations and easy plant-by-number diagrams  Includes handy Ask the Garden Doctor question-and-answer content, and Better Homes and Gardens Test Garden tips throughout\n<p>No matter your gardening experience and skill level, Gardening Made Simple provides the inspiration, insight, and advice you need to grow the garden of your dreams.<br/><br/> Tips and Tricks from the Book<br><br>          <img src=\"http://g-ecx.images-amazon.com/images/G/01/books/wiley/Perennial-Detail.jpg\" border=\"0\">  Planting a New Perennial Bed <br/>(Click on photo for book excerpt)        <img src=\"http://g-ecx.images-amazon.com/images/G/01/books/wiley/Techniques-Detail.jpg\" border=\"0\">   Planting Techniques<br/>(Click on photo for book excerpt)</p>\n", "Better Homes and Gardens Gardening Made Simple: The Complete Step-by-Step Guide to Gardening (Better Homes & Gardens)", "", "publish", "closed", "open", "", "better-homes-and-gardens-gardening-made-simple-the-complete-step-by-step-guide-to-gardening-better-homes-gardens", "", "", "2014-04-21 06:11:05", "2014-04-21 06:11:05", "", "0", "http://blogsforsales.com/green/better-homes-and-gardens-gardening-made-simple-the-complete-step-by-step-guide-to-gardening-better-homes-gardens/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("139", "1", "2014-04-21 06:11:05", "2014-04-21 06:11:05", "", "61ysZHt7FIL", "", "inherit", "closed", "open", "", "61yszht7fil", "", "", "2014-04-21 06:11:05", "2014-04-21 06:11:05", "", "138", "http://blogsforsales.com/green/wp-content/uploads/2014/04/61ysZHt7FIL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("140", "1", "2014-04-21 06:11:07", "2014-04-21 06:11:07", "<p>A gardening system that works-- so you don\'t have to!<br><br>Turn in your tiller for a stack of old newspapers! Replace your shovel with a layer of grass clippings! Let Pat Lanza show you how you can create lush, successful, easy-care gardens in practically any location without hours of backbreaking digging or noisy tilling.<br><br>* Practical, first-person advice from an experienced gardener<br>* Great ideas to let you spend more time enjoying your gardens and less time working in them<br>* Specific \"lasagna\" techniques for the most popular vegetables, flowers, herbs, fruits, and more<br><br />\n<h3>Product Features</h3>\n<ul>\n<li>gardening</li>\n</ul>\n", "Lasagna Gardening: A New Layering System for Bountiful Gardens: No Digging, No Tilling, No Weeding, No Kidding!", "", "publish", "closed", "open", "", "lasagna-gardening-a-new-layering-system-for-bountiful-gardens-no-digging-no-tilling-no-weeding-no-kidding", "", "", "2014-04-21 06:11:07", "2014-04-21 06:11:07", "", "0", "http://blogsforsales.com/green/lasagna-gardening-a-new-layering-system-for-bountiful-gardens-no-digging-no-tilling-no-weeding-no-kidding/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("141", "1", "2014-04-21 06:11:07", "2014-04-21 06:11:07", "", "61mTJBTww-L", "", "inherit", "closed", "open", "", "61mtjbtww-l", "", "", "2014-04-21 06:11:07", "2014-04-21 06:11:07", "", "140", "http://blogsforsales.com/green/wp-content/uploads/2014/04/61mTJBTww-L.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("142", "1", "2014-04-21 06:11:09", "2014-04-21 06:11:09", "<p>From sinking a seed into the soil through to sitting down to enjoy a meal made with vegetables and fruits harvested right outside your back door, this gorgeous kitchen gardening book is filled with practical, useful information for both novices and seasoned gardeners alike. Grow Cook Eat will inspire people who already buy fresh, seasonal, local, organic food to grow the food they love to eat. For those who already have experience getting their hands dirty in the garden, this handbook will help them refine their gardening skills and cultivate gourmet quality food. The book also fills in the blanks that exist between growing food in the garden and using it in the kitchen with guides to 50 of the best-loved, tastiest vegetables, herbs, and small fruits. The guides give readers easy-to-follow planting and growing information, specific instructions for harvesting all the edible parts of the plant, advice on storing food in a way that maximizes flavor, basic preparation techniques, and recipes. The recipes at the end of each guide help readers explore the foods they grow and demonstrate how to use unusual foods, like radish greens, garlic scapes, and green coriander seeds.</p>\n", "Grow Cook Eat: A Food Lover\'s Guide to Vegetable Gardening, Including 50 Recipes, Plus Harvesting and Storage Tips", "", "publish", "closed", "open", "", "grow-cook-eat-a-food-lovers-guide-to-vegetable-gardening-including-50-recipes-plus-harvesting-and-storage-tips", "", "", "2014-04-21 06:11:09", "2014-04-21 06:11:09", "", "0", "http://blogsforsales.com/green/grow-cook-eat-a-food-lovers-guide-to-vegetable-gardening-including-50-recipes-plus-harvesting-and-storage-tips/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("143", "1", "2014-04-21 06:11:09", "2014-04-21 06:11:09", "", "51YcjpN6V4L", "", "inherit", "closed", "open", "", "51ycjpn6v4l", "", "", "2014-04-21 06:11:09", "2014-04-21 06:11:09", "", "142", "http://blogsforsales.com/green/wp-content/uploads/2014/04/51YcjpN6V4L.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("144", "1", "2014-04-21 06:11:10", "2014-04-21 06:11:10", "<p>Get ready to journey into the huge world of growing small!</p>\n<p> </p>\n<p>The next garden trend combines the joy of gardening with the magic of miniatures. Gardening in Miniature is a complete guide to creating lush, living, small-scale gardens. It has everything you need to pick up this new hobby, including scaled down garden designs, techniques for creating tiny hardscapes, miniature garden care and maintenance, tips on choosing containers, how to buy the right plants, and where to find life-like accessories. Inspiring step-by-step projects feature basic skills that can be recreated in any number of designs, like a tiny patio, a trellis, a pond, and a secret garden.</p>\n<p> </p>\n<p>Whether you want to build a miniature empire in your garden bed or design a private garden with a pebble patio for an indoor centerpiece, Gardening in Miniature is the primer for creating your own tiny, living world</p>\n<h3>Product Features</h3>\n<ul>\n<li>Used Book in Good Condition</li>\n</ul>\n", "Gardening in Miniature: Create Your Own Tiny Living World", "", "publish", "closed", "open", "", "gardening-in-miniature-create-your-own-tiny-living-world", "", "", "2014-04-21 06:11:10", "2014-04-21 06:11:10", "", "0", "http://blogsforsales.com/green/gardening-in-miniature-create-your-own-tiny-living-world/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("145", "1", "2014-04-21 06:11:11", "2014-04-21 06:11:11", "", "61n4rfMMbDL", "", "inherit", "closed", "open", "", "61n4rfmmbdl", "", "", "2014-04-21 06:11:11", "2014-04-21 06:11:11", "", "144", "http://blogsforsales.com/green/wp-content/uploads/2014/04/61n4rfMMbDL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("146", "1", "2014-04-21 06:11:11", "2014-04-21 06:11:11", "<p>One of the bestselling garden books ever is fresher than ever! Ready to inspire a whole new generation of gardeners.<br><br>When he created the \"square foot gardening\" method, Mel Bartholomew, a retired engineer and efficiency expert, found the solution to the frustrations of most gardeners. His revolutionary system is simple: it\'s an ingenious planting method based on using square foot blocks of garden space instead of rows. Gardeners build up, not down, so there\'s no digging and no tilling after the first year. And the method requires less thinning, less weeding, and less watering.<br><br>\"I found a better way to garden, one that\'s more efficient, more manageable, and requires less work,\" Bartholomew explains. Not surprisingly, his method quickly received worldwide recognition and has been written up in every major newspaper and gardening magazine. His book, which served as the companion to the nationally acclaimed television series, has sold over 800,000 copies. Now freshened with new illustrations, the book Ingram calls \"the largest selling garden book in America\" is reissued for the delight of a whole new generation of gardeners.<br></p>\n", "Square Foot Gardening: A New Way to Garden in Less Space with Less Work", "", "publish", "closed", "open", "", "square-foot-gardening-a-new-way-to-garden-in-less-space-with-less-work", "", "", "2014-04-21 06:11:11", "2014-04-21 06:11:11", "", "0", "http://blogsforsales.com/green/square-foot-gardening-a-new-way-to-garden-in-less-space-with-less-work/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("147", "1", "2014-04-21 06:11:12", "2014-04-21 06:11:12", "", "61sBu6bClnL", "", "inherit", "closed", "open", "", "61sbu6bclnl", "", "", "2014-04-21 06:11:12", "2014-04-21 06:11:12", "", "146", "http://blogsforsales.com/green/wp-content/uploads/2014/04/61sBu6bClnL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("148", "1", "2014-04-21 06:11:13", "2014-04-21 06:11:13", "<p>Home vegetable gardening is all the rage. Millions of Americans have picked up spade and hoe and are digging into the soil for the first time. But starting a garden isn’t always simple. Many hopeful growers find themselves confused by the dizzying array of things to know about soil quality, garden layout, seeds, temperatures, planting schedules, fertilizer, pests, watering, and harvesting. Still other first-time gardeners plant too much, only to find themselves overwhelmed and exhausted by July. </p>\n<p>Barbara Pleasant is here to help. In Starter Vegetable Gardens, Pleasant a master gardener and award-winning gardening writer takes the guesswork out of growing food, explaining in simple, straightforward language how to start, maintain, and expand a bountiful vegetable garden in small, manageable spaces. </p>\n<p>Pleasant presents 24 no-fail, small-scale garden plans from a simple bag garden (planted right in soil bags!) to an orderly border and from a family food factory to specialty beds for salads, Cajun flavors, and Italian cuisine. For each plan she provides plant and material lists, a plot layout, four-color photographs, and tips for succession planting to keep the garden productive all season long. Her all-organic approach ensures that the harvest is not simply tasty but also chemical-free.</p>\n<p>Pleasant anticipates and answers novice gardeners myriad questions, guiding readers through the complexities of assessing site and soil, understanding the climate, choosing the very best vegetable varieties, starting seeds, identifying insect friends and foes, watering, fertilizing, mulching, and harvesting. <br><br>The books layout is friendly and accessible, filled with detailed images that bring the concepts to life. Both instructive and inspiring, Starter Vegetable Gardens is an essential one-stop resource for anyone just beginning to cultivate a vegetable-gardening green thumb.<br></p>\n</p>\n<p>Includes 24 illustrated  planting plans including: </p>\n</p>\n<p> Easy-Care Bag Garden Backyard Veggie Border Front-Yard Food Supply Family Food Factory Paintbrush Beds High-Value Verticals Marinara Medley Managed Mulch Garden Sweet Corn & Company Cajun Spice Six-Weeks-Sooner Salad Garden\n<p>                      <br></p>\n", "Starter Vegetable Gardens: 24 No-Fail Plans for Small Organic Gardens", "", "publish", "closed", "open", "", "starter-vegetable-gardens-24-no-fail-plans-for-small-organic-gardens", "", "", "2014-04-21 06:11:13", "2014-04-21 06:11:13", "", "0", "http://blogsforsales.com/green/starter-vegetable-gardens-24-no-fail-plans-for-small-organic-gardens/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("149", "1", "2014-04-21 06:11:13", "2014-04-21 06:11:13", "", "617SBt2AJuL", "", "inherit", "closed", "open", "", "617sbt2ajul", "", "", "2014-04-21 06:11:13", "2014-04-21 06:11:13", "", "148", "http://blogsforsales.com/green/wp-content/uploads/2014/04/617SBt2AJuL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("150", "1", "2014-04-21 06:11:14", "2014-04-21 06:11:14", "<p>Enjoy the fruits—and veggies and herbs—of your own labor! This comprehensive guide teaches you how to grow bigger and better-quality produce and manage pest problems either conventionally or by organic methods. Inside you\'ll find:\n<p> • Numerous growing, harvesting and storage tips for vegetables, fruits and herbs are included ensuring homeowners become expert food crop gardeners.\n<p>• Includes simple techniques and professional tips for planning, planting and caring for edible crops.\n<p>• An expansive encyclopedia showcases the most flavorful and easiest-to-grow vegetables, fruits and herbs.</p>\n", "Complete Guide to Vegetables Fruits and Herbs", "", "publish", "closed", "open", "", "complete-guide-to-vegetables-fruits-and-herbs", "", "", "2014-04-21 06:11:14", "2014-04-21 06:11:14", "", "0", "http://blogsforsales.com/green/complete-guide-to-vegetables-fruits-and-herbs/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("151", "1", "2014-04-21 06:11:14", "2014-04-21 06:11:14", "", "51V-Tybw8vL", "", "inherit", "closed", "open", "", "51v-tybw8vl", "", "", "2014-04-21 06:11:14", "2014-04-21 06:11:14", "", "150", "http://blogsforsales.com/green/wp-content/uploads/2014/04/51V-Tybw8vL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("152", "1", "2014-04-21 06:11:15", "2014-04-21 06:11:15", "<p>How can you keep from dragging your garden hose over newly planted seedling? Where can you find cheap garden stakes? What can you use to keep the family cat out of your freshly tilled flower beds? This book answers these questions and hundreds more with unique new tips. Plentiful illustrations make for great browsing, while subject-area organization leads you to specific problem solutions. This book is sure to spur you on to improve the bloom and beauty of your garden.<BR><br />\n<h3>Product Features</h3>\n<ul>\n<li>Used Book in Good Condition</li>\n</ul>\n", "1,001 Ingenious Gardening Ideas: New, Fun and Fabulous That Will Change the Way You Garden - Forever! (Rodale Garden Book)", "", "publish", "closed", "open", "", "1001-ingenious-gardening-ideas-new-fun-and-fabulous-that-will-change-the-way-you-garden-forever-rodale-garden-book", "", "", "2014-04-21 06:11:15", "2014-04-21 06:11:15", "", "0", "http://blogsforsales.com/green/1001-ingenious-gardening-ideas-new-fun-and-fabulous-that-will-change-the-way-you-garden-forever-rodale-garden-book/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("153", "1", "2014-04-21 06:11:17", "2014-04-21 06:11:17", "", "715X2ZFTJXL", "", "inherit", "closed", "open", "", "715x2zftjxl", "", "", "2014-04-21 06:11:17", "2014-04-21 06:11:17", "", "152", "http://blogsforsales.com/green/wp-content/uploads/2014/04/715X2ZFTJXL.gif", "0", "attachment", "image/gif", "0");
INSERT INTO `wp_posts` VALUES("154", "1", "2014-04-21 06:11:18", "2014-04-21 06:11:18", "<p>Without fresh, all-natural winter gardening in the seventeenth, eighteenth, and nineteenth centuries people would have starved to death. The good news is that feeding your family fresh food from your own backyard garden all winter long is far easier and less time-consuming than you might imagine. And you won\'t find better-tasting food at any price!</p>\n", "Backyard Winter Gardening: Vegetables Fresh and Simple, in Any Climate Without Artificial Heat or Electricity the Way It\'s Been Done for 2,000 Ye", "", "publish", "closed", "open", "", "backyard-winter-gardening-vegetables-fresh-and-simple-in-any-climate-without-artificial-heat-or-electricity-the-way-its-been-done-for-2000-ye", "", "", "2014-04-21 06:11:18", "2014-04-21 06:11:18", "", "0", "http://blogsforsales.com/green/backyard-winter-gardening-vegetables-fresh-and-simple-in-any-climate-without-artificial-heat-or-electricity-the-way-its-been-done-for-2000-ye/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("155", "1", "2014-04-21 06:11:18", "2014-04-21 06:11:18", "", "61nziIZVmAL", "", "inherit", "closed", "open", "", "61nziizvmal", "", "", "2014-04-21 06:11:18", "2014-04-21 06:11:18", "", "154", "http://blogsforsales.com/green/wp-content/uploads/2014/04/61nziIZVmAL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("156", "1", "2014-04-21 06:11:19", "2014-04-21 06:11:19", "<p>This is the complete guide to flower gardening, from experts Lewis and Nancy Hill. They cover it all--from choosing your site and designing your garden to improving your soil, choosing and caring for your plants, and fighting pests and disease. Create the flower garden of your dreams with this comprehensive reference.</p>\n", "The Flower Gardener\'s Bible: A Complete Guide to Colorful Blooms All Season Long; 10th Anniversary Edition with a new foreword by Suzy Bales", "", "publish", "closed", "open", "", "the-flower-gardeners-bible-a-complete-guide-to-colorful-blooms-all-season-long-10th-anniversary-edition-with-a-new-foreword-by-suzy-bales", "", "", "2014-04-21 06:11:19", "2014-04-21 06:11:19", "", "0", "http://blogsforsales.com/green/the-flower-gardeners-bible-a-complete-guide-to-colorful-blooms-all-season-long-10th-anniversary-edition-with-a-new-foreword-by-suzy-bales/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("157", "1", "2014-04-21 06:11:19", "2014-04-21 06:11:19", "", "51yNKNaF-HL", "", "inherit", "closed", "open", "", "51ynknaf-hl", "", "", "2014-04-21 06:11:19", "2014-04-21 06:11:19", "", "156", "http://blogsforsales.com/green/wp-content/uploads/2014/04/51yNKNaF-HL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("158", "1", "2014-04-21 06:11:21", "2014-04-21 06:11:21", "<p>You’ll find a bumper crop of vegetable gardening books on the shelves today, but it is a very rare title that actually contains new information. Straw Bale Gardens teaches gardening in a way that isn’t only new but is thoroughly innovative and revolutionary to home gardening. It solves every impediment today’s home gardeners face: bad soil, weeds, a short growing season, watering problems, limited garden space, and even physical difficulty working at ground level. Developed and pioneered by author and garden expert Joel Karsten, straw bale gardens create their own growing medium and heat source so you can get an earlier start. It couldn’t be simpler or more effective: all you need is a few bales of straw, some fertilizer, and some seeds or plants, and you can create a weedless vegetable garden anywhere—even in your driveway. Karsten’s step-by-step guide offers all the information you need to make your own straw bale garden today. In this lushly photographed volume, Karsten shares all of the secrets he has developed over years of teaching eager students the miracle of straw bale gardening. You’ll learn how to locate and choose straw bales, then how to condition and plant them for the earliest possible start. You’ll master Karsten’s methods for combating plant pests and maximizing space by applying the principles of vertical gardening to his straw bales. Whether it’s seedlings or seeds, veggies or flowers, there is practically no limit to the plant varieties that will prosper in a straw bale garden—and with Karsten’s breakthrough gardening guide, you can do it all yourself.<br />\n<h3>Product Features</h3>\n<ul>\n<li>This book is brand new</li>\n<li>This book is signed by the author</li>\n<li>We ship within 24 hours of payment</li>\n</ul>\n", "Straw Bale Gardens: The Breakthrough Method for Growing Vegetables Anywhere, Earlier and with No Weeding", "", "publish", "closed", "open", "", "straw-bale-gardens-the-breakthrough-method-for-growing-vegetables-anywhere-earlier-and-with-no-weeding", "", "", "2014-04-21 06:11:21", "2014-04-21 06:11:21", "", "0", "http://blogsforsales.com/green/straw-bale-gardens-the-breakthrough-method-for-growing-vegetables-anywhere-earlier-and-with-no-weeding/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("159", "1", "2014-04-21 06:11:21", "2014-04-21 06:11:21", "", "61dDLfH4gML", "", "inherit", "closed", "open", "", "61ddlfh4gml", "", "", "2014-04-21 06:11:21", "2014-04-21 06:11:21", "", "158", "http://blogsforsales.com/green/wp-content/uploads/2014/04/61dDLfH4gML.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("160", "1", "2014-04-21 06:15:00", "2014-04-21 06:15:00", "<p>~ ~ ~ WE OFFER BOTH PKT. & BULK SIZES ~ Kalanchoe Species Mix</p>\n<p>These seeds were harvested this season.   We carry a lot of extremely rare cactus if you want something rare let me know and I will listing for you.   Feel free to email me with any questions.</p>\n<p>Contains the following:</p>\n<p>Kalanchoe thyrsiflora (also known as Paddle Plant, Flapjacks, Desert Cabbage, White Lady, Geelplakkie, Meelplakkie, Plakkie) is a species of Kalanchoe, native to South Africa. A succulent plant producing a stalk about 1m tall, dying back after flowering. It forms a basal rosette of large, rounded, fleshy stalkless leaves, which are grayish-green with red margins, covered with a white powdery bloom. The inflorescence is terminal and erect with densely clustered thyrse-like panicles of greenish waxy flowers with yellow recurved lobes, narrowly urn-shaped. Flowering from autumn to spring. Common in grassveld amongst rocks.</p>\n<p>========================Kalanchoe rotundifolia<br />\nKalanchoe rotundifolia is a brittle succulent plant which grows up to 1m tall under favourable conditions. Adanson who derived the name Kalanchoe from the Chinese name for one of the species, described this genus in 1763. The species name rotundifolia comes from the Latin and means \"round leaves\".</p>\n<p>It is a orange-flowering species with a slender stem. It has fleshy, rounded or lobed leaves that are 2.5cm broad and are clustered at the base of erect stems. It must be noted that some of these plants, although with the species name rotundifolia, have leaves that are not round. They were grouped together because they had other similarities.<br />\n======================Kalanchoe grandiflora<br />\nAll succulents can be described as fleshy to some degree, but this kalanchoe is positively indecent, a real fleshpot. A tall, upright succulent to 3 feet.</p>\n<p>Turquoise leaves suffused with peachblow. The peachblow will most likely not be as pronounced in summer as with winter temperatures.<br />\n<h3>Product Features</h3>\n<ul>\n<li>This Order =  15  Seeds ~!!</li>\n<li>Click or Copy & Paste Link Below For Bulk Order</li>\n<li>www.amazon.com/gp/product/B00FJO45DK</li>\n<li>S&H is a FLAT RATE NO MATTER HOW MUCH YOU ORDER FROM US ~!!</li>\n<li>These seeds are VERY VERY small, each pack of seed will contain more than advertised.  But if you are uncomfortable working with VERY VERY small seeds please do NOT purchase this product. ~~ OVER 1,000+ VARIETIES & EXPANDING TO CHOOSE FROM ~~!!</li>\n</ul>\n", "15 x Kalanchoe Species Mix - Rare Fresh Seeds - SUCCULENT Leaves Can Form Entire Plant - Various Shades and Colors - Inflorescence Orange Blooms - Excellent Greenhouse or House Plant - By MySeeds.Co", "", "publish", "closed", "open", "", "15-x-kalanchoe-species-mix-rare-fresh-seeds-succulent-leaves-can-form-entire-plant-various-shades-and-colors-inflorescence-orange-blooms-excellent-greenhouse-or-house-plant-by-myseeds-co", "", "", "2014-04-21 06:15:00", "2014-04-21 06:15:00", "", "0", "http://blogsforsales.com/green/15-x-kalanchoe-species-mix-rare-fresh-seeds-succulent-leaves-can-form-entire-plant-various-shades-and-colors-inflorescence-orange-blooms-excellent-greenhouse-or-house-plant-by-myseeds-co/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("161", "1", "2014-04-21 06:15:00", "2014-04-21 06:15:00", "", "61toZ79+bHL", "", "inherit", "closed", "open", "", "61toz79bhl", "", "", "2014-04-21 06:15:00", "2014-04-21 06:15:00", "", "160", "http://blogsforsales.com/green/wp-content/uploads/2014/04/61toZ79+bHL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("162", "1", "2014-04-21 06:15:02", "2014-04-21 06:15:02", "<p>Package Include:20pcs of cherry tomato seeds<br /> Weight:app 5g</p>\n<p> Main specialty:<br /> Germination Temperature:18-25°C<br /> Sprout Days:7-15 days     <br /> Growth Optimum Temperature:18-36°C<br /> Space:20*30cm    <br /> Sunlight Requirement:Halfshadow ,Sunniness<br /> Seeded to Mature:about 70 days<br /> Seed Longevity:about 2 years<br /> Germination Percentage:≥80%<br /> Form and use:</p>\n<p> Note:<br /> 1.Please store the seeds in a shade and cool, dry place.<br /> 2.Because of climate conditions or improper cultivation techniques of loss, we shall not bear the economic responsibility.<br /> 3.The surface turns the soil is the thickness of the seed diameter 1-2 times.<br />\n<h3>Product Features</h3>\n<ul>\n<li>Fruit Color:purple</li>\n<li>Plant Height:sprawl</li>\n<li>Use:View, edible</li>\n<li>Fruit Weight of about 30g,thick pericarp,heatproof,strong Resistence,rich nutrition,are high-end special vegetables.</li>\n</ul>\n", "20 Seeds Purple Cherry Tomato Garden Organic Heirloom Fruit Vegetable Plant", "", "publish", "closed", "open", "", "20-seeds-purple-cherry-tomato-garden-organic-heirloom-fruit-vegetable-plant", "", "", "2014-04-21 06:15:02", "2014-04-21 06:15:02", "", "0", "http://blogsforsales.com/green/20-seeds-purple-cherry-tomato-garden-organic-heirloom-fruit-vegetable-plant/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("163", "1", "2014-04-21 06:15:03", "2014-04-21 06:15:03", "", "51el11zh0tL", "", "inherit", "closed", "open", "", "51el11zh0tl", "", "", "2014-04-21 06:15:03", "2014-04-21 06:15:03", "", "162", "http://blogsforsales.com/green/wp-content/uploads/2014/04/51el11zh0tL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("164", "1", "2014-04-21 06:15:05", "2014-04-21 06:15:05", "<p>This improved cultivator produces dainty little pointed Blue berries with an ambrosial woodland flavor. Forms compact perennial plants that grow in pretty leafy mounds and produce fruits the first summer from seed to enjoy all season long. These special petite strawberries are lovely as a a border edging or in containers, or plant them in hanging pots so you can pluck their exquisite little fruits as you stroll past.<br />\nDays to Germinate: 21 - 28 Days | Mature Height: 6 - 8 inches / Perennial Seeds<br />\n<h3>Product Features</h3>\n<ul>\n<li>This frost hardy variety makes success easy.</li>\n<li>It produces fruit the first year</li>\n<li>The flavor of these petite strawberries is quite sweet</li>\n<li>Plants should continue to fruit for 2 to 4 years</li>\n<li>Berries are medium to large size</li>\n</ul>\n", "100 Strawberry Seeds - Jewel Blue - Treasures By Lee Copyright Jewel Blue", "", "publish", "closed", "open", "", "100-strawberry-seeds-jewel-blue-treasures-by-lee-copyright-jewel-blue", "", "", "2014-04-21 06:15:05", "2014-04-21 06:15:05", "", "0", "http://blogsforsales.com/green/100-strawberry-seeds-jewel-blue-treasures-by-lee-copyright-jewel-blue/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("165", "1", "2014-04-21 06:15:05", "2014-04-21 06:15:05", "", "61PKodcw+dL", "", "inherit", "closed", "open", "", "61pkodcwdl", "", "", "2014-04-21 06:15:05", "2014-04-21 06:15:05", "", "164", "http://blogsforsales.com/green/wp-content/uploads/2014/04/61PKodcw+dL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("166", "1", "2014-04-21 06:15:06", "2014-04-21 06:15:06", "<p>*  We have a HUGE selection of herb seeds available that you wont want to miss! Visit our store and take a peek! *</p>\n<p>** FREE SHIPPING ON ANY ADDITIONAL SEEDS! PAY ONLY ONE FLAT SHIPPING FEE OF $2.50 FOR US ORDERS NO MATTER HOW MANY YOU ORDER! PLEASE VISIT MY STORE FOR OVER 800 TYPES OF FLOWER, HERB, FRUIT & VEGETABLE SEEDS!!! **</p>\n<p>FLAT RATE SHIPPING TO CANADA AND WORLDWIDE IS JUST $3.50. Sorry, no shipments to Italy at this time. </p>\n<p>All seeds will come in a resealable plastic zip lock bag with a label featuring a picture of the flower, planting instructions, and plant specifications such as height, spacing, and light requirements for easy planting. If stored properly, seeds can last for years! All seed packets contain 100 percent true named seeds - there are no fillers or other weeds or seeds mixed in. Most have been harvested by hand and all test at an exceptionally high germination rate. </p>\n<p>Combined free shipping applies to an unlimited number of seed packets paid for together at checkout within the required payment time of 7 days after last purchase has been made.<br />\nInternational buyers please check with your local customs office regarding regulations and allowances on plant seeds. I cannot be responsible for anything seized by customs or irratiated by your local post office. Please understand there are too many countries and too many types of seeds for me to be able to research every possibility. All international shipments will be sent First Class Mail International. You will be provided with a tracking number but please remember that international shipments take longer to arrive.</p>\n<p>If you have any questions about shipping, ordering, or the plants themselves, please feel free to send me a message. While I do not claim to know everything, I will be more than glad to answer any questions I can either from my own extensive experience or will do my best to try to find an answer for you.<br />\n<h3>Product Features</h3>\n<ul>\n<li>BLOOM TIME:  Late Spring - Early Summer</li>\n<li>HARDINESS ZONE:  4 - 9</li>\n<li>PLANT HEIGHT:  18 - 24\"  . . .   PLANT SPACING:  18 - 24\"</li>\n<li>LIGHT REQUIREMENTS:  Sun - Part Shade  . . .  SOIL / WATER:  Average</li>\n<li>Lavender is a wonderfully fragrant herb whose dried leaves and flowers are often used in floral arrangements, sachets, and potpourris. Lavender is used in baked goods and other deserts and the flowers are even used as decorations on cakes. The flowers are also popularly used in teas to give a relaxing scent and flavor. Lavender also boasts countless medicinal properties. The birds, bees, and butterflies also recognize this as a nectar rich favorite!</li>\n</ul>\n", "500 TRUE ENGLISH LAVENDER VERA Lavender Augustifolia Vera Herb Flower Seeds", "", "publish", "closed", "open", "", "500-true-english-lavender-vera-lavender-augustifolia-vera-herb-flower-seeds", "", "", "2014-04-21 06:15:06", "2014-04-21 06:15:06", "", "0", "http://blogsforsales.com/green/500-true-english-lavender-vera-lavender-augustifolia-vera-herb-flower-seeds/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("167", "1", "2014-04-21 06:15:07", "2014-04-21 06:15:07", "", "51AEurtYSuL", "", "inherit", "closed", "open", "", "51aeurtysul", "", "", "2014-04-21 06:15:07", "2014-04-21 06:15:07", "", "166", "http://blogsforsales.com/green/wp-content/uploads/2014/04/51AEurtYSuL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("168", "1", "2014-04-21 06:15:08", "2014-04-21 06:15:08", "<p>100 Blueberry Seeds<br />\n<h3>Product Features</h3>\n<ul>\n<li>100 Blueberry Seeds</li>\n<li>Stratisfied</li>\n<li>Comes with seed starting instructions</li>\n<li>Ships within 24-48 hours of payment</li>\n<li>FREE SHIPPING if you buy over $25.00 -- We have tons of other berry seeds in our storefront!</li>\n</ul>\n", "Highbush Blueberry Fruit Plant Seed 100 Stratisfied Berry Plant Seeds", "", "publish", "closed", "open", "", "highbush-blueberry-fruit-plant-seed-100-stratisfied-berry-plant-seeds", "", "", "2014-04-21 06:15:08", "2014-04-21 06:15:08", "", "0", "http://blogsforsales.com/green/highbush-blueberry-fruit-plant-seed-100-stratisfied-berry-plant-seeds/", "0", "post", "", "1");
INSERT INTO `wp_posts` VALUES("169", "1", "2014-04-21 06:15:08", "2014-04-21 06:15:08", "", "41ilcSRnClL", "", "inherit", "closed", "open", "", "41ilcsrncll", "", "", "2014-04-21 06:15:08", "2014-04-21 06:15:08", "", "168", "http://blogsforsales.com/green/wp-content/uploads/2014/04/41ilcSRnClL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("170", "1", "2014-04-21 06:15:10", "2014-04-21 06:15:10", "<p>Easy to grow from seed. Likes full sun or partial shade.<br />\nAn evergreen perennial ground cover with irridescent, bright red flowers.<br />\nAn incredible performer, producing masses of blooms.<br />\nCan be started indoors in winter to be transplanted outdoors in spring. Or can be sown directly into the ground in spring and summer.<br />\nInstructions included.<br />\n<h3>Product Features</h3>\n<ul>\n<li>Perennial / Easy to grow   zones 4-9</li>\n<li>Thrives in impoverished and hungry shallow soils</li>\n<li>Grows 4 inches tall and more than 2 feet wide</li>\n<li>Full sun / or partial shade</li>\n<li>This year\'s fresh seeds</li>\n</ul>\n", "50+ Aubrieta Rock Cress Bright Red Perennial Flower Seeds / Ground Cover", "", "publish", "closed", "open", "", "50-aubrieta-rock-cress-bright-red-perennial-flower-seeds-ground-cover", "", "", "2014-04-21 06:15:10", "2014-04-21 06:15:10", "", "0", "http://blogsforsales.com/green/50-aubrieta-rock-cress-bright-red-perennial-flower-seeds-ground-cover/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("171", "1", "2014-04-21 06:15:11", "2014-04-21 06:15:11", "", "617jdPANQDL", "", "inherit", "closed", "open", "", "617jdpanqdl", "", "", "2014-04-21 06:15:11", "2014-04-21 06:15:11", "", "170", "http://blogsforsales.com/green/wp-content/uploads/2014/04/617jdPANQDL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("172", "1", "2014-04-21 06:15:11", "2014-04-21 06:15:11", "<p>Comes with the 4 varieties in picture & 1 BONUS seed packs. Germination tested.  All products germination tested at 82% or higher.<br />\nPackage contains growing instructions.<br />\n<h3>Product Features</h3>\n<ul>\n<li>High yields in Mid Season</li>\n<li>Small to medium fruits</li>\n<li>Great variety for beginner gardeners</li>\n<li>Contain the highest flavor and aroma of all strawberry varieties.</li>\n<li>Tested for Germination- 100 Seeds Per Pack</li>\n</ul>\n", "Strawberry 4 Variety Pack 400 Plant Seeds with 1 Free Pack #001", "", "publish", "closed", "open", "", "strawberry-4-variety-pack-400-plant-seeds-with-1-free-pack-001", "", "", "2014-04-21 06:15:11", "2014-04-21 06:15:11", "", "0", "http://blogsforsales.com/green/strawberry-4-variety-pack-400-plant-seeds-with-1-free-pack-001/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("173", "1", "2014-04-21 06:15:12", "2014-04-21 06:15:12", "", "51VYhPU64lL", "", "inherit", "closed", "open", "", "51vyhpu64ll", "", "", "2014-04-21 06:15:12", "2014-04-21 06:15:12", "", "172", "http://blogsforsales.com/green/wp-content/uploads/2014/04/51VYhPU64lL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("174", "1", "2014-04-21 06:15:12", "2014-04-21 06:15:12", "<p>Coleus are easy to grow. Gardeners grow them both outdoors, and as indoor houseplants. Originating in Africa and Indonesia, Coleus tolerates shade well, making them a great indoor houseplant. They do well in shade gardens, pots and containers, and in hanging baskets.<br />\n<h3>Product Features</h3>\n<ul>\n<li>Quality Coleus seeds packaged by \"Seed Needs\"</li>\n<li>Mixture of dark purple, Red, Green, Scarlet, Lime, and many more!</li>\n<li>Foliage grows to a height of about 12 inches. Plants should be spaced 6 - 9 inches apart.</li>\n<li>Great in areas of shade & also makes a great Houseplant as well.</li>\n<li>Easy planting instructions along with a colorful picture printed on each \"Seed Needs\" packet!</li>\n</ul>\n", "250 Seeds, Coleus \"Rainbow Mixture\" (Solenostemon scutellarioides) Seeds By Seed Needs", "", "publish", "closed", "open", "", "250-seeds-coleus-rainbow-mixture-solenostemon-scutellarioides-seeds-by-seed-needs", "", "", "2014-04-21 06:15:12", "2014-04-21 06:15:12", "", "0", "http://blogsforsales.com/green/250-seeds-coleus-rainbow-mixture-solenostemon-scutellarioides-seeds-by-seed-needs/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("175", "1", "2014-04-21 06:15:13", "2014-04-21 06:15:13", "", "61ETnv1jifL", "", "inherit", "closed", "open", "", "61etnv1jifl", "", "", "2014-04-21 06:15:13", "2014-04-21 06:15:13", "", "174", "http://blogsforsales.com/green/wp-content/uploads/2014/04/61ETnv1jifL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("176", "1", "2014-04-21 06:15:14", "2014-04-21 06:15:14", "<p>Japanese Wisteria (Wisteria floribunda). Japanese wisteria was brought from Japan to the United States in 1860 by George Rogers Hall. Since then, it has become one of the most highly romanticized flowering garden plants. It is also a common subject for bonsai, along with Wisteria sinensis(Chinese wisteria)\n<p> The flowering habit of Japanese wisteria is perhaps the most spectacular of the Wisteria family. It sports the longest flower racemes of any wisteria; they can reach nearly half a meter in length. These racemes burst into great trails of clustered blue flowers in early- to mid-spring. The flowers carry a distinctive fragrance similar to that of grapes.\n<p> Japanese wisteria can grow over 30m long over many supports via powerful clockwise-twining stems. The foliage consists of shiny, dark-green, pinnately compound leaves 10-30cm in length. The leaves bear 9-13 oblong leaflets that are each 2-6 cm long. It also bears brown, velvety, bean-like seed pods 5-10cm long that mature in summer and persist until winter. Japanese wisteria prefers moist soils and full sun in USDA plant hardiness zones 5-9. The plant often lives over fifty years.<br />\n<h3>Product Features</h3>\n<ul>\n<li>Japanese Wisteria (Wisteria floribunda).</li>\n<li>Japanese wisteria was brought from Japan to the United States in 1860 by George Rogers Hall</li>\n<li>The flowering habit of Japanese wisteria is perhaps the most spectacular of the Wisteria family</li>\n<li>Full Sun</li>\n<li>Hardy Zones 5-9</li>\n</ul>\n", "Blue Japanese Wisteria Vine 5 Seeds - Hard to Find!", "", "publish", "closed", "open", "", "blue-japanese-wisteria-vine-5-seeds-hard-to-find", "", "", "2014-04-21 06:15:14", "2014-04-21 06:15:14", "", "0", "http://blogsforsales.com/green/blue-japanese-wisteria-vine-5-seeds-hard-to-find/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("177", "1", "2014-04-21 06:15:14", "2014-04-21 06:15:14", "", "61vJOVYNuKL", "", "inherit", "closed", "open", "", "61vjovynukl", "", "", "2014-04-21 06:15:14", "2014-04-21 06:15:14", "", "176", "http://blogsforsales.com/green/wp-content/uploads/2014/04/61vJOVYNuKL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("178", "1", "2014-04-21 06:15:15", "2014-04-21 06:15:15", "<p>This one pound pre-measured wheatgrass bag is our most popular product because everyone comes back for the incredible quality of seed that you can\'t find anywhere else. <br><br> QAI Certified Organic. All Wheat is Not Equal We have had the experience of growing wheatgrass and being in the commercial wheatgrass business over the last five years. We have experienced growing many different kinds of wheat from different areas: Texas, Utah, Idaho, Montana, California, and Israel-- both organic and non-organic. <br><br> The wheat we use now is undoubtedly the best wheat we have ever used. It has a spectacular germination rate and makes a beautiful and nutritious grass. Our wheat is QAI certified organic, which means the grower has not used herbicides in his field for over 3 years. <br><br> If a wheat is organic, it will have more of a variety of minerals than a non-organic wheat. If you grow with an organic compost the organisms in the soil will help the minerals absorb into the grass properly. Organic produce should also have the organism on it that produces cobalamin (B-12). Our certified organic hard red winter wheat is QAI Certified Organic. QAI is Quality Assurance International, who give independent, third party certification of organic food systems and have been the foundation of domestic and international organic food trade.<br />\n<h3>Product Features</h3>\n<ul>\n<li>Todd\'s Seeds are hand-packaged in the USA!</li>\n<li>Every lot is laboratory tested for germination and pathgeons</li>\n<li>QAI Certified Organic</li>\n<li>Nearly 100% germination!</li>\n<li>Always Fresh Seeds - Wheatgrass or Catgrass - you\'ll Both enjoy!</li>\n</ul>\n", "Todd\'s Seeds, Organic Wheatgrass Seeds, One Pound", "", "publish", "closed", "open", "", "todds-seeds-organic-wheatgrass-seeds-one-pound", "", "", "2014-04-21 06:15:15", "2014-04-21 06:15:15", "", "0", "http://blogsforsales.com/green/todds-seeds-organic-wheatgrass-seeds-one-pound/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("179", "1", "2014-04-21 06:15:15", "2014-04-21 06:15:15", "", "41K9J4qWPkL", "", "inherit", "closed", "open", "", "41k9j4qwpkl", "", "", "2014-04-21 06:15:15", "2014-04-21 06:15:15", "", "178", "http://blogsforsales.com/green/wp-content/uploads/2014/04/41K9J4qWPkL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("180", "1", "2014-04-21 06:15:16", "2014-04-21 06:15:16", "<p>10 cherry tree seeds with instructions.<br />\n<h3>Product Features</h3>\n<ul>\n<li>Lovely fragrance</li>\n<li>Zones: 3-10</li>\n<li>Bountiful, Large harvest yearly</li>\n<li>Full sun/Partial Sun</li>\n<li>Seed starting instructions included</li>\n</ul>\n", "Black Gold Sweet Cherry Tree Fruit Plant Seed Pack, Delicious Fruit, Easy to Grow", "", "publish", "closed", "open", "", "black-gold-sweet-cherry-tree-fruit-plant-seed-pack-delicious-fruit-easy-to-grow", "", "", "2014-04-21 06:15:16", "2014-04-21 06:15:16", "", "0", "http://blogsforsales.com/green/black-gold-sweet-cherry-tree-fruit-plant-seed-pack-delicious-fruit-easy-to-grow/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("181", "1", "2014-04-21 06:15:16", "2014-04-21 06:15:16", "", "41jP38HzThL", "", "inherit", "closed", "open", "", "41jp38hzthl", "", "", "2014-04-21 06:15:16", "2014-04-21 06:15:16", "", "180", "http://blogsforsales.com/green/wp-content/uploads/2014/04/41jP38HzThL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("182", "1", "2014-04-21 06:15:17", "2014-04-21 06:15:17", "<p>~ ~ ~ WE OFFER BOTH PKT. & BULK SIZES ~ ~ ~ Chrysanthemum cinerariifolium - Pyrethrum C. cinerariifolium is called the Dalmatian chrysanthemum, denoting its origin in that region of the Balkans (Dalmatia). It looks more like the common daisy than other pyrethrums. Its flowers, typically white with a yellow center, grow from numerous fairly rigid stems. Plants have blue-green leaves and grow to between 45 to 60 cm in height. The plant is economically important as a natural source of insecticide. The flowers are pulverized and the active components, called pyrethrins, contained in the seed cases, are extracted and sold in the form of an oleoresin. This is applied as a suspension in water or oil, or as a powder. Pyrethrins attack the nervous systems of all insects, and inhibit female mosquitoes from biting. When not present in amounts fatal to insects, they still appear to have an insect repellent effect. Insecticides Sprays Pyrethrum was used for centuries as an insecticide, and as a lice remedy in the Middle East (Persian powder, also known as \"Persian pellitory\"). It was sold worldwide under the brand Zacherlin by Austrian industrialist J. Zacherl. The flowers should be dried and then crushed and mixed with water. It should be noted that though the pesticide is organic, it can still be harmful to humans. Companion planting Because of the natural insecticidal properties of the pyrethrums, they are used as companion plants, to repel pest insects from nearby crops and ornamental plants. They are thought to repel aphids, bed bugs (cimex lectularius), leafhoppers, spider mites, harlequin bugs, ticks, pickleworms and imported cabbage worms, among others that are in gardens and farms. For example, they are planted among broccoli plants for protection from several common insect pests.<br />\n<h3>Product Features</h3>\n<ul>\n<li>This Order = 30 Seeds ~!!</li>\n<li>Click or Copy & Paste Link Below For Bulk Order</li>\n<li>www.amazon.com/gp/product/B00DSFSPQU</li>\n<li>S&H is a FLAT RATE NO MATTER HOW MUCH YOU ORDER FROM US ~!!</li>\n<li>~~ OVER 1,000+ VARIETIES & EXPANDING TO CHOOSE FROM ~~!!</li>\n</ul>\n", "30 PYRETHRUM DAISY SEEDS KILL BUGS INSECTS ~ NATURAL MOSQUITO REPELLENT ~~", "", "publish", "closed", "open", "", "30-pyrethrum-daisy-seeds-kill-bugs-insects-natural-mosquito-repellent", "", "", "2014-04-21 06:15:17", "2014-04-21 06:15:17", "", "0", "http://blogsforsales.com/green/30-pyrethrum-daisy-seeds-kill-bugs-insects-natural-mosquito-repellent/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("183", "1", "2014-04-21 06:15:18", "2014-04-21 06:15:18", "", "51xz26Uj0DL", "", "inherit", "closed", "open", "", "51xz26uj0dl", "", "", "2014-04-21 06:15:18", "2014-04-21 06:15:18", "", "182", "http://blogsforsales.com/green/wp-content/uploads/2014/04/51xz26Uj0DL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("184", "1", "2014-04-21 06:16:12", "2014-04-21 06:16:12", "<p>A large selection of garden vegetables. Grow your own beans, broccoli, cabbage, cantaloupe, carrots, corn, cucumbers, lettuce, okra, onions, peas, peppers, radishes, squash, zucchini, tomatoes and watermelon. Plenty to feed your family and varieties to meet everyone’s taste. Substitutions may be made for varieties that are out of stock<br />\n<h3>Product Features</h3>\n<ul>\n<li>Vegetable garden</li>\n<li>Start some seed indoors to get an earlier garden</li>\n<li>17 different varieties</li>\n<li>Varieties within the same species may be substituted for unavailable varieties.</li>\n</ul>\n", "Ferry Morse Large Vegetable Garden, 17 - Piece Set", "", "publish", "closed", "open", "", "ferry-morse-large-vegetable-garden-17-piece-set", "", "", "2014-04-21 06:16:12", "2014-04-21 06:16:12", "", "0", "http://blogsforsales.com/green/ferry-morse-large-vegetable-garden-17-piece-set/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("185", "1", "2014-04-21 06:16:12", "2014-04-21 06:16:12", "", "61WqxZXh5YL", "", "inherit", "closed", "open", "", "61wqxzxh5yl", "", "", "2014-04-21 06:16:12", "2014-04-21 06:16:12", "", "184", "http://blogsforsales.com/green/wp-content/uploads/2014/04/61WqxZXh5YL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("186", "1", "2014-04-21 06:16:13", "2014-04-21 06:16:13", "<p>Zziggysgal Custom Collection of 12 Heirloom Varieties of Vegetable Seeds - Open-Pollinated, Non-Hybrid & Non-GMO. \"Detroit Dark Red Beets\" - \"Waltham 29 Broccoli\" - \"Buttercrunch Lettuce\" - \"California Wonder Sweet Peppers\" - \"Viroflay  Spinach\" - \"Green Arrow Peas\" \"Black Beauty Squash\" - \"Early Prolific Straightneck Squash\" - \"Jubilee Tomatoes\" - \"Red Cherry Tomatoes\" - \"Landreth Stringless Bush Beans\" - \"Long Purple Eggplant\" - *A generous amount of seeds are in each packet* - The growing instructions and the background history of each type of heirloom vegetable are included. Garden-fresh veggies are a family treat!<br />\n<h3>Product Features</h3>\n<ul>\n<li>Zziggysgal Custom Collection of 12 Heirloom Varieties of Vegetable Seeds - Open-Pollinated, Non-Hybrid & Non-GMO.</li>\n<li>\"Detroit Dark Red Beets\"/Waltham 29 Broccoli\"/\"Buttercrunch Lettuce\"/\"California Wonder Sweet Peppers\"</li>\n<li>\"Viroflay  Spinach\"/\"Green Arrow Peas\"/\"Black Beauty Squash\"/\"Early Prolific Straightneck Squash\"</li>\n<li>\"Jubilee Tomatoes\"/\"Red Cherry Tomatoes\"/\"Landreth Stringless Bush Beans\"/\"Long Purple Eggplant\"</li>\n<li>The growing instructions and the background history of each type of heirloom vegetable are included. A generous amount of seeds are in each packet. *BONUS* packet of seeds included*</li>\n</ul>\n", "12 Heirloom Varieties of Vegetable Seeds", "", "publish", "closed", "open", "", "12-heirloom-varieties-of-vegetable-seeds", "", "", "2014-04-21 06:16:13", "2014-04-21 06:16:13", "", "0", "http://blogsforsales.com/green/12-heirloom-varieties-of-vegetable-seeds/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("187", "1", "2014-04-21 06:16:13", "2014-04-21 06:16:13", "", "61pWzxxsgdL", "", "inherit", "closed", "open", "", "61pwzxxsgdl", "", "", "2014-04-21 06:16:13", "2014-04-21 06:16:13", "", "186", "http://blogsforsales.com/green/wp-content/uploads/2014/04/61pWzxxsgdL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("188", "1", "2014-04-21 06:16:14", "2014-04-21 06:16:14", "<p style=\"color:#F00\">ARE YOU Trying to Avoid GENETICALLY MODIFIED (GMO) FOOD? </p>\n<p>Whether you\'re a Prepper or an Organic Gardener, just looking to grow healthy food, our 100% Organic Non-GMO Non-hybrid Heirloom Vegetable Seeds Are the Answer!</p>\n<p>Grow your own nutritious, healthy vegetables right in your own yard and feed your family with delicious, pesticide free, non-GMO food Or<br />\nSTORE AWAY for long term DISASTER preparedness. Your family is counting on<br />\nyou...don\'t put it off.\n<p>Customers are saying:</p>\n<p>I am THRILLED with the purchase. They were packaged well, and I received follow-up emails with hints and tips for growing vegetables!\"</p>\n<p>\"I am REALLY impressed at the speed with which these seeds sprout AND the healthy looking plants that are beginning to grow!\"</p>\n<p>\"you won\'t believe the amount of healthy, ORGANIC food you\'ll be able to produce from the number and variety of seeds provided. In addition, you are also provided with a lot of helpful information to get you started.\"</p>\n<p>Don\'t get caught short when disaster strikes. Over 9,500 seeds will produce 8,000+ healthy plants which will provide a never-ending supply of new seeds every year, as well as DELICIOUS vegetables for your table.</p>\n<p>32 Page FULL COLOR Downloadable PDF Planting, Sprouting and Storing Guide insures your success...even if you\'ve never planted a garden before! </p>\n<p>Whether you\'re preparing for doomsday or would just like to create an organic lifestyle, our Heirloom Seeds are the PERFECT investment for you and your family.</p>\n<p>100% LIFETIME MONEY BACK GUARANTEE.\n<p>If you don\'t LOVE your seeds at ANY point, we\'ll give you your money back in full, It\'s that simple.</p>\n<p>Try it now, click the ADD TO CART button above to experience these seeds RISK FREE!</p>\n<p>PS. Our licensed seed dealer ALWAYS dries our seeds to 8% humidity in an atmosphere controlled environment!<br />\n<h3>Product Features</h3>\n<ul>\n<li>LIFETIME SATISFACTION GUARANTEE! Get an ENDLESS Supply of Heirloom Survival Seeds For FREE After the Disaster, Guaranteed!</li>\n<li>Get New Seeds EVERY Year Right From Your Own Fresh Vegetables. 50 Varieties of High Quality Heirloom Seeds!  To See a LIST OF THE 50 Varieties of SEEDS YOU GET With This Package, Just Click the 3rd Image From Top on the LEFT SIDE of Your Screen.  9,500 Seeds.</li>\n<li>100% Organic, Non-GMO Non-Hybrid Open Pollinated Heritage Vegetable Seeds</li>\n<li>SAVE MONEY! Store Them In The Original Re-Sealable Moisture Proof Foil Laminated Package, Just As They Come, OR Use Your Own Re-Sealable Glass Jars as Bulk Vault Banks to Preserve Your Seeds For DECADES. Eat Fresh, Delicious, and Juicy Tomatoes/Watermelon/Vegetables Right From YOUR Garden!</li>\n<li>FREE 32 Page Guide for Planting, Storing and Sprouting Your Seeds to MAXIMIZE Your Investment! (Instant Download Available) This is a PDF BONUS Guide With FULL COLOR Pictures of What Your Mature Organic Vegetables Will Look Like, Ideal Soil Temperature, Seed and Row Spacing AND Planting Depth.</li>\n</ul>\n", "#1 Heirloom 100% ORGANIC Vegetable Garden SURVIVAL Seeds, 50 Varieties, LIFETIME SATISFACTION GUARANTEE! NON-GMO, NON-Hybrid, ALL-NATURAL, 9500+ Seeds! Germination 85%+! PERFECT for Survival Gardeners OR Health Food Enthusiasts! + Bonus FREE Guide!", "", "publish", "closed", "open", "", "1-heirloom-100-organic-vegetable-garden-survival-seeds-50-varieties-lifetime-satisfaction-guarantee-non-gmo-non-hybrid-all-natural-9500-seeds-germination-85-perfect-for-survival-gardeners-o", "", "", "2014-04-21 06:16:14", "2014-04-21 06:16:14", "", "0", "http://blogsforsales.com/green/1-heirloom-100-organic-vegetable-garden-survival-seeds-50-varieties-lifetime-satisfaction-guarantee-non-gmo-non-hybrid-all-natural-9500-seeds-germination-85-perfect-for-survival-gardeners-o/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("189", "1", "2014-04-21 06:16:14", "2014-04-21 06:16:14", "", "51ux3HGLgZL", "", "inherit", "closed", "open", "", "51ux3hglgzl", "", "", "2014-04-21 06:16:14", "2014-04-21 06:16:14", "", "188", "http://blogsforsales.com/green/wp-content/uploads/2014/04/51ux3HGLgZL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("190", "1", "2014-04-21 06:16:15", "2014-04-21 06:16:15", "<p>High Protein & Vitamin Pack. Most survival seed kits are very low in protein, not these!! Know exactly what you\'re getting: Tomatoes Beefsteak 75+ seeds, Broccoli Waltham 29 300+ seeds, Brussel Sprouts Long Island Improved 50+ seeds, Green Beans Bush Stringless 50+ seeds, Green Cabbage Golden Acre 150+ seeds, Kale Red Russian 50+ seeds, Spinach Bloomsdale Long Standing 50+ seeds, Black Eyed Peas 50+ seeds, Black Beans Turtle 50+ seeds, Corn Golden Bantam 12 treated 50+ seeds, Peas Wando 50+ seeds, Cauliflower Snowball 50+ seeds, Carrots Imperator 58  300+ seeds, Red Cabbage Red Acre 150+ seeds, Beets Detroit Dark Red 100+ seeds.Heirloom Seeds.<br />\n<h3>Product Features</h3>\n<ul>\n<li>NON GMO REAL SURVIVAL SEEDS HEAT SEALED IN A MYLAR BAG</li>\n<li>High Protein & Vitamin Pack. Most survival seed kits are very low in protein, not these!!</li>\n<li>Step by Step Instructions on how to collect new viable seeds from your plants & Planting Instructions.</li>\n<li>All seeds labeled paper envelope, (not a Ziploc or Poly bag)& Heat Sealed in a resealable Mylar Bag</li>\n<li>A NEVER ending food supply of Non-Hybrid, Heirloom, NON GMO first quality seeds for generations to come!!</li>\n</ul>\n", "Heirloom Vegetable Seeds Non Hybrid Survival Seed Kit, High Protein Kit ,Heirloom NO GMO Vegetable Seeds Heirloom High Protein & Vitamin Pack Tomatoes,Broccoli, Brussel Sprouts, Green Beans,Cabbage, Kale, Spinach, Black Eyed Peas, Black Beans Turtle, Corn, Peas,Cauliflower, Carrots,Beets", "", "publish", "closed", "open", "", "heirloom-vegetable-seeds-non-hybrid-survival-seed-kit-high-protein-kit-heirloom-no-gmo-vegetable-seeds-heirloom-high-protein-vitamin-pack-tomatoesbroccoli-brussel-sprouts-green-beanscabbage-k", "", "", "2014-04-21 06:16:15", "2014-04-21 06:16:15", "", "0", "http://blogsforsales.com/green/heirloom-vegetable-seeds-non-hybrid-survival-seed-kit-high-protein-kit-heirloom-no-gmo-vegetable-seeds-heirloom-high-protein-vitamin-pack-tomatoesbroccoli-brussel-sprouts-green-beanscabbage-k/", "0", "post", "", "1");
INSERT INTO `wp_posts` VALUES("191", "1", "2014-04-21 06:16:16", "2014-04-21 06:16:16", "", "61D4m8dpBBL", "", "inherit", "closed", "open", "", "61d4m8dpbbl", "", "", "2014-04-21 06:16:16", "2014-04-21 06:16:16", "", "190", "http://blogsforsales.com/green/wp-content/uploads/2014/04/61D4m8dpBBL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("192", "1", "2014-04-21 06:16:17", "2014-04-21 06:16:17", "<p>Absolutely unique, purple-skinned carrots with deep orange flesh. They look amazing in salads or as a steamed vegetable.  Roots have a high antioxidant and vitamin content, so are best eaten raw and are perfect for making carrot juice.<br />\n<h3>Product Features</h3>\n<ul>\n<li>Absolutely unique, purple-skinned carrots with deep orange flesh</li>\n<li>They look amazing in salads or as a steamed vegetable</li>\n<li>Roots have a high antioxidant and vitamin content</li>\n<li>350 Seeds</li>\n</ul>\n", "Purple Dragon Carrot 350 Seeds - Absolutely unique!", "", "publish", "closed", "open", "", "purple-dragon-carrot-350-seeds-absolutely-unique", "", "", "2014-04-21 06:16:17", "2014-04-21 06:16:17", "", "0", "http://blogsforsales.com/green/purple-dragon-carrot-350-seeds-absolutely-unique/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("193", "1", "2014-04-21 06:16:17", "2014-04-21 06:16:17", "", "41FMVnkCHNL", "", "inherit", "closed", "open", "", "41fmvnkchnl", "", "", "2014-04-21 06:16:17", "2014-04-21 06:16:17", "", "192", "http://blogsforsales.com/green/wp-content/uploads/2014/04/41FMVnkCHNL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("194", "1", "2014-04-21 06:16:18", "2014-04-21 06:16:18", "<p>The appearance of PURPLE CAULIFLOWER is truly breathtaking. This Graffiti variety is the first PURPLE CAULIFLOWER of its size that actually retains its color when cooked. Wonderful when stir fried with garlic and ginger, GRAFFITI PURPLE CAULIFLOWER is at its best wehn quickly blanched, shocked with ice water and served as the show-stopping element in a cruidite platter. This lovely cauliflower would also make great pickles, since an acidic environment will help maintain the purple color. 80 days.</P><P align=left>Cauliflower is recommended for a \"Low Carb\" diet!</P><P align=left> Purple Cauliflower resulted from the discovery of a purpled coloured spontaneous mutant plant in a cauliflower field in the late eighties, and years of dedicated classical breeding at the research station \"Danefeld\" in Denmark. Purple Cauliflower is based on a very stable source of colour formation without the problems of previous varieties. It has been tested in many temperate and subtropical areas and proved itself to be adaptable and productive.<P align=left>The purple colour is due to formation of anthocyanins also found in red cabbage and in red wine. The Danish Institute of Agricultural Sciences has carried out analyses showing that Purple Cauliflower contains approximately 200 times more anthocyanin than a white cauliflower exhibiting \"pinking\" but with exactly the same substances. Some scientists believe that anthocyanins are actually healthy compounds belonging to the group of phenolic antioxidants. Actually this is the reason why many doctors recommend drinking a glass of red wine every day....<br />\n<h3>Product Features</h3>\n<ul>\n<li>The appearance of PURPLE CAULIFLOWER is truly breathtaking</li>\n<li>Adaptable & productive</li>\n<li>80 Days to Maturity</li>\n<li>Fun to Grow!</li>\n<li>40 Seeds</li>\n</ul>\n", "Purple Cauliflower 40 Seeds -LOW CARB!- Veggie", "", "publish", "closed", "open", "", "purple-cauliflower-40-seeds-low-carb-veggie", "", "", "2014-04-21 06:16:18", "2014-04-21 06:16:18", "", "0", "http://blogsforsales.com/green/purple-cauliflower-40-seeds-low-carb-veggie/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("195", "1", "2014-04-21 06:16:18", "2014-04-21 06:16:18", "", "51MF8nMzKNL", "", "inherit", "closed", "open", "", "51mf8nmzknl", "", "", "2014-04-21 06:16:18", "2014-04-21 06:16:18", "", "194", "http://blogsforsales.com/green/wp-content/uploads/2014/04/51MF8nMzKNL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("196", "1", "2014-04-21 06:16:19", "2014-04-21 06:16:19", "<p>* There are Crimson Sweet Watermelon seeds in our store as well as Cantaloupe, Honey Dew, Papaya, and many more Melon seeds! * </p>\n<p>** FREE SHIPPING ON ANY ADDITIONAL SEEDS! PAY ONLY ONE FLAT SHIPPING FEE OF $2.50 FOR US ORDERS NO MATTER HOW MANY YOU ORDER! PLEASE VISIT MY STORE FOR OVER 800 TYPES OF FLOWER, HERB, FRUIT & VEGETABLE SEEDS!!! **</p>\n<p>FLAT RATE SHIPPING TO CANADA AND WORLDWIDE IS JUST $3.50. Sorry, no shipments to Italy at this time. </p>\n<p>All seeds will come in a resealable plastic zip lock bag with a label featuring a picture of the flower, planting instructions, and plant specifications such as height, spacing, and light requirements for easy planting. If stored properly, seeds can last for years! All seed packets contain 100 percent true named seeds - there are no fillers or other weeds or seeds mixed in. Most have been harvested by hand and all test at an exceptionally high germination rate. </p>\n<p>Combined free shipping applies to an unlimited number of seed packets paid for together at checkout within the required payment time of 7 days after last purchase has been made.<br />\nInternational buyers please check with your local customs office regarding regulations and allowances on plant seeds. I cannot be responsible for anything seized by customs or irratiated by your local post office. Please understand there are too many countries and too many types of seeds for me to be able to research every possibility. All international shipments will be sent First Class Mail International. You will be provided with a tracking number but please remember that international shipments take longer to arrive.</p>\n<p>If you have any questions about shipping, ordering, or the plants themselves, please feel free to send me a message. While I do not claim to know everything, I will be more than glad to answer any questions I can either from my own extensive experience or will do my best to try to find an answer for you.<br />\n<h3>Product Features</h3>\n<ul>\n<li>COLOR:  Green with Darker Green Stripes</li>\n<li>HARVEST:  75 Days</li>\n<li>PLANT HEIGHT:  6 - 12\"  . . .  PLANT SPACING:  5 - 6\'</li>\n<li>LIGHT REQUIREMENTS:  Sun  . . .  SOIL / WATER:  Average - Dry  (Tolerates Drought)</li>\n<li>Sugar Baby produces small round 8 pound melons that measures 7 - 8 inches. It has very few seeds, is fine textured, and is very sweet! It attracts bees, butterflies, and birds.</li>\n</ul>\n", "100 SUGAR BABY WATERMELON Citrullus lanatus Fruit Melon Seeds", "", "publish", "closed", "open", "", "100-sugar-baby-watermelon-citrullus-lanatus-fruit-melon-seeds", "", "", "2014-04-21 06:16:19", "2014-04-21 06:16:19", "", "0", "http://blogsforsales.com/green/100-sugar-baby-watermelon-citrullus-lanatus-fruit-melon-seeds/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("197", "1", "2014-04-21 06:16:19", "2014-04-21 06:16:19", "", "41eluleGgdL", "", "inherit", "closed", "open", "", "41eluleggdl", "", "", "2014-04-21 06:16:19", "2014-04-21 06:16:19", "", "196", "http://blogsforsales.com/green/wp-content/uploads/2014/04/41eluleGgdL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("198", "1", "2014-04-21 06:16:20", "2014-04-21 06:16:20", "<p>If these flavor-packed Brussels sprouts were any easier to harvest, they\'d have to fling themselves into your garden basket. There\'s no need to top these easy-picking plants. As soon as the hybrid plant\'s leaves break off and shed, it\'s harvest time, and the ripe 1\"-1.5\" round sprouts are yours for the picking. 105 days.<br />\n<h3>Product Features</h3>\n<ul>\n<li>Flavor-packed Brussels sprouts were any easier to harvest, they\'d have to fling themselves into your garden basket</li>\n<li>Ripe 1\"-1.5\" round sprouts are yours for the picking. 105 days</li>\n<li>There\'s no need to top these easy-picking plants</li>\n<li>Little Baby Cabbages in Your Back Yard</li>\n<li>100 Seeds Per Pack</li>\n</ul>\n", "Hinterland Trading Brussels Sprouts", "", "publish", "closed", "open", "", "hinterland-trading-brussels-sprouts", "", "", "2014-04-21 06:16:20", "2014-04-21 06:16:20", "", "0", "http://blogsforsales.com/green/hinterland-trading-brussels-sprouts/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("199", "1", "2014-04-21 06:16:20", "2014-04-21 06:16:20", "", "41IHP324mAL", "", "inherit", "closed", "open", "", "41ihp324mal", "", "", "2014-04-21 06:16:20", "2014-04-21 06:16:20", "", "198", "http://blogsforsales.com/green/wp-content/uploads/2014/04/41IHP324mAL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("200", "1", "2014-04-21 06:16:21", "2014-04-21 06:16:21", "<p>Spacemaster - the ultimate cucumber for the vegetable gardener with limited space! The vines of this variety need only about 1/3 the space of a typical cucumber plant. Excellent for pickling when small, they are also perfect for slicing when picked more mature. Plant Spacemaster Cucumber Seeds indoors or out and enjoy a bountiful harvest.<br />\n<h3>Product Features</h3>\n<ul>\n<li>BUY from Seeds and Things in the USA/ not  from SixCity in Hong Kong China</li>\n<li>Save space</li>\n<li>60 Days</li>\n<li>6 to 8 inches long</li>\n<li>Cucumis sativus \"Spacemaster\"</li>\n</ul>\n", "Free Shipping Cucumber \"Spacemaster Bush\" 30 Seeds, The ultimate cucumber for the vegetable gardener with limited space", "", "publish", "closed", "open", "", "free-shipping-cucumber-spacemaster-bush-30-seeds-the-ultimate-cucumber-for-the-vegetable-gardener-with-limited-space", "", "", "2014-04-21 06:16:21", "2014-04-21 06:16:21", "", "0", "http://blogsforsales.com/green/free-shipping-cucumber-spacemaster-bush-30-seeds-the-ultimate-cucumber-for-the-vegetable-gardener-with-limited-space/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("201", "1", "2014-04-21 06:16:21", "2014-04-21 06:16:21", "", "519cZIukQpL", "", "inherit", "closed", "open", "", "519cziukqpl", "", "", "2014-04-21 06:16:21", "2014-04-21 06:16:21", "", "200", "http://blogsforsales.com/green/wp-content/uploads/2014/04/519cZIukQpL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("202", "1", "2014-04-21 06:16:22", "2014-04-21 06:16:22", "<p>Organic gardening continues to be a rising trend in the u.s., so ferry morse has responded with seeds that are used certified 100-percent organically grown, stored and packaged. The seeds are produced under the rigorous standards set forth by the certified organic farmers. Beans, broccoli, carrots, cauliflower, corn, lettuce, okra, onions, peas, peppers, squash, tomatoes and watermelon. Substitutions may be made for varieties that are out of stock<br />\n<h3>Product Features</h3>\n<ul>\n<li>Vegetable garden</li>\n<li>Start some seed indoors to get an earlier garden</li>\n<li>13 different varieties</li>\n</ul>\n", "Ferry Morse Large Organic Vegetable Garden", "", "publish", "closed", "open", "", "ferry-morse-large-organic-vegetable-garden", "", "", "2014-04-21 06:16:22", "2014-04-21 06:16:22", "", "0", "http://blogsforsales.com/green/ferry-morse-large-organic-vegetable-garden/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("203", "1", "2014-04-21 06:16:22", "2014-04-21 06:16:22", "", "51IliuU9mHL", "", "inherit", "closed", "open", "", "51iliuu9mhl", "", "", "2014-04-21 06:16:22", "2014-04-21 06:16:22", "", "202", "http://blogsforsales.com/green/wp-content/uploads/2014/04/51IliuU9mHL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("204", "1", "2014-04-21 06:16:23", "2014-04-21 06:16:23", "<p>SWEET BELL PEPPER:  Bell peppers have a rounded, square shape with four lobes. They are hollow, with flat seeds inside. Bell peppers are the most commonly grown type of pepper in North America.  Most bell peppers are harvested when they are still green, but when left to mature on the plant for a longer length of time, some peppers will turn shades of red, yellow or even purple.\n<p>  <P> A Rainbow of Sweet Bell Peppers in Every Packet!\n<p> Each color has its own distinctive flavor! Here\'s what you get--white, yellow, orange, red, lilac, purple, and chocolate!\n<p> 65 to 70 days. Now you can enjoy sweet bell peppers in all the glorious colors and flavors available today--without paying expensive supermarket prices for \"gourmet\" peppers or buying half a dozen packets of seed! We have hand-blended, exclusively for Park customers, a mix of the finest variety of each color. Consisting of 6 hybrids and 1 open-pollinated type, this mix assures you of big, thick-walled, blocky bells in every color. We selected not only for appearance but uniform harvest time and superb disease resistance, so these varieties all mature within a week of one another and are vigorous garden performers. Economical and downright exciting, this is--in our opinion--the finest mix of sweet bells available anywhere!\n<p> 40 Seeds, 240mg<br />\n<h3>Product Features</h3>\n<ul>\n<li>A Rainbow of Sweet Bell Peppers in Every Packet!</li>\n<li>Here\'s what you get--white, yellow, orange, red, lilac, purple, and chocolate!</li>\n<li>65 to 70 days</li>\n<li>Now you can enjoy sweet bell peppers in all the glorious colors and flavors</li>\n<li>40 Seeds, 240mg</li>\n</ul>\n", "Organic Rainbow Bell Pepper 40 Seeds, 240mg", "", "publish", "closed", "open", "", "organic-rainbow-bell-pepper-40-seeds-240mg", "", "", "2014-04-21 06:16:23", "2014-04-21 06:16:23", "", "0", "http://blogsforsales.com/green/organic-rainbow-bell-pepper-40-seeds-240mg/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("205", "1", "2014-04-21 06:16:23", "2014-04-21 06:16:23", "", "410ipa9XiLL", "", "inherit", "closed", "open", "", "410ipa9xill", "", "", "2014-04-21 06:16:23", "2014-04-21 06:16:23", "", "204", "http://blogsforsales.com/green/wp-content/uploads/2014/04/410ipa9XiLL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("206", "1", "2014-04-21 06:16:24", "2014-04-21 06:16:24", "<p>Another classic favorite thanks to its high-quality flavor, crispness, and compact head. Buttercrunch is easy to grow, slow to bolt, and works well in containers. The leaves are very dark green and thicker than most lettuce varieties. My favorite lettuce variety.</p>\n<p>65 Days</p>\n<p>$1.69 Flat Rate Shipping- Mix and Match Varieties, No Limit<br />\n<h3>Product Features</h3>\n<ul>\n<li>$1.69 Flat Rate Shipping- Mix and Match, No Limit</li>\n<li>Grown in 2012 for the 2013 season</li>\n<li>88% Germination</li>\n</ul>\n", "1,000+ Buttercrunch Heirloom Lettuce Seeds- 2013 Seeds", "", "publish", "closed", "open", "", "1000-buttercrunch-heirloom-lettuce-seeds-2013-seeds", "", "", "2014-04-21 06:16:24", "2014-04-21 06:16:24", "", "0", "http://blogsforsales.com/green/1000-buttercrunch-heirloom-lettuce-seeds-2013-seeds/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("207", "1", "2014-04-21 06:16:24", "2014-04-21 06:16:24", "", "51vNJCg4NOL", "", "inherit", "closed", "open", "", "51vnjcg4nol", "", "", "2014-04-21 06:16:24", "2014-04-21 06:16:24", "", "206", "http://blogsforsales.com/green/wp-content/uploads/2014/04/51vNJCg4NOL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("208", "1", "2014-04-21 06:16:25", "2014-04-21 06:16:25", "<p>The Sugar Sweetie Cherry tomato has a great sweet flavor. The fruits are around an inch in diameter, and are great for fresh eating and in salads. This certified organic seed comes in a 100 milligram seed package, which is enough for about 10 plants (after thinning). Works great when grown in containers.<br />\n<h3>Product Features</h3>\n<ul>\n<li>Lycopersicon</li>\n<li>65 Days to Maturity</li>\n<li>Warm Season Crop</li>\n<li>Certified Organic</li>\n<li>25 Seeds</li>\n</ul>\n", "Cherry Tomato Sugar Sweetie Certified Organic Seeds", "", "publish", "closed", "open", "", "cherry-tomato-sugar-sweetie-certified-organic-seeds", "", "", "2014-04-21 06:16:25", "2014-04-21 06:16:25", "", "0", "http://blogsforsales.com/green/cherry-tomato-sugar-sweetie-certified-organic-seeds/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("209", "1", "2014-04-21 06:16:25", "2014-04-21 06:16:25", "", "31woLvKajCL", "", "inherit", "closed", "open", "", "31wolvkajcl", "", "", "2014-04-21 06:16:25", "2014-04-21 06:16:25", "", "208", "http://blogsforsales.com/green/wp-content/uploads/2014/04/31woLvKajCL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("210", "1", "2014-04-21 06:16:26", "2014-04-21 06:16:26", "<p>The Climbing Trip-L-Crop Tomato produces large crimson tomatoes. It has meaty centers with solid divisions. It is by far the most productive tomato, often producing 3 bushels from just one plant! When grown on a trellis the vines soar 12-18 feet and often to 25 feet. Even without a trellis Climbing Trip-L-Crop tomatoes will out-yield other varieties.<br />\n<h3>Product Features</h3>\n<ul>\n<li>Produces 3 bushels of fruit from just one plant!</li>\n<li>When grown on a trellis the vines soar 12-18 feet and often to 25 feet</li>\n<li>The Famous Italian Tree Tomato produces large Crimson tomatoes that grow as big as 6 inches across!</li>\n<li>Days to Maturity: 70</li>\n</ul>\n", "Hinterland Trading Rare Italian Tomato Tree- Grows up to 25 Feet Tall Trip -L Crop 30 Seeds", "", "publish", "closed", "open", "", "hinterland-trading-rare-italian-tomato-tree-grows-up-to-25-feet-tall-trip-l-crop-30-seeds", "", "", "2014-04-21 06:16:26", "2014-04-21 06:16:26", "", "0", "http://blogsforsales.com/green/hinterland-trading-rare-italian-tomato-tree-grows-up-to-25-feet-tall-trip-l-crop-30-seeds/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("211", "1", "2014-04-21 06:16:26", "2014-04-21 06:16:26", "", "41b7dZegUIL", "", "inherit", "closed", "open", "", "41b7dzeguil", "", "", "2014-04-21 06:16:26", "2014-04-21 06:16:26", "", "210", "http://blogsforsales.com/green/wp-content/uploads/2014/04/41b7dZegUIL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("212", "1", "2014-04-21 06:16:27", "2014-04-21 06:16:27", "<p>LIFETIME MYLAR ziplock container grow some now save others for later INSTRUCTIONS ARE INCLUDED TO HARVEST DRY AND RE-USE SEEDS SAVE MONEY ON YOUR FOOD BILL THE GIFT THAT KEEPS ON GIVING  YOUR ORDER WILL INCLUDE 23 VARIETIES OF NON GMO NON HYBRID HEIRLOOM AAA PREMIUM SEED SEEDS OF THE FOLLOWING VARIETIES: 1.beefsteak TOMATO (125plus +SEEDS) very tasty 2. Blue Lake bush Bean great flavor(50plus + seeds) 3. Dark Red Kidney Bean great in chili (50plus + seeds) 4. Buttercrunch Lettuce (400plus+ seeds) 5. Broccoli waltham (150plus+ seeds) 6. CABBAGE green 50 seeds7. nantes CARROT very tasty(300+plus seeds) 8. bantam sweet corn (50+plus seeds) 9. CANTALOUPE HALES BEST JUMBO(50+plus seeds) 10. Marketmore Cucumber (50+plus seeds) all time favorite 11.collard greens  (50+plus seeds) 12.turnip greens(50+plus seeds)13. Cherry Belle Radish (50+plus seeds)salad favorite 14. Spinach (50+plus seeds) 15.California Wonder Bell Pepper (50+plus seeds) 16. Jalapeno Pepper (50+plus seeds) A favorite 17 Watermelon (40+plus seeds) super tasty too 18. Yellow Crookneck Squash (50+plus seeds) 19.  Red Cayenne Pepper (50+plus seeds)great in hot spicy recipes 20.pumpkin  25 seeds  21.Dark Red Beet (50+plus seeds) Great Taste 22. Lima Beans (40 seeds) 23. Sunflower Seeds (50+plus seeds) SUN FLOWER SEEDS ARE FUN TO EAT<br />\n<h3>Product Features</h3>\n<ul>\n<li>23 Varieties Vegetable & fruit your seeds are fresh New Sealed</li>\n<li>Enclosed in a Mylar Heat Sealed Ziplock  Resealable  Container Instructions Are Included</li>\n<li>Planting, harvesting, and seed saving instructions are included</li>\n<li>Seeds are open pollinated and can be grown, harvested, and replanted endlessly</li>\n<li>Made In The USA By American Families 52,000 Customers Growing Daily</li>\n</ul>\n", "Survival Seed Kit- 23 Varieties - Non GMO - Non Hybrid - Emergency Seed Bank 2014", "", "publish", "closed", "open", "", "survival-seed-kit-23-varieties-non-gmo-non-hybrid-emergency-seed-bank-2014", "", "", "2014-04-21 06:16:27", "2014-04-21 06:16:27", "", "0", "http://blogsforsales.com/green/survival-seed-kit-23-varieties-non-gmo-non-hybrid-emergency-seed-bank-2014/", "0", "post", "", "1");
INSERT INTO `wp_posts` VALUES("213", "1", "2014-04-21 06:16:27", "2014-04-21 06:16:27", "", "61-Iyu3dwgL", "", "inherit", "closed", "open", "", "61-iyu3dwgl", "", "", "2014-04-21 06:16:27", "2014-04-21 06:16:27", "", "212", "http://blogsforsales.com/green/wp-content/uploads/2014/04/61-Iyu3dwgL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("214", "1", "2014-04-21 06:16:28", "2014-04-21 06:16:28", "<p>This graceful vegetable with Chinese origins has spread throughout the world</p>\n<p>Pak Choi features dark green leaves atop white spoon-shaped upright stems. Stems vary considerably in thickness and shape.</p>\n<p>The slight mustardy flavor of Pak Choi makes it a delightful addition to stir-fries, soups, noodle and meat dishes, and salads, if the young leaves are used. In China, the coarser leaves are often pickled.</p>\n<p>Some Chinese cooks also dip the leaves in boiling water and hang them out to dry in the sun for several days. Drying enables this highly perishable vegetable to be stored for winter months. Asian cooks use the entire plant at many stages of development.</p>\n<p>Planting Instructions Included<br />\n<h3>Product Features</h3>\n<ul>\n<li>Staple green for stir fries has succulent stalks and dark green leaves</li>\n<li>Needs full sun to partial shade with moderate water</li>\n<li>Matures in 65 to 75 days</li>\n<li>Easy to Grow</li>\n</ul>\n", "Seeds and Things Bok Choy Pak Choi Chinese Cabbage 299 + Seeds", "", "publish", "closed", "open", "", "seeds-and-things-bok-choy-pak-choi-chinese-cabbage-299-seeds", "", "", "2014-04-21 06:16:28", "2014-04-21 06:16:28", "", "0", "http://blogsforsales.com/green/seeds-and-things-bok-choy-pak-choi-chinese-cabbage-299-seeds/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("215", "1", "2014-04-21 06:16:28", "2014-04-21 06:16:28", "", "41f6HALpWzL", "", "inherit", "closed", "open", "", "41f6halpwzl", "", "", "2014-04-21 06:16:28", "2014-04-21 06:16:28", "", "214", "http://blogsforsales.com/green/wp-content/uploads/2014/04/41f6HALpWzL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("216", "1", "2014-04-21 06:16:29", "2014-04-21 06:16:29", "<p>The \"Christmas Tree\" Pepper! <br> The red, orange, yellow, and purple fruits look like Christmas tree lights! <br> 65 days from setting out transplants. The perfect pickling pepper, Sweet Pickle looks as good as it tastes with colorful \"Christmas tree light\" fruits of yellow, orange, red, and even purple! Plant an extra bush or two in containers just for the eye candy!<br> These peppers are about 2 inches long, tapering to a blunt end. Thick-walled and very sweet, they hold up beautifully on the plant, and keep their color, shape, and texture nicely when pickled. So appealing as they ripen into warm shades in the sunny garden!<br> Easy to grow and very heavy-yielding, Sweet Pickle plants reach 12 to 15 inches high and wide -- perfect for containers or a low edging around the veggie garden! Or dot them among your sun-loving flowering annuals -- they\'ll keep some pests at bay, and they look terrific!<br />\n<h3>Product Features</h3>\n<ul>\n<li>Sweet Pickle looks as good as it tastes.</li>\n<li>Harvest just 65 days from setting out transplants.</li>\n<li>Thick-walled and very sweet peppers.</li>\n<li>Grow in a container and bring inside in the winter.</li>\n<li>Just 2 inches long and packed with sweet flavor, they\'re super for salads, garnishes, and pickling!</li>\n</ul>\n", "Sweet Pickle Pepper 20 Seeds -The Christmas Tree Pepper", "", "publish", "closed", "open", "", "sweet-pickle-pepper-20-seeds-the-christmas-tree-pepper", "", "", "2014-04-21 06:16:29", "2014-04-21 06:16:29", "", "0", "http://blogsforsales.com/green/sweet-pickle-pepper-20-seeds-the-christmas-tree-pepper/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("217", "1", "2014-04-21 06:16:29", "2014-04-21 06:16:29", "", "61b31ulvrlL", "", "inherit", "closed", "open", "", "61b31ulvrll", "", "", "2014-04-21 06:16:29", "2014-04-21 06:16:29", "", "216", "http://blogsforsales.com/green/wp-content/uploads/2014/04/61b31ulvrlL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("218", "1", "2014-04-21 06:16:30", "2014-04-21 06:16:30", "<p>Premium Heirloom Seeds... NO GMO - NO PESTICIDES!</p>\n<p>Premium Quality AND Wide Variety Assortment</p>\n<p>- Truly High Quality Seeds Grown And Harvested By Exclusive Seed Producers<br />\n<br>- Large Assortment Accomodates Any And ALL Hardiness Zones<br />\n<br>- Detailed Planting/Growing Information PLUS Historical And Nutritional Information (All Printable) On Our Website.  Full Color Photos Of Each Type And Variety Can Be Printed From Our Website As Well.\n<p>The Truth About Reliable Long Term Storage</p>\n<p>Before Developing Our Seed Banks, We Consulted Expert Seed Saver, Suzanne Ashworth.  Suzanne Ashworth Is A World Renowned Horticulturist, Gardener, And Author of \"Seed to Seed\".  We Share Her Recommendations For Long Term Storage Containers And Techniques In The Printed Instructions Included In This Seed Bank.  You Don\'t Need To Pay For Fancy Labeled (But Inferior) Containers To Have The BEST Long Term Storage Container For These Seeds.  In Fact, The Best Container You Can Use Is Probably In Your Kitchen Right Now.  So, Don\'t Buy A Handful Of Seeds In A Tin Can or \"Mylar\" Bag That Will Fail To Preserve Your Seeds.  When You Purchase Our Seed Banks, You Will Get A LOT of Variety, plus Reliable Instructions/Suggestions For Storage.\n<p>BONUS - FREE Rare Heirloom Tomato Variety Pack</p>\n<p>- Nine Varieties Of The Most Sought After Rare Heirloom Tomatoes<br />\n<br>- Each Variety is Beautiful, Unique, and Possesses Flavor Like You\'ve Never Experienced!<br />\n<br>- A Treasure For The Heirloom Tomato Enthusiast.<br />\n<h3>Product Features</h3>\n<ul>\n<li>FREE Rare Heirloom Tomato Variety Pack - Nine of the Most Sought After Heirloom Tomato Varieties - FREE!</li>\n<li>Vegetables - Fruits - Medicinal and Culinary Herbs - 135 Varieties (144 Total)</li>\n<li>Large Assortment Covers All Hardiness Zones</li>\n<li>Secrets To Successful Long Term Seed Storage Provided With Purchase</li>\n<li>Premium Heirloom Seeds From #1 U.S.A. Seed Producers</li>\n</ul>\n", "135 Variety Organic Heirloom Survival Seed Bank - Emergency Seed Vault - Non GMO - Non Hybrid - ALL IN ONE: Vegetables - Fruits - Culinary Herbs - Medicinal Herbs - Sprouting Seeds ~ 135 VARIETIES - PLUS: Nine Rare Heirloom Tomato Varieties FREE! - FANTASTIC GIFT IDEA!", "", "publish", "closed", "open", "", "135-variety-organic-heirloom-survival-seed-bank-emergency-seed-vault-non-gmo-non-hybrid-all-in-one-vegetables-fruits-culinary-herbs-medicinal-herbs-sprouting-seeds-135-varieties-p", "", "", "2014-04-21 06:16:30", "2014-04-21 06:16:30", "", "0", "http://blogsforsales.com/green/135-variety-organic-heirloom-survival-seed-bank-emergency-seed-vault-non-gmo-non-hybrid-all-in-one-vegetables-fruits-culinary-herbs-medicinal-herbs-sprouting-seeds-135-varieties-p/", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("219", "1", "2014-04-21 06:16:31", "2014-04-21 06:16:31", "", "613Q8zsUTqL", "", "inherit", "closed", "open", "", "613q8zsutql", "", "", "2014-04-21 06:16:31", "2014-04-21 06:16:31", "", "218", "http://blogsforsales.com/green/wp-content/uploads/2014/04/613Q8zsUTqL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("220", "1", "2014-04-21 06:16:32", "2014-04-21 06:16:32", "<p>Tender annual 24-inch plant, 2-4-ounce. fruit. This productive, early maturing, determinate variety yields delicious, meaty, bright red fruit ideal for fresh sauces and canning. Plants do not need trellising.   50 Seed Count.<br />\n<h3>Product Features</h3>\n<ul>\n<li>100-percent certified organic seeds grown in the usa for over 20-year</li>\n<li>Free of gmo\'s (genetically modified organisms), chemicals and pesticides</li>\n<li>Hermetically sealed package that is re-sealable gives longer life and higher germination rates</li>\n<li>Independently tested for high germination rates and purity, meets or exceeds federal standards</li>\n<li>Seeds of change contributes 1-percent of net sales to advance the cause of sustainable organic agriculture worldwide</li>\n</ul>\n", "Seeds of Change 06465  Certified Organic Early Roma Tomato", "", "publish", "closed", "open", "", "seeds-of-change-06465-certified-organic-early-roma-tomato", "", "", "2014-04-21 06:16:32", "2014-04-21 06:16:32", "", "0", "http://blogsforsales.com/green/seeds-of-change-06465-certified-organic-early-roma-tomato/", "0", "post", "", "1");
INSERT INTO `wp_posts` VALUES("221", "1", "2014-04-21 06:16:33", "2014-04-21 06:16:33", "", "51nX5zKHRdL", "", "inherit", "closed", "open", "", "51nx5zkhrdl", "", "", "2014-04-21 06:16:33", "2014-04-21 06:16:33", "", "220", "http://blogsforsales.com/green/wp-content/uploads/2014/04/51nX5zKHRdL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("222", "1", "2014-04-21 06:16:35", "2014-04-21 06:16:35", "<p>Tokyo Long White Bunching Onion Seeds<br />\n<h3>Product Features</h3>\n<ul>\n<li>Tokyo Long White Bunching Onion Seeds</li>\n</ul>\n", "Tokyo Long White Bunching Onion Seeds - Allium Cepa - 1 Grams - Approx 450 Gardening Seeds - Vegetable Garden Seed", "", "publish", "closed", "open", "", "tokyo-long-white-bunching-onion-seeds-allium-cepa-1-grams-approx-450-gardening-seeds-vegetable-garden-seed", "", "", "2014-04-21 06:16:35", "2014-04-21 06:16:35", "", "0", "http://blogsforsales.com/green/tokyo-long-white-bunching-onion-seeds-allium-cepa-1-grams-approx-450-gardening-seeds-vegetable-garden-seed/", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("223", "1", "2014-04-21 06:16:35", "2014-04-21 06:16:35", "", "515Sex2ikJL", "", "inherit", "closed", "open", "", "515sex2ikjl", "", "", "2014-04-21 06:16:35", "2014-04-21 06:16:35", "", "222", "http://blogsforsales.com/green/wp-content/uploads/2014/04/515Sex2ikJL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("224", "1", "2014-04-21 06:24:42", "2014-04-21 06:24:42", "http://blogsforsales.com/green/wp-content/uploads/2014/04/cropped-007.jpg", "cropped-007.jpg", "", "inherit", "closed", "open", "", "cropped-007-jpg", "", "", "2014-04-21 06:24:42", "2014-04-21 06:24:42", "", "0", "http://blogsforsales.com/green/wp-content/uploads/2014/04/cropped-007.jpg", "0", "attachment", "image/jpeg", "0");

/* INSERT TABLE DATA: wp_term_relationships */
INSERT INTO `wp_term_relationships` VALUES("1", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("6", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("8", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("10", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("12", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("14", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("16", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("18", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("20", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("22", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("24", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("26", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("28", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("30", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("32", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("34", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("36", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("38", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("40", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("42", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("44", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("46", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("48", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("50", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("52", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("54", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("56", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("58", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("60", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("62", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("64", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("66", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("68", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("70", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("72", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("74", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("76", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("78", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("80", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("82", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("84", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("86", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("88", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("90", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("92", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("94", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("96", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("98", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("100", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("102", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("104", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("106", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("108", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("110", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("112", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("114", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("116", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("118", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("120", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("122", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("124", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("126", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("128", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("130", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("132", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("134", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("136", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("138", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("140", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("142", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("144", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("146", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("148", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("150", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("152", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("154", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("156", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("158", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("160", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("162", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("164", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("166", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("168", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("170", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("172", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("174", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("176", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("178", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("180", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("182", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("184", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("186", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("188", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("190", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("192", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("194", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("196", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("198", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("200", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("202", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("204", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("206", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("208", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("210", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("212", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("214", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("216", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("218", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("220", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("222", "3", "0");

/* INSERT TABLE DATA: wp_term_taxonomy */
INSERT INTO `wp_term_taxonomy` VALUES("1", "1", "category", "", "0", "40");
INSERT INTO `wp_term_taxonomy` VALUES("2", "2", "category", "", "0", "37");
INSERT INTO `wp_term_taxonomy` VALUES("3", "3", "category", "", "0", "32");

/* INSERT TABLE DATA: wp_terms */
INSERT INTO `wp_terms` VALUES("1", "Gardening Books", "gardenbooks", "0");
INSERT INTO `wp_terms` VALUES("2", "Gardening Tools", "gardentools", "0");
INSERT INTO `wp_terms` VALUES("3", "Plants &amp; Seeds", "plantsandseeds", "0");

/* INSERT TABLE DATA: wp_usermeta */
INSERT INTO `wp_usermeta` VALUES("1", "1", "first_name", "anton");
INSERT INTO `wp_usermeta` VALUES("2", "1", "last_name", "lomax");
INSERT INTO `wp_usermeta` VALUES("3", "1", "nickname", "admin");
INSERT INTO `wp_usermeta` VALUES("4", "1", "description", "");
INSERT INTO `wp_usermeta` VALUES("5", "1", "rich_editing", "true");
INSERT INTO `wp_usermeta` VALUES("6", "1", "comment_shortcuts", "false");
INSERT INTO `wp_usermeta` VALUES("7", "1", "admin_color", "fresh");
INSERT INTO `wp_usermeta` VALUES("8", "1", "use_ssl", "0");
INSERT INTO `wp_usermeta` VALUES("9", "1", "show_admin_bar_front", "true");
INSERT INTO `wp_usermeta` VALUES("10", "1", "wp_capabilities", "a:1:{s:13:\"administrator\";b:1;}");
INSERT INTO `wp_usermeta` VALUES("11", "1", "wp_user_level", "10");
INSERT INTO `wp_usermeta` VALUES("12", "1", "dismissed_wp_pointers", "wp330_toolbar,wp330_saving_widgets,wp340_choose_image_from_library,wp340_customize_current_theme_link,wp350_media,wp360_revisions,wp360_locks");
INSERT INTO `wp_usermeta` VALUES("13", "1", "show_welcome_panel", "1");
INSERT INTO `wp_usermeta` VALUES("14", "1", "wp_dashboard_quick_press_last_post_id", "3");
INSERT INTO `wp_usermeta` VALUES("15", "1", "wp_user-settings", "align=left&imgsize=thumbnail&editor=tinymce&galfile=1&ngg_upload_resize=1&uploader=1&mfold=o&libraryContent=browse&urlbutton=file&hidetb=1&wplink=1");
INSERT INTO `wp_usermeta` VALUES("16", "1", "wp_user-settings-time", "1398171831");

/* INSERT TABLE DATA: wp_users */
INSERT INTO `wp_users` VALUES("1", "admin", "$P$B7Px.TgtoDKe.N0cjS3xjnUYx9UpDc.", "admin", "mail@email.com", "", "2014-04-17 20:35:08", "", "0", "admin");

SET FOREIGN_KEY_CHECKS = 1;